/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(K){for(var e=[],v=0,R=K.length;v<R;v++)e[v]=me[K[v]];return e};define(me[51],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=v}),define(me[52],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(i){const A=[];for(let d in i)v.call(i,d)&&A.push(i[d]);return A}e.values=R;function C(i,A){for(let d in i)if(v.call(i,d)&&A({key:d,value:i[d]},function(){delete i[d]})===!1)return}e.forEach=C;function T(i,A){const d=Object.create(null);for(const p of i){const a=A(p);let f=d[a];f||(f=d[a]=[]),f.push(p)}return d}e.groupBy=T;function y(i){const A=Object.create(null);return i&&i.forEach((d,p)=>{A[p]=d}),A}e.fromMap=y;function I(i,A){const d=[],p=[];for(let a of i)A.has(a)||d.push(a);for(let a of A)i.has(a)||p.push(a);return{removed:d,added:p}}e.diffSets=I;function D(i,A){const d=[],p=[];for(let[a,f]of i)A.has(a)||d.push(f);for(let[a,f]of A)i.has(a)||p.push(f);return{removed:d,added:p}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(A,d){let p=this.map.get(A);p||(p=new Set,this.map.set(A,p)),p.add(d)}delete(A,d){const p=this.map.get(A);!p||(p.delete(d),p.size===0&&this.map.delete(A))}forEach(A,d){const p=this.map.get(A);!p||p.forEach(d)}}e.SetMap=P}),define(me[53],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(y){return(I,D,P)=>{let i=null,A=null;if(typeof P.value=="function"?(i="value",A=P.value):typeof P.get=="function"&&(i="get",A=P.get),!A)throw new Error("not supported");P[i]=y(A,D)}}e.createDecorator=v;function R(y,I,D){let P=null,i=null;if(typeof D.value=="function"?(P="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",i=D.get),!i)throw new Error("not supported");const A=`$memoize$${I}`;D[P]=function(...d){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,d)}),this[A]}}e.memoize=R;function C(y,I,D){return v((P,i)=>{const A=`$debounce$${i}`,d=`$debounce$result$${i}`;return function(...p){this[d]||(this[d]=D?D():void 0),clearTimeout(this[A]),I&&(this[d]=I(this[d],...p),p=[this[d]]),this[A]=setTimeout(()=>{P.apply(this,p),this[d]=D?D():void 0},y)}})}e.debounce=C;function T(y,I,D){return v((P,i)=>{const A=`$throttle$timer$${i}`,d=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...f){if(this[d]||(this[d]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...f)),this[a])return;const E=this[p]+y;E<=Date.now()?(this[p]=Date.now(),P.apply(this,[this[d]]),this[d]=D?D():void 0):(this[a]=!0,this[A]=setTimeout(()=>{this[a]=!1,this[p]=Date.now(),P.apply(this,[this[d]]),this[d]=D?D():void 0},E-Date.now()))}})}e.throttle=T}),define(me[17],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function C(h){D(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=C;function T(h){D(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=T;function y(h){if(h instanceof Error){let{name:t,message:n}=h;const s=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:s}}return h}e.transformErrorForSerialization=y;const I="Canceled";function D(h){return h instanceof Error&&h.name===I&&h.message===I}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function i(){const h=new Error(I);return h.name=h.message,h}e.canceled=i;function A(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=A;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=d;function p(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function a(h){const t=new Error(`${h} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function f(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=f;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function u(h){const t=h;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(h,t=Object.create(null)){const n=new Error(h);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[16],ge([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,k=0){return x[x.length-(1+k)]}e.tail=R;function C(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=C;function T(x,k,U=(F,M)=>F===M){if(x===k)return!0;if(!x||!k||x.length!==k.length)return!1;for(let F=0,M=x.length;F<M;F++)if(!U(x[F],k[F]))return!1;return!0}e.equals=T;function y(x,k,U){let F=0,M=x.length-1;for(;F<=M;){const $=(F+M)/2|0,H=U(x[$],k);if(H<0)F=$+1;else if(H>0)M=$-1;else return $}return-(F+1)}e.binarySearch=y;function I(x,k){let U=0,F=x.length;if(F===0)return 0;for(;U<F;){const M=Math.floor((U+F)/2);k(x[M])?F=M:U=M+1}return U}e.findFirstInSorted=I;function D(x,k,U){if(x=x|0,x>=k.length)throw new TypeError("invalid index");let F=k[Math.floor(k.length*Math.random())],M=[],$=[],H=[];for(let Q of k){const ae=U(Q,F);ae<0?M.push(Q):ae>0?$.push(Q):H.push(Q)}return x<M.length?D(x,M,U):x<M.length+H.length?H[0]:D(x-(M.length+H.length),$,U)}e.quickSelect=D;function P(x,k){const U=[];let F;for(const M of x.slice(0).sort(k))!F||k(F[0],M)!==0?(F=[M],U.push(F)):F.push(M);return U}e.groupBy=P;function i(x,k,U){const F=[];function M(Q,ae,we){if(ae===0&&we.length===0)return;const Le=F[F.length-1];Le&&Le.start+Le.deleteCount===Q?(Le.deleteCount+=ae,Le.toInsert.push(...we)):F.push({start:Q,deleteCount:ae,toInsert:we})}let $=0,H=0;for(;;){if($===x.length){M($,0,k.slice(H));break}if(H===k.length){M($,x.length-$,[]);break}const Q=x[$],ae=k[H],we=U(Q,ae);we===0?($+=1,H+=1):we<0?(M($,1,[]),$+=1):we>0&&(M($,0,[ae]),H+=1)}return F}e.sortedDiff=i;function A(x,k,U){const F=i(x,k,U),M=[],$=[];for(const H of F)M.push(...x.slice(H.start,H.start+H.deleteCount)),$.push(...H.toInsert);return{removed:M,added:$}}e.delta=A;function d(x,k,U){if(U===0)return[];const F=x.slice(0,U).sort(k);return a(x,k,F,U,x.length),F}e.top=d;function p(x,k,U,F,M){return U===0?Promise.resolve([]):new Promise(($,H)=>{(async()=>{const Q=x.length,ae=x.slice(0,U).sort(k);for(let we=U,Le=Math.min(U+F,Q);we<Q;we=Le,Le=Math.min(Le+F,Q)){if(we>U&&await new Promise(Ie=>setTimeout(Ie)),M&&M.isCancellationRequested)throw(0,v.canceled)();a(x,k,ae,we,Le)}return ae})().then($,H)})}e.topAsync=p;function a(x,k,U,F,M){for(const $=U.length;F<M;F++){const H=x[F];if(k(H,U[$-1])<0){U.pop();const Q=I(U,ae=>k(H,ae)<0);U.splice(Q,0,H)}}}function f(x){return x.filter(k=>!!k)}e.coalesce=f;function E(x){let k=0;for(let U=0;U<x.length;U++)x[U]&&(x[k]=x[U],k+=1);x.length=k}e.coalesceInPlace=E;function w(x,k,U){x.splice(U,0,x.splice(k,1)[0])}e.move=w;function _(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=_;function u(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=u;function c(x,k){if(!k)return x.filter((F,M)=>x.indexOf(F)===M);const U=Object.create(null);return x.filter(F=>{const M=k(F);return U[M]?!1:(U[M]=!0,!0)})}e.distinct=c;function h(x){const k=new Set;return x.filter(U=>k.has(U)?!1:(k.add(U),!0))}e.distinctES6=h;function t(x){const k=Object.create(null);return U=>{const F=x(U);return k[F]?!1:(k[F]=!0,!0)}}e.uniqueFilter=t;function n(x,k){for(let U=x.length-1;U>=0;U--){const F=x[U];if(k(F))return U}return-1}e.lastIndex=n;function s(x,k){return x.length>0?x[0]:k}e.firstOrDefault=s;function r(x,k,U=(F,M)=>F===M){let F=0;for(let M=0,$=Math.min(x.length,k.length);M<$&&U(x[M],k[M]);M++)F++;return F}e.commonPrefixLength=r;function o(x){return[].concat(...x)}e.flatten=o;function g(x,k){let U=typeof k=="number"?x:0;typeof k=="number"?U=x:(U=0,k=x);const F=[];if(U<=k)for(let M=U;M<k;M++)F.push(M);else for(let M=U;M>k;M--)F.push(M);return F}e.range=g;function m(x,k,U){return x.reduce((F,M)=>(F[k(M)]=U?U(M):M,F),Object.create(null))}e.index=m;function S(x,k){return x.push(k),()=>b(x,k)}e.insert=S;function b(x,k){const U=x.indexOf(k);if(U>-1)return x.splice(U,1),k}e.remove=b;function l(x,k,U){const F=x.slice(0,k),M=x.slice(k);return F.concat(U,M)}e.arrayInsert=l;function L(x,k){let U;if(typeof k=="number"){let F=k;U=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else U=Math.random;for(let F=x.length-1;F>0;F-=1){const M=Math.floor(U()*(F+1)),$=x[F];x[F]=x[M],x[M]=$}}e.shuffle=L;function O(x,k){const U=x.indexOf(k);U>-1&&(x.splice(U,1),x.unshift(k))}e.pushToStart=O;function W(x,k){const U=x.indexOf(k);U>-1&&(x.splice(U,1),x.push(k))}e.pushToEnd=W;function ie(x,k){return Array.isArray(x)?x.map(k):k(x)}e.mapArrayOrNot=ie;function re(x){return Array.isArray(x)?x:[x]}e.asArray=re;function N(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=N;function V(x,k){for(const U of x){const F=k(U);if(F!==void 0)return F}}e.mapFind=V}),define(me[72],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const C=this;let T=!1,y;return function(){return T||(T=!0,y=R.apply(C,arguments)),y}}e.once=v}),define(me[73],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(me[54],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function C(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=C;const T=Object.freeze([]);function y(){return T}R.empty=y;function*I(h){yield h}R.single=I;function D(h){return h||T}R.from=D;function P(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=P;function i(h){return h[Symbol.iterator]().next().value}R.first=i;function A(h,t){for(const n of h)if(t(n))return!0;return!1}R.some=A;function d(h,t){for(const n of h)if(t(n))return n}R.find=d;function*p(h,t){for(const n of h)t(n)&&(yield n)}R.filter=p;function*a(h,t){let n=0;for(const s of h)yield t(s,n++)}R.map=a;function*f(...h){for(const t of h)for(const n of t)yield n}R.concat=f;function*E(h){for(const t of h)for(const n of t)yield n}R.concatNested=E;function w(h,t,n){let s=n;for(const r of h)s=t(s,r);return s}R.reduce=w;function*_(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}R.slice=_;function u(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const s=h[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,R.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=u;function c(h,t,n=(s,r)=>s===r){const s=h[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),g=r.next();if(o.done!==g.done)return!1;if(o.done)return!0;if(!n(o.value,g.value))return!1}}R.equals=c})(v=e.Iterable||(e.Iterable={}))}),define(me[55],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",g=0,m=16,S=0;function b(N){let V=0,x=0;for(;V<N;){const k=t.charCodeAt(s);if(k>=48&&k<=57)x=x*16+k-48;else if(k>=65&&k<=70)x=x*16+k-65+10;else if(k>=97&&k<=102)x=x*16+k-97+10;else break;s++,V++}return V<N&&(x=-1),x}function l(N){s=N,o="",g=0,m=16,S=0}function L(){const N=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return S=3,t.substring(N,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;V=s}else S=3;return t.substring(N,V)}function O(){let N="",V=s;for(;;){if(s>=r){N+=t.substring(V,s),S=2;break}const x=t.charCodeAt(s);if(x===34){N+=t.substring(V,s),s++;break}if(x===92){if(N+=t.substring(V,s),s++,s>=r){S=2;break}switch(t.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const U=b(4);U>=0?N+=String.fromCharCode(U):S=4;break;default:S=5}V=s;continue}if(x>=0&&x<=31)if(D(x)){N+=t.substring(V,s),S=2;break}else S=6;s++}return N}function W(){if(o="",S=0,g=s,s>=r)return g=r,m=17;let N=t.charCodeAt(s);if(I(N)){do s++,o+=String.fromCharCode(N),N=t.charCodeAt(s);while(I(N));return m=15}if(D(N))return s++,o+=String.fromCharCode(N),N===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(N){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=O(),m=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring(V,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const x=r-1;let k=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,k=!0;break}s++}return k||(s++,S=1),o=t.substring(V,s),m=13}return o+=String.fromCharCode(N),s++,m=16;case 45:if(o+=String.fromCharCode(N),s++,s===r||!P(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),m=11;default:for(;s<r&&ie(N);)s++,N=t.charCodeAt(s);if(g!==s){switch(o=t.substring(g,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(N),s++,m=16}}function ie(N){if(I(N)||D(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let N;do N=W();while(N>=12&&N<=15);return N}return{setPosition:l,getPosition:()=>s,scan:n?re:W,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>S}}e.createScanner=y;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function A(t,n){const s=[],r=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function S(b,l,L,O){g.value=b,g.offset=l,g.length=L,g.type=O,g.colonOffset=void 0,o=g}try{u(t,{onObjectBegin:(b,l)=>{if(n<=b)throw r;o=void 0,m=n>b,s.push("")},onObjectProperty:(b,l,L)=>{if(n<l||(S(b,l,L,"property"),s[s.length-1]=b,n<=l+L))throw r},onObjectEnd:(b,l)=>{if(n<=b)throw r;o=void 0,s.pop()},onArrayBegin:(b,l)=>{if(n<=b)throw r;o=void 0,s.push(0)},onArrayEnd:(b,l)=>{if(n<=b)throw r;o=void 0,s.pop()},onLiteralValue:(b,l,L)=>{if(n<l||(S(b,l,L,h(b)),n<=l+L))throw r},onSeparator:(b,l,L)=>{if(n<=l)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=l,m=!1,o=void 0;else if(b===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:s,previousNode:o,isAtPropertyKey:m,matches:b=>{let l=0;for(let L=0;l<b.length&&L<s.length;L++)if(b[l]===s[L]||b[l]==="*")l++;else if(b[l]!=="**")return!1;return l===b.length}}}e.getLocation=A;function d(t,n=[],s=T.DEFAULT){let r=null,o=[];const g=[];function m(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return u(t,{onObjectBegin:()=>{const b={};m(b),g.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const b=[];m(b),g.push(o),o=b,r=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:m,onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},s),o[0]}e.parse=d;function p(t,n=[],s=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function g(b){return r.children.push(b),b}u(t,{onObjectBegin:b=>{r=g({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,l,L)=>{r=g({type:"property",offset:l,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:l,length:L,parent:r})},onObjectEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onArrayBegin:(b,l)=>{r=g({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onLiteralValue:(b,l,L)=>{g({type:h(b),offset:l,length:L,parent:r,value:b}),o(l+L)},onSeparator:(b,l,L)=>{r.type==="property"&&(b===":"?r.colonOffset=l:b===","&&o(l))},onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},s);const S=r.children[0];return S&&delete S.parent,S}e.parseTree=p;function a(t,n){if(!t)return;let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=a;function f(t){if(!t.parent||!t.parent.children)return[];const n=f(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=f;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function _(t,n,s=!1){if(w(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const g=_(r[o],n,s);if(g)return g}return t}}e.findNodeAtOffset=_;function u(t,n,s=T.DEFAULT){const r=y(t,!1);function o(ae){return ae?()=>ae(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(ae){return ae?we=>ae(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=o(n.onObjectBegin),S=g(n.onObjectProperty),b=o(n.onObjectEnd),l=o(n.onArrayBegin),L=o(n.onArrayEnd),O=g(n.onLiteralValue),W=g(n.onSeparator),ie=o(n.onComment),re=g(n.onError),N=s&&s.disallowComments,V=s&&s.allowTrailingComma;function x(){for(;;){const ae=r.scan();switch(r.getTokenError()){case 4:k(14);break;case 5:k(15);break;case 3:k(13);break;case 1:N||k(11);break;case 2:k(12);break;case 6:k(16);break}switch(ae){case 12:case 13:N?k(10):ie();break;case 16:k(1);break;case 15:case 14:break;default:return ae}}}function k(ae,we=[],Le=[]){if(re(ae),we.length+Le.length>0){let Ie=r.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){x();break}else if(Le.indexOf(Ie)!==-1)break;Ie=x()}}}function U(ae){const we=r.getTokenValue();return ae?O(we):S(we),x(),!0}function F(){switch(r.getToken()){case 11:let ae=0;try{ae=JSON.parse(r.getTokenValue()),typeof ae!="number"&&(k(2),ae=0)}catch(we){k(2)}O(ae);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function M(){return r.getToken()!==10?(k(3,[],[2,5]),!1):(U(!1),r.getToken()===6?(W(":"),x(),Q()||k(4,[],[2,5])):k(5,[],[2,5]),!0)}function $(){m(),x();let ae=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ae||k(4,[],[]),W(","),x(),r.getToken()===2&&V)break}else ae&&k(6,[],[]);M()||k(4,[],[2,5]),ae=!0}return b(),r.getToken()!==2?k(7,[2],[]):x(),!0}function H(){l(),x();let ae=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ae||k(4,[],[]),W(","),x(),r.getToken()===4&&V)break}else ae&&k(6,[],[]);Q()||k(4,[],[4,5]),ae=!0}return L(),r.getToken()!==4?k(8,[4],[]):x(),!0}function Q(){switch(r.getToken()){case 3:return H();case 1:return $();case 10:return U(!0);default:return F()}}return x(),r.getToken()===17?s.allowEmptyContent?!0:(k(4,[],[]),!1):Q()?(r.getToken()!==17&&k(9,[],[]),!0):(k(4,[],[]),!1)}e.visit=u;function c(t,n){let s=y(t),r=[],o,g=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:g!==m&&r.push(t.substring(g,m)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),g=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=c;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(me[133],ge([0,1,55]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,P,i){let A,d,p,a,f;if(P){for(a=P.offset,f=a+P.length,p=a;p>0&&!I(D,p-1);)p--;let g=f;for(;g<D.length&&!I(D,g);)g++;d=D.substring(p,g),A=T(d,i)}else d=D,A=0,p=0,a=0,f=D.length;const E=y(i,D);let w=!1,_=0,u;i.insertSpaces?u=C(" ",i.tabSize||4):u="	";const c=(0,v.createScanner)(d,!1);let h=!1;function t(){return E+C(u,A+_)}function n(){let g=c.scan();for(w=!1;g===15||g===14;)w=w||g===14,g=c.scan();return h=g===16||c.getTokenError()!==0,g}const s=[];function r(g,m,S){!h&&m<f&&S>a&&D.substring(m,S)!==g&&s.push({offset:m,length:S-m,content:g})}let o=n();if(o!==17){const g=c.getTokenOffset()+p,m=C(u,A);r(m,p,g)}for(;o!==17;){let g=c.getTokenOffset()+c.getTokenLength()+p,m=n(),S="";for(;!w&&(m===12||m===13);){const l=c.getTokenOffset()+p;r(" ",g,l),g=c.getTokenOffset()+c.getTokenLength()+p,S=m===12?t():"",m=n()}if(m===2)o!==1&&(_--,S=t());else if(m===4)o!==3&&(_--,S=t());else{switch(o){case 3:case 1:_++,S=t();break;case 5:case 12:S=t();break;case 13:w?S=t():S=" ";break;case 6:S=" ";break;case 10:if(m===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?S=" ":m!==5&&m!==17&&(h=!0);break;case 16:h=!0;break}w&&(m===12||m===13)&&(S=t())}const b=c.getTokenOffset()+p;r(S,g,b),o=m}return s}e.format=R;function C(D,P){let i="";for(let A=0;A<P;A++)i+=D;return i}function T(D,P){let i=0,A=0;const d=P.tabSize||4;for(;i<D.length;){const p=D.charAt(i);if(p===" ")A++;else if(p==="	")A+=d;else break;i++}return Math.floor(A/d)}function y(D,P){for(let i=0;i<P.length;i++){const A=P.charAt(i);if(A==="\r")return i+1<P.length&&P.charAt(i+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function I(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=I}),define(me[134],ge([0,1,55,133]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(P,i,A){return T(P,i,void 0,A)}e.removeProperty=C;function T(P,i,A,d,p){const a=i.slice(),f=[],E=(0,v.parseTree)(P,f);let w,_;for(;a.length>0&&(_=a.pop(),w=(0,v.findNodeAtLocation)(E,a),w===void 0&&A!==void 0);)typeof _=="string"?A={[_]:A}:A=[A];if(w)if(w.type==="object"&&typeof _=="string"&&Array.isArray(w.children)){const u=(0,v.findNodeAtLocation)(w,[_]);if(u!==void 0)if(A===void 0){if(!u.parent)throw new Error("Malformed AST");const c=w.children.indexOf(u.parent);let h,t=u.parent.offset+u.parent.length;if(c>0){const n=w.children[c-1];h=n.offset+n.length}else h=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(P,{offset:h,length:t-h,content:""},d)}else return y(P,{offset:u.offset,length:u.length,content:JSON.stringify(A)},d);else{if(A===void 0)return[];const c=`${JSON.stringify(_)}: ${JSON.stringify(A)}`,h=p?p(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(h>0){const n=w.children[h-1];t={offset:n.offset+n.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return y(P,t,d)}}else if(w.type==="array"&&typeof _=="number"&&Array.isArray(w.children))if(A!==void 0){const u=`${JSON.stringify(A)}`;let c;if(w.children.length===0||_===0)c={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const h=_===-1||_>w.children.length?w.children.length:_,t=w.children[h-1];c={offset:t.offset+t.length,length:0,content:","+u}}return y(P,c,d)}else{const u=_,c=w.children[u];let h;if(w.children.length===1)h={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],n=t.offset+t.length,s=w.offset+w.length;h={offset:n,length:s-2-n,content:""}}else h={offset:c.offset,length:w.children[u+1].offset-c.offset,content:""};return y(P,h,d)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${w.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return y(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(A)},d)}}e.setProperty=T;function y(P,i,A){let d=I(P,i),p=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,R.isEOL)(d,p-1);)p--;for(;a<d.length&&!(0,R.isEOL)(d,a);)a++}const f=(0,R.format)(d,{offset:p,length:a-p},A);for(let w=f.length-1;w>=0;w--){const _=f[w];d=I(d,_),p=Math.min(p,_.offset),a=Math.max(a,_.offset+_.length),a+=_.content.length-_.length}const E=P.length-(d.length-a)-p;return[{offset:p,length:E,content:d.substring(p,a)}]}e.withFormatting=y;function I(P,i){return P.substring(0,i.offset)+i.content+P.substring(i.offset+i.length)}e.applyEdit=I;function D(P,i){let A=i.slice(0).sort((p,a)=>{const f=p.offset-a.offset;return f===0?p.length-a.length:f}),d=P.length;for(let p=A.length-1;p>=0;p--){let a=A[p];if(a.offset+a.length<=d)P=I(P,a);else throw new Error("Overlapping edit");d=a.offset}return P}e.applyEdits=D}),define(me[135],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new v(()=>C(this.getValue()))}}e.Lazy=v}),define(me[6],ge([0,1,72,54]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let T=null;function y(u){T=u}if(e.setDisposableTracker=y,C){const u="__is_disposable_tracked__";T=new class{trackDisposable(c){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(h)},3e3)}markTracked(c){if(c&&c!==f.None)try{c[u]=!0}catch(h){}}}}function I(u){!T||T.markTracked(u)}function D(u){return T&&T.trackDisposable(u),u}e.trackDisposable=D;class P extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=P;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function A(u){if(R.Iterable.is(u)){let c=[];for(const h of u)if(h){I(h);try{h.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new P(c);return Array.isArray(u)?[]:u}else if(u)return I(u),u.dispose(),u}e.dispose=A;function d(...u){return u.forEach(I),p(()=>A(u))}e.combinedDisposable=d;function p(u){const c=D({dispose:()=>{I(c),u()}});return c}e.toDisposable=p;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{A(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new a,D(this)}dispose(){I(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var h;this._isDisposed||c===this._value||((h=this._value)===null||h===void 0||h.dispose(),c&&I(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,I(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(c,...h){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...h)},this.references.set(c,t));const{object:n}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class _{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=_}),define(me[56],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(T){this.element=T,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let T=this._first;for(;T!==v.Undefined;){const y=T.next;T.prev=v.Undefined,T.next=v.Undefined,T=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const I=new v(T);if(this._first===v.Undefined)this._first=I,this._last=I;else if(y){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==v.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==v.Undefined&&T.next!==v.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===v.Undefined&&T.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):T.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):T.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==v.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(K,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(K=typeof globalThis!="undefined"?globalThis:K||self,K.marked=e())}(this,function(){"use strict";function K(Ce,De){for(var ke=0;ke<De.length;ke++){var se=De[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ce,se.key,se)}}function e(Ce,De,ke){return De&&K(Ce.prototype,De),ke&&K(Ce,ke),Ce}function v(Ce,De){if(!!Ce){if(typeof Ce=="string")return R(Ce,De);var ke=Object.prototype.toString.call(Ce).slice(8,-1);if(ke==="Object"&&Ce.constructor&&(ke=Ce.constructor.name),ke==="Map"||ke==="Set")return Array.from(Ce);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(Ce,De)}}function R(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var ke=0,se=new Array(De);ke<De;ke++)se[ke]=Ce[ke];return se}function C(Ce,De){var ke;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(ke=v(Ce))||De&&Ce&&typeof Ce.length=="number"){ke&&(Ce=ke);var se=0;return function(){return se>=Ce.length?{done:!0}:{done:!1,value:Ce[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=Ce[Symbol.iterator](),ke.next.bind(ke)}function T(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var y=T(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(se){Ce.exports.defaults=se}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:ke}}),I=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(De){return A[De]};function p(Ce,De){if(De){if(I.test(Ce))return Ce.replace(D,d)}else if(P.test(Ce))return Ce.replace(i,d);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(Ce){return Ce.replace(a,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(Ce,De){Ce=Ce.source||Ce,De=De||"";var ke={replace:function(de,z){return z=z.source||z,z=z.replace(E,"$1"),Ce=Ce.replace(de,z),ke},getRegex:function(){return new RegExp(Ce,De)}};return ke}var _=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(Ce,De,ke){if(Ce){var se;try{se=decodeURIComponent(f(ke)).replace(_,"").toLowerCase()}catch(de){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}De&&!u.test(ke)&&(ke=r(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var h={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,De){h[" "+Ce]||(t.test(Ce)?h[" "+Ce]=Ce+"/":h[" "+Ce]=S(Ce,"/",!0)),Ce=h[" "+Ce];var ke=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Ce.replace(n,"$1")+De:De.charAt(0)==="/"?ke?De:Ce.replace(s,"$1")+De:Ce+De}var o={exec:function(){}};function g(Ce){for(var De=1,ke,se;De<arguments.length;De++){ke=arguments[De];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Ce[se]=ke[se])}return Ce}function m(Ce,De){var ke=Ce.replace(/\|/g,function(z,J,le){for(var Pe=!1,Ae=J;--Ae>=0&&le[Ae]==="\\";)Pe=!Pe;return Pe?"|":" |"}),se=ke.split(/ \|/),de=0;if(se.length>De)se.splice(De);else for(;se.length<De;)se.push("");for(;de<se.length;de++)se[de]=se[de].trim().replace(/\\\|/g,"|");return se}function S(Ce,De,ke){var se=Ce.length;if(se===0)return"";for(var de=0;de<se;){var z=Ce.charAt(se-de-1);if(z===De&&!ke)de++;else if(z!==De&&ke)de++;else break}return Ce.substr(0,se-de)}function b(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var ke=Ce.length,se=0,de=0;de<ke;de++)if(Ce[de]==="\\")de++;else if(Ce[de]===De[0])se++;else if(Ce[de]===De[1]&&(se--,se<0))return de;return-1}function l(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Ce,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Ce),De>>=1,Ce+=Ce;return ke+Ce}var O={escape:p,unescape:f,edit:w,cleanUrl:c,resolveUrl:r,noopTest:o,merge:g,splitCells:m,rtrim:S,findClosingBracket:b,checkSanitizeDeprecation:l,repeatString:L},W=y.defaults,ie=O.rtrim,re=O.splitCells,N=O.escape,V=O.findClosingBracket;function x(Ce,De,ke){var se=De.href,de=De.title?N(De.title):null,z=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:ke,href:se,title:de,text:z}:{type:"image",raw:ke,href:se,title:de,text:N(z)}}function k(Ce,De){var ke=Ce.match(/^(\s+)(?:```)/);if(ke===null)return De;var se=ke[1];return De.split(`
`).map(function(de){var z=de.match(/^\s+/);if(z===null)return de;var J=z[0];return J.length>=se.length?de.slice(se.length):de}).join(`
`)}var U=function(){function Ce(ke){this.options=ke||W}var De=Ce.prototype;return De.space=function(se){var de=this.rules.block.newline.exec(se);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(se){var de=this.rules.block.code.exec(se);if(de){var z=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?z:ie(z,`
`)}}},De.fences=function(se){var de=this.rules.block.fences.exec(se);if(de){var z=de[0],J=k(z,de[3]||"");return{type:"code",raw:z,lang:de[2]?de[2].trim():de[2],text:J}}},De.heading=function(se){var de=this.rules.block.heading.exec(se);if(de){var z=de[2].trim();if(/#$/.test(z)){var J=ie(z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(z=J.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:z}}},De.nptable=function(se){var de=this.rules.block.nptable.exec(se);if(de){var z={type:"table",header:re(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(z.header.length===z.align.length){var J=z.align.length,le;for(le=0;le<J;le++)/^ *-+: *$/.test(z.align[le])?z.align[le]="right":/^ *:-+: *$/.test(z.align[le])?z.align[le]="center":/^ *:-+ *$/.test(z.align[le])?z.align[le]="left":z.align[le]=null;for(J=z.cells.length,le=0;le<J;le++)z.cells[le]=re(z.cells[le],z.header.length);return z}}},De.hr=function(se){var de=this.rules.block.hr.exec(se);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(se){var de=this.rules.block.blockquote.exec(se);if(de){var z=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:z}}},De.list=function(se){var de=this.rules.block.list.exec(se);if(de){var z=de[0],J=de[2],le=J.length>1,Pe={type:"list",raw:z,ordered:le,start:le?+J.slice(0,-1):"",loose:!1,items:[]},Ae=de[0].match(this.rules.block.item),Ue=!1,Be,Qe,rt,et,Ye,ot,Et,bt,Ee=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var he=0;he<Ee;he++){if(Be=Ae[he],z=Be,he!==Ee-1){if(et=this.rules.block.listItemStart.exec(Ae[he+1]),this.options.pedantic?et[1].length>rt[1].length:et[1].length>rt[0].length||et[1].length>3){Ae.splice(he,2,Ae[he]+`
`+Ae[he+1]),he--,Ee--;continue}else(!this.options.pedantic||this.options.smartLists?et[2][et[2].length-1]!==J[J.length-1]:le===(et[2].length===1))&&(Ye=Ae.slice(he+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Ye.length),he=Ee-1);rt=et}Qe=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Qe-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Ue||/\n\n(?!\s*$)/.test(Be),he!==Ee-1&&(Ue=Be.charAt(Be.length-1)===`
`,ot||(ot=Ue)),ot&&(Pe.loose=!0),this.options.gfm&&(Et=/^\[[ xX]\] /.test(Be),bt=void 0,Et&&(bt=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:z,task:Et,checked:bt,loose:ot,text:Be})}return Pe}},De.html=function(se){var de=this.rules.block.html.exec(se);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):N(de[0]):de[0]}},De.def=function(se){var de=this.rules.block.def.exec(se);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var z=de[1].toLowerCase().replace(/\s+/g," ");return{tag:z,raw:de[0],href:de[2],title:de[3]}}},De.table=function(se){var de=this.rules.block.table.exec(se);if(de){var z={type:"table",header:re(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=de[0];var J=z.align.length,le;for(le=0;le<J;le++)/^ *-+: *$/.test(z.align[le])?z.align[le]="right":/^ *:-+: *$/.test(z.align[le])?z.align[le]="center":/^ *:-+ *$/.test(z.align[le])?z.align[le]="left":z.align[le]=null;for(J=z.cells.length,le=0;le<J;le++)z.cells[le]=re(z.cells[le].replace(/^ *\| *| *\| *$/g,""),z.header.length);return z}}},De.lheading=function(se){var de=this.rules.block.lheading.exec(se);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},De.paragraph=function(se){var de=this.rules.block.paragraph.exec(se);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},De.text=function(se){var de=this.rules.block.text.exec(se);if(de)return{type:"text",raw:de[0],text:de[0]}},De.escape=function(se){var de=this.rules.inline.escape.exec(se);if(de)return{type:"escape",raw:de[0],text:N(de[1])}},De.tag=function(se,de,z){var J=this.rules.inline.tag.exec(se);if(J)return!de&&/^<a /i.test(J[0])?de=!0:de&&/^<\/a>/i.test(J[0])&&(de=!1),!z&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?z=!0:z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(z=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:de,inRawBlock:z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]}},De.link=function(se){var de=this.rules.inline.link.exec(se);if(de){var z=de[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var J=ie(z.slice(0,-1),"\\");if((z.length-J.length)%2==0)return}else{var le=V(de[2],"()");if(le>-1){var Pe=de[0].indexOf("!")===0?5:4,Ae=Pe+de[1].length+le;de[2]=de[2].substring(0,le),de[0]=de[0].substring(0,Ae).trim(),de[3]=""}}var Ue=de[2],Be="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Qe&&(Ue=Qe[1],Be=Qe[3])}else Be=de[3]?de[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(z)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),x(de,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},de[0])}},De.reflink=function(se,de){var z;if((z=this.rules.inline.reflink.exec(se))||(z=this.rules.inline.nolink.exec(se))){var J=(z[2]||z[1]).replace(/\s+/g," ");if(J=de[J.toLowerCase()],!J||!J.href){var le=z[0].charAt(0);return{type:"text",raw:le,text:le}}return x(z,J,z[0])}},De.emStrong=function(se,de,z){z===void 0&&(z="");var J=this.rules.inline.emStrong.lDelim.exec(se);if(!!J&&!(J[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=J[1]||J[2]||"";if(!le||le&&(z===""||this.rules.inline.punctuation.exec(z))){var Pe=J[0].length-1,Ae,Ue,Be=Pe,Qe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,de=de.slice(-1*se.length+Pe);(J=rt.exec(de))!=null;)if(Ae=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!Ae){if(Ue=Ae.length,J[3]||J[4]){Be+=Ue;continue}else if((J[5]||J[6])&&Pe%3&&!((Pe+Ue)%3)){Qe+=Ue;continue}if(Be-=Ue,!(Be>0)){if(Be+Qe-Ue<=0&&!de.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+Be+Qe)),Math.min(Pe,Ue)%2)return{type:"em",raw:se.slice(0,Pe+J.index+Ue+1),text:se.slice(1,Pe+J.index+Ue)};if(Math.min(Pe,Ue)%2==0)return{type:"strong",raw:se.slice(0,Pe+J.index+Ue+1),text:se.slice(2,Pe+J.index+Ue-1)}}}}}},De.codespan=function(se){var de=this.rules.inline.code.exec(se);if(de){var z=de[2].replace(/\n/g," "),J=/[^ ]/.test(z),le=/^ /.test(z)&&/ $/.test(z);return J&&le&&(z=z.substring(1,z.length-1)),z=N(z,!0),{type:"codespan",raw:de[0],text:z}}},De.br=function(se){var de=this.rules.inline.br.exec(se);if(de)return{type:"br",raw:de[0]}},De.del=function(se){var de=this.rules.inline.del.exec(se);if(de)return{type:"del",raw:de[0],text:de[2]}},De.autolink=function(se,de){var z=this.rules.inline.autolink.exec(se);if(z){var J,le;return z[2]==="@"?(J=N(this.options.mangle?de(z[1]):z[1]),le="mailto:"+J):(J=N(z[1]),le=J),{type:"link",raw:z[0],text:J,href:le,tokens:[{type:"text",raw:J,text:J}]}}},De.url=function(se,de){var z;if(z=this.rules.inline.url.exec(se)){var J,le;if(z[2]==="@")J=N(this.options.mangle?de(z[0]):z[0]),le="mailto:"+J;else{var Pe;do Pe=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(Pe!==z[0]);J=N(z[0]),z[1]==="www."?le="http://"+J:le=J}return{type:"link",raw:z[0],text:J,href:le,tokens:[{type:"text",raw:J,text:J}]}}},De.inlineText=function(se,de,z){var J=this.rules.inline.text.exec(se);if(J){var le;return de?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]:le=N(this.options.smartypants?z(J[0]):J[0]),{type:"text",raw:J[0],text:le}}},Ce}(),F=O.noopTest,M=O.edit,$=O.merge,H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=M(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,H.item=M(H.item,"gm").replace(/bull/g,H.bullet).getRegex(),H.listItemStart=M(/^( *)(bull)/).replace("bull",H.bullet).getRegex(),H.list=M(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=M(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=M(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.blockquote=M(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=$({},H),H.gfm=$({},H.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.nptable=M(H.gfm.nptable).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.gfm.table=M(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.pedantic=$({},H.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=M(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=M(H._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=M(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=M(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=M(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=M(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=M(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=M(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=M(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=M(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=$({},Q),Q.pedantic=$({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=$({},Q.normal,{escape:M(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=M(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=$({},Q.gfm,{br:M(Q.br).replace("{2,}","*").getRegex(),text:M(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ae={block:H,inline:Q},we=y.defaults,Le=ae.block,Ie=ae.inline,Oe=O.repeatString;function We(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Ce){var De="",ke,se,de=Ce.length;for(ke=0;ke<de;ke++)se=Ce.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),De+="&#"+se+";";return De}var X=function(){function Ce(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||we,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Le.normal,inline:Ie.normal};this.options.pedantic?(se.block=Le.pedantic,se.inline=Ie.pedantic):this.options.gfm&&(se.block=Le.gfm,this.options.breaks?se.inline=Ie.breaks:se.inline=Ie.gfm),this.tokenizer.rules=se}Ce.lex=function(se,de){var z=new Ce(de);return z.lex(se)},Ce.lexInline=function(se,de){var z=new Ce(de);return z.inlineTokens(se)};var De=Ce.prototype;return De.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(se,de,z){de===void 0&&(de=[]),z===void 0&&(z=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var J,le,Pe,Ae;se;){if(J=this.tokenizer.space(se)){se=se.substring(J.raw.length),J.type&&de.push(J);continue}if(J=this.tokenizer.code(se)){se=se.substring(J.raw.length),Ae=de[de.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):de.push(J);continue}if(J=this.tokenizer.fences(se)){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.heading(se)){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.nptable(se)){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.hr(se)){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.blockquote(se)){se=se.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],z),de.push(J);continue}if(J=this.tokenizer.list(se)){for(se=se.substring(J.raw.length),Pe=J.items.length,le=0;le<Pe;le++)J.items[le].tokens=this.blockTokens(J.items[le].text,[],!1);de.push(J);continue}if(J=this.tokenizer.html(se)){se=se.substring(J.raw.length),de.push(J);continue}if(z&&(J=this.tokenizer.def(se))){se=se.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(se)){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.lheading(se)){se=se.substring(J.raw.length),de.push(J);continue}if(z&&(J=this.tokenizer.paragraph(se))){se=se.substring(J.raw.length),de.push(J);continue}if(J=this.tokenizer.text(se)){se=se.substring(J.raw.length),Ae=de[de.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):de.push(J);continue}if(se){var Ue="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return de},De.inline=function(se){var de,z,J,le,Pe,Ae,Ue=se.length;for(de=0;de<Ue;de++)switch(Ae=se[de],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},le=Ae.header.length,z=0;z<le;z++)Ae.tokens.header[z]=[],this.inlineTokens(Ae.header[z],Ae.tokens.header[z]);for(le=Ae.cells.length,z=0;z<le;z++)for(Pe=Ae.cells[z],Ae.tokens.cells[z]=[],J=0;J<Pe.length;J++)Ae.tokens.cells[z][J]=[],this.inlineTokens(Pe[J],Ae.tokens.cells[z][J]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(le=Ae.items.length,z=0;z<le;z++)this.inline(Ae.items[z].tokens);break}}return se},De.inlineTokens=function(se,de,z,J){de===void 0&&(de=[]),z===void 0&&(z=!1),J===void 0&&(J=!1);var le,Pe,Ae=se,Ue,Be,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Ue.index)+"["+Oe("a",Ue[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Ue.index)+"["+Oe("a",Ue[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Ue.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Be||(Qe=""),Be=!1,le=this.tokenizer.escape(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.tag(se,z,J)){se=se.substring(le.raw.length),z=le.inLink,J=le.inRawBlock;var et=de[de.length-1];et&&le.type==="text"&&et.type==="text"?(et.raw+=le.raw,et.text+=le.text):de.push(le);continue}if(le=this.tokenizer.link(se)){se=se.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,J)),de.push(le);continue}if(le=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(le.raw.length);var Ye=de[de.length-1];le.type==="link"?(le.tokens=this.inlineTokens(le.text,[],!0,J),de.push(le)):Ye&&le.type==="text"&&Ye.type==="text"?(Ye.raw+=le.raw,Ye.text+=le.text):de.push(le);continue}if(le=this.tokenizer.emStrong(se,Ae,Qe)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],z,J),de.push(le);continue}if(le=this.tokenizer.codespan(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.br(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.del(se)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],z,J),de.push(le);continue}if(le=this.tokenizer.autolink(se,j)){se=se.substring(le.raw.length),de.push(le);continue}if(!z&&(le=this.tokenizer.url(se,j))){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.inlineText(se,J,We)){se=se.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(Qe=le.raw.slice(-1)),Be=!0,Pe=de[de.length-1],Pe&&Pe.type==="text"?(Pe.raw+=le.raw,Pe.text+=le.text):de.push(le);continue}if(se){var ot="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return de},e(Ce,null,[{key:"rules",get:function(){return{block:Le,inline:Ie}}}]),Ce}(),ee=y.defaults,oe=O.cleanUrl,pe=O.escape,Se=function(){function Ce(ke){this.options=ke||ee}var De=Ce.prototype;return De.code=function(se,de,z){var J=(de||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(se,J);le!=null&&le!==se&&(z=!0,se=le)}return se=se.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+pe(J,!0)+'">'+(z?se:pe(se,!0))+`</code></pre>
`:"<pre><code>"+(z?se:pe(se,!0))+`</code></pre>
`},De.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},De.html=function(se){return se},De.heading=function(se,de,z,J){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+J.slug(z)+'">'+se+"</h"+de+`>
`:"<h"+de+">"+se+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(se,de,z){var J=de?"ol":"ul",le=de&&z!==1?' start="'+z+'"':"";return"<"+J+le+`>
`+se+"</"+J+`>
`},De.listitem=function(se){return"<li>"+se+`</li>
`},De.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(se){return"<p>"+se+`</p>
`},De.table=function(se,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+de+`</table>
`},De.tablerow=function(se){return`<tr>
`+se+`</tr>
`},De.tablecell=function(se,de){var z=de.header?"th":"td",J=de.align?"<"+z+' align="'+de.align+'">':"<"+z+">";return J+se+"</"+z+`>
`},De.strong=function(se){return"<strong>"+se+"</strong>"},De.em=function(se){return"<em>"+se+"</em>"},De.codespan=function(se){return"<code>"+se+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(se){return"<del>"+se+"</del>"},De.link=function(se,de,z){if(se=oe(this.options.sanitize,this.options.baseUrl,se),se===null)return z;var J='<a href="'+pe(se)+'"';return de&&(J+=' title="'+de+'"'),J+=">"+z+"</a>",J},De.image=function(se,de,z){if(se=oe(this.options.sanitize,this.options.baseUrl,se),se===null)return z;var J='<img src="'+se+'" alt="'+z+'"';return de&&(J+=' title="'+de+'"'),J+=this.options.xhtml?"/>":">",J},De.text=function(se){return se},Ce}(),ce=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(se){return se},De.em=function(se){return se},De.codespan=function(se){return se},De.del=function(se){return se},De.html=function(se){return se},De.text=function(se){return se},De.link=function(se,de,z){return""+z},De.image=function(se,de,z){return""+z},De.br=function(){return""},Ce}(),_e=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(se,de){var z=se,J=0;if(this.seen.hasOwnProperty(z)){J=this.seen[se];do J++,z=se+"-"+J;while(this.seen.hasOwnProperty(z))}return de||(this.seen[se]=J,this.seen[z]=0),z},De.slug=function(se,de){de===void 0&&(de={});var z=this.serialize(se);return this.getNextSafeSlug(z,de.dryrun)},Ce}(),Re=y.defaults,Ve=O.unescape,be=function(){function Ce(ke){this.options=ke||Re,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new _e}Ce.parse=function(se,de){var z=new Ce(de);return z.parse(se)},Ce.parseInline=function(se,de){var z=new Ce(de);return z.parseInline(se)};var De=Ce.prototype;return De.parse=function(se,de){de===void 0&&(de=!0);var z="",J,le,Pe,Ae,Ue,Be,Qe,rt,et,Ye,ot,Et,bt,Ee,he,ue,Y,Me,Fe=se.length;for(J=0;J<Fe;J++)switch(Ye=se[J],Ye.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Ve(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(rt="",Qe="",Ae=Ye.header.length,le=0;le<Ae;le++)Qe+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[le]),{header:!0,align:Ye.align[le]});for(rt+=this.renderer.tablerow(Qe),et="",Ae=Ye.cells.length,le=0;le<Ae;le++){for(Be=Ye.tokens.cells[le],Qe="",Ue=Be.length,Pe=0;Pe<Ue;Pe++)Qe+=this.renderer.tablecell(this.parseInline(Be[Pe]),{header:!1,align:Ye.align[Pe]});et+=this.renderer.tablerow(Qe)}z+=this.renderer.table(rt,et);continue}case"blockquote":{et=this.parse(Ye.tokens),z+=this.renderer.blockquote(et);continue}case"list":{for(ot=Ye.ordered,Et=Ye.start,bt=Ye.loose,Ae=Ye.items.length,et="",le=0;le<Ae;le++)he=Ye.items[le],ue=he.checked,Y=he.task,Ee="",he.task&&(Me=this.renderer.checkbox(ue),bt?he.tokens.length>0&&he.tokens[0].type==="text"?(he.tokens[0].text=Me+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=Me+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",text:Me}):Ee+=Me),Ee+=this.parse(he.tokens,bt),et+=this.renderer.listitem(Ee,Y,ue);z+=this.renderer.list(et,ot,Et);continue}case"html":{z+=this.renderer.html(Ye.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(et=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;J+1<Fe&&se[J+1].type==="text";)Ye=se[++J],et+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);z+=de?this.renderer.paragraph(et):et;continue}default:{var Je='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return z},De.parseInline=function(se,de){de=de||this.renderer;var z="",J,le,Pe=se.length;for(J=0;J<Pe;J++)switch(le=se[J],le.type){case"escape":{z+=de.text(le.text);break}case"html":{z+=de.html(le.text);break}case"link":{z+=de.link(le.href,le.title,this.parseInline(le.tokens,de));break}case"image":{z+=de.image(le.href,le.title,le.text);break}case"strong":{z+=de.strong(this.parseInline(le.tokens,de));break}case"em":{z+=de.em(this.parseInline(le.tokens,de));break}case"codespan":{z+=de.codespan(le.text);break}case"br":{z+=de.br();break}case"del":{z+=de.del(this.parseInline(le.tokens,de));break}case"text":{z+=de.text(le.text);break}default:{var Ae='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return z},Ce}(),Ge=O.merge,G=O.checkSanitizeDeprecation,ne=O.escape,ve=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function ze(Ce,De,ke){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=Ge({},ze.defaults,De||{}),G(De),ke){var se=De.highlight,de;try{de=X.lex(Ce,De)}catch(Pe){return ke(Pe)}var z=function(Ae){var Ue;if(!Ae)try{Ue=be.parse(de,De)}catch(Be){Ae=Be}return De.highlight=se,Ae?ke(Ae):ke(null,Ue)};if(!se||se.length<3||(delete De.highlight,!de.length))return z();var J=0;ze.walkTokens(de,function(Pe){Pe.type==="code"&&(J++,setTimeout(function(){se(Pe.text,Pe.lang,function(Ae,Ue){if(Ae)return z(Ae);Ue!=null&&Ue!==Pe.text&&(Pe.text=Ue,Pe.escaped=!0),J--,J===0&&z()})},0))}),J===0&&z();return}try{var le=X.lex(Ce,De);return De.walkTokens&&ze.walkTokens(le,De.walkTokens),be.parse(le,De)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ne(Pe.message+"",!0)+"</pre>";throw Pe}}ze.options=ze.setOptions=function(Ce){return Ge(ze.defaults,Ce),xe(ze.defaults),ze},ze.getDefaults=ve,ze.defaults=je,ze.use=function(Ce){var De=Ge({},Ce);if(Ce.renderer&&function(){var se=ze.defaults.renderer||new Se,de=function(le){var Pe=se[le];se[le]=function(){for(var Ae=arguments.length,Ue=new Array(Ae),Be=0;Be<Ae;Be++)Ue[Be]=arguments[Be];var Qe=Ce.renderer[le].apply(se,Ue);return Qe===!1&&(Qe=Pe.apply(se,Ue)),Qe}};for(var z in Ce.renderer)de(z);De.renderer=se}(),Ce.tokenizer&&function(){var se=ze.defaults.tokenizer||new U,de=function(le){var Pe=se[le];se[le]=function(){for(var Ae=arguments.length,Ue=new Array(Ae),Be=0;Be<Ae;Be++)Ue[Be]=arguments[Be];var Qe=Ce.tokenizer[le].apply(se,Ue);return Qe===!1&&(Qe=Pe.apply(se,Ue)),Qe}};for(var z in Ce.tokenizer)de(z);De.tokenizer=se}(),Ce.walkTokens){var ke=ze.defaults.walkTokens;De.walkTokens=function(se){Ce.walkTokens(se),ke&&ke(se)}}ze.setOptions(De)},ze.walkTokens=function(Ce,De){for(var ke=C(Ce),se;!(se=ke()).done;){var de=se.value;switch(De(de),de.type){case"table":{for(var z=C(de.tokens.header),J;!(J=z()).done;){var le=J.value;ze.walkTokens(le,De)}for(var Pe=C(de.tokens.cells),Ae;!(Ae=Pe()).done;)for(var Ue=Ae.value,Be=C(Ue),Qe;!(Qe=Be()).done;){var rt=Qe.value;ze.walkTokens(rt,De)}break}case"list":{ze.walkTokens(de.items,De);break}default:de.tokens&&ze.walkTokens(de.tokens,De)}}},ze.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=Ge({},ze.defaults,De||{}),G(De);try{var ke=X.lexInline(Ce,De);return De.walkTokens&&ze.walkTokens(ke,De.walkTokens),be.parseInline(ke,De)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ne(se.message+"",!0)+"</pre>";throw se}},ze.Parser=be,ze.parser=be.parse,ze.Renderer=Se,ze.TextRenderer=ce,ze.Lexer=X,ze.lexer=X.lex,ze.Tokenizer=U,ze.Slugger=_e,ze.parse=ze;var Xe=ze;return Xe}),define(me[74],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(y,I,D){return Math.min(Math.max(y,I),D)}e.clamp=v;function R(y,I){return(I+y%I)%I}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function K(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function y(D){T.push(D,Date.now())}function I(){const D=[];for(let P=0;P<T.length;P+=2)D.push({name:T[P],startTime:T[P+1]});return D}return{mark:y,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(C+y.startTime)});return T}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(me[11],ge([0,1]),function(K,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,T=!1,y=!1,I=!1,D=!1,P=!1,i=!1,A,d=R,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const E=typeof((v=f==null?void 0:f.versions)===null||v===void 0?void 0:v.electron)=="string"&&f.type==="renderer";if(e.isElectronSandboxed=E&&(f==null?void 0:f.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=f==null?void 0:f.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,C=a.indexOf("Windows")>=0,T=a.indexOf("Macintosh")>=0,i=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,P=!0,A=navigator.language,d=A;else if(typeof f=="object"){C=f.platform==="win32",T=f.platform==="darwin",y=f.platform==="linux",I=y&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,A=R,d=R;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),g=o.availableLanguages["*"];A=o.locale,d=g||R,p=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let u=0;T?u=1:C?u=3:y&&(u=2),e.isWindows=C,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=I,e.isNative=D,e.isWeb=P,e.isIOS=i,e.platform=u,e.userAgent=a,e.language=d;var c;(function(r){function o(){return e.language}r.value=o;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function m(){return e.language==="en"}r.isDefault=m})(c=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let b=0,l=g.length;b<l;b++){const L=g[b];if(L.id===S.data.vscodeSetImmediateId){g.splice(b,1),L.callback();return}}});let m=0;return S=>{const b=++m;g.push({id:b,callback:S}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(f==null?void 0:f.nextTick)=="function")return f.nextTick.bind(f);const o=Promise.resolve();return g=>o.then(g)}();var h;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:C?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,11]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const C=v.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(T){return(0,v.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(C){return(0,v.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,36]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,T=90,y=122,I=46,D=47,P=92,i=58,A=63;class d extends Error{constructor(c,h,t){let n;typeof h=="string"&&h.indexOf("not ")===0?(n="must not be",h=h.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${s} ${n} of type ${h}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,c){if(typeof u!="string")throw new d(c,"string",u)}function a(u){return u===D||u===P}function f(u){return u===D}function E(u){return u>=R&&u<=T||u>=C&&u<=y}function w(u,c,h,t){let n="",s=0,r=-1,o=0,g=0;for(let m=0;m<=u.length;++m){if(m<u.length)g=u.charCodeAt(m);else{if(t(g))break;g=D}if(t(g)){if(!(r===m-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const S=n.lastIndexOf(h);S===-1?(n="",s=0):(n=n.slice(0,S),s=n.length-1-n.lastIndexOf(h)),r=m,o=0;continue}else if(n.length!==0){n="",s=0,r=m,o=0;continue}}c&&(n+=n.length>0?`${h}..`:"..",s=2)}else n.length>0?n+=`${h}${u.slice(r+1,m)}`:n=u.slice(r+1,m),s=m-r-1;r=m,o=0}else g===I&&o!==-1?++o:o=-1}return n}function _(u,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const h=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return h?h===c.root?`${h}${t}`:`${h}${u}${t}`:t}e.win32={resolve(...u){let c="",h="",t=!1;for(let n=u.length-1;n>=-1;n--){let s;if(n>=0){if(s=u[n],p(s,"path"),s.length===0)continue}else c.length===0?s=v.cwd():(s=v.env[`=${c}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${c}\\`));const r=s.length;let o=0,g="",m=!1;const S=s.charCodeAt(0);if(r===1)a(S)&&(o=1,m=!0);else if(a(S))if(m=!0,a(s.charCodeAt(1))){let b=2,l=b;for(;b<r&&!a(s.charCodeAt(b));)b++;if(b<r&&b!==l){const L=s.slice(l,b);for(l=b;b<r&&a(s.charCodeAt(b));)b++;if(b<r&&b!==l){for(l=b;b<r&&!a(s.charCodeAt(b));)b++;(b===r||b!==l)&&(g=`\\\\${L}\\${s.slice(l,b)}`,o=b)}}}else o=1;else E(S)&&s.charCodeAt(1)===i&&(g=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(m=!0,o=3));if(g.length>0)if(c.length>0){if(g.toLowerCase()!==c.toLowerCase())continue}else c=g;if(t){if(c.length>0)break}else if(h=`${s.slice(o)}\\${h}`,t=m,m&&c.length>0)break}return h=w(h,!t,"\\",a),t?`${c}\\${h}`:`${c}${h}`||"."},normalize(u){p(u,"path");const c=u.length;if(c===0)return".";let h=0,t,n=!1;const s=u.charCodeAt(0);if(c===1)return f(s)?"\\":u;if(a(s))if(n=!0,a(u.charCodeAt(1))){let o=2,g=o;for(;o<c&&!a(u.charCodeAt(o));)o++;if(o<c&&o!==g){const m=u.slice(g,o);for(g=o;o<c&&a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&!a(u.charCodeAt(o));)o++;if(o===c)return`\\\\${m}\\${u.slice(g)}\\`;o!==g&&(t=`\\\\${m}\\${u.slice(g,o)}`,h=o)}}}else h=1;else E(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),h=2,c>2&&a(u.charCodeAt(2))&&(n=!0,h=3));let r=h<c?w(u.slice(h),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(u.charCodeAt(c-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){p(u,"path");const c=u.length;if(c===0)return!1;const h=u.charCodeAt(0);return a(h)||c>2&&E(h)&&u.charCodeAt(1)===i&&a(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,h;for(let s=0;s<u.length;++s){const r=u[s];p(r,"path"),r.length>0&&(c===void 0?c=h=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof h=="string"&&a(h.charCodeAt(0))){++n;const s=h.length;s>1&&a(h.charCodeAt(1))&&(++n,s>2&&(a(h.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&a(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c)return"";const h=e.win32.resolve(u),t=e.win32.resolve(c);if(h===t||(u=h.toLowerCase(),c=t.toLowerCase(),u===c))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===P;)n++;let s=u.length;for(;s-1>n&&u.charCodeAt(s-1)===P;)s--;const r=s-n;let o=0;for(;o<c.length&&c.charCodeAt(o)===P;)o++;let g=c.length;for(;g-1>o&&c.charCodeAt(g-1)===P;)g--;const m=g-o,S=r<m?r:m;let b=-1,l=0;for(;l<S;l++){const O=u.charCodeAt(n+l);if(O!==c.charCodeAt(o+l))break;O===P&&(b=l)}if(l!==S){if(b===-1)return t}else{if(m>S){if(c.charCodeAt(o+l)===P)return t.slice(o+l+1);if(l===2)return t.slice(o+l)}r>S&&(u.charCodeAt(n+l)===P?b=l:l===2&&(b=3)),b===-1&&(b=0)}let L="";for(l=n+b+1;l<=s;++l)(l===s||u.charCodeAt(l)===P)&&(L+=L.length===0?"..":"\\..");return o+=b,L.length>0?`${L}${t.slice(o,g)}`:(t.charCodeAt(o)===P&&++o,t.slice(o,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===P){if(c.charCodeAt(1)===P){const h=c.charCodeAt(2);if(h!==A&&h!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===P)return`\\\\?\\${c}`;return u},dirname(u){p(u,"path");const c=u.length;if(c===0)return".";let h=-1,t=0;const n=u.charCodeAt(0);if(c===1)return a(n)?u:".";if(a(n)){if(h=t=1,a(u.charCodeAt(1))){let o=2,g=o;for(;o<c&&!a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&a(u.charCodeAt(o));)o++;if(o<c&&o!==g){for(g=o;o<c&&!a(u.charCodeAt(o));)o++;if(o===c)return u;o!==g&&(h=t=o+1)}}}}else E(n)&&u.charCodeAt(1)===i&&(h=c>2&&a(u.charCodeAt(2))?3:2,t=h);let s=-1,r=!0;for(let o=c-1;o>=t;--o)if(a(u.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(h===-1)return".";s=h}return u.slice(0,s)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let h=0,t=-1,n=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(h=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,o=-1;for(s=u.length-1;s>=h;--s){const g=u.charCodeAt(s);if(a(g)){if(!n){h=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return h===t?t=o:t===-1&&(t=u.length),u.slice(h,t)}for(s=u.length-1;s>=h;--s)if(a(u.charCodeAt(s))){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(h,t)},extname(u){p(u,"path");let c=0,h=-1,t=0,n=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&E(u.charCodeAt(0))&&(c=t=2);for(let o=u.length-1;o>=c;--o){const g=u.charCodeAt(o);if(a(g)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),g===I?h===-1?h=o:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||n===-1||r===0||r===1&&h===n-1&&h===t+1?"":u.slice(h,n)},format:_.bind(null,"\\"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const h=u.length;let t=0,n=u.charCodeAt(0);if(h===1)return a(n)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(a(n)){if(t=1,a(u.charCodeAt(1))){let b=2,l=b;for(;b<h&&!a(u.charCodeAt(b));)b++;if(b<h&&b!==l){for(l=b;b<h&&a(u.charCodeAt(b));)b++;if(b<h&&b!==l){for(l=b;b<h&&!a(u.charCodeAt(b));)b++;b===h?t=b:b!==l&&(t=b+1)}}}}else if(E(n)&&u.charCodeAt(1)===i){if(h<=2)return c.root=c.dir=u,c;if(t=2,a(u.charCodeAt(2))){if(h===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,r=t,o=-1,g=!0,m=u.length-1,S=0;for(;m>=t;--m){if(n=u.charCodeAt(m),a(n)){if(!g){r=m+1;break}continue}o===-1&&(g=!1,o=m+1),n===I?s===-1?s=m:S!==1&&(S=1):s!==-1&&(S=-1)}return o!==-1&&(s===-1||S===0||S===1&&s===o-1&&s===r+1?c.base=c.name=u.slice(r,o):(c.name=u.slice(r,s),c.base=u.slice(r,o),c.ext=u.slice(s,o))),r>0&&r!==t?c.dir=u.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",h=!1;for(let t=u.length-1;t>=-1&&!h;t--){const n=t>=0?u[t]:v.cwd();p(n,"path"),n.length!==0&&(c=`${n}/${c}`,h=n.charCodeAt(0)===D)}return c=w(c,!h,"/",f),h?`/${c}`:c.length>0?c:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D,h=u.charCodeAt(u.length-1)===D;return u=w(u,!c,"/",f),u.length===0?c?"/":h?"./":".":(h&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let c;for(let h=0;h<u.length;++h){const t=u[h];p(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const h=1,t=u.length,n=t-h,s=1,r=c.length-s,o=n<r?n:r;let g=-1,m=0;for(;m<o;m++){const b=u.charCodeAt(h+m);if(b!==c.charCodeAt(s+m))break;b===D&&(g=m)}if(m===o)if(r>o){if(c.charCodeAt(s+m)===D)return c.slice(s+m+1);if(m===0)return c.slice(s+m)}else n>o&&(u.charCodeAt(h+m)===D?g=m:m===0&&(g=0));let S="";for(m=h+g+1;m<=t;++m)(m===t||u.charCodeAt(m)===D)&&(S+=S.length===0?"..":"/..");return`${S}${c.slice(s+g)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D;let h=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){h=n;break}}else t=!1;return h===-1?c?"/":".":c&&h===1?"//":u.slice(0,h)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let h=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,o=-1;for(s=u.length-1;s>=0;--s){const g=u.charCodeAt(s);if(g===D){if(!n){h=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return h===t?t=o:t===-1&&(t=u.length),u.slice(h,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===D){if(!n){h=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(h,t)},extname(u){p(u,"path");let c=-1,h=0,t=-1,n=!0,s=0;for(let r=u.length-1;r>=0;--r){const o=u.charCodeAt(r);if(o===D){if(!n){h=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===I?c===-1?c=r:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===h+1?"":u.slice(c,t)},format:_.bind(null,"/"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const h=u.charCodeAt(0)===D;let t;h?(c.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,g=u.length-1,m=0;for(;g>=t;--g){const S=u.charCodeAt(g);if(S===D){if(!o){s=g+1;break}continue}r===-1&&(o=!1,r=g+1),S===I?n===-1?n=g:m!==1&&(m=1):n!==-1&&(m=-1)}if(r!==-1){const S=s===0&&h?1:s;n===-1||m===0||m===1&&n===r-1&&n===s+1?c.base=c.name=u.slice(S,r):(c.name=u.slice(S,n),c.base=u.slice(S,r),c.ext=u.slice(n,r))}return s>0?c.dir=u.slice(0,s-1):h&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[136],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(T,...y){const I=y.reduce((i,A)=>(i[A]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(i=>!I[i]).forEach(i=>{for(let A=0;A<D.length;A++)if(i.search(D[A])!==-1){delete T[i];break}})}e.sanitizeProcessEnvironment=C}),define(me[44],ge([0,1,11]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class C{constructor(y){this._highResolution=R&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new C(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=C}),define(me[3],ge([0,1,17,72,6,56,44]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(w){w.None=()=>C.Disposable.None;function _(N){return(V,x=null,k)=>{let U=!1,F;return F=N(M=>{if(!U)return F?F.dispose():U=!0,V.call(x,M)},null,k),U&&F.dispose(),F}}w.once=_;function u(N,V){return r((x,k=null,U)=>N(F=>x.call(k,V(F)),null,U))}w.map=u;function c(N,V){return r((x,k=null,U)=>N(F=>{V(F),x.call(k,F)},null,U))}w.forEach=c;function h(N,V){return r((x,k=null,U)=>N(F=>V(F)&&x.call(k,F),null,U))}w.filter=h;function t(N){return N}w.signal=t;function n(...N){return(V,x=null,k)=>(0,C.combinedDisposable)(...N.map(U=>U(F=>V.call(x,F),null,k)))}w.any=n;function s(N,V,x){let k=x;return u(N,U=>(k=V(k,U),k))}w.reduce=s;function r(N){let V;const x=new d({onFirstListenerAdd(){V=N(x.fire,x)},onLastListenerRemove(){V.dispose()}});return x.event}w.snapshot=r;function o(N,V,x=100,k=!1,U){let F,M,$,H=0;const Q=new d({leakWarningThreshold:U,onFirstListenerAdd(){F=N(ae=>{H++,M=V(M,ae),k&&!$&&(Q.fire(M),M=void 0),clearTimeout($),$=setTimeout(()=>{const we=M;M=void 0,$=void 0,(!k||H>1)&&Q.fire(we),H=0},x)})},onLastListenerRemove(){F.dispose()}});return Q.event}w.debounce=o;function g(N){const V=new Date().getTime();return u(_(N),x=>new Date().getTime()-V)}w.stopwatch=g;function m(N,V=(x,k)=>x===k){let x=!0,k;return h(N,U=>{const F=x||!V(U,k);return x=!1,k=U,F})}w.latch=m;function S(N,V){return[w.filter(N,V),w.filter(N,x=>!V(x))]}w.split=S;function b(N,V=!1,x=[]){let k=x.slice(),U=N($=>{k?k.push($):M.fire($)});const F=()=>{k&&k.forEach($=>M.fire($)),k=null},M=new d({onFirstListenerAdd(){U||(U=N($=>M.fire($)))},onFirstListenerDidAdd(){k&&(V?setTimeout(F):F())},onLastListenerRemove(){U&&U.dispose(),U=null}});return M.event}w.buffer=b;class l{constructor(V){this.event=V}map(V){return new l(u(this.event,V))}forEach(V){return new l(c(this.event,V))}filter(V){return new l(h(this.event,V))}reduce(V,x){return new l(s(this.event,V,x))}latch(){return new l(m(this.event))}debounce(V,x=100,k=!1,U){return new l(o(this.event,V,x,k,U))}on(V,x,k){return this.event(V,x,k)}once(V,x,k){return _(this.event)(V,x,k)}}function L(N){return new l(N)}w.chain=L;function O(N,V,x=k=>k){const k=(...$)=>M.fire(x(...$)),U=()=>N.on(V,k),F=()=>N.removeListener(V,k),M=new d({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function W(N,V,x=k=>k){const k=(...$)=>M.fire(x(...$)),U=()=>N.addEventListener(V,k),F=()=>N.removeEventListener(V,k),M=new d({onFirstListenerAdd:U,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=W;function ie(N){const V=new d;let x=!1;return N.then(void 0,()=>null).then(()=>{x?V.fire(void 0):setTimeout(()=>V.fire(void 0),0)}),x=!0,V.event}w.fromPromise=ie;function re(N){return new Promise(V=>_(N)(V))}w.toPromise=re})(I=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new y.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function i(w){const _=P;return P=w,{dispose(){P=_}}}e.setGlobalLeakWarningThreshold=i;class A{constructor(_,u=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let u=P;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||_<u)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(c)||0;if(this._stacks.set(c,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class d{constructor(_){var u;this._disposed=!1,this._options=_,this._leakageMon=P>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,u,c)=>{var h;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[_,u]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,u);const s=(h=this._leakageMon)===null||h===void 0?void 0:h.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof C.DisposableStore?c.add(r):Array.isArray(c)&&c.push(r),r}),this._event}fire(_){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,_]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,t]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,t):h[0].call(h[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var _,u,c,h,t;this._disposed||(this._disposed=!0,(_=this._listeners)===null||_===void 0||_.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(h=(c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)===null||h===void 0||h.call(c),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class p extends d{constructor(_){super(_);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=p;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const u={event:_,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const h=this.events.indexOf(u);this.events.splice(h,1)};return(0,C.toDisposable)((0,R.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(u=>this.emitter.fire(u))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class f{constructor(){this.buffers=[]}wrapEvent(_){return(u,c,h)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(c,t)):u.call(c,t)},void 0,h)}bufferEvents(_){const u=[];this.buffers.push(u);const c=_();return this.buffers.pop(),u.forEach(h=>h()),c}}e.EventBufferer=f;class E{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,D){const P=setTimeout(I.bind(D),0);return{dispose(){clearTimeout(P)}}});var C;(function(I){function D(P){return P===I.None||P===I.Cancelled||P instanceof T?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=D,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(me[45],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(A){const d=this._icons.get(A.id);d?A.description?d.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function T(i,A){return new I(i,A)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(A,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class I{constructor(A,d,p){this.id=A,this.definition=d,this.description=p,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(i,A){const d=["codicon","codicon-"+i];return A&&d.push("codicon-modifier-"+A),d}e.getClassNamesArray=D;var P;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(f){if(f instanceof I)return["codicon","codicon-"+f.id];const E=A.exec(f.id);if(!E)return d(I.error);let[,w,_]=E;const u=["codicon","codicon-"+w];return _&&u.push("codicon-modifier-"+_.substr(1)),u}i.asClassNameArray=d;function p(f){return d(f).join(" ")}i.asClassName=p;function a(f){return"."+d(f).join(".")}i.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(me[93],ge([0,1,17,6]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}e.isReadableStream=C;function T(u){const c=u;return c?C(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(u,c){return new I(u,c)}e.newWriteableStream=y;class I{constructor(c,h){this.reducer=c,this.options=h,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var h;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((h=this.options)===null||h===void 0?void 0:h.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(h=>h(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(h=>h(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,h){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(h),this.resume();break;case"end":this.listeners.end.push(h),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(h),this.state.flowing&&this.flowErrors();break}}removeListener(c,h){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(h);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const h=[...this.pendingWritePromises];this.pendingWritePromises.length=0,h.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,c){const h=[];let t;for(;(t=u.read())!==null;)h.push(t);return c(h)}e.consumeReadable=D;function P(u,c,h){const t=[];let n;for(;(n=u.read())!==null&&t.length<h;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return u.read()}}}e.peekReadable=P;function i(u,c){return new Promise((h,t)=>{const n=[];A(u,{onData:s=>{c&&n.push(s)},onError:s=>{c?t(s):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}e.consumeStream=i;function A(u,c){u.on("error",h=>c.onError(h)),u.on("end",()=>c.onEnd()),u.on("data",h=>c.onData(h))}e.listenStream=A;function d(u,c){return new Promise((h,t)=>{const n=new R.DisposableStore,s=[],r=m=>{if(s.push(m),s.length>c)return n.dispose(),u.pause(),h({stream:u,buffer:s,ended:!1})},o=m=>t(m),g=()=>h({stream:u,buffer:s,ended:!0});n.add((0,R.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),n.add((0,R.toDisposable)(()=>u.removeListener("end",g))),u.on("end",g),n.add((0,R.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=d;function p(u,c){const h=y(c);return h.end(u),h}e.toStream=p;function a(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=a;function f(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=f;function E(u,c,h){const t=y(h);return A(u,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(u,c,h){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?h([u,n]):u)}}}e.prefixedReadable=w;function _(u,c,h){let t=!1;const n=y(h);return A(c,{onData:s=>t?n.write(s):(t=!0,n.write(h([u,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=_}),define(me[8],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function C(z,...J){return J.length===0?z:z.replace(R,function(le,Pe){const Ae=parseInt(Pe,10);return isNaN(Ae)||Ae<0||Ae>=J.length?le:J[Ae]})}e.format=C;function T(z){return z.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=T;function y(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function I(z,J){let le=0;const Pe=J.charCodeAt(0);for(let Ae=z.length-1;Ae>=0;Ae--)z.charCodeAt(Ae)===Pe&&le++;return le}e.count=I;function D(z,J,le="\u2026"){return z.length<=J?z:`${z.substr(0,J)}${le}`}e.truncate=D;function P(z,J=" "){const le=i(z,J);return A(le,J)}e.trim=P;function i(z,J){if(!z||!J)return z;const le=J.length;if(le===0||z.length===0)return z;let Pe=0;for(;z.indexOf(J,Pe)===Pe;)Pe=Pe+le;return z.substring(Pe)}e.ltrim=i;function A(z,J){if(!z||!J)return z;const le=J.length,Pe=z.length;if(le===0||Pe===0)return z;let Ae=Pe,Ue=-1;for(;Ue=z.lastIndexOf(J,Ae-1),!(Ue===-1||Ue+le!==Ae);){if(Ue===0)return"";Ae=Ue}return z.substring(0,Ae)}e.rtrim=A;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function p(z){return z.replace(/\*/g,"")}e.stripWildcards=p;function a(z,J,le={}){if(!z)throw new Error("Cannot create regex from empty string");J||(z=y(z)),le.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Pe="";return le.global&&(Pe+="g"),le.matchCase||(Pe+="i"),le.multiline&&(Pe+="m"),le.unicode&&(Pe+="u"),new RegExp(z,Pe)}e.createRegExp=a;function f(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function E(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=w;function _(z){return z.split(/\r\n|\r|\n/)}e.splitLines=_;function u(z){for(let J=0,le=z.length;J<le;J++){const Pe=z.charCodeAt(J);if(Pe!==32&&Pe!==9)return J}return-1}e.firstNonWhitespaceIndex=u;function c(z,J=0,le=z.length){for(let Pe=J;Pe<le;Pe++){const Ae=z.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return z.substring(J,Pe)}return z.substring(J,le)}e.getLeadingWhitespace=c;function h(z,J=z.length-1){for(let le=J;le>=0;le--){const Pe=z.charCodeAt(le);if(Pe!==32&&Pe!==9)return le}return-1}e.lastNonWhitespaceIndex=h;function t(z,J){return z<J?-1:z>J?1:0}e.compare=t;function n(z,J,le=0,Pe=z.length,Ae=0,Ue=J.length){for(;le<Pe&&Ae<Ue;le++,Ae++){let rt=z.charCodeAt(le),et=J.charCodeAt(Ae);if(rt<et)return-1;if(rt>et)return 1}const Be=Pe-le,Qe=Ue-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstring=n;function s(z,J){return r(z,J,0,z.length,0,J.length)}e.compareIgnoreCase=s;function r(z,J,le=0,Pe=z.length,Ae=0,Ue=J.length){for(;le<Pe&&Ae<Ue;le++,Ae++){let rt=z.charCodeAt(le),et=J.charCodeAt(Ae);if(rt===et)continue;const Ye=rt-et;if(!(Ye===32&&g(et))&&!(Ye===-32&&g(rt)))return o(rt)&&o(et)?Ye:n(z.toLowerCase(),J.toLowerCase(),le,Pe,Ae,Ue)}const Be=Pe-le,Qe=Ue-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstringIgnoreCase=r;function o(z){return z>=97&&z<=122}e.isLowerAsciiLetter=o;function g(z){return z>=65&&z<=90}e.isUpperAsciiLetter=g;function m(z){return o(z)||g(z)}function S(z,J){return z.length===J.length&&b(z,J)}e.equalsIgnoreCase=S;function b(z,J,le=z.length){for(let Pe=0;Pe<le;Pe++){const Ae=z.charCodeAt(Pe),Ue=J.charCodeAt(Pe);if(Ae!==Ue){if(m(Ae)&&m(Ue)){const Be=Math.abs(Ae-Ue);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function l(z,J){const le=J.length;return J.length>z.length?!1:b(z,J,le)}e.startsWithIgnoreCase=l;function L(z,J){let le,Pe=Math.min(z.length,J.length);for(le=0;le<Pe;le++)if(z.charCodeAt(le)!==J.charCodeAt(le))return le;return Pe}e.commonPrefixLength=L;function O(z,J){let le,Pe=Math.min(z.length,J.length);const Ae=z.length-1,Ue=J.length-1;for(le=0;le<Pe;le++)if(z.charCodeAt(Ae-le)!==J.charCodeAt(Ue-le))return le;return Pe}e.commonSuffixLength=O;function W(z){return 55296<=z&&z<=56319}e.isHighSurrogate=W;function ie(z){return 56320<=z&&z<=57343}e.isLowSurrogate=ie;function re(z,J){return(z-55296<<10)+(J-56320)+65536}e.computeCodePoint=re;function N(z,J,le){const Pe=z.charCodeAt(le);if(W(Pe)&&le+1<J){const Ae=z.charCodeAt(le+1);if(ie(Ae))return re(Pe,Ae)}return Pe}e.getNextCodePoint=N;function V(z,J){const le=z.charCodeAt(J-1);if(ie(le)&&J>1){const Pe=z.charCodeAt(J-2);if(W(Pe))return re(Pe,le)}return le}function x(z,J){const le=ze.getInstance(),Pe=J,Ae=z.length,Ue=N(z,Ae,J);J+=Ue>=65536?2:1;let Be=le.getGraphemeBreakType(Ue);for(;J<Ae;){const Qe=N(z,Ae,J),rt=le.getGraphemeBreakType(Qe);if(xe(Be,rt))break;J+=Qe>=65536?2:1,Be=rt}return J-Pe}e.nextCharLength=x;function k(z,J){const le=ze.getInstance(),Pe=J,Ae=V(z,J);J-=Ae>=65536?2:1;let Ue=le.getGraphemeBreakType(Ae);for(;J>0;){const Be=V(z,J),Qe=le.getGraphemeBreakType(Be);if(xe(Qe,Ue))break;J-=Be>=65536?2:1,Ue=Qe}return Pe-J}e.prevCharLength=k;function U(z,J){const le=ze.getInstance(),Pe=z.length,Ae=J,Ue=N(z,Pe,J),Be=le.getGraphemeBreakType(Ue);J+=Ue>=65536?2:1;let Qe=Be;for(;J<Pe;){const et=N(z,Pe,J),Ye=le.getGraphemeBreakType(et);if(xe(Qe,Ye))break;J+=et>=65536?2:1,Qe=Ye}const rt=J;for(J=Ae,Qe=Be;J>0;){const et=V(z,J),Ye=le.getGraphemeBreakType(et);if(xe(Ye,Qe))break;J-=et>=65536?2:1,Qe=Ye}return[J,rt]}function F(z,J){return J>0&&ie(z.charCodeAt(J))?U(z,J-1):U(z,J)}e.getCharContainingOffset=F;function M(z){const J=z.length;let le=0,Pe=0;for(;Pe<J;){const Be=N(z,J,Pe);Pe+=Be>=65536?2:1,Be<128?le+=1:Be<2048?le+=2:Be<65536?le+=3:le+=4}const Ae=new Uint8Array(le);Pe=0;let Ue=0;for(;Pe<J;){const Be=N(z,J,Pe);Pe+=Be>=65536?2:1,Be<128?Ae[Ue++]=Be:Be<2048?(Ae[Ue++]=192|(Be&1984)>>>6,Ae[Ue++]=128|(Be&63)>>>0):Be<65536?(Ae[Ue++]=224|(Be&61440)>>>12,Ae[Ue++]=128|(Be&4032)>>>6,Ae[Ue++]=128|(Be&63)>>>0):(Ae[Ue++]=240|(Be&1835008)>>>18,Ae[Ue++]=128|(Be&258048)>>>12,Ae[Ue++]=128|(Be&4032)>>>6,Ae[Ue++]=128|(Be&63)>>>0)}return Ae}e.encodeUTF8=M;function $(z){const J=z.byteLength,le=[];let Pe=0;for(;Pe<J;){const Ae=z[Pe];let Ue;if(Ae>=240&&Pe+3<J?Ue=(z[Pe++]&7)<<18>>>0|(z[Pe++]&63)<<12>>>0|(z[Pe++]&63)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ae>=224&&Pe+2<J?Ue=(z[Pe++]&15)<<12>>>0|(z[Pe++]&63)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ae>=192&&Pe+1<J?Ue=(z[Pe++]&31)<<6>>>0|(z[Pe++]&63)<<0>>>0:Ue=z[Pe++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)le.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const Be=Ue-65536,Qe=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);le.push(String.fromCharCode(Qe)),le.push(String.fromCharCode(rt))}else le.push(String.fromCharCode(65533))}return le.join("")}e.decodeUTF8=$;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(z){return H.test(z)}e.containsRTL=Q;const ae=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(z){return ae.test(z)}e.containsEmoji=we;const Le=/^[\t\n\r\x20-\x7E]*$/;function Ie(z){return Le.test(z)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Oe;function We(z){for(let J=0,le=z.length;J<le;J++)if(j(z.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=We;function j(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=j;function X(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=X;function ee(z,J){if(z.length<J)return z;const le=/\b/g;let Pe=0;for(;le.test(z)&&!(z.length-le.lastIndex<J);)Pe=le.lastIndex,le.lastIndex+=1;return z.substring(Pe).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function ce(z){return z&&(z=z.replace(oe,""),z=z.replace(pe,""),z=z.replace(Se,"")),z}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Re(z){return _e(z)?z.substr(1):z}e.stripUTF8BOM=Re;function Ve(z,J){if(!z||!J||z.length<J.length)return!1;const le=J.length,Pe=z.toLowerCase();let Ae=0,Ue=-1;for(;Ae<le;){const Be=Pe.indexOf(J[Ae],Ue+1);if(Be<0)return!1;Ue=Be,Ae++}return!0}e.fuzzyContains=Ve;function be(z,J=!1){return z?(J&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=be;function Ge(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ge;function G(z,J=1){if(J===0)return"";let le=-1;do le=z.indexOf(`
`,le+1),J--;while(J>0&&le>=0);return le===-1?z:(z[le-1]==="\r"&&le--,z.substr(0,le))}e.getNLines=G;function ne(z){const J=90-65+1;return z=z%(2*J),z<J?String.fromCharCode(97+z):String.fromCharCode(65+z-J)}e.singleLetterHash=ne;function ve(z){return ze.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ve;function xe(z,J){return z===0?J!==5&&J!==7:z===2&&J===3?!1:z===4||z===2||z===3||J===4||J===2||J===3?!0:!(z===8&&(J===8||J===9||J===11||J===12)||(z===11||z===9)&&(J===9||J===10)||(z===12||z===10)&&J===10||J===5||J===13||J===7||z===1||z===13&&J===14||z===6&&J===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Xe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const le=this._data,Pe=le.length/3;let Ae=1;for(;Ae<=Pe;)if(J<le[3*Ae])Ae=2*Ae;else if(J>le[3*Ae+1])Ae=2*Ae+1;else return le[3*Ae+2];return 0}}ze._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ce(z,J){if(z===0)return 0;const le=De(z,J);if(le!==void 0)return le;const Pe=V(J,z);return z-=ke(Pe),z}e.getLeftDeleteOffset=Ce;function De(z,J){let le=V(J,z);for(z-=ke(le);se(le)||le===65039||le===8419;){if(z===0)return;le=V(J,z),z-=ke(le)}if(!!X(le)){if(z>=0){const Pe=V(J,z);Pe===8205&&(z-=ke(Pe))}return z}}function ke(z){return z>=65536?2:1}function se(z){return 127995<=z&&z<=127999}var de;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(me[23],ge([0,1,8,93]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let I,D;class P{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new P(Buffer.allocUnsafe(m)):new P(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new P(m)}static fromString(m,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&C?new P(Buffer.from(m)):T?(I||(I=new TextEncoder),new P(I.encode(m))):new P(v.encodeUTF8(m))}static concat(m,S){if(typeof S=="undefined"){S=0;for(let L=0,O=m.length;L<O;L++)S+=m[L].byteLength}const b=P.alloc(S);let l=0;for(let L=0,O=m.length;L<O;L++){const W=m[L];b.set(W,l),l+=W.byteLength}return b}toString(){return C?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(m,S){return new P(this.buffer.subarray(m,S))}set(m,S){m instanceof P?this.buffer.set(m.buffer,S):this.buffer.set(m,S)}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,S){p(this.buffer,m,S)}readUInt32LE(m){return a(this.buffer,m)}writeUInt32LE(m,S){f(this.buffer,m,S)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,S){w(this.buffer,m,S)}}e.VSBuffer=P;function i(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0}e.readUInt16LE=i;function A(g,m,S){g[S+0]=m&255,m=m>>>8,g[S+1]=m&255}e.writeUInt16LE=A;function d(g,m){return g[m]*2**24+g[m+1]*2**16+g[m+2]*2**8+g[m+3]}e.readUInt32BE=d;function p(g,m,S){g[S+3]=m,m=m>>>8,g[S+2]=m,m=m>>>8,g[S+1]=m,m=m>>>8,g[S]=m}e.writeUInt32BE=p;function a(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0|g[m+2]<<16>>>0|g[m+3]<<24>>>0}e.readUInt32LE=a;function f(g,m,S){g[S+0]=m&255,m=m>>>8,g[S+1]=m&255,m=m>>>8,g[S+2]=m&255,m=m>>>8,g[S+3]=m&255}e.writeUInt32LE=f;function E(g,m){return g[m]}e.readUInt8=E;function w(g,m,S){g[S]=m}e.writeUInt8=w;function _(g){return R.consumeReadable(g,m=>P.concat(m))}e.readableToBuffer=_;function u(g){return R.toReadable(g)}e.bufferToReadable=u;function c(g){return R.consumeStream(g,m=>P.concat(m))}e.streamToBuffer=c;async function h(g){return g.ended?P.concat(g.buffer):P.concat([...g.buffer,await c(g.stream)])}e.bufferedStreamToBuffer=h;function t(g){return R.toStream(g,m=>P.concat(m))}e.bufferToStream=t;function n(g){return R.transform(g,{data:m=>typeof m=="string"?P.fromString(m):P.wrap(m)},m=>P.concat(m))}e.streamToBufferReadableStream=n;function s(g){return R.newWriteableStream(m=>P.concat(m),g)}e.newWriteableBufferStream=s;function r(g,m){return R.prefixedReadable(g,m,S=>P.concat(S))}e.prefixedBufferReadable=r;function o(g,m){return R.prefixedStream(g,m,S=>P.concat(S))}e.prefixedBufferStream=o}),define(me[75],ge([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return C(w,0)}e.hash=R;function C(w,_){switch(typeof w){case"object":return w===null?T(349,_):Array.isArray(w)?D(w,_):P(w,_);case"string":return I(w,_);case"boolean":return y(w,_);case"number":return T(w,_);case"undefined":return T(937,_);default:return T(617,_)}}e.doHash=C;function T(w,_){return(_<<5)-_+w|0}function y(w,_){return T(w?433:863,_)}function I(w,_){_=T(149417,_);for(let u=0,c=w.length;u<c;u++)_=T(w.charCodeAt(u),_);return _}e.stringHash=I;function D(w,_){return _=T(104579,_),w.reduce((u,c)=>C(c,u),_)}function P(w,_){return _=T(181387,_),Object.keys(w).sort().reduce((u,c)=>(u=I(c,u),C(w[c],u)),_)}class i{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=C(_,this._value),this._value}}e.Hasher=i;var A;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function d(w,_,u=32){const c=u-_,h=~((1<<c)-1);return(w<<_|(h&w)>>>c)>>>0}function p(w,_=0,u=w.byteLength,c=0){for(let h=0;h<u;h++)w[_+h]=c}function a(w,_,u="0"){for(;w.length<_;)w=u+w;return w}function f(w,_=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),_/4)}e.toHexString=f;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const u=_.length;if(u===0)return;const c=this._buff;let h=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=_.charCodeAt(0),s=0);;){let r=n;if(v.isHighSurrogate(n))if(s+1<u){const o=_.charCodeAt(s+1);v.isLowSurrogate(o)?(s++,r=v.computeCodePoint(n,o)):r=65533}else{t=n;break}else v.isLowSurrogate(n)&&(r=65533);if(h=this._push(c,h,r),s++,s<u)n=_.charCodeAt(s);else break}this._buffLen=h,this._leftoverHighSurrogate=t}_push(_,u,c){return c<128?_[u++]=c:c<2048?(_[u++]=192|(c&1984)>>>6,_[u++]=128|(c&63)>>>0):c<65536?(_[u++]=224|(c&61440)>>>12,_[u++]=128|(c&4032)>>>6,_[u++]=128|(c&63)>>>0):(_[u++]=240|(c&1835008)>>>18,_[u++]=128|(c&258048)>>>12,_[u++]=128|(c&4032)>>>6,_[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=E._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)_.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)_.setUint32(m,d(_.getUint32(m-12,!1)^_.getUint32(m-32,!1)^_.getUint32(m-56,!1)^_.getUint32(m-64,!1),1),!1);let c=this._h0,h=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,g;for(let m=0;m<80;m++)m<20?(r=h&t|~h&n,o=1518500249):m<40?(r=h^t^n,o=1859775393):m<60?(r=h&t|h&n|t&n,o=2400959708):(r=h^t^n,o=3395469782),g=d(c,5)+r+s+o+_.getUint32(m*4,!1)&4294967295,s=n,n=t,t=d(h,30),h=c,c=g;this._h0=this._h0+c&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[57],ge([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const T="error",y="warning",I="warn",D="info",P="ignore";function i(d){return d?v.equalsIgnoreCase(T,d)?C.Error:v.equalsIgnoreCase(y,d)||v.equalsIgnoreCase(I,d)?C.Warning:v.equalsIgnoreCase(D,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function A(d){switch(d){case C.Error:return T;case C.Warning:return y;case C.Info:return D;default:return P}}C.toString=A}(R||(R={})),e.default=R}),define(me[12],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(m){return Array.isArray(m)}e.isArray=v;function R(m){return typeof m=="string"}e.isString=R;function C(m){return Array.isArray(m)&&m.every(S=>R(S))}e.isStringArray=C;function T(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=T;function y(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=y;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function D(m){return m===!0||m===!1}e.isBoolean=D;function P(m){return typeof m=="undefined"}e.isUndefined=P;function i(m){return!A(m)}e.isDefined=i;function A(m){return P(m)||m===null}e.isUndefinedOrNull=A;function d(m,S){if(!m)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=d;function p(m){if(A(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function a(...m){const S=[];for(let b=0;b<m.length;b++){const l=m[b];if(A(l))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);S.push(l)}return S}e.assertAllDefined=a;const f=Object.prototype.hasOwnProperty;function E(m){if(!T(m))return!1;for(let S in m)if(f.call(m,S))return!1;return!0}e.isEmptyObject=E;function w(m){return typeof m=="function"}e.isFunction=w;function _(...m){return m.length>0&&m.every(w)}e.areFunctions=_;function u(m,S){const b=Math.min(m.length,S.length);for(let l=0;l<b;l++)c(m[l],S[l])}e.validateConstraints=u;function c(m,S){if(R(S)){if(typeof m!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(w(S)){try{if(m instanceof S)return}catch(b){}if(!A(m)&&m.constructor===S||S.length===1&&S.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function h(m){let S=[],b=Object.getPrototypeOf(m);for(;Object.prototype!==b;)S=S.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return S}e.getAllPropertyNames=h;function t(m){const S=[];for(const b of h(m))typeof m[b]=="function"&&S.push(b);return S}e.getAllMethodNames=t;function n(m,S){const b=L=>function(){const O=Array.prototype.slice.call(arguments,0);return S(L,O)};let l={};for(const L of m)l[L]=b(L);return l}e.createProxyObject=n;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function r(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=r;function o(m){return class{constructor(){return new Proxy({},{get(S,b){if(S[b])return S[b];throw new Error(`Not Implemented: ${m}->${String(b)}`)}})}}}e.NotImplementedProxy=o;function g(m){throw new Error("Unreachable")}e.assertNever=g}),define(me[29],ge([0,1,11,8,9,12]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function I(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function D(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function P(s,r=C.posix.sep){if(!s)return"";const o=s.length,g=s.charCodeAt(0);if(y(g)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let S=3;const b=S;for(;S<o&&!y(s.charCodeAt(S));S++);if(b!==S&&!y(s.charCodeAt(S+1))){for(S+=1;S<o;S++)if(y(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,r)}}return r}else if(w(g)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(y(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=P;function i(s){if(!v.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let o=2;const g=o;for(;o<s.length&&(r=s.charCodeAt(o),r!==92);o++);return!(g===o||(r=s.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=i;const A=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(s,r=v.isWindows){const o=r?A:d;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=a;function f(s,r,o){const g=s===r;return!o||g?g:!s||!r?!1:(0,R.equalsIgnoreCase)(s,r)}e.isEqual=f;function E(s,r,o,g=C.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let S=r.length;return r.charAt(r.length-1)===g&&S--,s.charAt(S)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=E;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function _(s,r){return v.isWindows&&s.endsWith(":")&&(s+=C.sep),(0,C.isAbsolute)(s)||(s=(0,C.join)(r,s)),s=(0,C.normalize)(s),v.isWindows?(s=(0,R.rtrim)(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=(0,R.rtrim)(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=_;function u(s){const r=(0,C.normalize)(s);return v.isWindows?s.length>3?!1:c(r)&&(s.length===2||r.charCodeAt(2)===92):r===C.posix.sep}e.isRootOrDriveLetter=u;function c(s){return v.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function h(s){return c(s)?s[0]:void 0}e.getDriveLetter=h;function t(s,r,o){return r.length>s.length?-1:s===r?0:(o&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function n(s){const r=s.split(":");let o,g,m;if(r.forEach(S=>{const b=Number(S);(0,T.isNumber)(b)?g===void 0?g=b:m===void 0&&(m=b):o=o?[o,S].join(":"):S}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:m!==void 0?m:g!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(me[24],ge([0,1,12]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const E=Array.isArray(f)?[]:{};return Object.keys(f).forEach(w=>{f[w]&&typeof f[w]=="object"?E[w]=R(f[w]):E[w]=f[w]}),E}e.deepClone=R;function C(f){if(!f||typeof f!="object")return f;const E=[f];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const _ in w)if(T.call(w,_)){const u=w[_];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return f}e.deepFreeze=C;const T=Object.prototype.hasOwnProperty;function y(f,E){return I(f,E,new Set)}e.cloneAndChange=y;function I(f,E,w){if((0,v.isUndefinedOrNull)(f))return f;const _=E(f);if(typeof _!="undefined")return _;if((0,v.isArray)(f)){const u=[];for(const c of f)u.push(I(c,E,w));return u}if((0,v.isObject)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const u={};for(let c in f)T.call(f,c)&&(u[c]=I(f[c],E,w));return w.delete(f),u}return f}function D(f,E,w=!0){return(0,v.isObject)(f)?((0,v.isObject)(E)&&Object.keys(E).forEach(_=>{_ in f?w&&((0,v.isObject)(f[_])&&(0,v.isObject)(E[_])?D(f[_],E[_],w):f[_]=E[_]):f[_]=E[_]}),f):E}e.mixin=D;function P(f,E){if(f===E)return!0;if(f==null||E===null||E===void 0||typeof f!=typeof E||typeof f!="object"||Array.isArray(f)!==Array.isArray(E))return!1;let w,_;if(Array.isArray(f)){if(f.length!==E.length)return!1;for(w=0;w<f.length;w++)if(!P(f[w],E[w]))return!1}else{const u=[];for(_ in f)u.push(_);u.sort();const c=[];for(_ in E)c.push(_);if(c.sort(),!P(u,c))return!1;for(w=0;w<u.length;w++)if(!P(f[u[w]],E[u[w]]))return!1}return!0}e.equals=P;function i(f){const E=new Set;return JSON.stringify(f,(w,_)=>{if((0,v.isObject)(_)||Array.isArray(_)){if(E.has(_))return"[Circular]";E.add(_)}return _})}e.safeStringify=i;function A(f,E,w){const _=E(f);return typeof _=="undefined"?w:_}e.getOrDefault=A;function d(f,E){const w=Object.create(null);return!f||!E||Object.keys(E).forEach(u=>{const c=f[u],h=E[u];P(c,h)||(w[u]=h)}),w}e.distinct=d;function p(f,E){const w=E.toLowerCase(),_=Object.keys(f).find(u=>u.toLowerCase()===w);return _?f[_]:f[E]}e.getCaseInsensitive=p;function a(f,E){const w=Object.create(null);for(const _ of Object.keys(f))E(_,f[_])&&(w[_]=f[_]);return w}e.filter=a}),define(me[94],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function C(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=C}),define(me[2],ge([0,1,11,9]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function I(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function P(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==A&&(r=A+r):r=A;break}return r}const i="",A="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,o,g,m,S,b=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,b),this.authority=o||i,this.path=P(this.scheme,g||i),this.query=m||i,this.fragment=S||i,I(this,b))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:g,path:m,query:S,fragment:b}=r;return o===void 0?o=this.scheme:o===null&&(o=i),g===void 0?g=this.authority:g===null&&(g=i),m===void 0?m=this.path:m===null&&(m=i),S===void 0?S=this.query:S===null&&(S=i),b===void 0?b=this.fragment:b===null&&(b=i),o===this.scheme&&g===this.authority&&m===this.path&&S===this.query&&b===this.fragment?this:new f(o,g,m,S,b)}static parse(r,o=!1){const g=d.exec(r);return g?new f(g[2]||i,n(g[4]||i),n(g[5]||i),n(g[7]||i),n(g[9]||i),o):new f(i,i,i,i,i)}static file(r){let o=i;if(v.isWindows&&(r=r.replace(/\\/g,A)),r[0]===A&&r[1]===A){const g=r.indexOf(A,2);g===-1?(o=r.substring(2),r=A):(o=r.substring(2,g),r=r.substring(g)||A)}return new f("file",o,r,i,i)}static from(r){const o=new f(r.scheme,r.authority,r.path,r.query,r.fragment);return I(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return v.isWindows&&r.scheme==="file"?g=p.file(R.win32.join(u(r,!0),...o)).path:g=R.posix.join(r.path,...o),r.with({path:g})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new f(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=p;const a=v.isWindows?1:void 0;class f extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,r){let o,g=-1;for(let m=0;m<s.length;m++){const S=s.charCodeAt(m);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||r&&S===47)g!==-1&&(o+=encodeURIComponent(s.substring(g,m)),g=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const b=E[S];b!==void 0?(g!==-1&&(o+=encodeURIComponent(s.substring(g,m)),g=-1),o+=b):g===-1&&(g=m)}}return g!==-1&&(o+=encodeURIComponent(s.substring(g))),o!==void 0?o:s}function _(s){let r;for(let o=0;o<s.length;o++){const g=s.charCodeAt(o);g===35||g===63?(r===void 0&&(r=s.substr(0,o)),r+=E[g]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function u(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,v.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function c(s,r){const o=r?_:w;let g="",{scheme:m,authority:S,path:b,query:l,fragment:L}=s;if(m&&(g+=m,g+=":"),(S||m==="file")&&(g+=A,g+=A),S){let O=S.indexOf("@");if(O!==-1){const W=S.substr(0,O);S=S.substr(O+1),O=W.indexOf(":"),O===-1?g+=o(W,!1):(g+=o(W.substr(0,O),!1),g+=":",g+=o(W.substr(O+1),!1)),g+="@"}S=S.toLowerCase(),O=S.indexOf(":"),O===-1?g+=o(S,!1):(g+=o(S.substr(0,O),!1),g+=S.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}g+=o(b,!0)}return l&&(g+="?",g+=o(l,!1)),L&&(g+="#",g+=r?L:w(L,!1)),g}function h(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+h(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>h(r)):s}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[22],ge([0,1,2,8]),function(K,e,v,R){"use strict";var C,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=I;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function P(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=P;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class d{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new d)}static forStrings(){return new E(new i)}static forConfigKeys(){return new E(new A)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new f,this._root.segment=r.value()),o=this._root;;){const m=r.cmp(o.segment);if(m>0)o.left||(o.left=new f,o.left.segment=r.value()),o=o.left;else if(m<0)o.right||(o.right=new f,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new f,o.mid.segment=r.value()),o=o.mid;else break}const g=o.value;return o.value=s,o.key=n,g}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let g=this._root;for(;g;){const m=r.cmp(g.segment);if(m>0)o.push([1,g]),g=g.left;else if(m<0)o.push([-1,g]),g=g.right;else if(r.hasNext())r.next(),o.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;o.length>0&&g.isEmpty();){let[S,b]=o.pop();switch(S){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}g=b}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const g=s.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,s){this[C]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,v.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.key,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.value,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:[r.key,r.value],done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=u;class c extends u{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class h{constructor(n){y.set(this,void 0),nt(this,y,n,"f")}get size(){return $e(this,y,"f").size}forEach(n,s){$e(this,y,"f").forEach(n,s)}get(n){return $e(this,y,"f").get(n)}has(n){return $e(this,y,"f").has(n)}entries(){return $e(this,y,"f").entries()}keys(){return $e(this,y,"f").keys()}values(){return $e(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return $e(this,y,"f").entries()}}e.ReadonlyMapView=h}),define(me[95],ge([0,1,22,8]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ce){return function(_e,Re){for(let Ve=0,be=ce.length;Ve<be;Ve++){const Ge=ce[Ve](_e,Re);if(Ge)return Ge}return null}}e.or=C,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ce,_e,Re){if(!Re||Re.length<_e.length)return null;let Ve;return ce?Ve=R.startsWithIgnoreCase(Re,_e):Ve=Re.indexOf(_e)===0,Ve?_e.length>0?[{start:0,end:_e.length}]:[]:null}function y(ce,_e){const Re=_e.toLowerCase().indexOf(ce.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ce.length}]}e.matchesContiguousSubString=y;function I(ce,_e){return D(ce.toLowerCase(),_e.toLowerCase(),0,0)}e.matchesSubString=I;function D(ce,_e,Re,Ve){if(Re===ce.length)return[];if(Ve===_e.length)return null;if(ce[Re]===_e[Ve]){let be=null;return(be=D(ce,_e,Re+1,Ve+1))?w({start:Ve,end:Ve+1},be):null}return D(ce,_e,Re,Ve+1)}function P(ce){return 97<=ce&&ce<=122}function i(ce){return 65<=ce&&ce<=90}e.isUpper=i;function A(ce){return 48<=ce&&ce<=57}function d(ce){return ce===32||ce===9||ce===10||ce===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ce=>p.add(ce.charCodeAt(0)));function a(ce){return d(ce)||p.has(ce)}function f(ce,_e){return ce===_e||a(ce)&&a(_e)}function E(ce){return P(ce)||i(ce)||A(ce)}function w(ce,_e){return _e.length===0?_e=[ce]:ce.end===_e[0].start?_e[0].start=ce.start:_e.unshift(ce),_e}function _(ce,_e){for(let Re=_e;Re<ce.length;Re++){const Ve=ce.charCodeAt(Re);if(i(Ve)||A(Ve)||Re>0&&!E(ce.charCodeAt(Re-1)))return Re}return ce.length}function u(ce,_e,Re,Ve){if(Re===ce.length)return[];if(Ve===_e.length)return null;if(ce[Re]!==_e[Ve].toLowerCase())return null;{let be=null,Ge=Ve+1;for(be=u(ce,_e,Re+1,Ve+1);!be&&(Ge=_(_e,Ge))<_e.length;)be=u(ce,_e,Re+1,Ge),Ge++;return be===null?null:w({start:Ve,end:Ve+1},be)}}function c(ce){let _e=0,Re=0,Ve=0,be=0,Ge=0;for(let je=0;je<ce.length;je++)Ge=ce.charCodeAt(je),i(Ge)&&_e++,P(Ge)&&Re++,E(Ge)&&Ve++,A(Ge)&&be++;const G=_e/ce.length,ne=Re/ce.length,ve=Ve/ce.length,xe=be/ce.length;return{upperPercent:G,lowerPercent:ne,alphaPercent:ve,numericPercent:xe}}function h(ce){const{upperPercent:_e,lowerPercent:Re}=ce;return Re===0&&_e>.6}function t(ce){const{upperPercent:_e,lowerPercent:Re,alphaPercent:Ve,numericPercent:be}=ce;return Re>.2&&_e<.8&&Ve>.6&&be<.2}function n(ce){let _e=0,Re=0,Ve=0,be=0;for(let Ge=0;Ge<ce.length;Ge++)Ve=ce.charCodeAt(Ge),i(Ve)&&_e++,P(Ve)&&Re++,d(Ve)&&be++;return(_e===0||Re===0)&&be===0?ce.length<=30:_e<=5}function s(ce,_e){if(!_e||(_e=_e.trim(),_e.length===0)||!n(ce)||_e.length>60)return null;const Re=c(_e);if(!t(Re)){if(!h(Re))return null;_e=_e.toLowerCase()}let Ve=null,be=0;for(ce=ce.toLowerCase();be<_e.length&&(Ve=u(ce,_e,0,be))===null;)be=_(_e,be+1);return Ve}e.matchesCamelCase=s;function r(ce,_e,Re=!1){if(!_e||_e.length===0)return null;let Ve=null,be=0;for(ce=ce.toLowerCase(),_e=_e.toLowerCase();be<_e.length&&(Ve=o(ce,_e,0,be,Re))===null;)be=g(_e,be+1);return Ve}e.matchesWords=r;function o(ce,_e,Re,Ve,be){if(Re===ce.length)return[];if(Ve===_e.length)return null;if(f(ce.charCodeAt(Re),_e.charCodeAt(Ve))){let Ge=null,G=Ve+1;if(Ge=o(ce,_e,Re+1,Ve+1,be),!be)for(;!Ge&&(G=g(_e,G))<_e.length;)Ge=o(ce,_e,Re+1,G,be),G++;return Ge===null?null:w({start:Ve,end:Ve+1},Ge)}else return null}function g(ce,_e){for(let Re=_e;Re<ce.length;Re++)if(a(ce.charCodeAt(Re))||Re>0&&a(ce.charCodeAt(Re-1)))return Re;return ce.length}const m=C(e.matchesPrefix,s,y),S=C(e.matchesPrefix,s,I),b=new v.LRUCache(1e4);function l(ce,_e,Re=!1){if(typeof ce!="string"||typeof _e!="string")return null;let Ve=b.get(ce);Ve||(Ve=new RegExp(R.convertSimple2RegExpPattern(ce),"i"),b.set(ce,Ve));const be=Ve.exec(_e);return be?[{start:be.index,end:be.index+be[0].length}]:Re?S(ce,_e):m(ce,_e)}e.matchesFuzzy=l;function L(ce,_e){const Re=We(ce,ce.toLowerCase(),0,_e,_e.toLowerCase(),0,!0);return Re?W(Re):null}e.matchesFuzzy2=L;function O(ce,_e,Re,Ve,be,Ge){const G=Math.min(13,ce.length);for(;Re<G;Re++){const ne=We(ce,_e,Re,Ve,be,Ge,!1);if(ne)return ne}return[0,Ge]}e.anyScore=O;function W(ce){if(typeof ce=="undefined")return[];const _e=[],Re=ce[1];for(let Ve=ce.length-1;Ve>1;Ve--){const be=ce[Ve]+Re,Ge=_e[_e.length-1];Ge&&Ge.end===be?Ge.end=be+1:_e.push({start:be,end:be+1})}return _e}e.createMatches=W;const ie=128;function re(){const ce=[],_e=[];for(let Re=0;Re<=ie;Re++)_e[Re]=0;for(let Re=0;Re<=ie;Re++)ce.push(_e.slice(0));return ce}function N(ce){const _e=[];for(let Re=0;Re<=ce;Re++)_e[Re]=0;return _e}const V=N(2*ie),x=N(2*ie),k=re(),U=re(),F=re(),M=!1;function $(ce,_e,Re,Ve,be){function Ge(ne,ve,xe=" "){for(;ne.length<ve;)ne=xe+ne;return ne}let G=` |   |${Ve.split("").map(ne=>Ge(ne,3)).join("|")}
`;for(let ne=0;ne<=Re;ne++)ne===0?G+=" |":G+=`${_e[ne-1]}|`,G+=ce[ne].slice(0,be+1).map(ve=>Ge(ve.toString(),3)).join("|")+`
`;return G}function H(ce,_e,Re,Ve){ce=ce.substr(_e),Re=Re.substr(Ve),console.log($(U,ce,ce.length,Re,Re.length)),console.log($(F,ce,ce.length,Re,Re.length)),console.log($(k,ce,ce.length,Re,Re.length))}function Q(ce,_e){if(_e<0||_e>=ce.length)return!1;const Re=ce.codePointAt(_e);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Re)}}function ae(ce,_e){if(_e<0||_e>=ce.length)return!1;switch(ce.charCodeAt(_e)){case 32:case 9:return!0;default:return!1}}function we(ce,_e,Re){return _e[ce]!==Re[ce]}function Le(ce,_e,Re,Ve,be,Ge,G=!1){for(;_e<Re&&be<Ge;)ce[_e]===Ve[be]&&(G&&(V[_e]=be),_e+=1),be+=1;return _e===Re}e.isPatternInWord=Le;var Ie;(function(ce){ce[ce.Diag=1]="Diag",ce[ce.Left=2]="Left",ce[ce.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Oe;(function(ce){ce.Default=[-100,0];function _e(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ce.isDefault=_e})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function We(ce,_e,Re,Ve,be,Ge,G){const ne=ce.length>ie?ie:ce.length,ve=Ve.length>ie?ie:Ve.length;if(Re>=ne||Ge>=ve||ne-Re>ve-Ge||!Le(_e,Re,ne,be,Ge,ve,!0))return;j(ne,ve,Re,Ge,_e,be);let xe=1,je=1,ze=Re,Xe=Ge;const Ce=[!1];for(xe=1,ze=Re;ze<ne;xe++,ze++){const z=V[ze],J=x[ze],le=ze+1<ne?x[ze+1]:ve;for(je=z-Ge+1,Xe=z;Xe<le;je++,Xe++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Xe<=J&&(Pe=X(ce,_e,ze,Re,Ve,be,Xe,ve,Ge,k[xe-1][je-1]===0,Ce));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Ue=Pe+U[xe-1][je-1]);const Be=Xe>z,Qe=Be?U[xe][je-1]+(k[xe][je-1]>0?-5:0):0,rt=Xe>z+1&&k[xe][je-1]>0,et=rt?U[xe][je-2]+(k[xe][je-2]>0?-5:0):0;if(rt&&(!Be||et>=Qe)&&(!Ae||et>=Ue))U[xe][je]=et,F[xe][je]=3,k[xe][je]=0;else if(Be&&(!Ae||Qe>=Ue))U[xe][je]=Qe,F[xe][je]=2,k[xe][je]=0;else if(Ae)U[xe][je]=Ue,F[xe][je]=1,k[xe][je]=k[xe-1][je-1]+1;else throw new Error("not possible")}}if(M&&H(ce,Re,Ve,Ge),!Ce[0]&&!G)return;xe--,je--;const De=[U[xe][je],Ge];let ke=0,se=0;for(;xe>=1;){let z=je;do{const J=F[xe][z];if(J===3)z=z-2;else if(J===2)z=z-1;else break}while(z>=1);ke>1&&_e[Re+xe-1]===be[Ge+je-1]&&!we(z+Ge-1,Ve,be)&&ke+1>k[xe][z]&&(z=je),z===je?ke++:ke=1,se||(se=z),xe--,je=z-1,De.push(je)}ve===ne&&(De[0]+=2);const de=se-ne;return De[0]-=de,De}e.fuzzyScore=We;function j(ce,_e,Re,Ve,be,Ge){let G=ce-1,ne=_e-1;for(;G>=Re&&ne>=Ve;)be[G]===Ge[ne]&&(x[G]=ne,G--),ne--}function X(ce,_e,Re,Ve,be,Ge,G,ne,ve,xe,je){if(_e[Re]!==Ge[G])return Number.MIN_SAFE_INTEGER;let ze=1,Xe=!1;return G===Re-Ve?ze=ce[Re]===be[G]?7:5:we(G,be,Ge)&&(G===0||!we(G-1,be,Ge))?(ze=ce[Re]===be[G]?7:5,Xe=!0):Q(Ge,G)&&(G===0||!Q(Ge,G-1))?ze=5:(Q(Ge,G-1)||ae(Ge,G-1))&&(ze=5,Xe=!0),ze>1&&Re===Ve&&(je[0]=!0),Xe||(Xe=we(G,be,Ge)||Q(Ge,G-1)||ae(Ge,G-1)),Re===Ve?G>ve&&(ze-=Xe?3:5):xe?ze+=Xe?2:0:ze+=Xe?0:1,G+1===ne&&(ze-=Xe?3:5),ze}function ee(ce,_e,Re,Ve,be,Ge,G){return pe(ce,_e,Re,Ve,be,Ge,!0,G)}e.fuzzyScoreGracefulAggressive=ee;function oe(ce,_e,Re,Ve,be,Ge,G){return pe(ce,_e,Re,Ve,be,Ge,!1,G)}e.fuzzyScoreGraceful=oe;function pe(ce,_e,Re,Ve,be,Ge,G,ne){let ve=We(ce,_e,Re,Ve,be,Ge,ne);if(ve&&!G)return ve;if(ce.length>=3){const xe=Math.min(7,ce.length-1);for(let je=Re+1;je<xe;je++){const ze=Se(ce,je);if(ze){const Xe=We(ze,ze.toLowerCase(),Re,Ve,be,Ge,ne);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Se(ce,_e){if(_e+1>=ce.length)return;const Re=ce[_e],Ve=ce[_e+1];if(Re!==Ve)return ce.slice(0,_e)+Ve+Re+ce.slice(_e+2)}}),define(me[137],ge([0,1,45,95,8]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function I(f){return f.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${T.source}`,"g");function P(f){return f.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=P;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function A(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(i,(E,w,_,u)=>_?E:w||u||"")}e.stripIcons=A;function d(f){const E=f.indexOf(e.iconStartMarker);return E===-1?{text:f}:p(f,E)}e.parseLabelWithIcons=d;function p(f,E){const w=[];let _="";function u(g){if(g){_+=g;for(const m of g)w.push(t)}}let c=-1,h="",t=0,n,s,r=E;const o=f.length;for(u(f.substr(0,E));r<o;)n=f[r],s=f[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=r,u(h),h=e.iconStartMarker,r++):n===")"&&c!==-1?(t+=r-c+1,c=-1,h=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?h+=n:(u(h),c=-1,h=""):u(n),r++;return u(h),{text:_,iconOffsets:w}}function a(f,E,w=!1){const{text:_,iconOffsets:u}=E;if(!u||u.length===0)return(0,R.matchesFuzzy)(f,_,w);const c=(0,C.ltrim)(_," "),h=_.length-c.length,t=(0,R.matchesFuzzy)(f,c,w);if(t)for(const n of t){const s=u[n.start+h]+h;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(me[96],ge([0,1,16,137,17]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",E=!1){var w,_;if(this.value=f,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(_=E.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(f,E=0){return this.value+=A(this.supportThemeIcons?(0,R.escapeIcons)(f):f).replace(/([ \t]+)/g,(w,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,E){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function I(a){return D(a)?!a.value:Array.isArray(a)?a.every(I):!0}e.isEmptyMarkdownString=I;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function P(a,f){return!a&&!f?!0:!a||!f?!1:Array.isArray(a)&&Array.isArray(f)?(0,v.equals)(a,f,i):D(a)&&D(f)?i(a,f):!1}e.markedStringsEquals=P;function i(a,f){return a===f?!0:!a||!f?!1:a.value===f.value&&a.isTrusted===f.isTrusted&&a.supportThemeIcons===f.supportThemeIcons}function A(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function d(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function p(a){const f=[],E=a.split("|").map(_=>_.trim());a=E[0];const w=E[1];if(w){const _=/height=(\d+)/.exec(w),u=/width=(\d+)/.exec(w),c=_?_[1]:"",h=u?u[1]:"",t=isFinite(parseInt(h)),n=isFinite(parseInt(c));t&&f.push(`width="${h}"`),n&&f.push(`height="${c}"`)}return{href:a,dimensions:f}}e.parseHrefAndDimensions=p}),define(me[58],ge([0,1,23,8,2]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,I)}e.stringify=T;function y(P){let i=JSON.parse(P);return i=D(i),i}e.parse=y;function I(P,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,R.regExpFlags)(i)}:i}function D(P,i=0){if(!P||i>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return C.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof v.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let A=0;A<P.length;++A)P[A]=D(P[A],i+1);else for(const A in P)Object.hasOwnProperty.call(P,A)&&(P[A]=D(P[A],i+1))}return P}e.revive=D}),define(me[10],ge([0,1,2,11]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,i){this._hosts[D]=P,this._ports[D]=i}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let i=this._hosts[P];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const A=this._ports[P],d=this._connectionTokens[P];let p=`path=${encodeURIComponent(D.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${A}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,i){const A=this.toUri(D,P);return A.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(A):R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&A.scheme===C.file?A.with({scheme:C.vscodeFileResource,authority:A.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(D,P){const i=this.toUri(D,P);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,P){return v.URI.isUri(D)?D:v.URI.parse(P.toUrl(D))}}e.FileAccess=new y}),define(me[76],ge([0,1,22]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function C(P){return D(P,"NFC",R)}e.normalizeNFC=C;const T=new v.LRUCache(1e4);function y(P){return D(P,"NFD",T)}e.normalizeNFD=y;const I=/[^\u0000-\u0080]/;function D(P,i,A){if(!e.canNormalize||!P)return P;const d=A.get(P);if(d)return d;let p;return I.test(P)?p=P.normalize(i):p=P,A.set(P,p),p}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(i){return y(i).replace(P,"")}}else return function(P){return P}}()}),define(me[25],ge([0,1,29,9,2,8,10,11]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=D;class P{constructor(a){this._ignorePathCasing=a}compare(a,f,E=!1){return a===f?0:(0,T.compare)(this.getComparisonKey(a,E),this.getComparisonKey(f,E))}isEqual(a,f,E=!1){return a===f?!0:!a||!f?!1:this.getComparisonKey(a,E)===this.getComparisonKey(f,E)}getComparisonKey(a,f=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,f,E=!1){if(a.scheme===f.scheme){if(a.scheme===y.Schemas.file)return v.isEqualOrParent(D(a),D(f),this._ignorePathCasing(a))&&a.query===f.query&&(E||a.fragment===f.fragment);if((0,e.isEqualAuthority)(a.authority,f.authority))return v.isEqualOrParent(a.path,f.path,this._ignorePathCasing(a),"/")&&a.query===f.query&&(E||a.fragment===f.fragment)}return!1}joinPath(a,...f){return C.URI.joinPath(a,...f)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return R.posix.basename(a.path)}extname(a){return R.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let f;return a.scheme===y.Schemas.file?f=C.URI.file(R.dirname(D(a))).path:(f=R.posix.dirname(a.path),a.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),f="/")),a.with({path:f})}normalizePath(a){if(!a.path.length)return a;let f;return a.scheme===y.Schemas.file?f=C.URI.file(R.normalize(D(a))).path:f=R.posix.normalize(a.path),a.with({path:f})}relativePath(a,f){if(a.scheme!==f.scheme||!(0,e.isEqualAuthority)(a.authority,f.authority))return;if(a.scheme===y.Schemas.file){const _=R.relative(D(a),D(f));return I.isWindows?v.toSlashes(_):_}let E=a.path||"/",w=f.path||"/";if(this._ignorePathCasing(a)){let _=0;for(const u=Math.min(E.length,w.length);_<u&&!(E.charCodeAt(_)!==w.charCodeAt(_)&&E.charAt(_).toLowerCase()!==w.charAt(_).toLowerCase());_++);E=w.substr(0,_)+E.substr(_)}return R.posix.relative(E,w)}resolvePath(a,f){if(a.scheme===y.Schemas.file){const E=C.URI.file(R.resolve(D(a),f));return a.with({authority:E.authority,path:E.path})}return f=v.toPosixPath(f),a.with({path:R.posix.resolve(a.path,f)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,f){return a===f||(0,T.equalsIgnoreCase)(a,f)}hasTrailingPathSeparator(a,f=R.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>v.getRoot(E).length&&E[E.length-1]===f}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,f=R.sep){return(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,f=R.sep){let E=!1;if(a.scheme===y.Schemas.file){const w=D(a);E=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===f}else{f="/";const w=a.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(p=>p.scheme===y.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new P(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,a){const f=[];for(let E=0;E<p.length;E++){const w=a(p[E]);p.some((_,u)=>u===E?!1:(0,e.isEqualOrParent)(w,a(_)))||f.push(p[E])}return f}e.distinctParents=i;var A;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(f){const E=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,h]=u.split(":");c&&h&&E.set(c,h)});const _=f.path.substring(0,f.path.indexOf(";"));return _&&E.set(p.META_DATA_MIME,_),E}p.parseMetaData=a})(A=e.DataUri||(e.DataUri={}));function d(p,a,f){if(a){let E=p.path;return E&&E[0]!==R.posix.sep&&(E=R.posix.sep+E),p.with({scheme:f,authority:a,path:E})}return p.with({scheme:f})}e.toLocalResource=d}),define(me[13],ge([0,1,21,17,3,6,56,25]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(U){return!!U&&typeof U.then=="function"}e.isThenable=D;function P(U){const F=new v.CancellationTokenSource,M=U(F.token),$=new Promise((H,Q)=>{F.token.onCancellationRequested(()=>{Q((0,R.canceled)())}),Promise.resolve(M).then(ae=>{F.dispose(),H(ae)},ae=>{F.dispose(),Q(ae)})});return new class{cancel(){F.cancel()}then(H,Q){return $.then(H,Q)}catch(H){return this.then(void 0,H)}finally(H){return $.finally(H)}}}e.createCancelablePromise=P;function i(U,F,M){return Promise.race([U,new Promise($=>F.onCancellationRequested(()=>$(M)))])}e.raceCancellation=i;async function A(U){let F=-1;const M=U.map((H,Q)=>H.then(ae=>(F=Q,ae))),$=await Promise.race(M);return U.forEach((H,Q)=>{Q!==F&&H.cancel()}),$}e.raceCancellablePromises=A;function d(U,F,M){let $;const H=setTimeout(()=>{$==null||$(void 0),M==null||M()},F);return Promise.race([U.finally(()=>clearTimeout(H)),new Promise(Q=>$=Q)])}e.raceTimeout=d;function p(U){return new Promise((F,M)=>{const $=U();D($)?$.then(F,M):F($)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(M,M).then($)})}return new Promise((M,$)=>{this.queuedPromise.then(M,$)})}return this.activePromise=F(),new Promise((M,$)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,$(H)})})}}e.Throttler=a;class f{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=f;class E{constructor(){this.promiseMap=new Map}queue(F,M){var $;const Q=(($=this.promiseMap.get(F))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===Q&&this.promiseMap.delete(F)});return this.promiseMap.set(F,Q),Q}}e.SequencerByKey=E;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,H)=>{this.doResolve=$,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class _{constructor(F){this.delayer=new w(F),this.throttler=new a}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function h(U,F){return F?new Promise((M,$)=>{const H=setTimeout(M,U);F.onCancellationRequested(()=>{clearTimeout(H),$((0,R.canceled)())})}):P(M=>h(U,M))}e.timeout=h;function t(U,F=0){const M=setTimeout(U,F);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(U){return U.then(void 0,F=>{})}e.ignoreErrors=n;function s(U){const F=[];let M=0;const $=U.length;function H(){return M<$?U[M++]():null}function Q(ae){ae!=null&&F.push(ae);const we=H();return we?we.then(Q):Promise.resolve(F)}return Promise.resolve(null).then(Q)}e.sequence=s;function r(U,F=$=>!!$,M=null){let $=0;const H=U.length,Q=()=>{if($>=H)return Promise.resolve(M);const ae=U[$++];return Promise.resolve(ae()).then(Le=>F(Le)?Promise.resolve(Le):Q())};return Q()}e.first=r;function o(U,F=$=>!!$,M=null){if(U.length===0)return Promise.resolve(M);let $=U.length;const H=()=>{var Q,ae;$=-1;for(const we of U)(ae=(Q=we).cancel)===null||ae===void 0||ae.call(Q)};return new Promise((Q,ae)=>{for(const we of U)we.then(Le=>{--$>=0&&F(Le)?(H(),Q(Le)):$===0&&Q(M)}).catch(Le=>{--$>=0&&(H(),ae(Le))})})}e.firstParallel=o;class g{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,$)=>{this.outstandingPromises.push({factory:F,c:M,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class m extends g{constructor(){super(1)}}e.Queue=m;class S{constructor(){this.queues=new Map}queueFor(F,M=I.extUri){const $=M.getComparisonKey(F);let H=this.queues.get($);return H||(H=new m,C.Event.once(H.onFinished)(()=>{H==null||H.dispose(),this.queues.delete($)}),this.queues.set($,H)),H}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=S;class b{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=b;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=l;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(U));let $=!1;return{dispose(){$||($=!0,clearTimeout(M))}}}}else e.runWhenIdle=(U,F)=>{const M=requestIdleCallback(U,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function ie(U,F,M){let $;for(let H=0;H<M;H++)try{return await U()}catch(Q){$=Q,await h(F)}throw $}e.retry=ie;class re{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,$){return this._pending={taskId:F,cancel:()=>$==null?void 0:$(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,$;const H=new Promise((Q,ae)=>{M=Q,$=ae});this._next={run:F,promise:H,promiseResolve:M,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=re;class N{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=V;class x extends C.Emitter{async fireAsync(F,M,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const H of this._listeners)this._asyncDeliveryQueue.push([H,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[H,Q]=this._asyncDeliveryQueue.shift(),ae=[],we=Object.assign(Object.assign({},Q),{waitUntil:Le=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");$&&(Le=$(Le,typeof H=="function"?H:H[0])),ae.push(Le)}});try{typeof H=="function"?H.call(void 0,we):H[0].call(H[1],we)}catch(Le){(0,R.onUnexpectedError)(Le);continue}Object.freeze(ae),await k.settled(ae).catch(Le=>(0,R.onUnexpectedError)(Le))}}}}e.AsyncEmitter=x;var k;(function(U){async function F(Q){return typeof Promise.allSettled=="function"?M(Q):$(Q)}U.allSettled=F;async function M(Q){return Promise.allSettled(Q)}async function $(Q){return Promise.all(Q.map(ae=>ae.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function H(Q){let ae;const we=await Promise.all(Q.map(Le=>Le.then(Ie=>Ie,Ie=>{ae||(ae=Ie)})));if(typeof ae!="undefined")throw ae;return we}U.settled=H})(k=e.Promises||(e.Promises={}))}),define(me[97],ge([0,1,9,13]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(b,l,L=!1){const O=b||"",W=l||"",ie=C.value.collator.compare(O,W);return C.value.collatorIsNumeric&&ie===0&&O!==W?O<W?-1:1:ie}e.compareFileNames=I;function D(b,l){const L=T.value.collator;return b=b||"",l=l||"",h(L,b,l)}e.compareFileNamesDefault=D;function P(b,l){const L=T.value.collator;return b=b||"",l=l||"",r(b,l)||h(L,b,l)}e.compareFileNamesUpper=P;function i(b,l){const L=T.value.collator;return b=b||"",l=l||"",s(b,l)||h(L,b,l)}e.compareFileNamesLower=i;function A(b,l){return b=b||"",l=l||"",b===l?0:b<l?-1:1}e.compareFileNamesUnicode=A;function d(b,l,L=!1){L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase());const[O,W]=u(b),[ie,re]=u(l);return O!==ie?O<ie?-1:1:W===re?0:W<re?-1:1}e.noIntlCompareFileNames=d;function p(b,l){const[L,O]=u(b),[W,ie]=u(l);let re=C.value.collator.compare(O,ie);if(re===0){if(C.value.collatorIsNumeric&&O!==ie)return O<ie?-1:1;if(re=C.value.collator.compare(L,W),C.value.collatorIsNumeric&&re===0&&L!==W)return L<W?-1:1}return re}e.compareFileExtensions=p;function a(b,l){b=b||"",l=l||"";const L=c(b),O=c(l),W=T.value.collator,ie=y.value.collator;return h(ie,L,O)||h(W,b,l)}e.compareFileExtensionsDefault=a;function f(b,l){b=b||"",l=l||"";const L=c(b),O=c(l),W=T.value.collator,ie=y.value.collator;return h(ie,L,O)||r(b,l)||h(W,b,l)}e.compareFileExtensionsUpper=f;function E(b,l){b=b||"",l=l||"";const L=c(b),O=c(l),W=T.value.collator,ie=y.value.collator;return h(ie,L,O)||s(b,l)||h(W,b,l)}e.compareFileExtensionsLower=E;function w(b,l){b=b||"",l=l||"";const L=c(b).toLowerCase(),O=c(l).toLowerCase();return L!==O?L<O?-1:1:b!==l?b<l?-1:1:0}e.compareFileExtensionsUnicode=w;const _=/^(.*?)(\.([^.]*))?$/;function u(b,l=!1){const L=b?_.exec(b):[];let O=[L&&L[1]||"",L&&L[3]||""];return l&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function c(b){const l=b?_.exec(b):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function h(b,l,L){let O=b.compare(l,L);return O!==0?O:l.length!==L.length?l.length<L.length?-1:1:0}function t(b){const l=b.charAt(0);return l.toLocaleUpperCase()!==l}function n(b){const l=b.charAt(0);return l.toLocaleLowerCase()!==l}function s(b,l){return t(b)&&n(l)?-1:n(b)&&t(l)?1:0}function r(b,l){return n(b)&&t(l)?-1:t(b)&&n(l)?1:0}function o(b,l,L=!1){return L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase()),b===l?0:b<l?-1:1}function g(b,l,L=!1){const O=b.split(v.sep),W=l.split(v.sep),ie=O.length-1,re=W.length-1;let N,V;for(let x=0;;x++){if(N=ie===x,V=re===x,N&&V)return I(O[x],W[x],L);if(N)return-1;if(V)return 1;const k=o(O[x],W[x],L);if(k!==0)return k}}e.comparePaths=g;function m(b,l,L){const O=b.toLowerCase(),W=l.toLowerCase(),ie=S(b,l,L);if(ie)return ie;const re=O.endsWith(L),N=W.endsWith(L);if(re!==N)return re?-1:1;const V=I(O,W);return V!==0?V:O.localeCompare(W)}e.compareAnything=m;function S(b,l,L){const O=b.toLowerCase(),W=l.toLowerCase(),ie=O.startsWith(L),re=W.startsWith(L);if(ie!==re)return ie?-1:1;if(ie&&re){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=S}),define(me[98],ge([0,1,97,95,9,11,8]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,D=[I,[]];function P(N,V,x,k){if(!N||!V)return D;const U=N.length,F=V.length;if(U<F)return D;const M=N.toLowerCase();return!k&&!M.includes(x)?D:i(V,x,F,N,M,U)}e.scoreFuzzy=P;function i(N,V,x,k,U,F){const M=[],$=[];for(let we=0;we<x;we++){const Le=we*F,Ie=Le-F,Oe=we>0,We=N[we],j=V[we];for(let X=0;X<F;X++){const ee=X>0,oe=Le+X,pe=oe-1,Se=Ie+X-1,ce=ee?M[pe]:0,_e=Oe&&ee?M[Se]:0,Re=Oe&&ee?$[Se]:0;let Ve;!_e&&Oe?Ve=0:Ve=A(We,j,k,U,X,Re),Ve&&_e+Ve>=ce?($[oe]=Re+1,M[oe]=_e+Ve):($[oe]=I,M[oe]=ce)}}const H=[];let Q=x-1,ae=F-1;for(;Q>=0&&ae>=0;){const we=Q*F+ae;$[we]===I||(H.push(ae),Q--),ae--}return[M[x*F-1],H.reverse()]}function A(N,V,x,k,U,F){let M=0;if(!d(V,k[U]))return M;if(M+=1,F>0&&(M+=F*5),N===x[U]&&(M+=1),U===0)M+=8;else{const $=p(x.charCodeAt(U-1));$?M+=$:(0,R.isUpper)(x.charCodeAt(U))&&(M+=2)}return M}function d(N,V){return N===V?!0:N==="/"||N==="\\"?V==="/"||V==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function f(N,V,x=0,k=0){const U=V;return U.values&&U.values.length>1?E(N,U.values,x,k):w(N,V,x,k)}e.scoreFuzzy2=f;function E(N,V,x,k){let U=0;const F=[];for(const M of V){const[$,H]=w(N,M,x,k);if(typeof $!="number")return a;U+=$,F.push(...H)}return[U,g(F)]}function w(N,V,x,k){const U=(0,R.fuzzyScore)(V.original,V.originalLowercase,x,N,N.toLowerCase(),k,!0);return U?[U[0],(0,R.createMatches)(U)]:a}const _=Object.freeze({score:0}),u=1<<18,c=1<<17,h=1<<16;function t(N,V,x,k,U){if(!N||!V.normalized)return _;const F=k.getItemLabel(N);if(!F)return _;const M=k.getItemDescription(N);let $;M?$=`${F}${M}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${x}`:$=`${F}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${x}`;const H=U[$];if(H)return H;const Q=n(F,M,k.getItemPath(N),V,x);return U[$]=Q,Q}e.scoreItemFuzzy=t;function n(N,V,x,k,U){const F=!x||!k.containsPathSeparator;return x&&(T.isLinux?k.pathNormalized===x:(0,y.equalsIgnoreCase)(k.pathNormalized,x))?{score:u,labelMatch:[{start:0,end:N.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:k.values&&k.values.length>1?s(N,V,x,k.values,F,U):r(N,V,x,k,F,U)}function s(N,V,x,k,U,F){let M=0;const $=[],H=[];for(const Q of k){const{score:ae,labelMatch:we,descriptionMatch:Le}=r(N,V,x,Q,U,F);if(ae===I)return _;M+=ae,we&&$.push(...we),Le&&H.push(...Le)}return{score:M,labelMatch:g($),descriptionMatch:g(H)}}function r(N,V,x,k,U,F){if(U||!V){const[M,$]=P(N,k.normalized,k.normalizedLowercase,F);if(M){const H=(0,R.matchesPrefix)(k.normalized,N);let Q;return H?(Q=c,Q+=Math.round(k.normalized.length/N.length*100)):Q=h,{score:Q+M,labelMatch:H||o($)}}}if(V){let M=V;x&&(M=`${V}${C.sep}`);const $=M.length,H=`${M}${N}`,[Q,ae]=P(H,k.normalized,k.normalizedLowercase,F);if(Q){const we=o(ae),Le=[],Ie=[];return we.forEach(Oe=>{Oe.start<$&&Oe.end>$?(Le.push({start:0,end:Oe.end-$}),Ie.push({start:Oe.start,end:$})):Oe.start>=$?Le.push({start:Oe.start-$,end:Oe.end-$}):Ie.push(Oe)}),{score:Q,labelMatch:Le,descriptionMatch:Ie}}}return _}function o(N){const V=[];if(!N)return V;let x;for(const k of N)x&&x.end===k?x.end+=1:(x={start:k,end:k+1},V.push(x));return V}function g(N){const V=N.sort((U,F)=>U.start-F.start),x=[];let k;for(const U of V)!k||!m(k,U)?(k=U,x.push(U)):(k.start=Math.min(k.start,U.start),k.end=Math.max(k.end,U.end));return x}function m(N,V){return!(N.end<V.start||V.end<N.start)}function S(N,V,x,k,U,F){const M=t(N,x,k,U,F),$=t(V,x,k,U,F),H=M.score,Q=$.score;if((H===u||Q===u)&&H!==Q)return H===u?-1:1;if(H>h||Q>h){if(H!==Q)return H>Q?-1:1;if(H<c&&Q<c){const j=l(M.labelMatch,$.labelMatch);if(j!==0)return j}const Oe=U.getItemLabel(N)||"",We=U.getItemLabel(V)||"";if(Oe.length!==We.length)return Oe.length-We.length}if(H!==Q)return H>Q?-1:1;const ae=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray($.labelMatch)&&$.labelMatch.length>0;if(ae&&!we)return-1;if(we&&!ae)return 1;const Le=b(N,M,U),Ie=b(V,$,U);return Le&&Ie&&Le!==Ie?Ie>Le?-1:1:L(N,V,x,U)}e.compareItemsByFuzzyScore=S;function b(N,V,x){let k=-1,U=-1;if(V.descriptionMatch&&V.descriptionMatch.length?k=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(k=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(U=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const F=x.getItemDescription(N);F&&(U+=F.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(U=V.descriptionMatch[V.descriptionMatch.length-1].end);return U-k}function l(N,V){if(!N&&!V||(!N||!N.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,U=N[N.length-1].end-x,F=V[0].start,$=V[V.length-1].end-F;return U===$?0:$<U?1:-1}function L(N,V,x,k){const U=k.getItemLabel(N)||"",F=k.getItemLabel(V)||"",M=k.getItemDescription(N),$=k.getItemDescription(V),H=U.length+(M?M.length:0),Q=F.length+($?$.length:0);if(H!==Q)return H-Q;const ae=k.getItemPath(N),we=k.getItemPath(V);return ae&&we&&ae.length!==we.length?ae.length-we.length:U!==F?(0,v.compareAnything)(U,F,x.normalized):M&&$&&M!==$?(0,v.compareAnything)(M,$,x.normalized):ae&&we&&ae!==we?(0,v.compareAnything)(ae,we,x.normalized):0}const O=" ";function W(N){typeof N!="string"&&(N="");const V=N.toLowerCase(),{pathNormalized:x,normalized:k,normalizedLowercase:U}=ie(N),F=x.indexOf(C.sep)>=0;let M;const $=N.split(O);if($.length>1)for(const H of $){const{pathNormalized:Q,normalized:ae,normalizedLowercase:we}=ie(H);ae&&(M||(M=[]),M.push({original:H,originalLowercase:H.toLowerCase(),pathNormalized:Q,normalized:ae,normalizedLowercase:we}))}return{original:N,originalLowercase:V,pathNormalized:x,normalized:k,normalizedLowercase:U,values:M,containsPathSeparator:F}}e.prepareQuery=W;function ie(N){let V;T.isWindows?V=N.replace(/\//g,C.sep):V=N.replace(/\\/g,C.sep);const x=(0,y.stripWildcards)(V).replace(/\s/g,"");return{pathNormalized:V,normalized:x,normalizedLowercase:x.toLowerCase()}}function re(N){return Array.isArray(N)?W(N.map(V=>V.original).join(O)):W(N.original)}e.pieceToQuery=re}),define(me[31],ge([0,1,8,29,9,22,13]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",P="/",i="[/\\\\]",A="[^/\\\\]",d=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${A}*?`;default:return`(?:${i}|${A}+${i}|${i}${A}+)*?`}}function a(M,$){if(!M)return[];const H=[];let Q=!1,ae=!1,we="";for(const Le of M){switch(Le){case $:if(!Q&&!ae){H.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}we+=Le}return we&&H.push(we),H}e.splitGlobAware=a;function f(M){if(!M)return"";let $="";const H=a(M,P);if(H.every(Q=>Q===D))$=".*";else{let Q=!1;H.forEach((ae,we)=>{if(ae===D){Q||($+=p(2),Q=!0);return}let Le=!1,Ie="",Oe=!1,We="";for(const j of ae){if(j!=="}"&&Le){Ie+=j;continue}if(Oe&&(j!=="]"||!We)){let X;j==="-"?X=j:(j==="^"||j==="!")&&!We?X="^":j===P?X="":X=v.escapeRegExpCharacters(j),We+=X;continue}switch(j){case"{":Le=!0;continue;case"[":Oe=!0;continue;case"}":$+=`(?:${a(Ie,",").map(oe=>f(oe)).join("|")})`,Le=!1,Ie="";break;case"]":$+="["+We+"]",Oe=!1,We="";break;case"?":$+=A;continue;case"*":$+=p(1);continue;default:$+=v.escapeRegExpCharacters(j)}}we<H.length-1&&(H[we+1]!==D||we+2<H.length)&&($+=i),Q=!1})}return $}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(M,$){if(!M)return s;let H;typeof M!="string"?H=M.pattern:H=M,H=H.trim();const Q=`${H}_${!!$.trimForExclusions}`;let ae=t.get(Q);if(ae)return o(ae,M);let we;if(E.test(H)){const Le=H.substr(4);ae=function(Ie,Oe){return typeof Ie=="string"&&Ie.endsWith(Le)?H:null}}else(we=w.exec(g(H,$)))?ae=m(we[1],H):($.trimForExclusions?u:_).test(H)?ae=S(H,$):(we=c.exec(g(H,$)))?ae=b(we[1].substr(1),H,!0):(we=h.exec(g(H,$)))?ae=b(we[1],H,!1):ae=l(H);return t.set(Q,ae),o(ae,M)}function o(M,$){return typeof $=="string"?M:function(H,Q){return R.isEqualOrParent(H,$.base)?M(C.relative($.base,H),Q):null}}function g(M,$){return $.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,$){const H=`/${M}`,Q=`\\${M}`,ae=function(Le,Ie){return typeof Le!="string"?null:Ie?Ie===M?$:null:Le===M||Le.endsWith(H)||Le.endsWith(Q)?$:null},we=[M];return ae.basenames=we,ae.patterns=[$],ae.allBasenames=we,ae}function S(M,$){const H=F(M.slice(1,-1).split(",").map(Ie=>r(Ie,$)).filter(Ie=>Ie!==s),M),Q=H.length;if(!Q)return s;if(Q===1)return H[0];const ae=function(Ie,Oe){for(let We=0,j=H.length;We<j;We++)if(H[We](Ie,Oe))return M;return null},we=H.find(Ie=>!!Ie.allBasenames);we&&(ae.allBasenames=we.allBasenames);const Le=H.reduce((Ie,Oe)=>Oe.allPaths?Ie.concat(Oe.allPaths):Ie,[]);return Le.length&&(ae.allPaths=Le),ae}function b(M,$,H){const Q=C.sep===C.posix.sep,ae=Q?M:M.replace(d,C.sep),we=C.sep+ae,Le=C.posix.sep+M,Ie=H?function(Oe,We){return typeof Oe=="string"&&(Oe===ae||Oe.endsWith(we)||!Q&&(Oe===M||Oe.endsWith(Le)))?$:null}:function(Oe,We){return typeof Oe=="string"&&(Oe===ae||!Q&&Oe===M)?$:null};return Ie.allPaths=[(H?"*/":"./")+M],Ie}function l(M){try{const $=new RegExp(`^${f(M)}$`);return function(H){return $.lastIndex=0,typeof H=="string"&&$.test(H)?M:null}}catch($){return s}}function L(M,$,H){return!M||typeof $!="string"?!1:O(M)($,void 0,H)}e.match=L;function O(M,$={}){if(!M)return n;if(typeof M=="string"||N(M)){const H=r(M,$);if(H===s)return n;const Q=function(ae,we){return!!H(ae,we)};return H.allBasenames&&(Q.allBasenames=H.allBasenames),H.allPaths&&(Q.allPaths=H.allPaths),Q}return k(M,$)}e.parse=O;function W(M){if(!M)return;let $;return H=>($||($=(M()||Promise.resolve([])).then(Q=>Q?re(Q):{})),$.then(Q=>!!Q[H]))}e.hasSiblingPromiseFn=W;function ie(M){if(!M)return;let $;return H=>{if(!$){const Q=M();$=Q?re(Q):{}}return!!$[H]}}e.hasSiblingFn=ie;function re(M){const $={};for(const H of M)$[H]=!0;return $}function N(M){const $=M;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=N;function V(M){return M.allBasenames||[]}e.getBasenameTerms=V;function x(M){return M.allPaths||[]}e.getPathTerms=x;function k(M,$){const H=F(Object.getOwnPropertyNames(M).map(Ie=>U(Ie,M[Ie],$)).filter(Ie=>Ie!==s)),Q=H.length;if(!Q)return s;if(!H.some(Ie=>!!Ie.requiresSiblings)){if(Q===1)return H[0];const Ie=function(j,X){for(let ee=0,oe=H.length;ee<oe;ee++){const pe=H[ee](j,X);if(pe)return pe}return null},Oe=H.find(j=>!!j.allBasenames);Oe&&(Ie.allBasenames=Oe.allBasenames);const We=H.reduce((j,X)=>X.allPaths?j.concat(X.allPaths):j,[]);return We.length&&(Ie.allPaths=We),Ie}const ae=function(Ie,Oe,We){let j;for(let X=0,ee=H.length;X<ee;X++){const oe=H[X];oe.requiresSiblings&&We&&(Oe||(Oe=C.basename(Ie)),j||(j=Oe.substr(0,Oe.length-C.extname(Ie).length)));const pe=oe(Ie,Oe,j,We);if(pe)return pe}return null},we=H.find(Ie=>!!Ie.allBasenames);we&&(ae.allBasenames=we.allBasenames);const Le=H.reduce((Ie,Oe)=>Oe.allPaths?Ie.concat(Oe.allPaths):Ie,[]);return Le.length&&(ae.allPaths=Le),ae}function U(M,$,H){if($===!1)return s;const Q=r(M,H);if(Q===s)return s;if(typeof $=="boolean")return Q;if($){const ae=$.when;if(typeof ae=="string"){const we=(Le,Ie,Oe,We)=>{if(!We||!Q(Le,Ie))return null;const j=ae.replace("$(basename)",Oe),X=We(j);return(0,y.isThenable)(X)?X.then(ee=>ee?M:null):X?M:null};return we.requiresSiblings=!0,we}}return Q}function F(M,$){const H=M.filter(Ie=>!!Ie.basenames);if(H.length<2)return M;const Q=H.reduce((Ie,Oe)=>{const We=Oe.basenames;return We?Ie.concat(We):Ie},[]);let ae;if($){ae=[];for(let Ie=0,Oe=Q.length;Ie<Oe;Ie++)ae.push($)}else ae=H.reduce((Ie,Oe)=>{const We=Oe.patterns;return We?Ie.concat(We):Ie},[]);const we=function(Ie,Oe){if(typeof Ie!="string")return null;if(!Oe){let j;for(j=Ie.length;j>0;j--){const X=Ie.charCodeAt(j-1);if(X===47||X===92)break}Oe=Ie.substr(j)}const We=Q.indexOf(Oe);return We!==-1?ae[We]:null};we.basenames=Q,we.patterns=ae,we.allBasenames=Q;const Le=M.filter(Ie=>!Ie.basenames);return Le.push(we),Le}}),define(me[77],ge([0,1,2,9,8,10,11,25,29]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(r,o,g){if(typeof r=="string"&&(r=v.URI.file(r)),g){const S=g.getWorkspaceFolder(r);if(S){const b=g.getWorkspace().folders.length>1;let l;if((0,I.isEqual)(S.uri,r)?l="":l=(0,I.relativePath)(S.uri,r),b){const L=S.name?S.name:(0,I.basename)(S.uri);l=l?L+" \u2022 "+l:L}return l}}if(r.scheme!==T.Schemas.file&&r.scheme!==T.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,R.normalize)(A(r.fsPath));let m=(0,R.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(m=p(m,o.userHome.fsPath)),m}e.getPathLabel=P;function i(r){if(!r)return;typeof r=="string"&&(r=v.URI.file(r));const o=(0,I.basename)(r)||(r.scheme===T.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?A(o):o}e.getBaseLabel=i;function A(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=A;let d=Object.create(null);function p(r,o){if(y.isWindows||!r||!o)return r;let g=d.original===o?d.normalized:void 0;return g||(g=`${(0,C.rtrim)(o,R.posix.sep)}${R.posix.sep}`,d={original:o,normalized:g}),(y.isLinux?r.startsWith(g):(0,C.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=p;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const f="\u2026",E="\\\\",w="~";function _(r,o=R.sep){const g=new Array(r.length);let m=!1;for(let S=0;S<r.length;S++){let b=r[S];if(b===""){g[S]=`.${o}`;continue}if(!b){g[S]=b;continue}m=!0;let l="";b.indexOf(E)===0?(l=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(o)===0?(l=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(w)===0&&(l=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length));const L=b.split(o);for(let O=1;m&&O<=L.length;O++)for(let W=L.length-O;m&&W>=0;W--){m=!1;let ie=L.slice(W,W+O).join(o);for(let re=0;!m&&re<r.length;re++)if(re!==S&&r[re]&&r[re].indexOf(ie)>-1){const N=W+O===L.length,V=W>0&&r[re].indexOf(o)>-1?o+ie:ie,x=r[re].endsWith(V);m=!N||x}if(!m){let re="";(L[0].endsWith(":")||l!=="")&&(W===1&&(W=0,O++,ie=L[0]+o+ie),W>0&&(re=L[0]+o),re=l+re),W>0&&(re=re+f+o),re=re+ie,W+O<L.length&&(re=re+o+f),g[S]=re}}m&&(g[S]=b)}return g}e.shorten=_;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(r,o=Object.create(null)){const g=[];let m=!1,S="";for(const b of r)if(b==="$"||m&&b==="{")S&&g.push({value:S,type:u.TEXT}),S="",m=!0;else if(b==="}"&&m){const l=o[S];if(typeof l=="string")l.length&&g.push({value:l,type:u.VARIABLE});else if(l){const L=g[g.length-1];(!L||L.type!==u.SEPARATOR)&&g.push({value:l.label,type:u.SEPARATOR})}S="",m=!1}else S+=b;return S&&!m&&g.push({value:S,type:u.TEXT}),g.filter((b,l)=>{if(b.type===u.SEPARATOR){const L=g[l-1],O=g[l+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=c;function h(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?R.posix:R.win32,g=o.basename(r),m=o.dirname(r);return g.length?{name:g,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(me[99],ge([0,1,2]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class C{constructor(A){this._uriTransformer=A}transformIncoming(A){const d=this._uriTransformer.transformIncoming(A);return d===A?A:R(v.URI.from(d))}transformOutgoing(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:R(v.URI.from(d))}transformOutgoingURI(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:v.URI.from(d)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,A,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return A.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const a=T(i[p],A,d+1);a!==null&&(i[p]=a)}}return null}function y(i,A){const d=T(i,A,0);return d===null?i:d}e.transformOutgoingURIs=y;function I(i,A,d,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?v.URI.revive(A.transformIncoming(i)):A.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const f=I(i[a],A,d,p+1);f!==null&&(i[a]=f)}}return null}function D(i,A){const d=I(i,A,!1,0);return d===null?i:d}e.transformIncomingURIs=D;function P(i,A){const d=I(i,A,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=P}),define(me[32],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return v.test(D)}e.isUUID=R;const C=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function I(){y(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,P="";return P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P+="-",P+=T[C[D++]],P+=T[C[D++]],P+="-",P+=T[C[D++]],P+=T[C[D++]],P+="-",P+=T[C[D++]],P+=T[C[D++]],P+="-",P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P+=T[C[D++]],P}e.generateUuid=I}),define(me[138],ge([0,1,100]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(T="utf8"){this.stringDecoder=new v.StringDecoder(T),this.remaining=null}write(T){const y=[],I=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(I.length<1)return y;let D=0,P,i=D;for(;i<I.length;)if(P=I.charCodeAt(i),P===13||P===10){if(y.push(I.substring(D,i)),i++,i<I.length){const A=P;P=I.charCodeAt(i),(A===13&&P===10||A===10&&P===13)&&i++}D=i}else i++;return this.remaining=D<I.length?I.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,59,101,280,9,13,11,29,32,76,25,2]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(k){k[k.UNLINK=0]="UNLINK",k[k.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function a(k,U=p.UNLINK){if((0,D.isRootOrDriveLetter)(k))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?E(k):f(k)}e.rimraf=a;async function f(k){try{const U=(0,T.join)((0,R.tmpdir)(),(0,P.generateUuid)());try{await x.rename(k,U)}catch(F){return E(k)}E(U).catch(F=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function E(k){return x.rmdir(k,{recursive:!0,maxRetries:3})}function w(k){if((0,D.isRootOrDriveLetter)(k))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(k,{recursive:!0})}e.rimrafSync=w;async function _(k,U){return h(await(U?u(k):x.readdir(k)))}e.readdir=_;async function u(k){try{return await x.readdir(k,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const U=[],F=await _(k);for(const M of F){let $=!1,H=!1,Q=!1;try{const ae=await x.lstat((0,T.join)(k,M));$=ae.isFile(),H=ae.isDirectory(),Q=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}U.push({name:M,isFile:()=>$,isDirectory:()=>H,isSymbolicLink:()=>Q})}return U}function c(k){return h(v.readdirSync(k))}e.readdirSync=c;function h(k){return k.map(U=>typeof U=="string"?I.isMacintosh?(0,i.normalizeNFC)(U):U:(U.name=I.isMacintosh?(0,i.normalizeNFC)(U.name):U.name,U))}async function t(k){const U=await _(k),F=[];for(const M of U)await s.existsDirectory((0,T.join)(k,M))&&F.push(M);return F}e.readDirsInDir=t;function n(k,U=1e3){return new Promise(F=>{let M=!1;const $=setInterval(()=>{M||(M=!0,v.access(k,H=>{M=!1,H&&(clearInterval($),F(void 0))}))},U)})}e.whenDeleted=n;var s;(function(k){async function U($){let H;try{if(H=await x.lstat($),!H.isSymbolicLink())return{stat:H}}catch(Q){}try{return{stat:await x.stat($),symbolicLink:(H==null?void 0:H.isSymbolicLink())?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(I.isWindows&&Q.code==="EACCES")try{return{stat:await x.stat(await x.readlink($)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ae}throw Q}}k.stat=U;async function F($){try{const{stat:H,symbolicLink:Q}=await k.stat($);return H.isFile()&&(Q==null?void 0:Q.dangling)!==!0}catch(H){}return!1}k.existsFile=F;async function M($){try{const{stat:H,symbolicLink:Q}=await k.stat($);return H.isDirectory()&&(Q==null?void 0:Q.dangling)!==!0}catch(H){}return!1}k.existsDirectory=M})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new y.ResourceQueue;function o(k,U,F){return r.queueFor(d.URI.file(k),A.extUriBiasedIgnorePathCase).queue(()=>{const M=b(F);return new Promise(($,H)=>m(k,U,M,Q=>Q?H(Q):$()))})}e.writeFile=o;let g=!0;function m(k,U,F,M){if(!g)return v.writeFile(k,U,{mode:F.mode,flag:F.flag},M);v.open(k,F.flag,F.mode,($,H)=>{if($)return M($);v.writeFile(H,U,Q=>{if(Q)return v.close(H,()=>M(Q));v.fdatasync(H,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),g=!1),v.close(H,we=>M(we))))})})}function S(k,U,F){const M=b(F);if(!g)return v.writeFileSync(k,U,{mode:M.mode,flag:M.flag});const $=v.openSync(k,M.flag,M.mode);try{v.writeFileSync($,U);try{v.fdatasyncSync($)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),g=!1}}finally{v.closeSync($)}}e.writeFileSync=S;function b(k){return k?{mode:typeof k.mode=="number"?k.mode:438,flag:typeof k.flag=="string"?k.flag:"w"}:{mode:438,flag:"w"}}async function l(k,U){if(k===U)return;async function F(M){try{const $=await x.lstat(M);if($.isDirectory()||$.isSymbolicLink())return;await x.utimes(M,$.atime,new Date)}catch($){}}try{await x.rename(k,U),await F(U)}catch(M){if(k.toLowerCase()!==U.toLowerCase()&&M.code==="EXDEV"||k.endsWith("."))await L(k,U,{preserveSymlinks:!1}),await a(k,p.MOVE),await F(U);else throw M}}e.move=l;async function L(k,U,F){return W(k,U,{root:{source:k,target:U},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(k,U,F){if(F.handledSourcePaths.has(k))return;F.handledSourcePaths.add(k);const{stat:M,symbolicLink:$}=await s.stat(k);if($){if(F.options.preserveSymlinks)try{return await N(k,U,F)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if($.dangling)return}return M.isDirectory()?ie(k,U,M.mode&O,F):re(k,U,M.mode&O)}async function ie(k,U,F,M){await x.mkdir(U,{recursive:!0,mode:F});const $=await _(k);for(const H of $)await W((0,T.join)(k,H),(0,T.join)(U,H),M)}async function re(k,U,F){await x.copyFile(k,U),await x.chmod(U,F)}async function N(k,U,F){let M=await x.readlink(k);(0,D.isEqualOrParent)(M,F.root.source,!I.isLinux)&&(M=(0,T.join)(F.root.target,M.substr(F.root.source.length+1))),await x.symlink(M,U)}async function V(k){try{return await x.access(k),!0}catch(U){return!1}}e.exists=V;var x;(function(k){k.access=(0,C.promisify)(v.access),k.stat=(0,C.promisify)(v.stat),k.lstat=(0,C.promisify)(v.lstat),k.utimes=(0,C.promisify)(v.utimes),k.read=(0,C.promisify)(v.read),k.readFile=(0,C.promisify)(v.readFile),k.write=(0,C.promisify)(v.write),k.writeFile=(0,C.promisify)(v.writeFile),k.appendFile=(0,C.promisify)(v.appendFile),k.fdatasync=(0,C.promisify)(v.fdatasync),k.truncate=(0,C.promisify)(v.truncate),k.rename=(0,C.promisify)(v.rename),k.copyFile=(0,C.promisify)(v.copyFile),k.open=(0,C.promisify)(v.open),k.close=(0,C.promisify)(v.close),k.symlink=(0,C.promisify)(v.symlink),k.readlink=(0,C.promisify)(v.readlink),k.chmod=(0,C.promisify)(v.chmod),k.readdir=(0,C.promisify)(v.readdir),k.mkdir=(0,C.promisify)(v.mkdir),k.unlink=(0,C.promisify)(v.unlink),k.rmdir=(0,C.promisify)(v.rmdir),k.realpath=(0,C.promisify)(v.realpath)})(x=e.Promises||(e.Promises={}))}),define(me[102],ge([0,1,59,8,9,28]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function y(i){const A=(0,C.dirname)(i);if(i===A)return i;const d=((0,C.basename)(i)||i).toLowerCase();try{const a=(0,T.readdirSync)(A).filter(f=>f.toLowerCase()===d);if(a.length===1){const f=y(A);if(f)return(0,C.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(d);if(f>=0){const E=y(A);if(E)return(0,C.join)(E,a[f])}}}catch(p){}return null}e.realcaseSync=y;async function I(i){try{return await T.Promises.realpath(i)}catch(A){const d=P(i);return await T.Promises.access(d,v.constants.R_OK),d}}e.realpath=I;function D(i){try{return v.realpathSync(i)}catch(A){const d=P(i);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=D;function P(i){return(0,R.rtrim)((0,C.normalize)(i),C.sep)}});var qe=this&&this.__decorate||function(K,e,v,R){var C=arguments.length,T=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,v,R);else for(var I=K.length-1;I>=0;I--)(y=K[I])&&(T=(C<3?y(T):C>3?y(e,v,T):y(e,v))||T);return C>3&&T&&Object.defineProperty(e,v,T),T};define(me[103],ge([0,1,3,6,13,21,17,23,16,12,58,8,53]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function a(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class _{constructor(M){this.buffer=M,this.pos=0}read(M){const $=this.buffer.slice(this.pos,this.pos+M);return this.pos+=$.byteLength,$}}class u{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function h(F){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=I.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const $=I.VSBuffer.fromString(M);F.write(s.String),F.write(h($.byteLength)),F.write($)}else if(r&&Buffer.isBuffer(M)){const $=I.VSBuffer.wrap(M);F.write(s.Buffer),F.write(h($.byteLength)),F.write($)}else if(M instanceof I.VSBuffer)F.write(s.VSBuffer),F.write(h(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(h(M.length));for(const $ of M)o(F,$)}else{const $=I.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(h($.byteLength)),F.write($)}}function g(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const $=t(F),H=[];for(let Q=0;Q<$;Q++)H.push(g(F));return H}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(M,$,H=null,Q=1e3){this.protocol=M,this.ctx=$,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(M,$){this.channels.set(M,$),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const $=this.send([M.type]);this.logger&&this.logger.logOutgoing($,0,1,E(M.type));return}case 201:case 202:case 204:case 203:{const $=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing($,M.id,1,E(M.type),M.data);return}}}send(M,$=void 0){const H=new u;return o(H,M),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onRawMessage(M){const $=new _(M),H=g($),Q=g($),ae=H[0];switch(ae){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:ae,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:ae,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:H[1]})}}onPromise(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const H=new T.CancellationTokenSource;let Q;try{Q=$.call(this.ctx,M.name,M.arg,H.token)}catch(Le){Q=Promise.reject(Le)}const ae=M.id;Q.then(Le=>{this.sendResponse({id:ae,data:Le,type:201}),this.activeRequests.delete(M.id)},Le=>{Le instanceof Error?this.sendResponse({id:ae,data:{message:Le.message,name:Le.name,stack:Le.stack?Le.stack.split?Le.stack.split(`
`):Le.stack:void 0},type:202}):this.sendResponse({id:ae,data:Le,type:203}),this.activeRequests.delete(M.id)});const we=(0,R.toDisposable)(()=>H.cancel());this.activeRequests.set(M.id,we)}onEventListen(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const H=M.id,ae=$.listen(this.ctx,M.name,M.arg)(we=>this.sendResponse({id:H,data:we,type:204}));this.activeRequests.set(M.id,ae)}disposeActiveRequest(M){const $=this.activeRequests.get(M.id);$&&($.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let $=this.pendingRequests.get(M.channelName);$||($=[],this.pendingRequests.set(M.channelName,$));const H=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:M,timeoutTimer:H})}flushPendingRequests(M){const $=this.pendingRequests.get(M);if($){for(const H of $)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,$=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=$}getChannel(M){const $=this;return{call(H,Q,ae){return $.isDisposed?Promise.reject(y.canceled()):$.requestPromise(M,H,Q,ae)},listen(H,Q){return $.isDisposed?Promise.reject(y.canceled()):$.requestEvent(M,H,Q)}}}requestPromise(M,$,H,Q=T.CancellationToken.None){const ae=this.lastRequestId++,Le={id:ae,type:100,channelName:M,name:$,arg:H};if(Q.isCancellationRequested)return Promise.reject(y.canceled());let Ie;return new Promise((We,j)=>{if(Q.isCancellationRequested)return j(y.canceled());const X=()=>{const Se=ce=>{switch(ce.type){case 201:this.handlers.delete(ae),We(ce.data);break;case 202:this.handlers.delete(ae);const _e=new Error(ce.data.message);_e.stack=ce.data.stack,_e.name=ce.data.name,j(_e);break;case 203:this.handlers.delete(ae),j(ce.data);break}};this.handlers.set(ae,Se),this.sendRequest(Le)};let ee=null;this.state===w.Idle?X():(ee=(0,C.createCancelablePromise)(Se=>this.whenInitialized()),ee.then(()=>{ee=null,X()}));const oe=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:ae,type:101}),j(y.canceled())},pe=Q.onCancellationRequested(oe);Ie=(0,R.combinedDisposable)((0,R.toDisposable)(oe),pe),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(M,$,H){const Q=this.lastRequestId++,we={id:Q,type:102,channelName:M,name:$,arg:H};let Le=null;const Ie=new v.Emitter({onFirstListenerAdd:()=>{Le=(0,C.createCancelablePromise)(We=>this.whenInitialized()),Le.then(()=>{Le=null,this.activeRequests.add(Ie),this.sendRequest(we)})},onLastListenerRemove:()=>{Le?(Le.cancel(),Le=null):(this.activeRequests.delete(Ie),this.sendRequest({id:Q,type:103}))}}),Oe=We=>Ie.fire(We.data);return this.handlers.set(Q,Oe),Ie.event}sendRequest(M){switch(M.type){case 100:case 102:{const $=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing($,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing($,M.id,0,a(M.type));return}}}send(M,$=void 0){const H=new u;return o(H,M),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onBuffer(M){const $=new _(M),H=g($),Q=g($),ae=H[0];switch(ae){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,E(ae)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],0,E(ae),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(M.id);$&&$(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([d.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class l{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:$,onDidClientDisconnect:H})=>{v.Event.once($.onMessage)(ae=>{const we=new _(ae),Le=g(we),Ie=new m($,Le),Oe=new b($);this.channels.forEach((j,X)=>Ie.registerChannel(X,j));const We={channelServer:Ie,channelClient:Oe,ctx:Le};this._connections.add(We),this._onDidAddConnection.fire(We),H(()=>{Ie.dispose(),Oe.dispose(),this._connections.delete(We),this._onDidRemoveConnection.fire(We)})})})}get connections(){const M=[];return this._connections.forEach($=>M.push($)),M}getChannel(M,$){const H=this;return{call(Q,ae,we){let Le;if((0,P.isFunction)($)){let Oe=(0,D.getRandomElement)(H.connections.filter($));Le=Oe?Promise.resolve(Oe):v.Event.toPromise(v.Event.filter(H.onDidAddConnection,$))}else Le=$.routeCall(H,Q,ae);const Ie=Le.then(Oe=>Oe.channelClient.getChannel(M));return O(Ie).call(Q,ae,we)},listen(Q,ae){if((0,P.isFunction)($))return H.getMulticastEvent(M,$,Q,ae);const we=$.routeEvent(H,Q,ae).then(Le=>Le.channelClient.getChannel(M));return O(we).listen(Q,ae)}}}getMulticastEvent(M,$,H,Q){const ae=this;let we=new R.DisposableStore;const Le=new v.Emitter({onFirstListenerAdd:()=>{we=new R.DisposableStore;const Ie=new v.EventMultiplexer,Oe=new Map,We=X=>{const oe=X.channelClient.getChannel(M).listen(H,Q),pe=Ie.add(oe);Oe.set(X,pe)},j=X=>{const ee=Oe.get(X);!ee||(ee.dispose(),Oe.delete(X))};ae.connections.filter($).forEach(We),v.Event.filter(ae.onDidAddConnection,$)(We,void 0,we),ae.onDidRemoveConnection(j,void 0,we),Ie.event(Le.fire,Le,we),we.add(Ie)},onLastListenerRemove:()=>{we.dispose()}});return Le.event}registerChannel(M,$){this.channels.set(M,$),this._connections.forEach(H=>{H.channelServer.registerChannel(M,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class L{constructor(M,$,H=null){const Q=new u;o(Q,$),M.send(Q.buffer),this.channelClient=new b(M,H),this.channelServer=new m(M,$,H)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,$){this.channelServer.registerChannel(M,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,$,H){return F.then(Q=>Q.call(M,$,H))},listen(M,$){const H=new v.Relay;return F.then(Q=>H.input=Q.listen(M,$)),H.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call($,H,Q){return M?F.call($,H,Q):(0,C.timeout)(0).then(()=>M=!0).then(()=>F.call($,H,Q))},listen($,H){if(M)return F.listen($,H);const Q=new v.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>Q.input=F.listen($,H)),Q.event}}}e.getNextTickChannel=W;class ie{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const $ of M.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ie;var re;(function(F){function M(Q,ae){const we=Q,Le=ae&&ae.disableMarshalling,Ie=new Map;for(const Oe in we)H(Oe)&&Ie.set(Oe,v.Event.buffer(we[Oe],!0));return new class{listen(Oe,We){const j=Ie.get(We);if(j)return j;throw new Error(`Event not found: ${We}`)}call(Oe,We,j){const X=we[We];if(typeof X=="function"){if(!Le&&Array.isArray(j))for(let ee=0;ee<j.length;ee++)j[ee]=(0,i.revive)(j[ee]);return X.apply(we,j)}throw new Error(`Method not found: ${We}`)}}}F.fromService=M;function $(Q,ae){const we=ae&&ae.disableMarshalling;return new Proxy({},{get(Le,Ie){var Oe;if(typeof Ie=="string")return((Oe=ae==null?void 0:ae.properties)===null||Oe===void 0?void 0:Oe.has(Ie))?ae.properties.get(Ie):H(Ie)?Q.listen(Ie):async function(...We){let j;ae&&!(0,P.isUndefinedOrNull)(ae.context)?j=[ae.context,...We]:j=We;const X=await Q.call(Ie,j);return we?X:(0,i.revive)(X)};throw new Error(`Property not found: ${String(Ie)}`)}})}F.toService=$;function H(Q){return Q[0]==="o"&&Q[1]==="n"&&A.isUpperAsciiLetter(Q.charCodeAt(2))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function x(F){return Array.isArray(F)?F.map(V):V(F)}function k(F,M,$,H,Q,ae,we){we=x(we);const Le=N[Q],Ie=Le[H%Le.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(ae)?(Oe=Oe.concat(we),Oe.push(")")):Oe.push(we),console.log.apply(console,Oe)}e.logWithColors=k;class U{constructor(M,$){this._outgoingPrefix=M,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,$,H,Q,ae){this._totalOutgoing+=M,k(this._outgoingPrefix,this._totalOutgoing,M,$,H,Q,ae)}logIncoming(M,$,H,Q,ae){this._totalIncoming+=M,k(this._incomingPrefix,this._totalIncoming,M,$,H,Q,ae)}}e.IPCLogger=U}),define(me[104],ge([0,1,3,103,6,23,11,36]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=T.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const S=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),S}if(this._chunks[0].byteLength>s){const S=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),S}let o=T.VSBuffer.alloc(s),g=0,m=0;for(;s>0;){const S=this._chunks[m];if(S.byteLength>s){const b=S.slice(0,s);o.set(b,g),g+=s,r&&(this._chunks[m]=S.slice(s),this._totalLength-=s),s-=s}else o.set(S,g),g+=S.byteLength,r?(this._chunks.shift(),this._totalLength-=S.byteLength):m++,s-=S.byteLength}return o}}e.ChunkStream=i;var A;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(A||(A={}));var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,r,o,g){this.type=s,this.id=r,this.ack=o,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends C.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,g=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(o,g,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=T.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends C.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=E;class w extends R.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new w(new E(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class u{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new u(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class h{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<h._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=h._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const s=Date.now(),r=(1+h._HISTORY_LENGTH)*1e3;let o=0;for(let g=0;g<h._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=r&&o++;return 1-o/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=h.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new p(4,0,0,P());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,g=r.length;o<g;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new p(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(me[105],ge([0,1,94]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(I){let D=(0,v.toUint8)(I);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(I){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=I;return D}set(I,D){let P=(0,v.toUint8)(D);I>=0&&I<256?this._asciiMap[I]=P:this._map.set(I,P)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class T{constructor(){this._actual=new R(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=T}),define(me[139],ge([0,1,105]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends v.CharacterClassifier{constructor(I){super(0);for(let D=0,P=I.length;D<P;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function T(y){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=y(D)),I[D])}e.getMapForWordSeparators=T(y=>new C(y))}),define(me[46],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(C,T){this.lineNumber=C,this.column=T}with(C=this.lineNumber,T=this.column){return C===this.lineNumber&&T===this.column?this:new v(C,T)}delta(C=0,T=0){return this.with(this.lineNumber+C,this.column+T)}equals(C){return v.equals(this,C)}static equals(C,T){return!C&&!T?!0:!!C&&!!T&&C.lineNumber===T.lineNumber&&C.column===T.column}isBefore(C){return v.isBefore(this,C)}static isBefore(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<T.column}isBeforeOrEqual(C){return v.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<=T.column}static compare(C,T){let y=C.lineNumber|0,I=T.lineNumber|0;if(y===I){let D=C.column|0,P=T.column|0;return D-P}return y-I}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new v(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=v}),define(me[42],ge([0,1,46]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,y,I,D){T>I||T===I&&y>D?(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=I,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,y){let I,D,P,i;return y.startLineNumber<T.startLineNumber?(I=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(I=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(I=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(P=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(P=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(P=T.endLineNumber,i=T.endColumn),new R(I,D,P,i)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,y){let I=T.startLineNumber,D=T.startColumn,P=T.endLineNumber,i=T.endColumn,A=y.startLineNumber,d=y.startColumn,p=y.endLineNumber,a=y.endColumn;return I<A?(I=A,D=d):I===A&&(D=Math.max(D,d)),P>p?(P=p,i=a):P===p&&(i=Math.min(i,a)),I>P||I===P&&D>i?null:new R(I,D,P,i)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new v.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new v.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new R(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new R(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new R(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const P=T.startLineNumber|0,i=y.startLineNumber|0;if(P===i){const A=T.startColumn|0,d=y.startColumn|0;if(A===d){const p=T.endLineNumber|0,a=y.endLineNumber|0;if(p===a){const f=T.endColumn|0,E=y.endColumn|0;return f-E}return p-a}return A-d}return P-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(me[140],ge([0,1,46,42]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(I,D,P,i){super(I,D,P,i);this.selectionStartLineNumber=I,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return T.selectionsEqual(this,I)}static selectionsEqual(I,D){return I.selectionStartLineNumber===D.selectionStartLineNumber&&I.selectionStartColumn===D.selectionStartColumn&&I.positionLineNumber===D.positionLineNumber&&I.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,I,D):new T(I,D,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,D){return this.getDirection()===0?new T(I,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,I,D)}static fromPositions(I,D=I){return new T(I.lineNumber,I.column,D.lineNumber,D.column)}static liftSelection(I){return new T(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,D){if(I&&!D||!I&&D)return!1;if(!I&&!D)return!0;if(I.length!==D.length)return!1;for(let P=0,i=I.length;P<i;P++)if(!this.selectionsEqual(I[P],D[P]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,D,P,i,A){return A===0?new T(I,D,P,i):new T(P,i,I,D)}}e.Selection=T}),define(me[106],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(f){this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace)}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class D{constructor(f,E){this.range=f,this.matches=E}}e.FindMatch=D;var P;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var A;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class d{constructor(f,E,w,_,u,c){this.identifier=f,this.range=E,this.text=w,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.ValidAnnotatedEditOperation=d;class p{constructor(f,E,w){this.reverseEdits=f,this.changes=E,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=p}),define(me[141],ge([0,1,8,139,46,42,106]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(u,c,h,t){this.searchString=u,this.isRegex=c,this.matchCase=h,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let h=!this.isRegex&&!u;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new i(c,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=D;function P(_){if(!_||_.length===0)return!1;for(let u=0,c=_.length;u<c;u++)if(_.charCodeAt(u)===92){if(u++,u>=c)break;const t=_.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class i{constructor(u,c,h){this.regex=u,this.wordSeparators=c,this.simpleSearch=h}}e.SearchData=i;function A(_,u,c){if(!c)return new y.FindMatch(_,null);let h=[];for(let t=0,n=u.length;t<n;t++)h[t]=u[t];return new y.FindMatch(_,h)}e.createFindMatch=A;class d{constructor(u){let c=[],h=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(c[h++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let h=0,t=c.length-1;if(t===-1||u<=c[0])return 0;for(;h<t;){const n=h+((t-h)/2>>0);c[n]>=u?t=n-1:c[n+1]>=u?(h=n,t=n):h=n+1}return h+1}}class p{static findMatches(u,c,h,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,h,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(u,h,s,t,n):[]}static _getMultilineMatchRange(u,c,h,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=c+n+o):r=c+n;let g;if(t){let l=t.findLineFeedCountBeforeOffset(n+s.length)-o;g=r+s.length+l}else g=r+s.length;const m=u.getPositionAt(r),S=u.getPositionAt(g);return new T.Range(m.lineNumber,m.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(u,c,h,t,n){const s=u.getOffsetAt(c.getStartPosition()),r=u.getValueInRange(c,1),o=u.getEOL()===`\r
`?new d(r):null,g=[];let m=0,S;for(h.reset(0);S=h.next(r);)if(g[m++]=A(this._getMultilineMatchRange(u,s,r,o,S.index,S[0]),S,t),m>=n)return g;return g}static _doFindMatchesLineByLine(u,c,h,t,n){const s=[];let r=0;if(c.startLineNumber===c.endLineNumber){const g=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(h,g,c.startLineNumber,c.startColumn-1,r,s,t,n),s}const o=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(h,o,c.startLineNumber,c.startColumn-1,r,s,t,n);for(let g=c.startLineNumber+1;g<c.endLineNumber&&r<n;g++)r=this._findMatchesInLine(h,u.getLineContent(g),g,0,r,s,t,n);if(r<n){const g=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(h,g,c.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(u,c,h,t,n,s,r,o){const g=u.wordSeparators;if(!r&&u.simpleSearch){const b=u.simpleSearch,l=b.length,L=c.length;let O=-l;for(;(O=c.indexOf(b,O+l))!==-1;)if((!g||E(g,c,L,O,l))&&(s[n++]=new y.FindMatch(new T.Range(h,O+1+t,h,O+1+l+t),null),n>=o))return n;return n}const m=new w(u.wordSeparators,u.regex);let S;m.reset(0);do if(S=m.next(c),S&&(s[n++]=A(new T.Range(h,S.index+1+t,h,S.index+1+S[0].length+t),S,r),n>=o))return n;while(S);return n}static findNextMatch(u,c,h,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,h,s,t):this._doFindNextMatchLineByLine(u,h,s,t)}static _doFindNextMatchMultiline(u,c,h,t){const n=new C.Position(c.lineNumber,1),s=u.getOffsetAt(n),r=u.getLineCount(),o=u.getValueInRange(new T.Range(n.lineNumber,n.column,r,u.getLineMaxColumn(r)),1),g=u.getEOL()===`\r
`?new d(o):null;h.reset(c.column-1);let m=h.next(o);return m?A(this._getMultilineMatchRange(u,s,o,g,m.index,m[0]),m,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new C.Position(1,1),h,t):null}static _doFindNextMatchLineByLine(u,c,h,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s),o=this._findFirstMatchInLine(h,r,s,c.column,t);if(o)return o;for(let g=1;g<=n;g++){const m=(s+g-1)%n,S=u.getLineContent(m+1),b=this._findFirstMatchInLine(h,S,m+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(u,c,h,t,n){u.reset(t-1);const s=u.next(c);return s?A(new T.Range(h,s.index+1,h,s.index+1+s[0].length),s,n):null}static findPreviousMatch(u,c,h,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,h,s,t):this._doFindPreviousMatchLineByLine(u,h,s,t)}static _doFindPreviousMatchMultiline(u,c,h,t){const n=this._doFindMatchesMultiline(u,new T.Range(1,1,c.lineNumber,c.column),h,t,10*I);if(n.length>0)return n[n.length-1];const s=u.getLineCount();return c.lineNumber!==s||c.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new C.Position(s,u.getLineMaxColumn(s)),h,t):null}static _doFindPreviousMatchLineByLine(u,c,h,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s).substring(0,c.column-1),o=this._findLastMatchInLine(h,r,s,t);if(o)return o;for(let g=1;g<=n;g++){const m=(n+s-g-1)%n,S=u.getLineContent(m+1),b=this._findLastMatchInLine(h,S,m+1,t);if(b)return b}return null}static _findLastMatchInLine(u,c,h,t){let n=null,s;for(u.reset(0);s=u.next(c);)n=A(new T.Range(h,s.index+1,h,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=p;function a(_,u,c,h,t){if(h===0)return!0;const n=u.charCodeAt(h-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(h);if(_.get(s)!==0)return!0}return!1}function f(_,u,c,h,t){if(h+t===c)return!0;const n=u.charCodeAt(h+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(h+t-1);if(_.get(s)!==0)return!0}return!1}function E(_,u,c,h,t){return a(_,u,c,h,t)&&f(_,u,c,h,t)}e.isValidMatch=E;class w{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(h=this._searchRegex.exec(u),!h))return null;const t=h.index,n=h[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,u,c,t,n))return h}while(h);return null}}e.Searcher=w}),define(me[107],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(I=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)I.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=v();function R(I){let D=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)D=I;else{let P="g";I.ignoreCase&&(P+="i"),I.multiline&&(P+="m"),I.unicode&&(P+="u"),D=new RegExp(I.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function T(I,D,P,i,A=C){if(P.length>A.maxLen){let E=I-A.maxLen/2;return E<0?E=0:i+=E,P=P.substring(E,I+A.maxLen/2),T(I,D,P,i,A)}const d=Date.now(),p=I-1-i;let a=-1,f=null;for(let E=1;!(Date.now()-d>=A.timeBudget);E++){const w=p-A.windowSize*E;D.lastIndex=Math.max(0,w);const _=y(D,P,p,a);if(!_&&f||(f=_,w<=0))break;a=w}if(f){let E={word:f[0],startColumn:i+1+f.index,endColumn:i+1+f.index+f[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=T;function y(I,D,P,i){let A;for(;A=I.exec(D);){const d=A.index||0;if(d<=P&&I.lastIndex>=P)return A;if(i>0&&d>i)return null}return null}}),define(me[142],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,P=I.notIn.length;D<P;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function T(y,I,D){y.has(I)?y.get(I).push(D):y.set(I,[D])}}),define(me[78],ge([0,1,31,9]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(T,y,I,D){if(Array.isArray(T)){let P=0;for(const i of T){const A=C(i,y,I,D);if(A===10)return A;A>P&&(P=A)}return P}else{if(typeof T=="string")return D?T==="*"?5:T===I?10:0:0;if(T){const{language:P,pattern:i,scheme:A,hasAccessToAllModels:d}=T;if(!D&&!d)return 0;let p=0;if(A)if(A===y.scheme)p=10;else if(A==="*")p=5;else return 0;if(P)if(P===I)p=10;else if(P==="*")p=Math.max(p,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a=Object.assign(Object.assign({},i),{base:(0,R.normalize)(i.base)}),a===y.fsPath||(0,v.match)(a,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(me[143],ge([0,1,105]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(a,f,E){const w=new Uint8Array(a*f);for(let _=0,u=a*f;_<u;_++)w[_]=E;this._data=w,this.rows=a,this.cols=f}get(a,f){return this._data[a*this.cols+f]}set(a,f,E){this._data[a*this.cols+f]=E}}e.Uint8Matrix=C;class T{constructor(a){let f=0,E=0;for(let _=0,u=a.length;_<u;_++){let[c,h,t]=a[_];h>f&&(f=h),c>E&&(E=c),t>E&&(E=t)}f++,E++;let w=new C(E,f,0);for(let _=0,u=a.length;_<u;_++){let[c,h,t]=a[_];w.set(c,h,t)}this._states=w,this._maxCharCode=f}nextState(a,f){return f<0||f>=this._maxCharCode?0:this._states.get(a,f)}}e.StateMachine=T;let y=null;function I(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function i(){if(P===null){P=new v.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<p.length;f++)P.set(p.charCodeAt(f),1);const a=".,;";for(let f=0;f<a.length;f++)P.set(a.charCodeAt(f),2)}return P}class A{static _createLink(a,f,E,w,_){let u=_-1;do{const c=f.charCodeAt(u);if(a.get(c)!==2)break;u--}while(u>w);if(w>0){const c=f.charCodeAt(w-1),h=f.charCodeAt(u);(c===40&&h===41||c===91&&h===93||c===123&&h===125)&&u--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:u+2},url:f.substring(w,u+1)}}static computeLinks(a,f=I()){const E=i();let w=[];for(let _=1,u=a.getLineCount();_<=u;_++){const c=a.getLineContent(_),h=c.length;let t=0,n=0,s=0,r=1,o=!1,g=!1,m=!1,S=!1;for(;t<h;){let b=!1;const l=c.charCodeAt(t);if(r===13){let L;switch(l){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:m=!0,g=!0,L=0;break;case 93:m=!1,L=g?0:1;break;case 123:S=!0,L=0;break;case 125:L=S?0:1;break;case 39:L=s===34||s===96?0:1;break;case 34:L=s===39||s===96?0:1;break;case 96:L=s===39||s===34?0:1;break;case 42:L=s===42?1:0;break;case 124:L=s===124?1:0;break;case 32:L=m?0:1;break;default:L=E.get(l)}L===1&&(w.push(A._createLink(E,c,_,n,t)),b=!0)}else if(r===12){let L;l===91?(g=!0,L=0):L=E.get(l),L===1?b=!0:r=13}else r=f.nextState(r,l),r===0&&(b=!0);b&&(r=1,o=!1,g=!1,S=!1,n=t+1,s=l),t++}r===13&&w.push(A._createLink(E,c,_,n,h))}return w}}e.LinkComputer=A;function d(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:A.computeLinks(p)}e.computeLinks=d}),define(me[144],ge([0,1,3,6]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,I){return this._map.set(y,I),this.fire([y]),(0,R.toDisposable)(()=>{this._map.get(y)===I&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,I){let D=null,P=!1;return this._promises.set(y,I.then(i=>{this._promises.delete(y),!(P||!i)&&(D=this.register(y,i))})),(0,R.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(y){const I=this.get(y);if(I)return Promise.resolve(I);const D=this._promises.get(y);return D?D.then(P=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(me[108],ge([0,1,23,11]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(C||(C={}));function T(A){for(let d=0,p=A.length;d<p;d+=4){const a=A[d+0],f=A[d+1],E=A[d+2],w=A[d+3];A[d+0]=w,A[d+1]=E,A[d+2]=f,A[d+3]=a}}function y(A){const d=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return R.isLittleEndian()||T(d),v.VSBuffer.wrap(d)}function I(A){const d=A.buffer;if(R.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const p=new Uint8Array(d.byteLength);return p.set(d),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(A){const d=new Uint32Array(P(A));let p=0;if(d[p++]=A.id,A.type==="full")d[p++]=1,d[p++]=A.data.length,d.set(A.data,p),p+=A.data.length;else{d[p++]=2,d[p++]=A.deltas.length;for(const a of A.deltas)d[p++]=a.start,d[p++]=a.deleteCount,a.data?(d[p++]=a.data.length,d.set(a.data,p),p+=a.data.length):d[p++]=0}return y(d)}e.encodeSemanticTokensDto=D;function P(A){let d=0;if(d+=1+1,A.type==="full")d+=1+A.data.length;else{d+=1,d+=(1+1+1)*A.deltas.length;for(const p of A.deltas)p.data&&(d+=p.data.length)}return d}function i(A){const d=I(A);let p=0;const a=d[p++];if(d[p++]===1){const _=d[p++],u=d.subarray(p,p+_);return p+=_,{id:a,type:"full",data:u}}const E=d[p++];let w=[];for(let _=0;_<E;_++){const u=d[p++],c=d[p++],h=d[p++];let t;h>0&&(t=d.subarray(p,p+h),p+=h),w[_]={start:u,deleteCount:c,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(me[109],ge([0,1,94]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(y,I){this.index=y,this.remainder=I}}e.PrefixSumIndexOfResult=R;class C{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,I){y=(0,v.toUint32)(y);const D=this.values,P=this.prefixSum,i=I.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(I,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,I){return y=(0,v.toUint32)(y),I=(0,v.toUint32)(I),this.values[y]===I?!1:(this.values[y]=I,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,I){y=(0,v.toUint32)(y),I=(0,v.toUint32)(I);const D=this.values,P=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return I>=i&&(I=i),I===0?!1:(this.values=new Uint32Array(D.length-I),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+I),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,v.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),y>=this.values.length&&(y=this.values.length-1);for(let D=I;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let I=0,D=this.values.length-1,P=0,i=0,A=0;for(;I<=D;)if(P=I+(D-I)/2|0,i=this.prefixSum[P],A=i-this.values[P],y<A)D=P-1;else if(y>=i)I=P+1;else break;return new R(P,y-A)}}e.PrefixSumComputer=C}),define(me[145],ge([0,1,8,46,109]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(I,D,P,i){this._uri=I,this._lines=D,this._eol=P,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const D=I.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new R.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let i=0;i<D;i++)P[i]=this._lines[i].length+I;this._lineStarts=new C.PrefixSumComputer(P)}}_setLineText(I,D){this._lines[I]=D,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,D){if(D.length===0)return;let P=(0,v.splitLines)(D);if(P.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}P[P.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]);let i=new Uint32Array(P.length-1);for(let A=1;A<P.length;A++)this._lines.splice(I.lineNumber+A-1,0,P[A]),i[A-1]=P[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,i)}}e.MirrorTextModel=T}),define(me[146],ge([18,19]),function(K,e){return K.create("vs/base/common/date",e)}),define(me[147],ge([0,1,146]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,T=C*24,y=T*7,I=T*30,D=T*365;function P(A,d){typeof A!="number"&&(A=A.getTime());const p=Math.round((new Date().getTime()-A)/1e3);if(p<-30)return(0,v.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let a;return p<R?(a=p,d?a===1?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):a===1?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a)):p<C?(a=Math.floor(p/R),d?a===1?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):a===1?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):p<T?(a=Math.floor(p/C),d?a===1?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):a===1?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a)):p<y?(a=Math.floor(p/T),d?a===1?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):a===1?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):p<I?(a=Math.floor(p/y),d?a===1?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):a===1?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a)):p<D?(a=Math.floor(p/I),d?a===1?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):a===1?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):(a=Math.floor(p/D),d?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a))}e.fromNow=P;function i(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[148],ge([18,19]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,148,12,16]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(P,i){return i&&(P.stack||P.stacktrace)?v.localize(0,null,I(P),y(P.stack)||y(P.stacktrace)):I(P)}function y(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?v.localize(1,null,P.message):P.message||v.localize(2,null)}function D(P=null,i=!1){if(!P)return v.localize(3,null);if(Array.isArray(P)){const A=C.coalesce(P),d=D(A[0],i);return A.length>1?v.localize(4,null,d,A.length):d}if(R.isString(P))return P;if(P.detail){const A=P.detail;if(A.error)return T(A.error,i);if(A.exception)return T(A.exception,i)}return P.stack?T(P,i):P.message?P.message:v.localize(5,null)}e.toErrorMessage=D}),define(me[149],ge([18,19]),function(K,e){return K.create("vs/base/node/processes",e)}),define(me[110],ge([0,1,9,28,37,149,36,12,24,29,11,138,10]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(c,h){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};h&&(t.cwd=h);const n=C.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(s=>{n.once("error",r=>{s({success:!1,error:r})}),n.once("exit",(r,o)=>{s(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{C.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,r,o)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function f(c=y.env){return c.comspec||"cmd.exe"}e.getWindowsShell=f;class E{constructor(h,t,n,s){if(t!==void 0&&n!==void 0&&s!==void 0)this.cmd=h,this.args=t,this.shell=n,this.options=s;else{const r=h;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(o=>{r[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let h=this.cmd.toLowerCase();const t=h.lastIndexOf(v.sep);return t!==-1&&(h=h.substring(t+1)),E.WellKnowCommands[h]?h:"other"}start(h){return i.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(y.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(t=>{let n,s;const r=new Promise((o,g)=>{n=o,s=g});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(g,m,S)=>{this.childProcess=null;const b=g;b&&b.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:S.toString()}):this.handleExec(n,h,g,m,S)})}else{let o=null;const g=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,n,h,s);const S={terminated:this.terminateRequested};I.isNumber(m)&&(S.cmdCode=m),n(S)};if(this.shell&&i.isWindows){const m=D.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let S=!1,b=!1;const l=[];let L=this.ensureQuotes(this.cmd);l.push(L.value),S=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),l.push(L.value),b=b&&L.quoted});const O=["/s","/c"];S?b?O.push('"'+l.join(" ")+'"'):l.length>1?O.push('"'+l[0]+'" '+l.slice(1).join(" ")):O.push('"'+l[0]+'"'):O.push(l.join(" ")),o=C.spawn(f(),O,m)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(I.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",g),this.handleSpawn(o,n,h,s,!0)))}return r})}handleClose(h,t,n,s){}ensureQuotes(h){return E.regexp.test(h)?{value:'"'+h+'"',quoted:!0}:{value:h,quoted:h.length>0&&h[0]==='"'&&h[h.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(h=>h.pid,h=>-1):new Promise(h=>{this.pidResolve=h})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(h=>(this.terminateRequested=!0,a(h,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),h=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(h=>{if(!this.shell||!i.isWindows)return h(!1);const t=C.spawn(f(),["/s","/c"]);t.on("error",n=>h(!0)),t.on("exit",n=>h(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class w extends E{constructor(h,t,n,s){super(h,t,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(h,t,n,s,r){[s,r].forEach((o,g)=>{const m=new A.LineDecoder;m.write(o).forEach(l=>{t({line:l,source:g===0?0:1})});const b=m.end();b&&t({line:b,source:g===0?0:1})}),h({terminated:this.terminateRequested,error:n})}handleSpawn(h,t,n,s,r){const o=new A.LineDecoder,g=new A.LineDecoder;h.stdout.on("data",m=>{o.write(m).forEach(b=>n({line:b,source:0}))}),h.stderr.on("data",m=>{g.write(m).forEach(b=>n({line:b,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=g}handleClose(h,t,n,s){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=w;function _(c){let h=[],t=!1;const n=function(s){if(t){h.push(s);return}(!c.send(s,o=>{if(o&&console.error(o),t=!1,h.length>0){const g=h.slice(0);h=[],g.forEach(m=>n(m))}})||i.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=_;var u;(function(c){async function h(t,n,s){if(v.isAbsolute(t))return t;if(n===void 0&&(n=y.cwd()),v.dirname(t)!=="."||(s===void 0&&I.isString(y.env.PATH)&&(s=y.env.PATH.split(v.delimiter)),s===void 0||s.length===0))return v.join(n,t);async function o(g){return await R.exists(g)?!(await R.Promises.stat(g)).isDirectory():!1}for(let g of s){let m;if(v.isAbsolute(g)?m=v.join(g,t):m=v.join(n,g,t),await o(m))return m;let S=m+".com";if(await o(S)||(S=m+".exe",await o(S)))return S}return v.join(n,t)}c.findExecutable=h})(u=e.win32||(e.win32={}))}),define(me[150],ge([18,19]),function(K,e){return K.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,11,107]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class I{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ve){this._values[ne]=ve}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(ne,ve,xe,je){this.id=ne,this.name=ve,this.defaultValue=xe,this.schema=je}compute(ne,ve,xe){return xe}}class i{constructor(ne,ve=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ne){return this.defaultValue}}class A{constructor(ne,ve,xe,je){this.id=ne,this.name=ve,this.defaultValue=xe,this.schema=je}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ve,xe){return xe}}function d(G,ne){return typeof G=="undefined"?ne:G==="false"?!1:Boolean(G)}e.boolean=d;class p extends A{constructor(ne,ve,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(ne,ve,xe,je)}validate(ne){return d(ne,this.defaultValue)}}class a extends A{constructor(ne,ve,xe,je,ze,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=xe,Xe.minimum=je,Xe.maximum=ze),super(ne,ve,xe,Xe),this.minimum=je,this.maximum=ze}static clampedInt(ne,ve,xe,je){if(typeof ne=="undefined")return ve;let ze=parseInt(ne,10);return isNaN(ze)?ve:(ze=Math.max(xe,ze),ze=Math.min(je,ze),ze|0)}validate(ne){return a.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class f extends A{constructor(ne,ve,xe,je,ze){typeof ze!="undefined"&&(ze.type="number",ze.default=xe),super(ne,ve,xe,ze),this.validationFn=je}static clamp(ne,ve,xe){return ne<ve?ve:ne>xe?xe:ne}static float(ne,ve){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ve;const xe=parseFloat(ne);return isNaN(xe)?ve:xe}validate(ne){return this.validationFn(f.float(ne,this.defaultValue))}}class E extends A{static string(ne,ve){return typeof ne!="string"?ve:ne}constructor(ne,ve,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(ne,ve,xe,je)}validate(ne){return E.string(ne,this.defaultValue)}}function w(G,ne,ve){return typeof G!="string"||ve.indexOf(G)===-1?ne:G}e.stringSet=w;class _ extends A{constructor(ne,ve,xe,je,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=je,ze.default=xe),super(ne,ve,xe,ze),this._allowedValues=je}validate(ne){return w(ne,this.defaultValue,this._allowedValues)}}class u extends P{constructor(ne,ve,xe,je,ze,Xe,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=ze,Ce.default=je),super(ne,ve,xe,Ce),this._allowedValues=ze,this._convert=Xe}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function c(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ve,xe){return xe===0?ne.accessibilitySupport:xe}}class t extends P{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(G){switch(G){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function g(G){switch(G){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class m extends i{constructor(){super(124,[62,31])}compute(ne,ve,xe){const je=["monaco-editor"];return ve.get(31)&&je.push(ve.get(31)),ne.extraEditorClassName&&je.push(ne.extraEditorClassName),ve.get(62)==="default"?je.push("mouse-default"):ve.get(62)==="copy"&&je.push("mouse-copy"),ve.get(97)&&je.push("showUnused"),ve.get(122)&&je.push("showDeprecated"),je.join(" ")}}class S extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ne,ve,xe){return xe&&ne.emptySelectionClipboard}}class b extends P{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:v.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class l extends P{constructor(){super(41,"fontLigatures",l.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?l.OFF:ne==="true"?l.ON:ne:Boolean(ne)?l.ON:l.OFF}}e.EditorFontLigatures=l,l.OFF='"liga" off, "calt" off',l.ON='"liga" on, "calt" on';class L extends i{constructor(){super(40)}compute(ne,ve,xe){return ne.fontInfo}}class O extends A{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(ne){let ve=f.float(ne,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ve,6,100)}compute(ne,ve,xe){return ne.fontInfo.fontSize}}class W extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(a.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ie extends P{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:xe,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:xe,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:xe,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:xe,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:xe,description:v.localize(35,null)}})}validate(ne){var ve,xe,je,ze,Xe;if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=Ce.multipleDefinitions)!==null&&ve!==void 0?ve:w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=Ce.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=Ce.multipleDeclarations)!==null&&je!==void 0?je:w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(ze=Ce.multipleImplementations)!==null&&ze!==void 0?ze:w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=Ce.multipleReferences)!==null&&Xe!==void 0?Xe:w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class re extends P{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:v.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:a.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var N;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ne,ve,xe){return V.computeLayout(ve,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ve=ne.height/ne.lineHeight,xe=ne.scrollBeyondLastLine?ve-1:0,je=(ne.viewLineCount+xe)/(ne.pixelRatio*ne.height),ze=Math.floor(ne.viewLineCount/je);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:ze}}static _computeMinimapLayout(ne,ve){const xe=ne.outerWidth,je=ne.outerHeight,ze=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Xe=ve.stableMinimapLayoutInput,Ce=Xe&&ne.outerHeight===Xe.outerHeight&&ne.lineHeight===Xe.lineHeight&&ne.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Xe.pixelRatio&&ne.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ne.minimap.enabled===Xe.minimap.enabled&&ne.minimap.side===Xe.minimap.side&&ne.minimap.size===Xe.minimap.size&&ne.minimap.showSlider===Xe.minimap.showSlider&&ne.minimap.renderCharacters===Xe.minimap.renderCharacters&&ne.minimap.maxColumn===Xe.minimap.maxColumn&&ne.minimap.scale===Xe.minimap.scale&&ne.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ne.isViewportWrapping===Xe.isViewportWrapping,De=ne.lineHeight,ke=ne.typicalHalfwidthCharacterWidth,se=ne.scrollBeyondLastLine,de=ne.minimap.renderCharacters;let z=ze>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const J=ne.minimap.maxColumn,le=ne.minimap.size,Pe=ne.minimap.side,Ae=ne.verticalScrollbarWidth,Ue=ne.viewLineCount,Be=ne.remainingWidth,Qe=ne.isViewportWrapping,rt=de?2:3;let et=Math.floor(ze*je);const Ye=et/ze;let ot=!1,Et=!1,bt=rt*z,Ee=z/ze,he=1;if(le==="fill"||le==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:ct,desiredRatio:it,minimapLineCount:pt}=V.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:se,height:je,lineHeight:De,pixelRatio:ze});if(Ue/pt>1)ot=!0,Et=!0,z=1,bt=1,Ee=z/ze;else{let at=!1,ft=z+1;if(le==="fit"){const Pt=Math.ceil((Ue+ct)*bt);Qe&&Ce&&Be<=ve.stableFitRemainingWidth?(at=!0,ft=ve.stableFitMaxMinimapScale):(at=Pt>et,Qe&&at?(ve.stableMinimapLayoutInput=ne,ve.stableFitRemainingWidth=Be):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(le==="fill"||at){ot=!0;const Pt=z;bt=Math.min(De*ze,Math.max(1,Math.floor(1/it))),z=Math.min(ft,Math.max(1,Math.floor(bt/rt))),z>Pt&&(he=Math.min(2,z/Pt)),Ee=z/ze/he,et=Math.ceil(Math.max(ht,Ue+ct)*bt),Qe&&at&&(ve.stableFitMaxMinimapScale=z)}}}const ue=Math.floor(J*Ee),Y=Math.min(ue,Math.max(0,Math.floor((Be-Ae-2)*Ee/(ke+Ee)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(ze*Y);const Fe=Me/ze;Me=Math.floor(Me*he);const Je=de?1:2,Ze=Pe==="left"?0:xe-Y-Ae;return{renderMinimap:Je,minimapLeft:Ze,minimapWidth:Y,minimapHeightIsEditorHeight:ot,minimapIsSampling:Et,minimapScale:z,minimapLineHeight:bt,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:et,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Ye}}static computeLayout(ne,ve){const xe=ve.outerWidth|0,je=ve.outerHeight|0,ze=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,Ce=ve.typicalHalfwidthCharacterWidth,De=ve.maxDigitWidth,ke=ve.pixelRatio,se=ve.viewLineCount,de=ne.get(119),z=de==="inherit"?ne.get(118):de,J=z==="inherit"?ne.get(114):z,le=ne.get(117),Pe=ne.get(2),Ae=ve.isDominatedByLongLines,Ue=ne.get(46),Be=ne.get(56).renderType!==0,Qe=ne.get(57),rt=ne.get(91),et=ne.get(61),Ye=ne.get(89),ot=Ye.verticalScrollbarSize,Et=Ye.verticalHasArrows,bt=Ye.arrowSize,Ee=Ye.horizontalScrollbarSize,he=ne.get(54),ue=ne.get(35);let Y;if(typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)){const Rt=parseFloat(he.substr(0,he.length-2));Y=a.clampedInt(Rt*Ce,0,0,1e3)}else Y=a.clampedInt(he,0,0,1e3);ue&&(Y+=16);let Me=0;if(Be){const Rt=Math.max(Xe,Qe);Me=Math.round(Rt*De)}let Fe=0;Ue&&(Fe=ze);let Je=0,Ze=Je+Fe,ht=Ze+Me,ct=ht+Y;const it=xe-Fe-Me-Y;let pt=!1,dt=!1,at=-1;Pe!==2&&(z==="inherit"&&Ae?(pt=!0,dt=!0):J==="on"||J==="bounded"?dt=!0:J==="wordWrapColumn"&&(at=le));const ft=V._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:ze,typicalHalfwidthCharacterWidth:Ce,pixelRatio:ke,scrollBeyondLastLine:rt,minimap:et,verticalScrollbarWidth:ot,viewLineCount:se,remainingWidth:it,isViewportWrapping:dt},ve.memory||new D);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Je+=ft.minimapWidth,Ze+=ft.minimapWidth,ht+=ft.minimapWidth,ct+=ft.minimapWidth);const Pt=it-ft.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/Ce)),At=Et?bt:0;return dt&&(at=Math.max(1,Ct),J==="bounded"&&(at=Math.min(at,le))),{width:xe,height:je,glyphMarginLeft:Je,glyphMarginWidth:Fe,lineNumbersLeft:Ze,lineNumbersWidth:Me,decorationsLeft:ht,decorationsWidth:Y,contentLeft:ct,contentWidth:Pt,minimap:ft,viewportColumn:Ct,isWordWrapMinified:pt,isViewportWrapping:dt,wrappingColumn:at,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Ee,overviewRuler:{top:At,width:ot,height:je-2*At,right:0}}}}e.EditorLayoutInfoComputer=V;class x extends P{constructor(){const ne={enabled:!0};super(53,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:v.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:d(ne.enabled,this.defaultValue.enabled)}}}class k extends P{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:v.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class U extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(ne,ve,xe){return ne.fontInfo.lineHeight}}class F extends P{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:ne.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:v.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(ve.scale,1,1,3),maxColumn:a.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(G){return G==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{top:a.clampedInt(ve.top,0,0,1e3),bottom:a.clampedInt(ve.bottom,0,0,1e3)}}}class H extends P{constructor(){const ne={enabled:!0,cycle:!1};super(72,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:v.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(125)}compute(ne,ve,xe){return ne.pixelRatio}}class ae extends P{constructor(){const ne={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:v.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:v.localize(59,null)},other:{type:"boolean",default:ne.other,description:v.localize(60,null)}}}],default:ne,description:v.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ve=ne,xe={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var we;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(ne){let ve=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ve=4,xe=ne):ne==="interval"?ve=3:ne==="relative"?ve=2:ne==="on"?ve=1:ve=0),{renderType:ve,renderFn:xe}}}function Ie(G){const ne=G.get(84);return ne==="editable"?G.get(77):ne!=="on"}e.filterValidationDecorations=Ie;class Oe extends P{constructor(){const ne=[],ve={type:"number",description:v.localize(67,null)};super(88,"rulers",ne,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:ne,description:v.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let ve=[];for(let xe of ne)if(typeof xe=="number")ve.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;ve.push({column:a.clampedInt(je.column,0,0,1e4),color:je.color})}return ve.sort((xe,je)=>xe.column-je.column),ve}return this.defaultValue}}function We(G,ne){if(typeof G!="string")return ne;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class j extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne,xe=a.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=a.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(ve.vertical,this.defaultValue.vertical),horizontal:We(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(ve.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:a.clampedInt(ve.verticalSliderSize,je,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class X extends P{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,suggestionPreviewExpanded:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:ne.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:v.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ne.showSuggestionPreview,description:v.localize(79,null)},"editor.suggest.suggestionPreviewExpanded":{type:"boolean",default:ne.suggestionPreviewExpanded,description:v.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:v.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ve=ne;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:d(ve.showSuggestionPreview,this.defaultValue.showSuggestionPreview),suggestionPreviewExpanded:d(ve.suggestionPreviewExpanded,this.defaultValue.suggestionPreviewExpanded),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class ee extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(113,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends i{constructor(){super(126,[77])}compute(ne,ve,xe){return ve.get(77)?!0:ne.tabFocusMode}}var pe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function Se(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends i{constructor(){super(128,[127])}compute(ne,ve,xe){const je=ve.get(127);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const _e="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?Ve:_e,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(G){return e.editorOptionsRegistry[G.id]=G,G}var Ge;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useShadowDOM=111]="useShadowDOM",G[G.useTabStops=112]="useTabStops",G[G.wordSeparators=113]="wordSeparators",G[G.wordWrap=114]="wordWrap",G[G.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=117]="wordWrapColumn",G[G.wordWrapOverride1=118]="wordWrapOverride1",G[G.wordWrapOverride2=119]="wordWrapOverride2",G[G.wrappingIndent=120]="wrappingIndent",G[G.wrappingStrategy=121]="wrappingStrategy",G[G.showDeprecated=122]="showDeprecated",G[G.inlayHints=123]="inlayHints",G[G.editorClassName=124]="editorClassName",G[G.pixelRatio=125]="pixelRatio",G[G.tabFocusMode=126]="tabFocusMode",G[G.layoutInfo=127]="layoutInfo",G[G.wrappingInfo=128]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(114,null)})),acceptSuggestionOnEnter:be(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(115,null),""],markdownDescription:v.localize(116,null)})),accessibilitySupport:be(new h),accessibilityPageSize:be(new a(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(117,null)})),ariaLabel:be(new E(4,"ariaLabel",v.localize(118,null))),autoClosingBrackets:be(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(119,null),v.localize(120,null),""],description:v.localize(121,null)})),autoClosingDelete:be(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(122,null),""],description:v.localize(123,null)})),autoClosingOvertype:be(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(124,null),""],description:v.localize(125,null)})),autoClosingQuotes:be(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(126,null),v.localize(127,null),""],description:v.localize(128,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null)],description:v.localize(134,null)})),automaticLayout:be(new p(10,"automaticLayout",!1)),autoSurround:be(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null),""],description:v.localize(138,null)})),stickyTabStops:be(new p(101,"stickyTabStops",!1,{description:v.localize(139,null)})),codeLens:be(new p(12,"codeLens",!0,{description:v.localize(140,null)})),codeLensFontFamily:be(new E(13,"codeLensFontFamily","",{description:v.localize(141,null)})),codeLensFontSize:be(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(142,null)})),colorDecorators:be(new p(15,"colorDecorators",!0,{description:v.localize(143,null)})),columnSelection:be(new p(16,"columnSelection",!1,{description:v.localize(144,null)})),comments:be(new t),contextmenu:be(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new p(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(145,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:v.localize(146,null)})),cursorSmoothCaretAnimation:be(new p(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(147,null)})),cursorStyle:be(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:v.localize(148,null)})),cursorSurroundingLines:be(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(149,null)})),cursorSurroundingLinesStyle:be(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(150,null),v.localize(151,null)],description:v.localize(152,null)})),cursorWidth:be(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(153,null)})),disableLayerHinting:be(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new p(28,"domReadOnly",!1)),dragAndDrop:be(new p(29,"dragAndDrop",!0,{description:v.localize(154,null)})),emptySelectionClipboard:be(new S),extraEditorClassName:be(new E(31,"extraEditorClassName","")),fastScrollSensitivity:be(new f(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:v.localize(155,null)})),find:be(new b),fixedOverflowWidgets:be(new p(34,"fixedOverflowWidgets",!1)),folding:be(new p(35,"folding",!0,{description:v.localize(156,null)})),foldingStrategy:be(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(157,null),v.localize(158,null)],description:v.localize(159,null)})),foldingHighlight:be(new p(37,"foldingHighlight",!0,{description:v.localize(160,null)})),unfoldOnClickAfterEndOfLine:be(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(161,null)})),fontFamily:be(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(162,null)})),fontInfo:be(new L),fontLigatures2:be(new l),fontSize:be(new O),fontWeight:be(new W),formatOnPaste:be(new p(44,"formatOnPaste",!1,{description:v.localize(163,null)})),formatOnType:be(new p(45,"formatOnType",!1,{description:v.localize(164,null)})),glyphMargin:be(new p(46,"glyphMargin",!0,{description:v.localize(165,null)})),gotoLocation:be(new ie),hideCursorInOverviewRuler:be(new p(48,"hideCursorInOverviewRuler",!1,{description:v.localize(166,null)})),highlightActiveIndentGuide:be(new p(49,"highlightActiveIndentGuide",!0,{description:v.localize(167,null)})),hover:be(new re),inDiffEditor:be(new p(51,"inDiffEditor",!1)),letterSpacing:be(new f(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>f.clamp(G,-5,20),{description:v.localize(168,null)})),lightbulb:be(new x),lineDecorationsWidth:be(new A(54,"lineDecorationsWidth",10)),lineHeight:be(new U),lineNumbers:be(new Le),lineNumbersMinChars:be(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new p(58,"linkedEditing",!1,{description:v.localize(169,null)})),links:be(new p(59,"links",!0,{description:v.localize(170,null)})),matchBrackets:be(new _(60,"matchBrackets","always",["always","near","never"],{description:v.localize(171,null)})),minimap:be(new F),mouseStyle:be(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new f(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:v.localize(172,null)})),mouseWheelZoom:be(new p(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(173,null)})),multiCursorMergeOverlapping:be(new p(65,"multiCursorMergeOverlapping",!0,{description:v.localize(174,null)})),multiCursorModifier:be(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),multiCursorPaste:be(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(178,null),v.localize(179,null)],markdownDescription:v.localize(180,null)})),occurrencesHighlight:be(new p(68,"occurrencesHighlight",!0,{description:v.localize(181,null)})),overviewRulerBorder:be(new p(69,"overviewRulerBorder",!0,{description:v.localize(182,null)})),overviewRulerLanes:be(new a(70,"overviewRulerLanes",3,0,3)),padding:be(new $),parameterHints:be(new H),peekWidgetDefaultFocus:be(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(183,null),v.localize(184,null)],description:v.localize(185,null)})),definitionLinkOpensInPeek:be(new p(74,"definitionLinkOpensInPeek",!1,{description:v.localize(186,null)})),quickSuggestions:be(new ae),quickSuggestionsDelay:be(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(187,null)})),readOnly:be(new p(77,"readOnly",!1)),renameOnType:be(new p(78,"renameOnType",!1,{description:v.localize(188,null),markdownDeprecationMessage:v.localize(189,null)})),renderControlCharacters:be(new p(79,"renderControlCharacters",!1,{description:v.localize(190,null)})),renderIndentGuides:be(new p(80,"renderIndentGuides",!0,{description:v.localize(191,null)})),renderFinalNewline:be(new p(81,"renderFinalNewline",!0,{description:v.localize(192,null)})),renderLineHighlight:be(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(193,null)],description:v.localize(194,null)})),renderLineHighlightOnlyWhenFocus:be(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(195,null)})),renderValidationDecorations:be(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(196,null),v.localize(197,null),v.localize(198,null),""],description:v.localize(199,null)})),revealHorizontalRightPadding:be(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new p(87,"roundedSelection",!0,{description:v.localize(200,null)})),rulers:be(new Oe),scrollbar:be(new j),scrollBeyondLastColumn:be(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(201,null)})),scrollBeyondLastLine:be(new p(91,"scrollBeyondLastLine",!0,{description:v.localize(202,null)})),scrollPredominantAxis:be(new p(92,"scrollPredominantAxis",!0,{description:v.localize(203,null)})),selectionClipboard:be(new p(93,"selectionClipboard",!0,{description:v.localize(204,null),included:R.isLinux})),selectionHighlight:be(new p(94,"selectionHighlight",!0,{description:v.localize(205,null)})),selectOnLineNumbers:be(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(206,null),v.localize(207,null)],description:v.localize(208,null)})),showUnused:be(new p(97,"showUnused",!0,{description:v.localize(209,null)})),showDeprecated:be(new p(122,"showDeprecated",!0,{description:v.localize(210,null)})),inlayHints:be(new k),snippetSuggestions:be(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(211,null),v.localize(212,null),v.localize(213,null),v.localize(214,null)],description:v.localize(215,null)})),smartSelect:be(new ee),smoothScrolling:be(new p(100,"smoothScrolling",!1,{description:v.localize(216,null)})),stopRenderingLineAfter:be(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new X),suggestFontSize:be(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestLineHeight:be(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestOnTriggerCharacters:be(new p(106,"suggestOnTriggerCharacters",!0,{description:v.localize(219,null)})),suggestSelection:be(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(220,null),v.localize(221,null),v.localize(222,null)],description:v.localize(223,null)})),tabCompletion:be(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(224,null),v.localize(225,null),v.localize(226,null)],description:v.localize(227,null)})),tabIndex:be(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(228,null),v.localize(229,null),v.localize(230,null)],description:v.localize(231,null)})),useShadowDOM:be(new p(111,"useShadowDOM",!0)),useTabStops:be(new p(112,"useTabStops",!0,{description:v.localize(232,null)})),wordSeparators:be(new E(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:v.localize(233,null)})),wordWrap:be(new _(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(234,null),v.localize(235,null),v.localize(236,null),v.localize(237,null)],description:v.localize(238,null)})),wordWrapBreakAfterCharacters:be(new E(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new E(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new a(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(239,null)})),wordWrapOverride1:be(new _(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new _(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Se,{enumDescriptions:[v.localize(240,null),v.localize(241,null),v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),wrappingStrategy:be(new _(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),editorClassName:be(new m),pixelRatio:be(new Q),tabFocusMode:be(new oe),layoutInfo:be(new V),wrappingInfo:be(new ce)}}),define(me[152],ge([18,19]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([18,19]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([18,19]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([18,19]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[156],ge([18,19]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(me[157],ge([18,19]),function(K,e){return K.create("vs/platform/markers/common/markers",e)}),define(me[158],ge([18,19]),function(K,e){return K.create("vs/platform/theme/common/iconRegistry",e)}),define(me[159],ge([18,19]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(me[160],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[162],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostProgress",e)}),define(me[163],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[164],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[165],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[166],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[167],ge([18,19]),function(K,e){return K.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[168],ge([18,19]),function(K,e){return K.create("vs/workbench/common/views",e)}),define(me[169],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[170],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[171],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[172],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[173],ge([18,19]),function(K,e){return K.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[174],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[175],ge([0,1,154]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=T;function y(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function I(d){if(!d)return null;let p=d.majorBase,a=d.majorMustEqual,f=d.minorBase,E=d.minorMustEqual,w=d.patchBase,_=d.patchMustEqual;d.hasCaret&&(p===0||(E=!1),_=!1);let u=0;if(d.preRelease){const c=C.exec(d.preRelease);if(c){const[,h,t,n]=c;u=Date.UTC(Number(h),Number(t)-1,Number(n))}}return{majorBase:p,majorMustEqual:a,minorBase:f,minorMustEqual:E,patchBase:w,patchMustEqual:_,isMinimum:d.hasGreaterEquals,notBefore:u}}e.normalizeVersion=I;function D(d,p,a){let f;typeof d=="string"?f=I(y(d)):f=d;let E;p instanceof Date?E=p.getTime():typeof p=="string"&&(E=new Date(p).getTime());let w;if(typeof a=="string"?w=I(y(a)):w=a,!f||!w)return!1;let _=f.majorBase,u=f.minorBase,c=f.patchBase,h=w.majorBase,t=w.minorBase,n=w.patchBase,s=w.notBefore,r=w.majorMustEqual,o=w.minorMustEqual,g=w.patchMustEqual;return w.isMinimum?_>h?!0:_<h?!1:u>t?!0:u<t||E&&E<s?!1:c>=n:(_===1&&h===0&&(!r||!o||!g)&&(h=1,t=0,n=0,r=!0,o=!1,g=!1),_<h?!1:_>h?!r:u<t?!1:u>t?!o:c<n?!1:c>n?!g:!(E&&E<s))}e.isValidVersion=D;function P(d,p,a,f){return a.isBuiltin||typeof a.main=="undefined"?!0:A(d,p,a.engines.vscode,f)}e.isValidExtensionVersion=P;function i(d,p,a){return d==="*"||A(p,a,d)}e.isEngineValid=i;function A(d,p,a,f=[]){let E=I(y(a));if(!E)return f.push(v.localize(0,null,a)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return f.push(v.localize(1,null,a)),!1}else if(!E.majorMustEqual)return f.push(v.localize(2,null,a)),!1;return D(d,p,E)?!0:(f.push(v.localize(3,null,d,a)),!1)}}),define(me[111],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(T,y=[],I=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=v;const R=(C,...T)=>new v(C,T);e.createSyncDescriptor=R}),define(me[79],ge([0,1,111]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(y,I,D){I instanceof v.SyncDescriptor||(I=new v.SyncDescriptor(I,[],D)),R.push([y,I])}e.registerSingleton=C;function T(){return R}e.getSingletonServiceDescriptors=T}),define(me[176],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=v;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const I=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);I.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),I)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let I of this._nodes.values())I.outgoing.delete(y),I.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let I=this._nodes.get(y);return I||(I=new v(T),this._nodes.set(y,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,I]of this._nodes)T.push(`${y}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const I=new Set([T]),D=this._findCycle(y,I);if(D)return D}}_findCycle(T,y){for(let[I,D]of T.outgoing){if(y.has(I))return[...y,I].join(" -> ");y.add(I);const P=this._findCycle(D,y);if(P)return P;y.delete(I)}}}e.Graph=R}),define(me[4],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(v=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(I,D,P,i){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:I,index:P,optional:i}):(D[v.DI_DEPENDENCIES]=[{id:I,index:P,optional:i}],D[v.DI_TARGET]=D)}function C(I){if(v.serviceIds.has(I))return v.serviceIds.get(I);const D=function(P,i,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,P,A,!1)};return D.toString=()=>I,v.serviceIds.set(I,D),D}e.createDecorator=C;function T(I){return I}e.refineServiceDecorator=T;function y(I){return function(D,P,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(I,D,i,!0)}}e.optional=y}),define(me[177],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[178],ge([0,1,3,75,6,22,74,78,177]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(P):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(p,a){let f={selector:p,provider:a,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(f){let E=this._entries.indexOf(f);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const a=[];for(let f of this._entries)f._score>0&&a.push(f.provider);return a}ordered(p){const a=[];return this._orderedForEach(p,f=>a.push(f.provider)),a}orderedGroups(p){const a=[];let f,E;return this._orderedForEach(p,w=>{f&&E===w._score?f.push(w.provider):(E=w._score,f=[w.provider],a.push(f))}),a}_orderedForEach(p,a){if(!!p){this._updateScores(p);for(const f of this._entries)f._score>0&&a(f)}}_updateScores(p){let a={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let f of this._entries)if(f._score=(0,I.score)(f.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),P(f.selector)&&f._score>0){for(let E of this._entries)E._score=0;f._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(p,a){return p._score<a._score?1:p._score>a._score?-1:p._time<a._time?1:p._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class A{constructor(p,a,f=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=a,this.max=f,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+(0,R.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const a=this._key(p),f=this._cache.get(a);return this._clamp(f==null?void 0:f.value)}update(p,a){const f=this._key(p);let E=this._cache.get(f);return E||(E=new y.MovingAverage,this._cache.set(f,E)),E.update(a),this.get(p)}}e.LanguageFeatureRequestDelays=A}),define(me[80],ge([0,1,2,42,178,144,45]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var P;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var i;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var A;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,ie=this.getFontStyle(L);return ie&1&&(W+=" mtki"),ie&2&&(W+=" mtkb"),ie&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),ie=this.getFontStyle(L);let re=`color: ${O[W]};`;return ie&1&&(re+="font-style: italic;"),ie&2&&(re+="font-weight: bold;"),ie&4&&(re+="text-decoration: underline;"),re}}e.TokenMetadata=p;var a;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(L){const O=l[L];let W=O&&y.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=y.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(L,O){let W=l[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var f;(function(l){l[l.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(l){return l&&v.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=t;var n;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var s;(function(l){l[l.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(l){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(N){return L.get(N)}l.fromString=W;function ie(N){return O.get(N)}l.toString=ie;function re(N,V){const x=O.get(N);let k=x&&y.iconRegistry.get("symbol-"+x);return k||(console.info("No codicon found for SymbolKind "+N),k=y.Codicon.symbolProperty),`${V?"inline":"block"} ${k.classNames}`}l.toCssClassName=re})(r=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var g;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var S;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(S=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var b;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[179],ge([0,1,6,12,4,3,56,54]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,C.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,P){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!P)throw new Error("invalid command");return this.registerCommand({id:D,handler:P})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const f=D.handler;D.handler=function(E,...w){return(0,R.validateConstraints)(w,a),f(E,...w)}}const{id:i}=D;let A=this._commands.get(i);A||(A=new y.LinkedList,this._commands.set(i,A));let d=A.unshift(D),p=(0,v.toDisposable)(()=>{d();const a=this._commands.get(i);(a==null?void 0:a.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),p}registerCommandAlias(D,P){return e.CommandsRegistry.registerCommand(D,(i,...A)=>i.get(e.ICommandService).executeCommand(P,...A))}getCommand(D){const P=this._commands.get(D);if(!(!P||P.isEmpty()))return I.Iterable.first(P)}getCommands(){const D=new Map;for(const P of this._commands.keys()){const i=this.getCommand(P);i&&D.set(P,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,8,4,11]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=C.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.isMacintosh),y.set("isLinux",C.isLinux),y.set("isWindows",C.isWindows),y.set("isWeb",C.isWeb),y.set("isMacNative",C.isMacintosh&&!C.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return A.INSTANCE}static true(){return d.INSTANCE}static has(l){return p.create(l)}static equals(l,L){return a.create(l,L)}static notEquals(l,L){return w.create(l,L)}static regex(l,L){return n.create(l,L)}static in(l,L){return f.create(l,L)}static not(l){return _.create(l)}static and(...l){return r.create(l)}static or(...l){return o.create(l)}static greater(l,L){return u.create(l,L)}static less(l,L){return h.create(l,L)}static deserialize(l,L=!1){if(!!l)return this._deserializeOrExpression(l,L)}static _deserializeOrExpression(l,L){let O=l.split("||");return o.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(l,L){let O=l.split("&&");return r.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(l,L){if(l=l.trim(),l.indexOf("!=")>=0){let O=l.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("==")>=0){let O=l.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("=~")>=0){let O=l.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(l.indexOf(" in ")>=0){let O=l.split(" in ");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(l)){const O=l.split(">=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(l)){const O=l.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(l)){const O=l.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(l)){const O=l.split("<");return h.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(l)?_.create(l.substr(1).trim()):p.create(l)}static _deserializeValue(l,L){if(l=l.trim(),l==="true")return!0;if(l==="false")return!1;let O=/^'([^']*)'$/.exec(l);return O?O[1].trim():l}static _deserializeRegexValue(l,L){if((0,v.isFalsyOrWhitespace)(l)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=l.indexOf("/"),W=l.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${l}', missing /-enclosure`);return console.warn(`bad regexp-value '${l}', missing /-enclosure`),null}let ie=l.slice(O+1,W),re=l[W+1]==="i"?"i":"";try{return new RegExp(ie,re)}catch(N){if(L)throw new Error(`bad regexp-value '${l}', parse error: ${N}`);return console.warn(`bad regexp-value '${l}', parse error: ${N}`),null}}}e.ContextKeyExpr=P;function i(b,l){return b.cmp(l)}class A{constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class d{constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class p{constructor(l){this.key=l,this.type=2}static create(l){const L=y.get(l);return typeof L=="boolean"?L?d.INSTANCE:A.INSTANCE:new p(l)}cmp(l){return l.type!==this.type?this.type-l.type:m(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=p;class a{constructor(l,L){this.key=l,this.value=L,this.type=4}static create(l,L){if(typeof L=="boolean")return L?p.create(l):_.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?d.INSTANCE:A.INSTANCE:new a(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(l){return l.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class f{constructor(l,L){this.key=l,this.valueKey=L,this.type=10}static create(l,L){return new f(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.valueKey,l.key,l.valueKey)}equals(l){return l.type===this.type?this.key===l.key&&this.valueKey===l.valueKey:!1}evaluate(l){const L=l.getValue(this.valueKey),O=l.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?I.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(l){return l.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=f;class E{constructor(l){this._actual=l,this.type=11}static create(l){return new E(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new E(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(l,L){this.key=l,this.value=L,this.type=5}static create(l,L){if(typeof L=="boolean")return L?_.create(l):p.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?A.INSTANCE:d.INSTANCE:new w(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(l){return l.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class _{constructor(l){this.key=l,this.type=3}static create(l){const L=y.get(l);return typeof L=="boolean"?L?A.INSTANCE:d.INSTANCE:new _(l)}cmp(l){return l.type!==this.type?this.type-l.type:m(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!l.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(l){return l.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=_;class u{constructor(l,L){this.key=l,this.value=L,this.type=12}static create(l,L){return new u(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class c{constructor(l,L){this.key=l,this.value=L,this.type=13}static create(l,L){return new c(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreaterEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class h{constructor(l,L){this.key=l,this.value=L,this.type=14}static create(l,L){return new h(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=h;class t{constructor(l,L){this.key=l,this.value=L,this.type=15}static create(l,L){return new t(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:S(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(l,L){this.key=l,this.regexp=L,this.type=7}static create(l,L){return new n(l,L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.key<l.key)return-1;if(this.key>l.key)return 1;const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return L<O?-1:L>O?1:0}equals(l){if(l.type===this.type){const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return this.key===l.key&&L===O}return!1}evaluate(l){let L=l.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const l=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${l}`}keys(){return[this.key]}map(l){return l.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(l){this._actual=l,this.type=8}static create(l){return new s(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new s(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(l){this.expr=l,this.type=6}static create(l){return r._normalizeArr(l)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=i(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(l))return!1;return!0}static _normalizeArr(l){const L=[];let O=!1;for(const W of l)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return A.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return d.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(i);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const ie=L.pop(),re=o.create(W.expr.map(N=>r.create([N,ie])));re&&(L.push(re),L.sort(i))}return L.length===1?L[0]:new r(L)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new r(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let L of this.expr)l.push(L.negate());return o.create(l)}}e.ContextKeyAndExpr=r;class o{constructor(l){this.expr=l,this.type=9}static create(l){const L=o._normalizeArr(l);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=i(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(l))return!0;return!1}static _normalizeArr(l){let L=[],O=!1;if(l){for(let W=0,ie=l.length;W<ie;W++){const re=l[W];if(!!re){if(re.type===0){O=!0;continue}if(re.type===1)return[d.INSTANCE];if(re.type===9){L=L.concat(re.expr);continue}L.push(re)}}if(L.length===0&&O)return[A.INSTANCE];L.sort(i)}return L}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new o(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let O of this.expr)l.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;l.length>1;){const O=l.shift(),W=l.shift(),ie=[];for(const re of L(O))for(const N of L(W))ie.push(P.and(re,N));l.unshift(P.or(...ie))}return l[0]}}e.ContextKeyOrExpr=o;class g extends p{constructor(l,L,O){super(l);this._defaultValue=L,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:l})):O!==!0&&g._info.push({key:l,description:O,type:L!=null?typeof L:void 0})}static all(){return g._info.values()}bindTo(l){return l.createKey(this.key,this._defaultValue)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(l){return P.equals(this.key,l)}notEqualsTo(l){return P.notEquals(this.key,l)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(b,l){return b<l?-1:b>l?1:0}function S(b,l,L,O){return b<L?-1:b>L?1:l<O?-1:l>O?1:0}}),define(me[180],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(me[181],ge([0,1,153,4,10]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var I;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var D;(function(A){A.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(d,p){super(d);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=C;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class I{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,d){if(typeof A=="undefined"||A===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof A=="string"||typeof d=="string"){let p=typeof A=="string"?A:A.value,a=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(p,a)}return A._lower===d._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=I;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[182],ge([0,1,8,26]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(p,a){return p.uuid&&a.uuid?p.uuid===a.uuid:p.id===a.id?!0:(0,v.compareIgnoreCase)(p.id,a.id)===0}e.areSameExtensions=C;class T{constructor(a,f){this.version=f,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof T?C(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(p,a){return`${p}.${a}`}e.getExtensionId=y;function I(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(p,a){return I(y(p,a))}e.getGalleryExtensionId=D;function P(p,a){const f=[],E=w=>{for(const _ of f)if(_.some(u=>C(a(u),a(w))))return _;return null};for(const w of p){const _=E(w);_?_.push(w):f.push([w])}return f}e.groupByExtension=P;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function A(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(p){const a=new Set;for(const f of p)f.malicious&&a.add(f.id.id);return a}e.getMaliciousExtensionsSet=d}),define(me[183],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(me[43],ge([0,1,156,9,2,4,8,12,22]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function P(N){return N.create===!0}e.isFileOpenForWriteOptions=P;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var A;(function(N){N[N.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var d;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function f(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function E(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=E;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(V,x){super(V);this.code=x}}e.FileSystemProviderError=_;function u(N,V){const x=new _(N.toString(),V);return h(x,V),x}e.createFileSystemProviderError=u;function c(N){return N||u((0,v.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=c;function h(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=h;function t(N){if(!N)return w.Unknown;if(N instanceof _)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function n(N){if(N instanceof S)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,x,k){this.resource=V,this.operation=x,this.target=k}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,x){this.ignorePathCasing=x,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const k of V)switch(k.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(k.resource,k);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(k.resource,k);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(k.resource,k);break}}contains(V,...x){return this.doContains(V,{includeChildren:!1},...x)}affects(V,...x){return this.doContains(V,{includeChildren:!0},...x)}doContains(V,x,...k){var U,F,M,$,H,Q;if(!V)return!1;const ae=k.length>0;return!!((!ae||k.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(V))||x.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(V)))||(!ae||k.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(V))||x.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(V)))||(!ae||k.includes(2))&&(((H=this.deleted)===null||H===void 0?void 0:H.findSubstr(V))||x.includeChildren&&((Q=this.deleted)===null||Q===void 0?void 0:Q.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const x=[],k=V===1?this.added:V===0?this.updated:this.deleted;if(k)for(const[,U]of k)x.push(U);return x}filter(V){return new g(this.changes.filter(x=>V(x)),this.ignorePathCasing)}}e.FileChangesEvent=g;function m(N,V,x){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),x?(0,y.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=m;class S extends Error{constructor(V,x,k){super(V);this.fileOperationResult=x,this.options=k}static isFileOperationError(V){return V instanceof Error&&!(0,I.isUndefinedOrNull)(V.fileOperationResult)}}e.FileOperationError=S;var b;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var l;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(l=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function O(N,V){if(!V.canHandleResource(C.URI.from({scheme:N.scheme})))return new Promise(x=>{const k=V.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===N.scheme&&U.added&&(k.dispose(),x())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(V){return(0,I.isNumber)(V)||(V=0),V<W.KB?(0,v.localize)(1,null,V.toFixed(0)):V<W.MB?(0,v.localize)(2,null,(V/W.KB).toFixed(2)):V<W.GB?(0,v.localize)(3,null,(V/W.MB).toFixed(2)):V<W.TB?(0,v.localize)(4,null,(V/W.GB).toFixed(2)):(0,v.localize)(5,null,(V/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var ie;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function re(N){return{maxFileSize:N===0?300*W.MB:16*W.GB,maxHeapSize:N===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=re}),define(me[82],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...C){this._entries=new Map;for(let[T,y]of C)this.set(T,y)}set(C,T){const y=this._entries.get(C);return this._entries.set(C,T),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=v}),define(me[184],ge([0,1,17,176,111,4,82,13]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(a){var f;super("cyclic dependency between services");this.message=(f=a.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new y.ServiceCollection,f=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=f,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...f){let E=d.traceInvocation(a),w=!1;try{return a({get:(u,c)=>{if(w)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(u,E);if(!h&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return h}},...f)}finally{w=!0,E.stop()}}createInstance(a,...f){let E,w;return a instanceof C.SyncDescriptor?(E=d.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(f),E)):(E=d.traceCreation(a),w=this._createInstance(a,f,E)),E.stop(),w}_createInstance(a,f=[],E){let w=T._util.getServiceDependencies(a).sort((c,h)=>c.index-h.index),_=[];for(const c of w){let h=this._getOrCreateServiceInstance(c.id,E);if(!h&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);_.push(h)}let u=w.length>0?w[0].index:f.length;if(f.length!==u){console.warn(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${f.length} static arguments`);let c=u-f.length;c>0?f=f.concat(new Array(c)):f=f.slice(0,u)}return new a(...[...f,..._])}_setServiceInstance(a,f){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,f);else if(this._parent)this._parent._setServiceInstance(a,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let f=this._services.get(a);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):f}_getOrCreateServiceInstance(a,f){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,f.branch(a,!0)):(f.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,f,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,f,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,f,E){const w=new R.Graph(c=>c.id.toString());let _=0;const u=[{id:a,desc:f,_trace:E}];for(;u.length;){const c=u.pop();if(w.lookupOrInsertNode(c),_++>1e3)throw new P(w);for(let h of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(h.id);if(!t&&!h.optional&&console.warn(`[createInstance] ${a} depends on ${h.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:h.id,desc:t,_trace:c._trace.branch(h.id,!0)};w.insertEdge(c,n),u.push(n)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:h}of c){if(this._getServiceInstanceOrDescriptor(h.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}w.removeNode(h)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,f,E=[],w,_){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(f,E,w,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,f,E,w,_);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(a,f=[],E,w){if(E){const _=new I.IdleValue(()=>this._createInstance(a,f,w));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let h=_.value,t=h[c];return typeof t!="function"||(t=t.bind(h),u[c]=t),t},set(u,c,h){return _.value[c]=h,!0}})}else return this._createInstance(a,f,w)}}e.InstantiationService=i;var A;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(A||(A={}));class d{constructor(a,f){this.type=a,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new d(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(a){return D?new d(0,a.name):d._None}branch(a,f){let E=new d(2,a.toString());return this._dep.push([a,f,E]),E}stop(){let a=Date.now()-this._start;d._totals+=a;let f=!1;function E(_,u){let c=[],h=new Array(_+1).join("	");for(const[t,n,s]of u._dep)if(n&&s){f=!0,c.push(`${h}CREATES -> ${t}`);let r=E(_+1,s);r&&c.push(r)}else c.push(`${h}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(a>2||f)&&console.log(w.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(me[14],ge([0,1,4,6,11,3,60]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class i extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class A extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...n):console.warn(`[main ${I()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...n):console.error(`[main ${I()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...n):console.error(`[main ${I()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class d extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class p extends P{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class a extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class f extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=f;class E extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function _(h){if(h.verbose)return D.Trace;if(typeof h.logLevel=="string"){const t=u(h.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function u(h){switch(h){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function c(h){switch(h){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(me[112],ge([0,1,14,43]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,P,i,A){try{const d=await new Promise((p,a)=>{K(["spdlog"],p,a)});return d.setFlushOn(v.LogLevel.Info),d.createAsyncRotatingLogger(D,P,i,A)}catch(d){console.error(d)}return null}function T(D,P,i,A){const d=K.__$__nodeRequire("spdlog");return d.setFlushOn(v.LogLevel.Info),d.createRotatingLogger(D,P,i,A)}e.createRotatingLogger=T;function y(D,P,i){switch(P){case v.LogLevel.Trace:D.trace(i);break;case v.LogLevel.Debug:D.debug(i);break;case v.LogLevel.Info:D.info(i);break;case v.LogLevel.Warning:D.warn(i);break;case v.LogLevel.Error:D.error(i);break;case v.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class I extends v.AbstractMessageLogger{constructor(P,i,A,d){super();this.name=P,this.filepath=i,this.rotating=A,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const P=this.rotating?6:1,i=30/P*R.ByteSize.MB;return C(this.name,this.filepath,i,P).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)y(this._logger,d,p);this.buffer=[]}})}log(P,i){this._logger?y(this._logger,P,i):this.getLevel()<=P&&this.buffer.push({level:P,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(me[113],ge([0,1,4,157,57]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(a,f){return f-a}D.compare=P;const i=Object.create(null);i[D.Error]=(0,R.localize)(0,null),i[D.Warning]=(0,R.localize)(1,null),i[D.Info]=(0,R.localize)(2,null);function A(a){return i[a]||""}D.toString=A;function d(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=d;function p(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const P="";function i(d){return A(d,!0)}D.makeKey=i;function A(d,p){let a=[P];return d.source?a.push(d.source.replace("\xA6","\\\xA6")):a.push(P),d.code?typeof d.code=="string"?a.push(d.code.replace("\xA6","\\\xA6")):a.push(d.code.value.replace("\xA6","\\\xA6")):a.push(P),d.severity!==void 0&&d.severity!==null?a.push(y.toString(d.severity)):a.push(P),d.message&&p?a.push(d.message.replace("\xA6","\\\xA6")):a.push(P),d.startLineNumber!==void 0&&d.startLineNumber!==null?a.push(d.startLineNumber.toString()):a.push(P),d.startColumn!==void 0&&d.startColumn!==null?a.push(d.startColumn.toString()):a.push(P),d.endLineNumber!==void 0&&d.endLineNumber!==null?a.push(d.endLineNumber.toString()):a.push(P),d.endColumn!==void 0&&d.endColumn!==null?a.push(d.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}D.makeKeyOptionalMessage=A})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(me[185],ge([0,1,57,4,3]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[186],ge([0,1,6,8,2,4]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function y(I,D){return C.URI.isUri(I)?(0,R.equalsIgnoreCase)(I.scheme,D):(0,R.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=y}),define(me[187],ge([0,1,10,11,36,25]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)y=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const I=(0,T.dirname)(v.FileAccess.asFileUri("",K));y=K.__$__nodeRequire((0,T.joinPath)(I,"product.json").fsPath);const D=K.__$__nodeRequire((0,T.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(K,e){return function(v,R){e(v,R,K)}};define(me[114],ge([0,1,4,21,6,13]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(A,d){super();this.deferred=new T.DeferredPromise,d.withProgress(A,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends C.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(A){this.stop();const d=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:p.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(me[38],ge([0,1,12,51]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,I){R.ok(v.isString(y)),R.ok(v.isObject(I)),R.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,I)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(me[115],ge([0,1,38,3]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[C(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;v.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,152,3,38,12,115]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=C.Registry.as(y.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,_=!0){this.registerConfigurations([w],_)}registerConfigurations(w,_=!0){const u=[];w.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,_,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const _=[],u=c=>{if(c.properties)for(const h in c.properties)_.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,c.properties[h]);c.allOf&&c.allOf.forEach(h=>u(h))};for(const c of w){u(c);const h=this.configurationContributors.indexOf(c);h!==-1&&this.configurationContributors.splice(h,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(w){const _=[],u=[];for(const c of w)for(const h in c)if(_.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]=Object.assign(Object.assign({},this.defaultValues[h]||{}),c[h]);const t={type:"object",default:this.defaultValues[h],description:v.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};u.push(A(h)),this.configurationProperties[h]=t,this.defaultLanguageConfigurationOverridesNode.properties[h]=t}else{this.defaultValues[h]=c[h];const t=this.configurationProperties[h];t&&(this.updatePropertyDefaultValue(h,t),this.updateSchema(h,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(w){const _=[];for(const u of w)for(const c in u)if(_.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const h=this.configurationProperties[c];h&&(this.updatePropertyDefaultValue(c,h),this.updateSchema(c,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const _ of w)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,_=!0,u,c=3){var h;c=T.isUndefinedOrNull(w.scope)?c:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(_&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=T.isUndefinedOrNull(o.scope)?c:o.scope,o.restricted=T.isUndefinedOrNull(o.restricted)?!!((h=u==null?void 0:u.restrictedConfigurations)===null||h===void 0?void 0:h.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=w.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,_,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const _=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let h=u.allOf;h&&h.forEach(_)};_(w)}updateSchema(w,_){switch(e.allSettings.properties[w]=_,_.scope){case 1:e.applicationSettings.properties[w]=_;break;case 2:e.machineSettings.properties[w]=_;break;case 6:e.machineOverridableSettings.properties[w]=_;break;case 3:e.windowSettings.properties[w]=_;break;case 4:e.resourceSettings.properties[w]=_;break;case 5:e.resourceSettings.properties[w]=_,this.resourceLanguageSettingsSchema.properties[w]=_;break}}removeFromSchema(w,_){switch(delete e.allSettings.properties[w],_.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const _=`[${w}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,u),e.allSettings.properties[_]=u,e.applicationSettings.properties[_]=u,e.machineSettings.properties[_]=u,e.machineOverridableSettings.properties[_]=u,e.windowSettings.properties[_]=u,e.resourceSettings.properties[_]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,_){let u=this.defaultValues[w];T.isUndefined(u)&&(u=_.default),T.isUndefined(u)&&(u=d(_.type)),_.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function A(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=A;function d(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const p=new P;C.Registry.add(e.Extensions.Configuration,p);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?v.localize(5,null,E):p.getConfigurationProperties()[E]!==void 0?v.localize(6,null,E):null:v.localize(4,null)}e.validateProperty=a;function f(){const E=[],w=p.getConfigurationProperties();for(const _ of Object.keys(w))E.push([_,w[_].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(me[84],ge([0,1,24,12,2,38,4,83]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=D;var P;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function A(n,s){const r=s?n?s.keys.filter(L=>n.keys.indexOf(L)===-1):[...s.keys]:[],o=n?s?n.keys.filter(L=>s.keys.indexOf(L)===-1):[...n.keys]:[],g=[];if(s&&n){for(const L of n.keys)if(s.keys.indexOf(L)!==-1){const O=w(n.contents,L),W=w(s.contents,L);v.equals(O,W)||g.push(L)}}const m=[],S=L=>{const O={};for(const W of L)for(const ie of W.identifiers)O[h(ie)]=W;return O},b=s?S(s.overrides):{},l=n?S(n.overrides):{};if(Object.keys(b).length)for(const L of r){const O=b[L];O&&m.push([(0,I.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(l).length)for(const L of o){const O=l[L];O&&m.push([(0,I.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(b).length&&Object.keys(l).length)for(const L of g){const O=l[L],W=b[L];if(O&&W){const ie=A({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});m.push([(0,I.overrideIdentifierFromKey)(L),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:o,updated:g,overrides:m}}e.compare=A;function d(n,s){const r=[];for(const o of Object.keys(n))if(I.OVERRIDE_PROPERTY_PATTERN.test(o)){const g={};for(const m in n[o])g[m]=n[o][m];r.push({identifiers:[(0,I.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(g),contents:p(g,s)})}return r}e.toOverrides=d;function p(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=p;function a(n,s,r,o){const g=s.split("."),m=g.pop();let S=n;for(let b=0;b<g.length;b++){let l=g[b],L=S[l];switch(typeof L){case"undefined":L=S[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${g.slice(0,b+1).join(".")} is ${JSON.stringify(L)}`);return}S=L}if(typeof S=="object"&&S!==null)try{S[m]=r}catch(b){o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(S)}`)}else o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=a;function f(n,s){const r=s.split(".");E(n,r)}e.removeFromValueTree=f;function E(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete n[r])}}function w(n,s,r){function o(S,b){let l=S;for(const L of b){if(typeof l!="object"||l===null)return;l=l[L]}return l}const g=s.split("."),m=o(n,g);return typeof m=="undefined"?r:m}e.getConfigurationValue=w;function _(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?R.isObject(n[o])&&R.isObject(s[o])?_(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=_;function u(){const n=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function c(){const n=Object.create(null),s=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,g=>console.error(`Conflict in default settings: ${g}`))}return n}e.getDefaultValues=c;function h(n){return`[${n}]`}e.keyFromOverrideIdentifier=h;function t(n,s,r){const o=n.inspect(s),g=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,55,22,16,12,24,2,83,84,38,6,3]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],g=n[r];g&&(typeof o=="object"&&typeof g=="object"?(o=y.deepClone(o),this.mergeContents(o,g)):o=g),s[r]=o}return new p(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const g of o.overrides){const[m]=s.filter(S=>C.equals(S.identifiers,g.identifiers));m?this.mergeContents(m.contents,g.contents):s.push(y.deepClone(g))}for(const g of o.keys)r.indexOf(g)===-1&&r.push(g)}return new p(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,P.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,P.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class a extends p{constructor(){const t=(0,P.getDefaultValues)(),n=(0,P.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,P.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,restricted:g}=this.doParseRaw(t,n);this._configurationModel=new p(s,r,o),this._restrictedConfigurations=g||[]}doParseContent(t){let n={},s=null,r=[],o=[],g=[];function m(b){Array.isArray(r)?r.push(b):s&&(r[s]=b)}let S={onObjectBegin:()=>{let b={};m(b),o.push(r),r=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let b=[];m(b),o.push(r),r=b,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:m,onError:(b,l,L)=>{g.push({error:b,offset:l,length:L})}};if(t)try{v.visit(t,S),n=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,P.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),g=Object.keys(t),m=(0,P.toOverrides)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:o,keys:g,overrides:m,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},g=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const S=this.filter(t[m],n,!1,r);o[m]=S.raw,g.push(...S.restricted)}else{const S=n[m],b=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&g.push(m),(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.skipRestricted&&(S==null?void 0:S.restricted)||(o[m]=t[m]))}return{raw:o,restricted:g}}}e.ConfigurationModelParser=f;class E extends A.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,s=new p,r=new p,o=new R.ResourceMap,g=new p,m=new R.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=m,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(t):g.getValue(t),ie=r.getValue(t),re=C.distinct(C.flatten(r.overrides.map(N=>N.identifiers))).filter(N=>r.getOverrideValue(t,N)!==void 0);return{defaultValue:m,userValue:S,userLocalValue:b,userRemoteValue:l,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:ie,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:l!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:g.getValue(t),override:n.overrideIdentifier?g.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),S=[...m.filter(b=>g.indexOf(b)===-1),...g.filter(b=>m.indexOf(b)===-1),...g.filter(b=>!y.equals(this._defaultConfiguration.override(o).getValue(b),t.override(o).getValue(b)))];return[o,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.localUserConfiguration,t),g=[...n,...s,...r];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.remoteUserConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.workspaceConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:g,overrides:m}=(0,P.compare)(s,n);let S=[...r,...o,...g];return(S.length||!s)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:g}=(0,P.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,m)=>(g.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),g),new R.ResourceMap);return new w(n,s,new p,r,o,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function _(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const t=new Set,n=new Map;for(const r of h)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,g])=>{const m=(0,R.getOrSet)(n,o,new Set);g.forEach(S=>m.add(S))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=_;class u{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(S=>o.add(S))),this.affectedKeys=[...o.values()];const g=new p;this.affectedKeys.forEach(m=>g.setValue(m,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,P.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(me[189],ge([0,1,37,9,110,155,28,11,183,84,4,10,136]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=T.localize(0,null);class a{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let f=class zt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,C.getWindowsShell(),t)}spawnTerminal(t,n,s,r){const o=n.terminal.external,g=(o==null?void 0:o.windowsExec)||zt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const m=R.basename(g).toLowerCase();if(m==="cmder"||m==="cmder.exe")return t.spawn(g,r?[r]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return g.indexOf(" ")>=0&&S.push('""'),S.push(g),(m==="wt"||m==="wt.exe")&&S.push("-d ."),new Promise((b,l)=>{const L=_(process),O=t.spawn(s,S,{cwd:r,env:L});O.on("error",l),O.on("exit",()=>b())})}runInTerminal(t,n,s,r,o){const g="windowsExec"in o&&o.windowsExec?o.windowsExec:zt.getDefaultTerminalWindows();return new Promise((m,S)=>{const b=`"${n} - ${p}"`,l=`""${s.join('" "')}" & pause"`,L=["/c","start",b,"/wait",g,"/c",l],O=Object.assign({},_(process),r);Object.keys(O).filter(re=>O[re]===null).forEach(re=>delete O[re]);const W={cwd:n,env:O,windowsVerbatimArguments:!0};v.spawn(zt.CMD,L,W).on("error",re=>{S(u(re))}),m(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=qe([He(0,(0,i.optional)(P.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let E=class Nn extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,s,r,o){const g=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((m,S)=>{if(g===D.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const b=g===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`,K).fsPath,"-t",t||p,"-w",n];for(let ie of s)L.push("-a"),L.push(ie);if(r)for(let ie in r){const re=r[ie];re===null?(L.push("-u"),L.push(ie)):(L.push("-e"),L.push(`${ie}=${re}`))}let O="";const W=v.spawn(Nn.OSASCRIPT,L);W.on("error",ie=>{S(u(ie))}),W.stderr.on("data",ie=>{O+=ie.toString()}),W.on("exit",ie=>{if(ie===0)m(void 0);else if(O){const re=O.split(`
`,1);S(new Error(re[0]))}else S(new Error(T.localize(1,null,b,ie)))})}else S(new Error(T.localize(2,null,g)))})}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((g,m)=>{const S=["-a",o];s&&S.push(s);const b=t.spawn("/usr/bin/open",S);b.on("error",m),b.on("exit",()=>g())})}};E.OSASCRIPT="/usr/bin/osascript",E=qe([He(0,(0,i.optional)(P.IConfigurationService))],E),e.MacExternalTerminalService=E;let w=class Vt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,s,r,o){const g=o.linuxExec?Promise.resolve(o.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((m,S)=>{let b=[];g.then(l=>{l.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const L=`${c(s)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;b.push(`''${L}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(N=>O[N]===null).forEach(N=>delete O[N]);const W={cwd:n,env:O};let ie="";const re=v.spawn(l,b,W);re.on("error",N=>{S(u(N))}),re.stderr.on("data",N=>{ie+=N.toString()}),re.on("exit",N=>{if(N===0)m(void 0);else if(ie){const V=ie.split(`
`,1);S(new Error(V[0]))}else S(new Error(T.localize(4,null,l,N)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{I.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((g,m)=>{o.then(S=>{const b=_(process),l=t.spawn(S,[],{cwd:s,env:b});l.on("error",m),l.on("exit",()=>g())})})}};w.WAIT_MESSAGE=T.localize(3,null),w=qe([He(0,(0,i.optional)(P.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function _(h){const t=h.env;return(0,d.sanitizeProcessEnvironment)(t),t}function u(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(T.localize(5,null,h.path)):h}function c(h){let t="";for(let n of h)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[116],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(y,I=R.Unknown,D){super(y);this._message=y,this._code=I,this._detail=D,this.isHandled=I===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof C&&y.isHandled}}e.RemoteAuthorityResolverError=C}),define(me[117],ge([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(P){return P.scheme===v.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=R;function C(P){if(!P)return;const i=P.indexOf("+");return i<0?P:P.substr(0,i)}e.getRemoteName=C;function T(P){return P.scheme!==v.Schemas.file&&P.scheme!==v.Schemas.vscodeRemote}function y(P){if(P.folders.length)return P.folders.every(i=>T(i.uri))?P.folders[0].uri:void 0;if(P.configuration&&T(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=y;function I(P){var i;return(i=y(P))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=I;function D(P){return y(P)!==void 0}e.isVirtualWorkspace=D}),define(me[190],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((C,T)=>K(["vsda"],C,T))}async sign(C){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(C)}catch(T){}return C}}e.SignService=v}),define(me[191],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,T,y=5){let I;return I=T(D=>{const P=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(P);return}const A=setTimeout(()=>this.flushBuffer(C),y);i={data:[P],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,i)}),I}stopBuffering(C){const T=this._terminalBufferMap.get(C);T&&T.dispose()}flushBuffer(C){const T=this._terminalBufferMap.get(C);T&&(this._terminalBufferMap.delete(C),this._callback(C,T.data.join("")))}}e.TerminalDataBufferer=v}),define(me[192],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,38,3,192,45]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var D;(function(E){function w(_){return _&&typeof _=="object"&&typeof _.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var i;(function(E){function w(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}E.isThemeIcon=w;const _=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function u(n){const s=_.exec(n);if(!s)return;let[,r]=s;return{id:r}}E.fromString=u;function c(n,s){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),s&&(r=`${r}~${s}`),{id:r}}E.modify=c;function h(n,s){var r,o;return n.id===s.id&&((r=n.color)===null||r===void 0?void 0:r.id)===((o=s.color)===null||o===void 0?void 0:o.id)}E.isEqual=h;function t(n){return{id:n.id}}E.asThemeIcon=t,E.asClassNameArray=I.CSSIcon.asClassNameArray,E.asClassName=I.CSSIcon.asClassName,E.asCSSSelector=I.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function A(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const _=this.themingParticipants.indexOf(w);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;C.Registry.add(e.Extensions.ThemingContribution,p);function a(E){return p.onColorThemeChange(E)}e.registerThemingParticipant=a;class f extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,_){let u=this.theme.getColor(w);return u&&_&&(u=_(u,this.theme)),u?u.toString():null}}e.Themable=f}),define(me[194],ge([0,1,38,193,3,158,115,13,45]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,_,u,c){const h=this.iconsById[w];if(h){if(u&&!h.description){h.description=u,this.iconSchema.properties[w].markdownDescription=`${u} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=u),this._onDidChange.fire()}return h}let t={id:w,description:u,defaults:_,deprecationMessage:c};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),u&&(n.markdownDescription=`${u}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const _=this.iconReferenceSchema.enum.indexOf(w);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,_){const u=this.iconFontsById[w];if(u)return u;let c={id:w,definition:_};return this.iconFontsById[w]=c,this._onDidChange.fire(),c}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(h,t)=>h.id.localeCompare(t.id),_=h=>{for(;R.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of c.filter(t=>!!t.description).sort(w))u.push(`|<i class="${_(h)}"></i>|${h.id}|${R.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const h of c.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(w))u.push(`|<i class="${_(h)}"></i>|${h.id}|`);return u.join(`
`)}}const i=new P;v.Registry.add(e.Extensions.IconContribution,i);function A(E,w,_,u){return i.registerIcon(E,w,_,u)}e.registerIcon=A;function d(){return i}e.getIconRegistry=d;function p(){for(const E of D.iconRegistry.all)i.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>i.registerIcon(E.id,E.definition,E.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let a=v.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,i.getIconSchema());const f=new I.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=A("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,22]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function I(d){const p=d;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=I;function D(d){const p=d;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(p,a,f,E){this._id=p,this._configuration=f,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class i{constructor(p,a){this.raw=a,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function A(d){return new i({uri:d,index:0,name:(0,R.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=A}),define(me[118],ge([0,1,4,159,61,2,11,9,25,134,55,10,77,29,117]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(V){return(typeof V=="string"?(0,I.extname)(V):(0,D.extname)(V))===f}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function w(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function _(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=_;function u(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(V){const x=V;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=c;function h(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=h;function t(V){const x=V;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function n(V){const x=V;if(x==null?void 0:x.uri)return{id:x.id,uri:T.URI.revive(x.uri)};const k=V;if(k==null?void 0:k.configPath)return{id:k.id,configPath:T.URI.revive(k.configPath)};if(V==null?void 0:V.id)return{id:V.id}}e.reviveIdentifier=n;function s(V,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(V,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(V){return o(V)||g(V)}e.isStoredWorkspaceFolder=r;function o(V){const x=V;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=o;function g(V){const x=V;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=g;function m(V,x,k,U,F=!y.isWindows,M){if(V.scheme!==U.scheme)return{name:k,uri:V.toString(!0)};let $=x?void 0:M.relativePath(U,V);if($!==void 0)$.length===0?$=".":y.isWindows&&V.scheme===A.Schemas.file&&!F&&($=$.replace(/\//g,"\\"));else if(V.scheme===A.Schemas.file)$=V.fsPath,y.isWindows&&($=(0,d.normalizeDriveLetter)($),F&&($=(0,p.toSlashes)($)));else{if(!M.isEqualAuthority(V.authority,U.authority))return{name:k,uri:V.toString(!0)};$=V.path}return{name:k,path:$}}e.getStoredWorkspaceFolder=m;function S(V,x,k){let U=[],F=new Set;const M=k.dirname(x);for(let $ of V){let H;if(o($))$.path&&(H=k.resolvePath(M,$.path));else if(g($))try{H=T.URI.parse($.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(Q){console.warn(Q)}if(H){let Q=k.getComparisonKey(H);if(!F.has(Q)){F.add(Q);const ae=$.name||k.basenameOrAuthority(H);U.push(new C.WorkspaceFolder({uri:H,name:ae,index:U.length},$))}}}return U}e.toWorkspaceFolders=S;function b(V,x,k,U,F){let M=l(x,V);const $=F.dirname(x),H=F.dirname(U),Q=[],ae=L(M.folders);for(const Oe of M.folders){const We=o(Oe)?F.resolvePath($,Oe.path):T.URI.parse(Oe.uri);let j;k?j=!1:j=!o(Oe)||(0,I.isAbsolute)(Oe.path),Q.push(m(We,j,Oe.name,H,ae,F))}const we={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Le=P.setProperty(V,["folders"],Q,we);let Ie=P.applyEdits(V,Le);return M.remoteAuthority===(0,a.getRemoteAuthority)(U)&&(Ie=P.applyEdits(Ie,P.removeProperty(Ie,["remoteAuthority"],we))),Ie}e.rewriteWorkspaceFileForNewLocation=b;function l(V,x){let k=i.parse(x);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(U=>r(U));else throw new Error(`${V} looks like an invalid workspace file.`);return k}function L(V){return y.isWindows?V.some(x=>o(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(V){return V.workspace&&typeof V.workspace=="object"&&typeof V.workspace.id=="string"&&typeof V.workspace.configPath=="string"}function W(V){return typeof V.folderUri=="string"}function ie(V){return typeof V.fileUri=="string"}function re(V,x){const k={workspaces:[],files:[]};if(V){const U=function(M,$){for(let H=0;H<M.length;H++)try{$(M[H],H)}catch(Q){x.warn(`Error restoring recent entry ${JSON.stringify(M[H])}: ${Q.toString()}. Skip entry.`)}},F=V;if(Array.isArray(F.entries))U(F.entries,M=>{const $=M.label,H=M.remoteAuthority;O(M)?k.workspaces.push({label:$,remoteAuthority:H,workspace:{id:M.workspace.id,configPath:T.URI.parse(M.workspace.configPath)}}):W(M)?k.workspaces.push({label:$,remoteAuthority:H,folderUri:T.URI.parse(M.folderUri)}):ie(M)&&k.files.push({label:$,remoteAuthority:H,fileUri:T.URI.parse(M.fileUri)})});else{const M=V;Array.isArray(M.workspaces3)&&U(M.workspaces3,($,H)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[H]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?k.workspaces.push({label:Q,workspace:{id:$.id,configPath:T.URI.parse($.configURIPath)}}):typeof $=="string"&&k.workspaces.push({label:Q,folderUri:T.URI.parse($)})}),Array.isArray(M.files2)&&U(M.files2,($,H)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[H]||void 0;typeof $=="string"&&k.files.push({label:Q,fileUri:T.URI.parse($)})})}}return k}e.restoreRecentlyOpened=re;function N(V){const x={entries:[]};for(const k of V.workspaces)_(k)?x.entries.push({folderUri:k.folderUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority}):x.entries.push({workspace:{id:k.workspace.id,configPath:k.workspace.configPath.toString()},label:k.label,remoteAuthority:k.remoteAuthority});for(const k of V.files)x.entries.push({fileUri:k.fileUri.toString(),label:k.label,remoteAuthority:k.remoteAuthority});return x}e.toStoreData=N}),define(me[85],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const T=this._idPool++;return this._data.set(T,C),this.logDebugInfo(),T}get(C,T){return this._data.has(C)?this._data.get(C)[T]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(me[47],ge([0,1,2,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(D=>({name:D.name,group:D.group,resource:v.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[62],ge([0,1,10,4]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,I){I===null?this._providerInfo.delete(y):this._providerInfo.set(y,I)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(me[195],ge([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(y,I,D){this._deferredPromises=new Map,this._id=y,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of P.values())i.complete()}catch(i){for(const A of P.values())A.error(i)}})()},0)}get keys(){var y;return Object.entries((y=this._value)!==null&&y!==void 0?y:{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(y,I){let D=this._value[y];return typeof D=="undefined"&&(D=I),D}update(y,I){this._value[y]=I;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const P=new v.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(y,I){super(y.identifier.value,!0,I);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=C}),define(me[15],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[196],ge([0,1,26,3]),function(K,e,v,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,D){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(I.identifier),nt(this,C,D,"f"),$e(this,C,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return $e(this,C,"f").get(this._id,I)}store(I,D){return $e(this,C,"f").store(this._id,I,D)}delete(I){return $e(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=T,C=new WeakMap}),define(me[119],ge([0,1,4,3]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(me[86],ge([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,T=y=>{let I=C.get(y);return I||(I={children:new Map,bus:new v.Emitter},C.set(y,I)),I};e.getPrivateApiFor=T}),define(me[48],ge([0,1,4,3,15]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(I){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}I.fromApiTunnel=D;function P(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}I.fromServiceTunnel=P})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,i,A,d){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,C.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)},Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[7],ge([0,1,16,17,96,22,8,12,2,32,43,116,86]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";var p,a,f,E,w,_,u,c,h,t,n,s,r,o,g,m,S,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(q){function B(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(B,q),Object.setPrototypeOf(B.prototype,q.prototype),B}let L=w=class{constructor(B){p.set(this,void 0),nt(this,p,B,"f")}static from(...B){let te=B;return new w(function(){if(te){for(const ye of te)ye&&typeof ye.dispose=="function"&&ye.dispose();te=void 0}})}dispose(){typeof $e(this,p,"f")=="function"&&($e(this,p,"f").call(this),nt(this,p,void 0,"f"))}};p=new WeakMap,L=w=qe([l],L),e.Disposable=L;let O=_=class{constructor(B,te){if(B<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=B,this._character=te}static Min(...B){if(B.length===0)throw new TypeError;let te=B[0];for(let ye=1;ye<B.length;ye++){const Ke=B[ye];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...B){if(B.length===0)throw new TypeError;let te=B[0];for(let ye=1;ye<B.length;ye++){const Ke=B[ye];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(B){if(!B)return!1;if(B instanceof _)return!0;let{line:te,character:ye}=B;return typeof te=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,te=0){if(B===null||te===null)throw(0,R.illegalArgument)();let ye;return typeof B=="undefined"?ye=0:typeof B=="number"?ye=B:(ye=typeof B.lineDelta=="number"?B.lineDelta:0,te=typeof B.characterDelta=="number"?B.characterDelta:0),ye===0&&te===0?this:new _(this.line+ye,this.character+te)}with(B,te=this.character){if(B===null||te===null)throw(0,R.illegalArgument)();let ye;return typeof B=="undefined"?ye=this.line:typeof B=="number"?ye=B:(ye=typeof B.line=="number"?B.line:this.line,te=typeof B.character=="number"?B.character:this.character),ye===this.line&&te===this.character?this:new _(ye,te)}toJSON(){return{line:this.line,character:this.character}}};O=_=qe([l],O),e.Position=O;let W=u=class{constructor(B,te,ye,Ke){let tt,lt;if(typeof B=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof Ke=="number"?(tt=new O(B,te),lt=new O(ye,Ke)):B instanceof O&&te instanceof O&&(tt=B,lt=te),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this._start=tt,this._end=lt):(this._start=lt,this._end=tt)}static isRange(B){return B instanceof u?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const te=O.Max(B.start,this._start),ye=O.Min(B.end,this._end);if(!te.isAfter(ye))return new u(te,ye)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const te=O.Min(B.start,this._start),ye=O.Max(B.end,this.end);return new u(te,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,te=this.end){if(B===null||te===null)throw(0,R.illegalArgument)();let ye;return B?O.isPosition(B)?ye=B:(ye=B.start||this.start,te=B.end||this.end):ye=this.start,ye.isEqual(this._start)&&te.isEqual(this.end)?this:new u(ye,te)}toJSON(){return[this.start,this.end]}};W=u=qe([l],W),e.Range=W;let ie=c=class extends W{constructor(B,te,ye,Ke){let tt,lt;if(typeof B=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof Ke=="number"?(tt=new O(B,te),lt=new O(ye,Ke)):B instanceof O&&te instanceof O&&(tt=B,lt=te),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt);this._anchor=tt,this._active=lt}static isSelection(B){return B instanceof c?!0:B?W.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ie=c=qe([l],ie),e.Selection=ie;class re{constructor(B,te,ye){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,R.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(te),this.connectionToken=ye}}e.ResolvedAuthority=re;class N extends Error{constructor(B,te=A.RemoteAuthorityResolverErrorCode.Unknown,ye){super(B);this._message=B,this._code=te,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(B,te){return new N(B,A.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(B){return new N(B,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var V;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let k=h=class{constructor(B,te){this._range=B,this._newText=te}static isTextEdit(B){return B instanceof h?!0:B?W.isRange(B)&&typeof B.newText=="string":!1}static replace(B,te){return new h(B,te)}static insert(B,te){return h.replace(new W(B,B),te)}static delete(B){return h.replace(B,"")}static setEndOfLine(B){const te=new h(new W(new O(0,0),new O(0,0)),"");return te.newEol=B,te}get range(){return this._range}set range(B){if(B&&!W.isRange(B))throw(0,R.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,R.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,R.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};k=h=qe([l],k),e.TextEdit=k;var U;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellOutput=4]="CellOutput",q[q.CellReplace=5]="CellReplace",q[q.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,te,ye,Ke){this._edits.push({_type:1,from:B,to:te,options:ye,metadata:Ke})}createFile(B,te,ye){this._edits.push({_type:1,from:void 0,to:B,options:te,metadata:ye})}deleteFile(B,te,ye){this._edits.push({_type:1,from:B,to:void 0,options:te,metadata:ye})}replaceNotebookMetadata(B,te,ye){this._edits.push({_type:3,metadata:ye,uri:B,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(B,te,ye,Ke,tt){let lt,mt,yt=[],kt;if($t.isNotebookRange(te)&&Ne.isNotebookCellDataArray(ye)&&!Ne.isNotebookCellDataArray(Ke)?(lt=te.start,mt=te.end,yt=ye,kt=Ke):typeof te=="number"&&typeof ye=="number"&&Ne.isNotebookCellDataArray(Ke)&&(lt=te,mt=ye,yt=Ke,kt=tt),lt===void 0||mt===void 0)throw new Error("Invalid arguments");(lt!==mt||yt.length>0)&&this._edits.push({_type:5,uri:B,index:lt,count:mt-lt,cells:yt,metadata:kt})}replaceNotebookCellMetadata(B,te,ye,Ke){this._edits.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:te,metadata:ye}})}replace(B,te,ye,Ke){this._edits.push({_type:2,uri:B,edit:new k(te,ye),metadata:Ke})}insert(B,te,ye,Ke){this.replace(B,new W(te,te),ye,Ke)}delete(B,te,ye){this.replace(B,te,"",ye)}has(B){return this._edits.some(te=>te._type===2&&te.uri.toString()===B.toString())}set(B,te){if(te)for(const ye of te)ye&&this._edits.push({_type:2,uri:B,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ke=this._edits[ye];Ke._type===2&&Ke.uri.toString()===B.toString()&&(this._edits[ye]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(B){const te=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===B.toString()&&te.push(ye.edit);return te}entries(){const B=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let ye=B.get(te.uri);ye||(ye=[te.uri,[]],B.set(te.uri,ye)),ye[1].push(te.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=qe([l],F),e.WorkspaceEdit=F;let M=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,te=this._tabstop++){if(typeof B=="function"){const ye=new t;ye._tabstop=this._tabstop,B(ye),this._tabstop=ye._tabstop,B=ye.value}else B=t._escape(B);return this.value+="${",this.value+=te,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,te=this._tabstop++){const ye=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(B,te){if(typeof te=="function"){const ye=new t;ye._tabstop=this._tabstop,te(ye),this._tabstop=ye._tabstop,te=ye.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,te&&(this.value+=":",this.value+=te),this.value+="}",this}};M=t=qe([l],M),e.SnippetString=M;var $;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var H;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(H=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=n=class{constructor(B,te){if(this.uri=B,te)if(te instanceof W)this.range=te;else if(te instanceof O)this.range=new W(te,te);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof n?!0:B?W.isRange(B.range)&&D.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=n=qe([l],Q),e.Location=Q;let ae=class{constructor(B,te){this.location=B,this.message=te}static is(B){return B?typeof B.message=="string"&&B.location&&W.isRange(B.location.range)&&D.URI.isUri(B.location.uri):!1}static isEqual(B,te){return B===te?!0:!B||!te?!1:B.message===te.message&&B.location.range.isEqual(te.location.range)&&B.location.uri.toString()===te.location.uri.toString()}};ae=qe([l],ae),e.DiagnosticRelatedInformation=ae;let we=class{constructor(B,te,ye=H.Error){if(!W.isRange(B))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=B,this.message=te,this.severity=ye}toJSON(){return{severity:H[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,te){return B===te?!0:!B||!te?!1:B.message===te.message&&B.severity===te.severity&&B.code===te.code&&B.severity===te.severity&&B.source===te.source&&B.range.isEqual(te.range)&&(0,v.equals)(B.tags,te.tags)&&(0,v.equals)(B.relatedInformation,te.relatedInformation,ae.isEqual)}};we=qe([l],we),e.Diagnostic=we;let Le=class{constructor(B,te){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:(0,C.isMarkdownString)(B)?this.contents=[B]:this.contents=[B],this.range=te}};Le=qe([l],Le),e.Hover=Le;var Ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor(B,te=Ie.Text){this.range=B,this.kind=te}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Oe=qe([l],Oe),e.DocumentHighlight=Oe;var We;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var j;(function(q){q[q.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let X=s=class{constructor(B,te,ye,Ke,tt){this.name=B,this.kind=te,this.containerName=tt,typeof ye=="string"&&(this.containerName=ye),Ke instanceof Q?this.location=Ke:ye instanceof W&&(this.location=new Q(Ke,ye)),s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};X=s=qe([l],X),e.SymbolInformation=X;let ee=r=class{constructor(B,te,ye,Ke,tt){this.name=B,this.detail=te,this.kind=ye,this.range=Ke,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(r.validate)}};ee=r=qe([l],ee),e.DocumentSymbol=ee;var oe;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(B,te){this.title=B,this.kind=te}};pe=qe([l],pe),e.CodeAction=pe;let Se=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};Se.sep=".",Se=o=qe([l],Se),e.CodeActionKind=Se,Se.Empty=new Se(""),Se.QuickFix=Se.Empty.append("quickfix"),Se.Refactor=Se.Empty.append("refactor"),Se.RefactorExtract=Se.Refactor.append("extract"),Se.RefactorInline=Se.Refactor.append("inline"),Se.RefactorRewrite=Se.Refactor.append("rewrite"),Se.Source=Se.Empty.append("source"),Se.SourceOrganizeImports=Se.Source.append("organizeImports"),Se.SourceFixAll=Se.Source.append("fixAll");let ce=class{constructor(B,te){if(this.range=B,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=qe([l],ce),e.SelectionRange=ce;class _e{constructor(B,te,ye,Ke,tt,lt){this.kind=B,this.name=te,this.detail=ye,this.uri=Ke,this.range=tt,this.selectionRange=lt}}e.CallHierarchyItem=_e;class Re{constructor(B,te){this.fromRanges=te,this.from=B}}e.CallHierarchyIncomingCall=Re;class Ve{constructor(B,te){this.fromRanges=te,this.to=B}}e.CallHierarchyOutgoingCall=Ve;let be=class{constructor(B,te){this.range=B,this.command=te}get isResolved(){return!!this.command}};be=qe([l],be),e.CodeLens=be;let Ge=g=class{constructor(B,te=!1){a.set(this,void 0),nt(this,a,new C.MarkdownString(B,{supportThemeIcons:te}),"f")}static isMarkdownString(B){return B instanceof g?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return $e(this,a,"f").value}set value(B){$e(this,a,"f").value=B}get isTrusted(){return $e(this,a,"f").isTrusted}set isTrusted(B){$e(this,a,"f").isTrusted=B}get supportThemeIcons(){return $e(this,a,"f").supportThemeIcons}appendText(B){return $e(this,a,"f").appendText(B),this}appendMarkdown(B){return $e(this,a,"f").appendMarkdown(B),this}appendCodeblock(B,te){return $e(this,a,"f").appendCodeblock(te!=null?te:"",B),this}};a=new WeakMap,Ge=g=qe([l],Ge),e.MarkdownString=Ge;let G=class{constructor(B,te){this.label=B,this.documentation=te}};G=qe([l],G),e.ParameterInformation=G;let ne=class{constructor(B,te){this.label=B,this.documentation=te,this.parameters=[]}};ne=qe([l],ne),e.SignatureInformation=ne;let ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ve=qe([l],ve),e.SignatureHelp=ve;var xe;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let ze=class{constructor(B,te,ye){this.text=B,this.position=te,this.kind=ye}};ze=qe([l],ze),e.InlayHint=ze;var Xe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var De;(function(q){q[q.Deprecated=1]="Deprecated"})(De=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor(B,te){this.label=B,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=qe([l],ke),e.CompletionItem=ke;let se=class{constructor(B=[],te=!1){this.items=B,this.isIncomplete=te}};se=qe([l],se),e.CompletionList=se;let de=class{constructor(B){this.text=B}};de=qe([l],de),e.InlineSuggestion=de;let z=class{constructor(B){this.items=B}};z=qe([l],z),e.InlineSuggestions=z;var J;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(J=e.ViewColumn||(e.ViewColumn={}));var le;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(le=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Be;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function B(te){switch(te){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=B}(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(B,te){if(te&&!D.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!W.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.target=te}};rt=qe([l],rt),e.DocumentLink=rt;let et=class{constructor(B,te,ye,Ke){this.red=B,this.green=te,this.blue=ye,this.alpha=Ke}};et=qe([l],et),e.Color=et;let Ye=class{constructor(B,te){if(te&&!(te instanceof et))throw(0,R.illegalArgument)("color");if(!W.isRange(B)||B.isEmpty)throw(0,R.illegalArgument)("range");this.range=B,this.color=te}};Ye=qe([l],Ye),e.ColorInformation=Ye;let ot=class{constructor(B){if(!B||typeof B!="string")throw(0,R.illegalArgument)("label");this.label=B}};ot=qe([l],ot),e.ColorPresentation=ot;var Et;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Et=e.ColorFormat||(e.ColorFormat={}));var bt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ee;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var he;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(he=e.TaskPanelKind||(e.TaskPanelKind={}));let ue=m=class{constructor(B,te){if(typeof B!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};ue.Clean=new m("clean","Clean"),ue.Build=new m("build","Build"),ue.Rebuild=new m("rebuild","Rebuild"),ue.Test=new m("test","Test"),ue=m=qe([l],ue),e.TaskGroup=ue;function Y(q){let B="";for(let te=0;te<q.length;te++)B+=q[te].replace(/,/g,",,")+",";return B}let Me=class{constructor(B,te,ye){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=B,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=ye):this._options=te)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,R.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let te of this._args)B.push(te);return Y(B)}};Me=qe([l],Me),e.ProcessExecution=Me;let Fe=class{constructor(B,te,ye){if(this._args=[],Array.isArray(te)){if(!B)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B,this._args=te,this._options=ye}else{if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B,this._options=te}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,R.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)B.push(typeof te=="string"?te:te.value);return Y(B)}};Fe=qe([l],Fe),e.ShellExecution=Fe;var Je;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Je=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class ht{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=ht;let ct=S=class{constructor(B,te,ye,Ke,tt,lt){this.__deprecated=!1,this._definition=this.definition=B;let mt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=ye,this.execution=Ke,mt=tt,this.__deprecated=!0):te===Ze.Global||te===Ze.Workspace?(this.target=te,this._name=this.name=ye,this._source=this.source=Ke,this.execution=tt,mt=lt):(this.target=te,this._name=this.name=ye,this._source=this.source=Ke,this.execution=tt,mt=lt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Me?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Fe?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const te=this._definition.type;(S.EmptyType===te||S.ProcessType===te||S.ShellType===te||S.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=S=qe([l],ct),e.Task=ct;var it;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(B,te=dt.None){this.collapsibleState=te,D.URI.isUri(B)?this.resourceUri=B:this.label=B}};pt=qe([l],pt),e.TreeItem=pt;var dt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let at=class{constructor(B,te){this.id=B,this.color=te}};at=qe([l],at),e.ThemeIcon=at,at.File=new at("file"),at.Folder=new at("folder");let ft=class{constructor(B){this.id=B}};ft=qe([l],ft),e.ThemeColor=ft;var Pt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(B,te){if(typeof B!="string"&&(!B||!D.URI.isUri(B)&&!D.URI.isUri(B.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=D.URI.file(B),this.base=B):D.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=te}};Ct=qe([l],Ct),e.RelativePattern=Ct;let At=class{constructor(B,te,ye,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof te=="string"&&(this.condition=te),typeof ye=="string"&&(this.hitCondition=ye),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};At=qe([l],At),e.Breakpoint=At;let Rt=class extends At{constructor(B,te,ye,Ke,tt){super(te,ye,Ke,tt);if(B===null)throw(0,R.illegalArgument)("location");this.location=B}};Rt=qe([l],Rt),e.SourceBreakpoint=Rt;let St=class extends At{constructor(B,te,ye,Ke,tt){super(te,ye,Ke,tt);this.functionName=B}};St=qe([l],St),e.FunctionBreakpoint=St;let Xt=class extends At{constructor(B,te,ye,Ke,tt,lt,mt){super(Ke,tt,lt,mt);if(!te)throw(0,R.illegalArgument)("dataId");this.label=B,this.dataId=te,this.canPersist=ye}};Xt=qe([l],Xt),e.DataBreakpoint=Xt;let Yt=class{constructor(B,te,ye){this.command=B,this.args=te||[],this.options=ye}};Yt=qe([l],Yt),e.DebugAdapterExecutable=Yt;let gt=class{constructor(B,te){this.port=B,this.host=te}};gt=qe([l],gt),e.DebugAdapterServer=gt;let Jt=class{constructor(B){this.path=B}};Jt=qe([l],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(B){this.implementation=B}};Zt=qe([l],Zt),e.DebugAdapterInlineImplementation=Zt;let Dt=class{constructor(B,te){this.range=B,this.expression=te}};Dt=qe([l],Dt),e.EvaluatableExpression=Dt;var dn;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(B,te){this.range=B,this.text=te}};en=qe([l],en),e.InlineValueText=en;let xt=class{constructor(B,te,ye=!0){this.range=B,this.variableName=te,this.caseSensitiveLookup=ye}};xt=qe([l],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor(B,te){this.range=B,this.expression=te}};ut=qe([l],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor(B,te){this.frameId=B,this.stoppedLocation=te}};tn=qe([l],tn),e.InlineValueContext=tn;var Ft;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=b=class extends Error{constructor(B,te=i.FileSystemProviderErrorCode.Unknown,ye){var Ke;super(D.URI.isUri(B)?B.toString(!0):B);this.code=(Ke=ye==null?void 0:ye.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(B){return new b(B,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(B){return new b(B,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(B){return new b(B,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(B){return new b(B,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(B){return new b(B,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(B){return new b(B,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Mt=b=qe([l],Mt),e.FileSystemError=Mt;let qt=class{constructor(B,te,ye){this.start=B,this.end=te,this.kind=ye}};qt=qe([l],qt),e.FoldingRange=qt;var wn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var bn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(bn=e.CommentMode||(e.CommentMode={}));class fn{constructor(B,te=[]){this.tokenTypes=B,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function Bt(q){return typeof q=="undefined"||(0,I.isStringArray)(q)}class nn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let te=0,ye=B.tokenTypes.length;te<ye;te++)this._tokenTypeStrToInt.set(B.tokenTypes[te],te);for(let te=0,ye=B.tokenModifiers.length;te<ye;te++)this._tokenModifierStrToInt.set(B.tokenModifiers[te],te)}}push(B,te,ye,Ke,tt){if(typeof B=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(B,te,ye,Ke,tt);if(W.isRange(B)&&typeof te=="string"&&Bt(ye))return this._push(B,te,ye);throw(0,R.illegalArgument)()}_push(B,te,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,tt=B.start.character,lt=B.end.character-B.start.character,mt=this._tokenTypeStrToInt.get(te);let yt=0;if(ye)for(const kt of ye){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);yt|=1<<Tt>>>0}this._pushEncoded(Ke,tt,lt,mt,yt)}_pushEncoded(B,te,ye,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,Tt=0;for(let Lt=0;Lt<yt;Lt++){let Nt=this._data[5*Lt],cn=this._data[5*Lt+1];Nt===0?(Nt=kt,cn+=Tt):Nt+=kt,this._data[5*Lt]=Nt,this._data[5*Lt+1]=cn,kt=Nt,Tt=cn}}let lt=B,mt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=B,this._prevChar=te}static _sortAndDeltaEncode(B){let te=[];const ye=B.length/5|0;for(let mt=0;mt<ye;mt++)te[mt]=mt;te.sort((mt,yt)=>{const kt=B[5*mt],Tt=B[5*yt];if(kt===Tt){const Lt=B[5*mt+1],Nt=B[5*yt+1];return Lt-Nt}return kt-Tt});const Ke=new Uint32Array(B.length);let tt=0,lt=0;for(let mt=0;mt<ye;mt++){const yt=5*te[mt],kt=B[yt+0],Tt=B[yt+1],Lt=B[yt+2],Nt=B[yt+3],cn=B[yt+4],On=kt-tt,zn=On===0?Tt-lt:Tt,un=5*mt;Ke[un+0]=On,Ke[un+1]=zn,Ke[un+2]=Lt,Ke[un+3]=Nt,Ke[un+4]=cn,tt=kt,lt=Tt}return Ke}build(B){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),B):new Ht(nn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=nn;class Ht{constructor(B,te){this.resultId=te,this.data=B}}e.SemanticTokens=Ht;class rn{constructor(B,te,ye){this.start=B,this.deleteCount=te,this.data=ye}}e.SemanticTokensEdit=rn;class En{constructor(B,te){this.resultId=te,this.edits=B}}e.SemanticTokensEdits=En;var _n;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(_n=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new at("arrow-left")},Kt=qe([l],Kt),e.QuickInputButtons=Kt;var Sn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class yn{constructor(B,te,ye){this.badge=B,this.tooltip=te,this.color=ye}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=yn;let sn=class{constructor(B){this.kind=B}};sn=qe([l],sn),e.ColorTheme=sn;var on;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(on=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,te){if(B<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");B<=te?(this._start=B,this._end=te):(this._start=te,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let te=this._start,ye=this._end;return B.start!==void 0&&(te=B.start),B.end!==void 0&&(ye=B.end),te===this._start&&ye===this._end?this:new $t(te,ye)}}e.NotebookRange=$t;class Gt{constructor(B,te){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=te)}with(B){let{inputCollapsed:te,outputCollapsed:ye}=B,Ke=Qt(B,["inputCollapsed","outputCollapsed"]);return te===void 0?te=this.inputCollapsed:te===null&&(te=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),te===this.inputCollapsed&&ye===this.outputCollapsed&&Object.keys(Ke).length===0?this:new Gt(Object.assign({inputCollapsed:te,outputCollapsed:ye},Ke))}}e.NotebookCellMetadata=Gt;class Wt{constructor(B={}){Object.assign(this,B)}with(B){return new Wt(B)}}e.NotebookDocumentMetadata=Wt;class Ne{constructor(B,te,ye,Ke,tt,lt){this.kind=B,this.value=te,this.languageId=ye,this.outputs=Ke!=null?Ke:[],this.metadata=tt,this.executionSummary=lt,Ne.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(te=>Ne.isNotebookCellData(te))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Ne;class an{constructor(B,te){this.cells=B,this.metadata=te!=null?te:new Wt}}e.NotebookData=an;class It{constructor(B,te,ye){if(this.data=B,this.mime=te,this.metadata=ye,B instanceof Uint8Array||(this.value=B),(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(B){return B instanceof It?!0:B?typeof B.mime=="string":!1}static error(B,te){const ye={name:B.name,message:B.message,stack:B.stack};return It.json(ye,"application/vnd.code.notebook.error",te)}static stdout(B,te){return It.text(B,"application/vnd.code.notebook.stdout",te)}static stderr(B,te){return It.text(B,"application/vnd.code.notebook.stderr",te)}static bytes(B,te="application/octet-stream",ye){return new It(B,te,ye)}static text(B,te="text/plain",ye){const Ke=$e(It,f,"f",E).encode(String(B));return new It(Ke,te,ye)}static json(B,te="application/json",ye){const Ke=JSON.stringify(B,void 0,"	");return It.text(Ke,te,ye)}}e.NotebookCellOutputItem=It,f=It,E={value:new TextEncoder};class vt{constructor(B,te,ye){this.outputs=B,typeof te=="string"?(this.id=te,this.metadata=ye):(this.id=(0,P.generateUuid)(),this.metadata=te!=null?te:ye)}}e.NotebookCellOutput=vt;var Dn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Cn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(mn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(B,te,ye,Ke,tt,lt){this.text=B,this.alignment=te,this.command=ye,this.tooltip=Ke,this.priority=tt,this.accessibilityInformation=lt}}e.NotebookCellStatusBarItem=kn;var In;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(B,te=[]){this.uri=B,this.provides=typeof te=="string"?[te]:te}}e.NotebookKernelPreload=Pn;let ln=class{constructor(B,te){this.label=B,this.timestamp=te}};ln=qe([l],ln),e.TimelineItem=ln;var pn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(pn=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(B,te){this.ranges=B,this.wordPattern=te}}e.LinkedEditingRanges=Rn;class Ln{constructor(B,te){this._port=B,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(q){q[q.Unset=0]="Unset",q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Z;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information",q[q.Hint=3]="Hint"})(Z=e.TestMessageSeverity||(e.TestMessageSeverity={}));var fe;(function(q){q[q.Pending=0]="Pending",q[q.Resolved=1]="Resolved"})(fe=e.TestItemStatus||(e.TestItemStatus={}));const Te=(q,B,te,ye)=>{let Ke=te;return{enumerable:!0,configurable:!1,get(){return Ke},set(tt){ye(Ke,tt)||(Ke=tt,q.bus.fire([3,B,tt]))}}},st=(q,B)=>q===B,wt=(q,B)=>q===B?!0:!q||!B?!1:q.isEqual(B);class _t{constructor(B,te,ye,Ke){this.label=te,this.data=Ke;const tt=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new T.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:Te(tt,"range",void 0,wt),description:Te(tt,"description",void 0,st),runnable:Te(tt,"runnable",!0,st),debuggable:Te(tt,"debuggable",!1,st),status:Te(tt,"status",fe.Resolved,st),error:Te(tt,"error",void 0,st)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const B=(0,d.getPrivateApiFor)(this);B.parent&&(0,d.getPrivateApiFor)(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof _t))throw new Error("Test child must be created through vscode.test.createTestItem()");const te=(0,d.getPrivateApiFor)(this);if(te.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);te.children.set(B.id,B),te.bus.fire([0,B])}}e.TestItemImpl=_t;class Mn{constructor(B){this.message=B,this.severity=Z.Error}static diff(B,te,ye){const Ke=new Mn(B);return Ke.expectedOutput=te,Ke.actualOutput=ye,Ke}}e.TestMessage=Mn;var $n;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore"})(Hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[120],ge([0,1,51,10,8,145,107,7,16]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function i(a,f){f?P.set(a,f):P.delete(a)}e.setWordDefinitionFor=i;function A(a){return P.get(a)}e.getWordDefinitionFor=A;class d extends T.MirrorTextModel{constructor(f,E,w,_,u,c,h,t){super(E,w,_,u);this._proxy=f,this._languageId=c,this._isDirty=h,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,D.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(E){return E?f._getTextInRange(E):f.getText()},get eol(){return f._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(E){return f._lineAt(E)},offsetAt(E){return f._offsetAt(E)},positionAt(E){return f._positionAt(E)},validateRange(E){return f._validateRange(E)},validatePosition(E){return f._validatePosition(E)},getWordRangeAtPosition(E,w){return f._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,v.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,v.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const E=this._validateRange(f);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,_=E.start.line,u=E.end.line,c=[];c.push(this._lines[_].substring(E.start.character));for(let h=_+1;h<u;h++)c.push(this._lines[h]);return c.push(this._lines[u].substring(0,E.end.character)),c.join(w)}_lineAt(f){let E;if(f instanceof I.Position?E=f.line:typeof f=="number"&&(E=f),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new p(E,this._lines[E],E===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(f),w=this._lines[E.index].length;return new I.Position(E.index,Math.min(E.remainder,w))}_validateRange(f){if(!(f instanceof I.Range))throw new Error("Invalid argument");const E=this._validatePosition(f.start),w=this._validatePosition(f.end);return E===f.start&&w===f.end?f:new I.Range(E.line,E.character,w.line,w.character)}_validatePosition(f){if(!(f instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:E,character:w}=f,_=!1;if(E<0)E=0,w=0,_=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,_=!0;else{const u=this._lines[E].length;w<0?(w=0,_=!0):w>u&&(w=u,_=!0)}return _?new I.Position(E,w):f}_getWordRangeAtPosition(f,E){const w=this._validatePosition(f);if(!E)E=A(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const _=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(_)return new I.Range(w.line,_.startColumn-1,w.line,_.endColumn-1)}}e.ExtHostDocumentData=d;class p{constructor(f,E,w){this._line=f,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(me[197],ge([0,1,7,3,109,6,78,22,2,32]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,p,a,f){this._notebook=a,this._selector=f,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(w=>{const _=this._cellUris.get(w.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const d=[],p=[];for(const a of this._notebook.getCells())a.kind===v.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),d.push(a.document.getText().length+1),p.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(d){var p,a;if(!d){let u="";for(const c of this._cells)u+=c.document.getText()+`
`;return u=u.slice(0,-1),u}if(d.isEmpty)return"";const f=this.locationAt(d.start),E=this.locationAt(d.end),w=this._cells[(p=this._cellUris.get(f.uri))!==null&&p!==void 0?p:-1],_=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!w||!_)return"";if(w===_)return w.document.getText(new v.Range(f.range.start,E.range.end));{const u=w.document.getText(new v.Range(f.range.start,new v.Position(w.document.lineCount,0))),c=_.document.getText(new v.Range(new v.Position(0,0),E.range.end));return u+`
`+c}}offsetAt(d){const p=this._cellLines.getIndexOf(d.line),a=this._cellLengths.getAccumulatedValue(p.index-1),f=this._cells[p.index].document.offsetAt(d.with(p.remainder));return a+f}positionAt(d){if(typeof d=="number"){const a=this._cellLengths.getIndexOf(d),f=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(f)}const p=this._cellUris.get(d.uri);if(p!==void 0){const a=this._cellLines.getAccumulatedValue(p-1);return new v.Position(a+d.range.start.line,d.range.start.character)}return new v.Position(0,0)}locationAt(d){v.Range.isRange(d)||(d=new v.Range(d,d));const p=this._cellLines.getIndexOf(d.start.line);let a=p;d.isEmpty||(a=this._cellLines.getIndexOf(d.end.line));const f=new v.Position(p.remainder,d.start.character),E=new v.Position(a.remainder,d.end.character),w=new v.Range(f,E),_=this._cells[p.index];return new v.Location(_.document.uri,_.document.validateRange(w))}contains(d){return this._cellUris.has(d)}validateRange(d){const p=this.validatePosition(d.start),a=this.validatePosition(d.end);return d.with(p,a)}validatePosition(d){const p=this._cellLines.getIndexOf(d.line),a=new v.Position(p.remainder,d.character),f=this._cells[p.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(p.index-1);return new v.Position(E+f.line,f.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[198],ge([0,1,7,15,3]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?v.ColorThemeKind.Light:I==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=qe([He(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(me[63],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=R}),define(me[199],ge([0,1,23]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function C(I,D){if(D.serializeBuffersForPostMessage){const P=new R,i=(p,a)=>{if(a instanceof ArrayBuffer){const f=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(a)){const f=T(a);if(f){const E=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:f,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},A=JSON.stringify(I,i),d=P.buffers.map(p=>{const a=new Uint8Array(p);return v.VSBuffer.wrap(a)});return{message:A,buffers:d}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(I,D){const P=D.map(d=>{const p=new ArrayBuffer(d.byteLength);return new Uint8Array(p).set(d.buffer),p}),i=D.length?(d,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:f}=a,E=P[f];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return p}:void 0;return{message:JSON.parse(I,i),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(me[87],ge([0,1,10,2]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(T,y){return T.scheme===v.Schemas.http||T.scheme===v.Schemas.https?T:(y&&y.authority&&y.isRemote&&T.scheme===v.Schemas.file&&(T=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:y.authority,path:T.path})),R.URI.from({scheme:v.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=C}),define(me[200],ge([0,1,3,6,87]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(I,D,P){this._proxy=I,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const A of this._insets.values())i.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,P,i,A){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===I){d=u;break}if(!d)throw new Error("not a visible editor");const p=this,a=this._handlePool++,f=new v.Emitter,E=new v.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,C.asWebviewUri)(u,p._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(u){this._options=u,p._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,p._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(u){return p._proxy.$postMessage(a,u)}},_=new class{constructor(){this.editor=I,this.line=D,this.height=P,this.webview=w,this.onDidDispose=E.event}dispose(){p._insets.has(a)&&(p._insets.delete(a),p._proxy.$disposeEditorInset(a),E.fire(),E.dispose(),f.dispose())}};return this._proxy.$createEditorInset(a,d.id,d.value.document.uri,D+1,P,i||{},A.identifier,A.extensionLocation),this._insets.set(a,{editor:I,inset:_,onDidReceiveMessage:f}),_}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=T}),define(me[201],ge([0,1,3,81,168,4,6,22,38,16,52,24,45,194]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",d.Codicon.window,(0,C.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var f;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=w;class _ extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(g,m,S){var b;const l=this.get(g.id);if(l)return l;const L=g;return L.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(b=L.openCommandActionDescriptor)!==null&&b!==void 0?b:{id:L.id},(0,I.getOrSet)(this.viewContainers,m,[]).push(L),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(L),this._onDidRegister.fire({viewContainer:L,viewContainerLocation:m}),L}deregisterViewContainer(g){for(const m of this.viewContainers.keys()){const S=this.viewContainers.get(m),b=S==null?void 0:S.indexOf(g);if(b!==-1){S==null||S.splice(b,1),S.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:m});return}}}get(g){return this.all.filter(m=>m.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(S=>(S==null?void 0:S.id)===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===g)}}D.Registry.add(a.ViewContainersRegistry,new _);var u;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function c(o,g){var m,S,b,l;const L=(m=o.group)!==null&&m!==void 0?m:u.More,O=(S=g.group)!==null&&S!==void 0?S:u.More;return L!==O?L.localeCompare(O):((b=o.order)!==null&&b!==void 0?b:5)-((l=g.order)!==null&&l!==void 0?l:5)}class h extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(g,m){this.registerViews2([{views:g,viewContainer:m}])}registerViews2(g){g.forEach(({views:m,viewContainer:S})=>this.addViews(m,S)),this._onViewsRegistered.fire(g)}deregisterViews(g,m){const S=this.removeViews(g,m);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:m})}moveViews(g,m){for(const S of this._views.keys())if(S!==m){const b=this.removeViews(g,S);b.length&&(this.addViews(b,m),this._onDidChangeContainer.fire({views:b,from:S,to:m}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const m of this._viewContainers){const S=(this._views.get(m)||[]).filter(b=>b.id===g)[0];if(S)return S}return null}getViewContainer(g){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(b=>b.id===g)[0])return m;return null}registerViewWelcomeContent(g,m){return this._viewWelcomeContents.add(g,m),this._onDidChangeViewWelcomeContent.fire(g),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,m),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,m){const S=new Map;for(const[b,l]of m)this._viewWelcomeContents.add(g,l),S.set(b,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,l),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),S}getViewWelcomeContent(g){const m=[];return this._viewWelcomeContents.forEach(g,S=>m.push(S)),m.sort(c)}addViews(g,m){let S=this._views.get(m);S||(S=[],this._views.set(m,S),this._viewContainers.push(m));for(const b of g){if(this.getView(b.id)!==null)throw new Error((0,C.localize)(1,null,b.id));S.push(b)}}removeViews(g,m){const S=this._views.get(m);if(!S)return[];const b=[],l=[];for(const L of S)g.includes(L)?b.push(L):l.push(L);return b.length&&(l.length?this._views.set(m,l):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),b}}D.Registry.add(a.ViewsRegistry,new h),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(g,m){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,g),this._hasResolve=!!m,this.resolve=async S=>{var b,l;if(m&&!this.resolved){const L=await m(S);L&&(this.tooltip=(b=this.tooltip)!==null&&b!==void 0?b:L.tooltip,this.command=(l=this.command)!==null&&l!==void 0?l:L.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[202],ge([0,1,2,179,118,14,180,201]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(a){return(f,...E)=>a(f.get(R.ICommandService),...E)}class P{static execute(f,E){const w={forceReuseWindow:E&&E.reuseWindow,remoteAuthority:E&&E.remoteAuthority};return f.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=P,P.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,f){return a.get(C.IWorkspacesService).removeRecentlyOpened([f])});class i{static execute(f,E){return typeof E=="string"?E=E.match(/^[^:/?#]+:\/\//)?v.URI.parse(E):v.URI.file(E):E=v.URI.revive(E),f.executeCommand("_workbench.removeFromRecentlyOpened",E)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(i.ID,D(i.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,f){const E=a.get(C.IWorkspacesService);let w;const _=f.uri,u=f.label,c=f.remoteAuthority;return f.type==="workspace"?w={workspace:await E.getWorkspaceIdentifier(_),label:u,remoteAuthority:c}:f.type==="folder"?w={folderUri:_,label:u,remoteAuthority:c}:w={fileUri:_,label:u,remoteAuthority:c},E.addRecentlyOpened([w])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(C.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,f){const E=a.get(T.ILogService),w=a.get(y.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&E.setLevel(f)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,f){const E=a.get(I.IViewDescriptorService),w=E.getViewContainerById(f.destinationId);if(!!w){for(const _ of f.viewIds){const u=E.getViewDescriptorById(_);(u==null?void 0:u.canMoveView)&&E.moveViewsToContainer([u],w,I.ViewVisibilityState.Default)}await a.get(I.IViewsService).openViewContainer(w.id,!0)}});class A{static execute(f,E){return!Array.isArray(E==null?void 0:E.viewIds)||typeof(E==null?void 0:E.destinationId)!="string"?Promise.reject("Invalid arguments"):f.executeCommand("_workbench.action.moveViews",E)}}e.MoveViewsAPICommand=A,A.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:A.ID,handler:D(A.execute),description:{description:"Move Views",args:[]}});class d{static execute(f,E){return f.executeCommand("_workbench.open",E)}}d.ID="vscode.open",R.CommandsRegistry.registerCommand(d.ID,D(d.execute));class p{static execute(f,E,w,_,u){return f.executeCommand("_workbench.diff",[E,w,_])}}p.ID="vscode.diff",R.CommandsRegistry.registerCommand(p.ID,D(p.execute))}),define(me[121],ge([0,1,3,13,169]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,P,i){const A={command:I};if(D&&Object.keys(D).length>0&&(A.arguments=D),this.internalSend("request",A),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const p=this.pendingRequests.get(A.seq);if(p){this.pendingRequests.delete(A.seq);const a={type:"response",seq:0,request_seq:A.seq,success:!1,command:I,message:(0,C.localize)(0,null,i,I)};p(a)}},i)}return P&&this.pendingRequests.set(A.seq,P),A.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,R.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,P)=>I.set(P,D)),await(0,R.timeout)(500),I.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(me[203],ge([0,1,8,2,9,24,10]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(n,s,r){return n.replace(I,function(o,g){return s&&g.length>0&&g[0]!=="_"?o:r&&r.hasOwnProperty(g)?r[g]:o})}e.formatPII=D;function P(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=P;function i(n){return n.configuration.request==="attach"&&!A(n)}e.isSessionAttach=i;function A(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(s,"extensionhost")||(0,v.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?A(n.parentSession):void 0}e.getExtensionHostDebugSession=A;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function p(n,s,r){let o,g=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=m.exec(n);){let b=S.index+1,l=b+S[0].length;if(b<=s&&l>=r){o=S[0],g=b;break}}if(o){let b=/\w+/g,l=null;for(;(l=b.exec(o))&&!(l.index+1+g+l[0].length>=r););l&&(o=o.substring(0,b.lastIndex))}return o?{start:g,end:g+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(n){return!!(n&&n.match(a))}e.isUri=f;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(f(n.path))return R.URI.parse(n.path);if((0,C.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=R.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function _(n,s){const r=s?E:w,o=(0,T.deepClone)(n);return c(o,(g,m)=>{g&&m&&(m.path=r(m))}),o}e.convertToDAPaths=_;function u(n,s){const r=s?E:w,o=(0,T.deepClone)(n);return c(o,(g,m)=>{!g&&m&&(m.path=r(m))}),o}e.convertToVSCPaths=u;function c(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const g=n;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":g.body.sources.forEach(m=>s(!1,m));break;case"scopes":g.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function h(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=h;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[204],ge([0,1,28,37,170,122,9,8,24,11,181,121]),function(K,e,v,R,C,T,y,I,D,P,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const u=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${d.TWO_CRLF}${u}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+u))}continue}}else{const u=this.rawData.indexOf(d.TWO_CRLF);if(u!==-1){const h=this.rawData.toString("utf8",0,u).split(d.HEADER_LINESEPARATOR);for(const t of h){const n=t.split(d.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class p extends d{startSession(){return new Promise((_,u)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",h=>{c?this._onError.fire(h):u(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class a extends p{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=a;class f extends p{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=f;class E extends d{constructor(_,u,c){super();this.adapterExecutable=_,this.debugType=u,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,u=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(y.isAbsolute(_)){if(!await(0,v.exists)(_))throw new Error(C.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let h=process.env;if(c.env&&Object.keys(c.env).length>0&&(h=D.mixin(D.deepClone(process.env),c.env)),_==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:h,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const r=R.fork(u[0],u.slice(1),s);if(!r.pid)throw new Error(C.localize(2,null,u[0]));this.serverProcess=r}else throw new Error(C.localize(3,null));else{const n={env:h};c.cwd&&(n.cwd=c.cwd),this.serverProcess=R.spawn(_,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((_,u)=>{const c=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,t,n){if(h)return u(h)});c.on("exit",_),c.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,u){if(!_)return;const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=y.join(u,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(y.isAbsolute(_.program)?c.program=_.program:c.program=y.join(u,_.program)),_.args&&(c.args=_.args);const h=_;return h.win&&(c.win=E.extract(h.win,u)),h.winx86&&(c.winx86=E.extract(h.winx86,u)),h.windows&&(c.windows=E.extract(h.windows,u)),h.osx&&(c.osx=E.extract(h.osx,u)),h.linux&&(c.linux=E.extract(h.linux,u)),c}static platformAdapterExecutable(_,u){let c=Object.create(null);u=u.toLowerCase();for(const o of _)if(o.contributes){const g=o.contributes.debuggers;g&&g.length>0&&g.filter(m=>typeof m.type=="string"&&I.equalsIgnoreCase(m.type,u)).forEach(m=>{const S=E.extract(m,o.extensionLocation.fsPath);c=D.mixin(c,S,o.isBuiltin)})}let h;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=c.winx86||c.win||c.windows:P.isWindows?h=c.win||c.windows:P.isMacintosh?h=c.osx:P.isLinux&&(h=c.linux),h=h||c;let t=h.program||c.program;const n=h.args||c.args;let s=h.runtime||c.runtime;const r=h.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[205],ge([0,1,37,11,29,189]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(d,p){return new Promise((a,f)=>{let E="";const w=v.spawn(d,p);w.pid&&w.stdout.on("data",_=>{E+=_.toString()}),w.on("error",_=>{f(_)}),w.on("close",_=>{a(E)})})}let I;function D(d,p){if(!I)if(R.isWindows)I=new T.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)I=new T.MacExternalTerminalService(void 0);else if(R.isLinux)I=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=p.getConfiguration("terminal");return I.runInTerminal(d.title,d.cwd,d.args,d.env||{},a.external||{})}e.runInExternalTerminal=D;function P(d){return d?R.isWindows?new Promise(async p=>{(await new Promise((f,E)=>{K(["windows-process-tree"],f,E)})).getProcessTree(d,f=>{p(f.children.length>0)})}):y("/usr/bin/pgrep",["-lP",String(d)]).then(p=>{const a=p.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var i;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(i||(i={}));function A(d,p,a,f){d=d.trim().toLowerCase();let E;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?E=1:d.indexOf("cmd.exe")>=0?E=0:d.indexOf("bash")>=0?E=2:R.isWindows?E=0:E=2;let w,_=" ";switch(E){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),a){const c=(0,C.getDriveLetter)(a);c&&(_+=`${c}:; `),_+=`cd ${w(a)}; `}if(f)for(let c in f){const h=f[c];h===null?_+=`Remove-Item env:${c}; `:_+=`\${env:${c}}='${h}'; `}if(p.length>0){const c=w(p.shift());_+=c[0]==="'"?`& ${c} `:`${c} `;for(let h of p)_+=`${w(h)} `}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),a){const c=(0,C.getDriveLetter)(a);c&&(_+=`${c}: && `),_+=`cd ${w(a)} && `}if(f){_+='cmd /C "';for(let c in f){let h=f[c];h===null?_+=`set "${c}=" && `:(h=h.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${c}=${h}" && `)}}for(let c of p)_+=`${w(c)} `;f&&(_+='"');break;case 2:w=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const u=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(a&&(_+=`cd ${w(a)} ; `),f){_+="/usr/bin/env";for(let c in f){const h=f[c];h===null?_+=` -u ${u(c)}`:_+=` ${u(`${c}=${h}`)}`}_+=" "}for(let c of p)_+=`${w(c)} `;break}return _}e.prepareCommand=A}),define(me[64],ge([0,1,31,10,9,11,81]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var A;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.CellClearOutput=3]="CellClearOutput",b[b.CellsClearOutput=4]="CellsClearOutput",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.Unknown=100]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));function a(b,l){if(l)return b.toString();const L=f.parse(b);return L?L.notebook.toString():b.toString()}e.getCellUndoRedoComparisonKey=a;var f;(function(b){b.scheme=R.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function L(N,V){return N.with({scheme:b.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==R.Schemas.file?N.scheme:""}`})}b.generate=L;function O(N){if(N.scheme!==b.scheme)return;const V=l.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parse=O;function W(N){if(N.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const V=l.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellMetadataUri=W;function ie(N,V,x){return N.with({scheme:x,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==R.Schemas.file?N.scheme:""}`})}b.generateCellUri=ie;function re(N,V){if(N.scheme!==V)return;const x=l.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellUri=re})(f=e.CellUri||(e.CellUri={}));const E=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function w(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=w;function _(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=_;function u(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=u;function c(b,l){return T.isWindows&&(b=b.replace(/\//g,"\\"),l=l.replace(/\//g,"\\")),v.match(b,l)}function h(b,l,L){let O=0;for(let W=0;W<l.length;W++){if(c(l[W],b))return O;O++}for(let W=0;W<L.length;W++){if(c(L[W],b))return O;O++}return O}function t(b,l,L){return b.sort((O,W)=>h(O,l,L)-h(W,l,L))}e.sortMimeTypes=t;function n(b,l,L,O=(W,ie)=>W===ie){const W=[];function ie(V,x,k){if(x===0&&k.length===0)return;const U=W[W.length-1];U&&U.start+U.deleteCount===V?(U.deleteCount+=x,U.toInsert.push(...k)):W.push({start:V,deleteCount:x,toInsert:k})}let re=0,N=0;for(;;){if(re===b.length){ie(re,0,l.slice(N));break}if(N===l.length){ie(re,b.length-re,[]);break}const V=b[re],x=l[N];if(O(V,x)){re+=1,N+=1;continue}L(x)?(ie(re,1,[]),re+=1):(ie(re,0,[x]),N+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(b){b.default="default",b.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(b){const l=b;return!!((typeof l.include=="string"||v.isRelativePattern(l.include))&&(typeof l.exclude=="string"||v.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=r;function o(b,l,L){if(Array.isArray(b.viewType)&&b.viewType.indexOf(l)>=0||b.viewType===l)return!0;if(b.filenamePattern){let O=r(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,W=r(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(v.match(O,(0,C.basename)(L.fsPath).toLowerCase()))return!(W&&v.match(W,(0,C.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class g{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)l[L]=this.textModel.cells[L].getHashValue();return l}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled";var m;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(l){return`${S._prefix}${l}`}static parse(l){if(l.startsWith(S._prefix))return l.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(me[206],ge([0,1,172,4,81]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[207],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=v;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(me[123],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=R;var C;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=T;class y{add(P){}update(P){}remove(P,i){}complete(){}}e.IncrementalChangeCollector=y;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const i=this.createChangeCollector();for(const A of P)switch(A[0]){case 0:{const d=A[1];if(d.parent){if(this.items.has(d.parent)){const p=this.items.get(d.parent);p.children.add(d.item.extId);const a=this.createItem(d,p);this.items.set(d.item.extId,a),i.add(a)}}else{this.roots.add(d.item.extId);const p=this.createItem(d);this.items.set(d.item.extId,p),i.add(p)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=A[1],p=this.items.get(d.extId);if(!p)break;d.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,d),i.update(p);break}case 2:{const d=this.items.get(A[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const p=[[A[1]]];for(;p.length;)for(const a of p.pop()){const f=this.items.get(a);f&&(p.push(f.children),this.items.delete(a),i.remove(f,f!==d),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(A[1]);break;case 3:this.updatePendingRoots(A[1]);break}i.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=I}),define(me[208],ge([0,1,9,36,12,24,11,77,173]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(A,d,p){this._contributedVariables=new Map,this._context=A,this._labelService=d,p&&(this._envVariablesPromise=p.then(a=>this.prepareEnv(a)))}prepareEnv(A){if(y.isWindows){const d=Object.create(null);return Object.keys(A).forEach(p=>{d[p.toLowerCase()]=A[p]}),d}return A}resolveWithEnvironment(A,d,p){return this.recursiveResolve(this.prepareEnv(A),d?d.uri:void 0,p)}async resolveAsync(A,d){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,d)}async resolveAnyBase(A,d,p,a){const f=T.deepClone(d);return y.isWindows&&f.windows?Object.keys(f.windows).forEach(E=>f[E]=f.windows[E]):y.isMacintosh&&f.osx?Object.keys(f.osx).forEach(E=>f[E]=f.osx[E]):y.isLinux&&f.linux&&Object.keys(f.linux).forEach(E=>f[E]=f.linux[E]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,f,p,a)}async resolveAnyAsync(A,d,p){return this.resolveAnyBase(A,d,p)}async resolveAnyMap(A,d,p){const a=new Map;return{newConfig:await this.resolveAnyBase(A,d,p,a),resolvedVariables:a}}resolveWithInteractionReplace(A,d,p,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,d,p,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,d){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,d)}recursiveResolve(A,d,p,a,f){if(C.isString(p))return this.resolveString(A,d,p,a,f);if(C.isArray(p))return p.map(E=>this.recursiveResolve(A,d,E,a,f));if(C.isObject(p)){let E=Object.create(null);return Object.keys(p).forEach(w=>{const _=this.resolveString(A,d,w,a,f);E[_]=this.recursiveResolve(A,d,p[w],a,f)}),E}return p}resolveString(A,d,p,a,f){return p.replace(P.VARIABLE_REGEXP,(w,_)=>{if(_.includes(P.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(A,w,_,d,a);return f&&f.set(_,u),u})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,d,p,a,f){let E;const w=p.split(":");w.length>1&&(p=w[0],E=w[1]);const _=()=>{const h=this._context.getFilePath();if(h)return h;throw new Error((0,D.localize)(0,null,d))},u=()=>{const h=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,d,v.basename(h)))},c=()=>{if(E){const h=this._context.getFolderUri(E);if(h)return h;throw new Error((0,D.localize)(2,null,d,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,d)):new Error((0,D.localize)(4,null,d))};switch(p){case"env":if(E){if(A){const h=A[y.isWindows?E.toLowerCase():E];if(C.isString(h))return h}return""}throw new Error((0,D.localize)(5,null,d));case"config":if(E){const h=this._context.getConfigurationValue(a,E);if(C.isUndefinedOrNull(h))throw new Error((0,D.localize)(6,null,d,E));if(C.isObject(h))throw new Error((0,D.localize)(7,null,d,E));return h}throw new Error((0,D.localize)(8,null,d));case"command":return this.resolveFromMap(d,E,f,"command");case"input":return this.resolveFromMap(d,E,f,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return a||E?(0,I.normalizeDriveLetter)(this.fsPath(c())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(c()));case"lineNumber":const h=this._context.getLineNumber();if(h)return h;throw new Error((0,D.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,d));case"file":return _();case"fileWorkspaceFolder":return u();case"relativeFile":return a||E?v.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const n=v.dirname(_());if(a||E){const g=v.relative(this.fsPath(c()),n);return g.length===0?".":g}return n;case"fileDirname":return v.dirname(_());case"fileExtname":return v.extname(_());case"fileBasename":return v.basename(_());case"fileBasenameNoExtension":const s=v.basename(_());return s.slice(0,s.length-v.extname(s).length);case"fileDirnameBasename":return v.basename(v.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||d;case"execInstallFolder":const o=this._context.getAppRoot();return o||d;case"pathSeparator":return v.sep;default:try{const g=E?`${p}:${E}`:p;return this.resolveFromMap(d,g,f,void 0)}catch(g){return d}}}}resolveFromMap(A,d,p,a){if(d&&p){const f=a===void 0?p[d]:p[a+":"+d];if(typeof f=="string")return f;throw new Error((0,D.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[209],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function A(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=A}),define(me[210],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,96,281,58,24,12,2,42,80,174,113,64,210,7]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function he(Y){const{selectionStartLineNumber:Me,selectionStartColumn:Fe,positionLineNumber:Je,positionColumn:Ze}=Y,ht=new f.Position(Me-1,Fe-1),ct=new f.Position(Je-1,Ze-1);return new f.Selection(ht,ct)}Ee.to=he;function ue(Y){const{anchor:Me,active:Fe}=Y;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Ee.from=ue})(E=e.Selection||(e.Selection={}));var w;(function(Ee){function he(Y){if(!Y)return;const{start:Me,end:Fe}=Y;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Ee.from=he;function ue(Y){if(!Y)return;const{startLineNumber:Me,startColumn:Fe,endLineNumber:Je,endColumn:Ze}=Y;return new f.Range(Me-1,Fe-1,Je-1,Ze-1)}Ee.to=ue})(w=e.Range||(e.Range={}));var _;(function(Ee){function he(ue){switch(ue){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}Ee.to=he})(_=e.TokenType||(e.TokenType={}));var u;(function(Ee){function he(Y){return new f.Position(Y.lineNumber-1,Y.column-1)}Ee.to=he;function ue(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=ue})(u=e.Position||(e.Position={}));var c;(function(Ee){function he(Y){switch(Y){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}Ee.from=he;function ue(Y){switch(Y){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=ue})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Ee){function he(Y){let Me;return Y.code&&((0,I.isString)(Y.code)||(0,I.isNumber)(Y.code)?Me=String(Y.code):Me={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},w.from(Y.range)),{message:Y.message,source:Y.source,code:Me,severity:n.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,v.coalesce)(Y.tags.map(c.from)):void 0})}Ee.from=he;function ue(Y){var Me;const Fe=new f.Diagnostic(w.to(Y),Y.message,n.to(Y.severity));return Fe.source=Y.source,Fe.code=(0,I.isString)(Y.code)?Y.code:(Me=Y.code)===null||Me===void 0?void 0:Me.value,Fe.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Fe.tags=Y.tags&&(0,v.coalesce)(Y.tags.map(c.to)),Fe}Ee.to=ue})(h=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function he(Y){return Object.assign(Object.assign({},w.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}Ee.from=he;function ue(Y){return new f.DiagnosticRelatedInformation(new f.Location(Y.resource,w.to(Y)),Y.message)}Ee.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Ee){function he(Y){switch(Y){case f.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ee.from=he;function ue(Y){switch(Y){case d.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=ue})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(Ee){function he(Y){return typeof Y=="number"&&Y>=f.ViewColumn.One?Y-1:Y===f.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=he;function ue(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ue})(s=e.ViewColumn||(e.ViewColumn={}));function r(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!r(Ee[0])}e.isDecorationOptionsArr=o;var g;(function(Ee){function he(Ze){return Ze.map(Ee.from)}Ee.fromMany=he;function ue(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Y(Ze){let ht;if(ue(Ze)){const{language:dt,value:at}=Ze;ht={value:"```"+dt+`
`+at+"\n```\n"}}else f.MarkdownString.isMarkdownString(Ze)?ht={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ht={value:Ze}:ht={value:""};const ct=Object.create(null);ht.uris=ct;const it=dt=>{try{let at=D.URI.parse(dt,!0);at=at.with({query:Me(at.query,ct)}),ct[dt]=at}catch(at){}return""},pt=new C.Renderer;return pt.link=it,pt.image=dt=>it(R.parseHrefAndDimensions(dt).href),C(ht.value,{renderer:pt}),ht}Ee.from=Y;function Me(Ze,ht){if(!Ze)return Ze;let ct;try{ct=(0,T.parse)(Ze)}catch(pt){}if(!ct)return Ze;let it=!1;return ct=(0,y.cloneAndChange)(ct,pt=>{if(D.URI.isUri(pt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=pt,it=!0,dt}else return}),it?JSON.stringify(ct):Ze}function Fe(Ze){const ht=new f.MarkdownString(Ze.value,Ze.supportThemeIcons);return ht.isTrusted=Ze.isTrusted,ht}Ee.to=Fe;function Je(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return o(Ee)?Ee.map(he=>({range:w.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?g.fromMany(he.hoverMessage):he.hoverMessage?g.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):Ee.map(he=>({range:w.from(he)}))}e.fromRangeOrRangeWithMessage=m;function S(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=S;var b;(function(Ee){function he(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?S(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}Ee.from=he})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var l;(function(Ee){function he(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?S(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?b.from(ue.before):void 0,after:ue.after?b.from(ue.after):void 0}}Ee.from=he})(l=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function he(ue){if(typeof ue=="undefined")return ue;switch(ue){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=he})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(Ee){function he(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?L.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?l.from(ue.light):void 0,dark:ue.dark?l.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?S(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?b.from(ue.before):void 0,after:ue.after?b.from(ue.after):void 0}}Ee.from=he})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(Ee){function he(Y){return{text:Y.newText,eol:Y.newEol&&ne.from(Y.newEol),range:w.from(Y.range)}}Ee.from=he;function ue(Y){const Me=new f.TextEdit(w.to(Y.range),Y.text);return Me.newEol=typeof Y.eol=="undefined"?void 0:ne.to(Y.eol),Me}Ee.to=ue})(W=e.TextEdit||(e.TextEdit={}));var ie;(function(Ee){function he(Y,Me,Fe){var Je,Ze,ht;const ct={edits:[]};if(Y instanceof f.WorkspaceEdit)for(let it of Y._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const pt=Me==null?void 0:Me.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:pt==null?void 0:pt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Je=Fe==null?void 0:Fe.getNotebookDocument(it.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(Ae.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(Ze=Fe==null?void 0:Fe.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(le.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ht=it.newOutputItems)===null||ht===void 0?void 0:ht.map(Pe.from))||[],append:it.append}});return ct}Ee.from=he;function ue(Y){const Me=new f.WorkspaceEdit;for(const Fe of Y.edits)Fe.edit?Me.replace(D.URI.revive(Fe.resource),w.to(Fe.edit.range),Fe.edit.text):Me.renameFile(D.URI.revive(Fe.oldUri),D.URI.revive(Fe.newUri),Fe.options);return Me}Ee.to=ue})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var re;(function(Ee){const he=Object.create(null);he[f.SymbolKind.File]=0,he[f.SymbolKind.Module]=1,he[f.SymbolKind.Namespace]=2,he[f.SymbolKind.Package]=3,he[f.SymbolKind.Class]=4,he[f.SymbolKind.Method]=5,he[f.SymbolKind.Property]=6,he[f.SymbolKind.Field]=7,he[f.SymbolKind.Constructor]=8,he[f.SymbolKind.Enum]=9,he[f.SymbolKind.Interface]=10,he[f.SymbolKind.Function]=11,he[f.SymbolKind.Variable]=12,he[f.SymbolKind.Constant]=13,he[f.SymbolKind.String]=14,he[f.SymbolKind.Number]=15,he[f.SymbolKind.Boolean]=16,he[f.SymbolKind.Array]=17,he[f.SymbolKind.Object]=18,he[f.SymbolKind.Key]=19,he[f.SymbolKind.Null]=20,he[f.SymbolKind.EnumMember]=21,he[f.SymbolKind.Struct]=22,he[f.SymbolKind.Event]=23,he[f.SymbolKind.Operator]=24,he[f.SymbolKind.TypeParameter]=25;function ue(Me){return typeof he[Me]=="number"?he[Me]:6}Ee.from=ue;function Y(Me){for(const Fe in he)if(he[Fe]===Me)return Number(Fe);return f.SymbolKind.Property}Ee.to=Y})(re=e.SymbolKind||(e.SymbolKind={}));var N;(function(Ee){function he(Y){switch(Y){case f.SymbolTag.Deprecated:return 1}}Ee.from=he;function ue(Y){switch(Y){case 1:return f.SymbolTag.Deprecated}}Ee.to=ue})(N=e.SymbolTag||(e.SymbolTag={}));var V;(function(Ee){function he(Y){return{name:Y.name,kind:re.from(Y.kind),tags:Y.tags&&Y.tags.map(N.from),containerName:Y.containerName,location:M.from(Y.location)}}Ee.from=he;function ue(Y){const Me=new f.SymbolInformation(Y.name,re.to(Y.kind),Y.containerName,M.to(Y.location));return Me.tags=Y.tags&&Y.tags.map(N.to),Me}Ee.to=ue})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(Ee){function he(Y){var Me,Fe;const Je={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:re.from(Y.kind),tags:(Fe=(Me=Y.tags)===null||Me===void 0?void 0:Me.map(N.from))!==null&&Fe!==void 0?Fe:[]};return Y.children&&(Je.children=Y.children.map(he)),Je}Ee.from=he;function ue(Y){const Me=new f.DocumentSymbol(Y.name,Y.detail,re.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return(0,v.isNonEmptyArray)(Y.tags)&&(Me.tags=Y.tags.map(N.to)),Y.children&&(Me.children=Y.children.map(ue)),Me}Ee.to=ue})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var k;(function(Ee){function he(ue){const Y=new f.CallHierarchyItem(re.to(ue.kind),ue.name,ue.detail||"",D.URI.revive(ue.uri),w.to(ue.range),w.to(ue.selectionRange));return Y._sessionId=ue._sessionId,Y._itemId=ue._itemId,Y}Ee.to=he})(k=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(Ee){function he(ue){return new f.CallHierarchyIncomingCall(k.to(ue.from),ue.fromRanges.map(Y=>w.to(Y)))}Ee.to=he})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ee){function he(ue){return new f.CallHierarchyOutgoingCall(k.to(ue.to),ue.fromRanges.map(Y=>w.to(Y)))}Ee.to=he})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function he(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}Ee.from=he;function ue(Y){return new f.Location(D.URI.revive(Y.uri),w.to(Y.range))}Ee.to=ue})(M=e.location||(e.location={}));var $;(function(Ee){function he(Y){const Me=Y,Fe=Y;return{originSelectionRange:Me.originSelectionRange?w.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Fe.uri,range:w.from(Me.targetRange?Me.targetRange:Fe.range),targetSelectionRange:Me.targetSelectionRange?w.from(Me.targetSelectionRange):void 0}}Ee.from=he;function ue(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}Ee.to=ue})($=e.DefinitionLink||(e.DefinitionLink={}));var H;(function(Ee){function he(Y){return{range:w.from(Y.range),contents:g.fromMany(Y.contents)}}Ee.from=he;function ue(Y){return new f.Hover(Y.contents.map(g.to),w.to(Y.range))}Ee.to=ue})(H=e.Hover||(e.Hover={}));var Q;(function(Ee){function he(Y){return{range:w.from(Y.range),expression:Y.expression}}Ee.from=he;function ue(Y){return new f.EvaluatableExpression(w.to(Y.range),Y.expression)}Ee.to=ue})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Ee){function he(Y){if(Y instanceof f.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=he;function ue(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}Ee.to=ue})(ae=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function he(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}Ee.from=he;function ue(Y){return new f.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}Ee.to=ue})(we=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(Ee){function he(Y){return{range:w.from(Y.range),kind:Y.kind}}Ee.from=he;function ue(Y){return new f.DocumentHighlight(w.to(Y.range),Y.kind)}Ee.to=ue})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(Ee){function he(ue){switch(ue){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}Ee.to=he})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(Ee){function he(ue){return{triggerKind:Ie.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}Ee.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var We;(function(Ee){function he(Y){switch(Y){case f.CompletionItemTag.Deprecated:return 1}}Ee.from=he;function ue(Y){switch(Y){case 1:return f.CompletionItemTag.Deprecated}}Ee.to=ue})(We=e.CompletionItemTag||(e.CompletionItemTag={}));var j;(function(Ee){const he=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ue(Fe){var Je;return(Je=he.get(Fe))!==null&&Je!==void 0?Je:9}Ee.from=ue;const Y=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Me(Fe){var Je;return(Je=Y.get(Fe))!==null&&Je!==void 0?Je:f.CompletionItemKind.Property}Ee.to=Me})(j=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Ee){function he(ue,Y){var Me;const Fe=new f.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Fe.label2=ue.label),Fe.insertText=ue.insertText,Fe.kind=j.to(ue.kind),Fe.tags=(Me=ue.tags)===null||Me===void 0?void 0:Me.map(We.to),Fe.detail=ue.detail,Fe.documentation=R.isMarkdownString(ue.documentation)?g.to(ue.documentation):ue.documentation,Fe.sortText=ue.sortText,Fe.filterText=ue.filterText,Fe.preselect=ue.preselect,Fe.commitCharacters=ue.commitCharacters,P.Range.isIRange(ue.range)?Fe.range=w.to(ue.range):typeof ue.range=="object"&&(Fe.range={inserting:w.to(ue.range.insert),replacing:w.to(ue.range.replace)}),Fe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Fe.insertText=new f.SnippetString(ue.insertText):(Fe.insertText=ue.insertText,Fe.textEdit=Fe.range instanceof f.Range?new f.TextEdit(Fe.range,Fe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ue.additionalTextEdits.map(Je=>W.to(Je))),Fe.command=Y&&ue.command?Y.fromInternal(ue.command):void 0,Fe}Ee.to=he})(X=e.CompletionItem||(e.CompletionItem={}));var ee;(function(Ee){function he(Y){return{label:Y.label,documentation:Y.documentation?g.fromStrict(Y.documentation):void 0}}Ee.from=he;function ue(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation}}Ee.to=ue})(ee=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(Ee){function he(Y){return{label:Y.label,documentation:Y.documentation?g.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ee.from):[],activeParameter:Y.activeParameter}}Ee.from=he;function ue(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ee.to):[],activeParameter:Y.activeParameter}}Ee.to=ue})(oe=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(Ee){function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(oe.from):[]}}Ee.from=he;function ue(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(oe.to):[]}}Ee.to=ue})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Se;(function(Ee){function he(Y){var Me;return{text:Y.text,position:u.from(Y.position),kind:ce.from((Me=Y.kind)!==null&&Me!==void 0?Me:f.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}Ee.from=he;function ue(Y){const Me=new f.InlayHint(Y.text,u.to(Y.position),ce.to(Y.kind));return Me.whitespaceAfter=Y.whitespaceAfter,Me.whitespaceBefore=Y.whitespaceBefore,Me}Ee.to=ue})(Se=e.InlayHint||(e.InlayHint={}));var ce;(function(Ee){function he(Y){return Y}Ee.from=he;function ue(Y){return Y}Ee.to=ue})(ce=e.InlayHintKind||(e.InlayHintKind={}));var _e;(function(Ee){function he(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=he;function ue(Y){let Me;if(Y.url)try{Me=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(Fe){}return new f.DocumentLink(w.to(Y.range),Me)}Ee.to=ue})(_e=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function he(Y){const Me=new f.ColorPresentation(Y.label);return Y.textEdit&&(Me.textEdit=W.to(Y.textEdit)),Y.additionalTextEdits&&(Me.additionalTextEdits=Y.additionalTextEdits.map(Fe=>W.to(Fe))),Me}Ee.to=he;function ue(Y){return{label:Y.label,textEdit:Y.textEdit?W.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Me=>W.from(Me)):void 0}}Ee.from=ue})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Ve;(function(Ee){function he(Y){return new f.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=he;function ue(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=ue})(Ve=e.Color||(e.Color={}));var be;(function(Ee){function he(Y){return{range:w.from(Y.range)}}Ee.from=he;function ue(Y){return new f.SelectionRange(w.to(Y.range))}Ee.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(Ee){function he(ue){switch(ue){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}Ee.to=he})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(Ee){function he(Y){switch(Y){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=he;function ue(Y){switch(Y){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=ue})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(Ee){function he(Y){if(Y===f.EndOfLine.CRLF)return 1;if(Y===f.EndOfLine.LF)return 0}Ee.from=he;function ue(Y){if(Y===1)return f.EndOfLine.CRLF;if(Y===0)return f.EndOfLine.LF}Ee.to=ue})(ne=e.EndOfLine||(e.EndOfLine={}));var ve;(function(Ee){function he(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=he})(ve=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(Ee){function he(ue){const Y={start:ue.start+1,end:ue.end+1};return ue.kind&&(Y.kind=je.from(ue.kind)),Y}Ee.from=he})(xe=e.FoldingRange||(e.FoldingRange={}));var je;(function(Ee){function he(ue){if(ue)switch(ue){case f.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Ee.from=he})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ze;(function(Ee){function he(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?w.from(ue.selection):void 0,override:typeof ue.override=="boolean"?A.EditorOverride.DISABLED:void 0}}Ee.from=he})(ze=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(Ee){function he(Y){return Y instanceof f.RelativePattern||typeof Y=="string"?Y:ue(Y)?new f.RelativePattern(Y.base,Y.pattern):Y}Ee.from=he;function ue(Y){const Me=Y;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Ee){function he(ue){if(ue){if(Array.isArray(ue))return ue.map(he);if(typeof ue=="string")return ue;{const Y=ue;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Xe.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=he})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var De;(function(Ee){function he(Y){return{start:Y.start,end:Y.end}}Ee.from=he;function ue(Y){return new f.NotebookRange(Y.start,Y.end)}Ee.to=ue})(De=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Ee){function he(ue){return new f.NotebookCellMetadata().with(Object.assign(Object.assign({},ue),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}Ee.to=he})(ke=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var se;(function(Ee){function he(Y){return Y}Ee.from=he;function ue(Y){return new f.NotebookDocumentMetadata().with(Y)}Ee.to=ue})(se=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var de;(function(Ee){function he(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=he;function ue(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}Ee.from=ue})(de=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var z;(function(Ee){function he(Y){switch(Y){case f.NotebookCellKind.Markup:return p.CellKind.Markup;case f.NotebookCellKind.Code:default:return p.CellKind.Code}}Ee.from=he;function ue(Y){switch(Y){case p.CellKind.Markup:return f.NotebookCellKind.Markup;case p.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=ue})(z=e.NotebookCellKind||(e.NotebookCellKind={}));var J;(function(Ee){function he(Y){const Me={metadata:se.from(Y.metadata),cells:[]};for(let Fe of Y.cells)f.NotebookCellData.validate(Fe),Me.cells.push(le.from(Fe));return Me}Ee.from=he;function ue(Y){return{metadata:se.to(Y.metadata),cells:Y.cells.map(le.to)}}Ee.to=ue})(J=e.NotebookData||(e.NotebookData={}));var le;(function(Ee){function he(Y){var Me;return{cellKind:z.from(Y.kind),language:Y.languageId,source:Y.value,metadata:Y.metadata,internalMetadata:de.from((Me=Y.executionSummary)!==null&&Me!==void 0?Me:{}),outputs:Y.outputs?Y.outputs.map(Ae.from):[]}}Ee.from=he;function ue(Y){return new f.NotebookCellData(z.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(Ae.to):void 0,Y.metadata?ke.to(Y.metadata):void 0)}Ee.to=ue})(le=e.NotebookCellData||(e.NotebookCellData={}));var Pe;(function(Ee){function he(Y){let Me,Fe;return Y.data instanceof Uint8Array?Fe=Array.from(Y.data):Me=Y.value,{metadata:Y.metadata,mime:Y.mime,value:Me,valueBytes:Fe}}Ee.from=he;function ue(Y){let Me;return Array.isArray(Y.valueBytes)?Me=new Uint8Array(Y.valueBytes):Me=Y.value,new f.NotebookCellOutputItem(Me,Y.mime,Y.metadata)}Ee.to=ue})(Pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Ee){function he(Y){return{outputId:Y.id,outputs:Y.outputs.map(Pe.from),metadata:Y.metadata}}Ee.from=he;function ue(Y){const Me=Y.outputs.map(Pe.to);return new f.NotebookCellOutput(Me,Y.outputId,Y.metadata)}Ee.to=ue})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ue;(function(Ee){function he(Fe){if(Fe!=null){if(Fe instanceof f.RelativePattern||typeof Fe=="string")return Fe;if(Me(Fe))return new f.RelativePattern(Fe.base,Fe.pattern);if(Y(Fe))return{include:Xe.from(Fe.include)||void 0,exclude:Xe.from(Fe.exclude)||void 0}}}Ee.from=he;function ue(Fe){return typeof Fe=="string"?Fe:Me(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}Ee.to=ue;function Y(Fe){const Je=Fe,Ze=Xe.from(Je.include);if(!(Ze&&Ze instanceof f.RelativePattern||typeof Ze=="string"))return!1;const ht=Xe.from(Je.exclude);return!!(ht&&ht instanceof f.RelativePattern||typeof ht=="string")}function Me(Fe){const Je=Fe;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ue=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Be;(function(Ee){function he(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?b.from(ue.top):void 0}}Ee.from=he})(Be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(Ee){function he(ue,Y,Me){const Fe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Fe,Me),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}Ee.from=he})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(Ee){function he(ue){var Y,Me,Fe;return{transientOutputs:(Y=ue==null?void 0:ue.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:(Me=ue==null?void 0:ue.transientCellMetadata)!==null&&Me!==void 0?Me:{},transientDocumentMetadata:(Fe=ue==null?void 0:ue.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=he})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(Ee){function he(Y){var Me;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Me=Y.provides)!==null&&Me!==void 0?Me:[]}}Ee.from=he;function ue(Y){return new f.NotebookKernelPreload(D.URI.revive(Y.uri),Y.provides)}Ee.to=ue})(et=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ye;(function(Ee){function he(Y){return{message:g.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?M.from(Y.location):void 0}}Ee.from=he;function ue(Y){const Me=new f.TestMessage(typeof Y.message=="string"?Y.message:g.to(Y.message));return Me.severity=Y.severity,Me.actualOutput=Y.actualOutput,Me.expectedOutput=Y.expectedOutput,Me}Ee.to=ue})(Ye=e.TestMessage||(e.TestMessage={}));var ot;(function(Ee){function he(Fe){var Je,Ze;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:(Je=Fe.debuggable)!==null&&Je!==void 0?Je:!1,description:Fe.description||null,runnable:(Ze=Fe.runnable)!==null&&Ze!==void 0?Ze:!0,error:Fe.error&&g.fromStrict(Fe.error)||null}}Ee.from=he;function ue(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=ue;function Y(Fe){return{id:Fe.extId,label:Fe.label,uri:D.URI.revive(Fe.uri),range:w.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:f.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}Ee.toPlain=Y;function Me(Fe){const Je=new f.TestItemImpl(Fe.extId,Fe.label,D.URI.revive(Fe.uri),void 0);return Je.range=w.to(Fe.range||void 0),Je.debuggable=Fe.debuggable,Je.description=Fe.description||void 0,Je.runnable=Fe.runnable,Je}Ee.to=Me})(ot=e.TestItem||(e.TestItem={}));var Et;(function(Ee){const he=(Y,Me)=>Object.assign(Object.assign({},ot.toPlain(Y.item)),{taskStates:Y.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(Ye.to)})),children:Y.children.map(Fe=>Me.get(Fe)).filter(I.isDefined).map(Fe=>he(Fe,Me))});function ue(Y){const Me=[],Fe=new Map;for(const Je of Y.items)Fe.set(Je.item.extId,Je),Je.direct&&Me.push(Je);return{completedAt:Y.completedAt,results:Me.map(Je=>he(Je,Fe))}}Ee.to=ue})(Et=e.TestResults||(e.TestResults={}));var bt;(function(Ee){function he(ue){switch(ue){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}Ee.to=he})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[211],ge([0,1,2,17,7,20,56]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,i,A,d={timeout:1500,errors:3}){this._logService=P,this._documents=i,this._mainThreadBulkEdits=A,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(i,A,d)=>{const a={dispose:this._callbacks.push([i,A,P])};return Array.isArray(d)&&d.push(a),a}}async $participateInSave(P,i){const A=v.URI.revive(P);let d=!1;const p=setTimeout(()=>d=!0,this._thresholds.timeout),a=[];try{for(let f of[...this._callbacks]){if(d)break;const E=this._documents.getDocument(A),w=await this._deliverEventAsyncAndBlameBadListeners(f,{document:E,reason:T.TextDocumentSaveReason.to(i)});a.push(w)}}finally{clearTimeout(p)}return a}_deliverEventAsyncAndBlameBadListeners([P,i,A],d){const p=this._badListeners.get(P);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,P,i,d).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const f=this._badListeners.get(P);this._badListeners.set(P,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,i,A,d){const p=[],a=Date.now(),{document:f,reason:E}=d,{version:w}=f,_=Object.freeze({document:f,reason:E,waitUntil(u){if(Object.isFrozen(p))throw(0,R.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(u))}});try{i.apply(A,[_])}catch(u){return Promise.reject(u)}return Object.freeze(p),new Promise((u,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(h),u(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(u=>{const c={edits:[]};for(const h of u)if(Array.isArray(h)&&h.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:s}of h)c.edits.push({_type:2,resource:f.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(c.edits.length!==0)return w===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(me[212],ge([0,1,3,13,31,2,20,7]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(A,d,p,a,f){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,p&&(this._config+=1),a&&(this._config+=2),f&&(this._config+=4);const E=(0,C.parse)(d),w=A(_=>{if(!p)for(let u of _.created){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidCreate.fire(c)}if(!a)for(let u of _.changed){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidChange.fire(c)}if(!f)for(let u of _.deleted){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(A,d,p){this._logService=d,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,d,p,a){return new D(this._onFileSystemEvent.event,A,d,p,a)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,d){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(p=>({oldUri:T.URI.revive(p.source),newUri:T.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(p=>T.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(p=>T.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,d){return(p,a,f)=>{const E=function(_){p.call(a,_)};return E.extension=A,d.event(E,void 0,f)}}async $onWillRunFileOperation(A,d,p,a){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))},p,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(f=>T.URI.revive(f.target))},p,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(f=>T.URI.revive(f.target))},p,a)}}async _fireWillEvent(A,d,p,a){const f=new Set,E=[];if(await A.fireAsync(d,a,async(_,u)=>{var c;const h=Date.now(),t=await Promise.resolve(_);t instanceof I.WorkspaceEdit&&(E.push(t),f.add((c=u.extension.displayName)!==null&&c!==void 0?c:u.extension.identifier.value)),Date.now()-h>p&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),a.isCancellationRequested||E.length===0)return;const w={edits:[]};for(let _ of E){let{edits:u}=y.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=P}),define(me[213],ge([0,1,10,24,2,20,7,64]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(d,p,a,f){this.start=d,this.deletedCount=p,this.deletedItems=a,this.items=f}static asApiEvents(d){return d.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(a=>a.apiCell)}))}}class P{constructor(d,p,a){var f,E,w;this.notebook=d,this._extHostDocument=p,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(f=a.internalMetadata)!==null&&f!==void 0?f:{},this._metadata=T.NotebookCellMetadata.to((E=a.metadata)!==null&&E!==void 0?E:{}),this._previousResult=T.NotebookCellExecutionSummary.to((w=a.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(d,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,p,a){const f=a.map(T.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===d);E&&(p||(E.outputs.length=0),E.outputs.push(...f))}setMetadata(d){this._metadata=T.NotebookCellMetadata.to(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=T.NotebookCellExecutionSummary.to(d)}}e.ExtHostCell=P;class i{constructor(d,p,a,f,E,w,_){this._proxy=d,this._textDocumentsAndEditors=p,this._textDocuments=a,this._emitter=f,this._viewType=E,this._metadata=w,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===v.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(p){return p=d._validateIndex(p),d._cells[p].apiCell},getCells(p){return(p?d._getCells(p):d._cells).map(f=>f.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,p){this._versionId=d.versionId,this._isDirty=p;for(const a of d.rawEvents)a.kind===I.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===I.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let p=d.start|0,a=d.end|0;return p<0&&(p=0),a>this._cells.length&&(a=this._cells.length),d.with({start:p,end:a})}_getCells(d){d=this._validateRange(d);const p=[];for(let a=d.start;a<d.end;a++)p.push(this._cells[a]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,p){if(this._disposed)return;const a=[],f=[],E=[];d.reverse().forEach(w=>{const u=w[2].map(t=>{const n=new P(this,this._textDocumentsAndEditors,t);return p||f.push(P.asModelAddData(this.apiNotebook,t)),n}),c=new D(w[0],w[1],[],u),h=this._cells.splice(w[0],w[1],...u);for(const t of h)E.push(t.uri),c.deletedItems.push(t.apiCell);a.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:E}),p||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(d,p){const a=this._cells.splice(d,1);this._cells.splice(p,0,...a);const f=[new D(d,1,a.map(E=>E.apiCell),[]),new D(p,0,[],a)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(f)}))}_setCellOutputs(d,p){const a=this._cells[d];a.setOutputs(p),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(d,p,a,f){const E=this._cells[d];E.setOutputItems(p,a,f),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(d,p){const a=this._cells[d];a.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(a.uri,p)}_changeCellMetadata(d,p){const a=this._cells[d],f=a.apiCell.metadata;a.setMetadata(p);const E=a.apiCell.metadata;(0,R.equals)(f,E)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(d,p){var a;const f=this._cells[d],E=f.internalMetadata;if(f.setInternalMetadata(p),E.runState!==p.runState){const w=(a=p.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,executionState:w}))}}getCellFromApiCell(d){return this._cells.find(p=>p.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(p=>p.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[124],ge([0,1,7,20]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(I){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=I}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(I){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:I})}replaceCellMetadata(I,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:I,metadata:D})}replaceCells(I,D,P){this._throwIfFinalized(),!(I===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:I,count:D-I,cells:P.map(R.NotebookCellData.from)})}}class T{constructor(I,D,P,i,A,d){this.id=I,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=A,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get selections(){return I._selections},get visibleRanges(){return I._visibleRanges},revealRange(D,P){I._proxy.$tryRevealRange(I.id,R.NotebookRange.from(D),P!=null?P:v.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn},edit(D){const P=new C(this.document.version);return D(P),I._applyEdit(P.finalize())},setDecorations(D,P){return I.setDecorations(D,P)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_acceptViewColumn(I){this._viewColumn=I}_applyEdit(I){if(I.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let i=0;i<I.cellEdits.length;i++){if(P<0){D.push(I.cellEdits[i]),P++;continue}const d=D[P],p=I.cellEdits[i];if(d.editType===1&&p.editType===1&&d.index===p.index){d.cells.push(...I.cellEdits[i].cells),d.count+=I.cellEdits[i].count;continue}D.push(I.cellEdits[i]),P++}return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,D)}setDecorations(I,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(I.key)))return D.isEmpty?this._hasDecorationsForKey.delete(I.key):this._hasDecorationsForKey.add(I.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),I.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[214],ge([0,1,20,114,162,21,53]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,d,p){const a=this._handles++,{title:f,location:E,cancellable:w}=d,_={label:(0,C.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(a,{location:v.ProgressLocation.from(E),title:f,source:_,cancellable:w},A),this._withProgress(a,p,!!w)}_withProgress(A,d,p){let a;p&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,a));const f=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let E;try{E=d(new P(this._proxy,A),p&&a?a.token:T.CancellationToken.None)}catch(w){throw f(A),w}return E.then(w=>f(A),w=>f(A)),E}$acceptProgressCanceled(A){const d=this._mapHandleToCancellationSource.get(A);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=I;function D(i,A){return i.message=A.message,typeof A.increment=="number"&&(typeof i.increment=="number"?i.increment+=A.increment:i.increment=A.increment),i}class P extends R.Progress{constructor(A,d){super(p=>this.throttledReport(p));this._proxy=A,this._handle=d}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}qe([(0,y.throttle)(100,(i,A)=>D(i,A),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[125],ge([0,1,51,17,73,20,7]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(d,p){const a=I._Keys.nextId();d.$registerTextEditorDecorationType(a,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){d.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(d,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,p){this._throwIfFinalized();let a=null;if(d instanceof y.Position)a=new y.Range(d,d);else if(d instanceof y.Range)a=d;else throw new Error("Unrecognized location");this._pushEdit(a,p,!1)}insert(d,p){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),p,!0)}delete(d){this._throwIfFinalized();let p=null;if(d instanceof y.Range)p=d;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(d,p,a){const f=this._document.validateRange(d);this._collectedEdits.push({range:f,text:p,forceMoveMarkers:a})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=D;class P{constructor(d,p,a,f){this._proxy=d,this._id=p,this._accept(a),this._logService=f;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const p=Math.floor(d);return p>0?p:null}if(typeof d=="string"){const p=parseInt(d,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(d){const p=this._validateTabSize(d);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const p=this._validateInsertSpaces(d);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const p={};let a=!1;if(typeof d.tabSize!="undefined"){const f=this._validateTabSize(d.tabSize);f==="auto"?(a=!0,p.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,a=!0,p.tabSize=f)}if(typeof d.insertSpaces!="undefined"){const f=this._validateInsertSpaces(d.insertSpaces);f==="auto"?(a=!0,p.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,a=!0,p.insertSpaces=f)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,a=!0,p.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,a=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(d){d.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=P;class i{constructor(d,p,a,f,E,w,_,u){this.id=d,this._proxy=p,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,w,a),this._visibleRanges=_,this._viewColumn=u;const c=this;this.value=Object.freeze({get document(){return f.getValue()},set document(h){throw(0,R.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(h){if(!(h instanceof y.Selection))throw(0,R.illegalArgument)("selection");c._selections=[h],c._trySetSelection()},get selections(){return c._selections},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof y.Selection)))throw(0,R.illegalArgument)("selections");c._selections=h,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(h){throw(0,R.readonly)("visibleRanges")},get options(){return c._options.value},set options(h){c._disposed||c._options.assign(h)},get viewColumn(){return c._viewColumn},set viewColumn(h){throw(0,R.readonly)("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(f.getValue(),t);return h(n),c._applyEdit(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(r=>T.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=T.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(T.Range.from(r));else{const{lineNumber:o,column:g}=T.Position.from(r);s.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return p.$tryInsertSnippet(d,h.value,s,n)},setDecorations(h,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(h.key)||(n?c._hasDecorationsForKey.delete(h.key):c._hasDecorationsForKey.add(h.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return p.$trySetDecorations(d,h.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const g=t[r];s[4*r]=g.start.line+1,s[4*r+1]=g.start.character+1,s[4*r+2]=g.end.line+1,s[4*r+3]=g.end.character+1}return p.$trySetDecorationsFast(d,h.key,s)}}))},revealRange(h,t){c._runOnProxy(()=>p.$tryRevealRange(d,T.Range.from(h),t||y.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(d,T.ViewColumn.from(h))},hide(){p.$tryHideEditor(d)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,v.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,v.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,v.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,v.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const p=d.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const a=p.edits.map(E=>E.range);a.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=a.length-1;E<w;E++){const _=a[E].end;if(a[E+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=p.edits.map(E=>({range:T.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,f,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(me[215],ge([0,1,165,25,2,3,6,13,7,12,16,20,21]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,w){if((0,P.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let _;return Array.isArray(E.highlights)&&(_=E.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),_=_.length?_:void 0),{label:E.label,highlights:_}}}class a{constructor(w,_,u){this._proxy=w,this.commands=_,this.logService=u,this.treeViews=new Map;function c(h){return h&&h.$treeViewId&&h.$treeItemHandle}_.registerArgumentProcessor({processArgument:h=>c(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(t=>c(t)?this.convertArgument(t):t):h})}registerTreeDataProvider(w,_,u){const c=this.createTreeView(w,{treeDataProvider:_},u);return{dispose:()=>c.dispose()}}createTreeView(w,_,u){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=_.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,canDragAndDrop:c}),t=this.createExtHostTreeView(w,_,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await h,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,_){const u=this.treeViews.get(w);return u?u.getChildren(_):Promise.reject(new Error((0,v.localize)(0,null,w)))}$onDrop(w,_,u){const c=this.treeViews.get(w);return c?c.onDrop(_,u):Promise.reject(new Error((0,v.localize)(1,null,w)))}async $hasResolve(w){const _=this.treeViews.get(w);if(!_)throw new Error((0,v.localize)(2,null,w));return _.hasResolve}$resolve(w,_,u){const c=this.treeViews.get(w);if(!c)throw new Error((0,v.localize)(3,null,w));return c.resolveTreeItem(_,u)}$setExpanded(w,_,u){const c=this.treeViews.get(w);if(!c)throw new Error((0,v.localize)(4,null,w));c.setExpanded(_,u)}$setSelection(w,_){const u=this.treeViews.get(w);if(!u)throw new Error((0,v.localize)(5,null,w));u.setSelection(_)}$setVisible(w,_){const u=this.treeViews.get(w);if(!u)throw new Error((0,v.localize)(6,null,w));u.setVisible(_)}createExtHostTreeView(w,_,u){const c=new f(w,_,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,c),c}convertArgument(w){const _=this.treeViews.get(w.$treeViewId);return _?_.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class f extends y.Disposable{constructor(w,_,u,c,h,t){super();if(this.viewId=w,this.proxy=u,this.commands=c,this.logService=h,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===w&&(this._title=o.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(g=>s=g),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=s;return n=null,this.refresh(o).then(()=>g())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,P.isUndefinedOrNull)(w))}getChildren(w){const _=w?this.getExtensionElement(w):void 0;if(w&&!_)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(_)).then(c=>c.map(h=>h.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,_){_=_||{select:!0,focus:!1};const u=(0,P.isUndefinedOrNull)(_.select)?!0:_.select,c=(0,P.isUndefinedOrNull)(_.focus)?!1:_.focus,h=(0,P.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:u,focus:c,expand:h})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:h})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,_){const u=this.getExtensionElement(w);u&&(_?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){(0,i.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,_){const u=w.map(h=>this.getExtensionElement(h)).filter(h=>!(0,P.isUndefinedOrNull)(h)),c=this.getExtensionElement(_);return u&&c?(0,I.asPromise)(()=>{var h;return(h=this.dndController)===null||h===void 0?void 0:h.onDrop(u,c)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,_){var u;if(!this.dataProvider.resolveTreeItem)return;const c=this.elements.get(w);if(c){const h=this.nodes.get(c);if(h){const t=(u=await this.dataProvider.resolveTreeItem(h.extensionItem,c,_))!==null&&u!==void 0?u:h.extensionItem;return h.item.tooltip=this.getTooltip(t.tooltip),h.item.command=this.getCommand(h.disposableStore,t.command),h.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(_=>_?this.resolveUnknownParentChain(_).then(u=>this.resolveTreeNode(_,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(w){const _=this.nodes.get(w);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,_){const u=this.nodes.get(w);return u?Promise.resolve(u):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>this.createHandle(w,c,_,!0)).then(c=>this.getChildren(_?_.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const t=this.nodes.get(h);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(w){if(w){let _;if(typeof w=="string"){const u=this.getExtensionElement(w);_=u?this.nodes.get(u):void 0}else _=w;return _&&_.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const _=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,c=await this.dataProvider.getChildren(w);if(_.token.isCancellationRequested)return[];const h=await Promise.all((0,i.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return _.token.isCancellationRequested?[]:(0,i.coalesce)(h)}finally{_.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const _=new Set,u=w.map(h=>this.nodes.get(h));for(const h of u)if(h&&!_.has(h.item.handle)){let t=h;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(h.item.handle)}const c=[];return _.forEach(h=>{const t=this.elements.get(h);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&c.push(h)}}),c}refreshHandles(w){const _={};return Promise.all(w.map(u=>this.refreshNode(u).then(c=>{c&&(_[u]=c.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(w){const _=this.getExtensionElement(w);if(_){const u=this.nodes.get(_);if(u)return this.clearChildren(_),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(c=>{if(c){const h=this.createTreeNode(_,c,u.parent);return this.updateNodeCache(_,h,u,u.parent),u.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,_,u){const c=this.createTreeNode(w,_,u);if(_.id&&this.elements.has(c.item.handle))throw new Error((0,v.localize)(7,null,_.id));return this.addNodeToCache(w,c),this.addNodeToParentCache(c,u),c}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?A.MarkdownString.from(w):w}getCommand(w,_){return _?this.commands.toInternal(_,w):void 0}createTreeNode(w,_,u){const c=new y.DisposableStore,h=this.createHandle(w,_,u),t=this.getLightIconPath(_);return{item:{handle:h,parentHandle:u?u.item.handle:void 0,label:p(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(c,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,P.isUndefinedOrNull)(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:_,label:u,resourceUri:c},h,t){if(_)return`${f.ID_HANDLE_PREFIX}/${_}`;const n=p(u,this.extension),s=h?h.item.handle:f.LABEL_HANDLE_PREFIX;let r=n?n.label:c?(0,R.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,g=this.getChildrenNodes(h)||[];let m,S=0;do{if(m=`${s}/${S}:${r}`,t||!this.elements.has(m)||o===m)break;S++}while(S<=g.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||C.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return C.URI.isUri(w)?w:C.URI.file(w)}addNodeToCache(w,_){this.elements.set(_.item.handle,w),this.nodes.set(w,_)}updateNodeCache(w,_,u,c){this.elements.delete(_.item.handle),this.nodes.delete(w),_.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,_);const h=this.getChildrenNodes(c)||[],t=h.filter(n=>n.item.handle===u.item.handle)[0];t&&h.splice(h.indexOf(t),1,_)}addNodeToParentCache(w,_){_?(_.children||(_.children=[]),_.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const _=this.nodes.get(w);if(_){if(_.children)for(const u of _.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}_.children=void 0}}else this.clearAll()}clear(w){const _=this.nodes.get(w);if(_){if(_.children)for(const u of _.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(w),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(me[216],ge([0,1,16,13,21,12,86,20,7,123]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const _=this.testIdsToInternal.get(w),u=_==null?void 0:_.get(E);if(u)return[_,u]}return(0,v.mapFind)(this.testIdsToInternal.values(),_=>{const u=_.get(E);return u&&[_,u]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(d++),E)}createIdMap(E){const w=new p(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=i;var A;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));let d=0;class p{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const _=typeof E=="string"?this.map.get(E):E,u=typeof w=="string"?this.map.get(w):w;if(!_||!u)return 0;if(_===u)return 3;for(let c=this.map.get(u.parent);c;c=this.map.get(c.parent))if(c===_)return 1;for(let c=this.map.get(_.parent);c;c=this.map.get(c.parent))if(c===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class a{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var _;const u=this.testIdToInternal.object.get(E);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const c=this.refreshChildren(u);return c.isSettled?this.expandChildren(u,w-1):c.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((_=u.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const _=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[u,c,h]=w;switch(c){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:_,item:{range:I.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:I.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[c]:h!=null?h:null}}]);break}break;default:(0,T.assertNever)(w[0])}}addItem(E,w,_){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const u=_?_.item.extId:null,c=E.resolveHandler?1:0,h=_?_.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:u,item:I.TestItem.from(E),expandLevels:h?h-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:u,src:t,expand:c,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=_==null?void 0:_.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(E){var w;let _;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?_=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),_=3):_=0,_!==E.expand&&(E.expand=_,this.pushDiff([1,{extId:E.actual.id,expand:_}]),_===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(w<0)return;const _=[...E.actual.children.values()].map(u=>this.expand(u.id,w)).filter(R.isThenable);if(_.length)return Promise.all(_).then(()=>{})}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new R.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new R.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const _=[E];for(;_.length;){const u=_.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const c of u.actual.children.values())_.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(me[217],ge([0,1,26,3,9]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let A of i.activationEvents)A==="onUri"&&(A=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(i)}}keepOnly(i){const A=new Set;i.forEach(d=>A.add(v.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>A.has(v.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,A){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(d.map(p=>p.identifier)),A.length>0){const p=new Set;A.forEach(a=>p.add(v.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!p.has(v.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const _=A.getArcs(E);for(let u=0;u<_.length;u++)if(!w.has(_[u]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let E of i){const w=v.ExtensionIdentifier.toKey(E.identifier);if(d.set(w,E),E.extensionDependencies)for(let _ of E.extensionDependencies){const u=v.ExtensionIdentifier.toKey(_);A.addArc(w,u)}}let p=new Set;A.getNodes().filter(E=>A.getArcs(E).length===0).forEach(E=>p.add(E));let a=A.getNodes().filter(E=>!p.has(E)),f;do{f=!1;for(let E=0;E<a.length;E++){const w=a[E];A.hasOnlyGoodArcs(w,p)&&(a.splice(E,1),E--,p.add(w),f=!0)}}while(f);return a.map(E=>d.get(E))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const A=this._activationMap.get(i);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const A=this._extensionsMap.get(v.ExtensionIdentifier.toKey(i));return A||void 0}}e.ExtensionDescriptionRegistry=y;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function D(P,i){const A=P.isBuiltin?0:P.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(A!==d)return A-d;const p=C.posix.basename(P.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return p<a?-1:p>a?1:0}}),define(me[218],ge([0,1,23]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function T(I){const D=v.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[39],ge([0,1,3,2,4,26,182]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class I{constructor(_){this.dependency=_}}e.MissingExtensionDependency=I;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(_,u,c,h){this.codeLoadingTime=_,this.activateCallTime=u,this.activateResolvedTime=c,this.activationReason=h}}e.ActivationTimes=P;class i{constructor(_,u){this.description=_,this.value=u}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var A;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(A=e.ActivationKind||(e.ActivationKind={}));function d(w){w.enableProposedApi||p(w)}e.checkProposedApiEnabled=d;function p(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=p;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function f(w){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=f;class E{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,u){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,u,c,h,t){}_onDidActivateExtensionError(_,u){}_onExtensionRuntimeError(_,u){}_onExtensionHostExit(_){}}e.NullExtensionService=E}),define(me[219],ge([0,1,26,39,14]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(a,f,E,w){this.startup=a,this.codeLoadingTime=f,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class I{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,f){return a===-1||f===-1?-1:f-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(a,f,E,w,_,u){this.activationFailed=a,this.activationFailedError=f,this.activationTimes=E,this.module=w,this.exports=_,this.subscriptions=u}}e.ActivatedExtension=D;class P extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class A extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let d=class{constructor(a,f,E,w,_){this._logService=_,this._registry=a,this._resolvedExtensionsSet=new Set,f.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,E.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const f=v.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(f)}getActivatedExtension(a){const f=v.ExtensionIdentifier.toKey(a),E=this._activatedExtensions.get(f);if(!E)throw new Error("Extension `"+a.value+"` is not known or not activated");return E}activateByEvent(a,f){if(this._alreadyActivatedEvents[a])return T;const E=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,f){const E=this._registry.getExtensionDescription(a);if(!E)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:E.identifier,reason:f}])}_handleActivateRequest(a,f,E){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(a.id))){f[v.ExtensionIdentifier.toKey(a.id)]=a;return}const w=this._registry.getExtensionDescription(a.id);if(!w){const c=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,c,new R.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(a.id),new A(c));return}const _=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let c=0,h=_.length;c<h;c++){const t=_[c];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const g=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),S=m&&m.displayName||t,b=new Error(`Cannot activate the '${g}' extension because its dependency '${S}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,b,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new A(b));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,f[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,f[v.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:a.reason};continue}const r=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new A(o));return}u?f[v.ExtensionIdentifier.toKey(w.identifier)]=a:E.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(_=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(_.id))),a.length===0))return Promise.resolve(void 0);const f=Object.create(null),E=[];for(let _=0,u=a.length;_<u;_++)this._handleActivateRequest(a[_],f,E);for(let _=0,u=E.length;_<u;_++){const c=v.ExtensionIdentifier.toKey(E[_].id);f[c]&&delete f[c]}const w=Object.keys(f).map(_=>f[_]);return E.length===0?Promise.all(w.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(w).then(_=>this._activateExtensions(E))}_activateExtension(a,f){const E=v.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const _=this._host.actualActivateExtension(a,f).then(void 0,u=>{const c=new Error;return u&&u.name&&(c.name=u.name),u&&u.message?c.message=`Activating extension '${a.value}' failed: ${u.message}.`:c.message=`Activating extension '${a.value}' failed: ${u}.`,u&&u.stack&&(c.stack=u.stack),this._host.onExtensionActivationError(a,c,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new A(u)}).then(u=>{this._activatedExtensions.set(E,u),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,_),_}};d=qe([He(4,C.ILogService)],d),e.ExtensionsActivator=d}),define(me[220],ge([0,1,14,39,27,10,112]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends v.LogService{constructor(P){if(P.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(R.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};I=qe([He(0,C.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(me[221],ge([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,v.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(me[126],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function C(I){const D=new v(!0,I);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function T(I){const D=new v(!1,I);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(I){return R[I].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,58,2,126]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(u){u.name="$ident";function c(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=c;function h(t){return t[u.name]}u.of=h})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(c){return c._id=p._n++,c}}e.IdObject=p,p._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=R.URI.revive(c.resource):(c.newUri=R.URI.revive(c.newUri),c.oldUri=R.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,v.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=w;var _;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[88],ge([0,1,5,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,P){return this._proxy.$setPassword(I,D,P)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,14,5,15]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,P,i){const A=this.getUsageKey(D,P);this._reportedUsages.has(A)||(this._reportedUsages.add(A),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};y=qe([He(0,T.IExtHostRpcService),He(1,R.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,P){}})}),define(me[222],ge([0,1,3,5,7,26]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,i,A={}){const d=T.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(d)||[],a=[...i].sort().join(" ");let f=p.find(E=>E.scopes===a);if(f)return f.result;{const E=this._getSession(D,d,P,i,A);f={scopes:a,result:E},p.push(f),this._inFlightRequests.set(d,p);try{return await E}finally{const w=p.findIndex(_=>_.scopes===a);w>-1&&(p.splice(w),this._inFlightRequests.set(d,p))}}}async _getSession(D,P,i,A,d={}){await this._proxy.$ensureProvider(i);const p=D.displayName||D.name;return this._proxy.$getSession(i,A,P,p,d)}async removeSession(D,P){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,i,A){var d;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:i,options:A!=null?A:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:P});const p=i.onDidChangeSessions(a=>{var f,E,w;this._proxy.$sendDidChangeSessions(D,{added:(f=a.added)!==null&&f!==void 0?f:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(d=A==null?void 0:A.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new C.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(f=>f.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(i=>{this._providers.some(A=>A.id===i.id)||this._providers.push(i)}),P.forEach(i=>{const A=this._providers.findIndex(d=>d.id===i.id);A>-1&&this._providers.splice(A)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[223],ge([0,1,5,15,20]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=qe([He(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(me[224],ge([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const y=T.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(I){return y.$writeText(I)}})}}e.ExtHostClipboard=R}),define(me[49],ge([0,1,12,7,20,24,5,16,14,58,42,46,2,6,4,15]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,P.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return C.Range.to(r);if(A.Position.isIPosition(r))return C.Position.to(r);if(i.Range.isIRange(r.range)&&d.URI.isUri(r.uri))return C.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((g,m)=>{if(!g.validate(s[m]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${s[m]}`);return g.convert(s[m])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,T.cloneAndChange)(n,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,P.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:g}=s;if(g)for(let m=0;m<g.args.length;m++)try{(0,v.validateConstraint)(n[m],g.args[m].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[m].name}' - ${g.args[m].description}`)}try{return await r.apply(o,n)}catch(m){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...n);S&&(t=S.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};E=qe([He(0,f.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,g)=>o.convert(t.arguments&&t.arguments[g]));else if((0,I.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,p.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class _{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",h=>d.URI.isUri(h),h=>h),_.Position=new _("position","A position in a text document",h=>R.Position.isPosition(h),C.Position.from),_.Range=new _("range","A range in a text document",h=>R.Range.isRange(h),C.Range.from),_.Selection=new _("selection","A selection in a text document",h=>R.Selection.isSelection(h),C.Selection.from),_.Number=new _("number","",h=>typeof h=="number",h=>h),_.String=new _("string","",h=>typeof h=="string",h=>h),_.CallHierarchyItem=new _("item","A call hierarchy item",h=>h instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class c{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=c}),define(me[225],ge([0,1,6,20,7,80,49,202,16,108]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(R.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,f)=>{if((0,D.isFalsyOrEmpty)(a))return;class E extends C.SymbolInformation{static to(_){const u=new E(_.name,R.SymbolKind.to(_.kind),_.containerName||"",new C.Location(f[0],R.Range.to(_.range)));return u.detail=_.detail,u.range=u.location.range,u.selectionRange=R.Range.to(_.selectionRange),u.children=_.children?_.children.map(E.to):[],u}}return a.map(E.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(R.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(R.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(f=>C.Position.isPosition(f)),a=>a.map(R.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(f=>{let E;for(const w of f.reverse())E=new C.SelectionRange(R.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const f=[];if(Array.isArray(a))for(let E of a)f.push(...E[1].map(R.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return R.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(R.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const f=(0,P.decodeSemanticTokensDto)(a);if(f.type==="full")return new C.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const f=(0,P.decodeSemanticTokensDto)(a);if(f.type==="full")return new C.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,f,E)=>{if(!a)return new C.CompletionList([]);const w=a.suggestions.map(_=>R.CompletionItem.to(_,E));return new C.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return R.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,f,E)=>d(w=>new C.CodeLens(R.Range.to(w.range),w.command&&E.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.Range.isRange(a),a=>C.Selection.isSelection(a)?R.Selection.from(a):R.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,f,E)=>d(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const _=new C.CodeAction(w.title,w.kind?new C.CodeActionKind(w.kind):void 0);return w.edit&&(_.edit=R.WorkspaceEdit.to(w.edit)),w.command&&(_.command=E.fromInternal(w.command)),_.isPreferred=w.isPreferred,_}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(f=>new C.ColorInformation(R.Range.to(f.range),R.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof C.Color,R.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:R.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(R.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(R.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(f=>R.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(R.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class A{constructor(f){this._disposables=new v.DisposableStore,this._commands=f}static register(f){return i.forEach(f.registerApiCommand,f),new A(f).registerCommands()}registerCommands(){const f=E=>(...w)=>E(this._commands,...w);this._register(I.RemoveFromRecentlyOpenedAPICommand.ID,f(I.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]})}_register(f,E,w){const _=this._commands.registerCommand(!1,f,E,this,w);this._disposables.add(_)}}e.ExtHostApiCommands=A;function d(a){return f=>{if(Array.isArray(f))return f.map(a)}}function p(a){if(!Array.isArray(a))return;const f=[];for(const E of a)T.isLocationLink(E)?f.push(R.DefinitionLink.to(E)):f.push(R.location.to(E));return f}}),define(me[226],ge([0,1,13,53,3,6,2,80,26,20,7,5]),function(K,e,v,R,C,T,y,I,D,P,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(c,h,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadComments),h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,g=r.getCommentByUniqueId(o);return g||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,g=n.commentUniqueId,m=r.getCommentByUniqueId(g);return m?(m.body=o,m):n}return n}})}createCommentController(c,h,t){const n=d.handlePool++,s=new a(c,n,this._proxy,h,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),r),s}$createCommentThreadTemplate(c,h,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(h,t)}async $updateCommentThreadTemplate(c,h,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(h,t)}$deleteCommentThread(c,h){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(h)}$provideCommentingRanges(c,h,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(h));return(0,v.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>P.Range.from(o)):void 0)}$toggleReaction(c,h,t,n,s){const r=this._commentControllers.get(c);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const o=r.getCommentThread(h);if(o){const g=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&g&&r.reactionHandler)return r.reactionHandler(g,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class p{constructor(c,h,t,n,s,r,o){this._proxy=c,this._commentController=h,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${h.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),h={};c("range")&&(h.range=P.Range.from(this._range)),c("label")&&(h.label=this.label),c("contextValue")&&(h.contextValue=this.contextValue),c("comments")&&(h.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(h.collapseState=_(this._collapseState)),c("canReply")&&(h.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(c){for(let h of this._commentsMap){let t=h[0],n=h[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,qe([(0,R.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class a{constructor(c,h,t,n,s){this._extension=c,this._handle=h,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,h,t,n){if(typeof c=="string"){const s=new p(this._proxy,this,c,h,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new p(this._proxy,this,void 0,c,h,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,h){const t=new p(this._proxy,this,void 0,y.URI.revive(c),P.Range.to(h),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,h){let t=this._threads.get(c);t&&(t.range=P.Range.to(h))}$deleteCommentThread(c){let h=this._threads.get(c);h&&h.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(u,c,h,t){let n=t.get(h);n||(n=++u.commentHandle,t.set(h,n));const s=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:n,body:P.MarkdownString.from(h.body),userName:h.author.name,userIconPath:s,label:h.label,commentReactions:h.reactions?h.reactions.map(r=>E(r)):void 0}}function E(u){return{label:u.label,iconPath:u.iconPath?P.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function _(u){if(u!==void 0)switch(u){case i.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(me[127],ge([0,1,2,5,7,4,15,14,16,8,9]),function(K,e,v,R,C,T,y,I,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class vn{constructor(p,a){this._logService=a,this._provider=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,a){const f=vn._handlePool++;this._provider.set(f,{provider:p,extensionId:a}),this._proxy.$registerDecorationProvider(f,a.value);const E=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(f,null);return}let _=(0,D.asArray)(w);if(_.length<=vn._maxEventSize){this._proxy.$onDidChange(f,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,_.length);const u=_.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),c=(0,D.groupBy)(u,(t,n)=>t.rank-n.rank||(0,P.compare)(t.uri.path,n.uri.path));let h=[];e:for(let t of c){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,h.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(f,h)});return new C.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(p,a,f){if(!this._provider.has(p))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:_}=this._provider.get(p);return await Promise.all(a.map(async u=>{try{const{uri:c,id:h}=u,t=await Promise.resolve(w.provideFileDecoration(v.URI.revive(c),f));if(!t)return;try{C.FileDecoration.validate(t),E[h]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(c){this._logService.error(c)}})),E}};A._handlePool=0,A._maxEventSize=250,A=qe([He(0,y.IExtHostRpcService),He(1,I.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(me[227],ge([0,1,160,113,2,5,7,20,3,14,22]),function(K,e,v,R,C,T,y,I,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class A{constructor(a,f,E,w,_){this._name=a,this._owner=f,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,f){if(!a){this.clear();return}this._checkDisposed();let E=[];if(C.URI.isUri(a)){if(!f){this.delete(a);return}this._data.set(a,f.slice()),E=[a]}else if(Array.isArray(a)){E=[];let _;a=[...a].sort(A._compareIndexedTuplesByUri);for(const u of a){const[c,h]=u;if((!_||c.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=c,E.push(c),this._data.set(c,[])),h){const t=this._data.get(c);t&&t.push(...h)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!this._proxy)return;const w=[];for(let _ of E){let u=[];const c=this._data.get(_);if(c)if(c.length>this._maxDiagnosticsPerFile){u=[];const h=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===h[t]&&u.push(I.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=c.map(h=>I.Diagnostic.from(h));w.push([_,u])}this._proxy.$changeMany(this._owner,w)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,f){this._checkDisposed();for(let E of this._data.keys())a.apply(f,[E,this.get(E),this])}get(a){this._checkDisposed();const f=this._data.get(a);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,f){return a[0].toString()<f[0].toString()?-1:a[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=A;let d=class jt{constructor(a,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(a,f){return a?a.concat(f):f}static _mapper(a){const f=new i.ResourceMap;for(const E of a)f.set(E,E);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(a,f){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:_,_logService:u}=this,c=new class{$changeMany(n,s){w.$changeMany(n,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let h;if(!f)f="_generated_diagnostic_collection_name_#"+jt._idPool++,h=f;else if(!E.has(f))h=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do h=f+jt._idPool++;while(E.has(h))}return new class extends A{constructor(){super(f,h,jt._maxDiagnosticsPerFile,c,_);E.set(h,this)}dispose(){super.dispose(),E.delete(h)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const f=new Map,E=[];for(const w of this._collections.values())w.forEach((_,u)=>{let c=f.get(_.toString());typeof c=="undefined"&&(c=E.length,f.set(_.toString(),c),E.push([_,[]])),E[c][1]=E[c][1].concat(...u)});return E}}_getDiagnostics(a){let f=[];for(let E of this._collections.values())E.has(a)&&(f=f.concat(E.get(a)));return f}$acceptMarkersChange(a){if(!this._mirrorCollection){const f="_generated_mirror",E=new A(f,f,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,E),this._mirrorCollection=E}for(const[f,E]of a)this._mirrorCollection.set(C.URI.revive(f),E.map(I.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=qe([He(1,P.ILogService)],d),e.ExtHostDiagnostics=d}),define(me[228],ge([0,1,2,5]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(I=>I?I.map(D=>v.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(I=>I?v.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(me[229],ge([0,1,17,2,7,5,10,21,8]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(A,d,p){this._documentsAndEditors=d,this._logService=p,this._documentContentProviders=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,d){if(Object.keys(y.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const p=P._handlePool++;this._documentContentProviders.set(p,d),this._proxy.$registerTextContentProvider(p,A);let a;return typeof d.onDidChange=="function"&&(a=d.onDidChange(f=>{if(f.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(p,f).then(E=>{if(!E&&typeof E!="string")return;const w=this._documentsAndEditors.getDocument(f);if(!w)return;const _=(0,D.splitLines)(E);if(!w.equalLines(_))return this._proxy.$onVirtualDocumentChange(f,E)},v.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(A,d){const p=this._documentContentProviders.get(A);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(d),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[230],ge([0,1,3,6,2,5,120,20,12,24]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,p){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const f of a)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const f of a)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const p=this._documentsAndEditors.getDocument(d);if(p)return p}getDocument(d){const p=this.getDocumentData(d);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return p.document}ensureDocumentData(d){const p=this._documentsAndEditors.getDocument(d);if(p)return Promise.resolve(p);let a=this._documentLoader.get(d.toString());return a||(a=this._proxy.$tryOpenDocument(d).then(f=>{this._documentLoader.delete(d.toString());const E=C.URI.revive(f);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},f=>(this._documentLoader.delete(d.toString()),Promise.reject(f))),this._documentLoader.set(d.toString(),a)),a}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(p=>C.URI.revive(p))}$acceptModelModeChanged(d,p){const a=C.URI.revive(d),f=this._documentsAndEditors.getDocument(a);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(p),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(d){const p=C.URI.revive(d),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(d,p){const a=C.URI.revive(d),f=this._documentsAndEditors.getDocument(a);if(!f)throw new Error("unknown document");f._acceptIsDirty(p),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(d,p,a){const f=C.URI.revive(d),E=this._documentsAndEditors.getDocument(f);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(p),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:E.document,contentChanges:p.changes.map(w=>({range:I.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(d,p){(0,y.setWordDefinitionFor)(d,p)}}e.ExtHostDocuments=i}),define(me[40],ge([0,1,51,3,6,2,4,5,120,15,125,20,14,22,10,54,135]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,h){this._extHostRpc=c,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const r=T.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),h.push(o.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const r=T.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(c.removedEditors)for(const s of c.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(c.addedEditors)for(const s of c.addedEditors){const r=T.URI.revive(s.documentUri);v.ok(this._documents.has(r),`document '${r}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,g=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),s.selections.map(A.Selection.to),s.options,s.visibleRanges.map(m=>A.Range.to(m)),typeof s.editorPosition=="number"?A.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,g)}c.newActiveEditor!==void 0&&(v.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(h),(0,C.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(h),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var h;return(h=this._documents.get(c))===null||h===void 0?void 0:h.value}allDocuments(){return f.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const h=this._editors.get(this._activeEditorId);return c?h:h==null?void 0:h.value}allEditors(){return[...this._editors.values()]}};_=qe([He(0,P.IExtHostRpcService),He(1,d.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[231],ge([0,1,2,5,6,7,20,143,8,23]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let f,E,w=14,_=14;for(const u of p){let c=f?(0,D.commonPrefixLength)(f,u):0;for(c===0?E=1:E=_;c<u.length;c++)c+1===u.length?(w=_,_=9):_+=1,a.push([E,u.toUpperCase().charCodeAt(c),_]),a.push([E,u.toLowerCase().charCodeAt(c),_]),E=_;f=u,_=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new I.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],f=I.LinkComputer.computeLinks({getLineContent(E){return p.lineAt(E-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const E of f){const w=y.DocumentLink.to(E);w.target&&a.push(w)}return a}}class A{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,a,f,E={},w){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const _=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(_,f),this._enableProposedApi.set(_,w!=null?w:!1);let u=2;E.isCaseSensitive&&(u+=1024),E.isReadonly&&(u+=2048),typeof f.copy=="function"&&(u+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(_,a,u).catch(h=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${a}`),console.error(h)});const c=f.onDidChangeFile(h=>{const t=[];for(const n of h){let{uri:s,type:r}=n;if(s.scheme!==a)continue;let o;switch(r){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(_,t)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(_),this._enableProposedApi.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(p,a){const{type:f,ctime:E,mtime:w,size:_,permissions:u}=p;return a?{type:f,ctime:E,mtime:w,size:_,permissions:u}:{type:f,ctime:E,mtime:w,size:_}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(v.URI.revive(a))).then(f=>{var E;return A._asIStat(f,(E=this._enableProposedApi.get(p))!==null&&E!==void 0?E:!1)})}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(v.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(v.URI.revive(a))).then(f=>P.VSBuffer.wrap(f))}$writeFile(p,a,f,E){return Promise.resolve(this._getFsProvider(p).writeFile(v.URI.revive(a),f.buffer,E))}$delete(p,a,f){return Promise.resolve(this._getFsProvider(p).delete(v.URI.revive(a),f))}$rename(p,a,f,E){return Promise.resolve(this._getFsProvider(p).rename(v.URI.revive(a),v.URI.revive(f),E))}$copy(p,a,f,E){const w=this._getFsProvider(p);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(v.URI.revive(a),v.URI.revive(f),E))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(v.URI.revive(a)))}$watch(p,a,f,E){const w=this._getFsProvider(p).watch(v.URI.revive(f),E);this._watches.set(a,w)}$unwatch(p,a){const f=this._watches.get(a);f&&(f.dispose(),this._watches.delete(a))}$open(p,a,f){const E=this._getFsProvider(p);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(v.URI.revive(a),f))}$close(p,a){const f=this._getFsProvider(p);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(a))}$read(p,a,f,E){const w=this._getFsProvider(p);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(E);return Promise.resolve(w.read(a,f,_.buffer,0,E)).then(u=>_.slice(0,u))}$write(p,a,f,E){const w=this._getFsProvider(p);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,f,E.buffer,0,E.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return a}}e.ExtHostFileSystem=A}),define(me[89],ge([0,1,5,43,7,23,4,15,62]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(A,d){const p=A.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return p.$stat(a).catch(Ut._handleError)},readDirectory(a){return p.$readdir(a).catch(Ut._handleError)},createDirectory(a){return p.$mkdir(a).catch(Ut._handleError)},async readFile(a){return p.$readFile(a).then(f=>f.buffer).catch(Ut._handleError)},writeFile(a,f){return p.$writeFile(a,T.VSBuffer.wrap(f)).catch(Ut._handleError)},delete(a,f){return p.$delete(a,Object.assign({recursive:!1,useTrash:!1},f)).catch(Ut._handleError)},rename(a,f,E){return p.$rename(a,f,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},copy(a,f,E){return p.$copy(a,f,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},isWritableFileSystem(a){const f=d.getCapabilities(a);if(typeof f=="number")return!(f&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new C.FileSystemError(String(A));if(A.name==="ENOPRO")throw C.FileSystemError.Unavailable(A.message);switch(A.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(A.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(A.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(A.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(A.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(A.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(A.message);default:throw new C.FileSystemError(A.message,A.name)}}};P=qe([He(0,I.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[232],ge([0,1,6,5]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,y),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(me[233],ge([0,1,2,24,20,7,13,5,8,42,16,12,140,6,108,73,85,44,17]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(j,X){this._documents=j,this._provider=X}provideDocumentSymbols(j,X){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,X)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(C.DocumentSymbol.from):u._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var X;j=j.slice(0).sort((pe,Se)=>{let ce=pe.location.range.start.compareTo(Se.location.range.start);return ce===0&&(ce=Se.location.range.end.compareTo(pe.location.range.end)),ce});const ee=[],oe=[];for(const pe of j){const Se={name:pe.name||"!!MISSING: name!!",kind:C.SymbolKind.from(pe.kind),tags:((X=pe.tags)===null||X===void 0?void 0:X.map(C.SymbolTag.from))||[],detail:"",containerName:pe.containerName,range:C.Range.from(pe.location.range),selectionRange:C.Range.from(pe.location.range),children:[]};for(;;){if(oe.length===0){oe.push(Se),ee.push(Se);break}const ce=oe[oe.length-1];if(P.Range.containsRange(ce.range,Se.range)&&!P.Range.equalsRange(ce.range,Se.range)){ce.children&&ce.children.push(Se),oe.push(Se);break}oe.pop()}}return ee}}class c{constructor(j,X,ee){this._documents=j,this._commands=X,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,X){const ee=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ee,X);if(!oe||X.isCancellationRequested)return;const pe=this._cache.add(oe),Se=new p.DisposableStore;this._disposables.set(pe,Se);const ce={cacheId:pe,lenses:[]};for(let _e=0;_e<oe.length;_e++)ce.lenses.push({cacheId:[pe,_e],range:C.Range.from(oe[_e].range),command:this._commands.toInternal(oe[_e].command,Se)});return ce}async resolveCodeLens(j,X){var ee;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let pe;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?pe=oe:pe=await this._provider.resolveCodeLens(oe,X),pe||(pe=oe),X.isCancellationRequested)return;const Se=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!Se)return j.command=this._commands.toInternal((ee=pe.command)!==null&&ee!==void 0?ee:c._badCmd,Se),j}releaseCodeLenses(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function h(We){return Array.isArray(We)?We.map(C.DefinitionLink.from):We?[C.DefinitionLink.from(We)]:[]}class t{constructor(j,X){this._documents=j,this._provider=X}provideDefinition(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDefinition(oe,pe,ee)).then(h)}}class n{constructor(j,X){this._documents=j,this._provider=X}provideDeclaration(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDeclaration(oe,pe,ee)).then(h)}}class s{constructor(j,X){this._documents=j,this._provider=X}provideImplementation(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideImplementation(oe,pe,ee)).then(h)}}class r{constructor(j,X){this._documents=j,this._provider=X}provideTypeDefinition(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(oe,pe,ee)).then(h)}}class o{constructor(j,X){this._documents=j,this._provider=X}provideHover(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideHover(oe,pe,ee)).then(Se=>{if(!(!Se||(0,i.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=oe.getWordRangeAtPosition(pe)),Se.range||(Se.range=new T.Range(pe,pe)),C.Hover.from(Se)})}}class g{constructor(j,X){this._documents=j,this._provider=X}provideEvaluatableExpression(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,pe,ee)).then(Se=>{if(Se)return C.EvaluatableExpression.from(Se)})}}class m{constructor(j,X){this._documents=j,this._provider=X}provideInlineValues(j,X,ee,oe){const pe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlineValues(pe,C.Range.to(X),C.InlineValueContext.to(ee),oe)).then(Se=>{if(Array.isArray(Se))return Se.map(ce=>C.InlineValue.from(ce))})}}class S{constructor(j,X){this._documents=j,this._provider=X}provideDocumentHighlights(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(oe,pe,ee)).then(Se=>{if(Array.isArray(Se))return Se.map(C.DocumentHighlight.from)})}}class b{constructor(j,X){this._documents=j,this._provider=X}provideLinkedEditingRanges(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,pe,ee)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,i.coalesce)(Se.ranges.map(C.Range.from)),wordPattern:Se.wordPattern}})}}class l{constructor(j,X){this._documents=j,this._provider=X}provideReferences(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideReferences(pe,Se,ee,oe)).then(ce=>{if(Array.isArray(ce))return ce.map(C.location.from)})}}class L{constructor(j,X,ee,oe,pe,Se,ce){this._documents=j,this._commands=X,this._diagnostics=ee,this._provider=oe,this._logService=pe,this._extension=Se,this._apiDeprecation=ce,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=d.Selection.isISelection(X)?C.Selection.to(X):C.Range.to(X),ce=[];for(const Re of this._diagnostics.getDiagnostics(j))if(Se.intersection(Re.range)&&ce.push(Re)>L._maxCodeActionsPerFile)break;const _e={diagnostics:ce,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(pe,Se,_e,oe)).then(Re=>{var Ve;if(!(0,i.isNonEmptyArray)(Re)||oe.isCancellationRequested)return;const be=this._cache.add(Re),Ge=new p.DisposableStore;this._disposables.set(be,Ge);const G=[];for(let ne=0;ne<Re.length;ne++){const ve=Re[ne];!ve||(L._isCommand(ve)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),G.push({_isSynthetic:!0,title:ve.title,command:this._commands.toInternal(ve,Ge)})):(_e.only&&(ve.kind?_e.only.contains(ve.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action is of kind '${ve.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),G.push({cacheId:[be,ne],title:ve.title,command:ve.command&&this._commands.toInternal(ve.command,Ge),diagnostics:ve.diagnostics&&ve.diagnostics.map(C.Diagnostic.from),edit:ve.edit&&C.WorkspaceEdit.from(ve.edit),kind:ve.kind&&ve.kind.value,isPreferred:ve.isPreferred,disabled:(Ve=ve.disabled)===null||Ve===void 0?void 0:Ve.reason})))}return{cacheId:be,actions:G}})}async resolveCodeAction(j,X){var ee;const[oe,pe]=j,Se=this._cache.get(oe,pe);if(!Se||L._isCommand(Se)||!this._provider.resolveCodeAction)return;const ce=(ee=await this._provider.resolveCodeAction(Se,X))!==null&&ee!==void 0?ee:Se;return(ce==null?void 0:ce.edit)?C.WorkspaceEdit.from(ce.edit):void 0}releaseCodeActions(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}L._maxCodeActionsPerFile=1e3;class O{constructor(j,X){this._documents=j,this._provider=X}provideDocumentFormattingEdits(j,X,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,X,ee)).then(pe=>{if(Array.isArray(pe))return pe.map(C.TextEdit.from)})}}class W{constructor(j,X){this._documents=j,this._provider=X}provideDocumentRangeFormattingEdits(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Range.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(pe,Se,ee,oe)).then(ce=>{if(Array.isArray(ce))return ce.map(C.TextEdit.from)})}}class ie{constructor(j,X){this._documents=j,this._provider=X,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,X,ee,oe,pe){const Se=this._documents.getDocument(j),ce=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,ce,ee,oe,pe)).then(_e=>{if(Array.isArray(_e))return _e.map(C.TextEdit.from)})}}class re{constructor(j,X){this._provider=j,this._logService=X,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,X){const ee=I.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(j,X)).then(oe=>{if((0,i.isNonEmptyArray)(oe))for(const pe of oe){if(!pe)continue;if(!pe.name){this._logService.warn("INVALID SymbolInformation, lacks name",pe);continue}const Se=I.IdObject.mixin(C.WorkspaceSymbol.from(pe));this._symbolCache.set(Se._id,pe),ee.symbols.push(Se)}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(j,X){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ee=this._symbolCache.get(j._id);if(ee){const oe=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,X));return oe&&(0,R.mixin)(j,C.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const X=this._resultCache.get(j);if(X){for(let[ee,oe]=X;ee<=oe;ee++)this._symbolCache.delete(ee);this._resultCache.delete(j)}}}class N{constructor(j,X,ee){this._documents=j,this._provider=X,this._logService=ee}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(pe,Se,ee,oe)).then(ce=>{if(!!ce)return C.WorkspaceEdit.from(ce)},ce=>{const _e=N._asMessage(ce);return _e?{rejectReason:_e,edits:void 0}:Promise.reject(ce)})}resolveRenameLocation(j,X,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),pe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.prepareRename(oe,pe,ee)).then(Se=>{let ce,_e;if(T.Range.isRange(Se)?(ce=Se,_e=oe.getText(Se)):(0,A.isObject)(Se)&&(ce=Se.range,_e=Se.placeholder),!!ce){if(ce.start.line>pe.line||ce.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:_e}}},Se=>{const ce=N._asMessage(Se);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class V{constructor(j,X){this.resultId=j,this.tokens=X}}class x{constructor(j,X){this._documents=j,this._provider=X,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,X,ee){const oe=this._documents.getDocument(j),pe=X!==0?this._previousResults.get(X):null;return(0,y.asPromise)(()=>pe&&typeof pe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,pe.resultId,ee):this._provider.provideDocumentSemanticTokens(oe,ee)).then(Se=>(pe&&this._previousResults.delete(X),Se?(Se=x._fixProvidedSemanticTokens(Se),this._send(x._convertToEdits(pe,Se),Se)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return x._isSemanticTokens(j)?x._isCorrectSemanticTokens(j)?j:new T.SemanticTokens(new Uint32Array(j.data),j.resultId):x._isSemanticTokensEdits(j)?x._isCorrectSemanticTokensEdits(j)?j:new T.SemanticTokensEdits(j.edits.map(X=>new T.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const X of j.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,X){if(!x._isSemanticTokens(X)||!j||!j.tokens)return X;const ee=j.tokens,oe=ee.length,pe=X.data,Se=pe.length;let ce=0;const _e=Math.min(oe,Se);for(;ce<_e&&ee[ce]===pe[ce];)ce++;if(ce===oe&&ce===Se)return new T.SemanticTokensEdits([],X.resultId);let Re=0;const Ve=_e-ce;for(;Re<Ve&&ee[oe-Re-1]===pe[Se-Re-1];)Re++;return new T.SemanticTokensEdits([{start:ce,deleteCount:oe-ce-Re,data:pe.subarray(ce,Se-Re)}],X.resultId)}_send(j,X){if(x._isSemanticTokens(j)){const ee=this._nextResultId++;return this._previousResults.set(ee,new V(j.resultId,j.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:j.data})}if(x._isSemanticTokensEdits(j)){const ee=this._nextResultId++;return x._isSemanticTokens(X)?this._previousResults.set(ee,new V(X.resultId,X.data)):this._previousResults.set(ee,new V(j.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class k{constructor(j,X){this._documents=j,this._provider=X}provideDocumentRangeSemanticTokens(j,X,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,C.Range.to(X),ee)).then(pe=>pe?this._send(pe):null)}_send(j){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=k;class U{constructor(j,X,ee,oe,pe){this._documents=j,this._commands=X,this._provider=ee,this._apiDeprecation=oe,this._extension=pe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Position.to(X),ce=pe.getWordRangeAtPosition(Se)||new T.Range(Se,Se),_e=ce.with({end:Se}),Re=new w.StopWatch(!0),Ve=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(pe,Se,oe,C.CompletionContext.to(ee)));if(!Ve||oe.isCancellationRequested)return;const be=Array.isArray(Ve)?new T.CompletionList(Ve):Ve,Ge=U.supportsResolving(this._provider)?this._cache.add(be.items):this._cache.add([]),G=new p.DisposableStore;this._disposables.set(Ge,G);const ne=[],ve={x:Ge,b:ne,a:{replace:C.Range.from(ce),insert:C.Range.from(_e)},c:be.isIncomplete||void 0,d:Re.elapsed()};for(let xe=0;xe<be.items.length;xe++){const je=be.items[xe],ze=this._convertCompletionItem(je,[Ge,xe],_e,ce);ne.push(ze)}return ve}async resolveCompletionItem(j,X){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...j);if(!ee)return;const oe=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,X));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var X;(X=this._disposables.get(j))===null||X===void 0||X.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,X,ee,oe){var pe;const Se=this._disposables.get(X[0]);if(!Se)throw Error("DisposableStore is missing...");const ce={x:X,a:(pe=j.label)!==null&&pe!==void 0?pe:"",o:j.label2,b:j.kind!==void 0?C.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(C.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(j.command,Se)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=j.textEdit.newText):typeof j.insertText=="string"?ce.h=j.insertText:j.insertText instanceof T.SnippetString&&(ce.h=j.insertText.value,ce.i|=4);let _e;return j.textEdit?_e=j.textEdit.range:j.range&&(_e=j.range),T.Range.isRange(_e)?ce.j=C.Range.from(_e):_e&&(!(ee==null?void 0:ee.isEqual(_e.inserting))||!(oe==null?void 0:oe.isEqual(_e.replacing)))&&(ce.j={insert:C.Range.from(_e.inserting),replace:C.Range.from(_e.replacing)}),ce}}class F{constructor(j,X){this._documents=j,this._provider=X}async provideInlineCompletions(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Position.to(X),ce=await(0,y.asPromise)(()=>this._provider.provideInlineCompletionItems(pe,Se,ee,oe));if(!!ce&&!oe.isCancellationRequested)return{items:ce.items.map(_e=>({text:_e.text,range:_e.range?C.Range.from(_e.range):void 0}))}}}class M{constructor(j,X){this._documents=j,this._provider=X,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(j,X,ee,oe){const pe=this._documents.getDocument(j),Se=C.Position.to(X),ce=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(pe,Se,oe,ce)).then(_e=>{if(_e){const Re=this._cache.add([_e]);return Object.assign(Object.assign({},C.SignatureHelp.from(_e)),{id:Re})}})}reviveContext(j){let X;if(j.activeSignatureHelp){const ee=C.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(X=oe,X.activeSignature=ee.activeSignature,X.activeParameter=ee.activeParameter):X=ee}return Object.assign(Object.assign({},j),{activeSignatureHelp:X})}releaseSignatureHelp(j){this._cache.delete(j)}}class ${constructor(j,X){this._documents=j,this._provider=X}provideInlayHints(j,X,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlayHints(oe,C.Range.to(X),ee)).then(pe=>pe?{hints:pe.map(C.InlayHint.from)}:void 0)}}class H{constructor(j,X){this._documents=j,this._provider=X,this._cache=new E.Cache("DocumentLink")}provideLinks(j,X){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,X)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(C.DocumentLink.from)};{const pe=this._cache.add(oe),Se={links:[],id:pe};for(let ce=0;ce<oe.length;ce++){const _e=C.DocumentLink.from(oe[ce]);_e.cacheId=[pe,ce],Se.links.push(_e)}return Se}}})}resolveLink(j,X){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...j);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,X)).then(oe=>oe&&C.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class Q{constructor(j,X){this._documents=j,this._provider=X}provideColors(j,X){const ee=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,X)).then(oe=>Array.isArray(oe)?oe.map(Se=>({color:C.Color.from(Se.color),range:C.Range.from(Se.range)})):[])}provideColorPresentations(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Range.to(X.range),Se=C.Color.to(X.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:oe,range:pe},ee)).then(ce=>{if(!!Array.isArray(ce))return ce.map(C.ColorPresentation.from)})}}class ae{constructor(j,X){this._documents=j,this._provider=X}provideFoldingRanges(j,X,ee){const oe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(oe,X,ee)).then(pe=>{if(!!Array.isArray(pe))return pe.map(C.FoldingRange.from)})}}class we{constructor(j,X,ee){this._documents=j,this._provider=X,this._logService=ee}provideSelectionRanges(j,X,ee){const oe=this._documents.getDocument(j),pe=X.map(C.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(oe,pe,ee)).then(Se=>{if(!(0,i.isNonEmptyArray)(Se))return[];if(Se.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let _e=0;_e<pe.length;_e++){const Re=[];ce.push(Re);let Ve=pe[_e],be=Se[_e];for(;;){if(!be.range.contains(Ve))throw new Error("INVALID selection range, must contain the previous range");if(Re.push(C.SelectionRange.from(be)),!be.parent)break;Ve=be.range,be=be.parent}}return ce})}}class Le{constructor(j,X){this._documents=j,this._provider=X,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(j,X,ee){const oe=this._documents.getDocument(j),pe=C.Position.to(X),Se=await this._provider.prepareCallHierarchy(oe,pe,ee);if(!Se)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(Se)?Se.map(_e=>this._cacheAndConvertItem(ce,_e)):[this._cacheAndConvertItem(ce,Se)]}async provideCallsTo(j,X,ee){const oe=this._itemFromCache(j,X);if(!oe)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(oe,ee);if(!!pe)return pe.map(Se=>({from:this._cacheAndConvertItem(j,Se.from),fromRanges:Se.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(j,X,ee){const oe=this._itemFromCache(j,X);if(!oe)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(oe,ee);if(!!pe)return pe.map(Se=>({to:this._cacheAndConvertItem(j,Se.to),fromRanges:Se.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,X){var ee;const oe=this._cache.get(j),pe={_sessionId:j,_itemId:oe.size.toString(36),name:X.name,detail:X.detail,kind:C.SymbolKind.from(X.kind),uri:X.uri,range:C.Range.from(X.range),selectionRange:C.Range.from(X.selectionRange),tags:(ee=X.tags)===null||ee===void 0?void 0:ee.map(C.SymbolTag.from)};return oe.set(pe._itemId,X),pe}_itemFromCache(j,X){const ee=this._cache.get(j);return ee==null?void 0:ee.get(X)}}class Ie{constructor(j,X){this.adapter=j,this.extension=X}}class Oe{constructor(j,X,ee,oe,pe,Se,ce){this._adapter=new Map,this._uriTransformer=X,this._proxy=j.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=oe,this._diagnostics=pe,this._logService=Se,this._apiDeprecation=ce}_transformDocumentSelector(j){return(0,i.coalesce)((0,i.asArray)(j).map(X=>this._doTransformDocumentSelector(X)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:C.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new T.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Oe._handlePool++}_withAdapter(j,X,ee,oe,pe=!1){const Se=this._adapter.get(j);if(!Se)return Promise.resolve(oe);if(Se.adapter instanceof X){let ce;Se.extension&&(ce=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${X.name}'`));const _e=ee(Se.adapter,Se.extension),Re=Se.extension;return Re&&Promise.resolve(_e).then(()=>this._logService.trace(`[${Re.identifier.value}] provider DONE after ${Date.now()-ce}ms`),Ve=>{pe&&Ve instanceof _.CancellationError||(this._logService.error(`[${Re.identifier.value}] provider FAILED`),this._logService.error(Ve))}),_e}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,X){const ee=this._nextHandle();return this._adapter.set(ee,new Ie(j,X)),ee}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,X,ee,oe){const pe=this._addNewAdapter(new u(this._documents,ee),j),Se=oe&&oe.label||Oe._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(X),Se),this._createDisposable(pe)}$provideDocumentSymbols(j,X,ee){return this._withAdapter(j,u,oe=>oe.provideDocumentSymbols(v.URI.revive(X),ee),void 0)}registerCodeLensProvider(j,X,ee){const oe=this._nextHandle(),pe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ie(new c(this._documents,this._commands.converter,ee),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(X),pe);let Se=this._createDisposable(oe);if(pe!==void 0){const ce=ee.onDidChangeCodeLenses(_e=>this._proxy.$emitCodeLensEvent(pe));Se=T.Disposable.from(Se,ce)}return Se}$provideCodeLenses(j,X,ee){return this._withAdapter(j,c,oe=>oe.provideCodeLenses(v.URI.revive(X),ee),void 0)}$resolveCodeLens(j,X,ee){return this._withAdapter(j,c,oe=>oe.resolveCodeLens(X,ee),void 0)}$releaseCodeLenses(j,X){this._withAdapter(j,c,ee=>Promise.resolve(ee.releaseCodeLenses(X)),void 0)}registerDefinitionProvider(j,X,ee){const oe=this._addNewAdapter(new t(this._documents,ee),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideDefinition(j,X,ee,oe){return this._withAdapter(j,t,pe=>pe.provideDefinition(v.URI.revive(X),ee,oe),[])}registerDeclarationProvider(j,X,ee){const oe=this._addNewAdapter(new n(this._documents,ee),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideDeclaration(j,X,ee,oe){return this._withAdapter(j,n,pe=>pe.provideDeclaration(v.URI.revive(X),ee,oe),[])}registerImplementationProvider(j,X,ee){const oe=this._addNewAdapter(new s(this._documents,ee),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideImplementation(j,X,ee,oe){return this._withAdapter(j,s,pe=>pe.provideImplementation(v.URI.revive(X),ee,oe),[])}registerTypeDefinitionProvider(j,X,ee){const oe=this._addNewAdapter(new r(this._documents,ee),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideTypeDefinition(j,X,ee,oe){return this._withAdapter(j,r,pe=>pe.provideTypeDefinition(v.URI.revive(X),ee,oe),[])}registerHoverProvider(j,X,ee,oe){const pe=this._addNewAdapter(new o(this._documents,ee),j);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(X)),this._createDisposable(pe)}$provideHover(j,X,ee,oe){return this._withAdapter(j,o,pe=>pe.provideHover(v.URI.revive(X),ee,oe),void 0)}registerEvaluatableExpressionProvider(j,X,ee,oe){const pe=this._addNewAdapter(new g(this._documents,ee),j);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(X)),this._createDisposable(pe)}$provideEvaluatableExpression(j,X,ee,oe){return this._withAdapter(j,g,pe=>pe.provideEvaluatableExpression(v.URI.revive(X),ee,oe),void 0)}registerInlineValuesProvider(j,X,ee,oe){const pe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new m(this._documents,ee),j);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(X),pe);let ce=this._createDisposable(Se);if(pe!==void 0){const _e=ee.onDidChangeInlineValues(Re=>this._proxy.$emitInlineValuesEvent(pe));ce=T.Disposable.from(ce,_e)}return ce}$provideInlineValues(j,X,ee,oe,pe){return this._withAdapter(j,m,Se=>Se.provideInlineValues(v.URI.revive(X),ee,oe,pe),void 0)}registerDocumentHighlightProvider(j,X,ee){const oe=this._addNewAdapter(new S(this._documents,ee),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideDocumentHighlights(j,X,ee,oe){return this._withAdapter(j,S,pe=>pe.provideDocumentHighlights(v.URI.revive(X),ee,oe),void 0)}registerLinkedEditingRangeProvider(j,X,ee){const oe=this._addNewAdapter(new b(this._documents,ee),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,X,ee,oe){return this._withAdapter(j,b,async pe=>{const Se=await pe.provideLinkedEditingRanges(v.URI.revive(X),ee,oe);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Oe._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(j,X,ee){const oe=this._addNewAdapter(new l(this._documents,ee),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideReferences(j,X,ee,oe,pe){return this._withAdapter(j,l,Se=>Se.provideReferences(v.URI.revive(X),ee,oe,pe),void 0)}registerCodeActionProvider(j,X,ee,oe){var pe,Se;const ce=new p.DisposableStore,_e=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(_e,this._transformDocumentSelector(X),{providedKinds:(pe=oe==null?void 0:oe.providedCodeActionKinds)===null||pe===void 0?void 0:pe.map(Re=>Re.value),documentation:(Se=oe==null?void 0:oe.documentation)===null||Se===void 0?void 0:Se.map(Re=>({kind:Re.kind.value,command:this._commands.converter.toInternal(Re.command,ce)}))},Oe._extLabel(j),Boolean(ee.resolveCodeAction)),ce.add(this._createDisposable(_e)),ce}$provideCodeActions(j,X,ee,oe,pe){return this._withAdapter(j,L,Se=>Se.provideCodeActions(v.URI.revive(X),ee,oe,pe),void 0)}$resolveCodeAction(j,X,ee){return this._withAdapter(j,L,oe=>oe.resolveCodeAction(X,ee),void 0)}$releaseCodeActions(j,X){this._withAdapter(j,L,ee=>Promise.resolve(ee.releaseCodeActions(X)),void 0)}registerDocumentFormattingEditProvider(j,X,ee){const oe=this._addNewAdapter(new O(this._documents,ee),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(X),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,X,ee,oe){return this._withAdapter(j,O,pe=>pe.provideDocumentFormattingEdits(v.URI.revive(X),ee,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,X,ee){const oe=this._addNewAdapter(new W(this._documents,ee),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(X),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,X,ee,oe,pe){return this._withAdapter(j,W,Se=>Se.provideDocumentRangeFormattingEdits(v.URI.revive(X),ee,oe,pe),void 0)}registerOnTypeFormattingEditProvider(j,X,ee,oe){const pe=this._addNewAdapter(new ie(this._documents,ee),j);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(X),oe,j.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(j,X,ee,oe,pe,Se){return this._withAdapter(j,ie,ce=>ce.provideOnTypeFormattingEdits(v.URI.revive(X),ee,oe,pe,Se),void 0)}registerWorkspaceSymbolProvider(j,X){const ee=this._addNewAdapter(new re(X,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(j,X,ee){return this._withAdapter(j,re,oe=>oe.provideWorkspaceSymbols(X,ee),{symbols:[]})}$resolveWorkspaceSymbol(j,X,ee){return this._withAdapter(j,re,oe=>oe.resolveWorkspaceSymbol(X,ee),void 0)}$releaseWorkspaceSymbols(j,X){this._withAdapter(j,re,ee=>ee.releaseWorkspaceSymbols(X),void 0)}registerRenameProvider(j,X,ee){const oe=this._addNewAdapter(new N(this._documents,ee,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(X),N.supportsResolving(ee)),this._createDisposable(oe)}$provideRenameEdits(j,X,ee,oe,pe){return this._withAdapter(j,N,Se=>Se.provideRenameEdits(v.URI.revive(X),ee,oe,pe),void 0)}$resolveRenameLocation(j,X,ee,oe){return this._withAdapter(j,N,pe=>pe.resolveRenameLocation(v.URI.revive(X),ee,oe),void 0)}registerDocumentSemanticTokensProvider(j,X,ee,oe){const pe=this._nextHandle(),Se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(pe,new Ie(new x(this._documents,ee),j)),this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(X),oe,Se);let ce=this._createDisposable(pe);if(Se){const _e=ee.onDidChangeSemanticTokens(Re=>this._proxy.$emitDocumentSemanticTokensEvent(Se));ce=T.Disposable.from(ce,_e)}return ce}$provideDocumentSemanticTokens(j,X,ee,oe){return this._withAdapter(j,x,pe=>pe.provideDocumentSemanticTokens(v.URI.revive(X),ee,oe),null,!0)}$releaseDocumentSemanticTokens(j,X){this._withAdapter(j,x,ee=>ee.releaseDocumentSemanticColoring(X),void 0)}registerDocumentRangeSemanticTokensProvider(j,X,ee,oe){const pe=this._addNewAdapter(new k(this._documents,ee),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(X),oe),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(j,X,ee,oe){return this._withAdapter(j,k,pe=>pe.provideDocumentRangeSemanticTokens(v.URI.revive(X),ee,oe),null,!0)}registerCompletionItemProvider(j,X,ee,oe){const pe=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(pe,this._transformDocumentSelector(X),oe,U.supportsResolving(ee),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(pe)}$provideCompletionItems(j,X,ee,oe,pe){return this._withAdapter(j,U,Se=>Se.provideCompletionItems(v.URI.revive(X),ee,oe,pe),void 0)}$resolveCompletionItem(j,X,ee){return this._withAdapter(j,U,oe=>oe.resolveCompletionItem(X,ee),void 0)}$releaseCompletionItems(j,X){this._withAdapter(j,U,ee=>ee.releaseCompletionItems(X),void 0)}registerInlineCompletionsProvider(j,X,ee){const oe=this._addNewAdapter(new F(this._documents,ee),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideInlineCompletions(j,X,ee,oe,pe){return this._withAdapter(j,F,Se=>Se.provideInlineCompletions(v.URI.revive(X),ee,oe,pe),void 0)}registerSignatureHelpProvider(j,X,ee,oe){const pe=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,Se=this._addNewAdapter(new M(this._documents,ee),j);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(X),pe),this._createDisposable(Se)}$provideSignatureHelp(j,X,ee,oe,pe){return this._withAdapter(j,M,Se=>Se.provideSignatureHelp(v.URI.revive(X),ee,oe,pe),void 0)}$releaseSignatureHelp(j,X){this._withAdapter(j,M,ee=>ee.releaseSignatureHelp(X),void 0)}registerInlayHintsProvider(j,X,ee){const oe=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new $(this._documents,ee),j);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(X),oe);let Se=this._createDisposable(pe);if(oe!==void 0){const ce=ee.onDidChangeInlayHints(_e=>this._proxy.$emitInlayHintsEvent(oe));Se=T.Disposable.from(Se,ce)}return Se}$provideInlayHints(j,X,ee,oe){return this._withAdapter(j,$,pe=>pe.provideInlayHints(v.URI.revive(X),ee,oe),void 0)}registerDocumentLinkProvider(j,X,ee){const oe=this._addNewAdapter(new H(this._documents,ee),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(X),typeof ee.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,X,ee){return this._withAdapter(j,H,oe=>oe.provideLinks(v.URI.revive(X),ee),void 0)}$resolveDocumentLink(j,X,ee){return this._withAdapter(j,H,oe=>oe.resolveLink(X,ee),void 0)}$releaseDocumentLinks(j,X){this._withAdapter(j,H,ee=>ee.releaseLinks(X),void 0)}registerColorProvider(j,X,ee){const oe=this._addNewAdapter(new Q(this._documents,ee),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideDocumentColors(j,X,ee){return this._withAdapter(j,Q,oe=>oe.provideColors(v.URI.revive(X),ee),[])}$provideColorPresentations(j,X,ee,oe){return this._withAdapter(j,Q,pe=>pe.provideColorPresentations(v.URI.revive(X),ee,oe),void 0)}registerFoldingRangeProvider(j,X,ee){const oe=this._nextHandle(),pe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ie(new ae(this._documents,ee),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(X),pe);let Se=this._createDisposable(oe);if(pe!==void 0){const ce=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));Se=T.Disposable.from(Se,ce)}return Se}$provideFoldingRanges(j,X,ee,oe){return this._withAdapter(j,ae,pe=>pe.provideFoldingRanges(v.URI.revive(X),ee,oe),void 0)}registerSelectionRangeProvider(j,X,ee){const oe=this._addNewAdapter(new we(this._documents,ee,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$provideSelectionRanges(j,X,ee,oe){return this._withAdapter(j,we,pe=>pe.provideSelectionRanges(v.URI.revive(X),ee,oe),[])}registerCallHierarchyProvider(j,X,ee){const oe=this._addNewAdapter(new Le(this._documents,ee),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(X)),this._createDisposable(oe)}$prepareCallHierarchy(j,X,ee,oe){return this._withAdapter(j,Le,pe=>Promise.resolve(pe.prepareSession(v.URI.revive(X),ee,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,X,ee,oe){return this._withAdapter(j,Le,pe=>pe.provideCallsTo(X,ee,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,X,ee,oe){return this._withAdapter(j,Le,pe=>pe.provideCallsFrom(X,ee,oe),void 0)}$releaseCallHierarchy(j,X){this._withAdapter(j,Le,ee=>Promise.resolve(ee.releaseSession(X)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,D.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Oe._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Oe._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Oe._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Oe._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Oe._serializeRegExp(j.beforeText),afterText:j.afterText?Oe._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Oe._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Oe._serializeOnEnterRule)}setLanguageConfiguration(j,X,ee){let{wordPattern:oe}=ee;if(oe&&(0,D.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(X,oe):this._documents.setWordDefinitionFor(X,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const pe=this._nextHandle(),Se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Oe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Oe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Oe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,X,Se),this._createDisposable(pe)}$setWordDefinitions(j){for(const X of j)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=Oe,Oe._handlePool=0}),define(me[234],ge([0,1,5,20,7]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(I,D){this._proxy=I.getProxy(v.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,D){await this._proxy.$changeLanguage(I,D);const P=this._documents.getDocumentData(I);if(!P)throw new Error(`document '${I.toString}' NOT found`);return P.document}async tokenAtPosition(I,D){var P;const i=I.version,A=R.Position.from(D),d=await this._proxy.$tokensAtPosition(I.uri,A),p={type:C.StandardTokenType.Other,range:(P=I.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new C.Range(D.line,D.character,D.line,D.character)};if(!d)return p;const a={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!a.range.contains(D)||i!==I.version?p:a}}e.ExtHostLanguages=T}),define(me[235],ge([0,1,5,14,39]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let y=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(v.MainContext.MainThreadMessageService)}showMessage(D,P,i,A,d){const p={extension:D};let a;typeof A=="string"||T(A)?a=[A,...d]:(p.modal=A&&A.modal,p.useCustom=A&&A.useCustom,a=d),p.useCustom&&(0,C.checkProposedApiEnabled)(D);const f=[];for(let E=0;E<a.length;E++){const w=a[E];if(typeof w=="string")f.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:_,isCloseAffordance:u}=w;f.push({title:_,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,i,p,f).then(E=>{if(typeof E=="number")return a[E]})}};y=qe([He(1,R.ILogService)],y),e.ExtHostMessageService=y}),define(me[236],ge([0,1,23,3,75,73,6,22,8,12,2,85,5,20,7,64,213,124]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(h,t){const n=_._Keys.nextId();h.$registerNotebookEditorDecorationType(n,p.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){h.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=_,_._Keys=new T.IdGenerator("NotebookEditorDecorationType");class u{constructor(h,t,n,s,r,o){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:g=>{var m;if(g&&g.$mid===12){const S=(m=g.notebookEditor)===null||m===void 0?void 0:m.notebookUri,b=g.cell.handle,l=this._documents.get(S),L=l==null?void 0:l.getCell(b);if(L)return L.apiCell}return g}})}get activeNotebookEditor(){var h;return(h=this._activeNotebookEditor)===null||h===void 0?void 0:h.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){return this._editors.get(h)}getIdByEditor(h){for(const[t,n]of this._editors)if(n.apiEditor===h)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,t){const n=this._documents.get(h);if(!n&&!t)throw new Error(`NO notebook document for '${h}'`);return n}_getProviderData(h){const t=this._notebookContentProviders.get(h);if(!t)throw new Error(`NO provider for '${h}'`);return t}registerNotebookContentProvider(h,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:h,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const g=p.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,g)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(h,r)),new a.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(h,t){if(!t)return;const n=t.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,t,n){const s=u._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(g=>this._notebookProxy.$emitCellStatusBarEvent(r))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),o&&o.dispose()})}createNotebookEditorDecorationType(h){return new _(this._notebookEditorsProxy,h).value}async createNotebookDocument(h){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&p.NotebookData.from(h.content)});return i.URI.revive(t)}async openNotebookDocument(h){const t=this._documents.get(h);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(h),s=this._documents.get(i.URI.revive(n));return(0,P.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(h,t){var n;i.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let s;typeof t=="object"?s={position:p.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(p.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.viewType,s),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,t,n,s){var r;const o=this._notebookStatusBarItemProviders.get(h),g=i.URI.revive(t),m=this._documents.get(g);if(!m||!o)return;const S=m.getCellFromIndex(n);if(!S)return;const b=await o.provideCellStatusBarItems(S.apiCell,s);if(!b)return;const l=new y.DisposableStore,L=this._statusBarCache.add([l]),O=(r=b&&b.map(W=>p.NotebookStatusBarItem.from(W,this._commandsConverter,l)))!==null&&r!==void 0?r:void 0;return{cacheId:L,items:O}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:h.identifier,location:h.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(h,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(h,t,n){const s=this._notebookSerializer.get(h);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(t.buffer,n);return p.NotebookData.from(r)}async $notebookToData(h,t,n){const s=this._notebookSerializer.get(h);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(p.NotebookData.to(t),n);return v.VSBuffer.wrap(r)}async $openNotebook(h,t,n,s,r){const{provider:o}=this._getProviderData(h),g=await o.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},r);return{metadata:p.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(p.NotebookCellData.from)}}async $saveNotebook(h,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:r}=this._getProviderData(h);return await r.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(h,t,n,s){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:o}=this._getProviderData(h);return await o.saveNotebookAs(i.URI.revive(n),r.apiNotebook,s),!0}async $backupNotebook(h,t,n){var s;const r=this.getNotebookDocument(i.URI.revive(t)),o=this._getProviderData(h),g=(s=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(o.extension),m=String((0,C.hash)([r.uri.toString(),this._backupIdPool++])),S=i.URI.joinPath(g,m),b=await o.provider.backupNotebook(r.apiNotebook,{destination:S},n);return r.updateBackup(b),b.id}$acceptModelChanged(h,t,n){this.getNotebookDocument(i.URI.revive(h)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(h,t){const n=this.getNotebookDocument(i.URI.revive(h));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(h){const t=this.getNotebookDocument(i.URI.revive(h));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",h,t);const n=this._editors.get(h);if(!n)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(p.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(p.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(h){for(const t in h){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(p.ViewColumn.to(h[t]))}}$acceptDocumentPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",h.path,t);const n=this.getNotebookDocument(i.URI.revive(h));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(h,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,h,n.visibleRanges.map(p.NotebookRange.to),n.selections.map(p.NotebookRange.to),typeof n.viewColumn=="number"?p.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(h){var t,n,s;if(h.removedDocuments)for(const o of h.removedDocuments){const g=i.URI.revive(o),m=this._documents.get(g);m&&(m.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===g.toString()&&this._editors.delete(S.id)}if(h.addedDocuments){const o=[];for(const g of h.addedDocuments){const m=i.URI.revive(g.uri),S=g.viewType;if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const b=this,l=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){b._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){b._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){b._onDidChangeCellMetadata.fire(L)},emitCellExecutionStateChange(L){b._onDidChangeCellExecutionState.fire(L)}},S,g.metadata?p.NotebookDocumentMetadata.to(g.metadata):new a.NotebookDocumentMetadata,m);l.acceptModelChanged({versionId:g.versionId,rawEvents:[{kind:f.NotebookCellsChangeType.Initialize,changes:[[0,0,g.cells]]}]},!1),o.push(...g.cells.map(L=>E.ExtHostCell.asModelAddData(l.apiNotebook,L))),(t=this._documents.get(m))===null||t===void 0||t.dispose(),this._documents.set(m,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(h.addedEditors)for(const o of h.addedEditors){if(this._editors.has(o.id))return;const g=i.URI.revive(o.documentUri),m=this._documents.get(g);m&&this._createExtHostEditor(m,o.id,o)}const r=[];if(h.removedEditors)for(const o of h.removedEditors){const g=this._editors.get(o);g&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===g.id&&(this._activeNotebookEditor=void 0),r.push(g))}if(h.visibleEditors){this._visibleNotebookEditors=h.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const o=new Set;this._visibleNotebookEditors.forEach(g=>o.add(g.id));for(const g of this._editors.values()){const m=o.has(g.id);g._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.newActiveEditor===null?this._activeNotebookEditor=void 0:h.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.newActiveEditor)),h.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(me[237],ge([0,1,3,6,5,26,2,20,87,22,13,64,21,16,14]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let f=class{constructor(c,h,t,n){this._mainContext=c,this._initData=h,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(c,h,t,n,s,r){for(let k of this._kernelData.values())if(k.controller.id===h&&T.ExtensionIdentifier.equals(c.identifier,k.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const o=this._handlePool++,g=this;this._logService.trace(`NotebookController[${o}], CREATED by ${c.identifier.value}, ${h}`);const m=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${c.identifier}'`);let S=!1;const b=new R.DisposableStore,l=new v.Emitter,L=new v.Emitter,O={id:`${c.identifier.value}/${h}`,viewType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:r?r.map(I.NotebookKernelPreload.from):[]};let W=s!=null?s:m,ie;this._proxy.$addKernel(o,O).catch(k=>{console.log(k),S=!0});let re=0;const N=()=>{if(S)return;const k=++re;Promise.resolve().then(()=>{k===re&&this._proxy.$updateKernel(o,O)})},V=new P.ResourceMap,x={get id(){return h},get viewType(){return O.viewType},onDidChangeNotebookAssociation:l.event,get label(){return O.label},set label(k){var U;O.label=(U=k!=null?k:c.displayName)!==null&&U!==void 0?U:c.name,N()},get detail(){var k;return(k=O.detail)!==null&&k!==void 0?k:""},set detail(k){O.detail=k,N()},get description(){var k;return(k=O.description)!==null&&k!==void 0?k:""},set description(k){O.description=k,N()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(k){O.supportedLanguages=k,N()},get hasExecutionOrder(){var k;return(k=O.hasExecutionOrder)!==null&&k!==void 0?k:!1},set hasExecutionOrder(k){O.hasExecutionOrder=k,N()},get preloads(){return O.preloads?O.preloads.map(I.NotebookKernelPreload.to):[]},get executeHandler(){return W},set executeHandler(k){W=k!=null?k:m},get interruptHandler(){return ie},set interruptHandler(k){ie=k,O.supportsInterrupt=Boolean(k),N()},createNotebookCellExecutionTask(k){if(S)throw new Error("notebook controller is DISPOSED");if(!V.has(k.notebook.uri))throw g._logService.trace(`NotebookController[${o}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(U=>U.toString())),new Error(`notebook controller is NOT associated to notebook: ${k.notebook.uri.toString()}`);return g._createNotebookCellExecution(k)},dispose:()=>{S||(this._logService.trace(`NotebookController[${o}], DISPOSED`),S=!0,this._kernelData.delete(o),b.dispose(),l.dispose(),L.dispose(),this._proxy.$removeKernel(o))},onDidReceiveMessage:L.event,postMessage(k,U){return g._proxy.$postMessage(o,U&&g._extHostNotebook.getIdByEditor(U),k)},asWebviewUri(k){return(0,D.asWebviewUri)(k,g._initData.remote)},updateNotebookAffinity(k,U){g._proxy.$updateNotebookPriority(o,k.uri,U)}};return this._kernelData.set(o,{extensionId:c.identifier,controller:x,onDidReceiveMessage:L,onDidChangeSelection:l,associatedNotebooks:V}),x}$acceptNotebookAssociation(c,h,t){const n=this._kernelData.get(c);if(n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(c,h,t){const n=this._kernelData.get(c);if(!n)return;const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(h)),r=[];for(let o of t){const g=s.getCell(o);g&&r.push(g.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,s.uri.toString(),r.length),await n.controller.executeHandler.call(n.controller,r,s.apiNotebook,n.controller)}catch(o){this._logService.error(`NotebookController[${c}] execute cells FAILED`,o),console.error(o)}}async $cancelCells(c,h,t){var n;const s=this._kernelData.get(c);if(!s)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(h));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,r.apiNotebook);for(let o of t){const g=r.getCell(o);g&&((n=this._activeExecutions.get(g.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(c,h,t){const n=this._kernelData.get(c);if(!n)return;const s=this._extHostNotebook.getEditorById(h);if(!s)throw new Error(`send message for UNKNOWN editor: ${h}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new w(t.notebook,t,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===E.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};f=qe([He(3,a.ILogService)],f),e.ExtHostNotebookKernels=f;var E;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(E||(E={}));class w extends R.Disposable{constructor(c,h,t){super();this._document=c,this._cell=h,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new _(10,n=>this.applyEdits(n)),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:A.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const h={editType:9,handle:this._cell.handle,internalMetadata:c};this.applyEdits([h])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const h=this._document.getCellFromIndex(c);if(!h)throw new Error("INVALID cell index");return h.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(h){c._executionOrder=h,c.mixinMetadata({executionOrder:h})},start(h){var t;if(c._state===E.Resolved||c._state===E.Started)throw new Error("Cannot call start again");c._state=E.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:A.NotebookCellExecutionState.Executing,runStartTime:(t=h==null?void 0:h.startTime)!==null&&t!==void 0?t:null})},end(h){var t,n;if(c._state===E.Resolved)throw new Error("Cannot call resolve twice");c._state=E.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:null,lastRunSuccess:(t=h==null?void 0:h.success)!==null&&t!==void 0?t:null,runEndTime:(n=h==null?void 0:h.endTime)!==null&&n!==void 0?n:null})},clearOutput(h){return c.verifyStateForOutput(),this.replaceOutput([],h)},async appendOutput(h,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return h=(0,p.asArray)(h),c.applyEditSoon({editType:2,handle:n,append:!0,outputs:h.map(I.NotebookCellOutput.from)})},async replaceOutput(h,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return h=(0,p.asArray)(h),c.applyEditSoon({editType:2,handle:n,outputs:h.map(I.NotebookCellOutput.from)})},async appendOutputItems(h,t){return c.verifyStateForOutput(),h=(0,p.asArray)(h),c.applyEditSoon({editType:7,append:!0,items:h.map(I.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(h,t){return c.verifyStateForOutput(),h=(0,p.asArray)(h),c.applyEditSoon({editType:7,items:h.map(I.NotebookCellOutputItem.from),outputId:t})},token:c._tokenSource.token})}}class _{constructor(c,h){this.delay=c,this.callback=h,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const h=this.batch;return this.batch=[],this.callback(h)})),this.waitPromise}}}),define(me[238],ge([0,1,3,5,124]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,P){var i;const A=this._extHostNotebook.getEditorById(I);!A||(i=this._rendererMessageEmitters.get(D))===null||i===void 0||i.fire({editor:A.apiEditor,message:P})}createRendererMessaging(I){return{onDidReceiveMessage:(...P)=>this.getOrCreateEmitterFor(I).event(...P),postMessage:(P,i)=>{const A=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);if(!A)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(A.id,I,i)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new v.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=T}),define(me[66],ge([0,1,5,3,6,23,4,15]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,f,E,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,f,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(f=>this._proxy.$clear(f,a))}show(a,f){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:f)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(a,f){super(a,!1,void 0,f)}append(a){super.append(a),this._id.then(f=>this._proxy.$append(f,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class i extends D{constructor(a,f,E){super(a,!0,f,E)}append(a){throw new Error("Not supported")}}class A{constructor(a,f){this.name=a,this._channel=f}append(a){this._channel.then(f=>f.append(a))}appendLine(a){this._channel.then(f=>f.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,f){this._channel.then(E=>E.show(a,f))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=A;let d=class{constructor(a){this._proxy=a.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,this._proxy)}createOutputChannelFromLogFile(a,f){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new i(a,f,this._proxy)}};d=qe([He(0,I.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[239],ge([0,1,13,21,3,6,5,2,7,17,16,57]),function(K,e,v,R,C,T,y,I,D,P,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(p,a,f){const E=p.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,g,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(r),b=++this._instances,l=E.$show(b,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},m),L={},O=l.then(()=>L);return Promise.race([O,S]).then(W=>{if(W!==L)return S.then(ie=>{const re=[];for(let N=0;N<ie.length;N++){const V=ie[N];let x,k,U,F,M;typeof V=="string"?x=V:(x=V.label,k=V.description,U=V.detail,F=V.picked,M=V.alwaysShow),re.push({label:x,description:k,handle:N,detail:U,picked:F,alwaysShow:M})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{g.onDidSelectItem(ie[N])}),E.$setItems(b,re),l.then(N=>{if(typeof N=="number")return ie[N];if(Array.isArray(N))return N.map(V=>ie[V])})})}).then(void 0,W=>{if(!(0,P.isPromiseCanceledError)(W))return E.$setError(b,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",o).then(void 0,g=>{if(!(0,P.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(r){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=R.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!g)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(S=>S.uri.toString()===g.uri.toString())}createQuickPick(r,o){const g=new t(r,o,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const g=this._sessions.get(r);g&&g._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const g=this._sessions.get(r);g&&g._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class _{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,g)=>{const m=o===D.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(m,o)}),this.update({buttons:r.map((o,g)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const g=r[o];this._pendingUpdate[o]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function u(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=h(s),o=c(s);return{dark:typeof r=="string"?I.URI.file(r):r,light:typeof o=="string"?I.URI.file(o):o}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function h(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends _{constructor(r,o,g){super(r,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)}),this.update({items:r.map((o,g)=>({label:o.label,description:o.description,handle:g,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends _{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?A.default.Error:A.default.Ignore})}}return new w(a,f)}e.createExtHostQuickOpen=d}),define(me[240],ge([0,1,2,3,53,6,13,5,16,97,14,26,39]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(r){if(r)return typeof r.iconPath=="string"?v.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const g=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,P.comparePaths)(g,m)}function f(r,o){let g=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(g=a(r,o),g!==0)return g;if(r.light&&o.light)g=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(g!==0)return g;if(r.dark&&o.dark)g=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return g}function E(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let g=0;g<r.arguments.length;g++){const m=r.arguments[g],S=o.arguments[g];if(m!==S)return m<S?-1:1}return 0}function w(r,o){let g=(0,P.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(g!==0)return g;if(r.command&&o.command)g=E(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(g!==0)return g;if(r.decorations&&o.decorations)g=f(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return g}function _(r,o){for(let g=0;g<r.length;g++)if(r[g]!==o[g])return!1;return!0}function u(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?_(r.arguments,o.arguments):r.arguments===o.arguments)}function c(r,o){return(0,D.equals)(r,o,u)}class h{constructor(o,g,m){this._extension=o,this._proxy=g,this._sourceControlHandle=m,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,d.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,g){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,g)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=h;class t{constructor(o,g,m,S,b){this._proxy=o,this._commands=g,this._sourceControlHandle=m,this._id=S,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,g){const m=this._resourceStatesCommandsMap.get(o);return m?(0,y.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const g=[...this._resourceStates].sort(w),S=(0,D.sortedDiff)(this._resourceSnapshot,g,w).map(L=>{const O=L.toInsert.map(W=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,W);const re=W.resourceUri,N=p(W.decorations),V=W.decorations&&p(W.decorations.light)||N,x=W.decorations&&p(W.decorations.dark)||N,k=[];let U;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ae=new T.DisposableStore;U=this._commands.converter.toInternal(W.command,ae),this._resourceStatesDisposablesMap.set(ie,ae)}else this._resourceStatesCommandsMap.set(ie,W.command);V&&k.push(V),x&&x.toString()!==(V==null?void 0:V.toString())&&k.push(x);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,$=W.decorations&&!!W.decorations.faded,H=W.contextValue||"";return{rawResource:[ie,re,k,F,M,$,H,U],handle:ie}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),b=S.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(ie=>ie.rawResource)]),l=S.reverse();for(const{start:L,deleteCount:O,toInsert:W}of l){const ie=W.map(N=>N.handle),re=this._handlesSnapshot.splice(L,O,...ie);for(const N of re)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),(o=this._resourceStatesDisposablesMap.get(N))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=g,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,g,m,S,b,l){this._proxy=g,this._commands=m,this._id=S,this._label=b,this._rootUri=l,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,b,l)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=o;const g=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&c(this._statusBarCommands,o))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=o;const g=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}get selected(){return this._selected}createResourceGroup(o,g){const m=new t(this._proxy,this._commands,this.handle,o,g),S=R.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,S),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],g=[];for(const[m,S]of this.createdResourceGroups){S.dispose();const b=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),b.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const l=m._takeResourceStateSnapshot();l.length>0&&g.push([m.handle,l]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(g=>{const m=g._takeResourceStateSnapshot();m.length!==0&&o.push([g.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,g,m){this._commands=g,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(I.MainContext.MainThreadSCM),this._telemetry=o.getProxy(I.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const b=this._sourceControls.get(S.sourceControlHandle);if(!b)return S;const l=b.getResourceGroup(S.groupHandle);return l?l.getResourceState(S.handle):S}else if(S&&S.$mid===4){const b=this._sourceControls.get(S.sourceControlHandle);return b?b.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const b=this._sourceControls.get(S.handle);return b||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,g,m,S){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,g,m,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const b=Un._handlePool++,l=new n(o,this._proxy,this._commands,g,m,S);this._sourceControls.set(b,l);const L=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(l),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(o.identifier),L),l}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const g=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier)),m=g&&g[g.length-1];return m&&m.inputBox}$provideOriginalResource(o,g,m){const S=v.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,S.toString());const b=this._sourceControls.get(o);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(S,m)).then(l=>l||null)}$onInputBoxValueChange(o,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(o,g,m,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,g,m);const b=this._sourceControls.get(o);if(!b)return Promise.resolve(void 0);const l=b.getResourceGroup(g);return l?l.$executeResourceCommand(m,S):Promise.resolve(void 0)}$validateInput(o,g,m){this.logService.trace("ExtHostSCM#$validateInput",o);const S=this._sourceControls.get(o);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>S.inputBox.validateInput(g,m)).then(b=>b?Promise.resolve([b.message,b.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var g,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((g=this._sourceControls.get(o))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=qe([He(2,i.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[241],ge([0,1,7,5,163,6]),function(K,e,v,R,C,T){"use strict";var y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(d,p,a,f,E=v.StatusBarAlignment.Left,w){y.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,y,d,"f"),nt(this,I,p,"f"),this._entryId=D.ID_GEN++,this._extension=a,this._id=f,this._alignment=E,this._priority=w}get id(){var d;return(d=this._id)!==null&&d!==void 0?d:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!D.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:$e(this,I,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:$e(this,I,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let a;this._name?a=this._name:a=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let f=this._color;this._backgroundColor&&(f=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,y,"f").$setEntry(this._entryId,p,a,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,f,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,I=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const p={message:d};return this._messages.unshift(p),this._update(),new v.Disposable(()=>{const a=this._messages.indexOf(p);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,p){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new P(this)}createStatusBarEntry(d,p,a,f){return new D(this._proxy,this._commands,d,p,a,f)}setStatusBarMessage(d,p){const a=this._statusMessage.setMessage(d);let f;return typeof p=="number"?f=setTimeout(()=>a.dispose(),p):typeof p!="undefined"&&p.then(()=>a.dispose(),()=>a.dispose()),new v.Disposable(()=>{a.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=i}),define(me[90],ge([0,1,5,3,4]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,P){return this._proxy.$getValue(I,D).then(i=>i||P)}setValue(I,D,P){return this._proxy.$setValue(I,D,P)}$acceptValue(I,D,P){this._onDidChangeStorage.fire({shared:I,key:D,value:P})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(me[91],ge([0,1,4,27,14,89,2]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,i,A){var d;this._logService=i,this._extHostFileSystem=A,this._workspace=(d=P.workspace)!==null&&d!==void 0?d:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,A=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=y.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),A}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};I=qe([He(0,R.IExtHostInitDataService),He(1,C.ILogService),He(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(me[33],ge([0,1,3,5,4,2,15,6,7,164,17,207,21,32,191]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class f{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(g,m=!0){o._checkDisposed(),o._proxy.$sendText(o._id,g,m)},show(g){o._checkDisposed(),o._proxy.$show(o._id,g)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,g,m,S,b,l,L,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:g,waitOnExit:m,strictEnv:S,hideFromUser:b,isFeatureTerminal:l,isExtensionOwnedTerminal:L,useShellEnvironment:O})}async createExtensionTerminal(t){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:t}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=f;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,_=class extends I.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(t){const n=new f(this._proxy,(0,p.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal(t.iconPath).then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){this._terminals[m]._id=t,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:T.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},g=new f(this._proxy,t,o,s);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,P.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const g=this.onDidOpenTerminal(async m=>{m===s.value&&(g.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new I.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const g=[],m={terminal:s.value,line:n},S=[];for(const L of this._linkProviders)S.push(new Promise(async O=>{o.token.onCancellationRequested(()=>O({provider:L,links:[]}));const W=await L.provideTerminalLinks(m,o.token)||[];o.token.isCancellationRequested||O({provider:L,links:W})}));const b=await Promise.all(S);if(o.token.isCancellationRequested)return[];const l=new Map;for(const L of b)L&&L.links.length>0&&g.push(...L.links.map(O=>{const W={id:w++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return l.set(W.id,{provider:L.provider,link:O}),W}));return this._terminalLinkCache.set(t,l),g}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,A.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new u(n[1]);this._setEnvironmentVariableCollection(s,r)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=qe([He(1,y.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let c=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t,n){throw new i.NotSupportedError}};c=qe([He(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[242],ge([0,1,3,16,5,125,20,7]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const A=this._extHostDocumentsAndEditors.allEditors();return i?A:A.map(d=>d.value)}async showTextDocument(i,A,d){let p;typeof A=="number"?p={position:y.ViewColumn.from(A),preserveFocus:d}:typeof A=="object"?p={position:y.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?y.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:p={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,p),f=a&&this._extHostDocumentsAndEditors.getEditor(a);if(f)return f.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,A){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(A.options&&d._acceptOptions(A.options),A.selections){const p=A.selections.selections.map(y.Selection.to);d._acceptSelections(p)}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(p)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},A.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(A.options.lineNumbers)})}),A.selections){const p=I.TextEditorSelectionChangeKind.fromValue(A.selections.source),a=A.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:a,kind:p})}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const A in i){const d=this._extHostDocumentsAndEditors.getEditor(A);if(!d)throw new Error("Unknown text editor");const p=y.ViewColumn.to(i[A]);d.value.viewColumn!==p&&(d._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[243],ge([0,1,2,4,5,6,7]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class I{constructor(i,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:d=>{var p,a;if(d&&d.$mid===11){const f=d.uri===void 0?void 0:v.URI.revive(d.uri);return(a=(p=this._itemsBySourceAndUriMap.get(d.source))===null||p===void 0?void 0:p.get(D(f)))===null||a===void 0?void 0:a.get(d.handle)}return d}})}async $getTimeline(i,A,d,p,a){const f=this._providers.get(i);return f==null?void 0:f.provideTimeline(v.URI.revive(A),d,p,a)}registerTimelineProvider(i,A,d,p){const a=new T.DisposableStore,f=this.convertTimelineItem(A.id,p,a).bind(this);let E;A.onDidChange&&(E=A.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:A.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},A),{scheme:i,onDidChange:void 0,async provideTimeline(_,u,c,h){var t;(h==null?void 0:h.resetCache)&&(a.clear(),(t=w.get(A.id))===null||t===void 0||t.clear());const n=await A.provideTimeline(_,u,c);if(n==null)return;const s=f(_,h);return Object.assign(Object.assign({},n),{source:A.id,items:n.items.map(s)})},dispose(){var _;for(const u of w.values())(_=u.get(A.id))===null||_===void 0||_.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(i,A,d){return(p,a)=>{let f;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(i);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(i,E));const w=D(p);f=E.get(w),f===void 0&&(f=new Map,E.set(w,f))}return E=>{var w,_;const{iconPath:u}=E,c=Qt(E,["iconPath"]),h=`${i}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;f==null||f.set(h,E);let t,n,s;return E.iconPath&&(u instanceof y.ThemeIcon?s={id:u.id}:v.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},c),{id:(_=c.id)!==null&&_!==void 0?_:void 0,handle:h,source:i,command:E.command?A.toInternal(E.command,d):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const p of this._itemsBySourceAndUriMap.values())(d=p.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=I;function D(P){return P==null?void 0:P.toString()}}),define(me[244],ge([0,1,6,10,2,5]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,i,A){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const d=A.schemes.find(p=>!y.supportedSchemes.has(p));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,i),this._proxy.$registerUriOpener(P,A.schemes,D,A.label),(0,v.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener with id: ${D}`);const d=C.URI.revive(P);return A.canOpenExternalUri(d,i)}async $openUri(D,P,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener id: '${D}'`);return A.openExternalUri(C.URI.revive(P.resolvedUri),{sourceUri:C.URI.revive(P.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[245],ge([0,1,5,2,6,17,26]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(P,i){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const A=I.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(A,i),this._proxy.$registerUriHandler(A,P),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(P,i){const A=this.handlers.get(P);if(!A)return Promise.resolve(void 0);try{A.handleUri(R.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(P){return R.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[67],ge([0,1,3,2,175,199,87,5]),function(K,e,v,R,C,T,y,I){"use strict";var D,P,i,A,d,p,a,f,E,w,_,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(m,S,b,l,L,O,W){D.set(this,void 0),P.set(this,void 0),i.set(this,void 0),A.set(this,void 0),d.set(this,void 0),p.set(this,void 0),a.set(this,""),f.set(this,void 0),E.set(this,!1),w.set(this,!1),_.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=$e(this,u,"f").event,nt(this,D,m,"f"),nt(this,P,S,"f"),nt(this,f,b,"f"),nt(this,A,l,"f"),nt(this,d,L,"f"),nt(this,p,O,"f"),nt(this,_,h(O),"f"),nt(this,i,W,"f")}dispose(){nt(this,E,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,w,!0,"f"),(0,y.asWebviewUri)(m,$e(this,A,"f").remote)}get cspSource(){return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,a,"f")}set html(m){this.assertNotDisposed(),$e(this,a,"f")!==m&&(nt(this,a,m,"f"),!$e(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,w,!0,"f"),$e(this,i,"f").report("Webview vscode-resource: uris",$e(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P,"f").$setHtml($e(this,D,"f"),m))}get options(){return this.assertNotDisposed(),$e(this,f,"f")}set options(m){this.assertNotDisposed(),$e(this,P,"f").$setOptions($e(this,D,"f"),s($e(this,p,"f"),$e(this,d,"f"),m)),nt(this,f,m,"f")}async postMessage(m){if($e(this,E,"f"))return!1;const S=(0,T.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:$e(this,_,"f")});return $e(this,P,"f").$postMessage($e(this,D,"f"),S.message,...S.buffers)}assertNotDisposed(){if($e(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,D=new WeakMap,P=new WeakMap,i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,_=new WeakMap,u=new WeakMap;function h(g){try{const m=(0,C.normalizeVersion)((0,C.parseVersion)(g.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=h;class t{constructor(m,S,b,l,L){this.initData=S,this.workspace=b,this._logService=l,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,S,...b){const l=this.getWebview(m);if(l){const{message:L}=(0,T.deserializeWebviewMessage)(S,b);l._onMessageEmitter.fire(L)}}$onMissingCsp(m,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,S,b){const l=new c(m,this._webviewProxy,r(S),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(m,l),l._onDidDispose(()=>{this._webviews.delete(m)}),l}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function n(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=n;function s(g,m,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||o(g,m)}}e.serializeWebviewOptions=s;function r(g){var m;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(m=g.localResourceRoots)===null||m===void 0?void 0:m.map(S=>R.URI.from(S))}}e.reviveOptions=r;function o(g,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(S=>S.uri),g.extensionLocation]}}),define(me[246],ge([0,1,21,75,6,10,25,2,20,67,85,5,7]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new p(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var f;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(f||(f={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new d.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new C.DisposableStore;return _(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(g=>{const m=this.getCustomDocumentEntry(n,g.document.uri);if(u(g)){const S=m.addEdit(g);this._proxy.$onDidEdit(g.document.uri,n,S,g.label)}else this._proxy.$onContentChange(g.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(o,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var g;const m=this._editorProviders.get(n);if(!m)throw new Error(`No provider found for '${n}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=I.URI.revive(t),b=await m.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let l;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(l=(g=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(n,b,l),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=I.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,g){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const S=D.ViewColumn.to(o),b=this._extHostWebview.createNewWebview(n,r.webviewOptions,m.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,S,r.panelOptions,b),L=I.URI.revive(t);switch(m.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,L);return m.provider.resolveCustomEditor(O,l,g)}case 0:{const O=this._extHostDocuments.getDocument(L);return m.provider.resolveCustomTextEditor(O,l,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const g=I.URI.revive(n),m=this._extHostDocuments.getDocument(g);await r.provider.moveCustomTextEditor(m,o,v.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,I.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),g=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(g),g.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,I.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function _(h){return typeof h.resolveCustomTextEditor=="function"}function u(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function c(h){const t=h.scheme===T.Schemas.file||h.scheme===T.Schemas.untitled?h.fsPath:h.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[247],ge([0,1,3,6,2,32,20,67,5,7]),function(K,e,v,R,C,T,y,I,D,P){"use strict";var i,A,d,p,a,f,E,w,_,u,c,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(g,m,S,b,l,L,O){super();i.set(this,void 0),A.set(this,void 0),d.set(this,void 0),p.set(this,void 0),a.set(this,void 0),f.set(this,void 0),E.set(this,void 0),w.set(this,void 0),_.set(this,!0),u.set(this,!0),c.set(this,!1),h.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,h,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,nt(this,i,g,"f"),nt(this,A,m,"f"),nt(this,d,S,"f"),nt(this,a,L,"f"),nt(this,w,l,"f"),nt(this,f,b,"f"),nt(this,p,O,"f")}dispose(){$e(this,c,"f")||(nt(this,c,!0,"f"),$e(this,h,"f").fire(),$e(this,A,"f").$disposeWebview($e(this,i,"f")),$e(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,p,"f")}get viewType(){return this.assertNotDisposed(),$e(this,d,"f")}get title(){return this.assertNotDisposed(),$e(this,f,"f")}set title(g){this.assertNotDisposed(),$e(this,f,"f")!==g&&(nt(this,f,g,"f"),$e(this,A,"f").$setTitle($e(this,i,"f"),g))}get iconPath(){return this.assertNotDisposed(),$e(this,E,"f")}set iconPath(g){this.assertNotDisposed(),$e(this,E,"f")!==g&&(nt(this,E,g,"f"),$e(this,A,"f").$setIconPath($e(this,i,"f"),C.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return $e(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,w,"f")=="number"&&$e(this,w,"f")<0))return $e(this,w,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,_,"f")}_updateViewState(g){$e(this,c,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(nt(this,u,g.active,"f"),nt(this,_,g.visible,"f"),nt(this,w,g.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(g,m){this.assertNotDisposed(),$e(this,A,"f").$reveal($e(this,i,"f"),{viewColumn:g?y.ViewColumn.from(g):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,c,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,_=new WeakMap,u=new WeakMap,c=new WeakMap,h=new WeakMap,t=new WeakMap;class s{constructor(g,m,S){this.webviews=m,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,m,S,b,l={}){const L=typeof b=="object"?b.viewColumn:b,O={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof b=="object"&&!!b.preserveFocus},W=(0,I.shouldSerializeBuffersForPostMessage)(g),ie=s.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(g),ie,m,{title:S,panelOptions:r(l),webviewOptions:(0,I.serializeWebviewOptions)(g,this.workspace,l),serializeBuffersForPostMessage:W},O);const re=this.webviews.createNewWebview(ie,l,g);return this.createNewWebviewPanel(ie,m,S,L,l,re)}$onDidChangeWebviewPanelViewStates(g){const m=Object.keys(g);m.sort((S,b)=>{const l=g[S],L=g[b];return l.active?1:L.active?-1:+l.visible-+L.visible});for(const S of m){const b=this.getWebviewPanel(S);if(!b)continue;const l=g[S];b._updateViewState({active:l.active,visible:l.visible,viewColumn:y.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(g){const m=this.getWebviewPanel(g);m==null||m.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,m,S){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:S,extension:g}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(g)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(g,m,S,b){const l=this._serializers.get(m);if(!l)throw new Error(`No serializer found for '${m}'`);const{serializer:L,extension:O}=l,W=this.webviews.createNewWebview(g,S.webviewOptions,O),ie=this.createNewWebviewPanel(g,m,S.title,b,S.panelOptions,W);await L.deserializeWebviewPanel(ie,S.state)}createNewWebviewPanel(g,m,S,b,l,L){const O=new n(g,this._proxy,m,S,b,l,L);return this._webviewPanels.set(g,O),O}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[248],ge([0,1,3,6,67,5,7]),function(K,e,v,R,C,T,y){"use strict";var I,D,P,i,A,d,p,a,f,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(c,h,t,n,s,r){super();I.set(this,void 0),D.set(this,void 0),P.set(this,void 0),i.set(this,void 0),A.set(this,!1),d.set(this,void 0),p.set(this,void 0),a.set(this,void 0),f.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=$e(this,f,"f").event,E.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,E,"f").event,nt(this,P,t,"f"),nt(this,p,n,"f"),nt(this,I,c,"f"),nt(this,D,h,"f"),nt(this,i,s,"f"),nt(this,d,r,"f")}dispose(){$e(this,A,"f")||(nt(this,A,!0,"f"),$e(this,E,"f").fire(),$e(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,p,"f")}set title(c){this.assertNotDisposed(),$e(this,p,"f")!==c&&(nt(this,p,c,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,I,"f"),c))}get description(){return this.assertNotDisposed(),$e(this,a,"f")}set description(c){this.assertNotDisposed(),$e(this,a,"f")!==c&&(nt(this,a,c,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,I,"f"),c))}get visible(){return $e(this,d,"f")}get webview(){return $e(this,i,"f")}get viewType(){return $e(this,P,"f")}_setVisible(c){c===$e(this,d,"f")||$e(this,A,"f")||(nt(this,d,c,"f"),$e(this,f,"f").fire())}show(c){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,I,"f"),!!c)}assertNotDisposed(){if($e(this,A,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,P=new WeakMap,i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,f=new WeakMap,E=new WeakMap;class _{constructor(c,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,h,t,n){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(c),h,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(c,h,t,n,s){const r=this._viewProviders.get(h);if(!r)throw new Error(`No view provider found for '${h}'`);const{provider:o,extension:g}=r,m=this._extHostWebview.createNewWebview(c,{},g),S=new w(c,this._proxy,h,t,m,!0);this._webviewViews.set(c,S),await o.resolveWebviewView(S,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,h){this.getWebviewView(c)._setVisible(h)}async $disposeWebviewView(c){const h=this.getWebviewView(c);this._webviewViews.delete(c),h.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const h=this._webviewViews.get(c);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=_}),define(me[128],ge([0,1,3,5,2,10,8,4,15]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class xn{constructor(A){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=A.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:A}),this._onDidChangeWindowState.fire(this._state))}openUri(A,d){let p;if(typeof A=="string"){p=A;try{A=C.URI.parse(A)}catch(a){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,y.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,p,d)}async asExternalUri(A,d){if((0,y.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(A,d);return C.URI.from(p)}};P.InitialState={focused:!0},P=qe([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(me[249],ge([0,1,9,101,32,49,6,5,2,15]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(d,p){super();const a=d.getProxy(I.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async f=>{const E=D.URI.file((0,v.join)((0,R.tmpdir)(),(0,C.generateUuid)()));return await a.$download(f,E),E})}};i=qe([He(0,P.IExtHostRpcService),He(1,T.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[250],ge([0,1,2,9,147,28,66,27,15,6,14,112,43]),function(K,e,v,R,C,T,y,I,D,P,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(w,_,u){this.name=w,this.file=_,this.appender=u}static async create(w,_){const u=await(0,A.createRotatingLogger)(w,_,30*d.ByteSize.MB,1);return u.clearFormatters(),new p(w,_,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class a extends y.AbstractExtHostOutputChannel{constructor(w,_,u){super(w,!1,v.URI.file(_.file),u);this._appender=_}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,_){this._appender.flush(),super.show(w,_)}clear(){this._appender.flush(),super.clear()}}let f=class extends y.ExtHostOutputService{constructor(w,_,u){super(w);this.logService=_,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const _=this._channels.get(w);_&&(this._visibleChannelDisposable.value=_.onDidAppend(()=>_.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const _=this._doCreateOutChannel(w);return _.then(u=>u._id.then(c=>this._channels.set(c,u))),new y.LazyOutputChannel(w,_)}async _doCreateOutChannel(w){try{const _=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(_)||await T.Promises.mkdir(_,{recursive:!0});const c=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,h=v.URI.file((0,R.join)(_,`${c}.log`)),t=await p.create(c,h.fsPath);return new a(w,t,this._proxy)}catch(_){return this.logService.error(_),new y.ExtHostPushOutputChannel(w,this._proxy)}}};f=qe([He(0,D.IExtHostRpcService),He(1,i.ILogService),He(2,I.IExtHostInitDataService)],f),e.ExtHostOutputService2=f}),define(me[251],ge([0,1,12,32,15,33]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends T.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,P,i){const A=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:D,shellPath:P,shellArgs:i},D);return this._terminals.push(A),A.create(P,i),A.value}createTerminalFromOptions(D,P){const i=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),D,D.name);return this._terminals.push(i),i.create((0,v.withNullAsUndefined)(D.shellPath),(0,v.withNullAsUndefined)(D.shellArgs),(0,v.withNullAsUndefined)(D.cwd),(0,v.withNullAsUndefined)(D.env),(0,v.withNullAsUndefined)(D.iconPath),(0,v.withNullAsUndefined)(D.message),void 0,(0,v.withNullAsUndefined)(D.strictEnv),(0,v.withNullAsUndefined)(D.hideFromUser),(0,v.withNullAsUndefined)(P==null?void 0:P.isFeatureTerminal),!0,(0,v.withNullAsUndefined)(P==null?void 0:P.useShellEnvironment)),i.value}};y=qe([He(0,C.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[252],ge([0,1,5,15,6,27,2,37,25,28,7,11,48,3,74,14]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(g,m,S){this.remoteAddress=g,this.localAddress=m,this._dispose=S,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(o){const g=o.trim().split(`
`),m=[];return g.forEach(b=>{const l=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);l&&l.length>=3&&m.push({pid:parseInt(l[1],10),socket:parseInt(l[2],10)})}),m.reduce((b,l)=>(b[l.socket]=l,b),{})}e.getSockets=w;function _(...o){const g=[].concat(...o.map(c));return[...new Map(g.filter(m=>m.st==="0A").map(m=>{const S=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:u(S[0]),port:parseInt(S[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=_;function u(o){let g="";if(o.length===8)for(let m=o.length-2;m>=0;m-=2)g+=parseInt(o.substr(m,2),16),m!==0&&(g+=".");else for(let m=o.length-4;m>=0;m-=4)g+=parseInt(o.substr(m,4),16).toString(16),m!==0&&(g+=":");return g}e.parseIpAddress=u;function c(o){const g=o.trim().split(`
`),m=g.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return g.map(b=>b.trim().split(/\s+/).reduce((l,L,O)=>(l[m[O]||O]=L,l),{}))}e.loadConnectionTable=c;function h(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const g=o.trim().split(`
`),m=[];return g.forEach(S=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);b&&b.length>=4&&m.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),m}e.getRootProcesses=t;async function n(o,g,m){const S=m.reduce((l,L)=>(l[L.pid]=L,l),{}),b=[];return o.forEach(({socket:l,ip:L,port:O})=>{var W;const ie=g[l]?g[l].pid:void 0,re=ie?(W=S[ie])===null||W===void 0?void 0:W.cmd:void 0;ie&&re&&!h(re)&&b.push({host:L,port:O,detail:re,pid:ie})}),b}e.findPorts=n;function s(o,g,m){const S=new Map,b=t(g);for(const l of o){const L=m.get(l.port);if(L){S.set(l.port,L);continue}const O=b.find(W=>W.cmd.includes(`${l.port}`));if(O){let W=O,ie;do ie=b.find(re=>re.ppid===W.pid),ie&&(W=ie);while(ie);S.set(l.port,{host:l.ip,port:l.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else S.set(l.port,{host:l.ip,port:l.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=s;let r=class extends C.Disposable{constructor(g,m,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(v.MainContext.MainThreadTunnelService),A.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(m,g.displayName);if(S){const b=new E(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,m){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:g,provider:m}),this._proxy.$registerPortsAttributesProvider(g,S),new i.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(g,m,S,b,l){const L=[];for(const W of g){const ie=this._portAttributesProviders.get(W);if(!ie)return[];L.push(...await Promise.all(m.map(async re=>ie.provider.providePortAttributes(re,S,b,l))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let m=new a.MovingAverage,S;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),l=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${l.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-b;m.update(L),(!S||JSON.stringify(S)!==JSON.stringify(l))&&(S=l,await this._proxy.$onFoundNewCandidates(S)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(m.value)))}}async setTunnelExtensionFunctions(g){var m;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((m=g.tunnelFeatures)!==null&&m!==void 0?m:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,m){if(this._extensionTunnels.has(g.host)){const S=this._extensionTunnels.get(g.host);S.has(g.port)&&(m&&S.get(g.port).disposeListener.dispose(),await S.get(g.port).tunnel.dispose(),S.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(g,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const b=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const l=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:b,disposeListener:l}),d.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const m=await Promise.all(g.map(b=>{var l;return this._showCandidatePort(b.host,b.port,(l=b.detail)!==null&&l!==void 0?l:"")})),S=g.filter((b,l)=>m[l]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(b=>b.port).join(", ")} to ${S.map(b=>b.port).join(", ")}`),S}async findCandidatePorts(){let g="",m="";try{g=await P.Promises.readFile("/proc/net/tcp","utf8"),m=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(V){}const S=_(g,m),b=await new Promise(V=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,k,U)=>{V(k)})}),l=w(b),L=await P.readdir("/proc"),O=[];for(let V of L)try{const x=Number(V),k=D.joinPath(y.URI.file("/proc"),V);if((await P.Promises.stat(k.fsPath)).isDirectory()&&!isNaN(x)){const F=await P.Promises.readlink(D.joinPath(k,"cwd").fsPath),M=await P.Promises.readFile(D.joinPath(k,"cmdline").fsPath,"utf8");O.push({pid:x,cwd:F,cmd:M})}}catch(x){}const W=[],ie=S.filter(V=>{const x=l[V.socket];return x||W.push(V),x}),re=n(ie,l,O);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const V=await new Promise(x=>{(0,I.exec)("ps -F -A -l | grep root",(k,U,F)=>{x(U)})});this._foundRootPorts=s(W,V,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return re.then(V=>N?V.concat(N):V)}};r=qe([He(0,R.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,f.ILogService)],r),e.ExtHostTunnelService=r}),define(me[253],ge([0,1,13,21,17,3,6,99,221,126,23]),function(K,e,v,R,C,T,y,I,D,P,i){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(r,o){try{return JSON.stringify(r,o)}catch(g){return"null"}}function p(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,g)=>g&&g.$mid===1?r.transformOutgoing(g):g:null}var f;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},_=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(o,g=null,m=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=g,this._uriTransformer=m,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,b=P.ProxyIdentifier.count;S<b;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,I.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:g,sid:m}=o;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,m)),this._proxies[g]}_createProxy(o,g){let m={get:(S,b)=>(typeof b=="string"&&!S[b]&&b.charCodeAt(0)===36&&(S[b]=(...l)=>this._remoteCall(o,b,l)),b===u?g:S[b])};return new Proxy(Object.create(null),m)}set(o,g){return this._locals[o.nid]=g,g}assertRegistered(o){for(let g=0,m=o.length;g<m;g++){const S=o[g];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const g=o.byteLength,m=h.read(o,0),S=m.readUInt8(),b=m.readUInt32();switch(S){case 1:case 2:{let{rpcId:l,method:L,args:O}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(O=(0,I.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,b,l,L,O,S===2);break}case 3:case 4:{let{rpcId:l,method:L,args:O}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(O=(0,I.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,b,l,L,O,S===4);break}case 5:{this._logger&&this._logger.logIncoming(g,b,0,"ack"),this._onDidReceiveAcknowledge(b);break}case 6:{this._receiveCancel(g,b);break}case 7:{this._receiveReply(g,b,void 0);break}case 9:{let l=t.deserializeReplyOKJSON(m);this._uriTransformer&&(l=(0,I.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReply(g,b,l);break}case 8:{let l=t.deserializeReplyOKVSBuffer(m);this._receiveReply(g,b,l);break}case 10:{let l=t.deserializeReplyErrError(m);this._uriTransformer&&(l=(0,I.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReplyErr(g,b,l);break}case 11:{this._receiveReplyErr(g,b,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,g,m,S,b,l){this._logger&&this._logger.logIncoming(o,g,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(m)}.${S}(`,b);const L=String(g);let O,W;if(l){const re=new R.CancellationTokenSource;b.push(re.token),O=this._invokeHandler(m,S,b),W=()=>re.cancel()}else O=this._invokeHandler(m,S,b),W=w;this._cancelInvokedHandlers[L]=W;const ie=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(ie.byteLength,g,1,"ack"),this._protocol.send(ie),O.then(re=>{delete this._cancelInvokedHandlers[L];const N=t.serializeReplyOK(g,re,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"reply:",re),this._protocol.send(N)},re=>{delete this._cancelInvokedHandlers[L];const N=t.serializeReplyErr(g,re);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"replyErr:",re),this._protocol.send(N)})}_receiveCancel(o,g){this._logger&&this._logger.logIncoming(o,g,1,"receiveCancel");const m=String(g);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,g,m){this._logger&&this._logger.logIncoming(o,g,0,"receiveReply:",m);const S=String(g);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const b=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],b.resolveOk(m)}_receiveReplyErr(o,g,m){this._logger&&this._logger.logIncoming(o,g,0,"receiveReplyErr:",m);const S=String(g);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const b=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let l;m&&(m.$isError?(l=new Error,l.name=m.name,l.message=m.message,l.stack=m.stack):l=m),b.resolveErr(l)}_invokeHandler(o,g,m){try{return Promise.resolve(this._doInvokeHandler(o,g,m))}catch(S){return Promise.reject(S)}}_doInvokeHandler(o,g,m){const S=this._locals[o];if(!S)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(o));let b=S[g];if(typeof b!="function")throw new Error("Unknown method "+g+" on actor "+(0,P.getStringIdentifierForProxy)(o));return b.apply(S,m)}_remoteCall(o,g,m){if(this._isDisposed)return Promise.reject(C.canceled());let S=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(S=m.pop()),S&&S.isCancellationRequested)return Promise.reject(C.canceled());const b=t.serializeRequestArguments(m,this._uriReplacer),l=++this._lastMessageId,L=String(l),O=new D.LazyPromise;S&&S.onCancellationRequested(()=>{const ie=t.serializeCancel(l);this._logger&&this._logger.logOutgoing(ie.byteLength,l,0,"cancel"),this._protocol.send(t.serializeCancel(l))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(l);const W=t.serializeRequest(l,o,g,b,!!S);return this._logger&&this._logger.logOutgoing(W.byteLength,l,0,`request: ${(0,P.getStringIdentifierForProxy)(o)}.${g}(`,m),this._protocol.send(W),O}}e.RPCProtocol=c,A=_,c.UNRESPONSIVE_TIME=3*1e3;class h{constructor(o,g){this._buff=o,this._offset=g}static alloc(o,g,m){let S=new h(i.VSBuffer.alloc(m+1+4),0);return S.writeUInt8(o),S.writeUInt32(g),S}static read(o,g){return new h(o,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,g}static sizeMixedArray(o,g){let m=0;m+=1;for(let S=0,b=o.length;S<b;S++){const l=o[S],L=g[S];switch(m+=1,L){case 1:m+=this.sizeLongString(l);break;case 2:m+=this.sizeVSBuffer(l);break;case 3:break}}return m}writeMixedArray(o,g){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,S=o.length;m<S;m++){const b=o[m];switch(g[m]){case 1:this.writeUInt8(1),this.writeLongString(b);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:g[m]=this.readLongString();break;case 2:g[m]=this.readVSBuffer();break;case 3:g[m]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(o){for(let g=0,m=o.length;g<m;g++)if(o[g]instanceof i.VSBuffer||typeof o[g]=="undefined")return!0;return!1}static serializeRequestArguments(o,g){if(this._arrayContainsBufferOrUndefined(o)){let m=[],S=[];for(let b=0,l=o.length;b<l;b++){const L=o[b];L instanceof i.VSBuffer?(m[b]=L,S[b]=2):typeof L=="undefined"?(m[b]=i.VSBuffer.alloc(0),S[b]=3):(m[b]=i.VSBuffer.fromString(p(L,g)),S[b]=1)}return{type:"mixed",args:m,argsType:S}}return{type:"simple",args:p(o,g)}}static serializeRequest(o,g,m,S,b){return S.type==="mixed"?this._requestMixedArgs(o,g,m,S.args,S.argsType,b):this._requestJSONArgs(o,g,m,S.args,b)}static _requestJSONArgs(o,g,m,S,b){const l=i.VSBuffer.fromString(m),L=i.VSBuffer.fromString(S);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(l),O+=h.sizeLongString(L);let W=h.alloc(b?2:1,o,O);return W.writeUInt8(g),W.writeShortString(l),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(o){const g=o.readUInt8(),m=o.readShortString(),S=o.readLongString();return{rpcId:g,method:m,args:JSON.parse(S)}}static _requestMixedArgs(o,g,m,S,b,l){const L=i.VSBuffer.fromString(m);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(L),O+=h.sizeMixedArray(S,b);let W=h.alloc(l?4:3,o,O);return W.writeUInt8(g),W.writeShortString(L),W.writeMixedArray(S,b),W.buffer}static deserializeRequestMixedArgs(o){const g=o.readUInt8(),m=o.readShortString(),S=o.readMixedArray(),b=new Array(S.length);for(let l=0,L=S.length;l<L;l++){const O=S[l];typeof O=="string"?b[l]=JSON.parse(O):b[l]=O}return{rpcId:g,method:m,args:b}}static serializeAcknowledged(o){return h.alloc(5,o,0).buffer}static serializeCancel(o){return h.alloc(6,o,0).buffer}static serializeReplyOK(o,g,m){return typeof g=="undefined"?this._serializeReplyOKEmpty(o):g instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(o,g):this._serializeReplyOKJSON(o,d(g,m))}static _serializeReplyOKEmpty(o){return h.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,g){let m=0;m+=h.sizeVSBuffer(g);let S=h.alloc(8,o,m);return S.writeVSBuffer(g),S.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,g){const m=i.VSBuffer.fromString(g);let S=0;S+=h.sizeLongString(m);let b=h.alloc(9,o,S);return b.writeLongString(m),b.buffer}static deserializeReplyOKJSON(o){const g=o.readLongString();return JSON.parse(g)}static serializeReplyErr(o,g){return g?this._serializeReplyErrEror(o,g):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,g){const m=i.VSBuffer.fromString(d(C.transformErrorForSerialization(g),null));let S=0;S+=h.sizeLongString(m);let b=h.alloc(10,o,S);return b.writeLongString(m),b.buffer}static deserializeReplyErrError(o){const g=o.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(o){return h.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(me[254],ge([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(me[255],ge([0,1,10,9,11,2,4,254]),function(K,e,v,R,C,T,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,A){this.localUserHome=i,this.remoteAgentService=A,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||C.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?R.win32:R.posix)}async fileURI(i){let A="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const p=i.indexOf("/",2);p===-1?(A=i.substring(2),i="/"):(A=i.substring(2,p),i=i.substring(p)||"/")}return T.URI.from({scheme:v.Schemas.file,authority:A,path:i,query:"",fragment:""})}};D=qe([He(1,I.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[68],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(y,I){this.line=y,this.character=I}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,I){return new v(0,0)}with(y){return new v(0,0)}}e.Position=v;class R{constructor(y,I,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(y,I),this.end=new v(D,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new R(0,0,0,0)}with(y){return new R(0,0,0,0)}}e.Range=R;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[30],ge([0,1,16,31,24,29,8,4,9,17,68]),function(K,e,v,R,C,T,y,I,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",d=" characters skipped \u27EB",p=(A.length+d.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(k){k[k.file=0]="file",k[k.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(k){k[k.File=1]="File",k[k.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function E(k){return!!k.preview}e.resultIsMatch=E;function w(k){return!!k.resource}e.isFileMatch=w;function _(k){return!!k.message}e.isProgressMessage=_;var u;(function(k){k[k.Normal=0]="Normal",k[k.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=c;class h{constructor(U,F,M){this.ranges=F;const $=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t($)){U=(0,y.getNLines)(U,M.matchLines);let H="",Q=0,ae=0;const we=Math.floor(M.charsPerLine/5),Le=[];for(const Ie of $){const Oe=Math.max(Ie.startColumn-we,0),We=Ie.startColumn+M.charsPerLine;if(Oe>ae+we+p){const j=A+(Oe-ae)+d;H+=j+U.slice(Oe,We),Q+=Oe-(ae+j.length)}else H+=U.slice(ae,We);Le.push(new s(0,Ie.startColumn-Q,Ie.endColumn-Q)),ae=We}this.preview={text:H,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const H=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:U,matches:(0,v.mapArrayOrNot)(F,Q=>new n(Q.startLineNumber-H,Q.startColumn,Q.endLineNumber-H,Q.endColumn))}}}}e.TextSearchMatch=h;function t(k){const U=k[0].startLineNumber;for(const F of k)if(F.startLineNumber!==U||F.endLineNumber!==U)return!1;return!0}class n{constructor(U,F,M,$){this.startLineNumber=U,this.startColumn=F,this.endLineNumber=M,this.endColumn=$}}e.SearchRange=n;class s extends n{constructor(U,F,M){super(U,F,U,M)}}e.OneLineRange=s;var r;(function(k){k.Default="default",k.FileNames="fileNames",k.Type="type",k.Modified="modified",k.CountDescending="countDescending",k.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(k,U=!0){const F=k&&k.files&&k.files.exclude,M=U&&k&&k.search&&k.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let $=Object.create(null);return $=C.mixin($,C.deepClone(F)),$=C.mixin($,C.deepClone(M),!0),$}e.getExcludes=o;function g(k,U){return k.excludePattern&&R.match(k.excludePattern,U)?!1:k.includePattern||k.usingSearchPaths?k.includePattern&&R.match(k.includePattern,U)?!0:k.usingSearchPaths?!!k.folderQueries&&k.folderQueries.some(F=>{const M=F.folder.fsPath;if(T.isEqualOrParent(U,M)){const $=D.relative(M,U);return!F.includePattern||!!R.match(F.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var m;(function(k){k[k.unknownEncoding=1]="unknownEncoding",k[k.regexParseError=2]="regexParseError",k[k.globParseError=3]="globParseError",k[k.invalidLiteral=4]="invalidLiteral",k[k.rgProcessError=5]="rgProcessError",k[k.other=6]="other",k[k.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(U,F){super(U);this.code=F}}e.SearchError=S;function b(k){const U=k.message;if((0,P.isPromiseCanceledError)(k))return new S(U,m.canceled);try{const F=JSON.parse(U);return new S(F.message,F.code)}catch(F){return new S(U,m.other)}}e.deserializeSearchError=b;function l(k){const U={message:k.message,code:k.code};return new Error(JSON.stringify(U))}e.serializeSearchError=l;function L(k){return k.type==="error"?!0:k.type==="success"}e.isSerializedSearchComplete=L;function O(k){return k.type==="success"}e.isSerializedSearchSuccess=O;function W(k){return!!k.path}e.isSerializedFileMatch=W;function ie(k,U){const F=k.searchPath?k.searchPath:k.relativePath;return(0,y.fuzzyContains)(F,U)}e.isFilePatternMatch=ie;class re{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=re;function N(k,U){const F=Object.assign(Object.assign({},k||{}),U||{});return Object.keys(F).filter(M=>{const $=F[M];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=N;class V{constructor(U,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=U.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(U,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,F,M))}includedInQuery(U,F,M){return Promise.resolve(this._parsedExcludeExpression(U,F,M)).then(H=>!!H).then(H=>H?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,F,M)).then(Q=>!!Q):Promise.resolve(!0)).then(H=>H)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=V;function x(k){for(const U in k)if(typeof k[U]!="boolean")return!0;return!1}}),define(me[34],ge([0,1,16,13,21,3,22,10,74,25,8,12,2,166,4,14,185,61,62,27,15,7,30,5]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(L,O,W){return new P.ExtUri(ie=>m(ie,W)).isEqual(L,O)}function r(L,O,W){return s(L.uri,O.uri,W)?0:(0,i.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:s(L.uri,O.uri,W)?(0,i.compare)(L.name,O.name):(0,i.compare)(L.uri.toString(),O.uri.toString())}function g(L,O,W,ie){const re=L.slice(0).sort((V,x)=>W(V,x,ie)),N=O.slice(0).sort((V,x)=>W(V,x,ie));return(0,v.delta)(re,N,(V,x)=>W(V,x,ie))}function m(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class S extends w.Workspace{constructor(O,W,ie,re,N,V){super(O,ie.map(x=>new w.WorkspaceFolder(x)),re,V);this._name=W,this._isUntitled=N,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(V),ie.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(O,W,ie,re){if(!O)return{workspace:null,added:[],removed:[]};const{id:N,name:V,folders:x,configuration:k,isUntitled:U}=O,F=[],M=W;W?x.forEach((ae,we)=>{const Le=d.URI.revive(ae.uri),Ie=S._findFolder(ie||W,Le,re);Ie?(Ie.name=ae.name,Ie.index=ae.index,F.push(Ie)):F.push({uri:Le,name:ae.name,index:we})}):F.push(...x.map(({uri:ae,name:we,index:Le})=>({uri:d.URI.revive(ae),name:we,index:Le}))),F.sort((ae,we)=>ae.index<we.index?-1:1);const $=new S(N,V,F,k?d.URI.revive(k):null,!!U,ae=>m(ae,re)),{added:H,removed:Q}=g(M?M.workspaceFolders:[],$.workspaceFolders,r,re);return{workspace:$,added:H,removed:Q}}static _findFolder(O,W,ie){for(let re=0;re<O.folders.length;re++){const N=O.workspaceFolders[re];if(s(N.uri,W,ie))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let b=class{constructor(O,W,ie,re){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=re,this._extHostFileSystemInfo=ie,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const N=W.workspace;this._confirmedWorkspace=N?new S(N.id,N.name,[],N.configuration?d.URI.revive(N.configuration):null,!!N.isUntitled,V=>m(V,ie)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,ie,...re){const N=[];if(Array.isArray(re)&&re.forEach(F=>{d.URI.isUri(F.uri)&&!N.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&N.push({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[W,ie].some(F=>typeof F!="number"||F<0)||ie===0&&N.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+ie>V.length)return!1;const x=V.slice(0);x.splice(W,ie,...N.map(F=>({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const M=x[F];if(x.some(($,H)=>H!==F&&s(M.uri,$.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,M)=>F.index=M);const{added:k,removed:U}=g(V,x,o,this._extHostFileSystemInfo);if(k.length===0&&U.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,ie,N).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,p.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let ie,re="";if(typeof O=="string"?(ie=d.URI.file(O),re=O):typeof O!="undefined"&&(ie=O,re=O.fsPath),!ie)return re;const N=this.getWorkspaceFolder(ie,!0);if(!N)return re;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let V=(0,P.relativePath)(N.uri,ie);return W&&N.name&&(V=`${N.name}/${V}`),V}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:ie,removed:re}=S.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:re}))}findFiles(O,W,ie,re,N=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${re.value}, entryPoint: findFiles`);let V;if(W===null?V=!1:W&&(typeof W=="string"?V=W:V=W.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:k}=l(O);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(x),(0,A.withUndefinedAsNull)(k),(0,A.withUndefinedAsNull)(V),(0,A.withUndefinedAsNull)(ie),N).then(U=>Array.isArray(U)?U.map(F=>d.URI.revive(F)):[])}async findTextInFiles(O,W,ie,re,N=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${re.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),x=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:k,folder:U}=l(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:x,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:k,excludePattern:F},$=!1;if(this._activeSearchCallbacks[V]=H=>{if($)return;const Q=d.URI.revive(H.resource);H.results.forEach(ae=>{(0,t.resultIsMatch)(ae)?ie({uri:Q,preview:{text:ae.preview.text,matches:(0,v.mapArrayOrNot)(ae.preview.matches,we=>new h.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,v.mapArrayOrNot)(ae.ranges,we=>new h.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):ie({uri:Q,text:ae.text,lineNumber:ae.lineNumber})})},N.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(O,(0,A.withUndefinedAsNull)(U),M,V,N);return delete this._activeSearchCallbacks[V],H||{}}catch(H){throw delete this._activeSearchCallbacks[V],H}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=qe([He(0,c.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,f.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function l(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||d.URI.file(L.base))),{includePattern:O,folder:W}}}),define(me[35],ge([0,1,24,3,34,5,7,188,83,12,13,4,15,14,2]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(n,s){if(s){const r=s.split(".");let o=n;for(let g=0;o&&g<r.length;g++)o=o[r[g]];return o}}function E(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(s,r,o){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};h=qe([He(0,d.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,p.ILogService)],h),e.ExtHostConfiguration=h;class t{constructor(s,r,o,g){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=g,this._extHostWorkspace=r,this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const g=c(r)||{},m=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,g,o==null?void 0:o.identifier);function S(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(l){return typeof f(m,l)!="undefined"},get:(l,L)=>{this._validateConfigurationAccess(s?`${s}.${l}`:l,g,o==null?void 0:o.identifier);let O=f(m,l);if(typeof O=="undefined")O=L;else{let W;const ie=(re,N)=>{let V;const x=()=>{W=W||(0,v.deepClone)(m),V=V||f(W,N)};return(0,P.isObject)(re)?new Proxy(re,{get:(k,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return x(),()=>V;if(W)return V=V||f(W,N),V[U];const F=k[U];return typeof U=="string"?ie(F,`${N}.${U}`):F},set:(k,U,F)=>(x(),V&&(V[U]=F),!0),deleteProperty:(k,U)=>(x(),V&&delete V[U],!0),defineProperty:(k,U,F)=>(x(),V&&Object.defineProperty(V,U,F),!0)}):re};O=ie(O,l)}return O},update:(l,L,O,W)=>{l=s?`${s}.${l}`:l;const ie=S(O);return L!==void 0?this._proxy.$updateConfigurationOption(ie,l,L,g,W):this._proxy.$removeConfigurationOption(ie,l,g,W)},inspect:l=>{var L,O,W,ie,re,N,V,x;l=s?`${s}.${l}`:l;const k=(0,v.deepClone)(this._configuration.inspect(l,g,this._extHostWorkspace.workspace));if(k)return{key:l,defaultValue:(L=k.default)===null||L===void 0?void 0:L.value,globalValue:(O=k.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=k.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(ie=k.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(re=k.default)===null||re===void 0?void 0:re.override,globalLanguageValue:(N=k.user)===null||N===void 0?void 0:N.override,workspaceLanguageValue:(V=k.workspace)===null||V===void 0?void 0:V.override,workspaceFolderLanguageValue:(x=k.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:k.overrideIdentifiers}}};return typeof m=="object"&&(0,v.mixin)(b,m,!1),Object.freeze(b)}_toReadonlyValue(s){const r=o=>(0,P.isObject)(o)?new Proxy(o,{get:(g,m)=>r(g[m]),set:(g,m,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(g,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(g,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const g=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(g===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(r==null?void 0:r.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new I.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,m)=>o.affectsConfiguration(g,c(m))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[69],ge([0,1,2,13,3,5,7,34,40,35,21,33,15,27,4,10,11,14,65,206,17]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(re){function N(x){if(x!=null)return x}re.from=N;function V(x){if(x!=null)return x}re.to=V})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(re){function N(x){if(x!=null)return x}re.from=N;function V(x){if(x!=null)return x}re.to=V})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(re){function N(x){if(x!=null)return x}re.from=N;function V(x){if(x!=null)return x}re.to=V})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(re){function N(k){if(k){const U=k;return U&&!!U.process}else return!1}re.is=N;function V(k){if(k==null)return;const U={process:k.process,args:k.args};return k.options&&(U.options=s.from(k.options)),U}re.from=V;function x(k){if(k!=null)return new y.ProcessExecution(k.process,k.args,k.options)}re.to=x})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(re){function N(x){if(x!=null)return x}re.from=N;function V(x){if(x!=null)return x}re.to=V})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(re){function N(k){if(k){const U=k;return U&&(!!U.commandLine||!!U.command)}else return!1}re.is=N;function V(k){if(k==null)return;const U={};return k.commandLine!==void 0?U.commandLine=k.commandLine:(U.command=k.command,U.args=k.args),k.options&&(U.options=o.from(k.options)),U}re.from=V;function x(k){if(!(k==null||k.command===void 0&&k.commandLine===void 0))return k.commandLine?new y.ShellExecution(k.commandLine,k.options):new y.ShellExecution(k.command,k.args?k.args:[],k.options)}re.to=x})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(re){function N(k){if(k){let U=k;return U&&U.customExecution==="customExecution"}else return!1}re.is=N;function V(k){return{customExecution:"customExecution"}}re.from=V;function x(k,U){return U.get(k)}re.to=x})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(re){function N(V,x){let k;return V.scope!==void 0&&typeof V.scope!="number"?k=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&x&&x.workspaceFile?k=x.workspaceFile:k=u.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:k}}re.from=N})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(re){function N(k,U){if(k==null)return[];const F=[];for(let M of k){const $=V(M,U);$&&F.push($)}return F}re.fromMany=N;function V(k,U){if(k==null)return;let F;k.execution instanceof y.ProcessExecution?F=r.from(k.execution):k.execution instanceof y.ShellExecution?F=g.from(k.execution):k.execution&&k.execution instanceof y.CustomExecution&&(F=m.from(k.execution));const M=t.from(k.definition);let $;if(k.scope?typeof k.scope=="number"?$=k.scope:$=k.scope.uri:$=y.TaskScope.Workspace,!M||!$)return;const H=k.group?k.group.id:void 0;return{_id:k._id,definition:M,name:k.name,source:{extensionId:U.identifier.value,label:k.source,scope:$},execution:F,isBackground:k.isBackground,group:H,presentationOptions:n.from(k.presentationOptions),problemMatchers:k.problemMatchers,hasDefinedMatchers:k.hasDefinedMatchers,runOptions:k.runOptions?k.runOptions:{reevaluateOnRerun:!0},detail:k.detail}}re.from=V;async function x(k,U,F){if(k==null)return;let M;r.is(k.execution)?M=r.to(k.execution):g.is(k.execution)?M=g.to(k.execution):m.is(k.execution)&&(M=m.to(k._id,F));const $=t.to(k.definition);let H;if(k.source&&(k.source.scope!==void 0?typeof k.source.scope=="number"?H=k.source.scope:H=await U.resolveWorkspaceFolder(v.URI.revive(k.source.scope)):H=y.TaskScope.Workspace),!$||!H)return;const Q=new y.Task($,H,k.name,k.source.label,M,k.problemMatchers);return k.isBackground!==void 0&&(Q.isBackground=k.isBackground),k.group!==void 0&&(Q.group=y.TaskGroup.from(k.group)),k.presentationOptions&&(Q.presentationOptions=n.to(k.presentationOptions)),k._id&&(Q._id=k._id),k.detail&&(Q.detail=k.detail),Q}re.to=x})(b=e.TaskDTO||(e.TaskDTO={}));var l;(function(re){function N(x){return x}re.from=N;function V(x){if(!!x)return Object.assign(Object.create(null),x)}re.to=V})(l=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(N,V,x){this._id=V,this._task=x,h.set(this,void 0),nt(this,h,N,"f")}get task(){return this._task}terminate(){$e(this,h,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}h=new WeakMap;var O;(function(re){function N(V){return{id:V._id,task:void 0}}re.from=N})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(N,V,x,k,U,F,M,$){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=k,this._configurationService=U,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,x){if(!x)return new y.Disposable(()=>{});const k=this.nextHandle();return this._handlers.set(k,{type:V,provider:x,extension:N}),this._proxy.$registerTaskProvider(k,V),new y.Disposable(()=>{this._handlers.delete(k),this._proxy.$unregisterTaskProvider(k)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(l.from(N)).then(async V=>{const x=[];for(let k of V){const U=await b.to(k,this._workspaceProvider,this._providedCustomExecutions2);U&&x.push(U)}return x})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,x){const k=this._providedCustomExecutions2.get(N.id);if(k){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,k),this._terminalService.attachPtyToTerminal(V,await k.callback(x))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const x=this._handlers.get(N);if(!x)return Promise.reject(new Error("no handler found"));const k=[],U=(0,R.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(V,k,x,F));return new Promise(F=>{U.then(M=>{Promise.all(k).then(()=>{F(M)})})})}async $resolveTask(N,V){const x=this._handlers.get(N);if(!x)return Promise.reject(new Error("no handler found"));if(V.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${x.type}].`);const k=await b.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!k)throw new Error("Unexpected: Task cannot be resolved.");const U=await x.provider.resolveTask(k,i.CancellationToken.None);if(!U)return;this.checkDeprecation(U,x);const F=b.from(U,x.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==k.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(F.execution)&&await this.addCustomExecution(F,U,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,x){const k=await this._proxy.$createTaskId(N);!x&&!this._providedCustomExecutions2.has(k)&&this._notProvidedCustomExecutions.add(k),this._providedCustomExecutions2.set(k,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const U=this._taskExecutionPromises.get(N);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let x=this._taskExecutionPromises.get(N.id);if(x)return x;const k=new Promise(async(U,F)=>{const M=V||await b.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);M?U(new L(this,N.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,k),k.then(U=>(this._taskExecutions.set(N.id,U),U),U=>Promise.reject(U))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let x=this._notProvidedCustomExecutions.values(),k=x.next();for(;!k.done;)!this._activeCustomExecutions2.has(k.value)&&this._lastStartedTask!==k.value&&(this._providedCustomExecutions2.delete(k.value),this._notProvidedCustomExecutions.delete(k.value)),k=x.next()}};W=qe([He(0,d.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let ie=class extends W{constructor(N,V,x,k,U,F,M,$){super(N,V,x,k,U,F,M,$);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const x=b.from(V,N);if(x===void 0)throw new Error("Task is not valid");if(m.is(x.execution))await this.addCustomExecution(x,V,!1);else throw new c.NotSupportedError;const k=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),V);return this._proxy.$executeTask(x).catch(U=>{throw new Error(U)}),k}provideTasksInternal(N,V,x,k){const U=[];if(k)for(let F of k){this.checkDeprecation(F,x),(!F.definition||!N[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=b.from(F,x.extension);M&&m.is(M.execution)?(U.push(M),V.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:x.extension}}async resolveTaskInternal(N){if(m.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,x){}};ie=qe([He(0,d.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)},Qt=this&&this.__rest||function(K,e){var v={};for(var R in K)Object.prototype.hasOwnProperty.call(K,R)&&e.indexOf(R)<0&&(v[R]=K[R]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(K);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(K,R[C])&&(v[R[C]]=K[R[C]]);return v};define(me[256],ge([0,1,16,13,23,21,3,72,54,6,24,12,2,32,5,40,15,86,20,7,34,216,123]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c,h,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(x,k)=>`${x}:${k.toString()}`;let m=class{constructor(k,U,F){this.documents=U,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new h.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new S(this.proxy),this.workspaceObservers=new N(this.proxy),this.textDocumentObservers=new V(this.proxy,U)}registerTestController(k,U){const F=(0,p.generateUuid)();this.controllers.set(F,{instance:U,extensionId:k}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var $;for(const H of M)($=this.testControllers.get(H))===null||$===void 0||$.subscribeFn(F,U)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(k){return this.textDocumentObservers.checkout(k.uri)}createWorkspaceTestObserver(k){return this.workspaceObservers.checkout(k.uri)}async runTests(k,U=T.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(A.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:k.exclude?F(k.exclude).map(M=>M.testId):void 0,tests:F(k.tests),debug:k.debug},U)}createTestRun(k,U,F,M=!0){return this.runQueue.createTestRun(k,U,F,M)}$publishTestResults(k){this.results=Object.freeze(k.map(U=>(0,i.deepFreeze)(_.TestResults.to(U))).concat(this.results).sort((U,F)=>F.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(k,U){const F=d.URI.revive(U),M=g(k,F);if(this.testControllers.has(M))return;const $=new T.CancellationTokenSource;let H;if(k===1){let Ie=this.documents.getDocument(F);if(!Ie){const Oe=new P.DisposableStore;Ie=await new Promise(We=>{Oe.add((0,R.disposableTimeout)(()=>We(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(j=>{const X=j.find(ee=>ee.document.uri.toString()===F.toString());X&&We(X)}))}).finally(()=>Oe.dispose())}if(Ie){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);H=We=>We.createDocumentTestRoot?We.createDocumentTestRoot(Ie.document,$.token):(0,e.createDefaultDocumentTestRoot)(We,Ie.document,Oe,$.token)}}else{const Ie=await this.workspace.getWorkspaceFolder2(F,!1);Ie&&(H=Oe=>Oe.createWorkspaceTestRoot(Ie,$.token))}if(!H)return;const Q=async(Ie,Oe)=>{try{const We=await H(Oe);We&&we.addRoot(We,Ie)}catch(We){console.error(We)}},ae=new P.DisposableStore,we=ae.add(this.ownedTests.createForHierarchy(Ie=>this.proxy.$publishDiff(k,U,Ie)));ae.add((0,P.toDisposable)(()=>$.dispose(!0)));const Le=[];for(const[Ie,Oe]of this.controllers)Le.push(Q(Ie,Oe.instance));Promise.all(Le).then(()=>we.pushDiff([3,-1])),this.testControllers.set(M,{store:ae,collection:we,subscribeFn:Q})}async $expandTest(k,U){const F=(0,v.mapFind)(this.testControllers.values(),M=>M.collection.treeId===k.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(k.testId,U<0?Infinity:U)),this.flushCollectionDiffs()}$unsubscribeFromTests(k,U){var F;const M=d.URI.revive(U),$=g(k,M);(F=this.testControllers.get($))===null||F===void 0||F.store.dispose(),this.testControllers.delete($)}$acceptDiff(k,U,F){k===1?this.textDocumentObservers.acceptDiff(d.URI.revive(U),F):this.workspaceObservers.acceptDiff(d.URI.revive(U),F)}async $runTestsForProvider(k,U){const F=this.controllers.get(k.tests[0].src.controller);if(!F)return;const M=k.tests.map(({testId:Q,src:ae})=>this.ownedTests.getTestById(Q,ae==null?void 0:ae.tree)).filter(A.isDefined).map(([Q,ae])=>ae),$=k.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(A.isDefined).filter(([Q,ae])=>M.some(we=>Q.comparePositions(we,ae)===1));if(!M.length)return;const H={tests:M.map(Q=>O.unwrap(Q.actual)),exclude:$.map(([,Q])=>O.unwrap(Q.actual)),debug:k.debug};await this.runQueue.enqueueRun({dto:b.fromInternal(k),token:U,extensionId:F.extensionId,req:H,doRun:()=>F.instance.runTests(H,U)})}$lookupTest(k){const U=this.ownedTests.getTestById(k.testId);if(!U)return Promise.resolve(void 0);const F=U[1],{actual:M,discoverCts:$,expandLevels:H}=F,Q=Qt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:k}of this.testControllers.values())k.flushDiff()}getInternalTestForReference(k){var U,F;return(F=(U=this.workspaceObservers.getMirroredTestDataByReference(k))!==null&&U!==void 0?U:(0,v.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(k)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(k)}};m=qe([He(0,E.IExtHostRpcService),He(1,f.IExtHostDocumentsAndEditors),He(2,c.IExtHostWorkspace)],m),e.ExtHostTesting=m;class S{constructor(k){this.proxy=k,this.state=new Map}enqueueRun(k){let U=this.state.get(k.extensionId);U||(U={queue:[],current:void 0},this.state.set(k.extensionId,U));const F=new R.DeferredPromise,M=()=>{const $=[],H=new Set;U.current={publicReq:k.req,factory:Q=>{const ae=new l(Q,k.dto,H,this.proxy);return $.push(ae),k.token.onCancellationRequested(()=>ae.end()),ae}},this.invokeRunner(k.extensionId,k.dto.id,k.doRun,$).finally(()=>F.complete())};return U.queue.push(M),U.queue.length===1&&M(),F.p}createTestRun(k,U,F,M){var $,H;const Q=this.state.get(k);if((Q==null?void 0:Q.current.publicReq)===U)return Q.current.factory(F);const ae=b.fromPublic(U),we=new l(F,ae,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(H=($=U.exclude)===null||$===void 0?void 0:$.map(Le=>Le.id))!==null&&H!==void 0?H:[],id:ae.id,tests:U.tests.map(Le=>Le.id),persist:M}),we.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ae.id)),we}invokeRunner(k,U,F,M){try{const $=F();return(0,R.isThenable)($)?$.then(()=>this.handleInvokeResult(k,U,M,void 0)).catch(H=>this.handleInvokeResult(k,U,M,H)):this.handleInvokeResult(k,U,M,void 0)}catch($){return this.handleInvokeResult(k,U,M,$)}}async handleInvokeResult(k,U,F,M){const $=this.state.get(k);!$||($.queue.shift(),$.queue.length>0?$.queue[0]():this.state.delete(k),await Promise.all(F.map(H=>H.onEnd.wait())))}}class b{constructor(k,U,F){this.id=k,this.include=U,this.exclude=F}static fromPublic(k){var U,F;return new b((0,p.generateUuid)(),new Set(k.tests.map(M=>M.id)),new Set((F=(U=k.exclude)===null||U===void 0?void 0:U.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(k){return new b(k.runId,new Set(k.tests.map(U=>U.testId)),new Set(k.excludeExtIds))}isIncluded(k){for(let U=k;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!0}}class l{constructor(k,U,F,M){this.name=k,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,p.generateUuid)()),o.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,M,"f"),nt(this,s,U,"f"),nt(this,o,F,"f"),M.$startedTestRunTask(U.id,{id:$e(this,r,"f"),name:k,running:!0})}setState(k,U,F){$e(this,s,"f").isIncluded(k)&&(this.ensureTestIsKnown(k),$e(this,n,"f").$updateTestStateInRun($e(this,s,"f").id,$e(this,r,"f"),k.id,U,F))}appendMessage(k,U){$e(this,s,"f").isIncluded(k)&&(this.ensureTestIsKnown(k),$e(this,n,"f").$appendTestMessageInRun($e(this,s,"f").id,$e(this,r,"f"),k.id,_.TestMessage.from(U)))}appendOutput(k){$e(this,n,"f").$appendOutputToRun($e(this,s,"f").id,$e(this,r,"f"),C.VSBuffer.fromString(k))}end(){$e(this,n,"f").$finishedTestRunTask($e(this,s,"f").id,$e(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(k){const U=$e(this,o,"f");if(U.has(k.id))return;const F=[];for(;F.unshift(_.TestItem.from(k)),!(U.has(k.id)||(U.add(k.id),!k.parent));)k=k.parent;$e(this,n,"f").$addTestsToRun($e(this,s,"f").id,F)}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const L=async(x,k,U,F)=>{if(!U)return;const M=await x.createWorkspaceTestRoot(U,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(k)});const $=O.getWrapperForTestItem(M,k);return $.refreshMatch(),$};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(k,U,F){super(k.id,k.label,k.uri,void 0);if(this.actual=k,this.filterDocument=U,this.actualParent=F,!(k instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${k.id} did not`);this.debuggable=k.debuggable,this.runnable=k.runnable,this.description=k.description,this.error=k.error,this.status=k.status,this.range=k.range,this.resolveHandler=k.resolveHandler;const M=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(k).bus.event(H=>{switch(H[0]){case 3:this[H[1]]=H[2];break;case 0:const Q=O.getWrapperForTestItem(H[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=k,Q.refreshMatch();break;default:M.bus.fire(H)}})}static removeFilter(k){this.wrapperMap.delete(k)}static getWrapperForTestItem(k,U,F){let M=this.wrapperMap.get(U);if(M==null?void 0:M.has(k))return M.get(k);M||(M=new WeakMap,this.wrapperMap.set(U,M));const $=new O(k,U,F);return M.set(k,$),$}static unwrap(k){return k instanceof O?k.actual:k}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var k,U;const F=this._cachedMatchesFilter;for(const $ of this.actual.children.values()){const H=O.getWrapperForTestItem($,this.filterDocument,this);H.hasNodeMatchingFilter?this.children.has(H.id)||this.addChild(H):H.dispose()}const M=this.children.size>0||((k=this.actual.uri)===null||k===void 0?void 0:k.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((U=this.actualParent)===null||U===void 0||U.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,_.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:U,removed:F}=this;return{get added(){return[...k].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(k){let U=[];for(const F of k){const M=this.items.get(F);M&&U.push(M.revived)}return U}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,U){return Object.assign(Object.assign({},k),{revived:_.TestItem.toPlain(k.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=ie;class re{constructor(){this.resources=new Map}checkout(k){var U,F;const M=k.toString(),$=(U=this.resources.get(M))!==null&&U!==void 0?U:this.createObserverData(k);return(F=$.pendingDeletion)===null||F===void 0||F.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,I.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(k))})}}getMirroredTestDataByReference(k){for(const{tests:U}of this.resources.values()){const F=U.getMirroredTestDataByReference(k);if(F)return F}}eventuallyDispose(k){return(0,R.disposableTimeout)(()=>this.unlisten(k),10*1e3)}createObserverData(k){const U=new ie,F=this.listen(k,$=>U.apply($)),M={observers:0,tests:U,listener:F};return this.resources.set(k.toString(),M),M}unlisten(k){var U;const F=k.toString(),M=this.resources.get(F);M&&(M.observers=-1,(U=M.pendingDeletion)===null||U===void 0||U.dispose(),M.listener.dispose(),this.resources.delete(F))}}class N extends re{constructor(k){super();this.proxy=k,this.diffListeners=new Map}acceptDiff(k,U){var F;(F=this.diffListeners.get(k.toString()))===null||F===void 0||F(U)}listen(k,U){this.proxy.$subscribeToDiffs(0,k);const F=k.toString();return this.diffListeners.set(F,U),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,k),this.diffListeners.delete(F)})}}class V extends re{constructor(k,U){super();this.proxy=k,this.documents=U,this.diffListeners=new Map}acceptDiff(k,U){var F;(F=this.diffListeners.get(k.toString()))===null||F===void 0||F(U)}listen(k,U){if(!this.documents.getDocument(k))return new u.Disposable(()=>{});const M=k.toString();return this.diffListeners.set(M,U),this.proxy.$subscribeToDiffs(1,k),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,k),this.diffListeners.delete(M)})}}}),define(me[257],ge([0,1,16,52,31,77,22,10,9,25,8,12,2,141,171,84,61,209,255,30]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(S,b,l,L){this.configurationService=S,this.workspaceContextService=b,this.editorGroupsService=l,this.pathService=L}text(S,b,l={}){S=this.getContentPattern(S,l);const L=this.configurationService.getValue(),O=b&&b.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),W=this.commonQuery(b==null?void 0:b.map(E.toWorkspaceFolder),l);return Object.assign(Object.assign({},W),{type:2,contentPattern:S,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles})}getContentPattern(S,b){const l=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},S),{wordSeparators:l.editor.wordSeparators});return this.isCaseSensitive(S,b)&&(L.isCaseSensitive=!0),this.isMultiline(S)&&(L.isMultiline=!0),L}file(S,b={}){const l=this.commonQuery(S,b);return Object.assign(Object.assign({},l),{type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey})}handleIncludeExclude(S,b){return S?(S=Array.isArray(S)?S.map(r):r(S),b?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],b={}){const l=this.handleIncludeExclude(b.includePattern,b.expandPatterns),L=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),O=S.length>1,W=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,b,L)):S.map(N=>this.getFolderQueryForRoot(N,b,L,O))).filter(N=>!!N),ie={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:L.pattern,includePattern:l.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const V=v.coalesce(v.flatten(this.editorGroupsService.groups.map(k=>k.editors.map(U=>U.resource)))).filter(k=>(0,u.pathIncludedInQuery)(ie,k.fsPath)),x=this.commonQueryFromFileList(V);return Object.assign(Object.assign({},ie),x)}const re=b.extraFileResources&&b.extraFileResources.filter(N=>(0,u.pathIncludedInQuery)(ie,N.fsPath));return ie.extraFileResources=re&&re.length?re:void 0,ie}commonQueryFromFileList(S){const b=[],l=new y.ResourceMap,L={};let O=!1;return S.forEach(W=>{var ie,re;if(W.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(W)){const V=(re=(ie=this.workspaceContextService.getWorkspaceFolder(W))===null||ie===void 0?void 0:ie.uri)!==null&&re!==void 0?re:W.with({path:D.dirname(W.fsPath)});let x=l.get(V);x||(O=!0,x={folder:V,includePattern:{}},b.push(x),l.set(V,x));const k=D.relative(V.fsPath,W.fsPath);(0,A.assertIsDefined)(x.includePattern)[k.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:b,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(S,b){if(b.isSmartCase){if(S.isRegExp){if(i.containsUppercaseCharacter(S.pattern,!0))return!0}else if(i.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,p.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const b=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),L=(Array.isArray(S)?S:n(S)).map(x=>{const k=this.pathService.resolvedUserHome;return k?(0,T.untildify)(x,k.scheme===I.Schemas.file?k.fsPath:k.path):x}),O=R.groupBy(L,x=>b(x)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),ie={},re=this.expandSearchPathPatterns(O.searchPaths||[]);re&&re.length&&(ie.searchPaths=re);const N=v.flatten(W),V=t(...N);return V&&(ie.pattern=V),ie}getExcludesForFolder(S,b){return b.disregardExcludeSettings?void 0:(0,u.getExcludes)(S,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const b=v.flatten(S.map(L=>{let{pathPortion:O,globPortion:W}=h(L);W&&(W=o(W));const ie=this.expandOneSearchPath(O);return v.flatten(ie.map(re=>this.resolveOneSearchPathPattern(re,W)))})),l=new Map;return b.forEach(L=>{const O=L.searchPath.toString(),W=l.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):l.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==I.Schemas.file?[{searchPath:b[0].uri.with({path:S})}]:[{searchPath:d.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=r(S),S.startsWith("../")||S===".."){const L=D.posix.resolve(b.path,S);return[{searchPath:b.with({path:L})}]}const l=o(S);return[{searchPath:b,pattern:l}]}else{if(S==="./"||S===".\\")return[];{const b=S.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=b.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(A.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&o(W)}});{const O=S.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:S,ie=a.localize(0,null,W);throw new Error(ie)}}}}resolveOneSearchPathPattern(S,b){const l=S.pattern&&b?`${S.pattern}/${b}`:S.pattern||b,L=[{searchPath:S.searchPath,pattern:l}];return l&&!l.endsWith("**")&&L.push({searchPath:S.searchPath,pattern:l+"/**"}),L}getFolderQueryForSearchPath(S,b,l){const L=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(S.searchPath),b,l,!1);return L?Object.assign(Object.assign({},L),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,b,l,L){let O;const W=d.URI.isUri(S)?S:S.uri;if(l.searchPaths){const x=l.searchPaths.filter(k=>(0,P.isEqual)(k.searchPath,W))[0];if(x&&!x.pattern)return null;x&&(O=x.pattern)}const ie=this.configurationService.getValue({resource:W}),re=this.getExcludesForFolder(ie,b),N=Object.assign(Object.assign({},re||{}),O||{}),V=d.URI.isUri(S)?(0,P.basename)(S):S.name;return{folder:W,folderName:L?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!ie.search.followSymlinks}}};c=qe([He(0,f.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,_.IPathService)],c),e.QueryBuilder=c;function h(m){const S=m.match(/[\*\{\}\(\)\[\]\?]/);if(S){const b=S.index,l=m.substr(0,b).match(/[/|\\][^/\\]*$/);if(l){let L=m.substr(0,l.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:m.substr((l.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((S,b)=>(S[b]=!0,S),Object.create(null)):void 0}function n(m){return C.splitGlobAware(m,",").map(S=>S.trim()).filter(S=>!!S.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function o(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(m,S){m=v.distinct(m,L=>L.toString());const b=[],l=S.getWorkspace();return m&&m.forEach(L=>{let O;if(S.getWorkbenchState()===2)O=(0,P.relativePath)(l.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=S.getWorkspaceFolder(L);if(W){const ie=W.name;if(l.folders.filter(N=>N.name===ie).length===1){const N=(0,P.relativePath)(W.uri,L);N===""?O=`./${W.name}`:O=`./${W.name}/${N}`}else O=L.fsPath}}O&&b.push(O)}),b}e.resolveResourcesForSearchIncludes=g}),define(me[258],ge([0,1,25,2,21,17,4,257,30,61]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function A(f,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const _=[],u=[];for(const r of w)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||f.forceUsingSearch?u.push(o):_.push(o)}if(_.length===0&&u.length===0)return Promise.resolve(void 0);let c;const h=new Promise((r,o)=>{c=r}),t=r=>c({activationEvent:r}),n=Promise.all(_.map(r=>d(f,r,t))).then(()=>{}),s=p(f,E.identifier,u,t);return Promise.all([n,s]).then(()=>{c(void 0)}),h}e.checkActivateWorkspaceContainsExtension=A;async function d(f,E,w){for(const _ of f.folders)if(await f.exists(v.joinPath(R.URI.revive(_),E))){w(`workspaceContains:${E}`);return}}async function p(f,E,w,_){if(w.length===0)return Promise.resolve(void 0);const u=new C.CancellationTokenSource,c=f.checkExists(f.folders,w,u.token),h=setTimeout(async()=>{u.cancel(),_(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await c}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}u.dispose(),clearTimeout(h),t&&_(`workspaceContains:${w.join(",")}`)}function a(f,E,w,_){const u=f.get(y.IInstantiationService),c=f.get(D.ISearchService),t=u.createInstance(I.QueryBuilder).file(E.map(n=>(0,P.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return c.fileSearch(t,_).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(K,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(K,v):C?C.value=v:e.set(K,v),v},$e=this&&this.__classPrivateFieldGet||function(K,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(K):R?R.value:e.get(K)};define(me[41],ge([0,1,161,9,70,25,13,6,22,2,14,5,35,219,90,34,39,217,17,26,23,195,7,116,4,27,91,15,82,48,33,3,258,88,196]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c,h,t,n,s,r,o,g,m,S,b,l,L,O,W){"use strict";var ie,re,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class Bn extends I.Disposable{constructor(F,M,$,H,Q,ae,we,Le,Ie,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=$,this._initData=we,this._extHostWorkspace=H,this._extHostConfiguration=Q,this._logService=ae,this._extHostTunnelService=Ie,this._extHostTerminalService=Oe,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=F.createChild(new m.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(j=>We.add(u.ExtensionIdentifier.toKey(j))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(j,X,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(j,_.transformErrorForSerialization(X),ee)},actualActivateExtension:async(j,X)=>{if(We.has(u.ExtensionIdentifier.toKey(j)))return await this._mainThreadExtensionsProxy.$activateExtension(j,X),new p.HostExtension;const ee=this._registry.getExtensionDescription(j);return this._activateExtension(ee,X)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){_.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const $=this._activator.getActivatedExtension(F);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map($=>{if(!!this._getEntryPoint($))return this._hostUtils.realpath($.extensionLocation.fsPath).then(H=>F.set(P.URI.file(H).fsPath,$))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const $=this._activator.getActivatedExtension(F);if(!$)return M;try{typeof $.module.deactivate=="function"&&(M=Promise.resolve($.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,I.dispose)($.subscriptions)}catch(H){this._logService.error(H)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then($=>{const H=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",H),$},$=>{throw this._logExtensionActivationTimes(F,M,"failure"),$})}_logExtensionActivationTimes(F,M,$,H){const Q=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),H||{}),{outcome:$}))}_doActivateExtension(F,M){const $=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const H=this._getEntryPoint(F);if(!H)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Q=new p.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,T.joinPath)(F.extensionLocation,H),Q),this._loadExtensionContext(F)]).then(ae=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,ae[0],ae[1],Q))).then(ae=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ae))}_loadExtensionContext(F){const M=new h.ExtensionGlobalMemento(F,this._storage),$=new h.ExtensionMemento(F.identifier.value,!1,this._storage),H=new W.ExtensionSecrets(F,this._secretState),Q=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ae=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Le;return Object.freeze({globalState:M,workspaceState:$,secrets:H,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ie){return R.join(F.extensionLocation.fsPath,Ie)},get storagePath(){var Ie;return(Ie=we._storagePath.workspaceValue(F))===null||Ie===void 0?void 0:Ie.fsPath},get globalStoragePath(){return we._storagePath.globalValue(F).fsPath},get logPath(){return R.join(we._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(we._initData.logsLocation,F.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(F)},get globalStorageUri(){return we._storagePath.globalValue(F)},get extensionMode(){return Q},get extension(){return Le===void 0&&(Le=new k(we,F.identifier,F,ae)),Le},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(F),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,$,H,Q){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,$,H,Q).then(ae=>new p.ActivatedExtension(!1,null,Q.build(),$,ae,H.subscriptions))}static _callActivateOptional(F,M,$,H,Q){if(typeof $.activate=="function")try{Q.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ae=typeof global=="object"?global:self,we=$.activate.apply(ae,[H]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(we).then(Le=>(Q.activateResolveStop(),Le))}catch(ae){return Promise.reject(ae)}else return Promise.resolve($)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(M),H=Promise.all([F,$]).then(()=>{});return Promise.race([H,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:F.map(ae=>ae.uri),forceUsingSearch:$,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,we,Le)=>this._mainThreadWorkspaceProxy.$checkExists(ae,we,Le)},Q=await(0,L.checkActivateWorkspaceContainsExtension)(H,M);if(!!Q)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Q.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const $=await this._loadCommonJSModule(null,M,new p.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise((H,Q)=>{const ae=(Ie,Oe)=>{Ie?Q(Ie):H(typeof Oe=="number"&&Oe>0?1:0)},we=(0,T.originalFSPath)(M),Le=$.run(we,ae);Le&&Le.then&&Le.then(()=>{H(0)}).catch(Ie=>{Q(Ie.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,I.toDisposable)(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const $=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${$}`,!1),{authorityPrefix:$,resolver:this._resolvers[$]}}async $resolveAuthority(F,M){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(F);if(!H)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${$}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),C.mark(`code/extHost/willResolveAuthority/${$}`);const Q=await H.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${$}`);const ae={authority:F,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},we={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:ae,options:we,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(C.mark(`code/extHost/didResolveAuthorityError/${$}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(F,M){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(F);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${$}`);const Q=P.URI.revive(M);if(typeof H.getCanonicalURI=="undefined")return Q;const ae=await(0,y.asPromise)(()=>H.getCanonicalURI(Q));return ae||Q}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(H=>H.extensionLocation=P.URI.revive(H.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(M.map(async H=>{const Q=this._registry.getExtensionDescription(H);if(!Q)return;const ae=await this._hostUtils.realpath(Q.extensionLocation.fsPath);$.delete(P.URI.file(ae).fsPath)})),await Promise.all(F.map(async H=>{const Q=await this._hostUtils.realpath(H.extensionLocation.fsPath);$.set(P.URI.file(Q).fsPath,H)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=c.VSBuffer.alloc(F),$=Math.random()%256;for(let H=0;H<F;H++)M.writeUInt8($,H);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};V=qe([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,g.IExtHostRpcService),He(3,f.IExtHostWorkspace),He(4,d.IExtHostConfiguration),He(5,i.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,S.IExtHostTunnelService),He(9,b.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function x(U,F){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class k{constructor(F,M,$,H){ie.set(this,void 0),re.set(this,void 0),N.set(this,void 0),nt(this,ie,F,"f"),nt(this,re,M,"f"),nt(this,N,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=H}get isActive(){return $e(this,ie,"f").isActivated($e(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,ie,"f").getExtensionExports($e(this,N,"f"))}activate(){return $e(this,ie,"f").activateByIdWithErrors($e(this,N,"f"),{startup:!1,extensionId:$e(this,re,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=k,ie=new WeakMap,re=new WeakMap,N=new WeakMap}),define(me[50],ge([0,1,9,2,3,13,5,7,121,34,41,40,208,35,203,15,4,12,36,47]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let c=class{constructor(m,S,b,l,L,O){this._workspaceService=S,this._extensionService=b,this._editorsService=l,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(ie=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,S){const b=m;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let l=`debug:${encodeURIComponent(b.path||"")}`,L="?";return S&&(l+=`${L}session=${encodeURIComponent(S.id)}`,L="&"),l+=`${L}ref=${b.sourceReference}`,R.URI.parse(l)}else{if(b.path)return R.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const S=[];for(const b of m.getAllExtensionDescriptions())if(b.contributes){const l=b.contributes.debuggers;if(l&&l.length>0)for(const L of l)(0,a.isDebuggerMainContribution)(L)&&S.push(L.type)}this._debugServiceProxy.$registerDebugTypes(S)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(S=>m.push(S)),m}addBreakpoints(m){this.startBreakpoints();const S=m.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(S,[],[]);const b=[],l=new Map;for(const L of S)if(L instanceof I.SourceBreakpoint){let O=l.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},l.set(L.location.uri.toString(),O),b.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof I.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(m){this.startBreakpoints();const S=m.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],S,[]);const b=S.filter(O=>O instanceof I.SourceBreakpoint).map(O=>O.id),l=S.filter(O=>O instanceof I.FunctionBreakpoint).map(O=>O.id),L=S.filter(O=>O instanceof I.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(b,l,L)}startDebugging(m,S,b){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,S,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,S,b){if(!S)return new I.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:l,provider:S}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,b,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,l),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==S),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(m,S,b){if(!b)return new I.Disposable(()=>{});if(!this.definesDebugType(m,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.getAdapterDescriptorFactoryByType(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:S,handle:l,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(S,l),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(m,S){if(!S)return new I.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:b,factory:S}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==S)})}async $runInTerminal(m,S){return Promise.resolve(void 0)}async $substituteVariables(m,S){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let b;const l=await this.getFolder(m);return l&&(b={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,S)}createDebugAdapter(m,S){if(m.type==="implementation")return new r(m.implementation)}createSignService(){}async $startDASession(m,S){const b=this,l=await this.getSession(S);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,l);if(!W)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const ie=W;return this._debugAdapters.set(m,ie),this.getDebugAdapterTrackers(l).then(re=>(re&&this._debugAdaptersTrackers.set(m,re),ie.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const V=N,x={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const k=await this._signService.sign(V.arguments.value);x.body={signature:k},ie.sendResponse(x)}else throw new Error("no signer")}catch(k){x.success=!1,x.message=k.message,ie.sendResponse(x)}}else re&&re.onDidSendMessage&&re.onDidSendMessage(N),N=(0,a.convertToVSCPaths)(N,!0),b._debugServiceProxy.$acceptDAMessage(m,N)}),ie.onError(N=>{re&&re.onError&&re.onError(N),this._debugServiceProxy.$acceptDAError(m,N.name,N.message,N.stack)}),ie.onExit(N=>{re&&re.onExit&&re.onExit((0,w.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,w.withNullAsUndefined)(N),void 0)}),re&&re.onWillStartSession&&re.onWillStartSession(),ie.startSession()))})}$sendDAMessage(m,S){S=(0,a.convertToDAPaths)(S,!1);const b=this._debugAdaptersTrackers.get(m);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(S);const l=this._debugAdapters.get(m);l&&l.sendMessage(S)}$stopDASession(m){const S=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),S&&S.onWillStopSession&&S.onWillStopSession();const b=this._debugAdapters.get(m);return this._debugAdapters.delete(m),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const S=[],b=[],l=[];if(m.added)for(const L of m.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new I.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new I.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const ie=R.URI.revive(L.uri);W=new I.SourceBreakpoint(new I.Location(ie,new I.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),S.push(W)}}if(m.removed)for(const L of m.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),b.push(O))}if(m.changed){for(const L of m.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof I.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof I.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new I.Location(R.URI.revive(L.uri),new I.Position(L.line,L.character))}l.push(O)}}}this.fireBreakpointChanges(S,b,l)}$provideDebugConfigurations(m,S,b){return(0,T.asPromise)(async()=>{const l=this.getConfigProviderByHandle(m);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(S);return l.provideDebugConfigurations(L,b)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(m,S,b,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(m);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(S);return L.resolveDebugConfiguration(O,b,l)})}$resolveDebugConfigurationWithSubstitutedVariables(m,S,b,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(m);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(S);return L.resolveDebugConfigurationWithSubstitutedVariables(O,b,l)})}async $provideDebugAdapter(m,S){const b=this.getAdapterDescriptorFactoryByHandle(m);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(S);return this.getAdapterDescriptor(b,l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(m){const S=await this.getSession(m);this._onDidStartDebugSession.fire(S)}async $acceptDebugSessionTerminated(m){const S=await this.getSession(m);S&&(this._onDidTerminateDebugSession.fire(S),this._debugSessions.delete(S.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,S){const b=await this.getSession(m);b&&b._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(m,S){const l={session:await this.getSession(m),event:S.event,body:S.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const S=this._adapterFactories.filter(b=>b.type===m);if(S.length>0)return S[0].factory}getAdapterDescriptorFactoryByHandle(m){const S=this._adapterFactories.filter(b=>b.handle===m);if(S.length>0)return S[0].factory}getConfigProviderByHandle(m){const S=this._configProviders.filter(b=>b.handle===m);if(S.length>0)return S[0].provider}definesDebugType(m,S){if(m.contributes){const b=m.contributes.debuggers;if(b&&b.length>0){for(const l of b)if(l.label&&l.type&&l.type===S)return!0}}return!1}getDebugAdapterTrackers(m){const b=m.configuration.type,l=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>(0,T.asPromise)(()=>L.factory.createDebugAdapterTracker(m)).then(O=>O,O=>null));return Promise.race([Promise.all(l).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new s(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(m,S){const b=S.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new I.DebugAdapterServer(b));if(m){const L=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>m.createDebugAdapterDescriptor(S,this.daExecutableFromPackage(S,L))).then(O=>{if(O)return O})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(S,l))}daExecutableFromPackage(m,S){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,S,b){(m.length>0||S.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:S,changed:b}))}async getSession(m){if(m)if(typeof m=="string"){const S=this._debugSessions.get(m);if(S)return S}else{let S=this._debugSessions.get(m.id);if(!S){const b=await this.getFolder(m.folderUri),l=m.parent?this._debugSessions.get(m.parent):void 0;S=new h(this._debugServiceProxy,m.id,m.type,m.name,b,m.configuration,l),this._debugSessions.set(S.id,S),this._debugServiceProxy.$sessionCached(S.id)}return S}throw new Error("cannot find session")}getFolder(m){if(m){const S=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}};c=qe([He(0,f.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class h{constructor(m,S,b,l,L,O,W){this._debugServiceProxy=m,this._id=S,this._type=b,this._name=l,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,S){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,S)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=h;class t{constructor(m){this.value=Object.freeze({append(S){m.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.ExtHostDebugConsole=t;class n extends d.AbstractVariableResolverService{constructor(m,S,b,l,L){function O(){if(S){const W=S.activeEditor();if(W)return W.document.uri;const ie=l.tabs.filter(re=>re.isActive);if(ie.length>0)return ie[0].resource}}super({getFolderUri:W=>{const ie=m.filter(re=>re.name===W);if(ie&&ie.length>0)return ie[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(W,ie)=>b.getConfiguration(void 0,W).get(ie),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const ie=L.getWorkspaceFolder(W);if(ie)return v.normalize(ie.uri.fsPath)}}},getSelectedText:()=>{if(S){const W=S.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(S){const W=S.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=n;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(S=>S.onError?S.onError(m):void 0)}onExit(m,S){this.trackers.forEach(b=>b.onExit?b.onExit(m,S):void 0)}}class r extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends c{constructor(m,S,b,l,L,O){super(m,S,b,l,L,O)}createVariableResolver(m,S,b){return new n(m,S,b,this._editorTabs)}};o=qe([He(0,f.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(me[259],ge([0,1,70,2,5,35,39,26,15,27,4,41,36,14]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(u,c,h,t,n,s,r){this._apiFactory=u,this._extensionRegistry=c,this._instaService=h,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,c,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};a=qe([He(2,i.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,A.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,p.ILogService)],a),e.RequireInterceptor=a;class f{constructor(u,c,h,t,n){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=h,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const h=this._extensionPaths.findSubstr(c.fsPath);if(h){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(h.identifier));return t||(t=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(h.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(u,c){this.nodeModuleName="keytar";const{environment:h}=c,t=u.getProxy(C.MainContext.MainThreadKeytar);if(h.appRoot){let n=h.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,c){return this._impl}alternativeModuleName(u){const c=u.length;if(c<=7||!this.alternativeNames)return;const h=c-7;if((u.charAt(h)==="/"||u.charAt(h)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};E=qe([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],E);let w=class{constructor(u,c,h){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(C.MainContext.MainThreadTelemetry);const t=h.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=R.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(u,c,h){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=h(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=qe([He(2,D.IExtHostRpcService)],w)}),define(me[260],ge([0,1,167,11,7,204,34,41,40,35,33,15,50,190,13,205,47]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends d.ExtHostDebugServiceBase{constructor(c,h,t,n,s,r,o){super(c,h,t,n,s,o);this._terminalService=r,this._integratedTerminalInstances=new _}createDebugAdapter(c,h){switch(c.type){case"server":return new T.SocketDebugAdapter(c);case"pipeServer":return new T.NamedPipeDebugAdapter(c);case"executable":return new T.ExecutableDebugAdapter(c,h.type)}return super.createDebugAdapter(c,h)}daExecutableFromPackage(c,h){const t=T.ExecutableDebugAdapter.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(c,h){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:s});let o=await this._integratedTerminalInstances.checkout(r),g,m=!1;if(o)g=c.cwd;else{const L={shellPath:n,shellArgs:s,cwd:c.cwd,name:c.title||v.localize(0,null)};m=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const S=await o.processId;m?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):R.isWindows?o.sendText("cls"):o.sendText("clear"));const b=(0,f.prepareCommand)(n,c.args,g,c.env);o.sendText(b);const l=this.onDidTerminateDebugSession(L=>{L.id===h&&(this._integratedTerminalInstances.free(o),l.dispose())});return S}else if(c.kind==="external")return(0,f.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,h)}createVariableResolver(c,h,t){return new d.ExtHostVariableResolverService(c,h,t,this._editorTabs,this._workspaceService)}};w=qe([He(0,A.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class _{constructor(){this._terminalInstances=new Map}async checkout(c){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,a.createCancelablePromise)(async r=>{if(s.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await n.processId))return null;const o=Date.now();return s.lastUsedAt+_.minUseDelay>o||r.isCancellationRequested||s.config!==c?null:(s.lastUsedAt=o,n)}));return await(0,a.firstParallel)(t,n=>!!n)}insert(c,h){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this._terminalInstances.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}_.minUseDelay=1e3}),define(me[261],ge([0,1,9,2,110,34,50,40,35,33,15,27,69,10,14,65,47]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends d.ExtHostTaskBase{constructor(u,c,h,t,n,s,r,o,g){super(u,c,h,t,n,s,r,o);this.workspaceService=h,this.editorTabs=g,c.remote.isRemote&&c.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,c){const h=c;if(!c.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const t=d.TaskHandleDTO.from(h,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,c);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=d.TaskDTO.from(c,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));d.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,c,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),c);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,c,h,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,h),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const r=d.TaskDTO.from(s,h.extension);r&&(n.push(r),d.CustomExecutionDTO.is(r.execution)&&c.push(this.addCustomExecution(r,s,!0)))}return{tasks:n,extension:h.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(u,this._editorService,c,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,c){const h=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(h),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(s),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let g of c.variables)t.variables[g]=await r.resolveAsync(o,g);if(c.process!==void 0){let g;if(c.process.path!==void 0){g=c.process.path.split(v.delimiter);for(let m=0;m<g.length;m++)g[m]=await r.resolveAsync(o,g[m])}t.process=await C.win32.findExecutable(await r.resolveAsync(o,c.process.name),c.process.cwd!==void 0?await r.resolveAsync(o,c.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,c,h){return C.win32.findExecutable(u,c,h)}};w=qe([He(0,i.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,a.ILogService),He(7,f.IExtHostApiDeprecationService),He(8,E.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(me[262],ge([0,1,13,17,70,6,2,5,253,14,79,82,27,184,15,63,41,33]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,h,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(c,null,n),h=_._transform(h,this._rpcProtocol);const s=new A.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},h)),s.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),s.set(f.IURITransformerService,new f.URITransformerService(n)),s.set(E.IHostUtils,t);const r=new p.InstantiationService(s,!0),o=r.invokeFunction(b=>b.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=r.invokeFunction(b=>b.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",h),this._extensionService=r.invokeFunction(b=>b.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(l,L)=>{let O="",W,ie;for(const re of L)O+=`
	at ${re.toString()}`,ie=re.getFileName(),!W&&ie&&(W=b.findSubstr(ie));return g.set(l,W),`${l.name||"Error"}: ${l.message||""}${O}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),S=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(b=>{const l=R.transformErrorForSerialization(b),L=g.get(b);L?m.$onExtensionRuntimeError(L.identifier,l):S.$onUnexpectedError(l)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const h=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),h]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(c,h){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(h.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(h.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(h.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(h.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(h.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(h.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(h.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(h.transformIncomingURIs(c.logFile)),c.workspace=h.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(me[263],ge([0,1,9,21,60,31,25,44,30]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(d,p,a){this.config=d,this.provider=p,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const p=this.config.folderQueries||[];return new Promise((a,f)=>{const E=w=>{this.resultCount++,d(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const _=w.toString(),u=v.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,u)||this.matchFile(E,{base:w,basename:u})}),Promise.all(p.map(w=>this.searchInFolder(w,E))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{f(new Error((0,C.toErrorMessage)(w)))})})}async searchInFolder(d,p){const a=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(d),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,d),_=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(a),u=I.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,a.token),h=u.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=v.posix.relative(d.folder.path,n.path);if(_){const r=v.basename(n.path);this.matchFile(p,{base:d.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(E,d.folder,s,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,p),{providerTime:h,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(d){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:a,includes:p,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},p,a,f){if(a===this.filePattern){const w=v.basename(this.filePattern);this.matchFile(f,{base:p,relativePath:this.filePattern,basename:w})}function E(w){const _=v.basename(w),u=v.dirname(w);let c=d[u];c||(c=d[u]=[],E(u)),c.push({base:p,relativePath:w,basename:_})}E(a)}matchDirectoryTree({rootEntries:d,pathToEntries:p},a,f){const E=this,w=this.filePattern;function _(u){const c=T.hasSiblingFn(()=>u.map(h=>h.basename));for(let h=0,t=u.length;h<t;h++){const n=u[h],{relativePath:s,basename:r}=n;if(!a.includedInQuerySync(s,r,w!==r?c:void 0))continue;const o=p[s];if(o)_(o);else{if(s===w)continue;E.matchFile(f,n)}if(E.isLimitHit)break}}_(d)}matchFile(d,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(p))}}class i{constructor(){this.sessions=new Map}fileSearch(d,p,a,f){const E=this.getSessionTokenSource(d.cacheKey),w=new P(d,p,E&&E.token);let _=0;const u=c=>{_+=c.length,a(c.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(w,i.BATCH_SIZE,u,f).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(d){const p=this.getSessionTokenSource(d);p&&p.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,p,a,f){f.onCancellationRequested(()=>{d.cancel()});const E=_=>{_&&(w.push(_),p>0&&w.length>=p&&(a(w),w=[]))};let w=[];return d.search(E).then(_=>(w.length&&a(w),_),_=>(w.length&&a(w),Promise.reject(_)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[129],ge([0,1,9,16,21,60,25,31,2,30,10,12]),function(K,e,v,R,C,T,y,I,D,P,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(u,c,h){this.query=u,this.provider=c,this.fileUtils=h,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const h=this.query.folderQueries||[],t=new C.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new a(u);let r=!1;const o=(g,m)=>{if(!r&&!this.isLimitHit){const S=this.resultSize(g);E(g)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const b=this.resultSize(g);this.resultCount+=b,(b>0||!E(g))&&this.collector.add(g,m)}};Promise.all(h.map((g,m)=>this.searchInFolder(g,S=>o(S,m),t.token))).then(g=>{t.dispose(),this.collector.flush();const m=g.some(S=>!!S&&!!S.limitHit);n({limitHit:this.isLimitHit||m,messages:(0,R.flatten)(g.map(S=>(S==null?void 0:S.message)?(0,A.isArray)(S.message)?S.message:[S.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const m=(0,T.toErrorMessage)(g);s(new Error(m))})})}resultSize(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const h=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:h.slice(0,c),preview:{matches:t.slice(0,c),text:u.preview.text},uri:u.uri}}async searchInFolder(u,c,h){const t=new P.QueryGlobTester(this.query,u),n=[],s={report:g=>{if(!this.validateProviderResult(g))return;const m=u.folder.scheme===i.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,S=y.relativePath(u.folder,g.uri);S&&n.push(t.includedInQuery(S,v.basename(S),m).then(b=>{b&&c(g)}))}},r=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,s,h);return await Promise.all(n),o}validateProviderResult(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,P.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),h=(0,P.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:h,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function p(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class a{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(f(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=a;function f(_){return E(_)?{preview:{matches:(0,R.mapArrayOrNot)(_.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:_.preview.text},ranges:(0,R.mapArrayOrNot)(_.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function E(_){return!!_.preview}e.extensionResultIsMatch=E;class w{constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){!u||this.addItemToBatch(u,c)}addItems(u,c){!u||this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,263,15,63,14,2,129]),function(K,e,v,R,C,T,y,I,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let A=class{constructor(f,E,w){this.extHostRpc=f,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,E){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(f)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(f,E){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(f)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(f,E,w,_){const u=d(w),c=this._fileSearchProvider.get(f);if(c)return this._fileSearchManager.fileSearch(u,c,h=>{this._proxy.$handleFileMatch(f,E,h.map(t=>t.resource))},_);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,E,w,_){const u=this._textSearchProvider.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const c=d(w);return this.createTextSearchManager(c,u).search(t=>this._proxy.$handleTextMatch(f,E,t),_)}createTextSearchManager(f,E){return new i.TextSearchManager(f,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};A=qe([He(0,y.IExtHostRpcService),He(1,I.IURITransformerService),He(2,D.ILogService)],A),e.ExtHostSearch=A;function d(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(p),extraFileResources:a.extraFileResources&&a.extraFileResources.map(f=>P.URI.revive(f))})}e.reviveQuery=d;function p(a){return Object.assign(Object.assign({},a),{folder:P.URI.revive(a.folder)})}}),define(me[264],ge([0,1,21,17,3,57,2,151,106,142,78,43,5,225,224,49,226,35,227,228,229,211,230,40,41,231,212,233,234,235,66,214,239,240,241,90,33,242,215,20,7,245,67,128,34,39,52,200,232,117,127,69,50,71,14,63,15,27,236,198,48,65,222,243,197,91,89,248,246,247,223,62,256,244,88,47,119,237,68,238,10,186]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c,h,t,n,s,r,o,g,m,S,b,l,L,O,W,ie,re,N,V,x,k,U,F,M,$,H,Q,ae,we,Le,Ie,Oe,We,j,X,ee,oe,pe,Se,ce,_e,Re,Ve,be,Ge,G,ne,ve,xe,je,ze,Xe,Ce,De,ke,se,de,z,J,le,Pe,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ue(Be){const Qe=Be.get(pe.IExtHostInitDataService),rt=Be.get(Xe.IExtHostFileSystemInfo),et=Be.get(ne.IExtHostConsumerFileSystem),Ye=Be.get(s.IExtHostExtensionService),ot=Be.get($.IExtHostWorkspace),Et=Be.get(de.IExtHostTelemetry),bt=Be.get(w.IExtHostConfiguration),Ee=Be.get(ee.IURITransformerService),he=Be.get(oe.IExtHostRpcService),ue=Be.get(ie.IExtHostStorage),Y=Be.get(G.IExtensionStoragePaths),Me=Be.get(X.ILogService),Fe=Be.get(_e.IExtHostTunnelService),Je=Be.get(Re.IExtHostApiDeprecationService),Ze=Be.get(M.IExtHostWindow),ht=Be.get(ke.IExtHostSecretState),ct=Be.get(se.IExtHostEditorTabs);he.set(d.ExtHostContext.ExtHostFileSystemInfo,rt),he.set(d.ExtHostContext.ExtHostLogService,Me),he.set(d.ExtHostContext.ExtHostWorkspace,ot),he.set(d.ExtHostContext.ExtHostConfiguration,bt),he.set(d.ExtHostContext.ExtHostExtensionService,Ye),he.set(d.ExtHostContext.ExtHostStorage,ue),he.set(d.ExtHostContext.ExtHostTunnelService,Fe),he.set(d.ExtHostContext.ExtHostWindow,Ze),he.set(d.ExtHostContext.ExtHostSecretState,ht),he.set(d.ExtHostContext.ExtHostTelemetry,Et),he.set(d.ExtHostContext.ExtHostEditorTabs,ct);const it=he.set(d.ExtHostContext.ExtHostDecorations,Be.get(Ie.IExtHostDecorations)),pt=he.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Be.get(n.IExtHostDocumentsAndEditors)),dt=he.set(d.ExtHostContext.ExtHostCommands,Be.get(f.IExtHostCommands)),at=he.set(d.ExtHostContext.ExtHostTerminalService,Be.get(re.IExtHostTerminalService)),ft=he.set(d.ExtHostContext.ExtHostDebugService,Be.get(We.IExtHostDebugService)),Pt=he.set(d.ExtHostContext.ExtHostSearch,Be.get(j.IExtHostSearch)),Ct=he.set(d.ExtHostContext.ExtHostTask,Be.get(Oe.IExtHostTask)),At=he.set(d.ExtHostContext.ExtHostOutputService,Be.get(b.IExtHostOutputService)),Rt=he.set(d.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(he)),St=he.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(he,pt)),Xt=he.set(d.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(he,pt,Me)),Yt=he.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new h.ExtHostDocumentSaveParticipant(Me,St,he.getProxy(d.MainContext.MainThreadBulkEdits))),gt=he.set(d.ExtHostContext.ExtHostNotebook,new Se.ExtHostNotebookController(he,dt,pt,St,Me,Y)),Jt=he.set(d.ExtHostContext.ExtHostNotebookKernels,new z.ExtHostNotebookKernels(he,Qe,gt,Me)),Zt=he.set(d.ExtHostContext.ExtHostNotebookRenderers,new le.ExtHostNotebookRenderers(he,gt)),Dt=he.set(d.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(he,pt)),dn=he.set(d.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(he.getProxy(d.MainContext.MainThreadTreeViews),dt,Me)),en=he.set(d.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(he.getProxy(d.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=he.set(d.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(he,Me)),ut=he.set(d.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(he,Ee,St,dt,xt,Me,Je)),tn=he.set(d.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(he,ut)),Ft=he.set(d.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(he,Me,pt)),Mt=he.set(d.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(he,ot,dt)),qt=he.set(d.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(he,dt,Me)),wn=he.set(d.ExtHostContext.ExtHostComments,new E.ExtHostComments(he,dt,St)),hn=he.set(d.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(he.getProxy(d.MainContext.MainThreadProgress))),bn=he.set(d.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(he)),fn=he.set(d.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(he)),Bt=he.set(d.ExtHostContext.ExtHostAuthentication,new Ve.ExtHostAuthentication(he)),nn=he.set(d.ExtHostContext.ExtHostTimeline,new be.ExtHostTimeline(he,dt)),Ht=he.set(d.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(he,{remote:Qe.remote},ot,Me,Je)),rn=he.set(d.ExtHostContext.ExtHostWebviewPanels,new je.ExtHostWebviewPanels(he,Ht,ot)),En=he.set(d.ExtHostContext.ExtHostCustomEditors,new xe.ExtHostCustomEditors(he,St,Y,Ht,rn)),_n=he.set(d.ExtHostContext.ExtHostWebviewViews,new ve.ExtHostWebviewViews(he,Ht)),Ot=he.set(d.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(he,pt,ot)),Kt=he.set(d.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(he)),Sn=(0,Q.values)(d.ExtHostContext);he.assertRegistered(Sn);const yn=new ze.ExtHostBulkEdits(he,pt),sn=new a.ExtHostClipboard(he),on=new S.ExtHostMessageService(he,Me),$t=new u.ExtHostDialogs(he),Gt=new W.ExtHostStatusBar(he,dt.converter),Wt=new m.ExtHostLanguages(he,St);return p.ExtHostApiCommands.register(dt),function(Ne,an,It){const vt=function(){let Z=!Ne.isUnderDevelopment;function fe(Te){Z||(Me.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")fe(st);else{const wt=st;typeof wt.scheme=="undefined"&&fe(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,H.throwProposedApiError)(Ne)}return st}}(),Dn={getSession(Z,fe,Te){return Bt.getSession(Ne,Z,fe,Te)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(Z,fe,Te,st){return Bt.registerAuthenticationProvider(Z,fe,Te,st)},get onDidChangeAuthenticationProviders(){return(0,H.checkProposedApiEnabled)(Ne),Bt.onDidChangeAuthenticationProviders},get providers(){return(0,H.checkProposedApiEnabled)(Ne),Bt.providers},logout(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),Bt.removeSession(Z,fe)}},Cn={registerCommand(Z,fe,Te){return dt.registerCommand(!0,Z,fe,Te)},registerTextEditorCommand(Z,fe,Te){return dt.registerCommand(!0,Z,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(_t=>{fe.apply(Te,[wt,_t,...st])}).then(_t=>{_t||Me.warn("Edits from command "+Z+" were not applied.")},_t=>{Me.warn("An error occurred while running command "+Z,_t)})})},registerDiffInformationCommand:(Z,fe,Te)=>((0,H.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,Z,async(...st)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}const _t=await Dt.getDiffInformation(wt.id);fe.apply(Te,[_t,...st])})),executeCommand(Z,...fe){return dt.executeCommand(Z,...fe)},getCommands(Z=!1){return dt.getCommands(Z)}},mn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var Z,fe;return(fe=(Z=Qe.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&fe!==void 0?fe:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,fe){return Ze.openUri(Z,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:fe==null?void 0:fe.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===Qe.environment.appUriScheme?Rt.createAppUri(Z):(!(0,Ae.matchesScheme)(Z.scheme,Pe.Schemas.http)&&!(0,Ae.matchesScheme)(Z.scheme,Pe.Schemas.https)&&(0,H.checkProposedApiEnabled)(Ne),Ze.asExternalUri(Z,{allowTunneling:!!Qe.remote.authority}))},get remoteName(){return(0,Le.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Qe.remote.isRemote?k.ExtensionKind.Workspace:k.ExtensionKind.UI,kn={registerTestController(Z){return Ot.registerTestController(Ne.identifier.value,Z)},createDocumentTestObserver(Z){return(0,H.checkProposedApiEnabled)(Ne),Ot.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,H.checkProposedApiEnabled)(Ne),Ot.createWorkspaceTestObserver(Z)},runTests(Z){return Ot.runTests(Z)},createTestItem(Z,fe){return new k.TestItemImpl(Z.id,Z.label,Z.uri,fe)},createTestRun(Z,fe,Te){return Ot.createTestRun(Ne.identifier.value,Z,fe,Te)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Ne),Ot.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Ne),Ot.results}},In={getExtension(Z){const fe=an.getExtensionDescription(Z);if(fe)return new s.Extension(Ye,Ne.identifier,fe,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new s.Extension(Ye,Ne.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},Pn={createDiagnosticCollection(Z){return xt.createDiagnosticCollection(Ne.identifier,Z)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:Z=>xt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,fe){return Wt.changeLanguage(Z.uri,fe)},match(Z,fe){return(0,i.score)(x.LanguageSelector.from(Z),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(Z,fe,Te){return ut.registerCodeActionProvider(Ne,vt(Z),fe,Te)},registerCodeLensProvider(Z,fe){return ut.registerCodeLensProvider(Ne,vt(Z),fe)},registerDefinitionProvider(Z,fe){return ut.registerDefinitionProvider(Ne,vt(Z),fe)},registerDeclarationProvider(Z,fe){return ut.registerDeclarationProvider(Ne,vt(Z),fe)},registerImplementationProvider(Z,fe){return ut.registerImplementationProvider(Ne,vt(Z),fe)},registerTypeDefinitionProvider(Z,fe){return ut.registerTypeDefinitionProvider(Ne,vt(Z),fe)},registerHoverProvider(Z,fe){return ut.registerHoverProvider(Ne,vt(Z),fe,Ne.identifier)},registerEvaluatableExpressionProvider(Z,fe){return ut.registerEvaluatableExpressionProvider(Ne,vt(Z),fe,Ne.identifier)},registerInlineValuesProvider(Z,fe){return ut.registerInlineValuesProvider(Ne,vt(Z),fe,Ne.identifier)},registerDocumentHighlightProvider(Z,fe){return ut.registerDocumentHighlightProvider(Ne,vt(Z),fe)},registerLinkedEditingRangeProvider(Z,fe){return ut.registerLinkedEditingRangeProvider(Ne,vt(Z),fe)},registerReferenceProvider(Z,fe){return ut.registerReferenceProvider(Ne,vt(Z),fe)},registerRenameProvider(Z,fe){return ut.registerRenameProvider(Ne,vt(Z),fe)},registerDocumentSymbolProvider(Z,fe,Te){return ut.registerDocumentSymbolProvider(Ne,vt(Z),fe,Te)},registerWorkspaceSymbolProvider(Z){return ut.registerWorkspaceSymbolProvider(Ne,Z)},registerDocumentFormattingEditProvider(Z,fe){return ut.registerDocumentFormattingEditProvider(Ne,vt(Z),fe)},registerDocumentRangeFormattingEditProvider(Z,fe){return ut.registerDocumentRangeFormattingEditProvider(Ne,vt(Z),fe)},registerOnTypeFormattingEditProvider(Z,fe,Te,...st){return ut.registerOnTypeFormattingEditProvider(Ne,vt(Z),fe,[Te].concat(st))},registerDocumentSemanticTokensProvider(Z,fe,Te){return ut.registerDocumentSemanticTokensProvider(Ne,vt(Z),fe,Te)},registerDocumentRangeSemanticTokensProvider(Z,fe,Te){return ut.registerDocumentRangeSemanticTokensProvider(Ne,vt(Z),fe,Te)},registerSignatureHelpProvider(Z,fe,Te,...st){return typeof Te=="object"?ut.registerSignatureHelpProvider(Ne,vt(Z),fe,Te):ut.registerSignatureHelpProvider(Ne,vt(Z),fe,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(Z,fe,...Te){return ut.registerCompletionItemProvider(Ne,vt(Z),fe,Te)},registerInlineCompletionItemProvider(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),ut.registerInlineCompletionsProvider(Ne,vt(Z),fe)},registerDocumentLinkProvider(Z,fe){return ut.registerDocumentLinkProvider(Ne,vt(Z),fe)},registerColorProvider(Z,fe){return ut.registerColorProvider(Ne,vt(Z),fe)},registerFoldingRangeProvider(Z,fe){return ut.registerFoldingRangeProvider(Ne,vt(Z),fe)},registerSelectionRangeProvider(Z,fe){return ut.registerSelectionRangeProvider(Ne,Z,fe)},registerCallHierarchyProvider(Z,fe){return ut.registerCallHierarchyProvider(Ne,Z,fe)},setLanguageConfiguration:(Z,fe)=>ut.setLanguageConfiguration(Ne,Z,fe),getTokenInformationAtPosition(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),Wt.tokenAtPosition(Z,fe)},registerInlayHintsProvider(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),ut.registerInlayHintsProvider(Ne,Z,fe)}},ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(Z,fe,Te){const st=await(y.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return Dt.showTextDocument(st,fe,Te)},createTextEditorDecorationType(Z){return Dt.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,fe,Te){return Dt.onDidChangeActiveTextEditor(Z,fe,Te)},onDidChangeVisibleTextEditors(Z,fe,Te){return Dt.onDidChangeVisibleTextEditors(Z,fe,Te)},onDidChangeTextEditorSelection(Z,fe,Te){return Dt.onDidChangeTextEditorSelection(Z,fe,Te)},onDidChangeTextEditorOptions(Z,fe,Te){return Dt.onDidChangeTextEditorOptions(Z,fe,Te)},onDidChangeTextEditorVisibleRanges(Z,fe,Te){return Dt.onDidChangeTextEditorVisibleRanges(Z,fe,Te)},onDidChangeTextEditorViewColumn(Z,fe,Te){return Dt.onDidChangeTextEditorViewColumn(Z,fe,Te)},onDidCloseTerminal(Z,fe,Te){return at.onDidCloseTerminal(Z,fe,Te)},onDidOpenTerminal(Z,fe,Te){return at.onDidOpenTerminal(Z,fe,Te)},onDidChangeActiveTerminal(Z,fe,Te){return at.onDidChangeActiveTerminal(Z,fe,Te)},onDidChangeTerminalDimensions(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),at.onDidChangeTerminalDimensions(Z,fe,Te)},onDidWriteTerminalData(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),at.onDidWriteTerminalData(Z,fe,Te)},get state(){return Ze.state},onDidChangeWindowState(Z,fe,Te){return Ze.onDidChangeWindowState(Z,fe,Te)},showInformationMessage(Z,...fe){return on.showMessage(Ne,T.default.Info,Z,fe[0],fe.slice(1))},showWarningMessage(Z,...fe){return on.showMessage(Ne,T.default.Warning,Z,fe[0],fe.slice(1))},showErrorMessage(Z,...fe){return on.showMessage(Ne,T.default.Error,Z,fe[0],fe.slice(1))},showQuickPick(Z,fe,Te){return Mt.showQuickPick(Z,!!Ne.enableProposedApi,fe,Te)},showWorkspaceFolderPick(Z){return Mt.showWorkspaceFolderPick(Z)},showInputBox(Z,fe){return Mt.showInput(Z,fe)},showOpenDialog(Z){return $t.showOpenDialog(Z)},showSaveDialog(Z){return $t.showSaveDialog(Z)},createStatusBarItem(Z,fe,Te){let st,wt,_t;return typeof Z=="string"?(st=Z,wt=fe,_t=Te):(wt=Z,_t=fe),Gt.createStatusBarEntry(Ne,st,wt,_t)},setStatusBarMessage(Z,fe){return Gt.setStatusBarMessage(Z,fe)},withScmProgress(Z){return Je.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),hn.withProgress(Ne,{location:k.ProgressLocation.SourceControl},(fe,Te)=>Z({report(st){}}))},withProgress(Z,fe){return hn.withProgress(Ne,Z,fe)},createOutputChannel(Z){return At.createOutputChannel(Z)},createWebviewPanel(Z,fe,Te,st){return rn.createWebviewPanel(Ne,Z,fe,Te,st)},createWebviewTextEditorInset(Z,fe,Te,st){return(0,H.checkProposedApiEnabled)(Ne),en.createWebviewEditorInset(Z,fe,Te,st,Ne)},createTerminal(Z,fe,Te){return typeof Z=="object"?"pty"in Z?at.createExtensionTerminal(Z):(Z.iconPath&&(0,H.checkProposedApiEnabled)(Ne),at.createTerminalFromOptions(Z)):at.createTerminal(Z,fe,Te)},registerTerminalLinkProvider(Z){return at.registerLinkProvider(Z)},registerTreeDataProvider(Z,fe){return dn.registerTreeDataProvider(Z,fe,Ne)},createTreeView(Z,fe){return dn.createTreeView(Z,fe,Ne)},registerWebviewPanelSerializer:(Z,fe)=>rn.registerWebviewPanelSerializer(Ne,Z,fe),registerCustomEditorProvider:(Z,fe,Te={})=>En.registerCustomEditorProvider(Ne,Z,fe,Te),registerFileDecorationProvider(Z){return it.registerFileDecorationProvider(Z,Ne.identifier)},registerUriHandler(Z){return Rt.registerUriHandler(Ne.identifier,Z)},createQuickPick(){return Mt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Mt.createInputBox(Ne.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(Z,fe,Te){return fn.onDidChangeActiveColorTheme(Z,fe,Te)},registerWebviewViewProvider(Z,fe,Te){return _n.registerWebviewViewProvider(Ne,Z,fe,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeActiveNotebookEditor(Z,fe,Te)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookEditorSelection(Z,fe,Te)},onDidChangeNotebookEditorVisibleRanges(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookEditorVisibleRanges(Z,fe,Te)},showNotebookDocument(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),gt.showNotebookDocument(Z,fe)},registerExternalUriOpener(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),Kt.registerExternalUriOpener(Ne.identifier,Z,fe,Te)},get openEditors(){return(0,H.checkProposedApiEnabled)(Ne),ct.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Ne),ct.onDidChangeTabs}},pn={get rootPath(){return Je.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(Z){throw R.readonly()},getWorkspaceFolder(Z){return ot.getWorkspaceFolder(Z)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(Z){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(Z){throw R.readonly()},updateWorkspaceFolders:(Z,fe,...Te)=>ot.updateWorkspaceFolders(Ne,Z,fe||0,...Te),onDidChangeWorkspaceFolders:function(Z,fe,Te){return ot.onDidChangeWorkspace(Z,fe,Te)},asRelativePath:(Z,fe)=>ot.getRelativePath(Z,fe),findFiles:(Z,fe,Te,st)=>ot.findFiles(x.GlobPattern.from(Z),x.GlobPattern.from(fe),Te,Ne.identifier,st),findTextInFiles:(Z,fe,Te,st)=>{let wt,_t;return typeof fe=="object"?(wt=fe,_t=Te):(wt={},_t=fe,st=Te),ot.findTextInFiles(Z,wt||{},_t,Ne.identifier,st)},saveAll:Z=>ot.saveAll(Z),applyEdit(Z){return yn.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,fe,Te,st)=>Ft.createFileSystemWatcher(x.GlobPattern.from(Z),fe,Te,st),get textDocuments(){return St.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw R.readonly()},openTextDocument(Z){let fe;const Te=Z;if(typeof Z=="string")fe=Promise.resolve(y.URI.file(Z));else if(y.URI.isUri(Z))fe=Promise.resolve(Z);else if(!Te||typeof Te=="object")fe=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Z,fe,Te)=>St.onDidAddDocument(Z,fe,Te),onDidCloseTextDocument:(Z,fe,Te)=>St.onDidRemoveDocument(Z,fe,Te),onDidChangeTextDocument:(Z,fe,Te)=>St.onDidChangeDocument(Z,fe,Te),onDidSaveTextDocument:(Z,fe,Te)=>St.onDidSaveDocument(Z,fe,Te),onWillSaveTextDocument:(Z,fe,Te)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(Z,fe,Te),onDidChangeConfiguration:(Z,fe,Te)=>It.onDidChangeConfiguration(Z,fe,Te),getConfiguration(Z,fe){return fe=arguments.length===1?void 0:fe,It.getConfiguration(Z,fe,Ne)},registerTextDocumentContentProvider(Z,fe){return Xt.registerTextDocumentContentProvider(Z,fe)},registerTaskProvider:(Z,fe)=>(Je.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Ne,Z,fe)),registerFileSystemProvider(Z,fe,Te){return tn.registerFileSystemProvider(Ne.identifier,Z,fe,Te,Ne.enableProposedApi)},get fs(){return et.value},registerFileSearchProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),Pt.registerFileSearchProvider(Z,fe)),registerTextSearchProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),Pt.registerTextSearchProvider(Z,fe)),registerRemoteAuthorityResolver:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),Ye.registerRemoteAuthorityResolver(Z,fe)),registerResourceLabelFormatter:Z=>((0,H.checkProposedApiEnabled)(Ne),bn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,fe,Te)=>Ft.onDidCreateFile(Z,fe,Te),onDidDeleteFiles:(Z,fe,Te)=>Ft.onDidDeleteFile(Z,fe,Te),onDidRenameFiles:(Z,fe,Te)=>Ft.onDidRenameFile(Z,fe,Te),onWillCreateFiles:(Z,fe,Te)=>Ft.getOnWillCreateFileEvent(Ne)(Z,fe,Te),onWillDeleteFiles:(Z,fe,Te)=>Ft.getOnWillDeleteFileEvent(Ne)(Z,fe,Te),onWillRenameFiles:(Z,fe,Te)=>Ft.getOnWillRenameFileEvent(Ne)(Z,fe,Te),openTunnel:Z=>((0,H.checkProposedApiEnabled)(Ne),Fe.openTunnel(Ne,Z).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,H.checkProposedApiEnabled)(Ne),Fe.getTunnels()},onDidChangeTunnels:(Z,fe,Te)=>((0,H.checkProposedApiEnabled)(Ne),Fe.onDidChangeTunnels(Z,fe,Te)),registerPortAttributesProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),Fe.registerPortsAttributesProvider(Z,fe)),registerTimelineProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),nn.registerTimelineProvider(Z,fe,Ne.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:Z=>((0,H.checkProposedApiEnabled)(Ne),ot.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,fe,Te)=>ot.onDidGrantWorkspaceTrust(Z,fe,Te)},An={get inputBox(){return Je.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Ne)},createSourceControl(Z,fe,Te){return qt.createSourceControl(Ne,Z,fe,Te)}},Tn={createCommentController(Z,fe){return wn.createCommentController(Ne,Z,fe)}},Rn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(Z,fe,Te){return ft.onDidStartDebugSession(Z,fe,Te)},onDidTerminateDebugSession(Z,fe,Te){return ft.onDidTerminateDebugSession(Z,fe,Te)},onDidChangeActiveDebugSession(Z,fe,Te){return ft.onDidChangeActiveDebugSession(Z,fe,Te)},onDidReceiveDebugSessionCustomEvent(Z,fe,Te){return ft.onDidReceiveDebugSessionCustomEvent(Z,fe,Te)},onDidChangeBreakpoints(Z,fe,Te){return ft.onDidChangeBreakpoints(Z,fe,Te)},registerDebugConfigurationProvider(Z,fe,Te){return ft.registerDebugConfigurationProvider(Z,fe,Te||k.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,fe){return ft.registerDebugAdapterDescriptorFactory(Ne,Z,fe)},registerDebugAdapterTrackerFactory(Z,fe){return ft.registerDebugAdapterTrackerFactory(Z,fe)},startDebugging(Z,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ft.startDebugging(Z,fe,{parentSession:Te}):ft.startDebugging(Z,fe,Te||{})},stopDebugging(Z){return ft.stopDebugging(Z)},addBreakpoints(Z){return ft.addBreakpoints(Z)},removeBreakpoints(Z){return ft.removeBreakpoints(Z)},asDebugSourceUri(Z,fe){return ft.asDebugSourceUri(Z,fe)}},Ln={registerTaskProvider:(Z,fe)=>Ct.registerTaskProvider(Ne,Z,fe),fetchTasks:Z=>Ct.fetchTasks(Z),executeTask:Z=>Ct.executeTask(Ne,Z),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(Z,fe,Te)=>Ct.onDidStartTask(Z,fe,Te),onDidEndTask:(Z,fe,Te)=>Ct.onDidEndTask(Z,fe,Te),onDidStartTaskProcess:(Z,fe,Te)=>Ct.onDidStartTaskProcess(Z,fe,Te),onDidEndTaskProcess:(Z,fe,Te)=>Ct.onDidEndTaskProcess(Z,fe,Te)},Fn={async openNotebookDocument(Z,fe){(0,H.checkProposedApiEnabled)(Ne);let Te;if(y.URI.isUri(Z))Te=Z,await gt.openNotebookDocument(Z);else if(typeof Z=="string")Te=y.URI.revive(await gt.createNotebookDocument({viewType:Z,content:fe}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,H.checkProposedApiEnabled)(Ne),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,fe,Te,st){return(0,H.checkProposedApiEnabled)(Ne),gt.registerNotebookSerializer(Ne,Z,fe,Te,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Z,fe,Te,st)=>((0,H.checkProposedApiEnabled)(Ne),gt.registerNotebookContentProvider(Ne,Z,fe,Te,Ne.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(Z,fe)=>((0,H.checkProposedApiEnabled)(Ne),gt.registerNotebookCellStatusBarItemProvider(Ne,Z,fe)),createNotebookEditorDecorationType(Z){return(0,H.checkProposedApiEnabled)(Ne),gt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return(0,H.checkProposedApiEnabled)(Ne),Zt.createRendererMessaging(Z)},onDidChangeNotebookDocumentMetadata(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookDocumentMetadata(Z,fe,Te)},onDidChangeNotebookCells(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCells(Z,fe,Te)},onDidChangeNotebookCellExecutionState(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCellExecutionState(Z,fe,Te)},onDidChangeCellOutputs(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeCellOutputs(Z,fe,Te)},onDidChangeCellMetadata(Z,fe,Te){return(0,H.checkProposedApiEnabled)(Ne),gt.onDidChangeCellMetadata(Z,fe,Te)},createConcatTextDocument(Z,fe){return(0,H.checkProposedApiEnabled)(Ne),new Ge.ExtHostNotebookConcatDocument(gt,St,Z,fe)},createNotebookController(Z,fe,Te,st,wt){return(0,H.checkProposedApiEnabled)(Ne),Jt.createNotebookController(Ne,Z,fe,Te,st,wt)}};return{version:Qe.version,authentication:Dn,commands:Cn,comments:Tn,debug:Rn,env:mn,extensions:In,languages:Pn,notebook:Fn,scm:An,tasks:Ln,test:kn,window:ln,workspace:pn,Breakpoint:k.Breakpoint,CallHierarchyIncomingCall:k.CallHierarchyIncomingCall,CallHierarchyItem:k.CallHierarchyItem,CallHierarchyOutgoingCall:k.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:k.CodeAction,CodeActionKind:k.CodeActionKind,CodeActionTriggerKind:k.CodeActionTriggerKind,CodeLens:k.CodeLens,Color:k.Color,ColorInformation:k.ColorInformation,ColorPresentation:k.ColorPresentation,ColorThemeKind:k.ColorThemeKind,CommentMode:k.CommentMode,CommentThreadCollapsibleState:k.CommentThreadCollapsibleState,CompletionItem:k.CompletionItem,CompletionItemKind:k.CompletionItemKind,CompletionItemTag:k.CompletionItemTag,CompletionList:k.CompletionList,CompletionTriggerKind:k.CompletionTriggerKind,ConfigurationTarget:k.ConfigurationTarget,CustomExecution:k.CustomExecution,DebugAdapterExecutable:k.DebugAdapterExecutable,DebugAdapterInlineImplementation:k.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:k.DebugAdapterNamedPipeServer,DebugAdapterServer:k.DebugAdapterServer,DebugConfigurationProviderTriggerKind:k.DebugConfigurationProviderTriggerKind,DebugConsoleMode:k.DebugConsoleMode,DecorationRangeBehavior:k.DecorationRangeBehavior,Diagnostic:k.Diagnostic,DiagnosticRelatedInformation:k.DiagnosticRelatedInformation,DiagnosticSeverity:k.DiagnosticSeverity,DiagnosticTag:k.DiagnosticTag,Disposable:k.Disposable,DocumentHighlight:k.DocumentHighlight,DocumentHighlightKind:k.DocumentHighlightKind,DocumentLink:k.DocumentLink,DocumentSymbol:k.DocumentSymbol,EndOfLine:k.EndOfLine,EnvironmentVariableMutatorType:k.EnvironmentVariableMutatorType,EvaluatableExpression:k.EvaluatableExpression,InlineValueText:k.InlineValueText,InlineValueVariableLookup:k.InlineValueVariableLookup,InlineValueEvaluatableExpression:k.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:k.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:k.ExtensionKind,ExtensionMode:k.ExtensionMode,ExternalUriOpenerPriority:k.ExternalUriOpenerPriority,FileChangeType:k.FileChangeType,FileDecoration:k.FileDecoration,FileSystemError:k.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:k.FoldingRange,FoldingRangeKind:k.FoldingRangeKind,FunctionBreakpoint:k.FunctionBreakpoint,InlineCompletionItem:k.InlineSuggestion,InlineCompletionList:k.InlineSuggestions,Hover:k.Hover,IndentAction:P.IndentAction,Location:k.Location,MarkdownString:k.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:k.ParameterInformation,PortAutoForwardAction:k.PortAutoForwardAction,Position:k.Position,ProcessExecution:k.ProcessExecution,ProgressLocation:k.ProgressLocation,QuickInputButtons:k.QuickInputButtons,Range:k.Range,RelativePattern:k.RelativePattern,Selection:k.Selection,SelectionRange:k.SelectionRange,SemanticTokens:k.SemanticTokens,SemanticTokensBuilder:k.SemanticTokensBuilder,SemanticTokensEdit:k.SemanticTokensEdit,SemanticTokensEdits:k.SemanticTokensEdits,SemanticTokensLegend:k.SemanticTokensLegend,ShellExecution:k.ShellExecution,ShellQuoting:k.ShellQuoting,SignatureHelp:k.SignatureHelp,SignatureHelpTriggerKind:k.SignatureHelpTriggerKind,SignatureInformation:k.SignatureInformation,SnippetString:k.SnippetString,SourceBreakpoint:k.SourceBreakpoint,StandardTokenType:k.StandardTokenType,StatusBarAlignment:k.StatusBarAlignment,SymbolInformation:k.SymbolInformation,SymbolKind:k.SymbolKind,SymbolTag:k.SymbolTag,Task:k.Task,TaskGroup:k.TaskGroup,TaskPanelKind:k.TaskPanelKind,TaskRevealKind:k.TaskRevealKind,TaskScope:k.TaskScope,TextDocumentSaveReason:k.TextDocumentSaveReason,TextEdit:k.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:k.TextEditorLineNumbersStyle,TextEditorRevealType:k.TextEditorRevealType,TextEditorSelectionChangeKind:k.TextEditorSelectionChangeKind,ThemeColor:k.ThemeColor,ThemeIcon:k.ThemeIcon,TreeItem:k.TreeItem,TreeItemCollapsibleState:k.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:y.URI,ViewColumn:k.ViewColumn,WorkspaceEdit:k.WorkspaceEdit,InlayHint:k.InlayHint,InlayHintKind:k.InlayHintKind,RemoteAuthorityResolverError:k.RemoteAuthorityResolverError,ResolvedAuthority:k.ResolvedAuthority,SourceControlInputBoxValidationType:k.SourceControlInputBoxValidationType,ExtensionRuntime:k.ExtensionRuntime,TimelineItem:k.TimelineItem,NotebookRange:k.NotebookRange,NotebookCellKind:k.NotebookCellKind,NotebookCellExecutionState:k.NotebookCellExecutionState,NotebookDocumentMetadata:k.NotebookDocumentMetadata,NotebookCellMetadata:k.NotebookCellMetadata,NotebookCellData:k.NotebookCellData,NotebookData:k.NotebookData,NotebookKernelPreload:k.NotebookKernelPreload,NotebookCellStatusBarAlignment:k.NotebookCellStatusBarAlignment,NotebookEditorRevealType:k.NotebookEditorRevealType,NotebookCellOutput:k.NotebookCellOutput,NotebookCellOutputItem:k.NotebookCellOutputItem,NotebookCellStatusBarItem:k.NotebookCellStatusBarItem,NotebookControllerAffinity:k.NotebookControllerAffinity,PortAttributes:k.PortAttributes,LinkedEditingRanges:k.LinkedEditingRanges,TestItemStatus:k.TestItemStatus,TestResultState:k.TestResultState,TestMessage:k.TestMessage,TextSearchCompleteMessageType:J.TextSearchCompleteMessageType,TestMessageSeverity:k.TestMessageSeverity,WorkspaceTrustState:k.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ue}),define(me[265],ge([0,1,79,66,34,127,35,49,40,33,69,50,71,91,90,48,65,128,89,62,88,119,47]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_,u,c,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,v.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,v.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,v.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,v.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,v.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,v.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,v.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,v.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,v.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,v.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,v.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,v.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,v.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,v.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,v.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,v.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,v.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[92],ge([0,1,16,14,30,68]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=y;function I(A,d,p,a){const f=(0,v.mapArrayOrNot)(p,D),E=new C.TextSearchMatch(d,f,a),w=E.preview.matches;return{ranges:(0,v.mapArrayOrNot)(f,P),uri:A,preview:{text:E.preview.text,matches:(0,v.mapArrayOrNot)(w,P)}}}e.createTextSearchResult=I;function D(A){return new C.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function P(A){return new T.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let i=class{constructor(d,p){this.prefix=d,this.logService=p}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};i=qe([He(1,R.ILogService)],i),e.OutputChannel=i}),define(me[266],ge([0,1,93,23]),function(K,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,I=512*8,D=512*128;class P{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,g)=>{K(["iconv-lite-umd"],o,g)})).getDecoder(p(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new P(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?I:y;return new Promise((o,g)=>{const m=(0,v.newWriteableStream)(O=>O.join("")),S=[];let b=0,l;const L=async()=>{try{const O=await h({buffer:R.VSBuffer.concat(S),bytesRead:b},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),l=await P.create(O.encoding);const W=l.write(R.VSBuffer.concat(S).buffer);m.write(W),S.length=0,b=0,o({stream:m,detected:O})}catch(O){g(O)}};(0,v.listenStream)(t,{onData:async O=>{l?m.write(l.write(O.buffer)):(S.push(O),b+=O.byteLength,b>=r&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>m.error(O),onEnd:async()=>{l||await L(),m.end(l==null?void 0:l.end())}})})}e.toDecodeStream=i;async function A(t,n,s){const o=(await new Promise((S,b)=>{K(["iconv-lite-umd"],S,b)})).getEncoder(p(n),s);let g=!1,m=!1;return{read(){if(m)return null;const S=t.read();if(typeof S!="string"){if(m=!0,!g&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=o.end();return b&&b.length>0?(g=!0,R.VSBuffer.wrap(b)):null}return g=!0,R.VSBuffer.wrap(o.write(S))}}}e.toEncodeReadable=A;async function d(t){return(await new Promise((s,r)=>{K(["iconv-lite-umd"],s,r)})).encodingExists(p(t))}e.encodingExists=d;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const f=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((m,S)=>{K(["jschardet"],m,S)}),s=t.slice(0,D),r=u(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const g=o.encoding.toLowerCase();return 0<=f.indexOf(g)?null:_(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function u(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function h({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let g=!0,m=!0,S=!1;for(let b=0;b<n&&b<T;b++){const l=b%2==1,L=t.readUInt8(b)===0;if(L&&(S=!0),g&&(l&&!L||!l&&L)&&(g=!1),m&&(l&&L||!l&&!L)&&(m=!1),L&&!g&&!m)break}S&&(g?r=e.UTF16le:m?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?E(t.slice(0,n)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=h,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[130],ge([0,1,266,28,129]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends C.TextSearchManager{constructor(I,D,P=R){super(I,D,{readdir:i=>P.readdir(i.fsPath),toCanonicalName:i=>(0,v.toCanonicalName)(i)})}}e.NativeTextSearchManager=T}),define(me[267],ge([0,1,268,282,283,2,284]),function(K,e,v,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(A,d,p,a,f,E){const w=E.environment.useHostProxy,_=typeof w=="boolean"?w:!E.remote.isRemote,u=(0,y.createProxyResolver)({resolveProxy:h=>A.resolveProxy(h),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(h,t,...n)=>{switch(h){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(h,t,n);break}function s(r,o,...g){a.error("Unknown log level",r),a.error(o,...g)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:h=>{f.$publicLog2("resolveProxy",h)},useHostProxy:_,env:process.env}),c=D(d,u);return i(p,c)}e.connectProxyResolver=I;function D(A,d){const p={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(f=>{p.config=A.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(f=>{a.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,(0,y.createHttpPatch)(v,d,{config:"off"},a,!0)),on:Object.assign({},v,(0,y.createHttpPatch)(v,d,{config:"on"},a,!0)),override:Object.assign({},v,(0,y.createHttpPatch)(v,d,{config:"override"},a,!0)),onRequest:Object.assign({},v,(0,y.createHttpPatch)(v,d,p,a,!0)),default:Object.assign(v,(0,y.createHttpPatch)(v,d,p,a,!1))},https:{off:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"off"},a,!0)),on:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"on"},a,!0)),override:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"override"},a,!0)),onRequest:Object.assign({},R,(0,y.createHttpPatch)(R,d,p,a,!0)),default:Object.assign(R,(0,y.createHttpPatch)(R,d,p,a,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const P=new Map;function i(A,d){return A.getExtensionPathIndex().then(p=>{const a=K.__$__nodeRequire("module"),f=a._load;a._load=function(w,_,u){if(w==="tls")return d.tls;if(w!=="http"&&w!=="https")return f.apply(this,arguments);const c=d[w],h=p.findSubstr(T.URI.file(_.filename).fsPath);let t=P.get(h);if(t||P.set(h,t={}),!t[w]){let n=c.default;h&&h.enableProposedApi&&(n=c[h.proxySupport]||c.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[269],ge([0,1,37,9,76,29,11,8,92,270]),function(K,e,v,R,C,T,y,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(u,c,h,t){const n=d(u,c,h,t),s=c.folder.fsPath;return{cmd:v.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=A;function d(u,c,h,t){const n=["--files","--hidden","--case-sensitive"];a([c],h,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}});const s=p([c],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function p(u,c,h,t=!0){const n=[];let s={};return u.forEach(r=>{const o=Object.assign({},r.excludePattern||{},c||{}),g=f(o,t?r.folder.fsPath:void 0,h);n.push(...g.globArgs),g.siblingClauses&&(s=Object.assign(s,g.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=p;function a(u,c,h=!0){const t=[];return u.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),r=f(s,h?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function f(u,c,h){const t=[],n={};return Object.keys(u).forEach(s=>{if(h&&h.has(s)||!s)return;const r=u[s];s=w(c?E(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(_(s))):r&&r.when&&(n[s]=r)}),{globArgs:t,siblingClauses:n}}function E(u,c){return R.isAbsolute(c)?c:R.join(u,c)}e.getAbsoluteGlob=E;function w(u){return u=I.rtrim(u,"\\"),I.rtrim(u,"/")}function _(u){return T.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=_}),define(me[271],ge([0,1,37,59,9,100,16,60,31,76,29,11,44,8,12,28,30,269,98]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;r.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==m).forEach(S=>{(0,i.isEqualOrParent)(S,m)&&(g[C.relative(m,S)]=!0)}),this.folderExcludePatterns.set(m,new t(g,m))})}cancel(){this.isCanceled=!0}walk(r,o,g,m,S){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);o.forEach(b=>{const l=C.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,l)||this.matchFile(g,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(r,(b,l)=>{this.call(this.cmdTraversal,this,b,g,m,L=>{if(L){const O=(0,I.toErrorMessage)(L);console.error(O),this.errors.push(O),l(L,void 0)}else l(null,void 0)})},(b,l)=>{this.fileWalkSW.stop();const L=b?y.coalesce(b)[0]:null;S(L,this.isLimitHit)})}parallel(r,o,g){const m=new Array(r.length),S=new Array(r.length);let b=!1,l=0;if(r.length===0)return g(null,[]);r.forEach((L,O)=>{o(L,(W,ie)=>{if(W?(b=!0,m[O]=null,S[O]=W):(m[O]=ie,S[O]=null),++l===r.length)return g(b?S:null,m)})})}call(r,o,...g){try{r.apply(o,g)}catch(m){g[g.length-1](m)}}cmdTraversal(r,o,g,m){const S=r.folder.fsPath,b=A.isMacintosh;let l;const L=()=>l&&l.kill();u.add(L);let O=k=>{u.delete(L),O=()=>{},m(k)},W="";const ie=this.initDirectoryTree();let re;const N=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);l=N.cmd,re=!Object.keys(N.siblingClauses).length;const V=N.rgArgs.args.map(k=>k.match(/^-/)?k:`'${k}'`).join(" ");let x=`${N.rgDiskPath} ${V}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:x}),this.cmdResultCount=0,this.collectStdout(l,"utf8",g,(k,U,F)=>{if(k){O(k);return}if(this.isLimitHit){O();return}const $=(W+(b?P.normalizeNFC(U||""):U)).split(`
`);if(F){const H=$.length;$[H-1]=$[H-1].trim(),$[H-1]||$.pop()}else W=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,re){for(const H of $)if(this.matchFile(o,{base:S,relativePath:H,searchPath:this.getSearchPath(r,H)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ie,S,$,o),F&&(this.matchDirectoryTree(ie,S,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),g=o.getBasenameTerms(),m=o.getPathTerms(),S=["-L","."];if(g.length||m.length){S.push("-not","(","(");for(const b of g)S.push("-name",b),S.push("-o");for(const b of m)S.push("-path",b),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),v.spawn("find",S,{cwd:r.folder.fsPath})}readStdout(r,o,g){let m="";this.collectStdout(r,o,()=>{},(S,b,l)=>{if(S){g(S);return}m+=b,l&&g(null,m)})}collectStdout(r,o,g,m){let S=(L,O,W)=>{(L||W)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),m(L,O,W)},b=!1;r.stdout?(this.forwardData(r.stdout,o,S),r.stdout.once("data",()=>b=!0)):g({message:"stdout is null"});let l;r.stderr?l=this.collectData(r.stderr):g({message:"stderr is null"}),r.on("error",L=>{S(L)}),r.on("close",L=>{let O;!b&&(O=this.decodeData(l,o))&&n(O)?S(new Error(`command failed with error code ${L}: ${this.decodeData(l,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(r,o,g){const m=new T.StringDecoder(o);return r.on("data",S=>{g(null,m.write(S))}),m}collectData(r){const o=[];return r.on("data",g=>{o.push(g)}),o}decodeData(r,o){const g=new T.StringDecoder(o);return r.map(m=>g.write(m)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},g,m,S){m.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const b=l=>{const L=C.basename(l),O=C.dirname(l);let W=o[O];W||(W=o[O]=[],b(O)),W.push({base:g,relativePath:l,basename:L,searchPath:this.getSearchPath(r,l)})};m.forEach(b)}matchDirectoryTree({rootEntries:r,pathToEntries:o},g,m){const S=this,b=this.folderExcludePatterns.get(g),l=this.filePattern;function L(O){S.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(ie=>ie.basename));for(let ie=0,re=O.length;ie<re;ie++){const N=O[ie],{relativePath:V,basename:x}=N;if(b.test(V,x,l!==x?W:void 0))continue;const k=o[V];if(k)L(k);else{if(S.filesWalked++,V===l)continue;S.matchFile(m,N)}if(S.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,g,m,S){const b=r.folder,l=D.hasSiblingFn(()=>g);this.parallel(g,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=o?[o,L].join(C.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(W,L,this.config.filePattern!==L?l:void 0))return O(null);const ie=[b.fsPath,W].join(C.sep);R.lstat(ie,(re,N)=>{if(re||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ie,N,(V,x)=>V||this.isCanceled||this.isLimitHit?O(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,N,(k,U)=>k||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?O(null):(this.walkedPaths[U]=!0,(0,f.readdir)(ie).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,W,F,m,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&a.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(m,{base:b.fsPath,relativePath:W,searchPath:this.getSearchPath(r,W)}),O(null,void 0)))})},L=>{const O=L&&y.coalesce(L);return S(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,g){return o.isSymbolicLink()?R.stat(r,g):g(null,o)}realPathIfNeeded(r,o,g){return o.isSymbolicLink()?R.realpath(r,(m,S)=>m?g(m):g(null,S)):g(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=c;class h{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,o,g){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(m,S)=>{g(m,{limitHit:S,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=h;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,g;Object.keys(r).filter(m=>r[m]).forEach(m=>{C.isAbsolute(m)?(o=o||D.getEmptyExpression(),o[m]=r[m]):(g=g||D.getEmptyExpression(),g[m]=r[m])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=g&&D.parse(g,{trimForExclusions:!0})}test(r,o,g){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,g)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return p.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(me[131],ge([0,1,37,285,100,16,52,31,9,8,2,30,68,286,270,92]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(b){this.outputChannel=b}provideTextSearchResults(b,l,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify(Object.assign(Object.assign({},l),{folder:l.folder.toString()}))}`),new Promise((W,ie)=>{O.onCancellationRequested(()=>M());const re=n(b,l),N=l.folder.fsPath,V=re.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${N}`);let x=v.spawn(E,re,{cwd:N});x.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),ie((0,A.serializeSearchError)(new A.SearchError(we&&we.message,A.SearchErrorCode.rgProcessError)))});let k=!1;const U=new c(l.maxResults,N,l.previewOptions);U.on("result",we=>{k=!0,H="",L.report(we)});let F=!1;const M=()=>{F=!0,x&&x.kill(),U&&U.cancel()};let $=!1;U.on("hitLimit",()=>{$=!0,M()});let H="";x.stdout.on("data",we=>{U.handleData(we),k||(H+=we)});let Q=!1;x.stdout.once("data",()=>Q=!0);let ae="";x.stderr.on("data",we=>{const Le=we.toString();this.outputChannel.appendLine(Le),ae+=Le}),x.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(k?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),F)W({limitHit:$});else{U.flush(),x=null;let we;ae&&!Q&&(we=_(ae))?ie((0,A.serializeSearchError)(new A.SearchError(we.message,we.code))):W({limitHit:$})}})})}}e.RipgrepTextSearchEngine=w;function _(S){const b=S.split(`
`),l=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new A.SearchError(u(b),A.SearchErrorCode.regexParseError);const L=l.match(/grep config error: unknown encoding: (.*)/);if(L)return new A.SearchError(`Unknown encoding: ${L[1]}`,A.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(l,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function u(S){const b=["Regex parse error"],l=S.filter(L=>L.startsWith("PCRE2:"));if(l.length>=1){const L=l[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];b.push(":"+O)}}return b.join("")}e.buildRegexParseError=u;class c extends R.EventEmitter{constructor(b,l,L){super();this.maxResults=b,this.rootFolder=l,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,l){return super.on(b,l),this}handleData(b){if(this.isDone)return;const l=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(l)}handleDecodedData(b){let l=b.indexOf(`
`);const L=this.remainder+b;if(l>=0)l+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;l>=0;)this.handleLine(L.substring(O,l).trim()),O=l+1,l=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(b){if(this.isDone||!b)return;let l;try{l=JSON.parse(b)}catch(L){throw new Error(`malformed line from rg: ${b}`)}if(l.type==="match"){const L=h(l.data.path),O=i.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(l.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const L=h(l.data.path),O=i.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(l.data,O).forEach(ie=>this.onResult(ie))}}createTextSearchMatch(b,l){const L=b.line_number-1;let O=!1,W=h(b.lines);L===0&&(0,P.startsWithUTF8BOM)(W)&&(O=!0,W=(0,P.stripUTF8BOM)(W));const ie=Buffer.from(W);let re=0,N=0,V=L;b.submatches.length===0&&b.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const x=(0,T.coalesce)(b.submatches.map((k,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=h(k.match);L===0&&U===0&&O&&(F=(0,P.stripUTF8BOM)(F),k.start=k.start<=3?0:k.start-3,k.end=k.end<=3?0:k.end-3);const M=ie.slice(re,k.start).toString().length,$=N+M,H=t(F),Q=V,ae=H.numLines+Q,we=H.numLines>0?H.lastLineLength:H.lastLineLength+$;return re=k.end,N=we,V=ae,new d.Range(Q,$,ae,we)}));return(0,f.createTextSearchResult)(l,W,x,this.previewOptions)}createTextSearchContext(b,l){const L=h(b.lines),O=b.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,ie)=>({text:W,uri:l,lineNumber:O+ie}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=c;function h(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const b=/\n/g;let l=0,L=-1,O;for(;O=b.exec(S);)l++,L=O.index;const W=L>=0?S.length-L-1:S.length;return{numLines:l,lastLineLength:W}}function n(S,b){const l=["--hidden"];l.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=(0,y.groupBy)(b.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ie=new Set;O.forEach(re=>{ie.add(re)}),l.push("-g","!*"),ie.forEach(re=>{s(re).map(f.anchorGlob).forEach(N=>{l.push("-g",N)})})}L&&L.length&&L.forEach(ie=>{l.push("-g",ie)}),b.excludes.map(f.anchorGlob).forEach(ie=>l.push("-g",`!${ie}`)),b.maxFileSize&&l.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?l.push("--no-ignore-parent"):l.push("--no-ignore"),b.followSymlinks&&l.push("--follow"),b.encoding&&b.encoding!=="utf8"&&l.push("--encoding",b.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,P.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),b.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),S.isRegExp&&(S.pattern=r(S.pattern),l.push("--auto-hybrid-regex"));let W;if(S.isWordMatch){const re=(0,P.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",re)}else if(S.isRegExp){let ie=g(S.pattern);ie=m(ie),l.push("--regexp",ie)}else W=S.pattern,l.push("--fixed-strings");return l.push("--no-config"),b.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),S.isMultiline&&l.push("--multiline"),b.beforeContext&&l.push("--before-context",b.beforeContext+""),b.afterContext&&l.push("--after-context",b.afterContext+""),l.push("--"),W&&l.push(W),l.push("."),l}function s(S){const b=(0,I.splitGlobAware)(S,"/");return b.map((l,L)=>b.slice(0,L+1).join("/"))}e.spreadGlobComponents=s;function r(S){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(b);)S=S.replace(b,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(l);)S=S.replace(l,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=r;const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function g(S){let b;try{b=new p.RegExpParser().parsePattern(S)}catch(re){return S}let l="",L=0;const O=(re,N,V)=>{l+=S.slice(L,re)+V,L=N},W=[];return new p.RegExpVisitor({onCharacterEnter(re){if(re.raw!=="\\n")return;const N=W[0];if(!N)O(re.start,re.end,"\\r?\\n");else if(!W.some(o))if(N.type==="CharacterClass")if(N.negate){const V=S.slice(N.start+2,re.start)+S.slice(re.end,N.end-1);O(N.start,N.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=S.slice(N.start+1,re.start)+S.slice(re.end,N.end-1);O(N.start,N.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else N.type==="Quantifier"&&O(re.start,re.end,"(?:\\r?\\n)")},onQuantifierEnter(re){W.unshift(re)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(re){W.unshift(re)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(re){W.unshift(re)},onCharacterClassLeave(){W.shift()},onAssertionEnter(re){o(re)&&W.push(re)},onAssertionLeave(re){W[0]===re&&W.shift()}}).visit(b),l+=S.slice(L),l}e.fixRegexNewline=g;function m(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[272],ge([0,1,21,131,114,10]),function(K,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,i,A,d){const p=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===T.Schemas.userData){const a=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:T.Schemas.file})}),f=new C.Progress(E=>A.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:i.folder.scheme})})));return this.withToken(d,E=>p.provideTextSearchResults(P,a,f,E))}else return this.withToken(d,a=>p.provideTextSearchResults(P,i,A,a))}async withToken(P,i){const A=I(P);this.inProgress.add(A);const d=await i(A.token);return this.inProgress.delete(A),d}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=y;function I(D){const P=new v.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(me[273],ge([0,1,28,131,130]),function(K,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,P,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(p){i({message:p})}},d=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(A),v);return new Promise((p,a)=>d.search(f=>{P(f.map(y))},D).then(f=>p({limitHit:f.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=T;function y(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((D,P)=>{if(P.ranges){const i=P;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[274],ge([0,1,59,287,16,13,17,3,98,9,44,2,43,30,271,273]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=u(t),r=new I.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=u(t),r=new I.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.ripgrepTextSearch(s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,d.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new f.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=E.BATCH_SIZE){let g=0;const m=b=>{Array.isArray(b)?(g+=b.length,s(b.map(l=>this.rawMatchToSearchItem(l)))):b.relativePath?(g++,s(this.rawMatchToSearchItem(b))):s(b)};if(n.sortByScore){let b=this.trySortedSearchFromCache(n,m,r);if(!b){const l=n.maxResults?Object.assign({},n,{maxResults:null}):n,L=new t(l);b=this.doSortedSearch(L,n,s,m,r)}return new Promise((l,L)=>{b.then(([O,W])=>{const ie=W.map(re=>this.rawMatchToSearchItem(re));this.sendProgress(ie,s,o),l(O)},L)})}const S=new t(n);return this.doSearch(S,m,o,r).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:"searchProcess",fromCache:!1,resultCount:g,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const g=new I.Emitter;let m=(0,T.createCancelablePromise)(b=>{let l=[];const L=O=>{Array.isArray(O)?l=O:(r(O),g.fire(O))};return this.doSearch(t,L,-1,b).then(O=>[O,l])}),S;if(n.cacheKey){S=this.getOrCreateCache(n.cacheKey);const b={promise:m,event:g.event,resolved:!1};S.resultsToSearchCache[n.filePattern||""]=b,m.then(()=>{b.resolved=!0},l=>{delete S.resultsToSearchCache[n.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([b,l])=>{const L=S?S.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,l,L,o).then(W=>{const ie=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:W.length},messages:b.messages,limitHit:b.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults},W]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!r)return;const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([g,m,S])=>{const b=i.StopWatch.create(!1);return this.sortResults(t,m,r.scorerCache,s).then(l=>{const L=b.elapsed(),O={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:m.length,sortingTime:L};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:O},l]})})}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),g=(S,b)=>(0,D.compareItemsByFuzzyScore)(S,b,o,!0,_,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(n,g,m,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=i.StopWatch.create(!1),g=n.indexOf(P.sep)>=0;let m;for(const L in t.resultsToSearchCache)if(n.startsWith(L)){if(g&&L.indexOf(P.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];m={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!m)return null;const S=o.elapsed(),b=i.StopWatch.create(!1),l=m.event(s);return r&&r.onCancellationRequested(()=>{l.dispose()}),m.promise.then(([L,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const W=[],ie=(0,D.prepareQuery)(n).normalizedLowercase;for(const re of O)!(0,p.isFilePatternMatch)(re,ie)||W.push(re);return[L,W,{cacheWasResolved:m.resolved,cacheLookupTime:S,cacheFilterTime:b.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,s,r){return new Promise((o,g)=>{let m=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(s?(m.push(S),s>0&&m.length>=s&&(n(m),m=[])):n(S))},S=>{n(S)},(S,b)=>{m.length&&n(m),S?g(S):o(b)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(h){return(0,P.basename)(h.relativePath)}getItemDescription(h){return(0,P.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function u(h){return Object.assign(Object.assign({},h),{folderQueries:h.folderQueries&&h.folderQueries.map(c),extraFileResources:h.extraFileResources&&h.extraFileResources.map(t=>A.URI.revive(t))})}function c(h){return Object.assign(Object.assign({},h),{folder:A.URI.revive(h.folder)})}}),define(me[275],ge([0,1,6,2,28,14,30,274,272,92,15,63,27,71,10,130]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends p.ExtHostSearch{constructor(_,u,c,h){super(_,c,h);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(a.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(_,u){const c=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,v.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,u,c,h){const t=(0,p.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,u,t,h):super.$provideFileSearchResults(_,u,c,h)}doInternalFileSearch(_,u,c,h){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,u,n.map(s=>R.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,h)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,u){return new f.NativeTextSearchManager(_,u)}};E=qe([He(0,i.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,A.IURITransformerService),He(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(me[132],ge([0,1,288,122,289,3,103,9,101,32,6,23,104,17,11]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(m){this.socket=m,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const S=b=>m(A.VSBuffer.wrap(b));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,p.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((m,S)=>{if(this.socket.bufferSize===0){m();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),m()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=f;var E;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(w||(w={}));class _ extends i.Disposable{constructor(m,S,b,l){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=l,S?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new d.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):A.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(A.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,S){let b=2;m.byteLength<126?b+=0:m.byteLength<2**16?b+=2:b+=8;const l=A.VSBuffer.alloc(b);if(S?l.writeUInt8(194,0):l.writeUInt8(130,0),m.byteLength<126)l.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){l.writeUInt8(126,1);let L=1;l.writeUInt8(m.byteLength>>>8&255,++L),l.writeUInt8(m.byteLength>>>0&255,++L)}else{l.writeUInt8(127,1);let L=1;l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(m.byteLength>>>24&255,++L),l.writeUInt8(m.byteLength>>>16&255,++L),l.writeUInt8(m.byteLength>>>8&255,++L),l.writeUInt8(m.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=l.byteLength+m.byteLength,this.socket.write(A.VSBuffer.concat([l,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),l=(S.readUInt8(0)&128)>>>7,L=S.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=l,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),b=S.readUInt8(1),l=(b&128)>>>7;let L=b&127,O=1;L===126?L=S.readUInt8(++O)*2**8+S.readUInt8(++O):L===127&&(L=S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*0+S.readUInt8(++O)*2**24+S.readUInt8(++O)*2**16+S.readUInt8(++O)*2**8+S.readUInt8(++O));let W=0;l&&(W=S.readUInt8(++O)*2**24+S.readUInt8(++O)*2**16+S.readUInt8(++O)*2**8+S.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);u(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(A.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function u(g,m){if(m===0)return;let S=g.byteLength>>>2;for(let ie=0;ie<S;ie++){const re=g.readUInt32BE(ie*4);g.writeUInt32BE(re^m,ie*4)}let b=S*4,l=g.byteLength-b;const L=m>>>24&255,O=m>>>16&255,W=m>>>8&255;l>=1&&g.writeUInt8(g.readUInt8(b)^L,b),l>=2&&g.writeUInt8(g.readUInt8(b+1)^O,b+1),l>=3&&g.writeUInt8(g.readUInt8(b+2)^W,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function h(){const g=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):m=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${g}.sock`),n(m),m}e.createRandomIPCHandle=h;function t(g,m,S){const b=(0,v.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${S}-${m}-sock`;let l;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?l=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${S}-${m}.sock`):l=(0,I.join)(g,`${S}-${m}.sock`),n(l),l}e.createStaticIPCHandle=t;function n(g){const m=c[a.platform];typeof m=="number"&&g.length>=m&&console.warn(`WARNING: IPC handle "${g}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const S=T.Event.fromNodeEventEmitter(m,"connection");return T.Event.map(S,b=>({protocol:new d.Protocol(new f(b)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((m,S)=>{const b=(0,R.createServer)();b.on("error",S),b.listen(g,()=>{b.removeListener("error",S),m(new s(b))})})}e.serve=r;function o(g,m){return new Promise((S,b)=>{const l=(0,R.createConnection)(g,()=>{l.removeListener("error",b),S(d.Client.fromSocket(new f(l),m))});l.once("error",b)})}e.connect=o}),define(me[276],ge([0,1,132,268,59,49,2,118,14]),function(K,e,v,R,C,T,y,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(d,p,a){this._commands=d,this.logService=p,this._ipcHandlePath=a,this._server=R.createServer((f,E)=>this.onRequest(f,E)),this.setup().catch(f=>(p.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,p){const a=[];d.setEncoding("utf8"),d.on("data",f=>a.push(f)),d.on("end",()=>{const f=JSON.parse(a.join(""));switch(f.type){case"open":this.open(f,p);break;case"openExternal":this.openExternal(f,p);break;case"status":this.getStatus(f,p);break;case"extensionManagement":this.manageExtensions(f,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${f.type}`,E=>{E&&this.logService.error(E)}),p.end();break}})}open(d,p){let{fileURIs:a,folderURIs:f,forceNewWindow:E,diffMode:w,addMode:_,forceReuseWindow:u,gotoLineMode:c,waitMarkerFilePath:h}=d;const t=[];if(Array.isArray(f))for(const n of f)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,I.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=h?y.URI.file(h):void 0,r={forceNewWindow:E,diffMode:w,addMode:_,gotoLineMode:c,forceReuseWindow:u,preferNewWindow:!u&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}p.writeHead(200),p.end()}async openExternal(d,p){for(const a of d.uris){const f=y.URI.parse(a),E=f.scheme==="file"?f:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}p.writeHead(200),p.end()}async manageExtensions(d,p){try{const a=w=>w==null?void 0:w.map(_=>/\.vsix$/i.test(_)?y.URI.parse(_):_),f={list:d.list,install:a(d.install),uninstall:a(d.uninstall),force:d.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);p.writeHead(200),p.write(E)}catch(a){p.writeHead(500),p.write(String(a),f=>{f&&this.logService.error(f)})}p.end()}async getStatus(d,p){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(a),p.end()}catch(a){p.writeHead(500),p.write(String(a),f=>{f&&this.logService.error(f)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let i=class extends P{constructor(d,p){super(d,p,(0,v.createRandomIPCHandle)())}};i=qe([He(0,T.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(me[277],ge([0,1,70,264,259,5,267,41,249,2,10,7,276,102]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const w=this,_=K.__$__nodeRequire("module"),u=_._load;_._load=function(h,t,n){for(let s of w._alternatives){let r=s(h);if(r){h=r;break}}return w._factories.has(h)?w._factories.get(h).load(h,P.URI.file((0,p.realpathSync)(t.filename)),s=>u.apply(this,[s,t,n])):u.apply(this,arguments)}}}class f extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const c=process.send,h=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(h.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,_,u){if(_.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{w&&v.mark(`code/extHost/willLoadExtensionCode/${w.value}`),c=K.__$__nodeRequire(_.fsPath)}catch(h){return Promise.reject(h)}finally{w&&v.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const _ in w){const u=w[_];u===null?delete process.env[_]:process.env[_]=u}}}e.ExtHostExtensionService=f}),define(me[278],ge([0,1,79,250,251,261,260,275,277,220,252,50,41,66,71,69,33,48,14]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(d.IExtHostExtensionService,D.ExtHostExtensionService),(0,v.registerSingleton)(_.ILogService,P.ExtHostLogService),(0,v.registerSingleton)(A.IExtHostDebugService,y.ExtHostDebugService),(0,v.registerSingleton)(p.IExtHostOutputService,R.ExtHostOutputService2),(0,v.registerSingleton)(a.IExtHostSearch,I.NativeExtHostSearch),(0,v.registerSingleton)(f.IExtHostTask,T.ExtHostTask),(0,v.registerSingleton)(E.IExtHostTerminalService,C.ExtHostTerminalService),(0,v.registerSingleton)(w.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[279],ge([0,1,122,290,70,17,104,132,187,218,262,23,99,28,102,13,265,278]),function(K,e,v,R,C,T,y,I,D,P,i,A,d,p,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=K.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function _(s){process.exit=function(r){if(s)w(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let u=function(s){w()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,g=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,S=3e5,b=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),m),l=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),S);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=A.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let re;if(O.skipWebSocketFrames)re=new I.NodeSocket(W);else{const N=A.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));re=new I.WebSocketNodeSocket(new I.NodeSocket(W),O.permessageDeflate,N,!1)}o?(b.cancel(),l.cancel(),o.beginAcceptReconnection(re,ie),o.endAcceptReconnection()):(clearTimeout(g),o=new y.PersistentProtocol(re,ie),o.onDidDispose(()=>u("renderer disconnected")),s(o),o.onSocketClose(()=>{b.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(l.isScheduled())return;b.isScheduled()&&l.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const g=v.createConnection(s,()=>{g.removeListener("error",o),r(new y.PersistentProtocol(new I.NodeSocket(g)))});g.once("error",o),g.on("close",()=>{u("renderer closed the socket")})})}}async function h(){const s=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,P.isMessageOfType)(r,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(g=>{o.dispose();const m=JSON.parse(g.toString()),S=m.commit,b=D.default.commit;S&&b&&S!==b&&w(55);const l=[];process.on("unhandledRejection",(W,ie)=>{l.push(ie),setTimeout(()=>{const re=l.indexOf(ie);re>=0&&ie.catch(N=>{l.splice(re,1),console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,T.onUnexpectedError)(W)})},1e3)}),process.on("rejectionHandled",W=>{const ie=l.indexOf(W);ie>=0&&l.splice(ie,1)}),process.on("uncaughtException",function(W){(0,T.onUnexpectedError)(W)});let L=0;setInterval(function(){try{process.kill(m.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${m.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=K.__$__nodeRequire("native-watchdog"),O.start(m.parentPid)}catch(W){(0,T.onUnexpectedError)(W)}s.send((0,P.createMessageOfType)(0)),r({protocol:s,initData:m})});s.send((0,P.createMessageOfType)(1))})}async function n(){C.mark("code/extHost/willConnectToRenderer");const s=await h();C.mark("code/extHost/didConnectToRenderer");const r=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=r;_(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const g=new class{exit(l){w(l)}exists(l){return(0,p.exists)(l)}realpath(l){return(0,a.realpath)(l)}};let m=null;if(o.remote.authority&&E.uriTransformerPath)try{const l=K.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);m=new d.URITransformer(l)}catch(b){console.error(b)}const S=new i.ExtensionHostMain(r.protocol,o,g,m);u=b=>S.terminate(b)}e.startExtensionHostProcess=n}),define(me[291],ge([0,1,279]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a18ea9c9ec25c59e599ba3c2eb668315546dd269/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
