/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/network","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(J){for(var e=[],v=0,R=J.length;v<R;v++)e[v]=be[J[v]];return e};define(be[42],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(be[52],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(n){const P=[];for(let d in n)v.call(n,d)&&P.push(n[d]);return P}e.values=R;function D(n,P){for(let d in n)if(v.call(n,d)&&P({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=D;function T(n,P){const d=Object.create(null);for(const g of n){const r=P(g);let a=d[r];a||(a=d[r]=[]),a.push(g)}return d}e.groupBy=T;function _(n){const P=Object.create(null);return n&&n.forEach((d,g)=>{P[g]=d}),P}e.fromMap=_;function S(n,P){const d=[],g=[];for(let r of n)P.has(r)||d.push(r);for(let r of P)n.has(r)||g.push(r);return{removed:d,added:g}}e.diffSets=S;function y(n,P){const d=[],g=[];for(let[r,a]of n)P.has(r)||d.push(a);for(let[r,a]of P)n.has(r)||g.push(a);return{removed:d,added:g}}e.diffMaps=y;class k{constructor(){this.map=new Map}add(P,d){let g=this.map.get(P);g||(g=new Set,this.map.set(P,g)),g.add(d)}delete(P,d){const g=this.map.get(P);!g||(g.delete(d),g.size===0&&this.map.delete(P))}forEach(P,d){const g=this.map.get(P);!g||g.forEach(d)}}e.SetMap=k}),define(be[53],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(_){return(S,y,k)=>{let n=null,P=null;if(typeof k.value=="function"?(n="value",P=k.value):typeof k.get=="function"&&(n="get",P=k.get),!P)throw new Error("not supported");k[n]=_(P,y)}}e.createDecorator=v;function R(_,S,y){let k=null,n=null;if(typeof y.value=="function"?(k="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",n=y.get),!n)throw new Error("not supported");const P=`$memoize$${S}`;y[k]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[P]}}e.memoize=R;function D(_,S,y){return v((k,n)=>{const P=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...g){this[d]||(this[d]=y?y():void 0),clearTimeout(this[P]),S&&(this[d]=S(this[d],...g),g=[this[d]]),this[P]=setTimeout(()=>{k.apply(this,g),this[d]=y?y():void 0},_)}})}e.debounce=D;function T(_,S,y){return v((k,n)=>{const P=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,g=`$throttle$lastRun$${n}`,r=`$throttle$pending$${n}`;return function(...a){if(this[d]||(this[d]=y?y():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...a)),this[r])return;const p=this[g]+_;p<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=y?y():void 0):(this[r]=!0,this[P]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=y?y():void 0},p-Date.now()))}})}e.throttle=T}),define(be[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function D(f){y(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function T(f){y(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=T;function _(f){if(f instanceof Error){let{name:t,message:i}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:t,message:i,stack:s}}return f}e.transformErrorForSerialization=_;const S="Canceled";function y(f){return f instanceof Error&&f.name===S&&f.message===S}e.isPromiseCanceledError=y;class k extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=k;function n(){const f=new Error(S);return f.name=f.message,f}e.canceled=n;function P(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=P;function d(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=d;function g(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function r(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=a;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function l(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function h(f,t=Object.create(null)){const i=new Error(f);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=h}),define(be[13],we([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,I=0){return W[W.length-(1+I)]}e.tail=R;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function T(W,I,H=(M,B)=>M===B){if(W===I)return!0;if(!W||!I||W.length!==I.length)return!1;for(let M=0,B=W.length;M<B;M++)if(!H(W[M],I[M]))return!1;return!0}e.equals=T;function _(W,I,H){let M=0,B=W.length-1;for(;M<=B;){const G=(M+B)/2|0,q=H(W[G],I);if(q<0)M=G+1;else if(q>0)B=G-1;else return G}return-(M+1)}e.binarySearch=_;function S(W,I){let H=0,M=W.length;if(M===0)return 0;for(;H<M;){const B=Math.floor((H+M)/2);I(W[B])?M=B:H=B+1}return H}e.findFirstInSorted=S;function y(W,I,H){if(W=W|0,W>=I.length)throw new TypeError("invalid index");let M=I[Math.floor(I.length*Math.random())],B=[],G=[],q=[];for(let se of I){const ve=H(se,M);ve<0?B.push(se):ve>0?G.push(se):q.push(se)}return W<B.length?y(W,B,H):W<B.length+q.length?q[0]:y(W-(B.length+q.length),G,H)}e.quickSelect=y;function k(W,I){const H=[];let M;for(const B of W.slice(0).sort(I))!M||I(M[0],B)!==0?(M=[B],H.push(M)):M.push(B);return H}e.groupBy=k;function n(W,I,H){const M=[];function B(se,ve,Le){if(ve===0&&Le.length===0)return;const xe=M[M.length-1];xe&&xe.start+xe.deleteCount===se?(xe.deleteCount+=ve,xe.toInsert.push(...Le)):M.push({start:se,deleteCount:ve,toInsert:Le})}let G=0,q=0;for(;;){if(G===W.length){B(G,0,I.slice(q));break}if(q===I.length){B(G,W.length-G,[]);break}const se=W[G],ve=I[q],Le=H(se,ve);Le===0?(G+=1,q+=1):Le<0?(B(G,1,[]),G+=1):Le>0&&(B(G,0,[ve]),q+=1)}return M}e.sortedDiff=n;function P(W,I,H){const M=n(W,I,H),B=[],G=[];for(const q of M)B.push(...W.slice(q.start,q.start+q.deleteCount)),G.push(...q.toInsert);return{removed:B,added:G}}e.delta=P;function d(W,I,H){if(H===0)return[];const M=W.slice(0,H).sort(I);return r(W,I,M,H,W.length),M}e.top=d;function g(W,I,H,M,B){return H===0?Promise.resolve([]):new Promise((G,q)=>{(async()=>{const se=W.length,ve=W.slice(0,H).sort(I);for(let Le=H,xe=Math.min(H+M,se);Le<se;Le=xe,xe=Math.min(xe+M,se)){if(Le>H&&await new Promise(Me=>setTimeout(Me)),B&&B.isCancellationRequested)throw(0,v.canceled)();r(W,I,ve,Le,xe)}return ve})().then(G,q)})}e.topAsync=g;function r(W,I,H,M,B){for(const G=H.length;M<B;M++){const q=W[M];if(I(q,H[G-1])<0){H.pop();const se=S(H,ve=>I(q,ve)<0);H.splice(se,0,q)}}}function a(W){return W.filter(I=>!!I)}e.coalesce=a;function p(W){let I=0;for(let H=0;H<W.length;H++)W[H]&&(W[I]=W[H],I+=1);W.length=I}e.coalesceInPlace=p;function m(W,I,H){W.splice(H,0,W.splice(I,1)[0])}e.move=m;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function l(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=l;function h(W,I){if(!I)return W.filter((M,B)=>W.indexOf(M)===B);const H=Object.create(null);return W.filter(M=>{const B=I(M);return H[B]?!1:(H[B]=!0,!0)})}e.distinct=h;function f(W){const I=new Set;return W.filter(H=>I.has(H)?!1:(I.add(H),!0))}e.distinctES6=f;function t(W){const I=Object.create(null);return H=>{const M=W(H);return I[M]?!1:(I[M]=!0,!0)}}e.uniqueFilter=t;function i(W,I){for(let H=W.length-1;H>=0;H--){const M=W[H];if(I(M))return H}return-1}e.lastIndex=i;function s(W,I){return W.length>0?W[0]:I}e.firstOrDefault=s;function o(W,I,H=(M,B)=>M===B){let M=0;for(let B=0,G=Math.min(W.length,I.length);B<G&&H(W[B],I[B]);B++)M++;return M}e.commonPrefixLength=o;function c(W){return[].concat(...W)}e.flatten=c;function w(W,I){let H=typeof I=="number"?W:0;typeof I=="number"?H=W:(H=0,I=W);const M=[];if(H<=I)for(let B=H;B<I;B++)M.push(B);else for(let B=H;B>I;B--)M.push(B);return M}e.range=w;function b(W,I,H){return W.reduce((M,B)=>(M[I(B)]=H?H(B):B,M),Object.create(null))}e.index=b;function A(W,I){return W.push(I),()=>C(W,I)}e.insert=A;function C(W,I){const H=W.indexOf(I);if(H>-1)return W.splice(H,1),I}e.remove=C;function u(W,I,H){const M=W.slice(0,I),B=W.slice(I);return M.concat(H,B)}e.arrayInsert=u;function F(W,I){let H;if(typeof I=="number"){let M=I;H=()=>{const B=Math.sin(M++)*179426549;return B-Math.floor(B)}}else H=Math.random;for(let M=W.length-1;M>0;M-=1){const B=Math.floor(H()*(M+1)),G=W[M];W[M]=W[B],W[B]=G}}e.shuffle=F;function O(W,I){const H=W.indexOf(I);H>-1&&(W.splice(H,1),W.unshift(I))}e.pushToStart=O;function z(W,I){const H=W.indexOf(I);H>-1&&(W.splice(H,1),W.push(I))}e.pushToEnd=z;function de(W,I){return Array.isArray(W)?W.map(I):I(W)}e.mapArrayOrNot=de;function he(W){return Array.isArray(W)?W:[W]}e.asArray=he;function $(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=$;function j(W,I){for(const H of W){const M=I(H);if(M!==void 0)return M}}e.mapFind=j}),define(be[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const D=this;let T=!1,_;return function(){return T||(T=!0,_=R.apply(D,arguments)),_}}e.once=v}),define(be[55],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(be[43],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function D(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=D;const T=Object.freeze([]);function _(){return T}R.empty=_;function*S(f){yield f}R.single=S;function y(f){return f||T}R.from=y;function k(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=k;function n(f){return f[Symbol.iterator]().next().value}R.first=n;function P(f,t){for(const i of f)if(t(i))return!0;return!1}R.some=P;function d(f,t){for(const i of f)if(t(i))return i}R.find=d;function*g(f,t){for(const i of f)t(i)&&(yield i)}R.filter=g;function*r(f,t){let i=0;for(const s of f)yield t(s,i++)}R.map=r;function*a(...f){for(const t of f)for(const i of t)yield i}R.concat=a;function*p(f){for(const t of f)for(const i of t)yield i}R.concatNested=p;function m(f,t,i){let s=i;for(const o of f)s=t(s,o);return s}R.reduce=m;function*E(f,t,i=f.length){for(t<0&&(t+=f.length),i<0?i+=f.length:i>f.length&&(i=f.length);t<i;t++)yield f[t]}R.slice=E;function l(f,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,f];const s=f[Symbol.iterator]();for(let o=0;o<t;o++){const c=s.next();if(c.done)return[i,R.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=l;function h(f,t,i=(s,o)=>s===o){const s=f[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const c=s.next(),w=o.next();if(c.done!==w.done)return!1;if(c.done)return!0;if(!i(c.value,w.value))return!1}}R.equals=h})(v=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function _(t,i=!1){let s=0,o=t.length,c="",w=0,b=16,A=0;function C($){let j=0,W=0;for(;j<$;){const I=t.charCodeAt(s);if(I>=48&&I<=57)W=W*16+I-48;else if(I>=65&&I<=70)W=W*16+I-65+10;else if(I>=97&&I<=102)W=W*16+I-97+10;else break;s++,j++}return j<$&&(W=-1),W}function u($){s=$,c="",w=0,b=16,A=0}function F(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return A=3,t.substring($,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;j=s}else A=3;return t.substring($,j)}function O(){let $="",j=s;for(;;){if(s>=o){$+=t.substring(j,s),A=2;break}const W=t.charCodeAt(s);if(W===34){$+=t.substring(j,s),s++;break}if(W===92){if($+=t.substring(j,s),s++,s>=o){A=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const H=C(4);H>=0?$+=String.fromCharCode(H):A=4;break;default:A=5}j=s;continue}if(W>=0&&W<=31)if(y(W)){$+=t.substring(j,s),A=2;break}else A=6;s++}return $}function z(){if(c="",A=0,w=s,s>=o)return w=o,b=17;let $=t.charCodeAt(s);if(S($)){do s++,c+=String.fromCharCode($),$=t.charCodeAt(s);while(S($));return b=15}if(y($))return s++,c+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),b=14;switch($){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,c=O(),b=10;case 47:const j=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!y(t.charCodeAt(s));)s++;return c=t.substring(j,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const W=o-1;let I=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,I=!0;break}s++}return I||(s++,A=1),c=t.substring(j,s),b=13}return c+=String.fromCharCode($),s++,b=16;case 45:if(c+=String.fromCharCode($),s++,s===o||!k(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=F(),b=11;default:for(;s<o&&de($);)s++,$=t.charCodeAt(s);if(w!==s){switch(c=t.substring(w,s),c){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return c+=String.fromCharCode($),s++,b=16}}function de($){if(S($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let $;do $=z();while($>=12&&$<=15);return $}return{setPosition:u,getPosition:()=>s,scan:i?he:z,getToken:()=>b,getTokenValue:()=>c,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>A}}e.createScanner=_;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,i){const s=[],o=new Object;let c;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(C,u,F,O){w.value=C,w.offset=u,w.length=F,w.type=O,w.colonOffset=void 0,c=w}try{l(t,{onObjectBegin:(C,u)=>{if(i<=C)throw o;c=void 0,b=i>C,s.push("")},onObjectProperty:(C,u,F)=>{if(i<u||(A(C,u,F,"property"),s[s.length-1]=C,i<=u+F))throw o},onObjectEnd:(C,u)=>{if(i<=C)throw o;c=void 0,s.pop()},onArrayBegin:(C,u)=>{if(i<=C)throw o;c=void 0,s.push(0)},onArrayEnd:(C,u)=>{if(i<=C)throw o;c=void 0,s.pop()},onLiteralValue:(C,u,F)=>{if(i<u||(A(C,u,F,f(C)),i<=u+F))throw o},onSeparator:(C,u,F)=>{if(i<=u)throw o;if(C===":"&&c&&c.type==="property")c.colonOffset=u,b=!1,c=void 0;else if(C===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(b=!0,s[s.length-1]=""),c=void 0}}})}catch(C){if(C!==o)throw C}return{path:s,previousNode:c,isAtPropertyKey:b,matches:C=>{let u=0;for(let F=0;u<C.length&&F<s.length;F++)if(C[u]===s[F]||C[u]==="*")u++;else if(C[u]!=="**")return!1;return u===C.length}}}e.getLocation=P;function d(t,i=[],s=T.DEFAULT){let o=null,c=[];const w=[];function b(C){Array.isArray(c)?c.push(C):o!==null&&(c[o]=C)}return l(t,{onObjectBegin:()=>{const C={};b(C),w.push(c),c=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{c=w.pop()},onArrayBegin:()=>{const C=[];b(C),w.push(c),c=C,o=null},onArrayEnd:()=>{c=w.pop()},onLiteralValue:b,onError:(C,u,F)=>{i.push({error:C,offset:u,length:F})}},s),c[0]}e.parse=d;function g(t,i=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(C){o.type==="property"&&(o.length=C-o.offset,o=o.parent)}function w(C){return o.children.push(C),C}l(t,{onObjectBegin:C=>{o=w({type:"object",offset:C,length:-1,parent:o,children:[]})},onObjectProperty:(C,u,F)=>{o=w({type:"property",offset:u,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:C,offset:u,length:F,parent:o})},onObjectEnd:(C,u)=>{o.length=C+u-o.offset,o=o.parent,c(C+u)},onArrayBegin:(C,u)=>{o=w({type:"array",offset:C,length:-1,parent:o,children:[]})},onArrayEnd:(C,u)=>{o.length=C+u-o.offset,o=o.parent,c(C+u)},onLiteralValue:(C,u,F)=>{w({type:f(C),offset:u,length:F,parent:o,value:C}),c(u+F)},onSeparator:(C,u,F)=>{o.type==="property"&&(C===":"?o.colonOffset=u:C===","&&c(u))},onError:(C,u,F)=>{i.push({error:C,offset:u,length:F})}},s);const A=o.children[0];return A&&delete A.parent,A}e.parseTree=g;function r(t,i){if(!t)return;let s=t;for(let o of i)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===o){s=w.children[1],c=!0;break}if(!c)return}else{const c=o;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const i=a(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=a;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const i=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(i[s.children[0].value]=p(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=m;function E(t,i,s=!1){if(m(t,i,s)){const o=t.children;if(Array.isArray(o))for(let c=0;c<o.length&&o[c].offset<=i;c++){const w=E(o[c],i,s);if(w)return w}return t}}e.findNodeAtOffset=E;function l(t,i,s=T.DEFAULT){const o=_(t,!1);function c(ve){return ve?()=>ve(o.getTokenOffset(),o.getTokenLength()):()=>!0}function w(ve){return ve?Le=>ve(Le,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=c(i.onObjectBegin),A=w(i.onObjectProperty),C=c(i.onObjectEnd),u=c(i.onArrayBegin),F=c(i.onArrayEnd),O=w(i.onLiteralValue),z=w(i.onSeparator),de=c(i.onComment),he=w(i.onError),$=s&&s.disallowComments,j=s&&s.allowTrailingComma;function W(){for(;;){const ve=o.scan();switch(o.getTokenError()){case 4:I(14);break;case 5:I(15);break;case 3:I(13);break;case 1:$||I(11);break;case 2:I(12);break;case 6:I(16);break}switch(ve){case 12:case 13:$?I(10):de();break;case 16:I(1);break;case 15:case 14:break;default:return ve}}}function I(ve,Le=[],xe=[]){if(he(ve),Le.length+xe.length>0){let Me=o.getToken();for(;Me!==17;){if(Le.indexOf(Me)!==-1){W();break}else if(xe.indexOf(Me)!==-1)break;Me=W()}}}function H(ve){const Le=o.getTokenValue();return ve?O(Le):A(Le),W(),!0}function M(){switch(o.getToken()){case 11:let ve=0;try{ve=JSON.parse(o.getTokenValue()),typeof ve!="number"&&(I(2),ve=0)}catch(Le){I(2)}O(ve);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return W(),!0}function B(){return o.getToken()!==10?(I(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(z(":"),W(),se()||I(4,[],[2,5])):I(5,[],[2,5]),!0)}function G(){b(),W();let ve=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ve||I(4,[],[]),z(","),W(),o.getToken()===2&&j)break}else ve&&I(6,[],[]);B()||I(4,[],[2,5]),ve=!0}return C(),o.getToken()!==2?I(7,[2],[]):W(),!0}function q(){u(),W();let ve=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ve||I(4,[],[]),z(","),W(),o.getToken()===4&&j)break}else ve&&I(6,[],[]);se()||I(4,[],[4,5]),ve=!0}return F(),o.getToken()!==4?I(8,[4],[]):W(),!0}function se(){switch(o.getToken()){case 3:return q();case 1:return G();case 10:return H(!0);default:return M()}}return W(),o.getToken()===17?s.allowEmptyContent?!0:(I(4,[],[]),!1):se()?(o.getToken()!==17&&I(9,[],[]),!0):(I(4,[],[]),!1)}e.visit=l;function h(t,i){let s=_(t),o=[],c,w=0,b;do switch(b=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:w!==b&&o.push(t.substring(w,b)),i!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,i)),w=s.getPosition();break}while(c!==17);return o.join("")}e.stripComments=h;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(be[108],we([0,1,44]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,k,n){let P,d,g,r,a;if(k){for(r=k.offset,a=r+k.length,g=r;g>0&&!S(y,g-1);)g--;let w=a;for(;w<y.length&&!S(y,w);)w++;d=y.substring(g,w),P=T(d,n)}else d=y,P=0,g=0,r=0,a=y.length;const p=_(n,y);let m=!1,E=0,l;n.insertSpaces?l=D(" ",n.tabSize||4):l="	";const h=(0,v.createScanner)(d,!1);let f=!1;function t(){return p+D(l,P+E)}function i(){let w=h.scan();for(m=!1;w===15||w===14;)m=m||w===14,w=h.scan();return f=w===16||h.getTokenError()!==0,w}const s=[];function o(w,b,A){!f&&b<a&&A>r&&y.substring(b,A)!==w&&s.push({offset:b,length:A-b,content:w})}let c=i();if(c!==17){const w=h.getTokenOffset()+g,b=D(l,P);o(b,g,w)}for(;c!==17;){let w=h.getTokenOffset()+h.getTokenLength()+g,b=i(),A="";for(;!m&&(b===12||b===13);){const u=h.getTokenOffset()+g;o(" ",w,u),w=h.getTokenOffset()+h.getTokenLength()+g,A=b===12?t():"",b=i()}if(b===2)c!==1&&(E--,A=t());else if(b===4)c!==3&&(E--,A=t());else{switch(c){case 3:case 1:E++,A=t();break;case 5:case 12:A=t();break;case 13:m?A=t():A=" ";break;case 6:A=" ";break;case 10:if(b===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?A=" ":b!==5&&b!==17&&(f=!0);break;case 16:f=!0;break}m&&(b===12||b===13)&&(A=t())}const C=h.getTokenOffset()+g;o(A,w,C),c=b}return s}e.format=R;function D(y,k){let n="";for(let P=0;P<k;P++)n+=y;return n}function T(y,k){let n=0,P=0;const d=k.tabSize||4;for(;n<y.length;){const g=y.charAt(n);if(g===" ")P++;else if(g==="	")P+=d;else break;n++}return Math.floor(P/d)}function _(y,k){for(let n=0;n<k.length;n++){const P=k.charAt(n);if(P==="\r")return n+1<k.length&&k.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=_;function S(y,k){return`\r
`.indexOf(y.charAt(k))!==-1}e.isEOL=S}),define(be[109],we([0,1,44,108]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(k,n,P){return T(k,n,void 0,P)}e.removeProperty=D;function T(k,n,P,d,g){const r=n.slice(),a=[],p=(0,v.parseTree)(k,a);let m,E;for(;r.length>0&&(E=r.pop(),m=(0,v.findNodeAtLocation)(p,r),m===void 0&&P!==void 0);)typeof E=="string"?P={[E]:P}:P=[P];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const l=(0,v.findNodeAtLocation)(m,[E]);if(l!==void 0)if(P===void 0){if(!l.parent)throw new Error("Malformed AST");const h=m.children.indexOf(l.parent);let f,t=l.parent.offset+l.parent.length;if(h>0){const i=m.children[h-1];f=i.offset+i.length}else f=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return _(k,{offset:f,length:t-f,content:""},d)}else return _(k,{offset:l.offset,length:l.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const h=`${JSON.stringify(E)}: ${JSON.stringify(P)}`,f=g?g(m.children.map(i=>i.children[0].value)):m.children.length;let t;if(f>0){const i=m.children[f-1];t={offset:i.offset+i.length,length:0,content:","+h}}else m.children.length===0?t={offset:m.offset+1,length:0,content:h}:t={offset:m.offset+1,length:0,content:h+","};return _(k,t,d)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(P!==void 0){const l=`${JSON.stringify(P)}`;let h;if(m.children.length===0||E===0)h={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const f=E===-1||E>m.children.length?m.children.length:E,t=m.children[f-1];h={offset:t.offset+t.length,length:0,content:","+l}}return _(k,h,d)}else{const l=E,h=m.children[l];let f;if(m.children.length===1)f={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const t=m.children[l-1],i=t.offset+t.length,s=m.offset+m.length;f={offset:i,length:s-2-i,content:""}}else f={offset:h.offset,length:m.children[l+1].offset-h.offset,content:""};return _(k,f,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return _(k,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},d)}}e.setProperty=T;function _(k,n,P){let d=S(k,n),g=n.offset,r=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;g>0&&!(0,R.isEOL)(d,g-1);)g--;for(;r<d.length&&!(0,R.isEOL)(d,r);)r++}const a=(0,R.format)(d,{offset:g,length:r-g},P);for(let m=a.length-1;m>=0;m--){const E=a[m];d=S(d,E),g=Math.min(g,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const p=k.length-(d.length-r)-g;return[{offset:g,length:p,content:d.substring(g,r)}]}e.withFormatting=_;function S(k,n){return k.substring(0,n.offset)+n.content+k.substring(n.offset+n.length)}e.applyEdit=S;function y(k,n){let P=n.slice(0).sort((g,r)=>{const a=g.offset-r.offset;return a===0?g.length-r.length:a}),d=k.length;for(let g=P.length-1;g>=0;g--){let r=P[g];if(r.offset+r.length<=d)k=S(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=y}),define(be[110],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(be[6],we([0,1,54,43]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let T=null;function _(l){T=l}if(e.setDisposableTracker=_,D){const l="__is_disposable_tracked__";T=new class{trackDisposable(h){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[l]||console.log(f)},3e3)}markTracked(h){if(h&&h!==a.None)try{h[l]=!0}catch(f){}}}}function S(l){!T||T.markTracked(l)}function y(l){return T&&T.trackDisposable(l),l}e.trackDisposable=y;class k extends Error{constructor(h){super(`Encountered errors while disposing of store. Errors: [${h.join(", ")}]`);this.errors=h}}e.MultiDisposeError=k;function n(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=n;function P(l){if(R.Iterable.is(l)){let h=[];for(const f of l)if(f){S(f);try{f.dispose()}catch(t){h.push(t)}}if(h.length===1)throw h[0];if(h.length>1)throw new k(h);return Array.isArray(l)?[]:l}else if(l)return S(l),l.dispose(),l}e.dispose=P;function d(...l){return l.forEach(S),g(()=>P(l))}e.combinedDisposable=d;function g(l){const h=y({dispose:()=>{S(h),l()}});return h}e.toDisposable=g;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return S(h),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,y(this)}dispose(){S(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){var f;this._isDisposed||h===this._value||((f=this._value)===null||f===void 0||f.dispose(),h&&S(h),this._value=h)}clear(){this.value=void 0}dispose(){var h;this._isDisposed=!0,S(this),(h=this._value)===null||h===void 0||h.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(h,...f){let t=this.references.get(h);t||(t={counter:0,object:this.createReferencedObject(h,...f)},this.references.set(h,t));const{object:i}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(h,t.object),this.references.delete(h))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=m;class E{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=E}),define(be[45],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(T){this.element=T,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let T=this._first;for(;T!==v.Undefined;){const _=T.next;T.prev=v.Undefined,T.next=v.Undefined,T=_}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,_){const S=new v(T);if(this._first===v.Undefined)this._first=S,this._last=S;else if(_){const k=this._last;this._last=S,S.prev=k,k.next=S}else{const k=this._first;this._first=S,S.next=k,k.prev=S}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(S))}}shift(){if(this._first!==v.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==v.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==v.Undefined&&T.next!==v.Undefined){const _=T.prev;_.next=T.next,T.next.prev=_}else T.prev===v.Undefined&&T.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):T.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):T.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==v.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(De,Se){for(var Ce=0;Ce<Se.length;Ce++){var ne=Se[Ce];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(De,ne.key,ne)}}function e(De,Se,Ce){return Se&&J(De.prototype,Se),Ce&&J(De,Ce),De}function v(De,Se){if(!!De){if(typeof De=="string")return R(De,Se);var Ce=Object.prototype.toString.call(De).slice(8,-1);if(Ce==="Object"&&De.constructor&&(Ce=De.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(De);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return R(De,Se)}}function R(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Ce=0,ne=new Array(Se);Ce<Se;Ce++)ne[Ce]=De[Ce];return ne}function D(De,Se){var Ce;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Ce=v(De))||Se&&De&&typeof De.length=="number"){Ce&&(De=Ce);var ne=0;return function(){return ne>=De.length?{done:!0}:{done:!1,value:De[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=De[Symbol.iterator](),Ce.next.bind(Ce)}function T(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var _=T(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ne){De.exports.defaults=ne}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Ce}}),S=/[&<>"']/,y=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Se){return P[Se]};function g(De,Se){if(Se){if(S.test(De))return De.replace(y,d)}else if(k.test(De))return De.replace(n,d);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(De){return De.replace(r,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(De,Se){De=De.source||De,Se=Se||"";var Ce={replace:function(ae,N){return N=N.source||N,N=N.replace(p,"$1"),De=De.replace(ae,N),Ce},getRegex:function(){return new RegExp(De,Se)}};return Ce}var E=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(De,Se,Ce){if(De){var ne;try{ne=decodeURIComponent(a(Ce)).replace(E,"").toLowerCase()}catch(ae){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Se&&!l.test(Ce)&&(Ce=o(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ae){return null}return Ce}var f={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(De,Se){f[" "+De]||(t.test(De)?f[" "+De]=De+"/":f[" "+De]=A(De,"/",!0)),De=f[" "+De];var Ce=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:De.replace(i,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:De.replace(s,"$1")+Se:De+Se}var c={exec:function(){}};function w(De){for(var Se=1,Ce,ne;Se<arguments.length;Se++){Ce=arguments[Se];for(ne in Ce)Object.prototype.hasOwnProperty.call(Ce,ne)&&(De[ne]=Ce[ne])}return De}function b(De,Se){var Ce=De.replace(/\|/g,function(N,Y,re){for(var ke=!1,Ie=Y;--Ie>=0&&re[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),ne=Ce.split(/ \|/),ae=0;if(ne.length>Se)ne.splice(Se);else for(;ne.length<Se;)ne.push("");for(;ae<ne.length;ae++)ne[ae]=ne[ae].trim().replace(/\\\|/g,"|");return ne}function A(De,Se,Ce){var ne=De.length;if(ne===0)return"";for(var ae=0;ae<ne;){var N=De.charAt(ne-ae-1);if(N===Se&&!Ce)ae++;else if(N!==Se&&Ce)ae++;else break}return De.substr(0,ne-ae)}function C(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Ce=De.length,ne=0,ae=0;ae<Ce;ae++)if(De[ae]==="\\")ae++;else if(De[ae]===Se[0])ne++;else if(De[ae]===Se[1]&&(ne--,ne<0))return ae;return-1}function u(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(De,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=De),Se>>=1,De+=De;return Ce+De}var O={escape:g,unescape:a,edit:m,cleanUrl:h,resolveUrl:o,noopTest:c,merge:w,splitCells:b,rtrim:A,findClosingBracket:C,checkSanitizeDeprecation:u,repeatString:F},z=_.defaults,de=O.rtrim,he=O.splitCells,$=O.escape,j=O.findClosingBracket;function W(De,Se,Ce){var ne=Se.href,ae=Se.title?$(Se.title):null,N=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ne,title:ae,text:N}:{type:"image",raw:Ce,href:ne,title:ae,text:$(N)}}function I(De,Se){var Ce=De.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ne=Ce[1];return Se.split(`
`).map(function(ae){var N=ae.match(/^\s+/);if(N===null)return ae;var Y=N[0];return Y.length>=ne.length?ae.slice(ne.length):ae}).join(`
`)}var H=function(){function De(Ce){this.options=Ce||z}var Se=De.prototype;return Se.space=function(ne){var ae=this.rules.block.newline.exec(ne);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(ne){var ae=this.rules.block.code.exec(ne);if(ae){var N=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?N:de(N,`
`)}}},Se.fences=function(ne){var ae=this.rules.block.fences.exec(ne);if(ae){var N=ae[0],Y=I(N,ae[3]||"");return{type:"code",raw:N,lang:ae[2]?ae[2].trim():ae[2],text:Y}}},Se.heading=function(ne){var ae=this.rules.block.heading.exec(ne);if(ae){var N=ae[2].trim();if(/#$/.test(N)){var Y=de(N,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(N=Y.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:N}}},Se.nptable=function(ne){var ae=this.rules.block.nptable.exec(ne);if(ae){var N={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(N.header.length===N.align.length){var Y=N.align.length,re;for(re=0;re<Y;re++)/^ *-+: *$/.test(N.align[re])?N.align[re]="right":/^ *:-+: *$/.test(N.align[re])?N.align[re]="center":/^ *:-+ *$/.test(N.align[re])?N.align[re]="left":N.align[re]=null;for(Y=N.cells.length,re=0;re<Y;re++)N.cells[re]=he(N.cells[re],N.header.length);return N}}},Se.hr=function(ne){var ae=this.rules.block.hr.exec(ne);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(ne){var ae=this.rules.block.blockquote.exec(ne);if(ae){var N=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:N}}},Se.list=function(ne){var ae=this.rules.block.list.exec(ne);if(ae){var N=ae[0],Y=ae[2],re=Y.length>1,ke={type:"list",raw:N,ordered:re,start:re?+Y.slice(0,-1):"",loose:!1,items:[]},Ie=ae[0].match(this.rules.block.item),Oe=!1,Ue,Qe,rt,et,Je,ot,_t,wt,pe=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var ue=0;ue<pe;ue++){if(Ue=Ie[ue],N=Ue,ue!==pe-1){if(et=this.rules.block.listItemStart.exec(Ie[ue+1]),this.options.pedantic?et[1].length>rt[1].length:et[1].length>rt[0].length||et[1].length>3){Ie.splice(ue,2,Ie[ue]+`
`+Ie[ue+1]),ue--,pe--;continue}else(!this.options.pedantic||this.options.smartLists?et[2][et[2].length-1]!==Y[Y.length-1]:re===(et[2].length===1))&&(Je=Ie.slice(ue+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Je.length),ue=pe-1);rt=et}Qe=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Qe-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Oe||/\n\n(?!\s*$)/.test(Ue),ue!==pe-1&&(Oe=Ue.charAt(Ue.length-1)===`
`,ot||(ot=Oe)),ot&&(ke.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Ue),wt=void 0,_t&&(wt=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:_t,checked:wt,loose:ot,text:Ue})}return ke}},Se.html=function(ne){var ae=this.rules.block.html.exec(ne);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):$(ae[0]):ae[0]}},Se.def=function(ne){var ae=this.rules.block.def.exec(ne);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var N=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(ne){var ae=this.rules.block.table.exec(ne);if(ae){var N={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=ae[0];var Y=N.align.length,re;for(re=0;re<Y;re++)/^ *-+: *$/.test(N.align[re])?N.align[re]="right":/^ *:-+: *$/.test(N.align[re])?N.align[re]="center":/^ *:-+ *$/.test(N.align[re])?N.align[re]="left":N.align[re]=null;for(Y=N.cells.length,re=0;re<Y;re++)N.cells[re]=he(N.cells[re].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},Se.lheading=function(ne){var ae=this.rules.block.lheading.exec(ne);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Se.paragraph=function(ne){var ae=this.rules.block.paragraph.exec(ne);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Se.text=function(ne){var ae=this.rules.block.text.exec(ne);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Se.escape=function(ne){var ae=this.rules.inline.escape.exec(ne);if(ae)return{type:"escape",raw:ae[0],text:$(ae[1])}},Se.tag=function(ne,ae,N){var Y=this.rules.inline.tag.exec(ne);if(Y)return!ae&&/^<a /i.test(Y[0])?ae=!0:ae&&/^<\/a>/i.test(Y[0])&&(ae=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:ae,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):$(Y[0]):Y[0]}},Se.link=function(ne){var ae=this.rules.inline.link.exec(ne);if(ae){var N=ae[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var Y=de(N.slice(0,-1),"\\");if((N.length-Y.length)%2==0)return}else{var re=j(ae[2],"()");if(re>-1){var ke=ae[0].indexOf("!")===0?5:4,Ie=ke+ae[1].length+re;ae[2]=ae[2].substring(0,re),ae[0]=ae[0].substring(0,Ie).trim(),ae[3]=""}}var Oe=ae[2],Ue="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);Qe&&(Oe=Qe[1],Ue=Qe[3])}else Ue=ae[3]?ae[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(N)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),W(ae,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},ae[0])}},Se.reflink=function(ne,ae){var N;if((N=this.rules.inline.reflink.exec(ne))||(N=this.rules.inline.nolink.exec(ne))){var Y=(N[2]||N[1]).replace(/\s+/g," ");if(Y=ae[Y.toLowerCase()],!Y||!Y.href){var re=N[0].charAt(0);return{type:"text",raw:re,text:re}}return W(N,Y,N[0])}},Se.emStrong=function(ne,ae,N){N===void 0&&(N="");var Y=this.rules.inline.emStrong.lDelim.exec(ne);if(!!Y&&!(Y[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=Y[1]||Y[2]||"";if(!re||re&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=Y[0].length-1,Ie,Oe,Ue=ke,Qe=0,rt=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ae=ae.slice(-1*ne.length+ke);(Y=rt.exec(ae))!=null;)if(Ie=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!Ie){if(Oe=Ie.length,Y[3]||Y[4]){Ue+=Oe;continue}else if((Y[5]||Y[6])&&ke%3&&!((ke+Oe)%3)){Qe+=Oe;continue}if(Ue-=Oe,!(Ue>0)){if(Ue+Qe-Oe<=0&&!ae.slice(rt.lastIndex).match(rt)&&(Oe=Math.min(Oe,Oe+Ue+Qe)),Math.min(ke,Oe)%2)return{type:"em",raw:ne.slice(0,ke+Y.index+Oe+1),text:ne.slice(1,ke+Y.index+Oe)};if(Math.min(ke,Oe)%2==0)return{type:"strong",raw:ne.slice(0,ke+Y.index+Oe+1),text:ne.slice(2,ke+Y.index+Oe-1)}}}}}},Se.codespan=function(ne){var ae=this.rules.inline.code.exec(ne);if(ae){var N=ae[2].replace(/\n/g," "),Y=/[^ ]/.test(N),re=/^ /.test(N)&&/ $/.test(N);return Y&&re&&(N=N.substring(1,N.length-1)),N=$(N,!0),{type:"codespan",raw:ae[0],text:N}}},Se.br=function(ne){var ae=this.rules.inline.br.exec(ne);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(ne){var ae=this.rules.inline.del.exec(ne);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Se.autolink=function(ne,ae){var N=this.rules.inline.autolink.exec(ne);if(N){var Y,re;return N[2]==="@"?(Y=$(this.options.mangle?ae(N[1]):N[1]),re="mailto:"+Y):(Y=$(N[1]),re=Y),{type:"link",raw:N[0],text:Y,href:re,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.url=function(ne,ae){var N;if(N=this.rules.inline.url.exec(ne)){var Y,re;if(N[2]==="@")Y=$(this.options.mangle?ae(N[0]):N[0]),re="mailto:"+Y;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);Y=$(N[0]),N[1]==="www."?re="http://"+Y:re=Y}return{type:"link",raw:N[0],text:Y,href:re,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.inlineText=function(ne,ae,N){var Y=this.rules.inline.text.exec(ne);if(Y){var re;return ae?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):$(Y[0]):Y[0]:re=$(this.options.smartypants?N(Y[0]):Y[0]),{type:"text",raw:Y[0],text:re}}},De}(),M=O.noopTest,B=O.edit,G=O.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=B(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=B(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=B(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=B(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=B(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=B(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=B(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=G({},q),q.gfm=G({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=B(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=B(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=G({},q.normal,{html:B(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:B(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=B(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=B(q._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=B(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=B(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=B(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=B(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=B(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=B(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=B(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=B(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=G({},se),se.pedantic=G({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:B(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:B(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=G({},se.normal,{escape:B(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=B(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=G({},se.gfm,{br:B(se.br).replace("{2,}","*").getRegex(),text:B(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:q,inline:se},Le=_.defaults,xe=ve.block,Me=ve.inline,ze=O.repeatString;function Ve(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(De){var Se="",Ce,ne,ae=De.length;for(Ce=0;Ce<ae;Ce++)ne=De.charCodeAt(Ce),Math.random()>.5&&(ne="x"+ne.toString(16)),Se+="&#"+ne+";";return Se}var Q=function(){function De(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Le,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ne={block:xe.normal,inline:Me.normal};this.options.pedantic?(ne.block=xe.pedantic,ne.inline=Me.pedantic):this.options.gfm&&(ne.block=xe.gfm,this.options.breaks?ne.inline=Me.breaks:ne.inline=Me.gfm),this.tokenizer.rules=ne}De.lex=function(ne,ae){var N=new De(ae);return N.lex(ne)},De.lexInline=function(ne,ae){var N=new De(ae);return N.inlineTokens(ne)};var Se=De.prototype;return Se.lex=function(ne){return ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(ne,ae,N){ae===void 0&&(ae=[]),N===void 0&&(N=!0),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var Y,re,ke,Ie;ne;){if(Y=this.tokenizer.space(ne)){ne=ne.substring(Y.raw.length),Y.type&&ae.push(Y);continue}if(Y=this.tokenizer.code(ne)){ne=ne.substring(Y.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Y.raw,Ie.text+=`
`+Y.text):ae.push(Y);continue}if(Y=this.tokenizer.fences(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.heading(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.nptable(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.hr(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.blockquote(ne)){ne=ne.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],N),ae.push(Y);continue}if(Y=this.tokenizer.list(ne)){for(ne=ne.substring(Y.raw.length),ke=Y.items.length,re=0;re<ke;re++)Y.items[re].tokens=this.blockTokens(Y.items[re].text,[],!1);ae.push(Y);continue}if(Y=this.tokenizer.html(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(N&&(Y=this.tokenizer.def(ne))){ne=ne.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.lheading(ne)){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(N&&(Y=this.tokenizer.paragraph(ne))){ne=ne.substring(Y.raw.length),ae.push(Y);continue}if(Y=this.tokenizer.text(ne)){ne=ne.substring(Y.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Y.raw,Ie.text+=`
`+Y.text):ae.push(Y);continue}if(ne){var Oe="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return ae},Se.inline=function(ne){var ae,N,Y,re,ke,Ie,Oe=ne.length;for(ae=0;ae<Oe;ae++)switch(Ie=ne[ae],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},re=Ie.header.length,N=0;N<re;N++)Ie.tokens.header[N]=[],this.inlineTokens(Ie.header[N],Ie.tokens.header[N]);for(re=Ie.cells.length,N=0;N<re;N++)for(ke=Ie.cells[N],Ie.tokens.cells[N]=[],Y=0;Y<ke.length;Y++)Ie.tokens.cells[N][Y]=[],this.inlineTokens(ke[Y],Ie.tokens.cells[N][Y]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(re=Ie.items.length,N=0;N<re;N++)this.inline(Ie.items[N].tokens);break}}return ne},Se.inlineTokens=function(ne,ae,N,Y){ae===void 0&&(ae=[]),N===void 0&&(N=!1),Y===void 0&&(Y=!1);var re,ke,Ie=ne,Oe,Ue,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Oe.index)+"["+ze("a",Oe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Oe.index)+"["+ze("a",Oe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Oe.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;){if(Ue||(Qe=""),Ue=!1,re=this.tokenizer.escape(ne)){ne=ne.substring(re.raw.length),ae.push(re);continue}if(re=this.tokenizer.tag(ne,N,Y)){ne=ne.substring(re.raw.length),N=re.inLink,Y=re.inRawBlock;var et=ae[ae.length-1];et&&re.type==="text"&&et.type==="text"?(et.raw+=re.raw,et.text+=re.text):ae.push(re);continue}if(re=this.tokenizer.link(ne)){ne=ne.substring(re.raw.length),re.type==="link"&&(re.tokens=this.inlineTokens(re.text,[],!0,Y)),ae.push(re);continue}if(re=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(re.raw.length);var Je=ae[ae.length-1];re.type==="link"?(re.tokens=this.inlineTokens(re.text,[],!0,Y),ae.push(re)):Je&&re.type==="text"&&Je.type==="text"?(Je.raw+=re.raw,Je.text+=re.text):ae.push(re);continue}if(re=this.tokenizer.emStrong(ne,Ie,Qe)){ne=ne.substring(re.raw.length),re.tokens=this.inlineTokens(re.text,[],N,Y),ae.push(re);continue}if(re=this.tokenizer.codespan(ne)){ne=ne.substring(re.raw.length),ae.push(re);continue}if(re=this.tokenizer.br(ne)){ne=ne.substring(re.raw.length),ae.push(re);continue}if(re=this.tokenizer.del(ne)){ne=ne.substring(re.raw.length),re.tokens=this.inlineTokens(re.text,[],N,Y),ae.push(re);continue}if(re=this.tokenizer.autolink(ne,x)){ne=ne.substring(re.raw.length),ae.push(re);continue}if(!N&&(re=this.tokenizer.url(ne,x))){ne=ne.substring(re.raw.length),ae.push(re);continue}if(re=this.tokenizer.inlineText(ne,Y,Ve)){ne=ne.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(Qe=re.raw.slice(-1)),Ue=!0,ke=ae[ae.length-1],ke&&ke.type==="text"?(ke.raw+=re.raw,ke.text+=re.text):ae.push(re);continue}if(ne){var ot="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return ae},e(De,null,[{key:"rules",get:function(){return{block:xe,inline:Me}}}]),De}(),te=_.defaults,ie=O.cleanUrl,fe=O.escape,Ee=function(){function De(Ce){this.options=Ce||te}var Se=De.prototype;return Se.code=function(ne,ae,N){var Y=(ae||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(ne,Y);re!=null&&re!==ne&&(N=!0,ne=re)}return ne=ne.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+fe(Y,!0)+'">'+(N?ne:fe(ne,!0))+`</code></pre>
`:"<pre><code>"+(N?ne:fe(ne,!0))+`</code></pre>
`},Se.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Se.html=function(ne){return ne},Se.heading=function(ne,ae,N,Y){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+Y.slug(N)+'">'+ne+"</h"+ae+`>
`:"<h"+ae+">"+ne+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ne,ae,N){var Y=ae?"ol":"ul",re=ae&&N!==1?' start="'+N+'"':"";return"<"+Y+re+`>
`+ne+"</"+Y+`>
`},Se.listitem=function(ne){return"<li>"+ne+`</li>
`},Se.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ne){return"<p>"+ne+`</p>
`},Se.table=function(ne,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ae+`</table>
`},Se.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Se.tablecell=function(ne,ae){var N=ae.header?"th":"td",Y=ae.align?"<"+N+' align="'+ae.align+'">':"<"+N+">";return Y+ne+"</"+N+`>
`},Se.strong=function(ne){return"<strong>"+ne+"</strong>"},Se.em=function(ne){return"<em>"+ne+"</em>"},Se.codespan=function(ne){return"<code>"+ne+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ne){return"<del>"+ne+"</del>"},Se.link=function(ne,ae,N){if(ne=ie(this.options.sanitize,this.options.baseUrl,ne),ne===null)return N;var Y='<a href="'+fe(ne)+'"';return ae&&(Y+=' title="'+ae+'"'),Y+=">"+N+"</a>",Y},Se.image=function(ne,ae,N){if(ne=ie(this.options.sanitize,this.options.baseUrl,ne),ne===null)return N;var Y='<img src="'+ne+'" alt="'+N+'"';return ae&&(Y+=' title="'+ae+'"'),Y+=this.options.xhtml?"/>":">",Y},Se.text=function(ne){return ne},De}(),le=function(){function De(){}var Se=De.prototype;return Se.strong=function(ne){return ne},Se.em=function(ne){return ne},Se.codespan=function(ne){return ne},Se.del=function(ne){return ne},Se.html=function(ne){return ne},Se.text=function(ne){return ne},Se.link=function(ne,ae,N){return""+N},Se.image=function(ne,ae,N){return""+N},Se.br=function(){return""},De}(),_e=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ne,ae){var N=ne,Y=0;if(this.seen.hasOwnProperty(N)){Y=this.seen[ne];do Y++,N=ne+"-"+Y;while(this.seen.hasOwnProperty(N))}return ae||(this.seen[ne]=Y,this.seen[N]=0),N},Se.slug=function(ne,ae){ae===void 0&&(ae={});var N=this.serialize(ne);return this.getNextSafeSlug(N,ae.dryrun)},De}(),Ae=_.defaults,We=O.unescape,ge=function(){function De(Ce){this.options=Ce||Ae,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _e}De.parse=function(ne,ae){var N=new De(ae);return N.parse(ne)},De.parseInline=function(ne,ae){var N=new De(ae);return N.parseInline(ne)};var Se=De.prototype;return Se.parse=function(ne,ae){ae===void 0&&(ae=!0);var N="",Y,re,ke,Ie,Oe,Ue,Qe,rt,et,Je,ot,_t,wt,pe,ue,oe,K,Re,Te=ne.length;for(Y=0;Y<Te;Y++)switch(Je=ne[Y],Je.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,We(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",Qe="",Ie=Je.header.length,re=0;re<Ie;re++)Qe+=this.renderer.tablecell(this.parseInline(Je.tokens.header[re]),{header:!0,align:Je.align[re]});for(rt+=this.renderer.tablerow(Qe),et="",Ie=Je.cells.length,re=0;re<Ie;re++){for(Ue=Je.tokens.cells[re],Qe="",Oe=Ue.length,ke=0;ke<Oe;ke++)Qe+=this.renderer.tablecell(this.parseInline(Ue[ke]),{header:!1,align:Je.align[ke]});et+=this.renderer.tablerow(Qe)}N+=this.renderer.table(rt,et);continue}case"blockquote":{et=this.parse(Je.tokens),N+=this.renderer.blockquote(et);continue}case"list":{for(ot=Je.ordered,_t=Je.start,wt=Je.loose,Ie=Je.items.length,et="",re=0;re<Ie;re++)ue=Je.items[re],oe=ue.checked,K=ue.task,pe="",ue.task&&(Re=this.renderer.checkbox(oe),wt?ue.tokens.length>0&&ue.tokens[0].type==="text"?(ue.tokens[0].text=Re+" "+ue.tokens[0].text,ue.tokens[0].tokens&&ue.tokens[0].tokens.length>0&&ue.tokens[0].tokens[0].type==="text"&&(ue.tokens[0].tokens[0].text=Re+" "+ue.tokens[0].tokens[0].text)):ue.tokens.unshift({type:"text",text:Re}):pe+=Re),pe+=this.parse(ue.tokens,wt),et+=this.renderer.listitem(pe,K,oe);N+=this.renderer.list(et,ot,_t);continue}case"html":{N+=this.renderer.html(Je.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(et=Je.tokens?this.parseInline(Je.tokens):Je.text;Y+1<Te&&ne[Y+1].type==="text";)Je=ne[++Y],et+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);N+=ae?this.renderer.paragraph(et):et;continue}default:{var Xe='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}return N},Se.parseInline=function(ne,ae){ae=ae||this.renderer;var N="",Y,re,ke=ne.length;for(Y=0;Y<ke;Y++)switch(re=ne[Y],re.type){case"escape":{N+=ae.text(re.text);break}case"html":{N+=ae.html(re.text);break}case"link":{N+=ae.link(re.href,re.title,this.parseInline(re.tokens,ae));break}case"image":{N+=ae.image(re.href,re.title,re.text);break}case"strong":{N+=ae.strong(this.parseInline(re.tokens,ae));break}case"em":{N+=ae.em(this.parseInline(re.tokens,ae));break}case"codespan":{N+=ae.codespan(re.text);break}case"br":{N+=ae.br();break}case"del":{N+=ae.del(this.parseInline(re.tokens,ae));break}case"text":{N+=ae.text(re.text);break}default:{var Ie='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return N},De}(),Ge=O.merge,V=O.checkSanitizeDeprecation,ee=O.escape,me=_.getDefaults,Ne=_.changeDefaults,He=_.defaults;function $e(De,Se,Ce){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=Ge({},$e.defaults,Se||{}),V(Se),Ce){var ne=Se.highlight,ae;try{ae=Q.lex(De,Se)}catch(ke){return Ce(ke)}var N=function(Ie){var Oe;if(!Ie)try{Oe=ge.parse(ae,Se)}catch(Ue){Ie=Ue}return Se.highlight=ne,Ie?Ce(Ie):Ce(null,Oe)};if(!ne||ne.length<3||(delete Se.highlight,!ae.length))return N();var Y=0;$e.walkTokens(ae,function(ke){ke.type==="code"&&(Y++,setTimeout(function(){ne(ke.text,ke.lang,function(Ie,Oe){if(Ie)return N(Ie);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),Y--,Y===0&&N()})},0))}),Y===0&&N();return}try{var re=Q.lex(De,Se);return Se.walkTokens&&$e.walkTokens(re,Se.walkTokens),ge.parse(re,Se)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ee(ke.message+"",!0)+"</pre>";throw ke}}$e.options=$e.setOptions=function(De){return Ge($e.defaults,De),Ne($e.defaults),$e},$e.getDefaults=me,$e.defaults=He,$e.use=function(De){var Se=Ge({},De);if(De.renderer&&function(){var ne=$e.defaults.renderer||new Ee,ae=function(re){var ke=ne[re];ne[re]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),Ue=0;Ue<Ie;Ue++)Oe[Ue]=arguments[Ue];var Qe=De.renderer[re].apply(ne,Oe);return Qe===!1&&(Qe=ke.apply(ne,Oe)),Qe}};for(var N in De.renderer)ae(N);Se.renderer=ne}(),De.tokenizer&&function(){var ne=$e.defaults.tokenizer||new H,ae=function(re){var ke=ne[re];ne[re]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),Ue=0;Ue<Ie;Ue++)Oe[Ue]=arguments[Ue];var Qe=De.tokenizer[re].apply(ne,Oe);return Qe===!1&&(Qe=ke.apply(ne,Oe)),Qe}};for(var N in De.tokenizer)ae(N);Se.tokenizer=ne}(),De.walkTokens){var Ce=$e.defaults.walkTokens;Se.walkTokens=function(ne){De.walkTokens(ne),Ce&&Ce(ne)}}$e.setOptions(Se)},$e.walkTokens=function(De,Se){for(var Ce=D(De),ne;!(ne=Ce()).done;){var ae=ne.value;switch(Se(ae),ae.type){case"table":{for(var N=D(ae.tokens.header),Y;!(Y=N()).done;){var re=Y.value;$e.walkTokens(re,Se)}for(var ke=D(ae.tokens.cells),Ie;!(Ie=ke()).done;)for(var Oe=Ie.value,Ue=D(Oe),Qe;!(Qe=Ue()).done;){var rt=Qe.value;$e.walkTokens(rt,Se)}break}case"list":{$e.walkTokens(ae.items,Se);break}default:ae.tokens&&$e.walkTokens(ae.tokens,Se)}}},$e.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=Ge({},$e.defaults,Se||{}),V(Se);try{var Ce=Q.lexInline(De,Se);return Se.walkTokens&&$e.walkTokens(Ce,Se.walkTokens),ge.parseInline(Ce,Se)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ee(ne.message+"",!0)+"</pre>";throw ne}},$e.Parser=ge,$e.parser=ge.parse,$e.Renderer=Ee,$e.TextRenderer=le,$e.Lexer=Q,$e.lexer=Q.lex,$e.Tokenizer=H,$e.Slugger=_e,$e.parse=$e;var Ye=$e;return Ye}),define(be[81],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(_,S,y){return Math.min(Math.max(_,S),y)}e.clamp=v;function R(_,S){return(S+_%S)%S}e.rot=R;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class T{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function J(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function _(y){T.push(y,Date.now())}function S(){const y=[];for(let k=0;k<T.length;k+=2)y.push({name:T[k],startTime:T[k+1]});return y}return{mark:_,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const _ of performance.getEntriesByType("mark"))T.push({name:_.name,startTime:Math.round(D+_.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(be[21],we([0,1]),function(J,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let D=!1,T=!1,_=!1,S=!1,y=!1,k=!1,n=!1,P,d=R,g,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const p=typeof((v=a==null?void 0:a.versions)===null||v===void 0?void 0:v.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=p&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,D=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,n=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=r.indexOf("Linux")>=0,k=!0,P=navigator.language,d=P;else if(typeof a=="object"){D=a.platform==="win32",T=a.platform==="darwin",_=a.platform==="linux",S=_&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,P=R,d=R;const o=a.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),w=c.availableLanguages["*"];P=c.locale,d=w||R,g=c._translationsConfigFile}catch(c){}y=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function E(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let l=0;T?l=1:D?l=3:_&&(l=2),e.isWindows=D,e.isMacintosh=T,e.isLinux=_,e.isLinuxSnap=S,e.isNative=y,e.isWeb=k,e.isIOS=n,e.platform=l,e.userAgent=r,e.language=d;var h;(function(o){function c(){return e.language}o.value=c;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=w;function b(){return e.language==="en"}o.isDefault=b})(h=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let C=0,u=w.length;C<u;C++){const F=w[C];if(F.id===A.data.vscodeSetImmediateId){w.splice(C,1),F.callback();return}}});let b=0;return A=>{const C=++b;w.push({id:C,callback:A}),e.globals.postMessage({vscodeSetImmediateId:C},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const c=Promise.resolve();return w=>c.then(w)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||n?2:D?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(be[46],we([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,v.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(D){return(0,v.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[14],we([0,1,46]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,T=90,_=122,S=46,y=47,k=92,n=58,P=63;class d extends Error{constructor(h,f,t){let i;typeof f=="string"&&f.indexOf("not ")===0?(i="must not be",f=f.replace(/^not /,"")):i="must be";const s=h.indexOf(".")!==-1?"property":"argument";let o=`The "${h}" ${s} ${i} of type ${f}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(l,h){if(typeof l!="string")throw new d(h,"string",l)}function r(l){return l===y||l===k}function a(l){return l===y}function p(l){return l>=R&&l<=T||l>=D&&l<=_}function m(l,h,f,t){let i="",s=0,o=-1,c=0,w=0;for(let b=0;b<=l.length;++b){if(b<l.length)w=l.charCodeAt(b);else{if(t(w))break;w=y}if(t(w)){if(!(o===b-1||c===1))if(c===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==S||i.charCodeAt(i.length-2)!==S){if(i.length>2){const A=i.lastIndexOf(f);A===-1?(i="",s=0):(i=i.slice(0,A),s=i.length-1-i.lastIndexOf(f)),o=b,c=0;continue}else if(i.length!==0){i="",s=0,o=b,c=0;continue}}h&&(i+=i.length>0?`${f}..`:"..",s=2)}else i.length>0?i+=`${f}${l.slice(o+1,b)}`:i=l.slice(o+1,b),s=b-o-1;o=b,c=0}else w===S&&c!==-1?++c:c=-1}return i}function E(l,h){if(h===null||typeof h!="object")throw new d("pathObject","Object",h);const f=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${t}`:`${f}${l}${t}`:t}e.win32={resolve(...l){let h="",f="",t=!1;for(let i=l.length-1;i>=-1;i--){let s;if(i>=0){if(s=l[i],g(s,"path"),s.length===0)continue}else h.length===0?s=v.cwd():(s=v.env[`=${h}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${h}\\`));const o=s.length;let c=0,w="",b=!1;const A=s.charCodeAt(0);if(o===1)r(A)&&(c=1,b=!0);else if(r(A))if(b=!0,r(s.charCodeAt(1))){let C=2,u=C;for(;C<o&&!r(s.charCodeAt(C));)C++;if(C<o&&C!==u){const F=s.slice(u,C);for(u=C;C<o&&r(s.charCodeAt(C));)C++;if(C<o&&C!==u){for(u=C;C<o&&!r(s.charCodeAt(C));)C++;(C===o||C!==u)&&(w=`\\\\${F}\\${s.slice(u,C)}`,c=C)}}}else c=1;else p(A)&&s.charCodeAt(1)===n&&(w=s.slice(0,2),c=2,o>2&&r(s.charCodeAt(2))&&(b=!0,c=3));if(w.length>0)if(h.length>0){if(w.toLowerCase()!==h.toLowerCase())continue}else h=w;if(t){if(h.length>0)break}else if(f=`${s.slice(c)}\\${f}`,t=b,b&&h.length>0)break}return f=m(f,!t,"\\",r),t?`${h}\\${f}`:`${h}${f}`||"."},normalize(l){g(l,"path");const h=l.length;if(h===0)return".";let f=0,t,i=!1;const s=l.charCodeAt(0);if(h===1)return a(s)?"\\":l;if(r(s))if(i=!0,r(l.charCodeAt(1))){let c=2,w=c;for(;c<h&&!r(l.charCodeAt(c));)c++;if(c<h&&c!==w){const b=l.slice(w,c);for(w=c;c<h&&r(l.charCodeAt(c));)c++;if(c<h&&c!==w){for(w=c;c<h&&!r(l.charCodeAt(c));)c++;if(c===h)return`\\\\${b}\\${l.slice(w)}\\`;c!==w&&(t=`\\\\${b}\\${l.slice(w,c)}`,f=c)}}}else f=1;else p(s)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),f=2,h>2&&r(l.charCodeAt(2))&&(i=!0,f=3));let o=f<h?m(l.slice(f),!i,"\\",r):"";return o.length===0&&!i&&(o="."),o.length>0&&r(l.charCodeAt(h-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(l){g(l,"path");const h=l.length;if(h===0)return!1;const f=l.charCodeAt(0);return r(f)||h>2&&p(f)&&l.charCodeAt(1)===n&&r(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let h,f;for(let s=0;s<l.length;++s){const o=l[s];g(o,"path"),o.length>0&&(h===void 0?h=f=o:h+=`\\${o}`)}if(h===void 0)return".";let t=!0,i=0;if(typeof f=="string"&&r(f.charCodeAt(0))){++i;const s=f.length;s>1&&r(f.charCodeAt(1))&&(++i,s>2&&(r(f.charCodeAt(2))?++i:t=!1))}if(t){for(;i<h.length&&r(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(l,h){if(g(l,"from"),g(h,"to"),l===h)return"";const f=e.win32.resolve(l),t=e.win32.resolve(h);if(f===t||(l=f.toLowerCase(),h=t.toLowerCase(),l===h))return"";let i=0;for(;i<l.length&&l.charCodeAt(i)===k;)i++;let s=l.length;for(;s-1>i&&l.charCodeAt(s-1)===k;)s--;const o=s-i;let c=0;for(;c<h.length&&h.charCodeAt(c)===k;)c++;let w=h.length;for(;w-1>c&&h.charCodeAt(w-1)===k;)w--;const b=w-c,A=o<b?o:b;let C=-1,u=0;for(;u<A;u++){const O=l.charCodeAt(i+u);if(O!==h.charCodeAt(c+u))break;O===k&&(C=u)}if(u!==A){if(C===-1)return t}else{if(b>A){if(h.charCodeAt(c+u)===k)return t.slice(c+u+1);if(u===2)return t.slice(c+u)}o>A&&(l.charCodeAt(i+u)===k?C=u:u===2&&(C=3)),C===-1&&(C=0)}let F="";for(u=i+C+1;u<=s;++u)(u===s||l.charCodeAt(u)===k)&&(F+=F.length===0?"..":"\\..");return c+=C,F.length>0?`${F}${t.slice(c,w)}`:(t.charCodeAt(c)===k&&++c,t.slice(c,w))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const h=e.win32.resolve(l);if(h.length<=2)return l;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const f=h.charCodeAt(2);if(f!==P&&f!==S)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(p(h.charCodeAt(0))&&h.charCodeAt(1)===n&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return l},dirname(l){g(l,"path");const h=l.length;if(h===0)return".";let f=-1,t=0;const i=l.charCodeAt(0);if(h===1)return r(i)?l:".";if(r(i)){if(f=t=1,r(l.charCodeAt(1))){let c=2,w=c;for(;c<h&&!r(l.charCodeAt(c));)c++;if(c<h&&c!==w){for(w=c;c<h&&r(l.charCodeAt(c));)c++;if(c<h&&c!==w){for(w=c;c<h&&!r(l.charCodeAt(c));)c++;if(c===h)return l;c!==w&&(f=t=c+1)}}}}else p(i)&&l.charCodeAt(1)===n&&(f=h>2&&r(l.charCodeAt(2))?3:2,t=f);let s=-1,o=!0;for(let c=h-1;c>=t;--c)if(r(l.charCodeAt(c))){if(!o){s=c;break}}else o=!1;if(s===-1){if(f===-1)return".";s=f}return l.slice(0,s)},basename(l,h){h!==void 0&&g(h,"ext"),g(l,"path");let f=0,t=-1,i=!0,s;if(l.length>=2&&p(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(f=2),h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let o=h.length-1,c=-1;for(s=l.length-1;s>=f;--s){const w=l.charCodeAt(s);if(r(w)){if(!i){f=s+1;break}}else c===-1&&(i=!1,c=s+1),o>=0&&(w===h.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=c))}return f===t?t=c:t===-1&&(t=l.length),l.slice(f,t)}for(s=l.length-1;s>=f;--s)if(r(l.charCodeAt(s))){if(!i){f=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(f,t)},extname(l){g(l,"path");let h=0,f=-1,t=0,i=-1,s=!0,o=0;l.length>=2&&l.charCodeAt(1)===n&&p(l.charCodeAt(0))&&(h=t=2);for(let c=l.length-1;c>=h;--c){const w=l.charCodeAt(c);if(r(w)){if(!s){t=c+1;break}continue}i===-1&&(s=!1,i=c+1),w===S?f===-1?f=c:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||i===-1||o===0||o===1&&f===i-1&&f===t+1?"":l.slice(f,i)},format:E.bind(null,"\\"),parse(l){g(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const f=l.length;let t=0,i=l.charCodeAt(0);if(f===1)return r(i)?(h.root=h.dir=l,h):(h.base=h.name=l,h);if(r(i)){if(t=1,r(l.charCodeAt(1))){let C=2,u=C;for(;C<f&&!r(l.charCodeAt(C));)C++;if(C<f&&C!==u){for(u=C;C<f&&r(l.charCodeAt(C));)C++;if(C<f&&C!==u){for(u=C;C<f&&!r(l.charCodeAt(C));)C++;C===f?t=C:C!==u&&(t=C+1)}}}}else if(p(i)&&l.charCodeAt(1)===n){if(f<=2)return h.root=h.dir=l,h;if(t=2,r(l.charCodeAt(2))){if(f===3)return h.root=h.dir=l,h;t=3}}t>0&&(h.root=l.slice(0,t));let s=-1,o=t,c=-1,w=!0,b=l.length-1,A=0;for(;b>=t;--b){if(i=l.charCodeAt(b),r(i)){if(!w){o=b+1;break}continue}c===-1&&(w=!1,c=b+1),i===S?s===-1?s=b:A!==1&&(A=1):s!==-1&&(A=-1)}return c!==-1&&(s===-1||A===0||A===1&&s===c-1&&s===o+1?h.base=h.name=l.slice(o,c):(h.name=l.slice(o,s),h.base=l.slice(o,c),h.ext=l.slice(s,c))),o>0&&o!==t?h.dir=l.slice(0,o-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let h="",f=!1;for(let t=l.length-1;t>=-1&&!f;t--){const i=t>=0?l[t]:v.cwd();g(i,"path"),i.length!==0&&(h=`${i}/${h}`,f=i.charCodeAt(0)===y)}return h=m(h,!f,"/",a),f?`/${h}`:h.length>0?h:"."},normalize(l){if(g(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===y,f=l.charCodeAt(l.length-1)===y;return l=m(l,!h,"/",a),l.length===0?h?"/":f?"./":".":(f&&(l+="/"),h?`/${l}`:l)},isAbsolute(l){return g(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let h;for(let f=0;f<l.length;++f){const t=l[f];g(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(l,h){if(g(l,"from"),g(h,"to"),l===h||(l=e.posix.resolve(l),h=e.posix.resolve(h),l===h))return"";const f=1,t=l.length,i=t-f,s=1,o=h.length-s,c=i<o?i:o;let w=-1,b=0;for(;b<c;b++){const C=l.charCodeAt(f+b);if(C!==h.charCodeAt(s+b))break;C===y&&(w=b)}if(b===c)if(o>c){if(h.charCodeAt(s+b)===y)return h.slice(s+b+1);if(b===0)return h.slice(s+b)}else i>c&&(l.charCodeAt(f+b)===y?w=b:b===0&&(w=0));let A="";for(b=f+w+1;b<=t;++b)(b===t||l.charCodeAt(b)===y)&&(A+=A.length===0?"..":"/..");return`${A}${h.slice(s+w)}`},toNamespacedPath(l){return l},dirname(l){if(g(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===y;let f=-1,t=!0;for(let i=l.length-1;i>=1;--i)if(l.charCodeAt(i)===y){if(!t){f=i;break}}else t=!1;return f===-1?h?"/":".":h&&f===1?"//":l.slice(0,f)},basename(l,h){h!==void 0&&g(h,"ext"),g(l,"path");let f=0,t=-1,i=!0,s;if(h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let o=h.length-1,c=-1;for(s=l.length-1;s>=0;--s){const w=l.charCodeAt(s);if(w===y){if(!i){f=s+1;break}}else c===-1&&(i=!1,c=s+1),o>=0&&(w===h.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=c))}return f===t?t=c:t===-1&&(t=l.length),l.slice(f,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===y){if(!i){f=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(f,t)},extname(l){g(l,"path");let h=-1,f=0,t=-1,i=!0,s=0;for(let o=l.length-1;o>=0;--o){const c=l.charCodeAt(o);if(c===y){if(!i){f=o+1;break}continue}t===-1&&(i=!1,t=o+1),c===S?h===-1?h=o:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===f+1?"":l.slice(h,t)},format:E.bind(null,"/"),parse(l){g(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const f=l.charCodeAt(0)===y;let t;f?(h.root="/",t=1):t=0;let i=-1,s=0,o=-1,c=!0,w=l.length-1,b=0;for(;w>=t;--w){const A=l.charCodeAt(w);if(A===y){if(!c){s=w+1;break}continue}o===-1&&(c=!1,o=w+1),A===S?i===-1?i=w:b!==1&&(b=1):i!==-1&&(b=-1)}if(o!==-1){const A=s===0&&f?1:s;i===-1||b===0||b===1&&i===o-1&&i===s+1?h.base=h.name=l.slice(A,o):(h.name=l.slice(A,i),h.base=l.slice(A,o),h.ext=l.slice(i,o))}return s>0?h.dir=l.slice(0,s-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],we([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(_){this._highResolution=R&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new D(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(be[3],we([0,1,12,54,6,45,56]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(m){m.None=()=>D.Disposable.None;function E($){return(j,W=null,I)=>{let H=!1,M;return M=$(B=>{if(!H)return M?M.dispose():H=!0,j.call(W,B)},null,I),H&&M.dispose(),M}}m.once=E;function l($,j){return o((W,I=null,H)=>$(M=>W.call(I,j(M)),null,H))}m.map=l;function h($,j){return o((W,I=null,H)=>$(M=>{j(M),W.call(I,M)},null,H))}m.forEach=h;function f($,j){return o((W,I=null,H)=>$(M=>j(M)&&W.call(I,M),null,H))}m.filter=f;function t($){return $}m.signal=t;function i(...$){return(j,W=null,I)=>(0,D.combinedDisposable)(...$.map(H=>H(M=>j.call(W,M),null,I)))}m.any=i;function s($,j,W){let I=W;return l($,H=>(I=j(I,H),I))}m.reduce=s;function o($){let j;const W=new d({onFirstListenerAdd(){j=$(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}m.snapshot=o;function c($,j,W=100,I=!1,H){let M,B,G,q=0;const se=new d({leakWarningThreshold:H,onFirstListenerAdd(){M=$(ve=>{q++,B=j(B,ve),I&&!G&&(se.fire(B),B=void 0),clearTimeout(G),G=setTimeout(()=>{const Le=B;B=void 0,G=void 0,(!I||q>1)&&se.fire(Le),q=0},W)})},onLastListenerRemove(){M.dispose()}});return se.event}m.debounce=c;function w($){const j=new Date().getTime();return l(E($),W=>new Date().getTime()-j)}m.stopwatch=w;function b($,j=(W,I)=>W===I){let W=!0,I;return f($,H=>{const M=W||!j(H,I);return W=!1,I=H,M})}m.latch=b;function A($,j){return[m.filter($,j),m.filter($,W=>!j(W))]}m.split=A;function C($,j=!1,W=[]){let I=W.slice(),H=$(G=>{I?I.push(G):B.fire(G)});const M=()=>{I&&I.forEach(G=>B.fire(G)),I=null},B=new d({onFirstListenerAdd(){H||(H=$(G=>B.fire(G)))},onFirstListenerDidAdd(){I&&(j?setTimeout(M):M())},onLastListenerRemove(){H&&H.dispose(),H=null}});return B.event}m.buffer=C;class u{constructor(j){this.event=j}map(j){return new u(l(this.event,j))}forEach(j){return new u(h(this.event,j))}filter(j){return new u(f(this.event,j))}reduce(j,W){return new u(s(this.event,j,W))}latch(){return new u(b(this.event))}debounce(j,W=100,I=!1,H){return new u(c(this.event,j,W,I,H))}on(j,W,I){return this.event(j,W,I)}once(j,W,I){return E(this.event)(j,W,I)}}function F($){return new u($)}m.chain=F;function O($,j,W=I=>I){const I=(...G)=>B.fire(W(...G)),H=()=>$.on(j,I),M=()=>$.removeListener(j,I),B=new d({onFirstListenerAdd:H,onLastListenerRemove:M});return B.event}m.fromNodeEventEmitter=O;function z($,j,W=I=>I){const I=(...G)=>B.fire(W(...G)),H=()=>$.addEventListener(j,I),M=()=>$.removeEventListener(j,I),B=new d({onFirstListenerAdd:H,onLastListenerRemove:M});return B.event}m.fromDOMEventEmitter=z;function de($){const j=new d;let W=!1;return $.then(void 0,()=>null).then(()=>{W?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),W=!0,j.event}m.fromPromise=de;function he($){return new Promise(j=>E($)(j))}m.toPromise=he})(S=e.Event||(e.Event={}));class y{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${y._idPool++}`}start(E){this._stopWatch=new _.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let k=-1;function n(m){const E=k;return k=m,{dispose(){k=E}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(E,l=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let l=k;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||E<l)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(h)||0;if(this._stacks.set(h,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,i=0;for(const[s,o]of this._stacks)(!t||i<o)&&(t=s,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(h)||0;this._stacks.set(h,t-1)}}}class d{constructor(E){var l;this._disposed=!1,this._options=E,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(E,l,h)=>{var f;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(l?[E,l]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,l);const s=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},h instanceof D.DisposableStore?h.add(o):Array.isArray(h)&&h.push(o),o}),this._event}fire(E){var l,h;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,E]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(i){(0,v.onUnexpectedError)(i)}}(h=this._perfMon)===null||h===void 0||h.stop()}}dispose(){var E,l,h,f,t;this._disposed||(this._disposed=!0,(E=this._listeners)===null||E===void 0||E.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(f=(h=this._options)===null||h===void 0?void 0:h.onLastListenerRemove)===null||f===void 0||f.call(h),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class g extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const l={event:E,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const f=this.events.indexOf(l);this.events.splice(f,1)};return(0,D.toDisposable)((0,R.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(l=>this.emitter.fire(l))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(E){return(l,h,f)=>E(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>l.call(h,t)):l.call(h,t)},void 0,f)}bufferEvents(E){const l=[];this.buffers.push(l);const h=E();return this.buffers.pop(),l.forEach(f=>f()),h}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(be[20],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(S,y){const k=setTimeout(S.bind(y),0);return{dispose(){clearTimeout(k)}}});var D;(function(S){function y(k){return k===S.None||k===S.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}S.isCancellationToken=y,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=_}),define(be[35],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function T(n,P){return new S(n,P)}e.registerCodicon=T;function _(n){return n?n.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=_;class S{constructor(P,d,g){this.id=P,this.definition=d,this.description=g,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function y(n,P){const d=["codicon","codicon-"+n];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=y;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(a){if(a instanceof S)return["codicon","codicon-"+a.id];const p=P.exec(a.id);if(!p)return d(S.error);let[,m,E]=p;const l=["codicon","codicon-"+m];return E&&l.push("codicon-modifier-"+E.substr(1)),l}n.asClassNameArray=d;function g(a){return d(a).join(" ")}n.asClassName=g;function r(a){return"."+d(a).join(".")}n.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[111],we([0,1,12,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=D;function T(l){const h=l;return h?D(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=T;function _(l,h){return new S(l,h)}e.newWriteableStream=_;class S{constructor(h,f){this.reducer=h,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(f=>f(h))}emitError(h){this.listeners.error.length===0?(0,v.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(f=>f(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,f){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(h,f){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(f);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(l,h){const f=[];let t;for(;(t=l.read())!==null;)f.push(t);return h(f)}e.consumeReadable=y;function k(l,h,f){const t=[];let i;for(;(i=l.read())!==null&&t.length<f;)t.push(i);return i===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return l.read()}}}e.peekReadable=k;function n(l,h){return new Promise((f,t)=>{const i=[];P(l,{onData:s=>{h&&i.push(s)},onError:s=>{h?t(s):f(void 0)},onEnd:()=>{f(h?h(i):void 0)}})})}e.consumeStream=n;function P(l,h){l.on("error",f=>h.onError(f)),l.on("end",()=>h.onEnd()),l.on("data",f=>h.onData(f))}e.listenStream=P;function d(l,h){return new Promise((f,t)=>{const i=new R.DisposableStore,s=[],o=b=>{if(s.push(b),s.length>h)return i.dispose(),l.pause(),f({stream:l,buffer:s,ended:!1})},c=b=>t(b),w=()=>f({stream:l,buffer:s,ended:!0});i.add((0,R.toDisposable)(()=>l.removeListener("error",c))),l.on("error",c),i.add((0,R.toDisposable)(()=>l.removeListener("end",w))),l.on("end",w),i.add((0,R.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}e.peekStream=d;function g(l,h){const f=_(h);return f.end(l),f}e.toStream=g;function r(){const l=_(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=r;function a(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=a;function p(l,h,f){const t=_(f);return P(l,{onData:i=>t.write(h.data(i)),onError:i=>t.error(h.error?h.error(i):i),onEnd:()=>t.end()}),t}e.transform=p;function m(l,h,f){let t=!1;return{read:()=>{const i=h.read();return t?i:(t=!0,i!==null?f([l,i]):l)}}}e.prefixedReadable=m;function E(l,h,f){let t=!1;const i=_(f);return P(h,{onData:s=>t?i.write(s):(t=!0,i.write(f([l,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(l)),i.end()}}),i}e.prefixedStream=E}),define(be[8],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function D(N,...Y){return Y.length===0?N:N.replace(R,function(re,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Y.length?re:Y[Ie]})}e.format=D;function T(N){return N.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=T;function _(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function S(N,Y){let re=0;const ke=Y.charCodeAt(0);for(let Ie=N.length-1;Ie>=0;Ie--)N.charCodeAt(Ie)===ke&&re++;return re}e.count=S;function y(N,Y,re="\u2026"){return N.length<=Y?N:`${N.substr(0,Y)}${re}`}e.truncate=y;function k(N,Y=" "){const re=n(N,Y);return P(re,Y)}e.trim=k;function n(N,Y){if(!N||!Y)return N;const re=Y.length;if(re===0||N.length===0)return N;let ke=0;for(;N.indexOf(Y,ke)===ke;)ke=ke+re;return N.substring(ke)}e.ltrim=n;function P(N,Y){if(!N||!Y)return N;const re=Y.length,ke=N.length;if(re===0||ke===0)return N;let Ie=ke,Oe=-1;for(;Oe=N.lastIndexOf(Y,Ie-1),!(Oe===-1||Oe+re!==Ie);){if(Oe===0)return"";Ie=Oe}return N.substring(0,Ie)}e.rtrim=P;function d(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(N){return N.replace(/\*/g,"")}e.stripWildcards=g;function r(N,Y,re={}){if(!N)throw new Error("Cannot create regex from empty string");Y||(N=_(N)),re.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return re.global&&(ke+="g"),re.matchCase||(ke+="i"),re.multiline&&(ke+="m"),re.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=r;function a(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function p(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=m;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function l(N){for(let Y=0,re=N.length;Y<re;Y++){const ke=N.charCodeAt(Y);if(ke!==32&&ke!==9)return Y}return-1}e.firstNonWhitespaceIndex=l;function h(N,Y=0,re=N.length){for(let ke=Y;ke<re;ke++){const Ie=N.charCodeAt(ke);if(Ie!==32&&Ie!==9)return N.substring(Y,ke)}return N.substring(Y,re)}e.getLeadingWhitespace=h;function f(N,Y=N.length-1){for(let re=Y;re>=0;re--){const ke=N.charCodeAt(re);if(ke!==32&&ke!==9)return re}return-1}e.lastNonWhitespaceIndex=f;function t(N,Y){return N<Y?-1:N>Y?1:0}e.compare=t;function i(N,Y,re=0,ke=N.length,Ie=0,Oe=Y.length){for(;re<ke&&Ie<Oe;re++,Ie++){let rt=N.charCodeAt(re),et=Y.charCodeAt(Ie);if(rt<et)return-1;if(rt>et)return 1}const Ue=ke-re,Qe=Oe-Ie;return Ue<Qe?-1:Ue>Qe?1:0}e.compareSubstring=i;function s(N,Y){return o(N,Y,0,N.length,0,Y.length)}e.compareIgnoreCase=s;function o(N,Y,re=0,ke=N.length,Ie=0,Oe=Y.length){for(;re<ke&&Ie<Oe;re++,Ie++){let rt=N.charCodeAt(re),et=Y.charCodeAt(Ie);if(rt===et)continue;const Je=rt-et;if(!(Je===32&&w(et))&&!(Je===-32&&w(rt)))return c(rt)&&c(et)?Je:i(N.toLowerCase(),Y.toLowerCase(),re,ke,Ie,Oe)}const Ue=ke-re,Qe=Oe-Ie;return Ue<Qe?-1:Ue>Qe?1:0}e.compareSubstringIgnoreCase=o;function c(N){return N>=97&&N<=122}e.isLowerAsciiLetter=c;function w(N){return N>=65&&N<=90}e.isUpperAsciiLetter=w;function b(N){return c(N)||w(N)}function A(N,Y){return N.length===Y.length&&C(N,Y)}e.equalsIgnoreCase=A;function C(N,Y,re=N.length){for(let ke=0;ke<re;ke++){const Ie=N.charCodeAt(ke),Oe=Y.charCodeAt(ke);if(Ie!==Oe){if(b(Ie)&&b(Oe)){const Ue=Math.abs(Ie-Oe);if(Ue!==0&&Ue!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Oe).toLowerCase())return!1}}return!0}function u(N,Y){const re=Y.length;return Y.length>N.length?!1:C(N,Y,re)}e.startsWithIgnoreCase=u;function F(N,Y){let re,ke=Math.min(N.length,Y.length);for(re=0;re<ke;re++)if(N.charCodeAt(re)!==Y.charCodeAt(re))return re;return ke}e.commonPrefixLength=F;function O(N,Y){let re,ke=Math.min(N.length,Y.length);const Ie=N.length-1,Oe=Y.length-1;for(re=0;re<ke;re++)if(N.charCodeAt(Ie-re)!==Y.charCodeAt(Oe-re))return re;return ke}e.commonSuffixLength=O;function z(N){return 55296<=N&&N<=56319}e.isHighSurrogate=z;function de(N){return 56320<=N&&N<=57343}e.isLowSurrogate=de;function he(N,Y){return(N-55296<<10)+(Y-56320)+65536}e.computeCodePoint=he;function $(N,Y,re){const ke=N.charCodeAt(re);if(z(ke)&&re+1<Y){const Ie=N.charCodeAt(re+1);if(de(Ie))return he(ke,Ie)}return ke}e.getNextCodePoint=$;function j(N,Y){const re=N.charCodeAt(Y-1);if(de(re)&&Y>1){const ke=N.charCodeAt(Y-2);if(z(ke))return he(ke,re)}return re}function W(N,Y){const re=$e.getInstance(),ke=Y,Ie=N.length,Oe=$(N,Ie,Y);Y+=Oe>=65536?2:1;let Ue=re.getGraphemeBreakType(Oe);for(;Y<Ie;){const Qe=$(N,Ie,Y),rt=re.getGraphemeBreakType(Qe);if(Ne(Ue,rt))break;Y+=Qe>=65536?2:1,Ue=rt}return Y-ke}e.nextCharLength=W;function I(N,Y){const re=$e.getInstance(),ke=Y,Ie=j(N,Y);Y-=Ie>=65536?2:1;let Oe=re.getGraphemeBreakType(Ie);for(;Y>0;){const Ue=j(N,Y),Qe=re.getGraphemeBreakType(Ue);if(Ne(Qe,Oe))break;Y-=Ue>=65536?2:1,Oe=Qe}return ke-Y}e.prevCharLength=I;function H(N,Y){const re=$e.getInstance(),ke=N.length,Ie=Y,Oe=$(N,ke,Y),Ue=re.getGraphemeBreakType(Oe);Y+=Oe>=65536?2:1;let Qe=Ue;for(;Y<ke;){const et=$(N,ke,Y),Je=re.getGraphemeBreakType(et);if(Ne(Qe,Je))break;Y+=et>=65536?2:1,Qe=Je}const rt=Y;for(Y=Ie,Qe=Ue;Y>0;){const et=j(N,Y),Je=re.getGraphemeBreakType(et);if(Ne(Je,Qe))break;Y-=et>=65536?2:1,Qe=Je}return[Y,rt]}function M(N,Y){return Y>0&&de(N.charCodeAt(Y))?H(N,Y-1):H(N,Y)}e.getCharContainingOffset=M;function B(N){const Y=N.length;let re=0,ke=0;for(;ke<Y;){const Ue=$(N,Y,ke);ke+=Ue>=65536?2:1,Ue<128?re+=1:Ue<2048?re+=2:Ue<65536?re+=3:re+=4}const Ie=new Uint8Array(re);ke=0;let Oe=0;for(;ke<Y;){const Ue=$(N,Y,ke);ke+=Ue>=65536?2:1,Ue<128?Ie[Oe++]=Ue:Ue<2048?(Ie[Oe++]=192|(Ue&1984)>>>6,Ie[Oe++]=128|(Ue&63)>>>0):Ue<65536?(Ie[Oe++]=224|(Ue&61440)>>>12,Ie[Oe++]=128|(Ue&4032)>>>6,Ie[Oe++]=128|(Ue&63)>>>0):(Ie[Oe++]=240|(Ue&1835008)>>>18,Ie[Oe++]=128|(Ue&258048)>>>12,Ie[Oe++]=128|(Ue&4032)>>>6,Ie[Oe++]=128|(Ue&63)>>>0)}return Ie}e.encodeUTF8=B;function G(N){const Y=N.byteLength,re=[];let ke=0;for(;ke<Y;){const Ie=N[ke];let Oe;if(Ie>=240&&ke+3<Y?Oe=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Y?Oe=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Y?Oe=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Oe=N[ke++],Oe>=0&&Oe<=55295||Oe>=57344&&Oe<=65535)re.push(String.fromCharCode(Oe));else if(Oe>=65536&&Oe<=1114111){const Ue=Oe-65536,Qe=55296+((Ue&1047552)>>>10),rt=56320+((Ue&1023)>>>0);re.push(String.fromCharCode(Qe)),re.push(String.fromCharCode(rt))}else re.push(String.fromCharCode(65533))}return re.join("")}e.decodeUTF8=G;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(N){return q.test(N)}e.containsRTL=se;const ve=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(N){return ve.test(N)}e.containsEmoji=Le;const xe=/^[\t\n\r\x20-\x7E]*$/;function Me(N){return xe.test(N)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=ze;function Ve(N){for(let Y=0,re=N.length;Y<re;Y++)if(x(N.charCodeAt(Y)))return!0;return!1}e.containsFullWidthCharacter=Ve;function x(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=x;function Q(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=Q;function te(N,Y){if(N.length<Y)return N;const re=/\b/g;let ke=0;for(;re.test(N)&&!(N.length-re.lastIndex<Y);)ke=re.lastIndex,re.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=te;const ie=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,Ee=/\x1b\[0?m/g;function le(N){return N&&(N=N.replace(ie,""),N=N.replace(fe,""),N=N.replace(Ee,"")),N}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Ae(N){return _e(N)?N.substr(1):N}e.stripUTF8BOM=Ae;function We(N,Y){if(!N||!Y||N.length<Y.length)return!1;const re=Y.length,ke=N.toLowerCase();let Ie=0,Oe=-1;for(;Ie<re;){const Ue=ke.indexOf(Y[Ie],Oe+1);if(Ue<0)return!1;Oe=Ue,Ie++}return!0}e.fuzzyContains=We;function ge(N,Y=!1){return N?(Y&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=ge;function Ge(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=Ge;function V(N,Y=1){if(Y===0)return"";let re=-1;do re=N.indexOf(`
`,re+1),Y--;while(Y>0&&re>=0);return re===-1?N:(N[re-1]==="\r"&&re--,N.substr(0,re))}e.getNLines=V;function ee(N){const Y=90-65+1;return N=N%(2*Y),N<Y?String.fromCharCode(97+N):String.fromCharCode(65+N-Y)}e.singleLetterHash=ee;function me(N){return $e.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=me;function Ne(N,Y){return N===0?Y!==5&&Y!==7:N===2&&Y===3?!1:N===4||N===2||N===3||Y===4||Y===2||Y===3?!0:!(N===8&&(Y===8||Y===9||Y===11||Y===12)||(N===11||N===9)&&(Y===9||Y===10)||(N===12||N===10)&&Y===10||Y===5||Y===13||Y===7||N===1||N===13&&Y===14||N===6&&Y===6)}e.breakBetweenGraphemeBreakType=Ne;var He;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const re=this._data,ke=re.length/3;let Ie=1;for(;Ie<=ke;)if(Y<re[3*Ie])Ie=2*Ie;else if(Y>re[3*Ie+1])Ie=2*Ie+1;else return re[3*Ie+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(N,Y){if(N===0)return 0;const re=Se(N,Y);if(re!==void 0)return re;const ke=j(Y,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=De;function Se(N,Y){let re=j(Y,N);for(N-=Ce(re);ne(re)||re===65039||re===8419;){if(N===0)return;re=j(Y,N),N-=Ce(re)}if(!!Q(re)){if(N>=0){const ke=j(Y,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function ne(N){return 127995<=N&&N<=127999}var ae;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(ae||(ae={}))}),define(be[24],we([0,1,8,111]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",_=typeof TextDecoder!="undefined";let S,y;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return D?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,A){return!((A==null?void 0:A.dontUseNodeBuffer)||!1)&&D?new k(Buffer.from(b)):T?(S||(S=new TextEncoder),new k(S.encode(b))):new k(v.encodeUTF8(b))}static concat(b,A){if(typeof A=="undefined"){A=0;for(let F=0,O=b.length;F<O;F++)A+=b[F].byteLength}const C=k.alloc(A);let u=0;for(let F=0,O=b.length;F<O;F++){const z=b[F];C.set(z,u),u+=z.byteLength}return C}toString(){return D?this.buffer.toString():_?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(b,A){return new k(this.buffer.subarray(b,A))}set(b,A){b instanceof k?this.buffer.set(b.buffer,A):this.buffer.set(b,A)}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,A){g(this.buffer,b,A)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,A){a(this.buffer,b,A)}readUInt8(b){return p(this.buffer,b)}writeUInt8(b,A){m(this.buffer,b,A)}}e.VSBuffer=k;function n(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.readUInt16LE=n;function P(w,b,A){w[A+0]=b&255,b=b>>>8,w[A+1]=b&255}e.writeUInt16LE=P;function d(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.readUInt32BE=d;function g(w,b,A){w[A+3]=b,b=b>>>8,w[A+2]=b,b=b>>>8,w[A+1]=b,b=b>>>8,w[A]=b}e.writeUInt32BE=g;function r(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.readUInt32LE=r;function a(w,b,A){w[A+0]=b&255,b=b>>>8,w[A+1]=b&255,b=b>>>8,w[A+2]=b&255,b=b>>>8,w[A+3]=b&255}e.writeUInt32LE=a;function p(w,b){return w[b]}e.readUInt8=p;function m(w,b,A){w[A]=b}e.writeUInt8=m;function E(w){return R.consumeReadable(w,b=>k.concat(b))}e.readableToBuffer=E;function l(w){return R.toReadable(w)}e.bufferToReadable=l;function h(w){return R.consumeStream(w,b=>k.concat(b))}e.streamToBuffer=h;async function f(w){return w.ended?k.concat(w.buffer):k.concat([...w.buffer,await h(w.stream)])}e.bufferedStreamToBuffer=f;function t(w){return R.toStream(w,b=>k.concat(b))}e.bufferToStream=t;function i(w){return R.transform(w,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=i;function s(w){return R.newWriteableStream(b=>k.concat(b),w)}e.newWriteableBufferStream=s;function o(w,b){return R.prefixedReadable(w,b,A=>k.concat(A))}e.prefixedBufferReadable=o;function c(w,b){return R.prefixedStream(w,b,A=>k.concat(A))}e.prefixedBufferStream=c}),define(be[57],we([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(m){return D(m,0)}e.hash=R;function D(m,E){switch(typeof m){case"object":return m===null?T(349,E):Array.isArray(m)?y(m,E):k(m,E);case"string":return S(m,E);case"boolean":return _(m,E);case"number":return T(m,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=D;function T(m,E){return(E<<5)-E+m|0}function _(m,E){return T(m?433:863,E)}function S(m,E){E=T(149417,E);for(let l=0,h=m.length;l<h;l++)E=T(m.charCodeAt(l),E);return E}e.stringHash=S;function y(m,E){return E=T(104579,E),m.reduce((l,h)=>D(h,l),E)}function k(m,E){return E=T(181387,E),Object.keys(m).sort().reduce((l,h)=>(l=S(h,l),D(m[h],l)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=n;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(m,E,l=32){const h=l-E,f=~((1<<h)-1);return(m<<E|(f&m)>>>h)>>>0}function g(m,E=0,l=m.byteLength,h=0){for(let f=0;f<l;f++)m[E+f]=h}function r(m,E,l="0"){for(;m.length<E;)m=l+m;return m}function a(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),E/4)}e.toHexString=a;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const l=E.length;if(l===0)return;const h=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=E.charCodeAt(0),s=0);;){let o=i;if(v.isHighSurrogate(i))if(s+1<l){const c=E.charCodeAt(s+1);v.isLowSurrogate(c)?(s++,o=v.computeCodePoint(i,c)):o=65533}else{t=i;break}else v.isLowSurrogate(i)&&(o=65533);if(f=this._push(h,f,o),s++,s<l)i=E.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(E,l,h){return h<128?E[l++]=h:h<2048?(E[l++]=192|(h&1984)>>>6,E[l++]=128|(h&63)>>>0):h<65536?(E[l++]=224|(h&61440)>>>12,E[l++]=128|(h&4032)>>>6,E[l++]=128|(h&63)>>>0):(E[l++]=240|(h&1835008)>>>18,E[l++]=128|(h&258048)>>>12,E[l++]=128|(h&4032)>>>6,E[l++]=128|(h&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,l=this._buffDV;for(let b=0;b<64;b+=4)E.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)E.setUint32(b,d(E.getUint32(b-12,!1)^E.getUint32(b-32,!1)^E.getUint32(b-56,!1)^E.getUint32(b-64,!1),1),!1);let h=this._h0,f=this._h1,t=this._h2,i=this._h3,s=this._h4,o,c,w;for(let b=0;b<80;b++)b<20?(o=f&t|~f&i,c=1518500249):b<40?(o=f^t^i,c=1859775393):b<60?(o=f&t|f&i|t&i,c=2400959708):(o=f^t^i,c=3395469782),w=d(h,5)+o+s+c+E.getUint32(b*4,!1)&4294967295,s=i,i=t,t=d(f,30),f=h,h=w;this._h0=this._h0+h&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],we([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const T="error",_="warning",S="warn",y="info",k="ignore";function n(d){return d?v.equalsIgnoreCase(T,d)?D.Error:v.equalsIgnoreCase(_,d)||v.equalsIgnoreCase(S,d)?D.Warning:v.equalsIgnoreCase(y,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function P(d){switch(d){case D.Error:return T;case D.Warning:return _;case D.Info:return y;default:return k}}D.toString=P}(R||(R={})),e.default=R}),define(be[10],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function R(b){return typeof b=="string"}e.isString=R;function D(b){return Array.isArray(b)&&b.every(A=>R(A))}e.isStringArray=D;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function _(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=_;function S(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=S;function y(b){return b===!0||b===!1}e.isBoolean=y;function k(b){return typeof b=="undefined"}e.isUndefined=k;function n(b){return!P(b)}e.isDefined=n;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function d(b,A){if(!b)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=d;function g(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function r(...b){const A=[];for(let C=0;C<b.length;C++){const u=b[C];if(P(u))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);A.push(u)}return A}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function p(b){if(!T(b))return!1;for(let A in b)if(a.call(b,A))return!1;return!0}e.isEmptyObject=p;function m(b){return typeof b=="function"}e.isFunction=m;function E(...b){return b.length>0&&b.every(m)}e.areFunctions=E;function l(b,A){const C=Math.min(b.length,A.length);for(let u=0;u<C;u++)h(b[u],A[u])}e.validateConstraints=l;function h(b,A){if(R(A)){if(typeof b!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(m(A)){try{if(b instanceof A)return}catch(C){}if(!P(b)&&b.constructor===A||A.length===1&&A.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(b){let A=[],C=Object.getPrototypeOf(b);for(;Object.prototype!==C;)A=A.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return A}e.getAllPropertyNames=f;function t(b){const A=[];for(const C of f(b))typeof b[C]=="function"&&A.push(C);return A}e.getAllMethodNames=t;function i(b,A){const C=F=>function(){const O=Array.prototype.slice.call(arguments,0);return A(F,O)};let u={};for(const F of b)u[F]=C(F);return u}e.createProxyObject=i;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function o(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=o;function c(b){return class{constructor(){return new Proxy({},{get(A,C){if(A[C])return A[C];throw new Error(`Not Implemented: ${b}->${String(C)}`)}})}}}e.NotImplementedProxy=c;function w(b){throw new Error("Unreachable")}e.assertNever=w}),define(be[36],we([0,1,21,8,14,10]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function S(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=S;function y(s){return s.indexOf("/")===-1&&(s=S(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function k(s,o=D.posix.sep){if(!s)return"";const c=s.length,w=s.charCodeAt(0);if(_(w)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let A=3;const C=A;for(;A<c&&!_(s.charCodeAt(A));A++);if(C!==A&&!_(s.charCodeAt(A+1))){for(A+=1;A<c;A++)if(_(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,o)}}return o}else if(m(w)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<c;b++)if(_(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=k;function n(s){if(!v.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const w=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(w===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(s,o=v.isWindows){const c=o?P:d;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&g.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=r;function a(s,o,c){const w=s===o;return!c||w?w:!s||!o?!1:(0,R.equalsIgnoreCase)(s,o)}e.isEqual=a;function p(s,o,c,w=D.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let A=o.length;return o.charAt(o.length-1)===w&&A--,s.charAt(A)===w}return o.charAt(o.length-1)!==w&&(o+=w),s.indexOf(o)===0}e.isEqualOrParent=p;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function E(s,o){return v.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(o,s)),s=(0,D.normalize)(s),v.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=E;function l(s){const o=(0,D.normalize)(s);return v.isWindows?s.length>3?!1:h(o)&&(s.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=l;function h(s){return v.isWindows?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(s){return h(s)?s[0]:void 0}e.getDriveLetter=f;function t(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function i(s){const o=s.split(":");let c,w,b;if(o.forEach(A=>{const C=Number(A);(0,T.isNumber)(C)?w===void 0?w=C:b===void 0&&(b=C):c=c?[c,A].join(":"):A}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:w!==void 0?w:void 0,column:b!==void 0?b:w!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(be[23],we([0,1,10]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const p=Array.isArray(a)?[]:{};return Object.keys(a).forEach(m=>{a[m]&&typeof a[m]=="object"?p[m]=R(a[m]):p[m]=a[m]}),p}e.deepClone=R;function D(a){if(!a||typeof a!="object")return a;const p=[a];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const E in m)if(T.call(m,E)){const l=m[E];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return a}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function _(a,p){return S(a,p,new Set)}e.cloneAndChange=_;function S(a,p,m){if((0,v.isUndefinedOrNull)(a))return a;const E=p(a);if(typeof E!="undefined")return E;if((0,v.isArray)(a)){const l=[];for(const h of a)l.push(S(h,p,m));return l}if((0,v.isObject)(a)){if(m.has(a))throw new Error("Cannot clone recursive data-structure");m.add(a);const l={};for(let h in a)T.call(a,h)&&(l[h]=S(a[h],p,m));return m.delete(a),l}return a}function y(a,p,m=!0){return(0,v.isObject)(a)?((0,v.isObject)(p)&&Object.keys(p).forEach(E=>{E in a?m&&((0,v.isObject)(a[E])&&(0,v.isObject)(p[E])?y(a[E],p[E],m):a[E]=p[E]):a[E]=p[E]}),a):p}e.mixin=y;function k(a,p){if(a===p)return!0;if(a==null||p===null||p===void 0||typeof a!=typeof p||typeof a!="object"||Array.isArray(a)!==Array.isArray(p))return!1;let m,E;if(Array.isArray(a)){if(a.length!==p.length)return!1;for(m=0;m<a.length;m++)if(!k(a[m],p[m]))return!1}else{const l=[];for(E in a)l.push(E);l.sort();const h=[];for(E in p)h.push(E);if(h.sort(),!k(l,h))return!1;for(m=0;m<l.length;m++)if(!k(a[l[m]],p[l[m]]))return!1}return!0}e.equals=k;function n(a){const p=new Set;return JSON.stringify(a,(m,E)=>{if((0,v.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=n;function P(a,p,m){const E=p(a);return typeof E=="undefined"?m:E}e.getOrDefault=P;function d(a,p){const m=Object.create(null);return!a||!p||Object.keys(p).forEach(l=>{const h=a[l],f=p[l];k(h,f)||(m[l]=f)}),m}e.distinct=d;function g(a,p){const m=p.toLowerCase(),E=Object.keys(a).find(l=>l.toLowerCase()===m);return E?a[E]:a[p]}e.getCaseInsensitive=g;function r(a,p){const m=Object.create(null);for(const E of Object.keys(a))p(E,a[E])&&(m[E]=a[E]);return m}e.filter=r}),define(be[82],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function D(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=D}),define(be[2],we([0,1,21,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,_=/^\/\//;function S(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,o){return!s&&!o?"file":s}function k(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const n="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(o,c,w,b,A,C=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=y(o,C),this.authority=c||n,this.path=k(this.scheme,w||n),this.query=b||n,this.fragment=A||n,S(this,C))}static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return l(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:w,path:b,query:A,fragment:C}=o;return c===void 0?c=this.scheme:c===null&&(c=n),w===void 0?w=this.authority:w===null&&(w=n),b===void 0?b=this.path:b===null&&(b=n),A===void 0?A=this.query:A===null&&(A=n),C===void 0?C=this.fragment:C===null&&(C=n),c===this.scheme&&w===this.authority&&b===this.path&&A===this.query&&C===this.fragment?this:new a(c,w,b,A,C)}static parse(o,c=!1){const w=d.exec(o);return w?new a(w[2]||n,i(w[4]||n),i(w[5]||n),i(w[7]||n),i(w[9]||n),c):new a(n,n,n,n,n)}static file(o){let c=n;if(v.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const w=o.indexOf(P,2);w===-1?(c=o.substring(2),o=P):(c=o.substring(2,w),o=o.substring(w)||P)}return new a("file",c,o,n,n)}static from(o){const c=new a(o.scheme,o.authority,o.path,o.query,o.fragment);return S(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return v.isWindows&&o.scheme==="file"?w=g.file(R.win32.join(l(o,!0),...c)).path:w=R.posix.join(o.path,...c),o.with({path:w})}toString(o=!1){return h(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const c=new a(o);return c._formatted=o.external,c._fsPath=o._sep===r?o.fsPath:null,c}}else return o}}e.URI=g;const r=v.isWindows?1:void 0;class a extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(o=!1){return o?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(s,o){let c,w=-1;for(let b=0;b<s.length;b++){const A=s.charCodeAt(b);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||o&&A===47)w!==-1&&(c+=encodeURIComponent(s.substring(w,b)),w=-1),c!==void 0&&(c+=s.charAt(b));else{c===void 0&&(c=s.substr(0,b));const C=p[A];C!==void 0?(w!==-1&&(c+=encodeURIComponent(s.substring(w,b)),w=-1),c+=C):w===-1&&(w=b)}}return w!==-1&&(c+=encodeURIComponent(s.substring(w))),c!==void 0?c:s}function E(s){let o;for(let c=0;c<s.length;c++){const w=s.charCodeAt(c);w===35||w===63?(o===void 0&&(o=s.substr(0,c)),o+=p[w]):o!==void 0&&(o+=s[c])}return o!==void 0?o:s}function l(s,o){let c;return s.authority&&s.path.length>1&&s.scheme==="file"?c=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?c=s.path.substr(1):c=s.path[1].toLowerCase()+s.path.substr(2):c=s.path,v.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=l;function h(s,o){const c=o?E:m;let w="",{scheme:b,authority:A,path:C,query:u,fragment:F}=s;if(b&&(w+=b,w+=":"),(A||b==="file")&&(w+=P,w+=P),A){let O=A.indexOf("@");if(O!==-1){const z=A.substr(0,O);A=A.substr(O+1),O=z.indexOf(":"),O===-1?w+=c(z,!1):(w+=c(z.substr(0,O),!1),w+=":",w+=c(z.substr(O+1),!1)),w+="@"}A=A.toLowerCase(),O=A.indexOf(":"),O===-1?w+=c(A,!1):(w+=c(A.substr(0,O),!1),w+=A.substr(O))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const O=C.charCodeAt(1);O>=65&&O<=90&&(C=`/${String.fromCharCode(O+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const O=C.charCodeAt(0);O>=65&&O<=90&&(C=`${String.fromCharCode(O+32)}:${C.substr(2)}`)}w+=c(C,!0)}return u&&(w+="?",w+=c(u,!1)),F&&(w+="#",w+=o?F:m(F,!1)),w}function f(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,o=>f(o)):s}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[22],we([0,1,2,8]),function(J,e,v,R){"use strict";var D,T,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(t,i,s){let o=t.get(i);return o===void 0&&(o=s,t.set(i,o)),o}e.getOrSet=S;function y(t){const i=[];return t.forEach((s,o)=>{i.push(`${o} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=y;function k(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=n;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new r(i))}static forPaths(){return new p(new d)}static forStrings(){return new p(new n)}static forConfigKeys(){return new p(new P)}clear(){this._root=void 0}set(i,s){const o=this._iter.reset(i);let c;for(this._root||(this._root=new a,this._root.segment=o.value()),c=this._root;;){const b=o.cmp(c.segment);if(b>0)c.left||(c.left=new a,c.left.segment=o.value()),c=c.left;else if(b<0)c.right||(c.right=new a,c.right.segment=o.value()),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new a,c.mid.segment=o.value()),c=c.mid;else break}const w=c.value;return c.value=s,c.key=i,w}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const o=this._iter.reset(i),c=[];let w=this._root;for(;w;){const b=o.cmp(w.segment);if(b>0)c.push([1,w]),w=w.left;else if(b<0)c.push([-1,w]),w=w.right;else if(o.hasNext())o.next(),c.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;c.length>0&&w.isEmpty();){let[A,C]=c.pop();switch(A){case 1:C.left=void 0;break;case 0:C.mid=void 0;break;case-1:C.right=void 0;break}w=C}break}}}findSubstr(i){const s=this._iter.reset(i);let o=this._root,c;for(;o;){const w=s.cmp(o.segment);if(w>0)o=o.left;else if(w<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(i){const s=this._iter.reset(i);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[s,o]of this)i(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=p;class m{constructor(i,s){this[D]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=s!=null?s:m.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:m.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[o,c]of this.map)i(c,v.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const o=this._map.get(i);if(!!o)return s!==0&&this.touch(o,s),o.value}set(i,s,o=0){let c=this._map.get(i);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:i,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const o=this._state;let c=this._head;for(;c;){if(s?i.bind(s)(c.value,c.key,this):i(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.key,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return c}values(){const i=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.value,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return c}entries(){const i=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:[o.key,o.value],done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>i;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,o=i.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const o=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const o=i.next,c=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,o)=>{i.push([o,s])}),i}fromJSON(i){this.clear();for(const[s,o]of i)this.set(s,o)}}e.LinkedMap=l;class h extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class f{constructor(i){_.set(this,void 0),nt(this,_,i,"f")}get size(){return Be(this,_,"f").size}forEach(i,s){Be(this,_,"f").forEach(i,s)}get(i){return Be(this,_,"f").get(i)}has(i){return Be(this,_,"f").has(i)}entries(){return Be(this,_,"f").entries()}keys(){return Be(this,_,"f").keys()}values(){return Be(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Be(this,_,"f").entries()}}e.ReadonlyMapView=f}),define(be[112],we([0,1,22,8]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...le){return function(_e,Ae){for(let We=0,ge=le.length;We<ge;We++){const Ge=le[We](_e,Ae);if(Ge)return Ge}return null}}e.or=D,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(le,_e,Ae){if(!Ae||Ae.length<_e.length)return null;let We;return le?We=R.startsWithIgnoreCase(Ae,_e):We=Ae.indexOf(_e)===0,We?_e.length>0?[{start:0,end:_e.length}]:[]:null}function _(le,_e){const Ae=_e.toLowerCase().indexOf(le.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+le.length}]}e.matchesContiguousSubString=_;function S(le,_e){return y(le.toLowerCase(),_e.toLowerCase(),0,0)}e.matchesSubString=S;function y(le,_e,Ae,We){if(Ae===le.length)return[];if(We===_e.length)return null;if(le[Ae]===_e[We]){let ge=null;return(ge=y(le,_e,Ae+1,We+1))?m({start:We,end:We+1},ge):null}return y(le,_e,Ae,We+1)}function k(le){return 97<=le&&le<=122}function n(le){return 65<=le&&le<=90}e.isUpper=n;function P(le){return 48<=le&&le<=57}function d(le){return le===32||le===9||le===10||le===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(le=>g.add(le.charCodeAt(0)));function r(le){return d(le)||g.has(le)}function a(le,_e){return le===_e||r(le)&&r(_e)}function p(le){return k(le)||n(le)||P(le)}function m(le,_e){return _e.length===0?_e=[le]:le.end===_e[0].start?_e[0].start=le.start:_e.unshift(le),_e}function E(le,_e){for(let Ae=_e;Ae<le.length;Ae++){const We=le.charCodeAt(Ae);if(n(We)||P(We)||Ae>0&&!p(le.charCodeAt(Ae-1)))return Ae}return le.length}function l(le,_e,Ae,We){if(Ae===le.length)return[];if(We===_e.length)return null;if(le[Ae]!==_e[We].toLowerCase())return null;{let ge=null,Ge=We+1;for(ge=l(le,_e,Ae+1,We+1);!ge&&(Ge=E(_e,Ge))<_e.length;)ge=l(le,_e,Ae+1,Ge),Ge++;return ge===null?null:m({start:We,end:We+1},ge)}}function h(le){let _e=0,Ae=0,We=0,ge=0,Ge=0;for(let He=0;He<le.length;He++)Ge=le.charCodeAt(He),n(Ge)&&_e++,k(Ge)&&Ae++,p(Ge)&&We++,P(Ge)&&ge++;const V=_e/le.length,ee=Ae/le.length,me=We/le.length,Ne=ge/le.length;return{upperPercent:V,lowerPercent:ee,alphaPercent:me,numericPercent:Ne}}function f(le){const{upperPercent:_e,lowerPercent:Ae}=le;return Ae===0&&_e>.6}function t(le){const{upperPercent:_e,lowerPercent:Ae,alphaPercent:We,numericPercent:ge}=le;return Ae>.2&&_e<.8&&We>.6&&ge<.2}function i(le){let _e=0,Ae=0,We=0,ge=0;for(let Ge=0;Ge<le.length;Ge++)We=le.charCodeAt(Ge),n(We)&&_e++,k(We)&&Ae++,d(We)&&ge++;return(_e===0||Ae===0)&&ge===0?le.length<=30:_e<=5}function s(le,_e){if(!_e||(_e=_e.trim(),_e.length===0)||!i(le)||_e.length>60)return null;const Ae=h(_e);if(!t(Ae)){if(!f(Ae))return null;_e=_e.toLowerCase()}let We=null,ge=0;for(le=le.toLowerCase();ge<_e.length&&(We=l(le,_e,0,ge))===null;)ge=E(_e,ge+1);return We}e.matchesCamelCase=s;function o(le,_e,Ae=!1){if(!_e||_e.length===0)return null;let We=null,ge=0;for(le=le.toLowerCase(),_e=_e.toLowerCase();ge<_e.length&&(We=c(le,_e,0,ge,Ae))===null;)ge=w(_e,ge+1);return We}e.matchesWords=o;function c(le,_e,Ae,We,ge){if(Ae===le.length)return[];if(We===_e.length)return null;if(a(le.charCodeAt(Ae),_e.charCodeAt(We))){let Ge=null,V=We+1;if(Ge=c(le,_e,Ae+1,We+1,ge),!ge)for(;!Ge&&(V=w(_e,V))<_e.length;)Ge=c(le,_e,Ae+1,V,ge),V++;return Ge===null?null:m({start:We,end:We+1},Ge)}else return null}function w(le,_e){for(let Ae=_e;Ae<le.length;Ae++)if(r(le.charCodeAt(Ae))||Ae>0&&r(le.charCodeAt(Ae-1)))return Ae;return le.length}const b=D(e.matchesPrefix,s,_),A=D(e.matchesPrefix,s,S),C=new v.LRUCache(1e4);function u(le,_e,Ae=!1){if(typeof le!="string"||typeof _e!="string")return null;let We=C.get(le);We||(We=new RegExp(R.convertSimple2RegExpPattern(le),"i"),C.set(le,We));const ge=We.exec(_e);return ge?[{start:ge.index,end:ge.index+ge[0].length}]:Ae?A(le,_e):b(le,_e)}e.matchesFuzzy=u;function F(le,_e){const Ae=Ve(le,le.toLowerCase(),0,_e,_e.toLowerCase(),0,!0);return Ae?z(Ae):null}e.matchesFuzzy2=F;function O(le,_e,Ae,We,ge,Ge){const V=Math.min(13,le.length);for(;Ae<V;Ae++){const ee=Ve(le,_e,Ae,We,ge,Ge,!1);if(ee)return ee}return[0,Ge]}e.anyScore=O;function z(le){if(typeof le=="undefined")return[];const _e=[],Ae=le[1];for(let We=le.length-1;We>1;We--){const ge=le[We]+Ae,Ge=_e[_e.length-1];Ge&&Ge.end===ge?Ge.end=ge+1:_e.push({start:ge,end:ge+1})}return _e}e.createMatches=z;const de=128;function he(){const le=[],_e=[];for(let Ae=0;Ae<=de;Ae++)_e[Ae]=0;for(let Ae=0;Ae<=de;Ae++)le.push(_e.slice(0));return le}function $(le){const _e=[];for(let Ae=0;Ae<=le;Ae++)_e[Ae]=0;return _e}const j=$(2*de),W=$(2*de),I=he(),H=he(),M=he(),B=!1;function G(le,_e,Ae,We,ge){function Ge(ee,me,Ne=" "){for(;ee.length<me;)ee=Ne+ee;return ee}let V=` |   |${We.split("").map(ee=>Ge(ee,3)).join("|")}
`;for(let ee=0;ee<=Ae;ee++)ee===0?V+=" |":V+=`${_e[ee-1]}|`,V+=le[ee].slice(0,ge+1).map(me=>Ge(me.toString(),3)).join("|")+`
`;return V}function q(le,_e,Ae,We){le=le.substr(_e),Ae=Ae.substr(We),console.log(G(H,le,le.length,Ae,Ae.length)),console.log(G(M,le,le.length,Ae,Ae.length)),console.log(G(I,le,le.length,Ae,Ae.length))}function se(le,_e){if(_e<0||_e>=le.length)return!1;const Ae=le.codePointAt(_e);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Ae)}}function ve(le,_e){if(_e<0||_e>=le.length)return!1;switch(le.charCodeAt(_e)){case 32:case 9:return!0;default:return!1}}function Le(le,_e,Ae){return _e[le]!==Ae[le]}function xe(le,_e,Ae,We,ge,Ge,V=!1){for(;_e<Ae&&ge<Ge;)le[_e]===We[ge]&&(V&&(j[_e]=ge),_e+=1),ge+=1;return _e===Ae}e.isPatternInWord=xe;var Me;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var ze;(function(le){le.Default=[-100,0];function _e(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}le.isDefault=_e})(ze=e.FuzzyScore||(e.FuzzyScore={}));function Ve(le,_e,Ae,We,ge,Ge,V){const ee=le.length>de?de:le.length,me=We.length>de?de:We.length;if(Ae>=ee||Ge>=me||ee-Ae>me-Ge||!xe(_e,Ae,ee,ge,Ge,me,!0))return;x(ee,me,Ae,Ge,_e,ge);let Ne=1,He=1,$e=Ae,Ye=Ge;const De=[!1];for(Ne=1,$e=Ae;$e<ee;Ne++,$e++){const N=j[$e],Y=W[$e],re=$e+1<ee?W[$e+1]:me;for(He=N-Ge+1,Ye=N;Ye<re;He++,Ye++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Ye<=Y&&(ke=Q(le,_e,$e,Ae,We,ge,Ye,me,Ge,I[Ne-1][He-1]===0,De));let Oe=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Oe=ke+H[Ne-1][He-1]);const Ue=Ye>N,Qe=Ue?H[Ne][He-1]+(I[Ne][He-1]>0?-5:0):0,rt=Ye>N+1&&I[Ne][He-1]>0,et=rt?H[Ne][He-2]+(I[Ne][He-2]>0?-5:0):0;if(rt&&(!Ue||et>=Qe)&&(!Ie||et>=Oe))H[Ne][He]=et,M[Ne][He]=3,I[Ne][He]=0;else if(Ue&&(!Ie||Qe>=Oe))H[Ne][He]=Qe,M[Ne][He]=2,I[Ne][He]=0;else if(Ie)H[Ne][He]=Oe,M[Ne][He]=1,I[Ne][He]=I[Ne-1][He-1]+1;else throw new Error("not possible")}}if(B&&q(le,Ae,We,Ge),!De[0]&&!V)return;Ne--,He--;const Se=[H[Ne][He],Ge];let Ce=0,ne=0;for(;Ne>=1;){let N=He;do{const Y=M[Ne][N];if(Y===3)N=N-2;else if(Y===2)N=N-1;else break}while(N>=1);Ce>1&&_e[Ae+Ne-1]===ge[Ge+He-1]&&!Le(N+Ge-1,We,ge)&&Ce+1>I[Ne][N]&&(N=He),N===He?Ce++:Ce=1,ne||(ne=N),Ne--,He=N-1,Se.push(He)}me===ee&&(Se[0]+=2);const ae=ne-ee;return Se[0]-=ae,Se}e.fuzzyScore=Ve;function x(le,_e,Ae,We,ge,Ge){let V=le-1,ee=_e-1;for(;V>=Ae&&ee>=We;)ge[V]===Ge[ee]&&(W[V]=ee,V--),ee--}function Q(le,_e,Ae,We,ge,Ge,V,ee,me,Ne,He){if(_e[Ae]!==Ge[V])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return V===Ae-We?$e=le[Ae]===ge[V]?7:5:Le(V,ge,Ge)&&(V===0||!Le(V-1,ge,Ge))?($e=le[Ae]===ge[V]?7:5,Ye=!0):se(Ge,V)&&(V===0||!se(Ge,V-1))?$e=5:(se(Ge,V-1)||ve(Ge,V-1))&&($e=5,Ye=!0),$e>1&&Ae===We&&(He[0]=!0),Ye||(Ye=Le(V,ge,Ge)||se(Ge,V-1)||ve(Ge,V-1)),Ae===We?V>me&&($e-=Ye?3:5):Ne?$e+=Ye?2:0:$e+=Ye?0:1,V+1===ee&&($e-=Ye?3:5),$e}function te(le,_e,Ae,We,ge,Ge,V){return fe(le,_e,Ae,We,ge,Ge,!0,V)}e.fuzzyScoreGracefulAggressive=te;function ie(le,_e,Ae,We,ge,Ge,V){return fe(le,_e,Ae,We,ge,Ge,!1,V)}e.fuzzyScoreGraceful=ie;function fe(le,_e,Ae,We,ge,Ge,V,ee){let me=Ve(le,_e,Ae,We,ge,Ge,ee);if(me&&!V)return me;if(le.length>=3){const Ne=Math.min(7,le.length-1);for(let He=Ae+1;He<Ne;He++){const $e=Ee(le,He);if($e){const Ye=Ve($e,$e.toLowerCase(),Ae,We,ge,Ge,ee);Ye&&(Ye[0]-=3,(!me||Ye[0]>me[0])&&(me=Ye))}}}return me}function Ee(le,_e){if(_e+1>=le.length)return;const Ae=le[_e],We=le[_e+1];if(Ae!==We)return le.slice(0,_e)+We+Ae+le.slice(_e+2)}}),define(be[113],we([0,1,35,112,8]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${T.source}`,"g");function S(a){return a.replace(_,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${T.source}`,"g");function k(a){return a.replace(y,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(n,(p,m,E,l)=>E?p:m||l||"")}e.stripIcons=P;function d(a){const p=a.indexOf(e.iconStartMarker);return p===-1?{text:a}:g(a,p)}e.parseLabelWithIcons=d;function g(a,p){const m=[];let E="";function l(w){if(w){E+=w;for(const b of w)m.push(t)}}let h=-1,f="",t=0,i,s,o=p;const c=a.length;for(l(a.substr(0,p));o<c;)i=a[o],s=a[o+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=o,l(f),f=e.iconStartMarker,o++):i===")"&&h!==-1?(t+=o-h+1,h=-1,f=""):h!==-1?/^[a-z0-9\-]$/i.test(i)?f+=i:(l(f),h=-1,f=""):l(i),o++;return l(f),{text:E,iconOffsets:m}}function r(a,p,m=!1){const{text:E,iconOffsets:l}=p;if(!l||l.length===0)return(0,R.matchesFuzzy)(a,E,m);const h=(0,D.ltrim)(E," "),f=E.length-h.length,t=(0,R.matchesFuzzy)(a,h,m);if(t)for(const i of t){const s=l[i.start+f]+f;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=r}),define(be[83],we([0,1,13,113,12]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(a="",p=!1){var m,E;if(this.value=a,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(E=p.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(a,p=0){return this.value+=P(this.supportThemeIcons?(0,R.escapeIcons)(a):a).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=_;function S(r){return y(r)?!r.value:Array.isArray(r)?r.every(S):!0}e.isEmptyMarkdownString=S;function y(r){return r instanceof _?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function k(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,v.equals)(r,a,n):y(r)&&y(a)?n(r,a):!1}e.markedStringsEquals=k;function n(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(r){const a=[],p=r.split("|").map(E=>E.trim());r=p[0];const m=p[1];if(m){const E=/height=(\d+)/.exec(m),l=/width=(\d+)/.exec(m),h=E?E[1]:"",f=l?l[1]:"",t=isFinite(parseInt(f)),i=isFinite(parseInt(h));t&&a.push(`width="${f}"`),i&&a.push(`height="${h}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=g}),define(be[58],we([0,1,24,8,2]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,S)}e.stringify=T;function _(k){let n=JSON.parse(k);return n=y(n),n}e.parse=_;function S(k,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,R.regExpFlags)(n)}:n}function y(k,n=0){if(!k||n>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof v.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=y(k[P],n+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=y(k[P],n+1))}return k}e.revive=y}),define(be[16],we([0,1,2,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,k,n){this._hosts[y]=k,this._ports[y]=n}setConnectionToken(y,k){this._connectionTokens[y]=k}rewrite(y){if(this._delegate)return this._delegate(y);const k=y.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[k],d=this._connectionTokens[k];let g=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class _{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,k,n){const P=this.toUri(y,k);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&P.scheme===D.file?P.with({scheme:D.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(y,k){const n=this.toUri(y,k);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,k){return v.URI.isUri(y)?y:v.URI.parse(k.toUrl(y))}}e.FileAccess=new _}),define(be[25],we([0,1,36,14,2,8,16,21]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,D.uriToFsPath)(g,!0)}e.originalFSPath=y;class k{constructor(r){this._ignorePathCasing=r}compare(r,a,p=!1){return r===a?0:(0,T.compare)(this.getComparisonKey(r,p),this.getComparisonKey(a,p))}isEqual(r,a,p=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,p)===this.getComparisonKey(a,p)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,p=!1){if(r.scheme===a.scheme){if(r.scheme===_.Schemas.file)return v.isEqualOrParent(y(r),y(a),this._ignorePathCasing(r))&&r.query===a.query&&(p||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return v.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(p||r.fragment===a.fragment)}return!1}joinPath(r,...a){return D.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return R.posix.basename(r.path)}extname(r){return R.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===_.Schemas.file?a=D.URI.file(R.dirname(y(r))).path:(a=R.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===_.Schemas.file?a=D.URI.file(R.normalize(y(r))).path:a=R.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))return;if(r.scheme===_.Schemas.file){const E=R.relative(y(r),y(a));return S.isWindows?v.toSlashes(E):E}let p=r.path||"/",m=a.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const l=Math.min(p.length,m.length);E<l&&!(p.charCodeAt(E)!==m.charCodeAt(E)&&p.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);p=m.substr(0,E)+p.substr(E)}return R.posix.relative(p,m)}resolvePath(r,a){if(r.scheme===_.Schemas.file){const p=D.URI.file(R.resolve(y(r),a));return r.with({authority:p.authority,path:p.path})}return a=v.toPosixPath(a),r.with({path:R.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,T.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=R.sep){if(r.scheme===_.Schemas.file){const p=y(r);return p.length>v.getRoot(p).length&&p[p.length-1]===a}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=R.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=R.sep){let p=!1;if(r.scheme===_.Schemas.file){const m=y(r);p=m!==void 0&&m.length===v.getRoot(m).length&&m[m.length-1]===a}else{a="/";const m=r.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===_.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(g,r){const a=[];for(let p=0;p<g.length;p++){const m=r(g[p]);g.some((E,l)=>l===p?!1:(0,e.isEqualOrParent)(m,r(E)))||a.push(g[p])}return a}e.distinctParents=n;var P;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(a){const p=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(l=>{const[h,f]=l.split(":");h&&f&&p.set(h,f)});const E=a.path.substring(0,a.path.indexOf(";"));return E&&p.set(g.META_DATA_MIME,E),p}g.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(g,r,a){if(r){let p=g.path;return p&&p[0]!==R.posix.sep&&(p=R.posix.sep+p),g.with({scheme:a,authority:r,path:p})}return g.with({scheme:a})}e.toLocalResource=d}),define(be[11],we([0,1,20,12,3,6,45,25]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(H){return!!H&&typeof H.then=="function"}e.isThenable=y;function k(H){const M=new v.CancellationTokenSource,B=H(M.token),G=new Promise((q,se)=>{M.token.onCancellationRequested(()=>{se((0,R.canceled)())}),Promise.resolve(B).then(ve=>{M.dispose(),q(ve)},ve=>{M.dispose(),se(ve)})});return new class{cancel(){M.cancel()}then(q,se){return G.then(q,se)}catch(q){return this.then(void 0,q)}finally(q){return G.finally(q)}}}e.createCancelablePromise=k;function n(H,M,B){return Promise.race([H,new Promise(G=>M.onCancellationRequested(()=>G(B)))])}e.raceCancellation=n;async function P(H){let M=-1;const B=H.map((q,se)=>q.then(ve=>(M=se,ve))),G=await Promise.race(B);return H.forEach((q,se)=>{se!==M&&q.cancel()}),G}e.raceCancellablePromises=P;function d(H,M,B){let G;const q=setTimeout(()=>{G==null||G(void 0),B==null||B()},M);return Promise.race([H.finally(()=>clearTimeout(q)),new Promise(se=>G=se)])}e.raceTimeout=d;function g(H){return new Promise((M,B)=>{const G=H();y(G)?G.then(M,B):M(G)})}e.asPromise=g;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(B,B).then(G)})}return new Promise((B,G)=>{this.queuedPromise.then(B,G)})}return this.activePromise=M(),new Promise((B,G)=>{this.activePromise.then(q=>{this.activePromise=null,B(q)},q=>{this.activePromise=null,G(q)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=a;class p{constructor(){this.promiseMap=new Map}queue(M,B){var G;const se=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(M)===se&&this.promiseMap.delete(M)});return this.promiseMap.set(M,se),se}}e.SequencerByKey=p;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,B=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,q)=>{this.doResolve=G,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class E{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,B){return this.delayer.trigger(()=>this.throttler.queue(M),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class l{constructor(){this._isOpen=!1,this._promise=new Promise((M,B)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class h extends l{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function f(H,M){return M?new Promise((B,G)=>{const q=setTimeout(B,H);M.onCancellationRequested(()=>{clearTimeout(q),G((0,R.canceled)())})}):k(B=>f(H,B))}e.timeout=f;function t(H,M=0){const B=setTimeout(H,M);return(0,T.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=t;function i(H){return H.then(void 0,M=>{})}e.ignoreErrors=i;function s(H){const M=[];let B=0;const G=H.length;function q(){return B<G?H[B++]():null}function se(ve){ve!=null&&M.push(ve);const Le=q();return Le?Le.then(se):Promise.resolve(M)}return Promise.resolve(null).then(se)}e.sequence=s;function o(H,M=G=>!!G,B=null){let G=0;const q=H.length,se=()=>{if(G>=q)return Promise.resolve(B);const ve=H[G++];return Promise.resolve(ve()).then(xe=>M(xe)?Promise.resolve(xe):se())};return se()}e.first=o;function c(H,M=G=>!!G,B=null){if(H.length===0)return Promise.resolve(B);let G=H.length;const q=()=>{var se,ve;G=-1;for(const Le of H)(ve=(se=Le).cancel)===null||ve===void 0||ve.call(se)};return new Promise((se,ve)=>{for(const Le of H)Le.then(xe=>{--G>=0&&M(xe)?(q(),se(xe)):G===0&&se(B)}).catch(xe=>{--G>=0&&(q(),ve(xe))})})}e.firstParallel=c;class w{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((B,G)=>{this.outstandingPromises.push({factory:M,c:B,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const B=M.factory();B.then(M.c,M.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class b extends w{constructor(){super(1)}}e.Queue=b;class A{constructor(){this.queues=new Map}queueFor(M,B=S.extUri){const G=B.getComparisonKey(M);let q=this.queues.get(G);return q||(q=new b,D.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(G)}),this.queues.set(G,q)),q}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=A;class C{constructor(M,B){this._token=-1,typeof M=="function"&&typeof B=="number"&&this.setIfNotSet(M,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},B)}setIfNotSet(M,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},B))}}e.TimeoutTimer=C;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,B){this.cancel(),this._token=setInterval(()=>{M()},B)}}e.IntervalTimer=u;class F{constructor(M,B){this.timeoutToken=-1,this.runner=M,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class O extends F{constructor(M,B){super(M,B);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const B=setTimeout(()=>M(H));let G=!1;return{dispose(){G||(G=!0,clearTimeout(B))}}}}else e.runWhenIdle=(H,M)=>{const B=requestIdleCallback(H,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(B))}}}}();class z{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function de(H,M,B){let G;for(let q=0;q<B;q++)try{return await H()}catch(se){G=se,await f(M)}throw G}e.retry=de;class he{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,B,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:B},B.then(()=>this.donePending(M),()=>this.donePending(M)),B}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let B,G;const q=new Promise((se,ve)=>{B=se,G=ve});this._next={run:M,promise:q,promiseResolve:B,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=he;class ${constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,B)=>{this.completeCallback=M,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(B=>{this.completeCallback(M),this.resolved=!0,B()})}error(M){return new Promise(B=>{this.errorCallback(M),this.rejected=!0,B()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=j;class W extends D.Emitter{async fireAsync(M,B,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,M]);for(;this._asyncDeliveryQueue.size>0&&!B.isCancellationRequested;){const[q,se]=this._asyncDeliveryQueue.shift(),ve=[],Le=Object.assign(Object.assign({},se),{waitUntil:xe=>{if(Object.isFrozen(ve))throw new Error("waitUntil can NOT be called asynchronous");G&&(xe=G(xe,typeof q=="function"?q:q[0])),ve.push(xe)}});try{typeof q=="function"?q.call(void 0,Le):q[0].call(q[1],Le)}catch(xe){(0,R.onUnexpectedError)(xe);continue}Object.freeze(ve),await I.settled(ve).catch(xe=>(0,R.onUnexpectedError)(xe))}}}}e.AsyncEmitter=W;var I;(function(H){async function M(se){return typeof Promise.allSettled=="function"?B(se):G(se)}H.allSettled=M;async function B(se){return Promise.allSettled(se)}async function G(se){return Promise.all(se.map(ve=>ve.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function q(se){let ve;const Le=await Promise.all(se.map(xe=>xe.then(Me=>Me,Me=>{ve||(ve=Me)})));if(typeof ve!="undefined")throw ve;return Le}H.settled=q})(I=e.Promises||(e.Promises={}))}),define(be[114],we([0,1,14,11]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new R.IdleValue(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(C,u,F=!1){const O=C||"",z=u||"",de=D.value.collator.compare(O,z);return D.value.collatorIsNumeric&&de===0&&O!==z?O<z?-1:1:de}e.compareFileNames=S;function y(C,u){const F=T.value.collator;return C=C||"",u=u||"",f(F,C,u)}e.compareFileNamesDefault=y;function k(C,u){const F=T.value.collator;return C=C||"",u=u||"",o(C,u)||f(F,C,u)}e.compareFileNamesUpper=k;function n(C,u){const F=T.value.collator;return C=C||"",u=u||"",s(C,u)||f(F,C,u)}e.compareFileNamesLower=n;function P(C,u){return C=C||"",u=u||"",C===u?0:C<u?-1:1}e.compareFileNamesUnicode=P;function d(C,u,F=!1){F||(C=C&&C.toLowerCase(),u=u&&u.toLowerCase());const[O,z]=l(C),[de,he]=l(u);return O!==de?O<de?-1:1:z===he?0:z<he?-1:1}e.noIntlCompareFileNames=d;function g(C,u){const[F,O]=l(C),[z,de]=l(u);let he=D.value.collator.compare(O,de);if(he===0){if(D.value.collatorIsNumeric&&O!==de)return O<de?-1:1;if(he=D.value.collator.compare(F,z),D.value.collatorIsNumeric&&he===0&&F!==z)return F<z?-1:1}return he}e.compareFileExtensions=g;function r(C,u){C=C||"",u=u||"";const F=h(C),O=h(u),z=T.value.collator,de=_.value.collator;return f(de,F,O)||f(z,C,u)}e.compareFileExtensionsDefault=r;function a(C,u){C=C||"",u=u||"";const F=h(C),O=h(u),z=T.value.collator,de=_.value.collator;return f(de,F,O)||o(C,u)||f(z,C,u)}e.compareFileExtensionsUpper=a;function p(C,u){C=C||"",u=u||"";const F=h(C),O=h(u),z=T.value.collator,de=_.value.collator;return f(de,F,O)||s(C,u)||f(z,C,u)}e.compareFileExtensionsLower=p;function m(C,u){C=C||"",u=u||"";const F=h(C).toLowerCase(),O=h(u).toLowerCase();return F!==O?F<O?-1:1:C!==u?C<u?-1:1:0}e.compareFileExtensionsUnicode=m;const E=/^(.*?)(\.([^.]*))?$/;function l(C,u=!1){const F=C?E.exec(C):[];let O=[F&&F[1]||"",F&&F[3]||""];return u&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function h(C){const u=C?E.exec(C):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function f(C,u,F){let O=C.compare(u,F);return O!==0?O:u.length!==F.length?u.length<F.length?-1:1:0}function t(C){const u=C.charAt(0);return u.toLocaleUpperCase()!==u}function i(C){const u=C.charAt(0);return u.toLocaleLowerCase()!==u}function s(C,u){return t(C)&&i(u)?-1:i(C)&&t(u)?1:0}function o(C,u){return i(C)&&t(u)?-1:t(C)&&i(u)?1:0}function c(C,u,F=!1){return F||(C=C&&C.toLowerCase(),u=u&&u.toLowerCase()),C===u?0:C<u?-1:1}function w(C,u,F=!1){const O=C.split(v.sep),z=u.split(v.sep),de=O.length-1,he=z.length-1;let $,j;for(let W=0;;W++){if($=de===W,j=he===W,$&&j)return S(O[W],z[W],F);if($)return-1;if(j)return 1;const I=c(O[W],z[W],F);if(I!==0)return I}}e.comparePaths=w;function b(C,u,F){const O=C.toLowerCase(),z=u.toLowerCase(),de=A(C,u,F);if(de)return de;const he=O.endsWith(F),$=z.endsWith(F);if(he!==$)return he?-1:1;const j=S(O,z);return j!==0?j:O.localeCompare(z)}e.compareAnything=b;function A(C,u,F){const O=C.toLowerCase(),z=u.toLowerCase(),de=O.startsWith(F),he=z.startsWith(F);if(de!==he)return de?-1:1;if(de&&he){if(O.length<z.length)return-1;if(O.length>z.length)return 1}return 0}e.compareByPrefix=A}),define(be[28],we([0,1,8,36,14,22,11]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const y="**",k="/",n="[/\\\\]",P="[^/\\\\]",d=/\//g;function g(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function r(B,G){if(!B)return[];const q=[];let se=!1,ve=!1,Le="";for(const xe of B){switch(xe){case G:if(!se&&!ve){q.push(Le),Le="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}Le+=xe}return Le&&q.push(Le),q}e.splitGlobAware=r;function a(B){if(!B)return"";let G="";const q=r(B,k);if(q.every(se=>se===y))G=".*";else{let se=!1;q.forEach((ve,Le)=>{if(ve===y){se||(G+=g(2),se=!0);return}let xe=!1,Me="",ze=!1,Ve="";for(const x of ve){if(x!=="}"&&xe){Me+=x;continue}if(ze&&(x!=="]"||!Ve)){let Q;x==="-"?Q=x:(x==="^"||x==="!")&&!Ve?Q="^":x===k?Q="":Q=v.escapeRegExpCharacters(x),Ve+=Q;continue}switch(x){case"{":xe=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Me,",").map(ie=>a(ie)).join("|")})`,xe=!1,Me="";break;case"]":G+="["+Ve+"]",ze=!1,Ve="";break;case"?":G+=P;continue;case"*":G+=g(1);continue;default:G+=v.escapeRegExpCharacters(x)}}Le<q.length-1&&(q[Le+1]!==y||Le+2<q.length)&&(G+=n),se=!1})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),i=function(){return!1},s=function(){return null};function o(B,G){if(!B)return s;let q;typeof B!="string"?q=B.pattern:q=B,q=q.trim();const se=`${q}_${!!G.trimForExclusions}`;let ve=t.get(se);if(ve)return c(ve,B);let Le;if(p.test(q)){const xe=q.substr(4);ve=function(Me,ze){return typeof Me=="string"&&Me.endsWith(xe)?q:null}}else(Le=m.exec(w(q,G)))?ve=b(Le[1],q):(G.trimForExclusions?l:E).test(q)?ve=A(q,G):(Le=h.exec(w(q,G)))?ve=C(Le[1].substr(1),q,!0):(Le=f.exec(w(q,G)))?ve=C(Le[1],q,!1):ve=u(q);return t.set(se,ve),c(ve,B)}function c(B,G){return typeof G=="string"?B:function(q,se){return R.isEqualOrParent(q,G.base)?B(D.relative(G.base,q),se):null}}function w(B,G){return G.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function b(B,G){const q=`/${B}`,se=`\\${B}`,ve=function(xe,Me){return typeof xe!="string"?null:Me?Me===B?G:null:xe===B||xe.endsWith(q)||xe.endsWith(se)?G:null},Le=[B];return ve.basenames=Le,ve.patterns=[G],ve.allBasenames=Le,ve}function A(B,G){const q=M(B.slice(1,-1).split(",").map(Me=>o(Me,G)).filter(Me=>Me!==s),B),se=q.length;if(!se)return s;if(se===1)return q[0];const ve=function(Me,ze){for(let Ve=0,x=q.length;Ve<x;Ve++)if(q[Ve](Me,ze))return B;return null},Le=q.find(Me=>!!Me.allBasenames);Le&&(ve.allBasenames=Le.allBasenames);const xe=q.reduce((Me,ze)=>ze.allPaths?Me.concat(ze.allPaths):Me,[]);return xe.length&&(ve.allPaths=xe),ve}function C(B,G,q){const se=D.sep===D.posix.sep,ve=se?B:B.replace(d,D.sep),Le=D.sep+ve,xe=D.posix.sep+B,Me=q?function(ze,Ve){return typeof ze=="string"&&(ze===ve||ze.endsWith(Le)||!se&&(ze===B||ze.endsWith(xe)))?G:null}:function(ze,Ve){return typeof ze=="string"&&(ze===ve||!se&&ze===B)?G:null};return Me.allPaths=[(q?"*/":"./")+B],Me}function u(B){try{const G=new RegExp(`^${a(B)}$`);return function(q){return G.lastIndex=0,typeof q=="string"&&G.test(q)?B:null}}catch(G){return s}}function F(B,G,q){return!B||typeof G!="string"?!1:O(B)(G,void 0,q)}e.match=F;function O(B,G={}){if(!B)return i;if(typeof B=="string"||$(B)){const q=o(B,G);if(q===s)return i;const se=function(ve,Le){return!!q(ve,Le)};return q.allBasenames&&(se.allBasenames=q.allBasenames),q.allPaths&&(se.allPaths=q.allPaths),se}return I(B,G)}e.parse=O;function z(B){if(!B)return;let G;return q=>(G||(G=(B()||Promise.resolve([])).then(se=>se?he(se):{})),G.then(se=>!!se[q]))}e.hasSiblingPromiseFn=z;function de(B){if(!B)return;let G;return q=>{if(!G){const se=B();G=se?he(se):{}}return!!G[q]}}e.hasSiblingFn=de;function he(B){const G={};for(const q of B)G[q]=!0;return G}function $(B){const G=B;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=$;function j(B){return B.allBasenames||[]}e.getBasenameTerms=j;function W(B){return B.allPaths||[]}e.getPathTerms=W;function I(B,G){const q=M(Object.getOwnPropertyNames(B).map(Me=>H(Me,B[Me],G)).filter(Me=>Me!==s)),se=q.length;if(!se)return s;if(!q.some(Me=>!!Me.requiresSiblings)){if(se===1)return q[0];const Me=function(x,Q){for(let te=0,ie=q.length;te<ie;te++){const fe=q[te](x,Q);if(fe)return fe}return null},ze=q.find(x=>!!x.allBasenames);ze&&(Me.allBasenames=ze.allBasenames);const Ve=q.reduce((x,Q)=>Q.allPaths?x.concat(Q.allPaths):x,[]);return Ve.length&&(Me.allPaths=Ve),Me}const ve=function(Me,ze,Ve){let x;for(let Q=0,te=q.length;Q<te;Q++){const ie=q[Q];ie.requiresSiblings&&Ve&&(ze||(ze=D.basename(Me)),x||(x=ze.substr(0,ze.length-D.extname(Me).length)));const fe=ie(Me,ze,x,Ve);if(fe)return fe}return null},Le=q.find(Me=>!!Me.allBasenames);Le&&(ve.allBasenames=Le.allBasenames);const xe=q.reduce((Me,ze)=>ze.allPaths?Me.concat(ze.allPaths):Me,[]);return xe.length&&(ve.allPaths=xe),ve}function H(B,G,q){if(G===!1)return s;const se=o(B,q);if(se===s)return s;if(typeof G=="boolean")return se;if(G){const ve=G.when;if(typeof ve=="string"){const Le=(xe,Me,ze,Ve)=>{if(!Ve||!se(xe,Me))return null;const x=ve.replace("$(basename)",ze),Q=Ve(x);return(0,_.isThenable)(Q)?Q.then(te=>te?B:null):Q?B:null};return Le.requiresSiblings=!0,Le}}return se}function M(B,G){const q=B.filter(Me=>!!Me.basenames);if(q.length<2)return B;const se=q.reduce((Me,ze)=>{const Ve=ze.basenames;return Ve?Me.concat(Ve):Me},[]);let ve;if(G){ve=[];for(let Me=0,ze=se.length;Me<ze;Me++)ve.push(G)}else ve=q.reduce((Me,ze)=>{const Ve=ze.patterns;return Ve?Me.concat(Ve):Me},[]);const Le=function(Me,ze){if(typeof Me!="string")return null;if(!ze){let x;for(x=Me.length;x>0;x--){const Q=Me.charCodeAt(x-1);if(Q===47||Q===92)break}ze=Me.substr(x)}const Ve=se.indexOf(ze);return Ve!==-1?ve[Ve]:null};Le.basenames=se,Le.patterns=ve,Le.allBasenames=se;const xe=B.filter(Me=>!Me.basenames);return xe.push(Le),xe}}),define(be[59],we([0,1,2,14,8,16,21,25,36]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(o,c,w){if(typeof o=="string"&&(o=v.URI.file(o)),w){const A=w.getWorkspaceFolder(o);if(A){const C=w.getWorkspace().folders.length>1;let u;if((0,S.isEqual)(A.uri,o)?u="":u=(0,S.relativePath)(A.uri,o),C){const F=A.name?A.name:(0,S.basename)(A.uri);u=u?F+" \u2022 "+u:F}return u}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,R.normalize)(P(o.fsPath));let b=(0,R.normalize)(o.fsPath);return!_.isWindows&&(c==null?void 0:c.userHome)&&(b=g(b,c.userHome.fsPath)),b}e.getPathLabel=k;function n(o){if(!o)return;typeof o=="string"&&(o=v.URI.file(o));const c=(0,S.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return _.isWindows&&(0,y.isRootOrDriveLetter)(c)?P(c):c}e.getBaseLabel=n;function P(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let d=Object.create(null);function g(o,c){if(_.isWindows||!o||!c)return o;let w=d.original===c?d.normalized:void 0;return w||(w=`${(0,D.rtrim)(c,R.posix.sep)}${R.posix.sep}`,d={original:c,normalized:w}),(_.isLinux?o.startsWith(w):(0,D.startsWithIgnoreCase)(o,w))&&(o=`~/${o.substr(w.length)}`),o}e.tildify=g;function r(o,c){return o.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=r;const a="\u2026",p="\\\\",m="~";function E(o,c=R.sep){const w=new Array(o.length);let b=!1;for(let A=0;A<o.length;A++){let C=o[A];if(C===""){w[A]=`.${c}`;continue}if(!C){w[A]=C;continue}b=!0;let u="";C.indexOf(p)===0?(u=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length)):C.indexOf(c)===0?(u=C.substr(0,C.indexOf(c)+c.length),C=C.substr(C.indexOf(c)+c.length)):C.indexOf(m)===0&&(u=C.substr(0,C.indexOf(m)+m.length),C=C.substr(C.indexOf(m)+m.length));const F=C.split(c);for(let O=1;b&&O<=F.length;O++)for(let z=F.length-O;b&&z>=0;z--){b=!1;let de=F.slice(z,z+O).join(c);for(let he=0;!b&&he<o.length;he++)if(he!==A&&o[he]&&o[he].indexOf(de)>-1){const $=z+O===F.length,j=z>0&&o[he].indexOf(c)>-1?c+de:de,W=o[he].endsWith(j);b=!$||W}if(!b){let he="";(F[0].endsWith(":")||u!=="")&&(z===1&&(z=0,O++,de=F[0]+c+de),z>0&&(he=F[0]+c),he=u+he),z>0&&(he=he+a+c),he=he+de,z+O<F.length&&(he=he+c+a),w[A]=he}}b&&(w[A]=C)}return w}e.shorten=E;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function h(o,c=Object.create(null)){const w=[];let b=!1,A="";for(const C of o)if(C==="$"||b&&C==="{")A&&w.push({value:A,type:l.TEXT}),A="",b=!0;else if(C==="}"&&b){const u=c[A];if(typeof u=="string")u.length&&w.push({value:u,type:l.VARIABLE});else if(u){const F=w[w.length-1];(!F||F.type!==l.SEPARATOR)&&w.push({value:u.label,type:l.SEPARATOR})}A="",b=!1}else A+=C;return A&&!b&&w.push({value:A,type:l.TEXT}),w.filter((C,u)=>{if(C.type===l.SEPARATOR){const F=w[u-1],O=w[u+1];return[F,O].every(z=>z&&(z.type===l.VARIABLE||z.type===l.TEXT)&&z.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=h;function f(o,c){return _.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):o.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(o,c){return _.isMacintosh||c?o.replace(/\(&&\w\)|&&/g,""):_.isWindows?o.replace(/&&|&/g,w=>w==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(o){const c=o.indexOf("/")!==-1?R.posix:R.win32,w=c.basename(o),b=c.dirname(o);return w.length?{name:w,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(be[115],we([0,1,2]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:R(v.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:R(v.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:v.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,P,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof v.URI)return P.transformOutgoing(n);for(let g in n)if(Object.hasOwnProperty.call(n,g)){const r=T(n[g],P,d+1);r!==null&&(n[g]=r)}}return null}function _(n,P){const d=T(n,P,0);return d===null?n:d}e.transformOutgoingURIs=_;function S(n,P,d,g){if(!n||g>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?v.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let r in n)if(Object.hasOwnProperty.call(n,r)){const a=S(n[r],P,d,g+1);a!==null&&(n[r]=a)}}return null}function y(n,P){const d=S(n,P,!1,0);return d===null?n:d}e.transformIncomingURIs=y;function k(n,P){const d=S(n,P,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=k}),define(be[37],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return v.test(y)}e.isUUID=R;const D=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(y){for(let k=0;k<y.length;k++)y[k]=Math.floor(Math.random()*256);return y};function S(){_(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,k="";return k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k+="-",k+=T[D[y++]],k+=T[D[y++]],k+="-",k+=T[D[y++]],k+=T[D[y++]],k+="-",k+=T[D[y++]],k+=T[D[y++]],k+="-",k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k+=T[D[y++]],k}e.generateUuid=S}),define(be[84],we([0,1,82]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(S){let y=(0,v.toUint8)(S);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(S){let y=new Uint8Array(256);for(let k=0;k<256;k++)y[k]=S;return y}set(S,y){let k=(0,v.toUint8)(y);S>=0&&S<256?this._asciiMap[S]=k:this._map.set(S,k)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=R;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class T{constructor(){this._actual=new R(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=T}),define(be[116],we([0,1,84]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends v.CharacterClassifier{constructor(S){super(0);for(let y=0,k=S.length;y<k;y++)this.set(S.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function T(_){let S={};return y=>(S.hasOwnProperty(y)||(S[y]=_(y)),S[y])}e.getMapForWordSeparators=T(_=>new D(_))}),define(be[38],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(D,T){this.lineNumber=D,this.column=T}with(D=this.lineNumber,T=this.column){return D===this.lineNumber&&T===this.column?this:new v(D,T)}delta(D=0,T=0){return this.with(this.lineNumber+D,this.column+T)}equals(D){return v.equals(this,D)}static equals(D,T){return!D&&!T?!0:!!D&&!!T&&D.lineNumber===T.lineNumber&&D.column===T.column}isBefore(D){return v.isBefore(this,D)}static isBefore(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<T.column}isBeforeOrEqual(D){return v.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<=T.column}static compare(D,T){let _=D.lineNumber|0,S=T.lineNumber|0;if(_===S){let y=D.column|0,k=T.column|0;return y-k}return _-S}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new v(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=v}),define(be[31],we([0,1,38]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,_,S,y){T>S||T===S&&_>y?(this.startLineNumber=S,this.startColumn=y,this.endLineNumber=T,this.endColumn=_):(this.startLineNumber=T,this.startColumn=_,this.endLineNumber=S,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,_){return!(_.lineNumber<T.startLineNumber||_.lineNumber>T.endLineNumber||_.lineNumber===T.startLineNumber&&_.column<T.startColumn||_.lineNumber===T.endLineNumber&&_.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,_){return!(_.startLineNumber<T.startLineNumber||_.endLineNumber<T.startLineNumber||_.startLineNumber>T.endLineNumber||_.endLineNumber>T.endLineNumber||_.startLineNumber===T.startLineNumber&&_.startColumn<T.startColumn||_.endLineNumber===T.endLineNumber&&_.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,_){return!(_.startLineNumber<T.startLineNumber||_.endLineNumber<T.startLineNumber||_.startLineNumber>T.endLineNumber||_.endLineNumber>T.endLineNumber||_.startLineNumber===T.startLineNumber&&_.startColumn<=T.startColumn||_.endLineNumber===T.endLineNumber&&_.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,_){let S,y,k,n;return _.startLineNumber<T.startLineNumber?(S=_.startLineNumber,y=_.startColumn):_.startLineNumber===T.startLineNumber?(S=_.startLineNumber,y=Math.min(_.startColumn,T.startColumn)):(S=T.startLineNumber,y=T.startColumn),_.endLineNumber>T.endLineNumber?(k=_.endLineNumber,n=_.endColumn):_.endLineNumber===T.endLineNumber?(k=_.endLineNumber,n=Math.max(_.endColumn,T.endColumn)):(k=T.endLineNumber,n=T.endColumn),new R(S,y,k,n)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,_){let S=T.startLineNumber,y=T.startColumn,k=T.endLineNumber,n=T.endColumn,P=_.startLineNumber,d=_.startColumn,g=_.endLineNumber,r=_.endColumn;return S<P?(S=P,y=d):S===P&&(y=Math.max(y,d)),k>g?(k=g,n=r):k===g&&(n=Math.min(n,r)),S>k||S===k&&y>n?null:new R(S,y,k,n)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,_){return!!T&&!!_&&T.startLineNumber===_.startLineNumber&&T.startColumn===_.startColumn&&T.endLineNumber===_.endLineNumber&&T.endColumn===_.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new v.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new v.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,_){return new R(this.startLineNumber,this.startColumn,T,_)}setStartPosition(T,_){return new R(T,_,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,_=T){return new R(T.lineNumber,T.column,_.lineNumber,_.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,_){return!(T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<_.startColumn||_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<T.startColumn)}static areIntersecting(T,_){return!(T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<=_.startColumn||_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,_){if(T&&_){const k=T.startLineNumber|0,n=_.startLineNumber|0;if(k===n){const P=T.startColumn|0,d=_.startColumn|0;if(P===d){const g=T.endLineNumber|0,r=_.endLineNumber|0;if(g===r){const a=T.endColumn|0,p=_.endColumn|0;return a-p}return g-r}return P-d}return k-n}return(T?1:0)-(_?1:0)}static compareRangesUsingEnds(T,_){return T.endLineNumber===_.endLineNumber?T.endColumn===_.endColumn?T.startLineNumber===_.startLineNumber?T.startColumn-_.startColumn:T.startLineNumber-_.startLineNumber:T.endColumn-_.endColumn:T.endLineNumber-_.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(be[117],we([0,1,38,31]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(S,y,k,n){super(S,y,k,n);this.selectionStartLineNumber=S,this.selectionStartColumn=y,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return T.selectionsEqual(this,S)}static selectionsEqual(S,y){return S.selectionStartLineNumber===y.selectionStartLineNumber&&S.selectionStartColumn===y.selectionStartColumn&&S.positionLineNumber===y.positionLineNumber&&S.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,S,y):new T(S,y,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,y){return this.getDirection()===0?new T(S,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,S,y)}static fromPositions(S,y=S){return new T(S.lineNumber,S.column,y.lineNumber,y.column)}static liftSelection(S){return new T(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,y){if(S&&!y||!S&&y)return!1;if(!S&&!y)return!0;if(S.length!==y.length)return!1;for(let k=0,n=S.length;k<n;k++)if(!this.selectionsEqual(S[k],y[k]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,y,k,n,P){return P===0?new T(S,y,k,n):new T(k,n,S,y)}}e.Selection=T}),define(be[85],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class y{constructor(a,p){this.range=a,this.matches=p}}e.FindMatch=y;var k;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class d{constructor(a,p,m,E,l,h){this.identifier=a,this.range=p,this.text=m,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=l,this._isTracked=h}}e.ValidAnnotatedEditOperation=d;class g{constructor(a,p,m){this.reverseEdits=a,this.changes=p,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=g}),define(be[118],we([0,1,8,116,38,31,85]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class y{constructor(l,h,f,t){this.searchString=l,this.isRegex=h,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let h=null;try{h=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let f=!this.isRegex&&!l;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new n(h,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=y;function k(E){if(!E||E.length===0)return!1;for(let l=0,h=E.length;l<h;l++)if(E.charCodeAt(l)===92){if(l++,l>=h)break;const t=E.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(l,h,f){this.regex=l,this.wordSeparators=h,this.simpleSearch=f}}e.SearchData=n;function P(E,l,h){if(!h)return new _.FindMatch(E,null);let f=[];for(let t=0,i=l.length;t<i;t++)f[t]=l[t];return new _.FindMatch(E,f)}e.createFindMatch=P;class d{constructor(l){let h=[],f=0;for(let t=0,i=l.length;t<i;t++)l.charCodeAt(t)===10&&(h[f++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(l){const h=this._lineFeedsOffsets;let f=0,t=h.length-1;if(t===-1||l<=h[0])return 0;for(;f<t;){const i=f+((t-f)/2>>0);h[i]>=l?t=i-1:h[i+1]>=l?(f=i,t=i):f=i+1}return f+1}}class g{static findMatches(l,h,f,t,i){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,f,new m(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(l,f,s,t,i):[]}static _getMultilineMatchRange(l,h,f,t,i,s){let o,c=0;t?(c=t.findLineFeedCountBeforeOffset(i),o=h+i+c):o=h+i;let w;if(t){let u=t.findLineFeedCountBeforeOffset(i+s.length)-c;w=o+s.length+u}else w=o+s.length;const b=l.getPositionAt(o),A=l.getPositionAt(w);return new T.Range(b.lineNumber,b.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(l,h,f,t,i){const s=l.getOffsetAt(h.getStartPosition()),o=l.getValueInRange(h,1),c=l.getEOL()===`\r
`?new d(o):null,w=[];let b=0,A;for(f.reset(0);A=f.next(o);)if(w[b++]=P(this._getMultilineMatchRange(l,s,o,c,A.index,A[0]),A,t),b>=i)return w;return w}static _doFindMatchesLineByLine(l,h,f,t,i){const s=[];let o=0;if(h.startLineNumber===h.endLineNumber){const w=l.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return o=this._findMatchesInLine(f,w,h.startLineNumber,h.startColumn-1,o,s,t,i),s}const c=l.getLineContent(h.startLineNumber).substring(h.startColumn-1);o=this._findMatchesInLine(f,c,h.startLineNumber,h.startColumn-1,o,s,t,i);for(let w=h.startLineNumber+1;w<h.endLineNumber&&o<i;w++)o=this._findMatchesInLine(f,l.getLineContent(w),w,0,o,s,t,i);if(o<i){const w=l.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);o=this._findMatchesInLine(f,w,h.endLineNumber,0,o,s,t,i)}return s}static _findMatchesInLine(l,h,f,t,i,s,o,c){const w=l.wordSeparators;if(!o&&l.simpleSearch){const C=l.simpleSearch,u=C.length,F=h.length;let O=-u;for(;(O=h.indexOf(C,O+u))!==-1;)if((!w||p(w,h,F,O,u))&&(s[i++]=new _.FindMatch(new T.Range(f,O+1+t,f,O+1+u+t),null),i>=c))return i;return i}const b=new m(l.wordSeparators,l.regex);let A;b.reset(0);do if(A=b.next(h),A&&(s[i++]=P(new T.Range(f,A.index+1+t,f,A.index+1+A[0].length+t),A,o),i>=c))return i;while(A);return i}static findNextMatch(l,h,f,t){const i=h.parseSearchRequest();if(!i)return null;const s=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(l,f,s,t):this._doFindNextMatchLineByLine(l,f,s,t)}static _doFindNextMatchMultiline(l,h,f,t){const i=new D.Position(h.lineNumber,1),s=l.getOffsetAt(i),o=l.getLineCount(),c=l.getValueInRange(new T.Range(i.lineNumber,i.column,o,l.getLineMaxColumn(o)),1),w=l.getEOL()===`\r
`?new d(c):null;f.reset(h.column-1);let b=f.next(c);return b?P(this._getMultilineMatchRange(l,s,c,w,b.index,b[0]),b,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(l,new D.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(l,h,f,t){const i=l.getLineCount(),s=h.lineNumber,o=l.getLineContent(s),c=this._findFirstMatchInLine(f,o,s,h.column,t);if(c)return c;for(let w=1;w<=i;w++){const b=(s+w-1)%i,A=l.getLineContent(b+1),C=this._findFirstMatchInLine(f,A,b+1,1,t);if(C)return C}return null}static _findFirstMatchInLine(l,h,f,t,i){l.reset(t-1);const s=l.next(h);return s?P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,i):null}static findPreviousMatch(l,h,f,t){const i=h.parseSearchRequest();if(!i)return null;const s=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(l,f,s,t):this._doFindPreviousMatchLineByLine(l,f,s,t)}static _doFindPreviousMatchMultiline(l,h,f,t){const i=this._doFindMatchesMultiline(l,new T.Range(1,1,h.lineNumber,h.column),f,t,10*S);if(i.length>0)return i[i.length-1];const s=l.getLineCount();return h.lineNumber!==s||h.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new D.Position(s,l.getLineMaxColumn(s)),f,t):null}static _doFindPreviousMatchLineByLine(l,h,f,t){const i=l.getLineCount(),s=h.lineNumber,o=l.getLineContent(s).substring(0,h.column-1),c=this._findLastMatchInLine(f,o,s,t);if(c)return c;for(let w=1;w<=i;w++){const b=(i+s-w-1)%i,A=l.getLineContent(b+1),C=this._findLastMatchInLine(f,A,b+1,t);if(C)return C}return null}static _findLastMatchInLine(l,h,f,t){let i=null,s;for(l.reset(0);s=l.next(h);)i=P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=g;function r(E,l,h,f,t){if(f===0)return!0;const i=l.charCodeAt(f-1);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=l.charCodeAt(f);if(E.get(s)!==0)return!0}return!1}function a(E,l,h,f,t){if(f+t===h)return!0;const i=l.charCodeAt(f+t);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=l.charCodeAt(f+t-1);if(E.get(s)!==0)return!0}return!1}function p(E,l,h,f,t){return r(E,l,h,f,t)&&a(E,l,h,f,t)}e.isValidMatch=p;class m{constructor(l,h){this._wordSeparators=l,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const h=l.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(f=this._searchRegex.exec(l),!f))return null;const t=f.index,i=f[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){v.getNextCodePoint(l,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||p(this._wordSeparators,l,h,t,i))return f}while(f);return null}}e.Searcher=m}),define(be[86],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(S=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)S.indexOf(k)>=0||(y+="\\"+k);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=v();function R(S){let y=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)y=S;else{let k="g";S.ignoreCase&&(k+="i"),S.multiline&&(k+="m"),S.unicode&&(k+="u"),y=new RegExp(S.source,k)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const D={maxLen:1e3,windowSize:15,timeBudget:150};function T(S,y,k,n,P=D){if(k.length>P.maxLen){let p=S-P.maxLen/2;return p<0?p=0:n+=p,k=k.substring(p,S+P.maxLen/2),T(S,y,k,n,P)}const d=Date.now(),g=S-1-n;let r=-1,a=null;for(let p=1;!(Date.now()-d>=P.timeBudget);p++){const m=g-P.windowSize*p;y.lastIndex=Math.max(0,m);const E=_(y,k,g,r);if(!E&&a||(a=E,m<=0))break;r=m}if(a){let p={word:a[0],startColumn:n+1+a.index,endColumn:n+1+a.index+a[0].length};return y.lastIndex=0,p}return null}e.getWordAtText=T;function _(S,y,k,n){let P;for(;P=S.exec(y);){const d=P.index||0;if(d<=k&&S.lastIndex>=k)return P;if(n>0&&d>n)return null}return null}}),define(be[119],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(S){if(this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let y=0,k=S.notIn.length;y<k;y++)switch(S.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=R;class D{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of S)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function T(_,S,y){_.has(S)?_.get(S).push(y):_.set(S,[y])}}),define(be[60],we([0,1,28,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(T,_,S,y){if(Array.isArray(T)){let k=0;for(const n of T){const P=D(n,_,S,y);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return y?T==="*"?5:T===S?10:0:0;if(T){const{language:k,pattern:n,scheme:P,hasAccessToAllModels:d}=T;if(!y&&!d)return 0;let g=0;if(P)if(P===_.scheme)g=10;else if(P==="*")g=5;else return 0;if(k)if(k===S)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(n){let r;if(typeof n=="string"?r=n:r=Object.assign(Object.assign({},n),{base:(0,R.normalize)(n.base)}),r===_.fsPath||(0,v.match)(r,_.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(be[120],we([0,1,84]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class D{constructor(r,a,p){const m=new Uint8Array(r*a);for(let E=0,l=r*a;E<l;E++)m[E]=p;this._data=m,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,p){this._data[r*this.cols+a]=p}}e.Uint8Matrix=D;class T{constructor(r){let a=0,p=0;for(let E=0,l=r.length;E<l;E++){let[h,f,t]=r[E];f>a&&(a=f),h>p&&(p=h),t>p&&(p=t)}a++,p++;let m=new D(p,a,0);for(let E=0,l=r.length;E<l;E++){let[h,f,t]=r[E];m.set(h,f,t)}this._states=m,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=T;let _=null;function S(){return _===null&&(_=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let k=null;function n(){if(k===null){k=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<g.length;a++)k.set(g.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)k.set(r.charCodeAt(a),2)}return k}class P{static _createLink(r,a,p,m,E){let l=E-1;do{const h=a.charCodeAt(l);if(r.get(h)!==2)break;l--}while(l>m);if(m>0){const h=a.charCodeAt(m-1),f=a.charCodeAt(l);(h===40&&f===41||h===91&&f===93||h===123&&f===125)&&l--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:l+2},url:a.substring(m,l+1)}}static computeLinks(r,a=S()){const p=n();let m=[];for(let E=1,l=r.getLineCount();E<=l;E++){const h=r.getLineContent(E),f=h.length;let t=0,i=0,s=0,o=1,c=!1,w=!1,b=!1,A=!1;for(;t<f;){let C=!1;const u=h.charCodeAt(t);if(o===13){let F;switch(u){case 40:c=!0,F=0;break;case 41:F=c?0:1;break;case 91:b=!0,w=!0,F=0;break;case 93:b=!1,F=w?0:1;break;case 123:A=!0,F=0;break;case 125:F=A?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=b?0:1;break;default:F=p.get(u)}F===1&&(m.push(P._createLink(p,h,E,i,t)),C=!0)}else if(o===12){let F;u===91?(w=!0,F=0):F=p.get(u),F===1?C=!0:o=13}else o=a.nextState(o,u),o===0&&(C=!0);C&&(o=1,c=!1,w=!1,A=!1,i=t+1,s=u),t++}o===13&&m.push(P._createLink(p,h,E,i,f))}return m}}e.LinkComputer=P;function d(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:P.computeLinks(g)}e.computeLinks=d}),define(be[121],we([0,1,3,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,S){return this._map.set(_,S),this.fire([_]),(0,R.toDisposable)(()=>{this._map.get(_)===S&&(this._map.delete(_),this.fire([_]))})}registerPromise(_,S){let y=null,k=!1;return this._promises.set(_,S.then(n=>{this._promises.delete(_),!(k||!n)&&(y=this.register(_,n))})),(0,R.toDisposable)(()=>{k=!0,y&&y.dispose()})}getPromise(_){const S=this.get(_);if(S)return Promise.resolve(S);const y=this._promises.get(_);return y?y.then(k=>this.get(_)):null}get(_){return this._map.get(_)||null}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(be[87],we([0,1,24,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function T(P){for(let d=0,g=P.length;d<g;d+=4){const r=P[d+0],a=P[d+1],p=P[d+2],m=P[d+3];P[d+0]=m,P[d+1]=p,P[d+2]=a,P[d+3]=r}}function _(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||T(d),v.VSBuffer.wrap(d)}function S(P){const d=P.buffer;if(R.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const g=new Uint8Array(d.byteLength);return g.set(d),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(P){const d=new Uint32Array(k(P));let g=0;if(d[g++]=P.id,P.type==="full")d[g++]=1,d[g++]=P.data.length,d.set(P.data,g),g+=P.data.length;else{d[g++]=2,d[g++]=P.deltas.length;for(const r of P.deltas)d[g++]=r.start,d[g++]=r.deleteCount,r.data?(d[g++]=r.data.length,d.set(r.data,g),g+=r.data.length):d[g++]=0}return _(d)}e.encodeSemanticTokensDto=y;function k(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const g of P.deltas)g.data&&(d+=g.data.length)}return d}function n(P){const d=S(P);let g=0;const r=d[g++];if(d[g++]===1){const E=d[g++],l=d.subarray(g,g+E);return g+=E,{id:r,type:"full",data:l}}const p=d[g++];let m=[];for(let E=0;E<p;E++){const l=d[g++],h=d[g++],f=d[g++];let t;f>0&&(t=d.subarray(g,g+f),g+=f),m[E]={start:l,deleteCount:h,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=n}),define(be[88],we([0,1,82]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(_,S){this.index=_,this.remainder=S}}e.PrefixSumIndexOfResult=R;class D{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,S){_=(0,v.toUint32)(_);const y=this.values,k=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,_),0),this.values.set(y.subarray(_),_+n),this.values.set(S,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(_,S){return _=(0,v.toUint32)(_),S=(0,v.toUint32)(S),this.values[_]===S?!1:(this.values[_]=S,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,S){_=(0,v.toUint32)(_),S=(0,v.toUint32)(S);const y=this.values,k=this.prefixSum;if(_>=y.length)return!1;let n=y.length-_;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(y.length-S),this.values.set(y.subarray(0,_),0),this.values.set(y.subarray(_+S),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(_){return _<0?0:(_=(0,v.toUint32)(_),this._getAccumulatedValue(_))}_getAccumulatedValue(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),_>=this.values.length&&(_=this.values.length-1);for(let y=S;y<=_;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalValue();let S=0,y=this.values.length-1,k=0,n=0,P=0;for(;S<=y;)if(k=S+(y-S)/2|0,n=this.prefixSum[k],P=n-this.values[k],_<P)y=k-1;else if(_>=n)S=k+1;else break;return new R(k,_-P)}}e.PrefixSumComputer=D}),define(be[122],we([0,1,8,38,88]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(S,y,k,n){this._uri=S,this._lines=y,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const y=S.changes;for(const k of y)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,y=this._lines.length,k=new Uint32Array(y);for(let n=0;n<y;n++)k[n]=this._lines[n].length+S;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(S,y){this._lines[S]=y,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,y){if(y.length===0)return;let k=(0,v.splitLines)(y);if(k.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+k[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}k[k.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(S.lineNumber+P-1,0,k[P]),n[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=T}),define(be[123],we([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(be[61],we([0,1,123,10,13]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,n){return n&&(k.stack||k.stacktrace)?v.localize(0,null,S(k),_(k.stack)||_(k.stacktrace)):S(k)}function _(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?v.localize(1,null,k.message):k.message||v.localize(2,null)}function y(k=null,n=!1){if(!k)return v.localize(3,null);if(Array.isArray(k)){const P=D.coalesce(k),d=y(P[0],n);return P.length>1?v.localize(4,null,d,P.length):d}if(R.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,n);if(P.exception)return T(P.exception,n)}return k.stack?T(k,n):k.message?k.message:v.localize(5,null)}e.toErrorMessage=y}),define(be[124],we([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(be[125],we([0,1,124,21,86]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=_;class S{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,me){this._values[ee]=me}}e.ValidatedEditorOptions=S;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class k{constructor(ee,me,Ne,He){this.id=ee,this.name=me,this.defaultValue=Ne,this.schema=He}compute(ee,me,Ne){return Ne}}class n{constructor(ee,me=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(ee){return this.defaultValue}}class P{constructor(ee,me,Ne,He){this.id=ee,this.name=me,this.defaultValue=Ne,this.schema=He}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,me,Ne){return Ne}}function d(V,ee){return typeof V=="undefined"?ee:V==="false"?!1:Boolean(V)}e.boolean=d;class g extends P{constructor(ee,me,Ne,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ne),super(ee,me,Ne,He)}validate(ee){return d(ee,this.defaultValue)}}class r extends P{constructor(ee,me,Ne,He,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ne,Ye.minimum=He,Ye.maximum=$e),super(ee,me,Ne,Ye),this.minimum=He,this.maximum=$e}static clampedInt(ee,me,Ne,He){if(typeof ee=="undefined")return me;let $e=parseInt(ee,10);return isNaN($e)?me:($e=Math.max(Ne,$e),$e=Math.min(He,$e),$e|0)}validate(ee){return r.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class a extends P{constructor(ee,me,Ne,He,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ee,me,Ne,$e),this.validationFn=He}static clamp(ee,me,Ne){return ee<me?me:ee>Ne?Ne:ee}static float(ee,me){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return me;const Ne=parseFloat(ee);return isNaN(Ne)?me:Ne}validate(ee){return this.validationFn(a.float(ee,this.defaultValue))}}class p extends P{static string(ee,me){return typeof ee!="string"?me:ee}constructor(ee,me,Ne,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ne),super(ee,me,Ne,He)}validate(ee){return p.string(ee,this.defaultValue)}}function m(V,ee,me){return typeof V!="string"||me.indexOf(V)===-1?ee:V}e.stringSet=m;class E extends P{constructor(ee,me,Ne,He,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=He,$e.default=Ne),super(ee,me,Ne,$e),this._allowedValues=He}validate(ee){return m(ee,this.defaultValue,this._allowedValues)}}class l extends k{constructor(ee,me,Ne,He,$e,Ye,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=$e,De.default=He),super(ee,me,Ne,De),this._allowedValues=$e,this._convert=Ye}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function h(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,me,Ne){return Ne===0?ee.accessibilitySupport:Ne}}class t extends k{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function w(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends n{constructor(){super(124,[62,31])}compute(ee,me,Ne){const He=["monaco-editor"];return me.get(31)&&He.push(me.get(31)),ee.extraEditorClassName&&He.push(ee.extraEditorClassName),me.get(62)==="default"?He.push("mouse-default"):me.get(62)==="copy"&&He.push("mouse-copy"),me.get(97)&&He.push("showUnused"),me.get(122)&&He.push("showDeprecated"),He.join(" ")}}class A extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ee,me,Ne){return Ne&&ee.emptySelectionClipboard}}class C extends k{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:v.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":m(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class u extends k{constructor(){super(41,"fontLigatures",u.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?u.OFF:ee==="true"?u.ON:ee:Boolean(ee)?u.ON:u.OFF}}e.EditorFontLigatures=u,u.OFF='"liga" off, "calt" off',u.ON='"liga" on, "calt" on';class F extends n{constructor(){super(40)}compute(ee,me,Ne){return ee.fontInfo}}class O extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(ee){let me=a.float(ee,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(me,6,100)}compute(ee,me,Ne){return ee.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(r.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class de extends k{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ne,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ne,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ne,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ne,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ne,description:v.localize(35,null)}})}validate(ee){var me,Ne,He,$e,Ye;if(!ee||typeof ee!="object")return this.defaultValue;const De=ee;return{multiple:m(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=De.multipleDefinitions)!==null&&me!==void 0?me:m(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=De.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:m(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=De.multipleDeclarations)!==null&&He!==void 0?He:m(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=De.multipleImplementations)!==null&&$e!==void 0?$e:m(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=De.multipleReferences)!==null&&Ye!==void 0?Ye:m(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends k{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:v.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:r.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky)}}}var $;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class j extends n{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ee,me,Ne){return j.computeLayout(me,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const me=ee.height/ee.lineHeight,Ne=ee.scrollBeyondLastLine?me-1:0,He=(ee.viewLineCount+Ne)/(ee.pixelRatio*ee.height),$e=Math.floor(ee.viewLineCount/He);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ne,desiredRatio:He,minimapLineCount:$e}}static _computeMinimapLayout(ee,me){const Ne=ee.outerWidth,He=ee.outerHeight,$e=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ye=me.stableMinimapLayoutInput,De=Ye&&ee.outerHeight===Ye.outerHeight&&ee.lineHeight===Ye.lineHeight&&ee.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Ye.pixelRatio&&ee.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&ee.minimap.enabled===Ye.minimap.enabled&&ee.minimap.side===Ye.minimap.side&&ee.minimap.size===Ye.minimap.size&&ee.minimap.showSlider===Ye.minimap.showSlider&&ee.minimap.renderCharacters===Ye.minimap.renderCharacters&&ee.minimap.maxColumn===Ye.minimap.maxColumn&&ee.minimap.scale===Ye.minimap.scale&&ee.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&ee.isViewportWrapping===Ye.isViewportWrapping,Se=ee.lineHeight,Ce=ee.typicalHalfwidthCharacterWidth,ne=ee.scrollBeyondLastLine,ae=ee.minimap.renderCharacters;let N=$e>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Y=ee.minimap.maxColumn,re=ee.minimap.size,ke=ee.minimap.side,Ie=ee.verticalScrollbarWidth,Oe=ee.viewLineCount,Ue=ee.remainingWidth,Qe=ee.isViewportWrapping,rt=ae?2:3;let et=Math.floor($e*He);const Je=et/$e;let ot=!1,_t=!1,wt=rt*N,pe=N/$e,ue=1;if(re==="fill"||re==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:ut,desiredRatio:it,minimapLineCount:pt}=j.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ne,height:He,lineHeight:Se,pixelRatio:$e});if(Oe/pt>1)ot=!0,_t=!0,N=1,wt=1,pe=N/$e;else{let at=!1,ft=N+1;if(re==="fit"){const Pt=Math.ceil((Oe+ut)*wt);Qe&&De&&Ue<=me.stableFitRemainingWidth?(at=!0,ft=me.stableFitMaxMinimapScale):(at=Pt>et,Qe&&at?(me.stableMinimapLayoutInput=ee,me.stableFitRemainingWidth=Ue):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0))}if(re==="fill"||at){ot=!0;const Pt=N;wt=Math.min(Se*$e,Math.max(1,Math.floor(1/it))),N=Math.min(ft,Math.max(1,Math.floor(wt/rt))),N>Pt&&(ue=Math.min(2,N/Pt)),pe=N/$e/ue,et=Math.ceil(Math.max(ht,Oe+ut)*wt),Qe&&at&&(me.stableFitMaxMinimapScale=N)}}}const oe=Math.floor(Y*pe),K=Math.min(oe,Math.max(0,Math.floor((Ue-Ie-2)*pe/(Ce+pe)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor($e*K);const Te=Re/$e;Re=Math.floor(Re*ue);const Xe=ae?1:2,Ze=ke==="left"?0:Ne-K-Ie;return{renderMinimap:Xe,minimapLeft:Ze,minimapWidth:K,minimapHeightIsEditorHeight:ot,minimapIsSampling:_t,minimapScale:N,minimapLineHeight:wt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:et,minimapCanvasOuterWidth:Te,minimapCanvasOuterHeight:Je}}static computeLayout(ee,me){const Ne=me.outerWidth|0,He=me.outerHeight|0,$e=me.lineHeight|0,Ye=me.lineNumbersDigitCount|0,De=me.typicalHalfwidthCharacterWidth,Se=me.maxDigitWidth,Ce=me.pixelRatio,ne=me.viewLineCount,ae=ee.get(119),N=ae==="inherit"?ee.get(118):ae,Y=N==="inherit"?ee.get(114):N,re=ee.get(117),ke=ee.get(2),Ie=me.isDominatedByLongLines,Oe=ee.get(46),Ue=ee.get(56).renderType!==0,Qe=ee.get(57),rt=ee.get(91),et=ee.get(61),Je=ee.get(89),ot=Je.verticalScrollbarSize,_t=Je.verticalHasArrows,wt=Je.arrowSize,pe=Je.horizontalScrollbarSize,ue=ee.get(54),oe=ee.get(35);let K;if(typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)){const Rt=parseFloat(ue.substr(0,ue.length-2));K=r.clampedInt(Rt*De,0,0,1e3)}else K=r.clampedInt(ue,0,0,1e3);oe&&(K+=16);let Re=0;if(Ue){const Rt=Math.max(Ye,Qe);Re=Math.round(Rt*Se)}let Te=0;Oe&&(Te=$e);let Xe=0,Ze=Xe+Te,ht=Ze+Re,ut=ht+K;const it=Ne-Te-Re-K;let pt=!1,dt=!1,at=-1;ke!==2&&(N==="inherit"&&Ie?(pt=!0,dt=!0):Y==="on"||Y==="bounded"?dt=!0:Y==="wordWrapColumn"&&(at=re));const ft=j._computeMinimapLayout({outerWidth:Ne,outerHeight:He,lineHeight:$e,typicalHalfwidthCharacterWidth:De,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:et,verticalScrollbarWidth:ot,viewLineCount:ne,remainingWidth:it,isViewportWrapping:dt},me.memory||new y);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Xe+=ft.minimapWidth,Ze+=ft.minimapWidth,ht+=ft.minimapWidth,ut+=ft.minimapWidth);const Pt=it-ft.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/De)),At=_t?wt:0;return dt&&(at=Math.max(1,Ct),Y==="bounded"&&(at=Math.min(at,re))),{width:Ne,height:He,glyphMarginLeft:Xe,glyphMarginWidth:Te,lineNumbersLeft:Ze,lineNumbersWidth:Re,decorationsLeft:ht,decorationsWidth:K,contentLeft:ut,contentWidth:Pt,minimap:ft,viewportColumn:Ct,isWordWrapMinified:pt,isViewportWrapping:dt,wrappingColumn:at,verticalScrollbarWidth:ot,horizontalScrollbarHeight:pe,overviewRuler:{top:At,width:ot,height:He-2*At,right:0}}}}e.EditorLayoutInfoComputer=j;class W extends k{constructor(){const ee={enabled:!0};super(53,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:v.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:d(ee.enabled,this.defaultValue.enabled)}}}class I extends k{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:v.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:d(me.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(me.fontFamily,this.defaultValue.fontFamily)}}}class H extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(ee,me,Ne){return ee.fontInfo.lineHeight}}class M extends k{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:ee.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:v.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:d(me.enabled,this.defaultValue.enabled),size:m(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(me.side,this.defaultValue.side,["right","left"]),showSlider:m(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(me.scale,1,1,3),maxColumn:r.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function B(V){return V==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{top:r.clampedInt(me.top,0,0,1e3),bottom:r.clampedInt(me.bottom,0,0,1e3)}}}class q extends k{constructor(){const ee={enabled:!0,cycle:!1};super(72,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:v.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class se extends n{constructor(){super(125)}compute(ee,me,Ne){return ee.pixelRatio}}class ve extends k{constructor(){const ee={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:v.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:v.localize(59,null)},other:{type:"boolean",default:ee.other,description:v.localize(60,null)}}}],default:ee,description:v.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const me=ee,Ne={other:d(me.other,this.defaultValue.other),comments:d(me.comments,this.defaultValue.comments),strings:d(me.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(ee){let me=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(me=4,Ne=ee):ee==="interval"?me=3:ee==="relative"?me=2:ee==="on"?me=1:me=0),{renderType:me,renderFn:Ne}}}function Me(V){const ee=V.get(84);return ee==="editable"?V.get(77):ee!=="on"}e.filterValidationDecorations=Me;class ze extends k{constructor(){const ee=[],me={type:"number",description:v.localize(67,null)};super(88,"rulers",ee,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:ee,description:v.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let me=[];for(let Ne of ee)if(typeof Ne=="number")me.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const He=Ne;me.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return me.sort((Ne,He)=>Ne.column-He.column),me}return this.defaultValue}}function Ve(V,ee){if(typeof V!="string")return ee;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class x extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee,Ne=r.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(me.vertical,this.defaultValue.vertical),horizontal:Ve(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(me.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(me.verticalSliderSize,He,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Q extends k{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,suggestionPreviewExpanded:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:ee.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:v.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ee.showSuggestionPreview,description:v.localize(79,null)},"editor.suggest.suggestionPreviewExpanded":{type:"boolean",default:ee.suggestionPreviewExpanded,description:v.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:v.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertMode:m(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:d(me.showSuggestionPreview,this.defaultValue.showSuggestionPreview),suggestionPreviewExpanded:d(me.suggestionPreviewExpanded,this.defaultValue.suggestionPreviewExpanded),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class te extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(113,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends n{constructor(){super(126,[77])}compute(ee,me,Ne){return me.get(77)?!0:ee.tabFocusMode}}var fe;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(fe=e.WrappingIndent||(e.WrappingIndent={}));function Ee(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class le extends n{constructor(){super(128,[127])}compute(ee,me,Ne){const He=me.get(127);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const _e="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Ae:R.isLinux?We:_e,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ge(V){return e.editorOptionsRegistry[V.id]=V,V}var Ge;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useShadowDOM=111]="useShadowDOM",V[V.useTabStops=112]="useTabStops",V[V.wordSeparators=113]="wordSeparators",V[V.wordWrap=114]="wordWrap",V[V.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=117]="wordWrapColumn",V[V.wordWrapOverride1=118]="wordWrapOverride1",V[V.wordWrapOverride2=119]="wordWrapOverride2",V[V.wrappingIndent=120]="wrappingIndent",V[V.wrappingStrategy=121]="wrappingStrategy",V[V.showDeprecated=122]="showDeprecated",V[V.inlayHints=123]="inlayHints",V[V.editorClassName=124]="editorClassName",V[V.pixelRatio=125]="pixelRatio",V[V.tabFocusMode=126]="tabFocusMode",V[V.layoutInfo=127]="layoutInfo",V[V.wrappingInfo=128]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ge(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(114,null)})),acceptSuggestionOnEnter:ge(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(115,null),""],markdownDescription:v.localize(116,null)})),accessibilitySupport:ge(new f),accessibilityPageSize:ge(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(117,null)})),ariaLabel:ge(new p(4,"ariaLabel",v.localize(118,null))),autoClosingBrackets:ge(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(119,null),v.localize(120,null),""],description:v.localize(121,null)})),autoClosingDelete:ge(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(122,null),""],description:v.localize(123,null)})),autoClosingOvertype:ge(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(124,null),""],description:v.localize(125,null)})),autoClosingQuotes:ge(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(126,null),v.localize(127,null),""],description:v.localize(128,null)})),autoIndent:ge(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null)],description:v.localize(134,null)})),automaticLayout:ge(new g(10,"automaticLayout",!1)),autoSurround:ge(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null),""],description:v.localize(138,null)})),stickyTabStops:ge(new g(101,"stickyTabStops",!1,{description:v.localize(139,null)})),codeLens:ge(new g(12,"codeLens",!0,{description:v.localize(140,null)})),codeLensFontFamily:ge(new p(13,"codeLensFontFamily","",{description:v.localize(141,null)})),codeLensFontSize:ge(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(142,null)})),colorDecorators:ge(new g(15,"colorDecorators",!0,{description:v.localize(143,null)})),columnSelection:ge(new g(16,"columnSelection",!1,{description:v.localize(144,null)})),comments:ge(new t),contextmenu:ge(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ge(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(145,null)})),cursorBlinking:ge(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:v.localize(146,null)})),cursorSmoothCaretAnimation:ge(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(147,null)})),cursorStyle:ge(new l(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:v.localize(148,null)})),cursorSurroundingLines:ge(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(149,null)})),cursorSurroundingLinesStyle:ge(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(150,null),v.localize(151,null)],description:v.localize(152,null)})),cursorWidth:ge(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(153,null)})),disableLayerHinting:ge(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ge(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:ge(new g(28,"domReadOnly",!1)),dragAndDrop:ge(new g(29,"dragAndDrop",!0,{description:v.localize(154,null)})),emptySelectionClipboard:ge(new A),extraEditorClassName:ge(new p(31,"extraEditorClassName","")),fastScrollSensitivity:ge(new a(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:v.localize(155,null)})),find:ge(new C),fixedOverflowWidgets:ge(new g(34,"fixedOverflowWidgets",!1)),folding:ge(new g(35,"folding",!0,{description:v.localize(156,null)})),foldingStrategy:ge(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(157,null),v.localize(158,null)],description:v.localize(159,null)})),foldingHighlight:ge(new g(37,"foldingHighlight",!0,{description:v.localize(160,null)})),unfoldOnClickAfterEndOfLine:ge(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(161,null)})),fontFamily:ge(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(162,null)})),fontInfo:ge(new F),fontLigatures2:ge(new u),fontSize:ge(new O),fontWeight:ge(new z),formatOnPaste:ge(new g(44,"formatOnPaste",!1,{description:v.localize(163,null)})),formatOnType:ge(new g(45,"formatOnType",!1,{description:v.localize(164,null)})),glyphMargin:ge(new g(46,"glyphMargin",!0,{description:v.localize(165,null)})),gotoLocation:ge(new de),hideCursorInOverviewRuler:ge(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(166,null)})),highlightActiveIndentGuide:ge(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(167,null)})),hover:ge(new he),inDiffEditor:ge(new g(51,"inDiffEditor",!1)),letterSpacing:ge(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>a.clamp(V,-5,20),{description:v.localize(168,null)})),lightbulb:ge(new W),lineDecorationsWidth:ge(new P(54,"lineDecorationsWidth",10)),lineHeight:ge(new H),lineNumbers:ge(new xe),lineNumbersMinChars:ge(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:ge(new g(58,"linkedEditing",!1,{description:v.localize(169,null)})),links:ge(new g(59,"links",!0,{description:v.localize(170,null)})),matchBrackets:ge(new E(60,"matchBrackets","always",["always","near","never"],{description:v.localize(171,null)})),minimap:ge(new M),mouseStyle:ge(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ge(new a(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:v.localize(172,null)})),mouseWheelZoom:ge(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(173,null)})),multiCursorMergeOverlapping:ge(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(174,null)})),multiCursorModifier:ge(new l(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],B,{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),multiCursorPaste:ge(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(178,null),v.localize(179,null)],markdownDescription:v.localize(180,null)})),occurrencesHighlight:ge(new g(68,"occurrencesHighlight",!0,{description:v.localize(181,null)})),overviewRulerBorder:ge(new g(69,"overviewRulerBorder",!0,{description:v.localize(182,null)})),overviewRulerLanes:ge(new r(70,"overviewRulerLanes",3,0,3)),padding:ge(new G),parameterHints:ge(new q),peekWidgetDefaultFocus:ge(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(183,null),v.localize(184,null)],description:v.localize(185,null)})),definitionLinkOpensInPeek:ge(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(186,null)})),quickSuggestions:ge(new ve),quickSuggestionsDelay:ge(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(187,null)})),readOnly:ge(new g(77,"readOnly",!1)),renameOnType:ge(new g(78,"renameOnType",!1,{description:v.localize(188,null),markdownDeprecationMessage:v.localize(189,null)})),renderControlCharacters:ge(new g(79,"renderControlCharacters",!1,{description:v.localize(190,null)})),renderIndentGuides:ge(new g(80,"renderIndentGuides",!0,{description:v.localize(191,null)})),renderFinalNewline:ge(new g(81,"renderFinalNewline",!0,{description:v.localize(192,null)})),renderLineHighlight:ge(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(193,null)],description:v.localize(194,null)})),renderLineHighlightOnlyWhenFocus:ge(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(195,null)})),renderValidationDecorations:ge(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ge(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(196,null),v.localize(197,null),v.localize(198,null),""],description:v.localize(199,null)})),revealHorizontalRightPadding:ge(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ge(new g(87,"roundedSelection",!0,{description:v.localize(200,null)})),rulers:ge(new ze),scrollbar:ge(new x),scrollBeyondLastColumn:ge(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(201,null)})),scrollBeyondLastLine:ge(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(202,null)})),scrollPredominantAxis:ge(new g(92,"scrollPredominantAxis",!0,{description:v.localize(203,null)})),selectionClipboard:ge(new g(93,"selectionClipboard",!0,{description:v.localize(204,null),included:R.isLinux})),selectionHighlight:ge(new g(94,"selectionHighlight",!0,{description:v.localize(205,null)})),selectOnLineNumbers:ge(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:ge(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(206,null),v.localize(207,null)],description:v.localize(208,null)})),showUnused:ge(new g(97,"showUnused",!0,{description:v.localize(209,null)})),showDeprecated:ge(new g(122,"showDeprecated",!0,{description:v.localize(210,null)})),inlayHints:ge(new I),snippetSuggestions:ge(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(211,null),v.localize(212,null),v.localize(213,null),v.localize(214,null)],description:v.localize(215,null)})),smartSelect:ge(new te),smoothScrolling:ge(new g(100,"smoothScrolling",!1,{description:v.localize(216,null)})),stopRenderingLineAfter:ge(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ge(new Q),suggestFontSize:ge(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestLineHeight:ge(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestOnTriggerCharacters:ge(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(219,null)})),suggestSelection:ge(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(220,null),v.localize(221,null),v.localize(222,null)],description:v.localize(223,null)})),tabCompletion:ge(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(224,null),v.localize(225,null),v.localize(226,null)],description:v.localize(227,null)})),tabIndex:ge(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ge(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(228,null),v.localize(229,null),v.localize(230,null)],description:v.localize(231,null)})),useShadowDOM:ge(new g(111,"useShadowDOM",!0)),useTabStops:ge(new g(112,"useTabStops",!0,{description:v.localize(232,null)})),wordSeparators:ge(new p(113,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:v.localize(233,null)})),wordWrap:ge(new E(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(234,null),v.localize(235,null),v.localize(236,null),v.localize(237,null)],description:v.localize(238,null)})),wordWrapBreakAfterCharacters:ge(new p(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ge(new p(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ge(new r(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(239,null)})),wordWrapOverride1:ge(new E(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ge(new E(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ge(new l(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ee,{enumDescriptions:[v.localize(240,null),v.localize(241,null),v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),wrappingStrategy:ge(new E(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),editorClassName:ge(new b),pixelRatio:ge(new se),tabFocusMode:ge(new ie),layoutInfo:ge(new j),wrappingInfo:ge(new le)}}),define(be[126],we([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[127],we([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[128],we([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(be[129],we([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(be[130],we([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(be[131],we([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(be[132],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[133],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[134],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(be[135],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[136],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[137],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[138],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[139],we([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(be[140],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[141],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[142],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[143],we([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[144],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(_){_[_.ACTIVATE=0]="ACTIVATE",_[_.RESTORE=1]="RESTORE",_[_.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(_){_[_.PICK=1]="PICK",_[_.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var D;(function(_){_[_.API=0]="API",_[_.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(_){_[_.Center=0]="Center",_[_.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",_[_.NearTop=2]="NearTop",_[_.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[145],we([0,1,127]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=T;function _(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=_;function S(d){if(!d)return null;let g=d.majorBase,r=d.majorMustEqual,a=d.minorBase,p=d.minorMustEqual,m=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(g===0||(p=!1),E=!1);let l=0;if(d.preRelease){const h=D.exec(d.preRelease);if(h){const[,f,t,i]=h;l=Date.UTC(Number(f),Number(t)-1,Number(i))}}return{majorBase:g,majorMustEqual:r,minorBase:a,minorMustEqual:p,patchBase:m,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:l}}e.normalizeVersion=S;function y(d,g,r){let a;typeof d=="string"?a=S(_(d)):a=d;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let m;if(typeof r=="string"?m=S(_(r)):m=r,!a||!m)return!1;let E=a.majorBase,l=a.minorBase,h=a.patchBase,f=m.majorBase,t=m.minorBase,i=m.patchBase,s=m.notBefore,o=m.majorMustEqual,c=m.minorMustEqual,w=m.patchMustEqual;return m.isMinimum?E>f?!0:E<f?!1:l>t?!0:l<t||p&&p<s?!1:h>=i:(E===1&&f===0&&(!o||!c||!w)&&(f=1,t=0,i=0,o=!0,c=!1,w=!1),E<f?!1:E>f?!o:l<t?!1:l>t?!c:h<i?!1:h>i?!w:!(p&&p<s))}e.isValidVersion=y;function k(d,g,r,a){return r.isBuiltin||typeof r.main=="undefined"?!0:P(d,g,r.engines.vscode,a)}e.isValidExtensionVersion=k;function n(d,g,r){return d==="*"||P(g,r,d)}e.isEngineValid=n;function P(d,g,r,a=[]){let p=S(_(r));if(!p)return a.push(v.localize(0,null,r)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return a.push(v.localize(1,null,r)),!1}else if(!p.majorMustEqual)return a.push(v.localize(2,null,r)),!1;return y(d,g,p)?!0:(a.push(v.localize(3,null,d,r)),!1)}}),define(be[89],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(T,_=[],S=!1){this.ctor=T,this.staticArguments=_,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=v;const R=(D,...T)=>new v(D,T);e.createSyncDescriptor=R}),define(be[62],we([0,1,89]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function D(_,S,y){S instanceof v.SyncDescriptor||(S=new v.SyncDescriptor(S,[],y)),R.push([_,S])}e.registerSingleton=D;function T(){return R}e.getSingletonServiceDescriptors=T}),define(be[146],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=v;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let _ of this._nodes.values())_.outgoing.size===0&&T.push(_);return T}insertEdge(T,_){const S=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(_);S.outgoing.set(this._hashFn(_),y),y.incoming.set(this._hashFn(T),S)}removeNode(T){const _=this._hashFn(T);this._nodes.delete(_);for(let S of this._nodes.values())S.outgoing.delete(_),S.incoming.delete(_)}lookupOrInsertNode(T){const _=this._hashFn(T);let S=this._nodes.get(_);return S||(S=new v(T),this._nodes.set(_,S)),S}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[_,S]of this._nodes)T.push(`${_}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,_]of this._nodes){const S=new Set([T]),y=this._findCycle(_,S);if(y)return y}}_findCycle(T,_){for(let[S,y]of T.outgoing){if(_.has(S))return[..._,S].join(" -> ");_.add(S);const k=this._findCycle(y,_);if(k)return k;_.delete(S)}}}e.Graph=R}),define(be[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function y(k){return k[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(S,y,k,n){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:S,index:k,optional:n}):(y[v.DI_DEPENDENCIES]=[{id:S,index:k,optional:n}],y[v.DI_TARGET]=y)}function D(S){if(v.serviceIds.has(S))return v.serviceIds.get(S);const y=function(k,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,k,P,!1)};return y.toString=()=>S,v.serviceIds.set(S,y),y}e.createDecorator=D;function T(S){return S}e.refineServiceDecorator=T;function _(S){return function(y,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(S,y,n,!0)}}e.optional=_}),define(be[147],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function R(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[148],we([0,1,3,57,6,22,81,60,147]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,r){let a={selector:g,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(a){let p=this._entries.indexOf(a);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(g){const r=[];return this._orderedForEach(g,a=>r.push(a.provider)),r}orderedGroups(g){const r=[];let a,p;return this._orderedForEach(g,m=>{a&&p===m._score?a.push(m.provider):(p=m._score,a=[m.provider],r.push(a))}),r}_orderedForEach(g,r){if(!!g){this._updateScores(g);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(g){let r={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,S.score)(a.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),k(a.selector)&&a._score>0){for(let p of this._entries)p._score=0;a._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(g,r){return g._score<r._score?1:g._score>r._score?-1:g._time<r._time?1:g._time>r._time?-1:0}}e.LanguageFeatureRegistry=n;class P{constructor(g,r,a=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=r,this.max=a,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+(0,R.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const r=this._key(g),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(g,r){const a=this._key(g);let p=this._cache.get(a);return p||(p=new _.MovingAverage,this._cache.set(a,p)),p.update(r),this.get(g)}}e.LanguageFeatureRequestDelays=P}),define(be[63],we([0,1,2,31,148,121,35]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class y{constructor(F,O){this.language=F,this.id=O}}e.LanguageIdentifier=y;var k;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let O=this.getForeground(F),z="mtk"+O,de=this.getFontStyle(F);return de&1&&(z+=" mtki"),de&2&&(z+=" mtkb"),de&4&&(z+=" mtku"),z}static getInlineStyleFromMetadata(F,O){const z=this.getForeground(F),de=this.getFontStyle(F);let he=`color: ${O[z]};`;return de&1&&(he+="font-style: italic;"),de&2&&(he+="font-weight: bold;"),de&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=g;var r;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(F){const O=u[F];let z=O&&_.iconRegistry.get(O);return z||(console.info("No codicon found for CompletionItemKind "+F),z=_.Codicon.symbolProperty),z.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(F,O){let z=u[F];return typeof z=="undefined"&&!O&&(z=9),z}}();var a;(function(u){u[u.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(u){return u&&v.URI.isUri(u.uri)&&R.Range.isIRange(u.range)&&(R.Range.isIRange(u.originSelectionRange)||R.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=t;var i;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(u){u[u.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var o;(function(u){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function z($){return F.get($)}u.fromString=z;function de($){return O.get($)}u.toString=de;function he($,j){const W=O.get($);let I=W&&_.iconRegistry.get("symbol-"+W);return I||(console.info("No codicon found for SymbolKind "+$),I=_.Codicon.symbolProperty),`${j?"inline":"block"} ${I.classNames}`}u.toCssClassName=he})(o=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(F){this.value=F}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var w;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(w=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var b;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(b=e.CommentMode||(e.CommentMode={}));var A;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var C;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[149],we([0,1,6,10,4,3,45,43]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,D.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,k){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:y,handler:k})}if(y.description){const r=[];for(let p of y.description.args)r.push(p.constraint);const a=y.handler;y.handler=function(p,...m){return(0,R.validateConstraints)(m,r),a(p,...m)}}const{id:n}=y;let P=this._commands.get(n);P||(P=new _.LinkedList,this._commands.set(n,P));let d=P.unshift(y),g=(0,v.toDisposable)(()=>{d();const r=this._commands.get(n);(r==null?void 0:r.isEmpty())&&this._commands.delete(n)});return this._onDidRegisterCommand.fire(n),g}registerCommandAlias(y,k){return e.CommandsRegistry.registerCommand(y,(n,...P)=>n.get(e.ICommandService).executeCommand(k,...P))}getCommand(y){const k=this._commands.get(y);if(!(!k||k.isEmpty()))return S.Iterable.first(k)}getCommands(){const y=new Map;for(const k of this._commands.keys()){const n=this.getCommand(k);n&&y.set(k,n)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(be[64],we([0,1,8,4,21]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",D.isMacintosh),_.set("isLinux",D.isLinux),_.set("isWindows",D.isWindows),_.set("isWeb",D.isWeb),_.set("isMacNative",D.isMacintosh&&!D.isWeb),_.set("isEdge",T.indexOf("Edg/")>=0),_.set("isFirefox",T.indexOf("Firefox")>=0),_.set("isChrome",T.indexOf("Chrome")>=0),_.set("isSafari",T.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var y;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(u){return g.create(u)}static equals(u,F){return r.create(u,F)}static notEquals(u,F){return m.create(u,F)}static regex(u,F){return i.create(u,F)}static in(u,F){return a.create(u,F)}static not(u){return E.create(u)}static and(...u){return o.create(u)}static or(...u){return c.create(u)}static greater(u,F){return l.create(u,F)}static less(u,F){return f.create(u,F)}static deserialize(u,F=!1){if(!!u)return this._deserializeOrExpression(u,F)}static _deserializeOrExpression(u,F){let O=u.split("||");return c.create(O.map(z=>this._deserializeAndExpression(z,F)))}static _deserializeAndExpression(u,F){let O=u.split("&&");return o.create(O.map(z=>this._deserializeOne(z,F)))}static _deserializeOne(u,F){if(u=u.trim(),u.indexOf("!=")>=0){let O=u.split("!=");return m.create(O[0].trim(),this._deserializeValue(O[1],F))}if(u.indexOf("==")>=0){let O=u.split("==");return r.create(O[0].trim(),this._deserializeValue(O[1],F))}if(u.indexOf("=~")>=0){let O=u.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(u.indexOf(" in ")>=0){let O=u.split(" in ");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const O=u.split(">=");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const O=u.split(">");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const O=u.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const O=u.split("<");return f.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(u)?E.create(u.substr(1).trim()):g.create(u)}static _deserializeValue(u,F){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let O=/^'([^']*)'$/.exec(u);return O?O[1].trim():u}static _deserializeRegexValue(u,F){if((0,v.isFalsyOrWhitespace)(u)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=u.indexOf("/"),z=u.lastIndexOf("/");if(O===z||O<0){if(F)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let de=u.slice(O+1,z),he=u[z+1]==="i"?"i":"";try{return new RegExp(de,he)}catch($){if(F)throw new Error(`bad regexp-value '${u}', parse error: ${$}`);return console.warn(`bad regexp-value '${u}', parse error: ${$}`),null}}}e.ContextKeyExpr=k;function n(C,u){return C.cmp(u)}class P{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(u){this.key=u,this.type=2}static create(u){const F=_.get(u);return typeof F=="boolean"?F?d.INSTANCE:P.INSTANCE:new g(u)}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class r{constructor(u,F){this.key=u,this.value=F,this.type=4}static create(u,F){if(typeof F=="boolean")return F?g.create(u):E.create(u);const O=_.get(u);return typeof O=="boolean"?F===(O?"true":"false")?d.INSTANCE:P.INSTANCE:new r(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(u,F){this.key=u,this.valueKey=F,this.type=10}static create(u,F){return new a(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const F=u.getValue(this.valueKey),O=u.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?S.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=a;class p{constructor(u){this._actual=u,this.type=11}static create(u){return new p(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new p(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(u,F){this.key=u,this.value=F,this.type=5}static create(u,F){if(typeof F=="boolean")return F?E.create(u):g.create(u);const O=_.get(u);return typeof O=="boolean"?F===(O?"true":"false")?P.INSTANCE:d.INSTANCE:new m(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class E{constructor(u){this.key=u,this.type=3}static create(u){const F=_.get(u);return typeof F=="boolean"?F?P.INSTANCE:d.INSTANCE:new E(u)}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class l{constructor(u,F){this.key=u,this.value=F,this.type=12}static create(u,F){return new l(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class h{constructor(u,F){this.key=u,this.value=F,this.type=13}static create(u,F){return new h(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class f{constructor(u,F){this.key=u,this.value=F,this.type=14}static create(u,F){return new f(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(u,F){this.key=u,this.value=F,this.type=15}static create(u,F){return new t(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:A(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(u,F){this.key=u,this.regexp=F,this.type=7}static create(u,F){return new i(u,F)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const F=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return F<O?-1:F>O?1:0}equals(u){if(u.type===this.type){const F=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return this.key===u.key&&F===O}return!1}evaluate(u){let F=u.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(u){this._actual=u,this.type=8}static create(u){return new s(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new s(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class o{constructor(u){this.expr=u,this.type=6}static create(u){return o._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const z=n(this.expr[F],u.expr[F]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(u.expr[F]))return!1;return!0}return!1}evaluate(u){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(u))return!1;return!0}static _normalizeArr(u){const F=[];let O=!1;for(const z of u)if(!!z){if(z.type===1){O=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){F.push(...z.expr);continue}F.push(z)}if(F.length===0&&O)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(n);F.length>1;){const z=F[F.length-1];if(z.type!==9)break;F.pop();const de=F.pop(),he=c.create(z.expr.map($=>o.create([$,de])));he&&(F.push(he),F.sort(n))}return F.length===1?F[0]:new o(F)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let F of this.expr)u.push(...F.keys());return u}map(u){return new o(this.expr.map(F=>F.map(u)))}negate(){let u=[];for(let F of this.expr)u.push(F.negate());return c.create(u)}}e.ContextKeyAndExpr=o;class c{constructor(u){this.expr=u,this.type=9}static create(u){const F=c._normalizeArr(u);if(F.length!==0)return F.length===1?F[0]:new c(F)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const z=n(this.expr[F],u.expr[F]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(u.expr[F]))return!1;return!0}return!1}evaluate(u){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(u))return!0;return!1}static _normalizeArr(u){let F=[],O=!1;if(u){for(let z=0,de=u.length;z<de;z++){const he=u[z];if(!!he){if(he.type===0){O=!0;continue}if(he.type===1)return[d.INSTANCE];if(he.type===9){F=F.concat(he.expr);continue}F.push(he)}}if(F.length===0&&O)return[P.INSTANCE];F.sort(n)}return F}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let F of this.expr)u.push(...F.keys());return u}map(u){return new c(this.expr.map(F=>F.map(u)))}negate(){let u=[];for(let O of this.expr)u.push(O.negate());const F=O=>O.type===9?O.expr:[O];for(;u.length>1;){const O=u.shift(),z=u.shift(),de=[];for(const he of F(O))for(const $ of F(z))de.push(k.and(he,$));u.unshift(k.or(...de))}return u[0]}}e.ContextKeyOrExpr=c;class w extends g{constructor(u,F,O){super(u);this._defaultValue=F,typeof O=="object"?w._info.push(Object.assign(Object.assign({},O),{key:u})):O!==!0&&w._info.push({key:u,description:O,type:F!=null?typeof F:void 0})}static all(){return w._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(u){return k.equals(this.key,u)}notEqualsTo(u){return k.notEquals(this.key,u)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(C,u){return C<u?-1:C>u?1:0}function A(C,u,F,O){return C<F?-1:C>F?1:u<O?-1:u>O?1:0}}),define(be[150],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=D;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class S{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,d){if(typeof P=="undefined"||P===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof P=="string"||typeof d=="string"){let g=typeof P=="string"?P:P.value,r=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(g,r)}return P._lower===d._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=S;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[151],we([0,1,8,26]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(g,r){return g.uuid&&r.uuid?g.uuid===r.uuid:g.id===r.id?!0:(0,v.compareIgnoreCase)(g.id,r.id)===0}e.areSameExtensions=D;class T{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?D(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function _(g,r){return`${g}.${r}`}e.getExtensionId=_;function S(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(g,r){return S(_(g,r))}e.getGalleryExtensionId=y;function k(g,r){const a=[],p=m=>{for(const E of a)if(E.some(l=>D(r(l),r(m))))return E;return null};for(const m of g){const E=p(m);E?E.push(m):a.push([m])}return a}e.groupByExtension=k;function n(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(g){const r=new Set;for(const a of g)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=d}),define(be[65],we([0,1,128,14,2,4,8,10,22]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k($){return $.create===!0}e.isFileOpenForWriteOptions=k;var n;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function($){$[$.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var d;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g($){return!!($.capabilities&2)}e.hasReadWriteCapability=g;function r($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=r;function a($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function p($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=p;var m;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=E;function l($,j){const W=new E($.toString(),j);return f(W,j),W}e.createFileSystemProviderError=l;function h($){return $||l((0,v.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=h;function f($,j){return $.name=j?`${j} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=f;function t($){if(!$)return m.Unknown;if($ instanceof E)return $.code;const j=/^(.+) \(FileSystemError\)$/.exec($.name);if(!j)return m.Unknown;switch(j[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function i($){if($ instanceof A)return $.fileOperationResult;switch(t($)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(j,W,I){this.resource=j,this.operation=W,this.target=I}isOperation(j){return this.operation===j}}e.FileOperationEvent=o;var c;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class w{constructor(j,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const I of j)switch(I.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(I.resource,I);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(I.resource,I);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(I.resource,I);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...I){var H,M,B,G,q,se;if(!j)return!1;const ve=I.length>0;return!!((!ve||I.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(j))||W.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(j)))||(!ve||I.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(j))||W.includeChildren&&((G=this.updated)===null||G===void 0?void 0:G.findSuperstr(j)))||(!ve||I.includes(2))&&(((q=this.deleted)===null||q===void 0?void 0:q.findSubstr(j))||W.includeChildren&&((se=this.deleted)===null||se===void 0?void 0:se.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const W=[],I=j===1?this.added:j===0?this.updated:this.deleted;if(I)for(const[,H]of I)W.push(H);return W}filter(j){return new w(this.changes.filter(W=>j(W)),this.ignorePathCasing)}}e.FileChangesEvent=w;function b($,j,W){return!$||!j||$===j||j.length>$.length?!1:(j.charAt(j.length-1)!==R.sep&&(j+=R.sep),W?(0,_.startsWithIgnoreCase)($,j):$.indexOf(j)===0)}e.isParent=b;class A extends Error{constructor(j,W,I){super(j);this.fileOperationResult=W,this.options=I}static isFileOperationError(j){return j instanceof Error&&!(0,S.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=A;var C;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=F;async function O($,j){if(!j.canHandleResource(D.URI.from({scheme:$.scheme})))return new Promise(W=>{const I=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===$.scheme&&H.added&&(I.dispose(),W())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,S.isNumber)(j)||(j=0),j<z.KB?(0,v.localize)(1,null,j.toFixed(0)):j<z.MB?(0,v.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,v.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,v.localize)(4,null,(j/z.GB).toFixed(2)):(0,v.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var de;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(de=e.Arch||(e.Arch={}));function he($){return{maxFileSize:$===0?300*z.MB:16*z.GB,maxHeapSize:$===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=he}),define(be[66],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[T,_]of D)this.set(T,_)}set(D,T){const _=this._entries.get(D);return this._entries.set(D,T),_}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(be[152],we([0,1,12,146,89,4,66,11]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class k extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class n{constructor(r=new _.ServiceCollection,a=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(r){return new n(r,this._strict,this)}invokeFunction(r,...a){let p=d.traceInvocation(r),m=!1;try{return r({get:(l,h)=>{if(m)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(l,p);if(!f&&h!==T.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return f}},...a)}finally{m=!0,p.stop()}}createInstance(r,...a){let p,m;return r instanceof D.SyncDescriptor?(p=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(a),p)):(p=d.traceCreation(r),m=this._createInstance(r,a,p)),p.stop(),m}_createInstance(r,a=[],p){let m=T._util.getServiceDependencies(r).sort((h,f)=>h.index-f.index),E=[];for(const h of m){let f=this._getOrCreateServiceInstance(h.id,p);if(!f&&this._strict&&!h.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${h.id}.`);E.push(f)}let l=m.length>0?m[0].index:a.length;if(a.length!==l){console.warn(`[createInstance] First service dependency of ${r.name} at position ${l+1} conflicts with ${a.length} static arguments`);let h=l-a.length;h>0?a=a.concat(new Array(h)):a=a.slice(0,l)}return new r(...[...a,...E])}_setServiceInstance(r,a){if(this._services.get(r)instanceof D.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,a.branch(r,!0)):(a.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,a,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,p){const m=new R.Graph(h=>h.id.toString());let E=0;const l=[{id:r,desc:a,_trace:p}];for(;l.length;){const h=l.pop();if(m.lookupOrInsertNode(h),E++>1e3)throw new k(m);for(let f of T._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${r} depends on ${f.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const i={id:f.id,desc:t,_trace:h._trace.branch(f.id,!0)};m.insertEdge(h,i),l.push(i)}}}for(;;){const h=m.roots();if(h.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:f}of h){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const i=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,i)}m.removeNode(f)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,p=[],m,E){if(this._services.get(r)instanceof D.SyncDescriptor)return this._createServiceInstance(a,p,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,p,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],p,m){if(p){const E=new S.IdleValue(()=>this._createInstance(r,a,m));return new Proxy(Object.create(null),{get(l,h){if(h in l)return l[h];let f=E.value,t=f[h];return typeof t!="function"||(t=t.bind(f),l[h]=t),t},set(l,h,f){return E.value[h]=f,!0}})}else return this._createInstance(r,a,m)}}e.InstantiationService=n;var P;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return y?new d(0,r.name):d._None}branch(r,a){let p=new d(2,r.toString());return this._dep.push([r,a,p]),p}stop(){let r=Date.now()-this._start;d._totals+=r;let a=!1;function p(E,l){let h=[],f=new Array(E+1).join("	");for(const[t,i,s]of l._dep)if(i&&s){a=!0,h.push(`${f}CREATES -> ${t}`);let o=p(E+1,s);o&&h.push(o)}else h.push(`${f}uses -> ${t}`);return h.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(be[17],we([0,1,4,6,21,3,61]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function S(){return new Date().toISOString()}var y;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(c){}i+=(s>0?" ":"")+o}return i}}e.AbstractMessageLogger=n;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...i):console.log(`[main ${S()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...i):console.log(`[main ${S()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...i):console.log(`[main ${S()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...i):console.warn(`[main ${S()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...i):console.error(`[main ${S()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...i):console.error(`[main ${S()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends k{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,_.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=a;class p extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=m;function E(f){if(f.verbose)return y.Trace;if(typeof f.logLevel=="string"){const t=l(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function l(f){switch(f){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function h(f){switch(f){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=h}),define(be[90],we([0,1,4,129,47]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var _;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(r,a){return a-r}y.compare=k;const n=Object.create(null);n[y.Error]=(0,R.localize)(0,null),n[y.Warning]=(0,R.localize)(1,null),n[y.Info]=(0,R.localize)(2,null);function P(r){return n[r]||""}y.toString=P;function d(r){switch(r){case D.default.Error:return y.Error;case D.default.Warning:return y.Warning;case D.default.Info:return y.Info;case D.default.Ignore:return y.Hint}}y.fromSeverity=d;function g(r){switch(r){case y.Error:return D.default.Error;case y.Warning:return D.default.Warning;case y.Info:return D.default.Info;case y.Hint:return D.default.Ignore}}y.toSeverity=g}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(y){const k="";function n(d){return P(d,!0)}y.makeKey=n;function P(d,g){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(_.toString(d.severity)):r.push(k),d.message&&g?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}y.makeKeyOptionalMessage=P})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(be[153],we([0,1,47,4,3]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(be[154],we([0,1,6,8,2,4]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function _(S,y){return D.URI.isUri(S)?(0,R.equalsIgnoreCase)(S.scheme,y):(0,R.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=_});var je=this&&this.__decorate||function(J,e,v,R){var D=arguments.length,T=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,v,R);else for(var S=J.length-1;S>=0;S--)(_=J[S])&&(T=(D<3?_(T):D>3?_(e,v,T):_(e,v))||T);return D>3&&T&&Object.defineProperty(e,v,T),T},Ke=this&&this.__param||function(J,e){return function(v,R){e(v,R,J)}};define(be[155],we([0,1,4,20,6,11]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var _;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(P,d){super();this.deferred=new T.DeferredPromise,d.withProgress(P,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:g.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(be[29],we([0,1,10,42]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(_,S){R.ok(v.isString(_)),R.ok(v.isObject(S)),R.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,S)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new D}),define(be[91],we([0,1,29,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[D(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new T;v.Registry.add(e.Extensions.JSONContribution,_)}),define(be[67],we([0,1,126,3,29,10,91]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=D.Registry.as(_.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,E=!0){this.registerConfigurations([m],E)}registerConfigurations(m,E=!0){const l=[];m.forEach(h=>{l.push(...this.validateAndRegisterProperties(h,E,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(m){const E=[],l=h=>{if(h.properties)for(const f in h.properties)E.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,h.properties[f]);h.allOf&&h.allOf.forEach(f=>l(f))};for(const h of m){l(h);const f=this.configurationContributors.indexOf(h);f!==-1&&this.configurationContributors.splice(f,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(m){const E=[],l=[];for(const h of m)for(const f in h)if(E.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),h[f]);const t={type:"object",default:this.defaultValues[f],description:v.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};l.push(P(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=h[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(m){const E=[];for(const l of m)for(const h in l)if(E.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const f=this.configurationProperties[h];f&&(this.updatePropertyDefaultValue(h,f),this.updateSchema(h,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const E of m)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,E=!0,l,h=3){var f;h=T.isUndefinedOrNull(m.scope)?h:m.scope;let t=[],i=m.properties;if(i)for(let o in i){if(E&&r(o)){delete i[o];continue}const c=i[o];if(this.updatePropertyDefaultValue(o,c),e.OVERRIDE_PROPERTY_PATTERN.test(o)?c.scope=void 0:(c.scope=T.isUndefinedOrNull(c.scope)?h:c.scope,c.restricted=T.isUndefinedOrNull(c.restricted)?!!((f=l==null?void 0:l.restrictedConfigurations)===null||f===void 0?void 0:f.includes(o)):c.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let s=m.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,E,l,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const E=l=>{let h=l.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let f=l.allOf;f&&f.forEach(E)};E(m)}updateSchema(m,E){switch(e.allSettings.properties[m]=E,E.scope){case 1:e.applicationSettings.properties[m]=E;break;case 2:e.machineSettings.properties[m]=E;break;case 6:e.machineOverridableSettings.properties[m]=E;break;case 3:e.windowSettings.properties[m]=E;break;case 4:e.resourceSettings.properties[m]=E;break;case 5:e.resourceSettings.properties[m]=E,this.resourceLanguageSettingsSchema.properties[m]=E;break}}removeFromSchema(m,E){switch(delete e.allSettings.properties[m],E.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const E=`[${m}]`,l={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,l),e.allSettings.properties[E]=l,e.applicationSettings.properties[E]=l,e.machineSettings.properties[E]=l,e.machineOverridableSettings.properties[E]=l,e.windowSettings.properties[E]=l,e.resourceSettings.properties[E]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,E){let l=this.defaultValues[m];T.isUndefined(l)&&(l=E.default),T.isUndefined(l)&&(l=d(E.type)),E.default=l}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function P(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=P;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new k;D.Registry.add(e.Extensions.Configuration,g);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?v.localize(5,null,p):g.getConfigurationProperties()[p]!==void 0?v.localize(6,null,p):null:v.localize(4,null)}e.validateProperty=r;function a(){const p=[],m=g.getConfigurationProperties();for(const E of Object.keys(m))p.push([E,m[E].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=a}),define(be[92],we([0,1,23,10,2,29,4,67]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof D.URI)}e.isConfigurationOverrides=y;var k;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(i,s){const o=s?i?s.keys.filter(F=>i.keys.indexOf(F)===-1):[...s.keys]:[],c=i?s?i.keys.filter(F=>s.keys.indexOf(F)===-1):[...i.keys]:[],w=[];if(s&&i){for(const F of i.keys)if(s.keys.indexOf(F)!==-1){const O=m(i.contents,F),z=m(s.contents,F);v.equals(O,z)||w.push(F)}}const b=[],A=F=>{const O={};for(const z of F)for(const de of z.identifiers)O[f(de)]=z;return O},C=s?A(s.overrides):{},u=i?A(i.overrides):{};if(Object.keys(C).length)for(const F of o){const O=C[F];O&&b.push([(0,S.overrideIdentifierFromKey)(F),O.keys])}if(Object.keys(u).length)for(const F of c){const O=u[F];O&&b.push([(0,S.overrideIdentifierFromKey)(F),O.keys])}if(Object.keys(C).length&&Object.keys(u).length)for(const F of w){const O=u[F],z=C[F];if(O&&z){const de=P({contents:O.contents,keys:O.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,S.overrideIdentifierFromKey)(F),[...de.added,...de.removed,...de.updated]])}}return{added:o,removed:c,updated:w,overrides:b}}e.compare=P;function d(i,s){const o=[];for(const c of Object.keys(i))if(S.OVERRIDE_PROPERTY_PATTERN.test(c)){const w={};for(const b in i[c])w[b]=i[c][b];o.push({identifiers:[(0,S.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(w),contents:g(w,s)})}return o}e.toOverrides=d;function g(i,s){const o=Object.create(null);for(let c in i)r(o,c,i[c],s);return o}e.toValuesTree=g;function r(i,s,o,c){const w=s.split("."),b=w.pop();let A=i;for(let C=0;C<w.length;C++){let u=w[C],F=A[u];switch(typeof F){case"undefined":F=A[u]=Object.create(null);break;case"object":break;default:c(`Ignoring ${s} as ${w.slice(0,C+1).join(".")} is ${JSON.stringify(F)}`);return}A=F}if(typeof A=="object"&&A!==null)try{A[b]=o}catch(C){c(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(A)}`)}else c(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=r;function a(i,s){const o=s.split(".");p(i,o)}e.removeFromValueTree=a;function p(i,s){const o=s.shift();if(s.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const c=i[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,s),Object.keys(c).length===0&&delete i[o])}}function m(i,s,o){function c(A,C){let u=A;for(const F of C){if(typeof u!="object"||u===null)return;u=u[F]}return u}const w=s.split("."),b=c(i,w);return typeof b=="undefined"?o:b}e.getConfigurationValue=m;function E(i,s,o){Object.keys(s).forEach(c=>{c!=="__proto__"&&(c in i?R.isObject(i[c])&&R.isObject(s[c])?E(i[c],s[c],o):o&&(i[c]=s[c]):i[c]=s[c])})}e.merge=E;function l(){const i=T.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=l;function h(){const i=Object.create(null),s=T.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let o in s){let c=s[o].default;r(i,o,c,w=>console.error(`Conflict in default settings: ${w}`))}return i}e.getDefaultValues=h;function f(i){return`[${i}]`}e.keyFromOverrideIdentifier=f;function t(i,s,o){const c=i.inspect(s),w=i.inspect(o);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:c.defaultValue}e.getMigratedSettingValue=t}),define(be[156],we([0,1,44,22,13,10,23,2,67,92,29,6,3]),function(J,e,v,R,D,T,_,S,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o],w=i[o];w&&(typeof c=="object"&&typeof w=="object"?(c=_.deepClone(c),this.mergeContents(c,w)):c=w),s[o]=c}return new g(s,this.keys,this.overrides)}merge(...t){const i=_.deepClone(this.contents),s=_.deepClone(this.overrides),o=[...this.keys];for(const c of t){this.mergeContents(i,c.contents);for(const w of c.overrides){const[b]=s.filter(A=>D.equals(A.identifiers,w.identifiers));b?this.mergeContents(b.contents,w.contents):s.push(_.deepClone(w))}for(const w of c.keys)o.indexOf(w)===-1&&o.push(w)}return new g(i,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&T.isObject(t[s])&&T.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=_.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,k.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(){const t=(0,k.getDefaultValues)(),i=(0,k.getConfigurationKeys)(),s=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,k.toValuesTree)(t[o],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,i,s)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:o,overrides:c,restricted:w}=this.doParseRaw(t,i);this._configurationModel=new g(s,o,c),this._restrictedConfigurations=w||[]}doParseContent(t){let i={},s=null,o=[],c=[],w=[];function b(C){Array.isArray(o)?o.push(C):s&&(o[s]=C)}let A={onObjectBegin:()=>{let C={};b(C),c.push(o),o=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let C=[];b(C),c.push(o),o=C,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:b,onError:(C,u,F)=>{w.push({error:C,offset:u,length:F})}};if(t)try{v.visit(t,A),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(t,i){const s=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,i);t=o.raw;const c=(0,k.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),w=Object.keys(t),b=(0,k.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:c,keys:w,overrides:b,restricted:o.restricted}}filter(t,i,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const c={},w=[];for(let b in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(b)&&s){const A=this.filter(t[b],i,!1,o);c[b]=A.raw,w.push(...A.restricted)}else{const A=i[b],C=A?typeof A.scope!="undefined"?A.scope:3:void 0;(A==null?void 0:A.restricted)&&w.push(b),(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&(o.skipRestricted&&(A==null?void 0:A.restricted)||(c[b]=t[b]))}return{raw:c,restricted:w}}}e.ConfigurationModelParser=a;class p extends P.Disposable{constructor(t,i,s,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(t,i,s=new g,o=new g,c=new R.ResourceMap,w=new g,b=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=w,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new g,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const o=this.getConsolidateConfigurationModel(i,s),c=this.getFolderConfigurationModelForResource(i.resource,s),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,b=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),C=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,z=i.overrideIdentifier?w.override(i.overrideIdentifier).getValue(t):w.getValue(t),de=o.getValue(t),he=D.distinct(D.flatten(o.overrides.map($=>$.identifiers))).filter($=>o.getOverrideValue(t,$)!==void 0);return{defaultValue:b,userValue:A,userLocalValue:C,userRemoteValue:u,workspaceValue:F,workspaceFolderValue:O,memoryValue:z,value:de,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:w.getValue(t),override:i.overrideIdentifier?w.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const c=(0,y.overrideIdentifierFromKey)(o),w=this._defaultConfiguration.getKeysForOverrideIdentifier(c),b=t.getKeysForOverrideIdentifier(c),A=[...b.filter(C=>w.indexOf(C)===-1),...w.filter(C=>b.indexOf(C)===-1),...w.filter(C=>!_.equals(this._defaultConfiguration.override(c).getValue(C),t.override(c).getValue(C)))];return[c,A]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=(0,k.compare)(this.localUserConfiguration,t),w=[...i,...s,...o];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=(0,k.compare)(this.remoteUserConfiguration,t);let w=[...i,...s,...o];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=(0,k.compare)(this.workspaceConfiguration,t);let w=[...i,...s,...o];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:c,removed:w,overrides:b}=(0,k.compare)(s,i);let A=[...o,...c,...w];return(A.length||!s)&&this.updateFolderConfiguration(t,i),{keys:A,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:c,overrides:w}=(0,k.compare)(i,void 0);return{keys:[...s,...o,...c],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((w,b)=>(w.set(S.URI.revive(b[0]),this.parseConfigurationModel(b[1])),w),new R.ResourceMap);return new m(i,s,new g,o,c,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function E(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,i=new Map;for(const o of f)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,w])=>{const b=(0,R.getOrSet)(i,c,new Set);w.forEach(A=>b.add(A))});const s=[];return i.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class l{constructor(t,i,s,o){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(b=>c.add(b)),t.overrides.forEach(([,b])=>b.forEach(A=>c.add(A))),this.affectedKeys=[...c.values()];const w=new g;this.affectedKeys.forEach(b=>w.setValue(b,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!_.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,k.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=l;class h extends l{constructor(t,i,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=h}),define(be[93],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(_,S=R.Unknown,y){super(_);this._message=_,this._code=S,this._detail=y,this.isHandled=S===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(_){return _ instanceof D&&_._code===R.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof D&&_._code===R.NoResolverFound}static isHandled(_){return _ instanceof D&&_.isHandled}}e.RemoteAuthorityResolverError=D}),define(be[94],we([0,1,16]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===v.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function D(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=D;function T(k){return k.scheme!==v.Schemas.file&&k.scheme!==v.Schemas.vscodeRemote}function _(k){if(k.folders.length)return k.folders.every(n=>T(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=_;function S(k){var n;return(n=_(k))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=S;function y(k){return _(k)!==void 0}e.isVirtualWorkspace=y}),define(be[157],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,T,_=5){let S;return S=T(y=>{const k=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(D),_);n={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),S.dispose()}},this._terminalBufferMap.set(D,n)}),S}stopBuffering(D){const T=this._terminalBufferMap.get(D);T&&T.dispose()}flushBuffer(D){const T=this._terminalBufferMap.get(D);T&&(this._terminalBufferMap.delete(D),this._callback(D,T.data.join("")))}}e.TerminalDataBufferer=v}),define(be[158],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(be[159],we([0,1,4,6,29,3,158,35]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var y;(function(p){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var n;(function(p){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}p.isThemeIcon=m;const E=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const s=E.exec(i);if(!s)return;let[,o]=s;return{id:o}}p.fromString=l;function h(i,s){let o=i.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),s&&(o=`${o}~${s}`),{id:o}}p.modify=h;function f(i,s){var o,c;return i.id===s.id&&((o=i.color)===null||o===void 0?void 0:o.id)===((c=s.color)===null||c===void 0?void 0:c.id)}p.isEqual=f;function t(i){return{id:i.id}}p.asThemeIcon=t,p.asClassNameArray=S.CSSIcon.asClassNameArray,p.asClassName=S.CSSIcon.asClassName,p.asCSSSelector=S.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function P(p){switch(p){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,R.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;D.Registry.add(e.Extensions.ThemingContribution,g);function r(p){return g.onColorThemeChange(p)}e.registerThemingParticipant=r;class a extends R.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let l=this.theme.getColor(m);return l&&E&&(l=E(l,this.theme)),l?l.toString():null}}e.Themable=a}),define(be[160],we([0,1,29,159,3,130,91,11,35]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,E,l,h){const f=this.iconsById[m];if(f){if(l&&!f.description){f.description=l,this.iconSchema.properties[m].markdownDescription=`${l} $(${m})`;const s=this.iconReferenceSchema.enum.indexOf(m);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=l),this._onDidChange.fire()}return f}let t={id:m,description:l,defaults:E,deprecationMessage:h};this.iconsById[m]=t;let i={$ref:"#/definitions/icons"};return h&&(i.deprecationMessage=h),l&&(i.markdownDescription=`${l}: $(${m})`),this.iconSchema.properties[m]=i,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const E=this.iconReferenceSchema.enum.indexOf(m);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,E){const l=this.iconFontsById[m];if(l)return l;let h={id:m,definition:E};return this.iconFontsById[m]=h,this._onDidChange.fire(),h}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(f,t)=>f.id.localeCompare(t.id),E=f=>{for(;R.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of h.filter(t=>!!t.description).sort(m))l.push(`|<i class="${E(f)}"></i>|${f.id}|${R.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const f of h.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(m))l.push(`|<i class="${E(f)}"></i>|${f.id}|`);return l.join(`
`)}}const n=new k;v.Registry.add(e.Extensions.IconContribution,n);function P(p,m,E,l){return n.registerIcon(p,m,E,l)}e.registerIcon=P;function d(){return n}e.getIconRegistry=d;function g(){for(const p of y.iconRegistry.all)n.registerIcon(p.id,p.definition,p.description);y.iconRegistry.onDidRegister(p=>n.registerIcon(p.id,p.definition,p.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let r=v.Registry.as(_.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,n.getIconSchema());const a=new S.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=P("widget-close",y.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",y.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",y.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[48],we([0,1,2,25,4,22]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var _;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function S(d){const g=d;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=S;function y(d){const g=d;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class k{constructor(g,r,a,p){this._id=g,this._configuration=a,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(g,r){this.raw=r,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(d){return new n({uri:d,index:0,name:(0,R.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(be[161],we([0,1,4,131,48,2,21,14,25,109,44,16,59,36,94]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(j){return(typeof j=="string"?(0,S.extname)(j):(0,y.extname)(j))===a}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function m(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function E(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=E;function l(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=l;function h(j){const W=j;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=h;function f(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(j){const W=j;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function i(j){const W=j;if(W==null?void 0:W.uri)return{id:W.id,uri:T.URI.revive(W.uri)};const I=j;if(I==null?void 0:I.configPath)return{id:I.id,configPath:T.URI.revive(I.configPath)};if(j==null?void 0:j.id)return{id:j.id}}e.reviveIdentifier=i;function s(j,W){return y.extUriBiasedIgnorePathCase.isEqualOrParent(j,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(j){return c(j)||w(j)}e.isStoredWorkspaceFolder=o;function c(j){const W=j;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function w(j){const W=j;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=w;function b(j,W,I,H,M=!_.isWindows,B){if(j.scheme!==H.scheme)return{name:I,uri:j.toString(!0)};let G=W?void 0:B.relativePath(H,j);if(G!==void 0)G.length===0?G=".":_.isWindows&&j.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(j.scheme===P.Schemas.file)G=j.fsPath,_.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,g.toSlashes)(G)));else{if(!B.isEqualAuthority(j.authority,H.authority))return{name:I,uri:j.toString(!0)};G=j.path}return{name:I,path:G}}e.getStoredWorkspaceFolder=b;function A(j,W,I){let H=[],M=new Set;const B=I.dirname(W);for(let G of j){let q;if(c(G))G.path&&(q=I.resolvePath(B,G.path));else if(w(G))try{q=T.URI.parse(G.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(se){console.warn(se)}if(q){let se=I.getComparisonKey(q);if(!M.has(se)){M.add(se);const ve=G.name||I.basenameOrAuthority(q);H.push(new D.WorkspaceFolder({uri:q,name:ve,index:H.length},G))}}}return H}e.toWorkspaceFolders=A;function C(j,W,I,H,M){let B=u(W,j);const G=M.dirname(W),q=M.dirname(H),se=[],ve=F(B.folders);for(const ze of B.folders){const Ve=c(ze)?M.resolvePath(G,ze.path):T.URI.parse(ze.uri);let x;I?x=!1:x=!c(ze)||(0,S.isAbsolute)(ze.path),se.push(b(Ve,x,ze.name,q,ve,M))}const Le={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},xe=k.setProperty(j,["folders"],se,Le);let Me=k.applyEdits(j,xe);return B.remoteAuthority===(0,r.getRemoteAuthority)(H)&&(Me=k.applyEdits(Me,k.removeProperty(Me,["remoteAuthority"],Le))),Me}e.rewriteWorkspaceFileForNewLocation=C;function u(j,W){let I=n.parse(W);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(H=>o(H));else throw new Error(`${j} looks like an invalid workspace file.`);return I}function F(j){return _.isWindows?j.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function O(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function z(j){return typeof j.folderUri=="string"}function de(j){return typeof j.fileUri=="string"}function he(j,W){const I={workspaces:[],files:[]};if(j){const H=function(B,G){for(let q=0;q<B.length;q++)try{G(B[q],q)}catch(se){W.warn(`Error restoring recent entry ${JSON.stringify(B[q])}: ${se.toString()}. Skip entry.`)}},M=j;if(Array.isArray(M.entries))H(M.entries,B=>{const G=B.label,q=B.remoteAuthority;O(B)?I.workspaces.push({label:G,remoteAuthority:q,workspace:{id:B.workspace.id,configPath:T.URI.parse(B.workspace.configPath)}}):z(B)?I.workspaces.push({label:G,remoteAuthority:q,folderUri:T.URI.parse(B.folderUri)}):de(B)&&I.files.push({label:G,remoteAuthority:q,fileUri:T.URI.parse(B.fileUri)})});else{const B=j;Array.isArray(B.workspaces3)&&H(B.workspaces3,(G,q)=>{const se=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[q]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?I.workspaces.push({label:se,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&I.workspaces.push({label:se,folderUri:T.URI.parse(G)})}),Array.isArray(B.files2)&&H(B.files2,(G,q)=>{const se=Array.isArray(B.fileLabels)&&B.fileLabels[q]||void 0;typeof G=="string"&&I.files.push({label:se,fileUri:T.URI.parse(G)})})}}return I}e.restoreRecentlyOpened=he;function $(j){const W={entries:[]};for(const I of j.workspaces)E(I)?W.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):W.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of j.files)W.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return W}e.toStoreData=$}),define(be[68],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const T=this._idPool++;return this._data.set(T,D),this.logDebugInfo(),T}get(D,T){return this._data.has(D)?this._data.get(D)[T]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(be[69],we([0,1,2,3,4]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(y=>({name:y.name,group:y.group,resource:v.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(be[49],we([0,1,16,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(_,S){S===null?this._providerInfo.delete(_):this._providerInfo.set(_,S)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(be[162],we([0,1,11]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(_,S,y){this._deferredPromises=new Map,this._id=_,this._shared=S,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const P of k.values())P.error(n)}})()},0)}get keys(){var _;return Object.entries((_=this._value)!==null&&_!==void 0?_:{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(_,S){let y=this._value[_];return typeof y=="undefined"&&(y=S),y}update(_,S){this._value[_]=S;let y=this._deferredPromises.get(_);if(y!==void 0)return y.p;const k=new v.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class D extends R{constructor(_,S){super(_.identifier.value,!0,S);this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=D}),define(be[15],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[163],we([0,1,26,3]),function(J,e,v,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(S,y){D.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(S.identifier),nt(this,D,y,"f"),Be(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(S){return Be(this,D,"f").get(this._id,S)}store(S,y){return Be(this,D,"f").store(this._id,S,y)}delete(S){return Be(this,D,"f").delete(this._id,S)}}e.ExtensionSecrets=T,D=new WeakMap}),define(be[95],we([0,1,4,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(_){this._enabled=_}$onDidChangeTelemetryEnabled(_){this._enabled=_,this._onDidChangeTelemetryEnabled.fire(_)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(be[70],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(_){_[_.NewChild=0]="NewChild",_[_.Disposed=1]="Disposed",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,T=_=>{let S=D.get(_);return S||(S={children:new Map,bus:new v.Emitter},D.set(_,S)),S};e.getPrivateApiFor=T}),define(be[71],we([0,1,4,3,15]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(S){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}S.fromApiTunnel=y;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}S.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let _=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,k){return{dispose:()=>{}}}async $providePortAttributes(y,k,n,P,d){return[]}async $forwardPort(y,k){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=je([Ke(0,D.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(J);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(J,R[D])&&(v[R[D]]=J[R[D]]);return v};define(be[7],we([0,1,13,12,83,22,8,10,2,37,65,93,70]),function(J,e,v,R,D,T,_,S,y,k,n,P,d){"use strict";var g,r,a,p,m,E,l,h,f,t,i,s,o,c,w,b,A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function u(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let F=m=class{constructor(L){g.set(this,void 0),nt(this,g,L,"f")}static from(...L){let Z=L;return new m(function(){if(Z){for(const ye of Z)ye&&typeof ye.dispose=="function"&&ye.dispose();Z=void 0}})}dispose(){typeof Be(this,g,"f")=="function"&&(Be(this,g,"f").call(this),nt(this,g,void 0,"f"))}};g=new WeakMap,F=m=je([u],F),e.Disposable=F;let O=E=class{constructor(L,Z){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(Z<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=Z}static Min(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let ye=1;ye<L.length;ye++){const qe=L[ye];qe.isBefore(Z)&&(Z=qe)}return Z}static Max(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let ye=1;ye<L.length;ye++){const qe=L[ye];qe.isAfter(Z)&&(Z=qe)}return Z}static isPosition(L){if(!L)return!1;if(L instanceof E)return!0;let{line:Z,character:ye}=L;return typeof Z=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,Z=0){if(L===null||Z===null)throw(0,R.illegalArgument)();let ye;return typeof L=="undefined"?ye=0:typeof L=="number"?ye=L:(ye=typeof L.lineDelta=="number"?L.lineDelta:0,Z=typeof L.characterDelta=="number"?L.characterDelta:0),ye===0&&Z===0?this:new E(this.line+ye,this.character+Z)}with(L,Z=this.character){if(L===null||Z===null)throw(0,R.illegalArgument)();let ye;return typeof L=="undefined"?ye=this.line:typeof L=="number"?ye=L:(ye=typeof L.line=="number"?L.line:this.line,Z=typeof L.character=="number"?L.character:this.character),ye===this.line&&Z===this.character?this:new E(ye,Z)}toJSON(){return{line:this.line,character:this.character}}};O=E=je([u],O),e.Position=O;let z=l=class{constructor(L,Z,ye,qe){let tt,lt;if(typeof L=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof qe=="number"?(tt=new O(L,Z),lt=new O(ye,qe)):L instanceof O&&Z instanceof O&&(tt=L,lt=Z),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this._start=tt,this._end=lt):(this._start=lt,this._end=tt)}static isRange(L){return L instanceof l?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof l?this.contains(L._start)&&this.contains(L._end):L instanceof O?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const Z=O.Max(L.start,this._start),ye=O.Min(L.end,this._end);if(!Z.isAfter(ye))return new l(Z,ye)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const Z=O.Min(L.start,this._start),ye=O.Max(L.end,this.end);return new l(Z,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,Z=this.end){if(L===null||Z===null)throw(0,R.illegalArgument)();let ye;return L?O.isPosition(L)?ye=L:(ye=L.start||this.start,Z=L.end||this.end):ye=this.start,ye.isEqual(this._start)&&Z.isEqual(this.end)?this:new l(ye,Z)}toJSON(){return[this.start,this.end]}};z=l=je([u],z),e.Range=z;let de=h=class extends z{constructor(L,Z,ye,qe){let tt,lt;if(typeof L=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof qe=="number"?(tt=new O(L,Z),lt=new O(ye,qe)):L instanceof O&&Z instanceof O&&(tt=L,lt=Z),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt);this._anchor=tt,this._active=lt}static isSelection(L){return L instanceof h?!0:L?z.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};de=h=je([u],de),e.Selection=de;class he{constructor(L,Z,ye){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,R.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(Z),this.connectionToken=ye}}e.ResolvedAuthority=he;class $ extends Error{constructor(L,Z=P.RemoteAuthorityResolverErrorCode.Unknown,ye){super(L);this._message=L,this._code=Z,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,Z){return new $(L,P.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(L){return new $(L,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var j;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var W;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let I=f=class{constructor(L,Z){this._range=L,this._newText=Z}static isTextEdit(L){return L instanceof f?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,Z){return new f(L,Z)}static insert(L,Z){return f.replace(new z(L,L),Z)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const Z=new f(new z(new O(0,0),new O(0,0)),"");return Z.newEol=L,Z}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};I=f=je([u],I),e.TextEdit=I;var H;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellOutput=4]="CellOutput",U[U.CellReplace=5]="CellReplace",U[U.CellOutputItem=6]="CellOutputItem"})(H=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,Z,ye,qe){this._edits.push({_type:1,from:L,to:Z,options:ye,metadata:qe})}createFile(L,Z,ye){this._edits.push({_type:1,from:void 0,to:L,options:Z,metadata:ye})}deleteFile(L,Z,ye){this._edits.push({_type:1,from:L,to:void 0,options:Z,metadata:ye})}replaceNotebookMetadata(L,Z,ye){this._edits.push({_type:3,metadata:ye,uri:L,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(L,Z,ye,qe,tt){let lt,mt,St=[],kt;if(xt.isNotebookRange(Z)&&Fe.isNotebookCellDataArray(ye)&&!Fe.isNotebookCellDataArray(qe)?(lt=Z.start,mt=Z.end,St=ye,kt=qe):typeof Z=="number"&&typeof ye=="number"&&Fe.isNotebookCellDataArray(qe)&&(lt=Z,mt=ye,St=qe,kt=tt),lt===void 0||mt===void 0)throw new Error("Invalid arguments");(lt!==mt||St.length>0)&&this._edits.push({_type:5,uri:L,index:lt,count:mt-lt,cells:St,metadata:kt})}replaceNotebookCellMetadata(L,Z,ye,qe){this._edits.push({_type:3,metadata:qe,uri:L,edit:{editType:8,index:Z,metadata:ye}})}replace(L,Z,ye,qe){this._edits.push({_type:2,uri:L,edit:new I(Z,ye),metadata:qe})}insert(L,Z,ye,qe){this.replace(L,new z(Z,Z),ye,qe)}delete(L,Z,ye){this.replace(L,Z,"",ye)}has(L){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===L.toString())}set(L,Z){if(Z)for(const ye of Z)ye&&this._edits.push({_type:2,uri:L,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const qe=this._edits[ye];qe._type===2&&qe.uri.toString()===L.toString()&&(this._edits[ye]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(L){const Z=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===L.toString()&&Z.push(ye.edit);return Z}entries(){const L=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let ye=L.get(Z.uri);ye||(ye=[Z.uri,[]],L.set(Z.uri,ye)),ye[1].push(Z.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=je([u],M),e.WorkspaceEdit=M;let B=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,Z=this._tabstop++){if(typeof L=="function"){const ye=new t;ye._tabstop=this._tabstop,L(ye),this._tabstop=ye._tabstop,L=ye.value}else L=t._escape(L);return this.value+="${",this.value+=Z,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,Z=this._tabstop++){const ye=L.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(L,Z){if(typeof Z=="function"){const ye=new t;ye._tabstop=this._tabstop,Z(ye),this._tabstop=ye._tabstop,Z=ye.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};B=t=je([u],B),e.SnippetString=B;var G;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var q;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(L,Z){if(this.uri=L,Z)if(Z instanceof z)this.range=Z;else if(Z instanceof O)this.range=new z(Z,Z);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?z.isRange(L.range)&&y.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=je([u],se),e.Location=se;let ve=class{constructor(L,Z){this.location=L,this.message=Z}static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.location.range.isEqual(Z.location.range)&&L.location.uri.toString()===Z.location.uri.toString()}};ve=je([u],ve),e.DiagnosticRelatedInformation=ve;let Le=class{constructor(L,Z,ye=q.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=L,this.message=Z,this.severity=ye}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.severity===Z.severity&&L.code===Z.code&&L.severity===Z.severity&&L.source===Z.source&&L.range.isEqual(Z.range)&&(0,v.equals)(L.tags,Z.tags)&&(0,v.equals)(L.relatedInformation,Z.relatedInformation,ve.isEqual)}};Le=je([u],Le),e.Diagnostic=Le;let xe=class{constructor(L,Z){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,D.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=Z}};xe=je([u],xe),e.Hover=xe;var Me;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(L,Z=Me.Text){this.range=L,this.kind=Z}toJSON(){return{range:this.range,kind:Me[this.kind]}}};ze=je([u],ze),e.DocumentHighlight=ze;var Ve;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var x;(function(U){U[U.Deprecated=1]="Deprecated"})(x=e.SymbolTag||(e.SymbolTag={}));let Q=s=class{constructor(L,Z,ye,qe,tt){this.name=L,this.kind=Z,this.containerName=tt,typeof ye=="string"&&(this.containerName=ye),qe instanceof se?this.location=qe:ye instanceof z&&(this.location=new se(qe,ye)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Q=s=je([u],Q),e.SymbolInformation=Q;let te=o=class{constructor(L,Z,ye,qe,tt){this.name=L,this.detail=Z,this.kind=ye,this.range=qe,this.selectionRange=tt,this.children=[],o.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(o.validate)}};te=o=je([u],te),e.DocumentSymbol=te;var ie;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let fe=class{constructor(L,Z){this.title=L,this.kind=Z}};fe=je([u],fe),e.CodeAction=fe;let Ee=c=class{constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.sep)}};Ee.sep=".",Ee=c=je([u],Ee),e.CodeActionKind=Ee,Ee.Empty=new Ee(""),Ee.QuickFix=Ee.Empty.append("quickfix"),Ee.Refactor=Ee.Empty.append("refactor"),Ee.RefactorExtract=Ee.Refactor.append("extract"),Ee.RefactorInline=Ee.Refactor.append("inline"),Ee.RefactorRewrite=Ee.Refactor.append("rewrite"),Ee.Source=Ee.Empty.append("source"),Ee.SourceOrganizeImports=Ee.Source.append("organizeImports"),Ee.SourceFixAll=Ee.Source.append("fixAll");let le=class{constructor(L,Z){if(this.range=L,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};le=je([u],le),e.SelectionRange=le;class _e{constructor(L,Z,ye,qe,tt,lt){this.kind=L,this.name=Z,this.detail=ye,this.uri=qe,this.range=tt,this.selectionRange=lt}}e.CallHierarchyItem=_e;class Ae{constructor(L,Z){this.fromRanges=Z,this.from=L}}e.CallHierarchyIncomingCall=Ae;class We{constructor(L,Z){this.fromRanges=Z,this.to=L}}e.CallHierarchyOutgoingCall=We;let ge=class{constructor(L,Z){this.range=L,this.command=Z}get isResolved(){return!!this.command}};ge=je([u],ge),e.CodeLens=ge;let Ge=w=class{constructor(L,Z=!1){r.set(this,void 0),nt(this,r,new D.MarkdownString(L,{supportThemeIcons:Z}),"f")}static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Be(this,r,"f").value}set value(L){Be(this,r,"f").value=L}get isTrusted(){return Be(this,r,"f").isTrusted}set isTrusted(L){Be(this,r,"f").isTrusted=L}get supportThemeIcons(){return Be(this,r,"f").supportThemeIcons}appendText(L){return Be(this,r,"f").appendText(L),this}appendMarkdown(L){return Be(this,r,"f").appendMarkdown(L),this}appendCodeblock(L,Z){return Be(this,r,"f").appendCodeblock(Z!=null?Z:"",L),this}};r=new WeakMap,Ge=w=je([u],Ge),e.MarkdownString=Ge;let V=class{constructor(L,Z){this.label=L,this.documentation=Z}};V=je([u],V),e.ParameterInformation=V;let ee=class{constructor(L,Z){this.label=L,this.documentation=Z,this.parameters=[]}};ee=je([u],ee),e.SignatureInformation=ee;let me=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};me=je([u],me),e.SignatureHelp=me;var Ne;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var He;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(He=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(L,Z,ye){this.text=L,this.position=Z,this.kind=ye}};$e=je([u],$e),e.InlayHint=$e;var Ye;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Se;(function(U){U[U.Deprecated=1]="Deprecated"})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(L,Z){this.label=L,this.kind=Z}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=je([u],Ce),e.CompletionItem=Ce;let ne=class{constructor(L=[],Z=!1){this.items=L,this.isIncomplete=Z}};ne=je([u],ne),e.CompletionList=ne;let ae=class{constructor(L){this.text=L}};ae=je([u],ae),e.InlineSuggestion=ae;let N=class{constructor(L){this.items=L}};N=je([u],N),e.InlineSuggestions=N;var Y;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Y=e.ViewColumn||(e.ViewColumn={}));var re;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ue;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(Z){switch(Z){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(L,Z){if(Z&&!y.URI.isUri(Z))throw(0,R.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=Z}};rt=je([u],rt),e.DocumentLink=rt;let et=class{constructor(L,Z,ye,qe){this.red=L,this.green=Z,this.blue=ye,this.alpha=qe}};et=je([u],et),e.Color=et;let Je=class{constructor(L,Z){if(Z&&!(Z instanceof et))throw(0,R.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=Z}};Je=je([u],Je),e.ColorInformation=Je;let ot=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};ot=je([u],ot),e.ColorPresentation=ot;var _t;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var pe;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let oe=b=class{constructor(L,Z){if(typeof L!="string"||typeof Z!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}get id(){return this._id}};oe.Clean=new b("clean","Clean"),oe.Build=new b("build","Build"),oe.Rebuild=new b("rebuild","Rebuild"),oe.Test=new b("test","Test"),oe=b=je([u],oe),e.TaskGroup=oe;function K(U){let L="";for(let Z=0;Z<U.length;Z++)L+=U[Z].replace(/,/g,",,")+",";return L}let Re=class{constructor(L,Z,ye){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=ye):this._options=Z)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)L.push(Z);return K(L)}};Re=je([u],Re),e.ProcessExecution=Re;let Te=class{constructor(L,Z,ye){if(this._args=[],Array.isArray(Z)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=Z,this._options=ye}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)L.push(typeof Z=="string"?Z:Z.value);return K(L)}};Te=je([u],Te),e.ShellExecution=Te;var Xe;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Xe=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class ht{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ht;let ut=A=class{constructor(L,Z,ye,qe,tt,lt){this.__deprecated=!1,this._definition=this.definition=L;let mt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=ye,this.execution=qe,mt=tt,this.__deprecated=!0):Z===Ze.Global||Z===Ze.Workspace?(this.target=Z,this._name=this.name=ye,this._source=this.source=qe,this.execution=tt,mt=lt):(this.target=Z,this._name=this.name=ye,this._source=this.source=qe,this.execution=tt,mt=lt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Re?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const Z=this._definition.type;(A.EmptyType===Z||A.ProcessType===Z||A.ShellType===Z||A.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=A=je([u],ut),e.Task=ut;var it;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,Z=dt.None){this.collapsibleState=Z,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=je([u],pt),e.TreeItem=pt;var dt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let at=class{constructor(L,Z){this.id=L,this.color=Z}};at=je([u],at),e.ThemeIcon=at,at.File=new at("file"),at.Folder=new at("folder");let ft=class{constructor(L){this.id=L}};ft=je([u],ft),e.ThemeColor=ft;var Pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(L,Z){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof Z!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=y.URI.file(L),this.base=L):y.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=Z}};Ct=je([u],Ct),e.RelativePattern=Ct;let At=class{constructor(L,Z,ye,qe){this.enabled=typeof L=="boolean"?L:!0,typeof Z=="string"&&(this.condition=Z),typeof ye=="string"&&(this.hitCondition=ye),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};At=je([u],At),e.Breakpoint=At;let Rt=class extends At{constructor(L,Z,ye,qe,tt){super(Z,ye,qe,tt);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Rt=je([u],Rt),e.SourceBreakpoint=Rt;let yt=class extends At{constructor(L,Z,ye,qe,tt){super(Z,ye,qe,tt);this.functionName=L}};yt=je([u],yt),e.FunctionBreakpoint=yt;let Gt=class extends At{constructor(L,Z,ye,qe,tt,lt,mt){super(qe,tt,lt,mt);if(!Z)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=Z,this.canPersist=ye}};Gt=je([u],Gt),e.DataBreakpoint=Gt;let Qt=class{constructor(L,Z,ye){this.command=L,this.args=Z||[],this.options=ye}};Qt=je([u],Qt),e.DebugAdapterExecutable=Qt;let gt=class{constructor(L,Z){this.port=L,this.host=Z}};gt=je([u],gt),e.DebugAdapterServer=gt;let Yt=class{constructor(L){this.path=L}};Yt=je([u],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(L){this.implementation=L}};Jt=je([u],Jt),e.DebugAdapterInlineImplementation=Jt;let Dt=class{constructor(L,Z){this.range=L,this.expression=Z}};Dt=je([u],Dt),e.EvaluatableExpression=Dt;var un;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Xt=class{constructor(L,Z){this.range=L,this.text=Z}};Xt=je([u],Xt),e.InlineValueText=Xt;let Bt=class{constructor(L,Z,ye=!0){this.range=L,this.variableName=Z,this.caseSensitiveLookup=ye}};Bt=je([u],Bt),e.InlineValueVariableLookup=Bt;let ct=class{constructor(L,Z){this.range=L,this.expression=Z}};ct=je([u],ct),e.InlineValueEvaluatableExpression=ct;let Zt=class{constructor(L,Z){this.frameId=L,this.stoppedLocation=Z}};Zt=je([u],Zt),e.InlineValueContext=Zt;var Lt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Mt=C=class extends Error{constructor(L,Z=n.FileSystemProviderErrorCode.Unknown,ye){var qe;super(y.URI.isUri(L)?L.toString(!0):L);this.code=(qe=ye==null?void 0:ye.name)!==null&&qe!==void 0?qe:"Unknown",(0,n.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(L){return new C(L,n.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,n.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,n.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,n.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,n.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,n.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Mt=C=je([u],Mt),e.FileSystemError=Mt;let Vt=class{constructor(L,Z,ye){this.start=L,this.end=Z,this.kind=ye}};Vt=je([u],Vt),e.FoldingRange=Vt;var pn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(pn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var cn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var vn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(vn=e.CommentMode||(e.CommentMode={}));class dn{constructor(L,Z=[]){this.tokenTypes=L,this.tokenModifiers=Z}}e.SemanticTokensLegend=dn;function $t(U){return typeof U=="undefined"||(0,S.isStringArray)(U)}class en{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let Z=0,ye=L.tokenTypes.length;Z<ye;Z++)this._tokenTypeStrToInt.set(L.tokenTypes[Z],Z);for(let Z=0,ye=L.tokenModifiers.length;Z<ye;Z++)this._tokenModifierStrToInt.set(L.tokenModifiers[Z],Z)}}push(L,Z,ye,qe,tt){if(typeof L=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof qe=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,Z,ye,qe,tt);if(z.isRange(L)&&typeof Z=="string"&&$t(ye))return this._push(L,Z,ye);throw(0,R.illegalArgument)()}_push(L,Z,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const qe=L.start.line,tt=L.start.character,lt=L.end.character-L.start.character,mt=this._tokenTypeStrToInt.get(Z);let St=0;if(ye)for(const kt of ye){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);St|=1<<Tt>>>0}this._pushEncoded(qe,tt,lt,mt,St)}_pushEncoded(L,Z,ye,qe,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,Tt=0;for(let Ft=0;Ft<St;Ft++){let Nt=this._data[5*Ft],an=this._data[5*Ft+1];Nt===0?(Nt=kt,an+=Tt):Nt+=kt,this._data[5*Ft]=Nt,this._data[5*Ft+1]=an,kt=Nt,Tt=an}}let lt=L,mt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=Z}static _sortAndDeltaEncode(L){let Z=[];const ye=L.length/5|0;for(let mt=0;mt<ye;mt++)Z[mt]=mt;Z.sort((mt,St)=>{const kt=L[5*mt],Tt=L[5*St];if(kt===Tt){const Ft=L[5*mt+1],Nt=L[5*St+1];return Ft-Nt}return kt-Tt});const qe=new Uint32Array(L.length);let tt=0,lt=0;for(let mt=0;mt<ye;mt++){const St=5*Z[mt],kt=L[St+0],Tt=L[St+1],Ft=L[St+2],Nt=L[St+3],an=L[St+4],Ln=kt-tt,xn=Ln===0?Tt-lt:Tt,ln=5*mt;qe[ln+0]=Ln,qe[ln+1]=xn,qe[ln+2]=Ft,qe[ln+3]=Nt,qe[ln+4]=an,tt=kt,lt=Tt}return qe}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(en._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=en;class Ht{constructor(L,Z){this.resultId=Z,this.data=L}}e.SemanticTokens=Ht;class tn{constructor(L,Z,ye){this.start=L,this.deleteCount=Z,this.data=ye}}e.SemanticTokensEdit=tn;class bn{constructor(L,Z){this.resultId=Z,this.edits=L}}e.SemanticTokensEdits=bn;var wn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new at("arrow-left")},jt=je([u],jt),e.QuickInputButtons=jt;var _n;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(L,Z,ye){this.badge=L,this.tooltip=Z,this.color=ye}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let nn=class{constructor(L){this.kind=L}};nn=je([u],nn),e.ColorTheme=nn;var rn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(rn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(L,Z){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(Z<0)throw(0,R.illegalArgument)("end must be positive");L<=Z?(this._start=L,this._end=Z):(this._start=Z,this._end=L)}static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let Z=this._start,ye=this._end;return L.start!==void 0&&(Z=L.start),L.end!==void 0&&(ye=L.end),Z===this._start&&ye===this._end?this:new xt(Z,ye)}}e.NotebookRange=xt;class qt{constructor(L,Z){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=Z)}with(L){let{inputCollapsed:Z,outputCollapsed:ye}=L,qe=Kt(L,["inputCollapsed","outputCollapsed"]);return Z===void 0?Z=this.inputCollapsed:Z===null&&(Z=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),Z===this.inputCollapsed&&ye===this.outputCollapsed&&Object.keys(qe).length===0?this:new qt(Object.assign({inputCollapsed:Z,outputCollapsed:ye},qe))}}e.NotebookCellMetadata=qt;class Wt{constructor(L={}){Object.assign(this,L)}with(L){return new Wt(L)}}e.NotebookDocumentMetadata=Wt;class Fe{constructor(L,Z,ye,qe,tt,lt){this.kind=L,this.value=Z,this.languageId=ye,this.outputs=qe!=null?qe:[],this.metadata=tt,this.executionSummary=lt,Fe.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(Z=>Fe.isNotebookCellData(Z))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Fe;class sn{constructor(L,Z){this.cells=L,this.metadata=Z!=null?Z:new Wt}}e.NotebookData=sn;class It{constructor(L,Z,ye){if(this.data=L,this.mime=Z,this.metadata=ye,L instanceof Uint8Array||(this.value=L),(0,_.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(L){return L instanceof It?!0:L?typeof L.mime=="string":!1}static error(L,Z){const ye={name:L.name,message:L.message,stack:L.stack};return It.json(ye,"application/vnd.code.notebook.error",Z)}static stdout(L,Z){return It.text(L,"application/vnd.code.notebook.stdout",Z)}static stderr(L,Z){return It.text(L,"application/vnd.code.notebook.stderr",Z)}static bytes(L,Z="application/octet-stream",ye){return new It(L,Z,ye)}static text(L,Z="text/plain",ye){const qe=Be(It,a,"f",p).encode(String(L));return new It(qe,Z,ye)}static json(L,Z="application/json",ye){const qe=JSON.stringify(L,void 0,"	");return It.text(qe,Z,ye)}}e.NotebookCellOutputItem=It,a=It,p={value:new TextEncoder};class vt{constructor(L,Z,ye){this.outputs=L,typeof Z=="string"?(this.id=Z,this.metadata=ye):(this.id=(0,k.generateUuid)(),this.metadata=Z!=null?Z:ye)}}e.NotebookCellOutput=vt;var yn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(yn=e.NotebookCellKind||(e.NotebookCellKind={}));var Sn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var hn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(hn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(fn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Dn{constructor(L,Z,ye,qe,tt,lt){this.text=L,this.alignment=Z,this.command=ye,this.tooltip=qe,this.priority=tt,this.accessibilityInformation=lt}}e.NotebookCellStatusBarItem=Dn;var Cn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Cn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class kn{constructor(L,Z=[]){this.uri=L,this.provides=typeof Z=="string"?[Z]:Z}}e.NotebookKernelPreload=kn;let on=class{constructor(L,Z){this.label=L,this.timestamp=Z}};on=je([u],on),e.TimelineItem=on;var mn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(mn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor(L,Z){this.ranges=L,this.wordPattern=Z}}e.LinkedEditingRanges=An;class Tn{constructor(L,Z){this._port=L,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var X;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information",U[U.Hint=3]="Hint"})(X=e.TestMessageSeverity||(e.TestMessageSeverity={}));var ce;(function(U){U[U.Pending=0]="Pending",U[U.Resolved=1]="Resolved"})(ce=e.TestItemStatus||(e.TestItemStatus={}));const Pe=(U,L,Z,ye)=>{let qe=Z;return{enumerable:!0,configurable:!1,get(){return qe},set(tt){ye(qe,tt)||(qe=tt,U.bus.fire([3,L,tt]))}}},st=(U,L)=>U===L,bt=(U,L)=>U===L?!0:!U||!L?!1:U.isEqual(L);class Et{constructor(L,Z,ye,qe){this.label=Z,this.data=qe;const tt=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new T.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:Pe(tt,"range",void 0,bt),description:Pe(tt,"description",void 0,st),runnable:Pe(tt,"runnable",!0,st),debuggable:Pe(tt,"debuggable",!1,st),status:Pe(tt,"status",ce.Resolved,st),error:Pe(tt,"error",void 0,st)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const L=(0,d.getPrivateApiFor)(this);L.parent&&(0,d.getPrivateApiFor)(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof Et))throw new Error("Test child must be created through vscode.test.createTestItem()");const Z=(0,d.getPrivateApiFor)(this);if(Z.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);Z.children.set(L.id,L),Z.bus.fire([0,L])}}e.TestItemImpl=Et;class Fn{constructor(L){this.message=L,this.severity=X.Error}static diff(L,Z,ye){const qe=new Fn(L);return qe.expectedOutput=Z,qe.actualOutput=ye,qe}}e.TestMessage=Fn;var Un;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Bn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var $n;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore"})($n=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[96],we([0,1,42,16,8,122,86,7,13]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(r,a){a?k.set(r,a):k.delete(r)}e.setWordDefinitionFor=n;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class d extends T.MirrorTextModel{constructor(a,p,m,E,l,h,f,t){super(p,m,E,l);this._proxy=a,this._languageId=h,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===R.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(p){return p?a._getTextInRange(p):a.getText()},get eol(){return a._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(p){return a._lineAt(p)},offsetAt(p){return a._offsetAt(p)},positionAt(p){return a._positionAt(p)},validateRange(p){return a._validateRange(p)},validatePosition(p){return a._validatePosition(p)},getWordRangeAtPosition(p,m){return a._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,v.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,v.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const p=this._validateRange(a);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,E=p.start.line,l=p.end.line,h=[];h.push(this._lines[E].substring(p.start.character));for(let f=E+1;f<l;f++)h.push(this._lines[f]);return h.push(this._lines[l].substring(0,p.end.character)),h.join(m)}_lineAt(a){let p;if(a instanceof S.Position?p=a.line:typeof a=="number"&&(p=a),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new g(p,this._lines[p],p===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(a),m=this._lines[p.index].length;return new S.Position(p.index,Math.min(p.remainder,m))}_validateRange(a){if(!(a instanceof S.Range))throw new Error("Invalid argument");const p=this._validatePosition(a.start),m=this._validatePosition(a.end);return p===a.start&&m===a.end?a:new S.Range(p.line,p.character,m.line,m.character)}_validatePosition(a){if(!(a instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:p,character:m}=a,E=!1;if(p<0)p=0,m=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,E=!0;else{const l=this._lines[p].length;m<0?(m=0,E=!0):m>l&&(m=l,E=!0)}return E?new S.Position(p,m):a}_getWordRangeAtPosition(a,p){const m=this._validatePosition(a);if(!p)p=P(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,_.getWordAtText)(m.character+1,(0,_.ensureValidWordDefinition)(p),this._lines[m.line],0);if(E)return new S.Range(m.line,E.startColumn-1,m.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class g{constructor(a,p,m){this._line=a,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(be[164],we([0,1,7,3,88,6,60,22,2,37]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,g,r,a){this._notebook=r,this._selector=a,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(m=>{const E=this._cellUris.get(m.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const d=[],g=[];for(const r of this._notebook.getCells())r.kind===v.NotebookCellKind.Code&&(!this._selector||(0,_.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(d){var g,r;if(!d){let l="";for(const h of this._cells)l+=h.document.getText()+`
`;return l=l.slice(0,-1),l}if(d.isEmpty)return"";const a=this.locationAt(d.start),p=this.locationAt(d.end),m=this._cells[(g=this._cellUris.get(a.uri))!==null&&g!==void 0?g:-1],E=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!m||!E)return"";if(m===E)return m.document.getText(new v.Range(a.range.start,p.range.end));{const l=m.document.getText(new v.Range(a.range.start,new v.Position(m.document.lineCount,0))),h=E.document.getText(new v.Range(new v.Position(0,0),p.range.end));return l+`
`+h}}offsetAt(d){const g=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(g.index-1),a=this._cells[g.index].document.offsetAt(d.with(g.remainder));return r+a}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const g=this._cellUris.get(d.uri);if(g!==void 0){const r=this._cellLines.getAccumulatedValue(g-1);return new v.Position(r+d.range.start.line,d.range.start.character)}return new v.Position(0,0)}locationAt(d){v.Range.isRange(d)||(d=new v.Range(d,d));const g=this._cellLines.getIndexOf(d.start.line);let r=g;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const a=new v.Position(g.remainder,d.start.character),p=new v.Position(r.remainder,d.end.character),m=new v.Range(a,p),E=this._cells[g.index];return new v.Location(E.document.uri,E.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const g=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(g,r)}validatePosition(d){const g=this._cellLines.getIndexOf(d.line),r=new v.Position(g.remainder,d.character),a=this._cells[g.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(p+a.line,a.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[165],we([0,1,7,15,3]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(S){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let y=S==="light"?v.ColorThemeKind.Light:S==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[72],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=R}),define(be[166],we([0,1,24]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function D(S,y){if(y.serializeBuffersForPostMessage){const k=new R,n=(g,r)=>{if(r instanceof ArrayBuffer){const a=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=T(r);if(a){const p=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(S,n),d=k.buffers.map(g=>{const r=new Uint8Array(g);return v.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=D;function T(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(S,y){const k=y.map(d=>{const g=new ArrayBuffer(d.byteLength);return new Uint8Array(g).set(d.buffer),g}),n=y.length?(d,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:a}=r,p=k[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return g}:void 0;return{message:JSON.parse(S,n),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(be[73],we([0,1,16,2]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(T,_){return T.scheme===v.Schemas.http||T.scheme===v.Schemas.https?T:(_&&_.authority&&_.isRemote&&T.scheme===v.Schemas.file&&(T=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:_.authority,path:T.path})),R.URI.from({scheme:v.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=D}),define(be[167],we([0,1,3,6,73]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(S,y,k){this._proxy=S,this._editors=y,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,y,k,n,P){let d;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===S){d=l;break}if(!d)throw new Error("not a visible editor");const g=this,r=this._handlePool++,a=new v.Emitter,p=new v.Emitter,m=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,D.asWebviewUri)(l,g._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(l){this._options=l,g._proxy.$setOptions(r,l)}get options(){return this._options}set html(l){this._html=l,g._proxy.$setHtml(r,l)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(l){return g._proxy.$postMessage(r,l)}},E=new class{constructor(){this.editor=S,this.line=y,this.height=k,this.webview=m,this.onDidDispose=p.event}dispose(){g._insets.has(r)&&(g._insets.delete(r),g._proxy.$disposeEditorInset(r),p.fire(),p.dispose(),a.dispose())}};return this._proxy.$createEditorInset(r,d.id,d.value.document.uri,y+1,k,n||{},P.identifier,P.extensionLocation),this._insets.set(r,{editor:S,inset:E,onDidReceiveMessage:a}),E}$onDidDispose(S){const y=this._insets.get(S);y&&y.inset.dispose()}$onDidReceiveMessage(S,y){const k=this._insets.get(S);k&&k.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=T}),define(be[168],we([0,1,3,64,139,4,6,22,29,13,52,23,35,160]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",d.Codicon.window,(0,D.localize)(0,null));var r;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=m;class E extends _.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(w,b,A){var C;const u=this.get(w.id);if(u)return u;const F=w;return F.openCommandActionDescriptor=(A==null?void 0:A.donotRegisterOpenCommand)?void 0:(C=F.openCommandActionDescriptor)!==null&&C!==void 0?C:{id:F.id},(0,S.getOrSet)(this.viewContainers,b,[]).push(F),(A==null?void 0:A.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(w){for(const b of this.viewContainers.keys()){const A=this.viewContainers.get(b),C=A==null?void 0:A.indexOf(w);if(C!==-1){A==null||A.splice(C,1),A.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:w,viewContainerLocation:b});return}}}get(w){return this.all.filter(b=>b.id===w)[0]}getViewContainers(w){return[...this.viewContainers.get(w)||[]]}getViewContainerLocation(w){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(A=>(A==null?void 0:A.id)===w.id).length>0)[0]}getDefaultViewContainer(w){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===w)}}y.Registry.add(r.ViewContainersRegistry,new E);var l;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function h(c,w){var b,A,C,u;const F=(b=c.group)!==null&&b!==void 0?b:l.More,O=(A=w.group)!==null&&A!==void 0?A:l.More;return F!==O?F.localeCompare(O):((C=c.order)!==null&&C!==void 0?C:5)-((u=w.order)!==null&&u!==void 0?u:5)}class f extends _.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(w,b){this.registerViews2([{views:w,viewContainer:b}])}registerViews2(w){w.forEach(({views:b,viewContainer:A})=>this.addViews(b,A)),this._onViewsRegistered.fire(w)}deregisterViews(w,b){const A=this.removeViews(w,b);A.length&&this._onViewsDeregistered.fire({views:A,viewContainer:b})}moveViews(w,b){for(const A of this._views.keys())if(A!==b){const C=this.removeViews(w,A);C.length&&(this.addViews(C,b),this._onDidChangeContainer.fire({views:C,from:A,to:b}))}}getViews(w){return this._views.get(w)||[]}getView(w){for(const b of this._viewContainers){const A=(this._views.get(b)||[]).filter(C=>C.id===w)[0];if(A)return A}return null}getViewContainer(w){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(C=>C.id===w)[0])return b;return null}registerViewWelcomeContent(w,b){return this._viewWelcomeContents.add(w,b),this._onDidChangeViewWelcomeContent.fire(w),(0,_.toDisposable)(()=>{this._viewWelcomeContents.delete(w,b),this._onDidChangeViewWelcomeContent.fire(w)})}registerViewWelcomeContent2(w,b){const A=new Map;for(const[C,u]of b)this._viewWelcomeContents.add(w,u),A.set(C,(0,_.toDisposable)(()=>{this._viewWelcomeContents.delete(w,u),this._onDidChangeViewWelcomeContent.fire(w)}));return this._onDidChangeViewWelcomeContent.fire(w),A}getViewWelcomeContent(w){const b=[];return this._viewWelcomeContents.forEach(w,A=>b.push(A)),b.sort(h)}addViews(w,b){let A=this._views.get(b);A||(A=[],this._views.set(b,A),this._viewContainers.push(b));for(const C of w){if(this.getView(C.id)!==null)throw new Error((0,D.localize)(1,null,C.id));A.push(C)}}removeViews(w,b){const A=this._views.get(b);if(!A)return[];const C=[],u=[];for(const F of A)w.includes(F)?C.push(F):u.push(F);return C.length&&(u.length?this._views.set(b,u):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),C}}y.Registry.add(r.ViewsRegistry,new f),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var i;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(w,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,w),this._hasResolve=!!b,this.resolve=async A=>{var C,u;if(b&&!this.resolved){const F=await b(A);F&&(this.tooltip=(C=this.tooltip)!==null&&C!==void 0?C:F.tooltip,this.command=(u=this.command)!==null&&u!==void 0?u:F.command)}A.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(be[169],we([0,1,2,149,161,17,150,168]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(r){return(a,...p)=>r(a.get(R.ICommandService),...p)}class k{static execute(a,p){const m={forceReuseWindow:p&&p.reuseWindow,remoteAuthority:p&&p.remoteAuthority};return a.executeCommand("_files.newWindow",m)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:k.ID,handler:y(k.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(r,a){return r.get(D.IWorkspacesService).removeRecentlyOpened([a])});class n{static execute(a,p){return typeof p=="string"?p=p.match(/^[^:/?#]+:\/\//)?v.URI.parse(p):v.URI.file(p):p=v.URI.revive(p),a.executeCommand("_workbench.removeFromRecentlyOpened",p)}}e.RemoveFromRecentlyOpenedAPICommand=n,n.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(n.ID,y(n.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(r,a){const p=r.get(D.IWorkspacesService);let m;const E=a.uri,l=a.label,h=a.remoteAuthority;return a.type==="workspace"?m={workspace:await p.getWorkspaceIdentifier(E),label:l,remoteAuthority:h}:a.type==="folder"?m={folderUri:E,label:l,remoteAuthority:h}:m={fileUri:E,label:l,remoteAuthority:h},p.addRecentlyOpened([m])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(r){return r.get(D.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(r,a){const p=r.get(T.ILogService),m=r.get(_.IEnvironmentService);m.isExtensionDevelopment&&!!m.extensionTestsLocationURI&&p.setLevel(a)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(r){return r.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(r,a){const p=r.get(S.IViewDescriptorService),m=p.getViewContainerById(a.destinationId);if(!!m){for(const E of a.viewIds){const l=p.getViewDescriptorById(E);(l==null?void 0:l.canMoveView)&&p.moveViewsToContainer([l],m,S.ViewVisibilityState.Default)}await r.get(S.IViewsService).openViewContainer(m.id,!0)}});class P{static execute(a,p){return!Array.isArray(p==null?void 0:p.viewIds)||typeof(p==null?void 0:p.destinationId)!="string"?Promise.reject("Invalid arguments"):a.executeCommand("_workbench.action.moveViews",p)}}e.MoveViewsAPICommand=P,P.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:P.ID,handler:y(P.execute),description:{description:"Move Views",args:[]}});class d{static execute(a,p){return a.executeCommand("_workbench.open",p)}}d.ID="vscode.open",R.CommandsRegistry.registerCommand(d.ID,y(d.execute));class g{static execute(a,p,m,E,l){return a.executeCommand("_workbench.diff",[p,m,E])}}g.ID="vscode.diff",R.CommandsRegistry.registerCommand(g.ID,y(g.execute))}),define(be[170],we([0,1,3,11,140]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,y,k,n){const P={command:S};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.internalSend("request",P),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const g=this.pendingRequests.get(P.seq);if(g){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:S,message:(0,D.localize)(0,null,n,S)};g(r)}},n)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,y){return S.type!=="event"||y.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,R.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const y=S,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}internalSend(S,y){y.type=S,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((y,k)=>S.set(k,y)),await(0,R.timeout)(500),S.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[171],we([0,1,8,2,14,23,16]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function y(i,s,o){return i.replace(S,function(c,w){return s&&w.length>0&&w[0]!=="_"?c:o&&o.hasOwnProperty(w)?o[w]:c})}e.formatPII=y;function k(i){const s={};for(const o of Object.keys(i))o.startsWith("!")||(s[o]=i[o]);return s}e.filterExceptionsFromTelemetry=k;function n(i){return i.configuration.request==="attach"&&!P(i)}e.isSessionAttach=n;function P(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(s,"extensionhost")||(0,v.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?P(i.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=d;function g(i,s,o){let c,w=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=b.exec(i);){let C=A.index+1,u=C+A[0].length;if(C<=s&&u>=o){c=A[0],w=C;break}}if(c){let C=/\w+/g,u=null;for(;(u=C.exec(c))&&!(u.index+1+w+u[0].length>=o););u&&(c=c.substring(0,C.lastIndex))}return c?{start:w,end:w+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(i){return!!(i&&i.match(r))}e.isUri=a;function p(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(a(i.path))return R.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return R.URI.file(i.path)}return i.path}function m(i){if(typeof i.path=="object"){const s=R.URI.revive(i.path);if(s)return s.scheme===_.Schemas.file?s.fsPath:s.toString()}return i.path}function E(i,s){const o=s?p:m,c=(0,T.deepClone)(i);return h(c,(w,b)=>{w&&b&&(b.path=o(b))}),c}e.convertToDAPaths=E;function l(i,s){const o=s?p:m,c=(0,T.deepClone)(i);return h(c,(w,b)=>{!w&&b&&(b.path=o(b))}),c}e.convertToVSCPaths=l;function h(i,s){switch(i.type){case"event":const o=i;switch(o.event){case"output":s(!1,o.body.source);break;case"loadedSource":s(!1,o.body.source);break;case"breakpoint":s(!1,o.body.breakpoint.source);break;default:break}break;case"request":const c=i;switch(c.command){case"setBreakpoints":s(!0,c.arguments.source);break;case"breakpointLocations":s(!0,c.arguments.source);break;case"source":s(!0,c.arguments.source);break;case"gotoTargets":s(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const w=i;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>s(!1,b));break;case"scopes":w.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function f(i){return i.filter(s=>{var o;return!((o=s.presentation)===null||o===void 0?void 0:o.hidden)}).sort((s,o)=>s.presentation?o.presentation?s.presentation.group?o.presentation.group?s.presentation.group!==o.presentation.group?s.presentation.group.localeCompare(o.presentation.group):t(s.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(s.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=f;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(be[50],we([0,1,28,16,14,21,64]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(C){C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var n;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));function r(C,u){if(u)return C.toString();const F=a.parse(C);return F?F.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const u=/^ch(\d{7,})/;function F($,j){return $.with({scheme:C.scheme,fragment:`ch${j.toString().padStart(7,"0")}${$.scheme!==R.Schemas.file?$.scheme:""}`})}C.generate=F;function O($){if($.scheme!==C.scheme)return;const j=u.exec($.fragment);return j?{handle:Number(j[1]),notebook:$.with({scheme:$.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parse=O;function z($){if($.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const j=u.exec($.fragment);return j?{handle:Number(j[1]),notebook:$.with({scheme:$.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellMetadataUri=z;function de($,j,W){return $.with({scheme:W,fragment:`ch${j.toString().padStart(7,"0")}${$.scheme!==R.Schemas.file?$.scheme:""}`})}C.generateCellUri=de;function he($,j){if($.scheme!==j)return;const W=u.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellUri=he})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function m(C){var u,F;return(F=(u=p.get(C))===null||u===void 0?void 0:u.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=m;function E(C){var u,F;return(F=(u=p.get(C))===null||u===void 0?void 0:u.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=E;function l(C){var u,F;return(F=(u=p.get(C))===null||u===void 0?void 0:u.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=l;function h(C,u){return T.isWindows&&(C=C.replace(/\//g,"\\"),u=u.replace(/\//g,"\\")),v.match(C,u)}function f(C,u,F){let O=0;for(let z=0;z<u.length;z++){if(h(u[z],C))return O;O++}for(let z=0;z<F.length;z++){if(h(F[z],C))return O;O++}return O}function t(C,u,F){return C.sort((O,z)=>f(O,u,F)-f(z,u,F))}e.sortMimeTypes=t;function i(C,u,F,O=(z,de)=>z===de){const z=[];function de(j,W,I){if(W===0&&I.length===0)return;const H=z[z.length-1];H&&H.start+H.deleteCount===j?(H.deleteCount+=W,H.toInsert.push(...I)):z.push({start:j,deleteCount:W,toInsert:I})}let he=0,$=0;for(;;){if(he===C.length){de(he,0,u.slice($));break}if($===u.length){de(he,C.length-he,[]);break}const j=C[he],W=u[$];if(O(j,W)){he+=1,$+=1;continue}F(W)?(de(he,1,[]),he+=1):(de(he,0,[W]),$+=1)}return z}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(C){C.default="default",C.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(C){const u=C;return!!((typeof u.include=="string"||v.isRelativePattern(u.include))&&(typeof u.exclude=="string"||v.isRelativePattern(u.exclude)))}e.isDocumentExcludePattern=o;function c(C,u,F){if(Array.isArray(C.viewType)&&C.viewType.indexOf(u)>=0||C.viewType===u)return!0;if(C.filenamePattern){let O=o(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,z=o(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(v.match(O,(0,D.basename)(F.fsPath).toLowerCase()))return!(z&&v.match(z,(0,D.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class w{constructor(u){this.textModel=u}getElements(){const u=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)u[F]=this.textModel.cells[F].getHashValue();return u}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled";var b;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(u){return`${A._prefix}${u}`}static parse(u){if(u.startsWith(A._prefix))return u.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(be[172],we([0,1,142,4,64]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[173],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=v;function R(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=R}),define(be[97],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(y,k)=>{k.expand!==void 0&&(y.expand=k.expand),k.item!==void 0&&(y.item=y.item?Object.assign(y.item,k.item):k.item)};e.applyTestItemUpdate=R;var D;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(y,k)=>`${y}:${k.toString()}`;e.getTestSubscriptionKey=T;class _{add(k){}update(k){}remove(k,n){}complete(){}}e.IncrementalChangeCollector=_;class S{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const n=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const g=this.items.get(d.parent);g.children.add(d.item.extId);const r=this.createItem(d,g);this.items.set(d.item.extId,r),n.add(r)}}else{this.roots.add(d.item.extId);const g=this.createItem(d);this.items.set(d.item.extId,g),n.add(g)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],g=this.items.get(d.extId);if(!g)break;d.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,d),n.update(g);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const g=[[P[1]]];for(;g.length;)for(const r of g.pop()){const a=this.items.get(r);a&&(g.push(a.children),this.items.delete(r),n.remove(a,a!==d),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}n.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new _}}e.AbstractIncrementalTestCollection=S}),define(be[174],we([0,1,14,46,10,23,21,59,143]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,d,g){this._contributedVariables=new Map,this._context=P,this._labelService=d,g&&(this._envVariablesPromise=g.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(_.isWindows){const d=Object.create(null);return Object.keys(P).forEach(g=>{d[g.toLowerCase()]=P[g]}),d}return P}resolveWithEnvironment(P,d,g){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,g)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,g,r){const a=T.deepClone(d);return _.isWindows&&a.windows?Object.keys(a.windows).forEach(p=>a[p]=a.windows[p]):_.isMacintosh&&a.osx?Object.keys(a.osx).forEach(p=>a[p]=a.osx[p]):_.isLinux&&a.linux&&Object.keys(a.linux).forEach(p=>a[p]=a.linux[p]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,a,g,r)}async resolveAnyAsync(P,d,g){return this.resolveAnyBase(P,d,g)}async resolveAnyMap(P,d,g){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,g,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,g,r,a){if(D.isString(g))return this.resolveString(P,d,g,r,a);if(D.isArray(g))return g.map(p=>this.recursiveResolve(P,d,p,r,a));if(D.isObject(g)){let p=Object.create(null);return Object.keys(g).forEach(m=>{const E=this.resolveString(P,d,m,r,a);p[E]=this.recursiveResolve(P,d,g[m],r,a)}),p}return g}resolveString(P,d,g,r,a){return g.replace(k.VARIABLE_REGEXP,(m,E)=>{if(E.includes(k.VARIABLE_LHS))return m;let l=this.evaluateSingleVariable(P,m,E,d,r);return a&&a.set(E,l),l})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,g,r,a){let p;const m=g.split(":");m.length>1&&(g=m[0],p=m[1]);const E=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,y.localize)(0,null,d))},l=()=>{const f=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,d,v.basename(f)))},h=()=>{if(p){const f=this._context.getFolderUri(p);if(f)return f;throw new Error((0,y.localize)(2,null,d,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(g){case"env":if(p){if(P){const f=P[_.isWindows?p.toLowerCase():p];if(D.isString(f))return f}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(p){const f=this._context.getConfigurationValue(r,p);if(D.isUndefinedOrNull(f))throw new Error((0,y.localize)(6,null,d,p));if(D.isObject(f))throw new Error((0,y.localize)(7,null,d,p));return f}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,p,a,"command");case"input":return this.resolveFromMap(d,p,a,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return r||p?(0,S.normalizeDriveLetter)(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(h()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,y.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return l();case"relativeFile":return r||p?v.relative(this.fsPath(h()),E()):E();case"relativeFileDirname":const i=v.dirname(E());if(r||p){const w=v.relative(this.fsPath(h()),i);return w.length===0?".":w}return i;case"fileDirname":return v.dirname(E());case"fileExtname":return v.extname(E());case"fileBasename":return v.basename(E());case"fileBasenameNoExtension":const s=v.basename(E());return s.slice(0,s.length-v.extname(s).length);case"fileDirnameBasename":return v.basename(v.dirname(E()));case"execPath":const o=this._context.getExecPath();return o||d;case"execInstallFolder":const c=this._context.getAppRoot();return c||d;case"pathSeparator":return v.sep;default:try{const w=p?`${g}:${p}`:g;return this.resolveFromMap(d,w,a,void 0)}catch(w){return d}}}}resolveFromMap(P,d,g,r){if(d&&g){const a=r===void 0?g[d]:g[r+":"+d];if(typeof a=="string")return a;throw new Error((0,y.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[175],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var D;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var _;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(be[176],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,13,83,230,58,23,10,2,31,63,144,90,50,176,7]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(pe){function ue(K){const{selectionStartLineNumber:Re,selectionStartColumn:Te,positionLineNumber:Xe,positionColumn:Ze}=K,ht=new a.Position(Re-1,Te-1),ut=new a.Position(Xe-1,Ze-1);return new a.Selection(ht,ut)}pe.to=ue;function oe(K){const{anchor:Re,active:Te}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}pe.from=oe})(p=e.Selection||(e.Selection={}));var m;(function(pe){function ue(K){if(!K)return;const{start:Re,end:Te}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}pe.from=ue;function oe(K){if(!K)return;const{startLineNumber:Re,startColumn:Te,endLineNumber:Xe,endColumn:Ze}=K;return new a.Range(Re-1,Te-1,Xe-1,Ze-1)}pe.to=oe})(m=e.Range||(e.Range={}));var E;(function(pe){function ue(oe){switch(oe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}pe.to=ue})(E=e.TokenType||(e.TokenType={}));var l;(function(pe){function ue(K){return new a.Position(K.lineNumber-1,K.column-1)}pe.to=ue;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}pe.from=oe})(l=e.Position||(e.Position={}));var h;(function(pe){function ue(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}pe.from=ue;function oe(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}pe.to=oe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(pe){function ue(K){let Re;return K.code&&((0,S.isString)(K.code)||(0,S.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Re,severity:i.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,v.coalesce)(K.tags.map(h.from)):void 0})}pe.from=ue;function oe(K){var Re;const Te=new a.Diagnostic(m.to(K),K.message,i.to(K.severity));return Te.source=K.source,Te.code=(0,S.isString)(K.code)?K.code:(Re=K.code)===null||Re===void 0?void 0:Re.value,Te.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Te.tags=K.tags&&(0,v.coalesce)(K.tags.map(h.to)),Te}pe.to=oe})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function ue(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}pe.from=ue;function oe(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,m.to(K)),K.message)}pe.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(pe){function ue(K){switch(K){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}pe.from=ue;function oe(K){switch(K){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}pe.to=oe})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(pe){function ue(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=ue;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=oe})(s=e.ViewColumn||(e.ViewColumn={}));function o(pe){return typeof pe.range!="undefined"}function c(pe){return pe.length===0?!0:!!o(pe[0])}e.isDecorationOptionsArr=c;var w;(function(pe){function ue(Ze){return Ze.map(pe.from)}pe.fromMany=ue;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function K(Ze){let ht;if(oe(Ze)){const{language:dt,value:at}=Ze;ht={value:"```"+dt+`
`+at+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ze)?ht={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ht={value:Ze}:ht={value:""};const ut=Object.create(null);ht.uris=ut;const it=dt=>{try{let at=y.URI.parse(dt,!0);at=at.with({query:Re(at.query,ut)}),ut[dt]=at}catch(at){}return""},pt=new D.Renderer;return pt.link=it,pt.image=dt=>it(R.parseHrefAndDimensions(dt).href),D(ht.value,{renderer:pt}),ht}pe.from=K;function Re(Ze,ht){if(!Ze)return Ze;let ut;try{ut=(0,T.parse)(Ze)}catch(pt){}if(!ut)return Ze;let it=!1;return ut=(0,_.cloneAndChange)(ut,pt=>{if(y.URI.isUri(pt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=pt,it=!0,dt}else return}),it?JSON.stringify(ut):Ze}function Te(Ze){const ht=new a.MarkdownString(Ze.value,Ze.supportThemeIcons);return ht.isTrusted=Ze.isTrusted,ht}pe.to=Te;function Xe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:pe.from(Ze)}pe.fromStrict=Xe})(w=e.MarkdownString||(e.MarkdownString={}));function b(pe){return c(pe)?pe.map(ue=>({range:m.from(ue.range),hoverMessage:Array.isArray(ue.hoverMessage)?w.fromMany(ue.hoverMessage):ue.hoverMessage?w.from(ue.hoverMessage):void 0,renderOptions:ue.renderOptions})):pe.map(ue=>({range:m.from(ue)}))}e.fromRangeOrRangeWithMessage=b;function A(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?y.URI.file(pe):pe}e.pathOrURIToURI=A;var C;(function(pe){function ue(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?A(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}pe.from=ue})(C=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var u;(function(pe){function ue(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?A(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?C.from(oe.before):void 0,after:oe.after?C.from(oe.after):void 0}}pe.from=ue})(u=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(pe){function ue(oe){if(typeof oe=="undefined")return oe;switch(oe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=ue})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(pe){function ue(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?F.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?u.from(oe.light):void 0,dark:oe.dark?u.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?A(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?C.from(oe.before):void 0,after:oe.after?C.from(oe.after):void 0}}pe.from=ue})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(pe){function ue(K){return{text:K.newText,eol:K.newEol&&ee.from(K.newEol),range:m.from(K.range)}}pe.from=ue;function oe(K){const Re=new a.TextEdit(m.to(K.range),K.text);return Re.newEol=typeof K.eol=="undefined"?void 0:ee.to(K.eol),Re}pe.to=oe})(z=e.TextEdit||(e.TextEdit={}));var de;(function(pe){function ue(K,Re,Te){var Xe,Ze,ht;const ut={edits:[]};if(K instanceof a.WorkspaceEdit)for(let it of K._allEntries())if(it._type===1)ut.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const pt=Re==null?void 0:Re.getDocument(it.uri);ut.edits.push({_type:2,resource:it.uri,edit:z.from(it.edit),modelVersionId:pt==null?void 0:pt.version,metadata:it.metadata})}else it._type===3?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Xe=Te==null?void 0:Te.getNotebookDocument(it.uri,!0))===null||Xe===void 0?void 0:Xe.apiNotebook.version}):it._type===4?(it.newOutputs&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(Ie.from)}}),it.newMetadata&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(Ze=Te==null?void 0:Te.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(re.from)}}):it._type===6&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ht=it.newOutputItems)===null||ht===void 0?void 0:ht.map(ke.from))||[],append:it.append}});return ut}pe.from=ue;function oe(K){const Re=new a.WorkspaceEdit;for(const Te of K.edits)Te.edit?Re.replace(y.URI.revive(Te.resource),m.to(Te.edit.range),Te.edit.text):Re.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Re}pe.to=oe})(de=e.WorkspaceEdit||(e.WorkspaceEdit={}));var he;(function(pe){const ue=Object.create(null);ue[a.SymbolKind.File]=0,ue[a.SymbolKind.Module]=1,ue[a.SymbolKind.Namespace]=2,ue[a.SymbolKind.Package]=3,ue[a.SymbolKind.Class]=4,ue[a.SymbolKind.Method]=5,ue[a.SymbolKind.Property]=6,ue[a.SymbolKind.Field]=7,ue[a.SymbolKind.Constructor]=8,ue[a.SymbolKind.Enum]=9,ue[a.SymbolKind.Interface]=10,ue[a.SymbolKind.Function]=11,ue[a.SymbolKind.Variable]=12,ue[a.SymbolKind.Constant]=13,ue[a.SymbolKind.String]=14,ue[a.SymbolKind.Number]=15,ue[a.SymbolKind.Boolean]=16,ue[a.SymbolKind.Array]=17,ue[a.SymbolKind.Object]=18,ue[a.SymbolKind.Key]=19,ue[a.SymbolKind.Null]=20,ue[a.SymbolKind.EnumMember]=21,ue[a.SymbolKind.Struct]=22,ue[a.SymbolKind.Event]=23,ue[a.SymbolKind.Operator]=24,ue[a.SymbolKind.TypeParameter]=25;function oe(Re){return typeof ue[Re]=="number"?ue[Re]:6}pe.from=oe;function K(Re){for(const Te in ue)if(ue[Te]===Re)return Number(Te);return a.SymbolKind.Property}pe.to=K})(he=e.SymbolKind||(e.SymbolKind={}));var $;(function(pe){function ue(K){switch(K){case a.SymbolTag.Deprecated:return 1}}pe.from=ue;function oe(K){switch(K){case 1:return a.SymbolTag.Deprecated}}pe.to=oe})($=e.SymbolTag||(e.SymbolTag={}));var j;(function(pe){function ue(K){return{name:K.name,kind:he.from(K.kind),tags:K.tags&&K.tags.map($.from),containerName:K.containerName,location:B.from(K.location)}}pe.from=ue;function oe(K){const Re=new a.SymbolInformation(K.name,he.to(K.kind),K.containerName,B.to(K.location));return Re.tags=K.tags&&K.tags.map($.to),Re}pe.to=oe})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(pe){function ue(K){var Re,Te;const Xe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:he.from(K.kind),tags:(Te=(Re=K.tags)===null||Re===void 0?void 0:Re.map($.from))!==null&&Te!==void 0?Te:[]};return K.children&&(Xe.children=K.children.map(ue)),Xe}pe.from=ue;function oe(K){const Re=new a.DocumentSymbol(K.name,K.detail,he.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,v.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map($.to)),K.children&&(Re.children=K.children.map(oe)),Re}pe.to=oe})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var I;(function(pe){function ue(oe){const K=new a.CallHierarchyItem(he.to(oe.kind),oe.name,oe.detail||"",y.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return K._sessionId=oe._sessionId,K._itemId=oe._itemId,K}pe.to=ue})(I=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(pe){function ue(oe){return new a.CallHierarchyIncomingCall(I.to(oe.from),oe.fromRanges.map(K=>m.to(K)))}pe.to=ue})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(pe){function ue(oe){return new a.CallHierarchyOutgoingCall(I.to(oe.to),oe.fromRanges.map(K=>m.to(K)))}pe.to=ue})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(pe){function ue(K){return{range:K.range&&m.from(K.range),uri:K.uri}}pe.from=ue;function oe(K){return new a.Location(y.URI.revive(K.uri),m.to(K.range))}pe.to=oe})(B=e.location||(e.location={}));var G;(function(pe){function ue(K){const Re=K,Te=K;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Te.uri,range:m.from(Re.targetRange?Re.targetRange:Te.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}pe.from=ue;function oe(K){return{targetUri:y.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}pe.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(pe){function ue(K){return{range:m.from(K.range),contents:w.fromMany(K.contents)}}pe.from=ue;function oe(K){return new a.Hover(K.contents.map(w.to),m.to(K.range))}pe.to=oe})(q=e.Hover||(e.Hover={}));var se;(function(pe){function ue(K){return{range:m.from(K.range),expression:K.expression}}pe.from=ue;function oe(K){return new a.EvaluatableExpression(m.to(K.range),K.expression)}pe.to=oe})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(pe){function ue(K){if(K instanceof a.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=ue;function oe(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}pe.to=oe})(ve=e.InlineValue||(e.InlineValue={}));var Le;(function(pe){function ue(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}pe.from=ue;function oe(K){return new a.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}pe.to=oe})(Le=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(pe){function ue(K){return{range:m.from(K.range),kind:K.kind}}pe.from=ue;function oe(K){return new a.DocumentHighlight(m.to(K.range),K.kind)}pe.to=oe})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(pe){function ue(oe){switch(oe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}pe.to=ue})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function ue(oe){return{triggerKind:Me.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}pe.to=ue})(ze=e.CompletionContext||(e.CompletionContext={}));var Ve;(function(pe){function ue(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}pe.from=ue;function oe(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}pe.to=oe})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));var x;(function(pe){const ue=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function oe(Te){var Xe;return(Xe=ue.get(Te))!==null&&Xe!==void 0?Xe:9}pe.from=oe;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Re(Te){var Xe;return(Xe=K.get(Te))!==null&&Xe!==void 0?Xe:a.CompletionItemKind.Property}pe.to=Re})(x=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(pe){function ue(oe,K){var Re;const Te=new a.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Te.label2=oe.label),Te.insertText=oe.insertText,Te.kind=x.to(oe.kind),Te.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(Ve.to),Te.detail=oe.detail,Te.documentation=R.isMarkdownString(oe.documentation)?w.to(oe.documentation):oe.documentation,Te.sortText=oe.sortText,Te.filterText=oe.filterText,Te.preselect=oe.preselect,Te.commitCharacters=oe.commitCharacters,k.Range.isIRange(oe.range)?Te.range=m.to(oe.range):typeof oe.range=="object"&&(Te.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Te.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Te.insertText=new a.SnippetString(oe.insertText):(Te.insertText=oe.insertText,Te.textEdit=Te.range instanceof a.Range?new a.TextEdit(Te.range,Te.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Te.additionalTextEdits=oe.additionalTextEdits.map(Xe=>z.to(Xe))),Te.command=K&&oe.command?K.fromInternal(oe.command):void 0,Te}pe.to=ue})(Q=e.CompletionItem||(e.CompletionItem={}));var te;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0}}pe.from=ue;function oe(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation}}pe.to=oe})(te=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(te.from):[],activeParameter:K.activeParameter}}pe.from=ue;function oe(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(te.to):[],activeParameter:K.activeParameter}}pe.to=oe})(ie=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(pe){function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ie.from):[]}}pe.from=ue;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ie.to):[]}}pe.to=oe})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Ee;(function(pe){function ue(K){var Re;return{text:K.text,position:l.from(K.position),kind:le.from((Re=K.kind)!==null&&Re!==void 0?Re:a.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}pe.from=ue;function oe(K){const Re=new a.InlayHint(K.text,l.to(K.position),le.to(K.kind));return Re.whitespaceAfter=K.whitespaceAfter,Re.whitespaceBefore=K.whitespaceBefore,Re}pe.to=oe})(Ee=e.InlayHint||(e.InlayHint={}));var le;(function(pe){function ue(K){return K}pe.from=ue;function oe(K){return K}pe.to=oe})(le=e.InlayHintKind||(e.InlayHintKind={}));var _e;(function(pe){function ue(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}pe.from=ue;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?y.URI.parse(K.url,!0):y.URI.revive(K.url)}catch(Te){}return new a.DocumentLink(m.to(K.range),Re)}pe.to=oe})(_e=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(pe){function ue(K){const Re=new a.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Te=>z.to(Te))),Re}pe.to=ue;function oe(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>z.from(Re)):void 0}}pe.from=oe})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(pe){function ue(K){return new a.Color(K[0],K[1],K[2],K[3])}pe.to=ue;function oe(K){return[K.red,K.green,K.blue,K.alpha]}pe.from=oe})(We=e.Color||(e.Color={}));var ge;(function(pe){function ue(K){return{range:m.from(K.range)}}pe.from=ue;function oe(K){return new a.SelectionRange(m.to(K.range))}pe.to=oe})(ge=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(pe){function ue(oe){switch(oe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}pe.to=ue})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(pe){function ue(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=ue;function oe(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}pe.to=oe})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(pe){function ue(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}pe.from=ue;function oe(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}pe.to=oe})(ee=e.EndOfLine||(e.EndOfLine={}));var me;(function(pe){function ue(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=ue})(me=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(pe){function ue(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=He.from(oe.kind)),K}pe.from=ue})(Ne=e.FoldingRange||(e.FoldingRange={}));var He;(function(pe){function ue(oe){if(oe)switch(oe){case a.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}pe.from=ue})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(pe){function ue(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorOverride.DISABLED:void 0}}pe.from=ue})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(pe){function ue(K){return K instanceof a.RelativePattern||typeof K=="string"?K:oe(K)?new a.RelativePattern(K.base,K.pattern):K}pe.from=ue;function oe(K){const Re=K;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var De;(function(pe){function ue(oe){if(oe){if(Array.isArray(oe))return oe.map(ue);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Ye.from(K.pattern),exclusive:K.exclusive}}}else return}pe.from=ue})(De=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(pe){function ue(K){return{start:K.start,end:K.end}}pe.from=ue;function oe(K){return new a.NotebookRange(K.start,K.end)}pe.to=oe})(Se=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(pe){function ue(oe){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}pe.to=ue})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ne;(function(pe){function ue(K){return K}pe.from=ue;function oe(K){return new a.NotebookDocumentMetadata().with(K)}pe.to=oe})(ne=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ae;(function(pe){function ue(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}pe.to=ue;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}pe.from=oe})(ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var N;(function(pe){function ue(K){switch(K){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}pe.from=ue;function oe(K){switch(K){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}pe.to=oe})(N=e.NotebookCellKind||(e.NotebookCellKind={}));var Y;(function(pe){function ue(K){const Re={metadata:ne.from(K.metadata),cells:[]};for(let Te of K.cells)a.NotebookCellData.validate(Te),Re.cells.push(re.from(Te));return Re}pe.from=ue;function oe(K){return{metadata:ne.to(K.metadata),cells:K.cells.map(re.to)}}pe.to=oe})(Y=e.NotebookData||(e.NotebookData={}));var re;(function(pe){function ue(K){var Re;return{cellKind:N.from(K.kind),language:K.languageId,source:K.value,metadata:K.metadata,internalMetadata:ae.from((Re=K.executionSummary)!==null&&Re!==void 0?Re:{}),outputs:K.outputs?K.outputs.map(Ie.from):[]}}pe.from=ue;function oe(K){return new a.NotebookCellData(N.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(Ie.to):void 0,K.metadata?Ce.to(K.metadata):void 0)}pe.to=oe})(re=e.NotebookCellData||(e.NotebookCellData={}));var ke;(function(pe){function ue(K){let Re,Te;return K.data instanceof Uint8Array?Te=Array.from(K.data):Re=K.value,{metadata:K.metadata,mime:K.mime,value:Re,valueBytes:Te}}pe.from=ue;function oe(K){let Re;return Array.isArray(K.valueBytes)?Re=new Uint8Array(K.valueBytes):Re=K.value,new a.NotebookCellOutputItem(Re,K.mime,K.metadata)}pe.to=oe})(ke=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(pe){function ue(K){return{outputId:K.id,outputs:K.outputs.map(ke.from),metadata:K.metadata}}pe.from=ue;function oe(K){const Re=K.outputs.map(ke.to);return new a.NotebookCellOutput(Re,K.outputId,K.metadata)}pe.to=oe})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Oe;(function(pe){function ue(Te){if(Te!=null){if(Te instanceof a.RelativePattern||typeof Te=="string")return Te;if(Re(Te))return new a.RelativePattern(Te.base,Te.pattern);if(K(Te))return{include:Ye.from(Te.include)||void 0,exclude:Ye.from(Te.exclude)||void 0}}}pe.from=ue;function oe(Te){return typeof Te=="string"?Te:Re(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}pe.to=oe;function K(Te){const Xe=Te,Ze=Ye.from(Xe.include);if(!(Ze&&Ze instanceof a.RelativePattern||typeof Ze=="string"))return!1;const ht=Ye.from(Xe.exclude);return!!(ht&&ht instanceof a.RelativePattern||typeof ht=="string")}function Re(Te){const Xe=Te;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Oe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ue;(function(pe){function ue(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?C.from(oe.top):void 0}}pe.from=ue})(Ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(pe){function ue(oe,K,Re){const Te=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Te,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}pe.from=ue})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(pe){function ue(oe){var K,Re,Te;return{transientOutputs:(K=oe==null?void 0:oe.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:(Re=oe==null?void 0:oe.transientCellMetadata)!==null&&Re!==void 0?Re:{},transientDocumentMetadata:(Te=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}pe.from=ue})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(pe){function ue(K){var Re;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Re=K.provides)!==null&&Re!==void 0?Re:[]}}pe.from=ue;function oe(K){return new a.NotebookKernelPreload(y.URI.revive(K.uri),K.provides)}pe.to=oe})(et=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Je;(function(pe){function ue(K){return{message:w.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?B.from(K.location):void 0}}pe.from=ue;function oe(K){const Re=new a.TestMessage(typeof K.message=="string"?K.message:w.to(K.message));return Re.severity=K.severity,Re.actualOutput=K.actualOutput,Re.expectedOutput=K.expectedOutput,Re}pe.to=oe})(Je=e.TestMessage||(e.TestMessage={}));var ot;(function(pe){function ue(Te){var Xe,Ze;return{extId:Te.id,label:Te.label,uri:Te.uri,range:m.from(Te.range)||null,debuggable:(Xe=Te.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Te.description||null,runnable:(Ze=Te.runnable)!==null&&Ze!==void 0?Ze:!0,error:Te.error&&w.fromStrict(Te.error)||null}}pe.from=ue;function oe(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:m.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=oe;function K(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:m.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}pe.toPlain=K;function Re(Te){const Xe=new a.TestItemImpl(Te.extId,Te.label,y.URI.revive(Te.uri),void 0);return Xe.range=m.to(Te.range||void 0),Xe.debuggable=Te.debuggable,Xe.description=Te.description||void 0,Xe.runnable=Te.runnable,Xe}pe.to=Re})(ot=e.TestItem||(e.TestItem={}));var _t;(function(pe){const ue=(K,Re)=>Object.assign(Object.assign({},ot.toPlain(K.item)),{taskStates:K.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(Je.to)})),children:K.children.map(Te=>Re.get(Te)).filter(S.isDefined).map(Te=>ue(Te,Re))});function oe(K){const Re=[],Te=new Map;for(const Xe of K.items)Te.set(Xe.item.extId,Xe),Xe.direct&&Re.push(Xe);return{completedAt:K.completedAt,results:Re.map(Xe=>ue(Xe,Te))}}pe.to=oe})(_t=e.TestResults||(e.TestResults={}));var wt;(function(pe){function ue(oe){switch(oe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}pe.to=ue})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[177],we([0,1,2,12,7,9,45]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(k,n,P,d={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,P,d)=>{const r={dispose:this._callbacks.push([n,P,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,n){const P=v.URI.revive(k);let d=!1;const g=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(d)break;const p=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(a,{document:p,reason:T.TextDocumentSaveReason.to(n)});r.push(m)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([k,n,P],d){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,n,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,P,d){const g=[],r=Date.now(),{document:a,reason:p}=d,{version:m}=a,E=Object.freeze({document:a,reason:p,waitUntil(l){if(Object.isFrozen(g))throw(0,R.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(l))}});try{n.apply(P,[E])}catch(l){return Promise.reject(l)}return Object.freeze(g),new Promise((l,h)=>{const f=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(f),l(t)}).catch(t=>{clearTimeout(f),h(t)})}).then(l=>{const h={edits:[]};for(const f of l)if(Array.isArray(f)&&f.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:i,range:s}of f)h.edits.push({_type:2,resource:a.uri,edit:{range:s&&T.Range.from(s),text:t,eol:i&&T.EndOfLine.from(i)}});if(h.edits.length!==0)return m===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(be[178],we([0,1,3,11,28,2,9,7]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(P,d,g,r,a){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const p=(0,D.parse)(d),m=P(E=>{if(!g)for(let l of E.created){const h=T.URI.revive(l);p(h.fsPath)&&this._onDidCreate.fire(h)}if(!r)for(let l of E.changed){const h=T.URI.revive(l);p(h.fsPath)&&this._onDidChange.fire(h)}if(!a)for(let l of E.deleted){const h=T.URI.revive(l);p(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=S.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,d,g){this._logService=d,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,g,r){return new y(this._onFileSystemEvent.event,P,d,g,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(g=>({oldUri:T.URI.revive(g.source),newUri:T.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(g,r,a)=>{const p=function(E){g.call(r,E)};return p.extension=P,d.event(p,void 0,a)}}async $onWillRunFileOperation(P,d,g,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(a=>({oldUri:T.URI.revive(a.source),newUri:T.URI.revive(a.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(a=>T.URI.revive(a.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(a=>T.URI.revive(a.target))},g,r)}}async _fireWillEvent(P,d,g,r){const a=new Set,p=[];if(await P.fireAsync(d,r,async(E,l)=>{var h;const f=Date.now(),t=await Promise.resolve(E);t instanceof S.WorkspaceEdit&&(p.push(t),a.add((h=l.extension.displayName)!==null&&h!==void 0?h:l.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),r.isCancellationRequested||p.length===0)return;const m={edits:[]};for(let E of p){let{edits:l}=_.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(l)}return{edit:m,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=k}),define(be[179],we([0,1,16,23,2,9,7,50]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(d,g,r,a){this.start=d,this.deletedCount=g,this.deletedItems=r,this.items=a}static asApiEvents(d){return d.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(r=>r.apiCell)}))}}class k{constructor(d,g,r){var a,p,m;this.notebook=d,this._extHostDocument=g,this._cellData=r,this.handle=r.handle,this.uri=D.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(a=r.internalMetadata)!==null&&a!==void 0?a:{},this._metadata=T.NotebookCellMetadata.to((p=r.metadata)!==null&&p!==void 0?p:{}),this._previousResult=T.NotebookCellExecutionSummary.to((m=r.internalMetadata)!==null&&m!==void 0?m:{})}static asModelAddData(d,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,g,r){const a=r.map(T.NotebookCellOutputItem.to),p=this._outputs.find(m=>m.id===d);p&&(g||(p.outputs.length=0),p.outputs.push(...a))}setMetadata(d){this._metadata=T.NotebookCellMetadata.to(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=T.NotebookCellExecutionSummary.to(d)}}e.ExtHostCell=k;class n{constructor(d,g,r,a,p,m,E){this._proxy=d,this._textDocumentsAndEditors=g,this._textDocuments=r,this._emitter=a,this._viewType=p,this._metadata=m,this.uri=E,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===v.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(g){return g=d._validateIndex(g),d._cells[g].apiCell},getCells(g){return(g?d._getCells(g):d._cells).map(a=>a.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,g){this._versionId=d.versionId,this._isDirty=g;for(const r of d.rawEvents)r.kind===S.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===S.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let g=d.start|0,r=d.end|0;return g<0&&(g=0),r>this._cells.length&&(r=this._cells.length),d.with({start:g,end:r})}_getCells(d){d=this._validateRange(d);const g=[];for(let r=d.start;r<d.end;r++)g.push(this._cells[r]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,g){if(this._disposed)return;const r=[],a=[],p=[];d.reverse().forEach(m=>{const l=m[2].map(t=>{const i=new k(this,this._textDocumentsAndEditors,t);return g||a.push(k.asModelAddData(this.apiNotebook,t)),i}),h=new y(m[0],m[1],[],l),f=this._cells.splice(m[0],m[1],...l);for(const t of f)p.push(t.uri),h.deletedItems.push(t.apiCell);r.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:p}),g||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(r)}))}_moveCell(d,g){const r=this._cells.splice(d,1);this._cells.splice(g,0,...r);const a=[new y(d,1,r.map(p=>p.apiCell),[]),new y(g,0,[],r)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(a)}))}_setCellOutputs(d,g){const r=this._cells[d];r.setOutputs(g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,g,r,a){const p=this._cells[d];p.setOutputItems(g,r,a),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(d,g){const r=this._cells[d];r.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(r.uri,g)}_changeCellMetadata(d,g){const r=this._cells[d],a=r.apiCell.metadata;r.setMetadata(g);const p=r.apiCell.metadata;(0,R.equals)(a,p)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(d,g){var r;const a=this._cells[d],p=a.internalMetadata;if(a.setInternalMetadata(g),p.runState!==g.runState){const m=(r=g.runState)!==null&&r!==void 0?r:_.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:m}))}}getCellFromApiCell(d){return this._cells.find(g=>g.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(g=>g.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[98],we([0,1,7,9]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:S,metadata:y})}replaceCells(S,y,k){this._throwIfFinalized(),!(S===y&&k.length===0)&&this._collectedEdits.push({editType:1,index:S,count:y-S,cells:k.map(R.NotebookCellData.from)})}}class T{constructor(S,y,k,n,P,d){this.id=S,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=n,this._viewColumn=d}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},get visibleRanges(){return S._visibleRanges},revealRange(y,k){S._proxy.$tryRevealRange(S.id,R.NotebookRange.from(y),k!=null?k:v.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(y){const k=new D(this.document.version);return y(k),S._applyEdit(k.finalize())},setDecorations(y,k){return S.setDecorations(y,k)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const y=[];let k=-1;for(let n=0;n<S.cellEdits.length;n++){if(k<0){y.push(S.cellEdits[n]),k++;continue}const d=y[k],g=S.cellEdits[n];if(d.editType===1&&g.editType===1&&d.index===g.index){d.cells.push(...S.cellEdits[n].cells),d.count+=S.cellEdits[n].count;continue}y.push(S.cellEdits[n]),k++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,y)}setDecorations(S,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return y.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(y),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(be[180],we([0,1,9,155,134,20,53]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,g){const r=this._handles++,{title:a,location:p,cancellable:m}=d,E={label:(0,D.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:v.ProgressLocation.from(p),title:a,source:E,cancellable:m},P),this._withProgress(r,g,!!m)}_withProgress(P,d,g){let r;g&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const a=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let p;try{p=d(new k(this._proxy,P),g&&r?r.token:T.CancellationToken.None)}catch(m){throw a(P),m}return p.then(m=>a(P),m=>a(P)),p}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=S;function y(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class k extends R.Progress{constructor(P,d){super(g=>this.throttledReport(g));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,_.throttle)(100,(n,P)=>y(n,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[99],we([0,1,42,12,55,9,7]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(d,g){const r=S._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=S,S._Keys=new D.IdGenerator("TextEditorDecorationType");class y{constructor(d,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,g){this._throwIfFinalized();let r=null;if(d instanceof _.Position)r=new _.Range(d,d);else if(d instanceof _.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(d,g){this._throwIfFinalized(),this._pushEdit(new _.Range(d,d),g,!0)}delete(d){this._throwIfFinalized();let g=null;if(d instanceof _.Range)g=d;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(d,g,r){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:g,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==_.EndOfLine.LF&&d!==_.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class k{constructor(d,g,r,a){this._proxy=d,this._id=g,this._accept(r),this._logService=a;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const g=Math.floor(d);return g>0?g:null}if(typeof d=="string"){const g=parseInt(d,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(d){const g=this._validateTabSize(d);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const g=this._validateInsertSpaces(d);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const g={};let r=!1;if(typeof d.tabSize!="undefined"){const a=this._validateTabSize(d.tabSize);a==="auto"?(r=!0,g.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,g.tabSize=a)}if(typeof d.insertSpaces!="undefined"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(r=!0,g.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,g.insertSpaces=a)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,g.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,g.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(d){d.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class n{constructor(d,g,r,a,p,m,E,l){this.id=d,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=E,this._viewColumn=l;const h=this;this.value=Object.freeze({get document(){return a.getValue()},set document(f){throw(0,R.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(f){if(!(f instanceof _.Selection))throw(0,R.illegalArgument)("selection");h._selections=[f],h._trySetSelection()},get selections(){return h._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof _.Selection)))throw(0,R.illegalArgument)("selections");h._selections=f,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(f){throw(0,R.readonly)("visibleRanges")},get options(){return h._options.value},set options(f){h._disposed||h._options.assign(f)},get viewColumn(){return h._viewColumn},set viewColumn(f){throw(0,R.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(a.getValue(),t);return f(i),h._applyEdit(i)},insertSnippet(f,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(o=>T.Range.from(o));else if(t instanceof _.Position){const{lineNumber:o,column:c}=T.Position.from(t);s=[{startLineNumber:o,startColumn:c,endLineNumber:o,endColumn:c}]}else if(t instanceof _.Range)s=[T.Range.from(t)];else{s=[];for(const o of t)if(o instanceof _.Range)s.push(T.Range.from(o));else{const{lineNumber:c,column:w}=T.Position.from(o);s.push({startLineNumber:c,startColumn:w,endLineNumber:c,endColumn:w})}}return g.$tryInsertSnippet(d,f.value,s,i)},setDecorations(f,t){const i=t.length===0;i&&!h._hasDecorationsForKey.has(f.key)||(i?h._hasDecorationsForKey.delete(f.key):h._hasDecorationsForKey.add(f.key),h._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return g.$trySetDecorations(d,f.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let o=0,c=t.length;o<c;o++){const w=t[o];s[4*o]=w.start.line+1,s[4*o+1]=w.start.character+1,s[4*o+2]=w.end.line+1,s[4*o+3]=w.end.character+1}return g.$trySetDecorationsFast(d,f.key,s)}}))},revealRange(f,t){h._runOnProxy(()=>g.$tryRevealRange(d,T.Range.from(f),t||_.TextEditorRevealType.Default))},show(f){g.$tryShowEditor(d,T.ViewColumn.from(f))},hide(){g.$tryHideEditor(d)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,v.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,v.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,v.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,v.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const g=d.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(p=>p.range);r.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=r.length-1;p<m;p++){const E=r[p].end;if(r[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=g.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,a,{setEndOfLine:typeof g.setEndOfLine=="number"?T.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=n}),define(be[181],we([0,1,137,25,2,3,6,11,7,10,13,9,20]),function(J,e,v,R,D,T,_,S,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(p,m){if((0,k.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let E;return Array.isArray(p.highlights)&&(E=p.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),E=E.length?E:void 0),{label:p.label,highlights:E}}}class r{constructor(m,E,l){this._proxy=m,this.commands=E,this.logService=l,this.treeViews=new Map;function h(f){return f&&f.$treeViewId&&f.$treeItemHandle}E.registerArgumentProcessor({processArgument:f=>h(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>h(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(m,E,l){const h=this.createTreeView(m,{treeDataProvider:E},l);return{dispose:()=>h.dispose()}}createTreeView(m,E,l){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=E.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(m,E,l);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await f,this.treeViews.delete(m),t.dispose()}}}$getChildren(m,E){const l=this.treeViews.get(m);return l?l.getChildren(E):Promise.reject(new Error((0,v.localize)(0,null,m)))}$onDrop(m,E,l){const h=this.treeViews.get(m);return h?h.onDrop(E,l):Promise.reject(new Error((0,v.localize)(1,null,m)))}async $hasResolve(m){const E=this.treeViews.get(m);if(!E)throw new Error((0,v.localize)(2,null,m));return E.hasResolve}$resolve(m,E,l){const h=this.treeViews.get(m);if(!h)throw new Error((0,v.localize)(3,null,m));return h.resolveTreeItem(E,l)}$setExpanded(m,E,l){const h=this.treeViews.get(m);if(!h)throw new Error((0,v.localize)(4,null,m));h.setExpanded(E,l)}$setSelection(m,E){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(5,null,m));l.setSelection(E)}$setVisible(m,E){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(6,null,m));l.setVisible(E)}createExtHostTreeView(m,E,l){const h=new a(m,E,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(m,h),h}convertArgument(m){const E=this.treeViews.get(m.$treeViewId);return E?E.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends _.Disposable{constructor(m,E,l,h,f,t){super();if(this.viewId=m,this.proxy=l,this.commands=h,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const c of t.contributes.views[o])c.id===m&&(this._title=c.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,s;this._register(T.Event.debounce(this._onDidChangeData.event,(o,c)=>(o||(o={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>i)),o.elements.push(c.element)),c.message&&(o.message=!0),o),200,!0)(({message:o,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return i=null,this.refresh(c).then(()=>w())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const E=m?this.getExtensionElement(m):void 0;if(m&&!E)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(m);return(l?Promise.resolve(l):this.fetchChildrenNodes(E)).then(h=>h.map(f=>f.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,E){E=E||{select:!0,focus:!1};const l=(0,k.isUndefinedOrNull)(E.select)?!0:E.select,h=(0,k.isUndefinedOrNull)(E.focus)?!1:E.focus,f=(0,k.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:l,focus:h,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:h,expand:f})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,E){const l=this.getExtensionElement(m);l&&(E?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(m){(0,n.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(m,E){const l=m.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f)),h=this.getExtensionElement(E);return l&&h?(0,S.asPromise)(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(l,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,E){var l;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(m);if(h){const f=this.nodes.get(h);if(f){const t=(l=await this.dataProvider.resolveTreeItem(f.extensionItem,h,E))!==null&&l!==void 0?l:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(E=>E?this.resolveUnknownParentChain(E).then(l=>this.resolveTreeNode(E,l[l.length-1]).then(h=>(l.push(h),l))):Promise.resolve([]))}resolveParent(m){const E=this.nodes.get(m);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,E){const l=this.nodes.get(m);return l?Promise.resolve(l):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(h=>this.createHandle(m,h,E,!0)).then(h=>this.getChildren(E?E.item.handle:void 0).then(()=>{const f=this.getExtensionElement(h);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(m){if(m){let E;if(typeof m=="string"){const l=this.getExtensionElement(m);E=l?this.nodes.get(l):void 0}else E=m;return E&&E.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=m?this.nodes.get(m):void 0,h=await this.dataProvider.getChildren(m);if(E.token.isCancellationRequested)return[];const f=await Promise.all((0,n.coalesce)(h||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,l):null}));return E.token.isCancellationRequested?[]:(0,n.coalesce)(f)}finally{E.dispose()}}refresh(m){if(m.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(m);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const E=new Set,l=m.map(f=>this.nodes.get(f));for(const f of l)if(f&&!E.has(f.item.handle)){let t=f;for(;t&&t.parent&&l.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&E.add(f.item.handle)}const h=[];return E.forEach(f=>{const t=this.elements.get(f);if(t){const i=this.nodes.get(t);i&&(!i.parent||!E.has(i.parent.item.handle))&&h.push(f)}}),h}refreshHandles(m){const E={};return Promise.all(m.map(l=>this.refreshNode(l).then(h=>{h&&(E[l]=h.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(m){const E=this.getExtensionElement(m);if(E){const l=this.nodes.get(E);if(l)return this.clearChildren(E),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(h=>{if(h){const f=this.createTreeNode(E,h,l.parent);return this.updateNodeCache(E,f,l,l.parent),l.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,E,l){const h=this.createTreeNode(m,E,l);if(E.id&&this.elements.has(h.item.handle))throw new Error((0,v.localize)(7,null,E.id));return this.addNodeToCache(m,h),this.addNodeToParentCache(h,l),h}getTooltip(m){return y.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,E){return E?this.commands.toInternal(E,m):void 0}createTreeNode(m,E,l){const h=new _.DisposableStore,f=this.createHandle(m,E,l),t=this.getLightIconPath(E);return{item:{handle:f,parentHandle:l?l.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(h,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,k.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:l,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(m){return m.iconPath instanceof y.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:E,label:l,resourceUri:h},f,t){if(E)return`${a.ID_HANDLE_PREFIX}/${E}`;const i=g(l,this.extension),s=f?f.item.handle:a.LABEL_HANDLE_PREFIX;let o=i?i.label:h?(0,R.basename)(h):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const c=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,w=this.getChildrenNodes(f)||[];let b,A=0;do{if(b=`${s}/${A}:${o}`,t||!this.elements.has(b)||c===b)break;A++}while(A<=w.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon))return typeof m.iconPath=="string"||D.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return D.URI.isUri(m)?m:D.URI.file(m)}addNodeToCache(m,E){this.elements.set(E.item.handle,m),this.nodes.set(m,E)}updateNodeCache(m,E,l,h){this.elements.delete(E.item.handle),this.nodes.delete(m),E.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(m,E);const f=this.getChildrenNodes(h)||[],t=f.filter(i=>i.item.handle===l.item.handle)[0];t&&f.splice(f.indexOf(t),1,E)}addNodeToParentCache(m,E){E?(E.children||(E.children=[]),E.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const E=this.nodes.get(m);if(E){if(E.children)for(const l of E.children){const h=this.elements.get(l.item.handle);h&&this.clear(h)}E.children=void 0}}else this.clearAll()}clear(m){const E=this.nodes.get(m);if(E){if(E.children)for(const l of E.children){const h=this.elements.get(l.item.handle);h&&this.clear(h)}this.nodes.delete(m),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(be[182],we([0,1,13,11,20,10,70,9,7,97]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class n{constructor(){this.testIdsToInternal=new Map}getTestById(p,m){if(m!==void 0){const E=this.testIdsToInternal.get(m),l=E==null?void 0:E.get(p);if(l)return[E,l]}return(0,v.mapFind)(this.testIdsToInternal.values(),E=>{const l=E.get(p);return l&&[E,l]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(d++),p)}createIdMap(p){const m=new g(p);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=n;var P;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class g{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const m=this.map.get(p);return m?(this.map.delete(p),this._roots.delete(m),!0):!1}get(p){return this.map.get(p)}comparePositions(p,m){const E=typeof p=="string"?this.map.get(p):p,l=typeof m=="string"?this.map.get(m):m;if(!E||!l)return 0;if(E===l)return 3;for(let h=this.map.get(l.parent);h;h=this.map.get(h.parent))if(h===E)return 1;for(let h=this.map.get(E.parent);h;h=this.map.get(h.parent))if(h===l)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class r{constructor(p,m){this.testIdToInternal=p,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,m){this.addItem(p,m,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const m=this.diff[this.diff.length-1];if(m&&p[0]===1){if(m[0]===1&&m[1].extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}if(m[0]===0&&m[1].item.extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,m){var E;const l=this.testIdToInternal.object.get(p);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const h=this.refreshChildren(l);return h.isSettled?this.expandChildren(l,m-1):h.p.then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return((E=l.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?l.initialExpand.p.then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){var p;for(const m of this.testItemToInternal.values())(p=m.discoverCts)===null||p===void 0||p.dispose(!0),(0,_.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,m){const E=p==null?void 0:p.actual.id;switch(m[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(p);break;case 0:this.addItem(m[1],p.src.controller,p);break;case 3:const[l,h,f]=m;switch(h){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:E,item:{range:S.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:S.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[h]:f!=null?f:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(p,m,E){if(!(p instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const l=E?E.item.extId:null,h=p.resolveHandler?1:0,f=E?E.expandLevels:1,t={controller:m,tree:this.testIdToInternal.object.id},i={actual:p,parent:l,item:S.TestItem.from(p),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(p,i),this.pushDiff([0,{parent:l,src:t,expand:h,item:i.item}]);const s=(0,_.getPrivateApiFor)(p);s.parent=E==null?void 0:E.actual,s.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const o of s.children.values())this.testItemToInternal.has(o)||this.addItem(o,m,i)}updateExpandability(p){var m;let E;p.actual.resolveHandler?p.actual.status===y.TestItemStatus.Pending?E=p.discoverCts?2:1:((m=p.initialExpand)===null||m===void 0||m.complete(),E=3):E=0,E!==p.expand&&(p.expand=E,this.pushDiff([1,{extId:p.actual.id,expand:E}]),E===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,m){if(m<0)return;const E=[...p.actual.children.values()].map(l=>this.expand(l.id,m)).filter(R.isThenable);if(E.length)return Promise.all(E).then(()=>{})}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const m=new R.DeferredPromise;return m.complete(),m}return p.expand=2,p.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new R.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var m;this.pushDiff([2,p.actual.id]);const E=[p];for(;E.length;){const l=E.pop();if(!!l){(m=l.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(l.item.extId),this.testItemToInternal.delete(l.actual);for(const h of l.actual.children.values())E.push(this.testIdToInternal.object.get(h.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(be[183],we([0,1,26,3,14]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class _{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${v.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(d=>P.add(v.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(v.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=_._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(g=>g.identifier)),P.length>0){const g=new Set;P.forEach(r=>g.add(v.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(v.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const E=P.getArcs(p);for(let l=0;l<E.length;l++)if(!m.has(E[l]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let p of n){const m=v.ExtensionIdentifier.toKey(p.identifier);if(d.set(m,p),p.extensionDependencies)for(let E of p.extensionDependencies){const l=v.ExtensionIdentifier.toKey(E);P.addArc(m,l)}}let g=new Set;P.getNodes().filter(p=>P.getArcs(p).length===0).forEach(p=>g.add(p));let r=P.getNodes().filter(p=>!g.has(p)),a;do{a=!1;for(let p=0;p<r.length;p++){const m=r[p];P.hasOnlyGoodArcs(m,g)&&(r.splice(p,1),p--,g.add(m),a=!0)}}while(a);return r.map(p=>d.get(p))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(v.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=_;var S;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(S||(S={}));function y(k,n){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==d)return P-d;const g=D.posix.basename(k.extensionLocation.path),r=D.posix.basename(n.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(be[184],we([0,1,24]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function T(S){const y=v.VSBuffer.alloc(1);switch(S){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=T;function _(S,y){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=_}),define(be[32],we([0,1,3,2,4,26,151]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(E){this.dependency=E}}e.MissingExtensionDependency=S;var y;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(E,l,h,f){this.codeLoadingTime=E,this.activateCallTime=l,this.activateResolvedTime=h,this.activationReason=f}}e.ActivationTimes=k;class n{constructor(E,l){this.description=E,this.value=l}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||g(m)}e.checkProposedApiEnabled=d;function g(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=g;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function a(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=a;class p{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,l){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,l,h,f,t){}_onDidActivateExtensionError(E,l){}_onExtensionRuntimeError(E,l){}_onExtensionHostExit(E){}}e.NullExtensionService=p}),define(be[185],we([0,1,26,32,17]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class _{constructor(r,a,p,m){this.startup=r,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=m}}e.ExtensionActivationTimes=_,_.NONE=new _(!1,-1,-1,-1);class S{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,a){return r===-1||a===-1?-1:a-r}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(r,a,p,m,E,l){this.activationFailed=r,this.activationFailedError=a,this.activationTimes=p,this.module=m,this.exports=E,this.subscriptions=l}}e.ActivatedExtension=y;class k extends y{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends y{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends y{constructor(r){super(!0,r,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let d=class{constructor(r,a,p,m,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,a.forEach(l=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(l),l)),this._host=m,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const a=v.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(a)}getActivatedExtension(r){const a=v.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(a);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,a){if(this._alreadyActivatedEvents[r])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(m=>({id:m.identifier,reason:{startup:a,extensionId:m.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,a){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:a}])}_handleActivateRequest(r,a,p){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(r.id))){a[v.ExtensionIdentifier.toKey(r.id)]=r;return}const m=this._registry.getExtensionDescription(r.id);if(!m){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,h,new R.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(r.id),new P(h));return}const E=typeof m.extensionDependencies=="undefined"?[]:m.extensionDependencies;let l=!0;for(let h=0,f=E.length;h<f;h++){const t=E[h];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const w=m.displayName||m.identifier.value,b=this._registry.getExtensionDescription(t),A=b&&b.displayName||t,C=new Error(`Cannot activate the '${w}' extension because its dependency '${A}' failed to activate`);C.detail=i.activationFailedError,this._host.onExtensionActivationError(m.identifier,C,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new P(C));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){l=!1,a[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,a[v.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:r.reason};continue}const o=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(m.identifier,c,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new P(c));return}l?a[v.ExtensionIdentifier.toKey(m.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const a=Object.create(null),p=[];for(let E=0,l=r.length;E<l;E++)this._handleActivateRequest(r[E],a,p);for(let E=0,l=p.length;E<l;E++){const h=v.ExtensionIdentifier.toKey(p[E].id);a[h]&&delete a[h]}const m=Object.keys(a).map(E=>a[E]);return p.length===0?Promise.all(m.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(m).then(E=>this._activateExtensions(p))}_activateExtension(r,a){const p=v.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const m=this._activatingExtensions.get(p);if(m)return m;const E=this._host.actualActivateExtension(r,a).then(void 0,l=>{const h=new Error;return l&&l.name&&(h.name=l.name),l&&l.message?h.message=`Activating extension '${r.value}' failed: ${l.message}.`:h.message=`Activating extension '${r.value}' failed: ${l}.`,l&&l.stack&&(h.stack=l.stack),this._host.onExtensionActivationError(r,h,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(l),new P(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,E),E}};d=je([Ke(4,D.ILogService)],d),e.ExtensionsActivator=d}),define(be[186],we([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,_)=>{this._actualOk=T,this._actualErr=_,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,v.onUnexpectedError)(T))}then(T,_){return this._ensureActual().then(T,_)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(be[100],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(y,k){this.isMain=y,this.sid=k,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function D(S){const y=new v(!0,S);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function T(S){const y=new v(!1,S);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=T;function _(S){return R[S].sid}e.getStringIdentifierForProxy=_}),define(be[5],we([0,1,58,2,100]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var _;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(_=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(l){l.name="$ident";function h(t,i){return Object.defineProperty(t,l.name,{value:i,enumerable:!0}),t}l.mixin=h;function f(t){return t[l.name]}l.of=f})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(h){return h._id=g._n++,h}}e.IdObject=g,g._n=0;var r;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(l){if(l&&l.edits)for(const h of l.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,v.revive)(h.metadata));return l}e.reviveWorkspaceEditDto=m;var E;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],we([0,1,5,3,4]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(S){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,y){return this._proxy.$getPassword(S,y)}store(S,y,k){return this._proxy.$setPassword(S,y,k)}delete(S,y){return this._proxy.$deletePassword(S,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(be[75],we([0,1,4,17,5,15]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,k,n){const P=this.getUsageKey(y,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};_=je([Ke(0,T.IExtHostRpcService),Ke(1,R.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(S,y,k){}})}),define(be[187],we([0,1,3,5,7,26]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,k,n,P={}){const d=T.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(d)||[],r=[...n].sort().join(" ");let a=g.find(p=>p.scopes===r);if(a)return a.result;{const p=this._getSession(y,d,k,n,P);a={scopes:r,result:p},g.push(a),this._inFlightRequests.set(d,g);try{return await p}finally{const m=g.findIndex(E=>E.scopes===r);m>-1&&(g.splice(m),this._inFlightRequests.set(d,g))}}}async _getSession(y,k,n,P,d={}){await this._proxy.$ensureProvider(n);const g=y.displayName||y.name;return this._proxy.$getSession(n,P,k,g,d)}async removeSession(y,k){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,n,P){var d;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:n,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:k});const g=n.onDidChangeSessions(r=>{var a,p,m;this._proxy.$sendDidChangeSessions(y,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(y,k,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new D.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(a=>a.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,k){return y.forEach(n=>{this._providers.some(P=>P.id===n.id)||this._providers.push(n)}),k.forEach(n=>{const P=this._providers.findIndex(d=>d.id===n.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(be[188],we([0,1,5,15,9]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(S,y){this._extHostDocumentsAndEditors=y,this._proxy=S.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const y=D.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=je([Ke(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[189],we([0,1,5]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const _=T.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(S){return _.$writeText(S)}})}}e.ExtHostClipboard=R}),define(be[76],we([0,1,10,7,9,23,5,13,17,58,31,38,2,6,4,15]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadCommands),this._logService=i,this.converter=new m(this,s=>{const o=this._apiCommands.get(s);return(o==null?void 0:o.result)===l.Void?o:void 0},i),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(o){if(n.Range.isIRange(o))return D.Range.to(o);if(P.Position.isIPosition(o))return D.Position.to(o);if(n.Range.isIRange(o.range)&&d.URI.isUri(o.uri))return D.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const o=t.args.map((w,b)=>{if(!w.validate(s[b]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${s[b]}`);return w.convert(s[b])}),c=await this.executeCommand(t.internalId,...o);return t.result.convert(c,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,o,c){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:o,description:c}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const o=(0,T.cloneAndChange)(i,function(c){if(c instanceof R.Position)return D.Position.from(c);if(c instanceof R.Range)return D.Range.from(c);if(c instanceof R.Location)return D.location.from(c);if(R.NotebookRange.isNotebookRange(c))return D.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,o,s);return(0,k.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw c}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:o,thisArg:c,description:w}=s;if(w)for(let b=0;b<w.args.length;b++)try{(0,v.validateConstraint)(i[b],w.args[b].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[b].name}' - ${w.args[b].description}`)}try{return await o.apply(c,i)}catch(b){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...i);A&&(t=A.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((o,c)=>c.processArgument(o),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:o}=s;o&&(t[i]=o)}return Promise.resolve(t)}};p=je([Ke(0,a.IExtHostRpcService),Ke(1,y.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const o=this._lookupApiCommand(t.command);if(o)s.id=o.internalId,s.arguments=o.args.map((c,w)=>c.convert(t.arguments&&t.arguments[w]));else if((0,S.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),i.add((0,g.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),s.$ident=c,s.id=this.delegatingCommandId,s.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return s}fromInternal(t){const i=_.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class E{constructor(t,i,s,o){this.name=t,this.description=i,this.validate=s,this.convert=o}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new E(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",f=>d.URI.isUri(f),f=>f),E.Position=new E("position","A position in a text document",f=>R.Position.isPosition(f),D.Position.from),E.Range=new E("range","A range in a text document",f=>R.Range.isRange(f),D.Range.from),E.Selection=new E("selection","A selection in a text document",f=>R.Selection.isSelection(f),D.Selection.from),E.Number=new E("number","",f=>typeof f=="number",f=>f),E.String=new E("string","",f=>typeof f=="string",f=>f),E.CallHierarchyItem=new E("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,D.CallHierarchyItem.to);class l{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=l,l.Void=new l("no result",f=>f);class h{constructor(t,i,s,o,c){this.id=t,this.internalId=i,this.description=s,this.args=o,this.result=c}}e.ApiCommand=h}),define(be[190],we([0,1,6,9,7,63,76,169,13,87]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const n=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(R.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,y.isFalsyOrEmpty)(r))return;class p extends D.SymbolInformation{static to(E){const l=new p(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new D.Location(a[0],R.Range.to(E.range)));return l.detail=E.detail,l.range=l.location.range,l.selectionRange=R.Range.to(E.selectionRange),l.children=E.children?E.children.map(p.to):[],l}}return r.map(p.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new _.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(R.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(R.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>D.Position.isPosition(a)),r=>r.map(R.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let p;for(const m of a.reverse())p=new D.SelectionRange(R.Range.to(m),p);return p}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let p of r)a.push(...p[1].map(R.WorkspaceSymbol.to));return a})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,p)=>{if(!r)return new D.CompletionList([]);const m=r.suggestions.map(E=>R.CompletionItem.to(E,p));return new D.CompletionList(m,r.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,p)=>d(m=>new D.CodeLens(R.Range.to(m.range),m.command&&p.fromInternal(m.command)))(r))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>D.Range.isRange(r),r=>D.Selection.isSelection(r)?R.Selection.from(r):R.Range.from(r)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,p)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const E=new D.CodeAction(m.title,m.kind?new D.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=R.WorkspaceEdit.to(m.edit)),m.command&&(E.command=p.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(r))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new D.ColorInformation(R.Range.to(a.range),R.Color.to(a.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",r=>r instanceof D.Color,R.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(R.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>R.NotebookExclusiveDocumentPattern.to(a))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],_.ApiCommandResult.Void)];class P{constructor(a){this._disposables=new v.DisposableStore,this._commands=a}static register(a){return n.forEach(a.registerApiCommand,a),new P(a).registerCommands()}registerCommands(){const a=p=>(...m)=>p(this._commands,...m);this._register(S.RemoveFromRecentlyOpenedAPICommand.ID,a(S.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]})}_register(a,p,m){const E=this._commands.registerCommand(!1,a,p,this,m);this._disposables.add(E)}}e.ExtHostApiCommands=P;function d(r){return a=>{if(Array.isArray(a))return a.map(r)}}function g(r){if(!Array.isArray(r))return;const a=[];for(const p of r)T.isLocationLink(p)?a.push(R.DefinitionLink.to(p)):a.push(R.location.to(p));return a}}),define(be[191],we([0,1,11,53,3,6,2,63,26,9,7,5]),function(J,e,v,R,D,T,_,S,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(h,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.commentThreadHandle);return o||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);return o?{thread:o,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let c=i.commentUniqueId,w=o.getCommentByUniqueId(c);return w||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const o=s.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let c=i.text,w=i.commentUniqueId,b=o.getCommentByUniqueId(w);return b?(b.body=c,b):i}return i}})}createCommentController(h,f,t){const i=d.handlePool++,s=new r(h,i,this._proxy,f,t);this._commentControllers.set(s.handle,s);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return o.push(s),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),o),s}$createCommentThreadTemplate(h,f,t){const i=this._commentControllers.get(h);!i||i.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(h,f,t){const i=this._commentControllers.get(h);!i||i.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(h,f){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(h,f,t){const i=this._commentControllers.get(h);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(_.URI.revive(f));return(0,v.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(o=>o?o.map(c=>k.Range.from(c)):void 0)}$toggleReaction(h,f,t,i,s){const o=this._commentControllers.get(h);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const c=o.getCommentThread(f);if(c){const w=c.getCommentByUniqueId(i.uniqueIdInThread);if(o!==void 0&&w&&o.reactionHandler)return o.reactionHandler(w,m(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class g{constructor(h,f,t,i,s,o,c){this._proxy=h,this._commentController=f,this._id=t,this._uri=i,this._range=s,this._comments=o,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),c),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};h("range")&&(f.range=k.Range.from(this._range)),h("label")&&(f.label=this.label),h("contextValue")&&(f.contextValue=this.contextValue),h("comments")&&(f.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(f.collapseState=E(this._collapseState)),h("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(h){for(let f of this._commentsMap){let t=f[0],i=f[1];if(h===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,R.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class r{constructor(h,f,t,i,s){this._extension=h,this._handle=f,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,f,t,i){if(typeof h=="string"){const s=new g(this._proxy,this,h,f,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new g(this._proxy,this,void 0,h,f,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(h,f){const t=new g(this._proxy,this,void 0,_.URI.revive(h),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,f){let t=this._threads.get(h);t&&(t.range=k.Range.to(f))}$deleteCommentThread(h){let f=this._threads.get(h);f&&f.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(l,h,f,t){let i=t.get(f);i||(i=++l.commentHandle,t.set(f,i));const s=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:i,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:s,label:f.label,commentReactions:f.reactions?f.reactions.map(o=>p(o)):void 0}}function p(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function m(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?_.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function E(l){if(l!==void 0)switch(l){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}}),define(be[101],we([0,1,2,5,7,4,15,17,13,8,14]),function(J,e,v,R,D,T,_,S,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class gn{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const a=gn._handlePool++;this._provider.set(a,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const p=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(a,null);return}let E=(0,y.asArray)(m);if(E.length<=gn._maxEventSize){this._proxy.$onDidChange(a,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const l=E.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),h=(0,y.groupBy)(l,(t,i)=>t.rank-i.rank||(0,k.compare)(t.uri.path,i.uri.path));let f=[];e:for(let t of h){let i;for(let s of t){let o=(0,n.dirname)(s.uri.path);if(i!==o&&(i=o,f.push(s.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(a,f)});return new D.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(g,r,a){if(!this._provider.has(g))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:E}=this._provider.get(g);return await Promise.all(r.map(async l=>{try{const{uri:h,id:f}=l,t=await Promise.resolve(m.provideFileDecoration(v.URI.revive(h),a));if(!t)return;try{D.FileDecoration.validate(t),p[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${E.value}': ${i}`)}}catch(h){this._logService.error(h)}})),p}};P._handlePool=0,P._maxEventSize=250,P=je([Ke(0,_.IExtHostRpcService),Ke(1,S.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[192],we([0,1,132,90,2,5,7,9,3,17,22]),function(J,e,v,R,D,T,_,S,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,a,p,m,E){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let p=[];if(D.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),p=[r]}else if(Array.isArray(r)){p=[];let E;r=[...r].sort(P._compareIndexedTuplesByUri);for(const l of r){const[h,f]=l;if((!E||h.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=h,p.push(h),this._data.set(h,[])),f){const t=this._data.get(h);t&&t.push(...f)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!this._proxy)return;const m=[];for(let E of p){let l=[];const h=this._data.get(E);if(h)if(h.length>this._maxDiagnosticsPerFile){l=[];const f=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of h)if(i.severity===f[t]&&l.push(S.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=h.map(f=>S.Diagnostic.from(f));m.push([E,l])}this._proxy.$changeMany(this._owner,m)}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let p of this._data.keys())r.apply(a,[p,this.get(p),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class zt{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=new n.ResourceMap;for(const p of r)a.set(p,p);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(r,a){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:E,_logService:l}=this,h=new class{$changeMany(i,s){m.$changeMany(i,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,s.length===0?"CLEARING":s)}$clear(i){m.$clear(i),l.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){m.dispose()}};let f;if(!a)a="_generated_diagnostic_collection_name_#"+zt._idPool++,f=a;else if(!p.has(a))f=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do f=a+zt._idPool++;while(p.has(f))}return new class extends P{constructor(){super(a,f,zt._maxDiagnosticsPerFile,h,E);p.set(f,this)}dispose(){super.dispose(),p.delete(f)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,p=[];for(const m of this._collections.values())m.forEach((E,l)=>{let h=a.get(E.toString());typeof h=="undefined"&&(h=p.length,a.set(E.toString(),h),p.push([E,[]])),p[h][1]=p[h][1].concat(...l)});return p}}_getDiagnostics(r){let a=[];for(let p of this._collections.values())p.has(r)&&(a=a.concat(p.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",p=new P(a,a,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of r)this._mirrorCollection.set(D.URI.revive(a),p.map(S.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([Ke(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(be[193],we([0,1,2,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(_){this._proxy=_.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(S=>S?S.map(y=>v.URI.revive(y)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(S=>S?v.URI.revive(S):void 0)}}e.ExtHostDialogs=D}),define(be[194],we([0,1,12,2,7,5,16,20,8]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,d,g){this._documentsAndEditors=d,this._logService=g,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(_.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,d),this._proxy.$registerTextContentProvider(g,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(a=>{if(a.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(g,a).then(p=>{if(!p&&typeof p!="string")return;const m=this._documentsAndEditors.getDocument(a);if(!m)return;const E=(0,y.splitLines)(p);if(!m.equalLines(E))return this._proxy.$onVirtualDocumentChange(a,p)},v.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const g=this._documentContentProviders.get(P);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(d),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[195],we([0,1,3,6,2,5,96,9,10,23]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(d,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const g=this._documentsAndEditors.getDocument(d);if(g)return g}getDocument(d){const g=this.getDocumentData(d);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return g.document}ensureDocumentData(d){const g=this._documentsAndEditors.getDocument(d);if(g)return Promise.resolve(g);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(a=>{this._documentLoader.delete(d.toString());const p=D.URI.revive(a);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(p))},a=>(this._documentLoader.delete(d.toString()),Promise.reject(a))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(g=>D.URI.revive(g))}$acceptModelModeChanged(d,g){const r=D.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(g),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(d){const g=D.URI.revive(d),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,g){const r=D.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(d,g,r){const a=D.URI.revive(d),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:p.document,contentChanges:g.changes.map(m=>({range:S.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,g){(0,_.setWordDefinitionFor)(d,g)}}e.ExtHostDocuments=n}),define(be[39],we([0,1,42,3,6,2,4,5,96,15,99,9,17,22,16,43,110]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(h,f){this._extHostRpc=h,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const f=[],t=[],i=[];if(h.removedDocuments)for(const s of h.removedDocuments){const o=T.URI.revive(s),c=this._documents.get(o);(c==null?void 0:c.unref())&&(this._documents.delete(o),f.push(c.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const o=T.URI.revive(s.uri);let c=this._documents.get(o);if(c&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);c||(c=new m(new y.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(o,c),t.push(c.value)),c.ref()}if(h.removedEditors)for(const s of h.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&i.push(o)}if(h.addedEditors)for(const s of h.addedEditors){const o=T.URI.revive(s.documentUri);v.ok(this._documents.has(o),`document '${o}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(o).value,w=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>c.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(b=>P.Range.to(b)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,w)}h.newActiveEditor!==void 0&&(v.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,D.dispose)(f),(0,D.dispose)(i),h.removedDocuments&&this._onDidRemoveDocuments.fire(f),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var f;return(f=this._documents.get(h))===null||f===void 0?void 0:f.value}allDocuments(){return a.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return h?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};E=je([Ke(0,k.IExtHostRpcService),Ke(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[196],we([0,1,2,5,6,7,9,120,8,24]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const r=this._schemes.indexOf(g);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),r=[];let a,p,m=14,E=14;for(const l of g){let h=a?(0,y.commonPrefixLength)(a,l):0;for(h===0?p=1:p=E;h<l.length;h++)h+1===l.length?(m=E,E=9):E+=1,r.push([p,l.toUpperCase().charCodeAt(h),E]),r.push([p,l.toLowerCase().charCodeAt(h),E]),p=E;a=l,E=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new S.StateMachine(r)}}provideDocumentLinks(g){this._initStateMachine();const r=[],a=S.LinkComputer.computeLinks({getLineContent(p){return g.lineAt(p-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const p of a){const m=_.DocumentLink.to(p);m.target&&r.push(m)}return r}}class P{constructor(g,r){this._extHostLanguageFeatures=r,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,r,a,p={},m){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(E,a),this._enableProposedApi.set(E,m!=null?m:!1);let l=2;p.isCaseSensitive&&(l+=1024),p.isReadonly&&(l+=2048),typeof a.copy=="function"&&(l+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(E,r,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${r}`),console.error(f)});const h=a.onDidChangeFile(f=>{const t=[];for(const i of f){let{uri:s,type:o}=i;if(s.scheme!==r)continue;let c;switch(o){case T.FileChangeType.Changed:c=0;break;case T.FileChangeType.Created:c=1;break;case T.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:c})}this._proxy.$onFileSystemChange(E,t)});return(0,D.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,r){const{type:a,ctime:p,mtime:m,size:E,permissions:l}=g;return r?{type:a,ctime:p,mtime:m,size:E,permissions:l}:{type:a,ctime:p,mtime:m,size:E}}$stat(g,r){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(r))).then(a=>{var p;return P._asIStat(a,(p=this._enableProposedApi.get(g))!==null&&p!==void 0?p:!1)})}$readdir(g,r){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(r)))}$readFile(g,r){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(r))).then(a=>k.VSBuffer.wrap(a))}$writeFile(g,r,a,p){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(r),a.buffer,p))}$delete(g,r,a){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(r),a))}$rename(g,r,a,p){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(r),v.URI.revive(a),p))}$copy(g,r,a,p){const m=this._getFsProvider(g);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(v.URI.revive(r),v.URI.revive(a),p))}$mkdir(g,r){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(r)))}$watch(g,r,a,p){const m=this._getFsProvider(g).watch(v.URI.revive(a),p);this._watches.set(r,m)}$unwatch(g,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(g,r,a){const p=this._getFsProvider(g);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(v.URI.revive(r),a))}$close(g,r){const a=this._getFsProvider(g);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(g,r,a,p){const m=this._getFsProvider(g);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(p);return Promise.resolve(m.read(r,a,E.buffer,0,p)).then(l=>E.slice(0,l))}$write(g,r,a,p){const m=this._getFsProvider(g);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,a,p.buffer,0,p.byteLength))}_getFsProvider(g){const r=this._fsProvider.get(g);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=P}),define(be[77],we([0,1,5,65,7,24,4,15,49]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(P,d){const g=P.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return g.$stat(r).catch(Ut._handleError)},readDirectory(r){return g.$readdir(r).catch(Ut._handleError)},createDirectory(r){return g.$mkdir(r).catch(Ut._handleError)},async readFile(r){return g.$readFile(r).then(a=>a.buffer).catch(Ut._handleError)},writeFile(r,a){return g.$writeFile(r,T.VSBuffer.wrap(a)).catch(Ut._handleError)},delete(r,a){return g.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Ut._handleError)},rename(r,a,p){return g.$rename(r,a,Object.assign({overwrite:!1},p)).catch(Ut._handleError)},copy(r,a,p){return g.$copy(r,a,Object.assign({overwrite:!1},p)).catch(Ut._handleError)},isWritableFileSystem(r){const a=d.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new D.FileSystemError(String(P));if(P.name==="ENOPRO")throw D.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(P.message);default:throw new D.FileSystemError(P.message,P.name)}}};k=je([Ke(0,S.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(be[197],we([0,1,6,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(_){this._handlePool=0,this._proxy=_.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,_),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=D}),define(be[198],we([0,1,2,23,9,7,11,5,8,31,13,10,117,6,87,55,68,56,12]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(x,Q){this._documents=x,this._provider=Q}provideDocumentSymbols(x,Q){const te=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideDocumentSymbols(te,Q)).then(ie=>{if(!(0,n.isFalsyOrEmpty)(ie))return ie[0]instanceof T.DocumentSymbol?ie.map(D.DocumentSymbol.from):l._asDocumentSymbolTree(ie)})}static _asDocumentSymbolTree(x){var Q;x=x.slice(0).sort((fe,Ee)=>{let le=fe.location.range.start.compareTo(Ee.location.range.start);return le===0&&(le=Ee.location.range.end.compareTo(fe.location.range.end)),le});const te=[],ie=[];for(const fe of x){const Ee={name:fe.name||"!!MISSING: name!!",kind:D.SymbolKind.from(fe.kind),tags:((Q=fe.tags)===null||Q===void 0?void 0:Q.map(D.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:D.Range.from(fe.location.range),selectionRange:D.Range.from(fe.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Ee),te.push(Ee);break}const le=ie[ie.length-1];if(k.Range.containsRange(le.range,Ee.range)&&!k.Range.equalsRange(le.range,Ee.range)){le.children&&le.children.push(Ee),ie.push(Ee);break}ie.pop()}}return te}}class h{constructor(x,Q,te){this._documents=x,this._commands=Q,this._provider=te,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Q){const te=this._documents.getDocument(x),ie=await this._provider.provideCodeLenses(te,Q);if(!ie||Q.isCancellationRequested)return;const fe=this._cache.add(ie),Ee=new g.DisposableStore;this._disposables.set(fe,Ee);const le={cacheId:fe,lenses:[]};for(let _e=0;_e<ie.length;_e++)le.lenses.push({cacheId:[fe,_e],range:D.Range.from(ie[_e].range),command:this._commands.toInternal(ie[_e].command,Ee)});return le}async resolveCodeLens(x,Q){var te;const ie=x.cacheId&&this._cache.get(...x.cacheId);if(!ie)return;let fe;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?fe=ie:fe=await this._provider.resolveCodeLens(ie,Q),fe||(fe=ie),Q.isCancellationRequested)return;const Ee=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Ee)return x.command=this._commands.toInternal((te=fe.command)!==null&&te!==void 0?te:h._badCmd,Ee),x}releaseCodeLenses(x){var Q;(Q=this._disposables.get(x))===null||Q===void 0||Q.dispose(),this._disposables.delete(x),this._cache.delete(x)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(Ve){return Array.isArray(Ve)?Ve.map(D.DefinitionLink.from):Ve?[D.DefinitionLink.from(Ve)]:[]}class t{constructor(x,Q){this._documents=x,this._provider=Q}provideDefinition(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideDefinition(ie,fe,te)).then(f)}}class i{constructor(x,Q){this._documents=x,this._provider=Q}provideDeclaration(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideDeclaration(ie,fe,te)).then(f)}}class s{constructor(x,Q){this._documents=x,this._provider=Q}provideImplementation(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideImplementation(ie,fe,te)).then(f)}}class o{constructor(x,Q){this._documents=x,this._provider=Q}provideTypeDefinition(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideTypeDefinition(ie,fe,te)).then(f)}}class c{constructor(x,Q){this._documents=x,this._provider=Q}provideHover(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideHover(ie,fe,te)).then(Ee=>{if(!(!Ee||(0,n.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=ie.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new T.Range(fe,fe)),D.Hover.from(Ee)})}}class w{constructor(x,Q){this._documents=x,this._provider=Q}provideEvaluatableExpression(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideEvaluatableExpression(ie,fe,te)).then(Ee=>{if(Ee)return D.EvaluatableExpression.from(Ee)})}}class b{constructor(x,Q){this._documents=x,this._provider=Q}provideInlineValues(x,Q,te,ie){const fe=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideInlineValues(fe,D.Range.to(Q),D.InlineValueContext.to(te),ie)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(le=>D.InlineValue.from(le))})}}class A{constructor(x,Q){this._documents=x,this._provider=Q}provideDocumentHighlights(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideDocumentHighlights(ie,fe,te)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(D.DocumentHighlight.from)})}}class C{constructor(x,Q){this._documents=x,this._provider=Q}provideLinkedEditingRanges(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideLinkedEditingRanges(ie,fe,te)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,n.coalesce)(Ee.ranges.map(D.Range.from)),wordPattern:Ee.wordPattern}})}}class u{constructor(x,Q){this._documents=x,this._provider=Q}provideReferences(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideReferences(fe,Ee,te,ie)).then(le=>{if(Array.isArray(le))return le.map(D.location.from)})}}class F{constructor(x,Q,te,ie,fe,Ee,le){this._documents=x,this._commands=Q,this._diagnostics=te,this._provider=ie,this._logService=fe,this._extension=Ee,this._apiDeprecation=le,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=d.Selection.isISelection(Q)?D.Selection.to(Q):D.Range.to(Q),le=[];for(const Ae of this._diagnostics.getDiagnostics(x))if(Ee.intersection(Ae.range)&&le.push(Ae)>F._maxCodeActionsPerFile)break;const _e={diagnostics:le,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:D.CodeActionTriggerKind.to(te.trigger)};return(0,_.asPromise)(()=>this._provider.provideCodeActions(fe,Ee,_e,ie)).then(Ae=>{var We;if(!(0,n.isNonEmptyArray)(Ae)||ie.isCancellationRequested)return;const ge=this._cache.add(Ae),Ge=new g.DisposableStore;this._disposables.set(ge,Ge);const V=[];for(let ee=0;ee<Ae.length;ee++){const me=Ae[ee];!me||(F._isCommand(me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),V.push({_isSynthetic:!0,title:me.title,command:this._commands.toInternal(me,Ge)})):(_e.only&&(me.kind?_e.only.contains(me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action is of kind '${me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),V.push({cacheId:[ge,ee],title:me.title,command:me.command&&this._commands.toInternal(me.command,Ge),diagnostics:me.diagnostics&&me.diagnostics.map(D.Diagnostic.from),edit:me.edit&&D.WorkspaceEdit.from(me.edit),kind:me.kind&&me.kind.value,isPreferred:me.isPreferred,disabled:(We=me.disabled)===null||We===void 0?void 0:We.reason})))}return{cacheId:ge,actions:V}})}async resolveCodeAction(x,Q){var te;const[ie,fe]=x,Ee=this._cache.get(ie,fe);if(!Ee||F._isCommand(Ee)||!this._provider.resolveCodeAction)return;const le=(te=await this._provider.resolveCodeAction(Ee,Q))!==null&&te!==void 0?te:Ee;return(le==null?void 0:le.edit)?D.WorkspaceEdit.from(le.edit):void 0}releaseCodeActions(x){var Q;(Q=this._disposables.get(x))===null||Q===void 0||Q.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}F._maxCodeActionsPerFile=1e3;class O{constructor(x,Q){this._documents=x,this._provider=Q}provideDocumentFormattingEdits(x,Q,te){const ie=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ie,Q,te)).then(fe=>{if(Array.isArray(fe))return fe.map(D.TextEdit.from)})}}class z{constructor(x,Q){this._documents=x,this._provider=Q}provideDocumentRangeFormattingEdits(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Range.to(Q);return(0,_.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Ee,te,ie)).then(le=>{if(Array.isArray(le))return le.map(D.TextEdit.from)})}}class de{constructor(x,Q){this._documents=x,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,Q,te,ie,fe){const Ee=this._documents.getDocument(x),le=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,le,te,ie,fe)).then(_e=>{if(Array.isArray(_e))return _e.map(D.TextEdit.from)})}}class he{constructor(x,Q){this._provider=x,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,Q){const te=S.IdObject.mixin({symbols:[]});return(0,_.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,Q)).then(ie=>{if((0,n.isNonEmptyArray)(ie))for(const fe of ie){if(!fe)continue;if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Ee=S.IdObject.mixin(D.WorkspaceSymbol.from(fe));this._symbolCache.set(Ee._id,fe),te.symbols.push(Ee)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(x,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const te=this._symbolCache.get(x._id);if(te){const ie=await(0,_.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Q));return ie&&(0,R.mixin)(x,D.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(x){const Q=this._resultCache.get(x);if(Q){for(let[te,ie]=Q;te<=ie;te++)this._symbolCache.delete(te);this._resultCache.delete(x)}}}class ${constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.provideRenameEdits(fe,Ee,te,ie)).then(le=>{if(!!le)return D.WorkspaceEdit.from(le)},le=>{const _e=$._asMessage(le);return _e?{rejectReason:_e,edits:void 0}:Promise.reject(le)})}resolveRenameLocation(x,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument(x),fe=D.Position.to(Q);return(0,_.asPromise)(()=>this._provider.prepareRename(ie,fe,te)).then(Ee=>{let le,_e;if(T.Range.isRange(Ee)?(le=Ee,_e=ie.getText(Ee)):(0,P.isObject)(Ee)&&(le=Ee.range,_e=Ee.placeholder),!!le){if(le.start.line>fe.line||le.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(le),text:_e}}},Ee=>{const le=$._asMessage(Ee);return le?{rejectReason:le,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class j{constructor(x,Q){this.resultId=x,this.tokens=Q}}class W{constructor(x,Q){this._documents=x,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,Q,te){const ie=this._documents.getDocument(x),fe=Q!==0?this._previousResults.get(Q):null;return(0,_.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ie,fe.resultId,te):this._provider.provideDocumentSemanticTokens(ie,te)).then(Ee=>(fe&&this._previousResults.delete(Q),Ee?(Ee=W._fixProvidedSemanticTokens(Ee),this._send(W._convertToEdits(fe,Ee),Ee)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return W._isSemanticTokens(x)?W._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):W._isSemanticTokensEdits(x)?W._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(Q=>new T.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Q of x.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Q){if(!W._isSemanticTokens(Q)||!x||!x.tokens)return Q;const te=x.tokens,ie=te.length,fe=Q.data,Ee=fe.length;let le=0;const _e=Math.min(ie,Ee);for(;le<_e&&te[le]===fe[le];)le++;if(le===ie&&le===Ee)return new T.SemanticTokensEdits([],Q.resultId);let Ae=0;const We=_e-le;for(;Ae<We&&te[ie-Ae-1]===fe[Ee-Ae-1];)Ae++;return new T.SemanticTokensEdits([{start:le,deleteCount:ie-le-Ae,data:fe.subarray(le,Ee-Ae)}],Q.resultId)}_send(x,Q){if(W._isSemanticTokens(x)){const te=this._nextResultId++;return this._previousResults.set(te,new j(x.resultId,x.data)),(0,r.encodeSemanticTokensDto)({id:te,type:"full",data:x.data})}if(W._isSemanticTokensEdits(x)){const te=this._nextResultId++;return W._isSemanticTokens(Q)?this._previousResults.set(te,new j(Q.resultId,Q.data)):this._previousResults.set(te,new j(x.resultId)),(0,r.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(x.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class I{constructor(x,Q){this._documents=x,this._provider=Q}provideDocumentRangeSemanticTokens(x,Q,te){const ie=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ie,D.Range.to(Q),te)).then(fe=>fe?this._send(fe):null)}_send(x){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=I;class H{constructor(x,Q,te,ie,fe){this._documents=x,this._commands=Q,this._provider=te,this._apiDeprecation=ie,this._extension=fe,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Position.to(Q),le=fe.getWordRangeAtPosition(Ee)||new T.Range(Ee,Ee),_e=le.with({end:Ee}),Ae=new m.StopWatch(!0),We=await(0,_.asPromise)(()=>this._provider.provideCompletionItems(fe,Ee,ie,D.CompletionContext.to(te)));if(!We||ie.isCancellationRequested)return;const ge=Array.isArray(We)?new T.CompletionList(We):We,Ge=H.supportsResolving(this._provider)?this._cache.add(ge.items):this._cache.add([]),V=new g.DisposableStore;this._disposables.set(Ge,V);const ee=[],me={x:Ge,b:ee,a:{replace:D.Range.from(le),insert:D.Range.from(_e)},c:ge.isIncomplete||void 0,d:Ae.elapsed()};for(let Ne=0;Ne<ge.items.length;Ne++){const He=ge.items[Ne],$e=this._convertCompletionItem(He,[Ge,Ne],_e,le);ee.push($e)}return me}async resolveCompletionItem(x,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...x);if(!te)return;const ie=await(0,_.asPromise)(()=>this._provider.resolveCompletionItem(te,Q));if(!!ie)return this._convertCompletionItem(ie,x)}releaseCompletionItems(x){var Q;(Q=this._disposables.get(x))===null||Q===void 0||Q.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Q,te,ie){var fe;const Ee=this._disposables.get(Q[0]);if(!Ee)throw Error("DisposableStore is missing...");const le={x:Q,a:(fe=x.label)!==null&&fe!==void 0?fe:"",o:x.label2,b:x.kind!==void 0?D.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(D.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(x.command,Ee)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=x.textEdit.newText):typeof x.insertText=="string"?le.h=x.insertText:x.insertText instanceof T.SnippetString&&(le.h=x.insertText.value,le.i|=4);let _e;return x.textEdit?_e=x.textEdit.range:x.range&&(_e=x.range),T.Range.isRange(_e)?le.j=D.Range.from(_e):_e&&(!(te==null?void 0:te.isEqual(_e.inserting))||!(ie==null?void 0:ie.isEqual(_e.replacing)))&&(le.j={insert:D.Range.from(_e.inserting),replace:D.Range.from(_e.replacing)}),le}}class M{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlineCompletions(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Position.to(Q),le=await(0,_.asPromise)(()=>this._provider.provideInlineCompletionItems(fe,Ee,te,ie));if(!!le&&!ie.isCancellationRequested)return{items:le.items.map(_e=>({text:_e.text,range:_e.range?D.Range.from(_e.range):void 0}))}}}class B{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(x,Q,te,ie){const fe=this._documents.getDocument(x),Ee=D.Position.to(Q),le=this.reviveContext(te);return(0,_.asPromise)(()=>this._provider.provideSignatureHelp(fe,Ee,ie,le)).then(_e=>{if(_e){const Ae=this._cache.add([_e]);return Object.assign(Object.assign({},D.SignatureHelp.from(_e)),{id:Ae})}})}reviveContext(x){let Q;if(x.activeSignatureHelp){const te=D.SignatureHelp.to(x.activeSignatureHelp),ie=this._cache.get(x.activeSignatureHelp.id,0);ie?(Q=ie,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return Object.assign(Object.assign({},x),{activeSignatureHelp:Q})}releaseSignatureHelp(x){this._cache.delete(x)}}class G{constructor(x,Q){this._documents=x,this._provider=Q}provideInlayHints(x,Q,te){const ie=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideInlayHints(ie,D.Range.to(Q),te)).then(fe=>fe?{hints:fe.map(D.InlayHint.from)}:void 0)}}class q{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new p.Cache("DocumentLink")}provideLinks(x,Q){const te=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideDocumentLinks(te,Q)).then(ie=>{if(!(!Array.isArray(ie)||ie.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.map(D.DocumentLink.from)};{const fe=this._cache.add(ie),Ee={links:[],id:fe};for(let le=0;le<ie.length;le++){const _e=D.DocumentLink.from(ie[le]);_e.cacheId=[fe,le],Ee.links.push(_e)}return Ee}}})}resolveLink(x,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...x);return te?(0,_.asPromise)(()=>this._provider.resolveDocumentLink(te,Q)).then(ie=>ie&&D.DocumentLink.from(ie)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Q){this._documents=x,this._provider=Q}provideColors(x,Q){const te=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideDocumentColors(te,Q)).then(ie=>Array.isArray(ie)?ie.map(Ee=>({color:D.Color.from(Ee.color),range:D.Range.from(Ee.range)})):[])}provideColorPresentations(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Range.to(Q.range),Ee=D.Color.to(Q.color);return(0,_.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:ie,range:fe},te)).then(le=>{if(!!Array.isArray(le))return le.map(D.ColorPresentation.from)})}}class ve{constructor(x,Q){this._documents=x,this._provider=Q}provideFoldingRanges(x,Q,te){const ie=this._documents.getDocument(x);return(0,_.asPromise)(()=>this._provider.provideFoldingRanges(ie,Q,te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(D.FoldingRange.from)})}}class Le{constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}provideSelectionRanges(x,Q,te){const ie=this._documents.getDocument(x),fe=Q.map(D.Position.to);return(0,_.asPromise)(()=>this._provider.provideSelectionRanges(ie,fe,te)).then(Ee=>{if(!(0,n.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const le=[];for(let _e=0;_e<fe.length;_e++){const Ae=[];le.push(Ae);let We=fe[_e],ge=Ee[_e];for(;;){if(!ge.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(D.SelectionRange.from(ge)),!ge.parent)break;We=ge.range,ge=ge.parent}}return le})}}class xe{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,te){const ie=this._documents.getDocument(x),fe=D.Position.to(Q),Ee=await this._provider.prepareCallHierarchy(ie,fe,te);if(!Ee)return;const le=this._idPool.nextId();return this._cache.set(le,new Map),Array.isArray(Ee)?Ee.map(_e=>this._cacheAndConvertItem(le,_e)):[this._cacheAndConvertItem(le,Ee)]}async provideCallsTo(x,Q,te){const ie=this._itemFromCache(x,Q);if(!ie)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(ie,te);if(!!fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(x,Ee.from),fromRanges:Ee.fromRanges.map(le=>D.Range.from(le))}))}async provideCallsFrom(x,Q,te){const ie=this._itemFromCache(x,Q);if(!ie)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(ie,te);if(!!fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(x,Ee.to),fromRanges:Ee.fromRanges.map(le=>D.Range.from(le))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){var te;const ie=this._cache.get(x),fe={_sessionId:x,_itemId:ie.size.toString(36),name:Q.name,detail:Q.detail,kind:D.SymbolKind.from(Q.kind),uri:Q.uri,range:D.Range.from(Q.range),selectionRange:D.Range.from(Q.selectionRange),tags:(te=Q.tags)===null||te===void 0?void 0:te.map(D.SymbolTag.from)};return ie.set(fe._itemId,Q),fe}_itemFromCache(x,Q){const te=this._cache.get(x);return te==null?void 0:te.get(Q)}}class Me{constructor(x,Q){this.adapter=x,this.extension=Q}}class ze{constructor(x,Q,te,ie,fe,Ee,le){this._adapter=new Map,this._uriTransformer=Q,this._proxy=x.getProxy(S.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ie,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=le}_transformDocumentSelector(x){return(0,n.coalesce)((0,n.asArray)(x).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:D.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Q,te,ie,fe=!1){const Ee=this._adapter.get(x);if(!Ee)return Promise.resolve(ie);if(Ee.adapter instanceof Q){let le;Ee.extension&&(le=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${Q.name}'`));const _e=te(Ee.adapter,Ee.extension),Ae=Ee.extension;return Ae&&Promise.resolve(_e).then(()=>this._logService.trace(`[${Ae.identifier.value}] provider DONE after ${Date.now()-le}ms`),We=>{fe&&We instanceof E.CancellationError||(this._logService.error(`[${Ae.identifier.value}] provider FAILED`),this._logService.error(We))}),_e}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Q){const te=this._nextHandle();return this._adapter.set(te,new Me(x,Q)),te}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Q,te,ie){const fe=this._addNewAdapter(new l(this._documents,te),x),Ee=ie&&ie.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Q),Ee),this._createDisposable(fe)}$provideDocumentSymbols(x,Q,te){return this._withAdapter(x,l,ie=>ie.provideDocumentSymbols(v.URI.revive(Q),te),void 0)}registerCodeLensProvider(x,Q,te){const ie=this._nextHandle(),fe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Me(new h(this._documents,this._commands.converter,te),x)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(Q),fe);let Ee=this._createDisposable(ie);if(fe!==void 0){const le=te.onDidChangeCodeLenses(_e=>this._proxy.$emitCodeLensEvent(fe));Ee=T.Disposable.from(Ee,le)}return Ee}$provideCodeLenses(x,Q,te){return this._withAdapter(x,h,ie=>ie.provideCodeLenses(v.URI.revive(Q),te),void 0)}$resolveCodeLens(x,Q,te){return this._withAdapter(x,h,ie=>ie.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(x,Q){this._withAdapter(x,h,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(x,Q,te){const ie=this._addNewAdapter(new t(this._documents,te),x);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideDefinition(x,Q,te,ie){return this._withAdapter(x,t,fe=>fe.provideDefinition(v.URI.revive(Q),te,ie),[])}registerDeclarationProvider(x,Q,te){const ie=this._addNewAdapter(new i(this._documents,te),x);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideDeclaration(x,Q,te,ie){return this._withAdapter(x,i,fe=>fe.provideDeclaration(v.URI.revive(Q),te,ie),[])}registerImplementationProvider(x,Q,te){const ie=this._addNewAdapter(new s(this._documents,te),x);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideImplementation(x,Q,te,ie){return this._withAdapter(x,s,fe=>fe.provideImplementation(v.URI.revive(Q),te,ie),[])}registerTypeDefinitionProvider(x,Q,te){const ie=this._addNewAdapter(new o(this._documents,te),x);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideTypeDefinition(x,Q,te,ie){return this._withAdapter(x,o,fe=>fe.provideTypeDefinition(v.URI.revive(Q),te,ie),[])}registerHoverProvider(x,Q,te,ie){const fe=this._addNewAdapter(new c(this._documents,te),x);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideHover(x,Q,te,ie){return this._withAdapter(x,c,fe=>fe.provideHover(v.URI.revive(Q),te,ie),void 0)}registerEvaluatableExpressionProvider(x,Q,te,ie){const fe=this._addNewAdapter(new w(this._documents,te),x);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideEvaluatableExpression(x,Q,te,ie){return this._withAdapter(x,w,fe=>fe.provideEvaluatableExpression(v.URI.revive(Q),te,ie),void 0)}registerInlineValuesProvider(x,Q,te,ie){const fe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new b(this._documents,te),x);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(Q),fe);let le=this._createDisposable(Ee);if(fe!==void 0){const _e=te.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(fe));le=T.Disposable.from(le,_e)}return le}$provideInlineValues(x,Q,te,ie,fe){return this._withAdapter(x,b,Ee=>Ee.provideInlineValues(v.URI.revive(Q),te,ie,fe),void 0)}registerDocumentHighlightProvider(x,Q,te){const ie=this._addNewAdapter(new A(this._documents,te),x);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideDocumentHighlights(x,Q,te,ie){return this._withAdapter(x,A,fe=>fe.provideDocumentHighlights(v.URI.revive(Q),te,ie),void 0)}registerLinkedEditingRangeProvider(x,Q,te){const ie=this._addNewAdapter(new C(this._documents,te),x);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideLinkedEditingRanges(x,Q,te,ie){return this._withAdapter(x,C,async fe=>{const Ee=await fe.provideLinkedEditingRanges(v.URI.revive(Q),te,ie);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ze._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Q,te){const ie=this._addNewAdapter(new u(this._documents,te),x);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideReferences(x,Q,te,ie,fe){return this._withAdapter(x,u,Ee=>Ee.provideReferences(v.URI.revive(Q),te,ie,fe),void 0)}registerCodeActionProvider(x,Q,te,ie){var fe,Ee;const le=new g.DisposableStore,_e=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,te,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(_e,this._transformDocumentSelector(Q),{providedKinds:(fe=ie==null?void 0:ie.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ae=>Ae.value),documentation:(Ee=ie==null?void 0:ie.documentation)===null||Ee===void 0?void 0:Ee.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,le)}))},ze._extLabel(x),Boolean(te.resolveCodeAction)),le.add(this._createDisposable(_e)),le}$provideCodeActions(x,Q,te,ie,fe){return this._withAdapter(x,F,Ee=>Ee.provideCodeActions(v.URI.revive(Q),te,ie,fe),void 0)}$resolveCodeAction(x,Q,te){return this._withAdapter(x,F,ie=>ie.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(x,Q){this._withAdapter(x,F,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(x,Q,te){const ie=this._addNewAdapter(new O(this._documents,te),x);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ie)}$provideDocumentFormattingEdits(x,Q,te,ie){return this._withAdapter(x,O,fe=>fe.provideDocumentFormattingEdits(v.URI.revive(Q),te,ie),void 0)}registerDocumentRangeFormattingEditProvider(x,Q,te){const ie=this._addNewAdapter(new z(this._documents,te),x);return this._proxy.$registerRangeFormattingSupport(ie,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ie)}$provideDocumentRangeFormattingEdits(x,Q,te,ie,fe){return this._withAdapter(x,z,Ee=>Ee.provideDocumentRangeFormattingEdits(v.URI.revive(Q),te,ie,fe),void 0)}registerOnTypeFormattingEditProvider(x,Q,te,ie){const fe=this._addNewAdapter(new de(this._documents,te),x);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Q),ie,x.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(x,Q,te,ie,fe,Ee){return this._withAdapter(x,de,le=>le.provideOnTypeFormattingEdits(v.URI.revive(Q),te,ie,fe,Ee),void 0)}registerWorkspaceSymbolProvider(x,Q){const te=this._addNewAdapter(new he(Q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(x,Q,te){return this._withAdapter(x,he,ie=>ie.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(x,Q,te){return this._withAdapter(x,he,ie=>ie.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(x,Q){this._withAdapter(x,he,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(x,Q,te){const ie=this._addNewAdapter(new $(this._documents,te,this._logService),x);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(Q),$.supportsResolving(te)),this._createDisposable(ie)}$provideRenameEdits(x,Q,te,ie,fe){return this._withAdapter(x,$,Ee=>Ee.provideRenameEdits(v.URI.revive(Q),te,ie,fe),void 0)}$resolveRenameLocation(x,Q,te,ie){return this._withAdapter(x,$,fe=>fe.resolveRenameLocation(v.URI.revive(Q),te,ie),void 0)}registerDocumentSemanticTokensProvider(x,Q,te,ie){const fe=this._nextHandle(),Ee=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Me(new W(this._documents,te),x)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Q),ie,Ee);let le=this._createDisposable(fe);if(Ee){const _e=te.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));le=T.Disposable.from(le,_e)}return le}$provideDocumentSemanticTokens(x,Q,te,ie){return this._withAdapter(x,W,fe=>fe.provideDocumentSemanticTokens(v.URI.revive(Q),te,ie),null,!0)}$releaseDocumentSemanticTokens(x,Q){this._withAdapter(x,W,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(x,Q,te,ie){const fe=this._addNewAdapter(new I(this._documents,te),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Q),ie),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(x,Q,te,ie){return this._withAdapter(x,I,fe=>fe.provideDocumentRangeSemanticTokens(v.URI.revive(Q),te,ie),null,!0)}registerCompletionItemProvider(x,Q,te,ie){const fe=this._addNewAdapter(new H(this._documents,this._commands.converter,te,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Q),ie,H.supportsResolving(te),`${x.identifier.value}(${ie.join("")})`),this._createDisposable(fe)}$provideCompletionItems(x,Q,te,ie,fe){return this._withAdapter(x,H,Ee=>Ee.provideCompletionItems(v.URI.revive(Q),te,ie,fe),void 0)}$resolveCompletionItem(x,Q,te){return this._withAdapter(x,H,ie=>ie.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(x,Q){this._withAdapter(x,H,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(x,Q,te){const ie=this._addNewAdapter(new M(this._documents,te),x);return this._proxy.$registerInlineCompletionsSupport(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideInlineCompletions(x,Q,te,ie,fe){return this._withAdapter(x,M,Ee=>Ee.provideInlineCompletions(v.URI.revive(Q),te,ie,fe),void 0)}registerSignatureHelpProvider(x,Q,te,ie){const fe=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,Ee=this._addNewAdapter(new B(this._documents,te),x);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(Q),fe),this._createDisposable(Ee)}$provideSignatureHelp(x,Q,te,ie,fe){return this._withAdapter(x,B,Ee=>Ee.provideSignatureHelp(v.URI.revive(Q),te,ie,fe),void 0)}$releaseSignatureHelp(x,Q){this._withAdapter(x,B,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(x,Q,te){const ie=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new G(this._documents,te),x);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(Q),ie);let Ee=this._createDisposable(fe);if(ie!==void 0){const le=te.onDidChangeInlayHints(_e=>this._proxy.$emitInlayHintsEvent(ie));Ee=T.Disposable.from(Ee,le)}return Ee}$provideInlayHints(x,Q,te,ie){return this._withAdapter(x,G,fe=>fe.provideInlayHints(v.URI.revive(Q),te,ie),void 0)}registerDocumentLinkProvider(x,Q,te){const ie=this._addNewAdapter(new q(this._documents,te),x);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks(x,Q,te){return this._withAdapter(x,q,ie=>ie.provideLinks(v.URI.revive(Q),te),void 0)}$resolveDocumentLink(x,Q,te){return this._withAdapter(x,q,ie=>ie.resolveLink(Q,te),void 0)}$releaseDocumentLinks(x,Q){this._withAdapter(x,q,te=>te.releaseLinks(Q),void 0)}registerColorProvider(x,Q,te){const ie=this._addNewAdapter(new se(this._documents,te),x);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideDocumentColors(x,Q,te){return this._withAdapter(x,se,ie=>ie.provideColors(v.URI.revive(Q),te),[])}$provideColorPresentations(x,Q,te,ie){return this._withAdapter(x,se,fe=>fe.provideColorPresentations(v.URI.revive(Q),te,ie),void 0)}registerFoldingRangeProvider(x,Q,te){const ie=this._nextHandle(),fe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new Me(new ve(this._documents,te),x)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(Q),fe);let Ee=this._createDisposable(ie);if(fe!==void 0){const le=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=T.Disposable.from(Ee,le)}return Ee}$provideFoldingRanges(x,Q,te,ie){return this._withAdapter(x,ve,fe=>fe.provideFoldingRanges(v.URI.revive(Q),te,ie),void 0)}registerSelectionRangeProvider(x,Q,te){const ie=this._addNewAdapter(new Le(this._documents,te,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$provideSelectionRanges(x,Q,te,ie){return this._withAdapter(x,Le,fe=>fe.provideSelectionRanges(v.URI.revive(Q),te,ie),[])}registerCallHierarchyProvider(x,Q,te){const ie=this._addNewAdapter(new xe(this._documents,te),x);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(Q)),this._createDisposable(ie)}$prepareCallHierarchy(x,Q,te,ie){return this._withAdapter(x,xe,fe=>Promise.resolve(fe.prepareSession(v.URI.revive(Q),te,ie)),void 0)}$provideCallHierarchyIncomingCalls(x,Q,te,ie){return this._withAdapter(x,xe,fe=>fe.provideCallsTo(Q,te,ie),void 0)}$provideCallHierarchyOutgoingCalls(x,Q,te,ie){return this._withAdapter(x,xe,fe=>fe.provideCallsFrom(Q,te,ie),void 0)}$releaseCallHierarchy(x,Q){this._withAdapter(x,xe,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,y.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Q,te){let{wordPattern:ie}=te;if(ie&&(0,y.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(Q,ie):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const fe=this._nextHandle(),Ee={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?ze._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?ze._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?ze._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Q,Ee),this._createDisposable(fe)}$setWordDefinitions(x){for(const Q of x)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(be[199],we([0,1,5,9,7]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(S,y){this._proxy=S.getProxy(v.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(S,y){await this._proxy.$changeLanguage(S,y);const k=this._documents.getDocumentData(S);if(!k)throw new Error(`document '${S.toString}' NOT found`);return k.document}async tokenAtPosition(S,y){var k;const n=S.version,P=R.Position.from(y),d=await this._proxy.$tokensAtPosition(S.uri,P),g={type:D.StandardTokenType.Other,range:(k=S.getWordRangeAtPosition(y))!==null&&k!==void 0?k:new D.Range(y.line,y.character,y.line,y.character)};if(!d)return g;const r={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!r.range.contains(y)||n!==S.version?g:r}}e.ExtHostLanguages=T}),define(be[200],we([0,1,5,17,32]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(S){return S&&S.title}let _=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(v.MainContext.MainThreadMessageService)}showMessage(y,k,n,P,d){const g={extension:y};let r;typeof P=="string"||T(P)?r=[P,...d]:(g.modal=P&&P.modal,g.useCustom=P&&P.useCustom,r=d),g.useCustom&&(0,D.checkProposedApiEnabled)(y);const a=[];for(let p=0;p<r.length;p++){const m=r[p];if(typeof m=="string")a.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:E,isCloseAffordance:l}=m;a.push({title:E,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,n,g,a).then(p=>{if(typeof p=="number")return r[p]})}};_=je([Ke(1,R.ILogService)],_),e.ExtHostMessageService=_}),define(be[201],we([0,1,24,3,57,55,6,22,8,10,2,68,5,9,7,50,179,98]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(f,t){const i=E._Keys.nextId();f.$registerNotebookEditorDecorationType(i,g.NotebookDecorationRenderOptions.from(t)),this.value={key:i,dispose(){f.$removeNotebookEditorDecorationType(i)}}}}e.NotebookEditorDecorationType=E,E._Keys=new T.IdGenerator("NotebookEditorDecorationType");class l{constructor(f,t,i,s,o,c){this._textDocumentsAndEditors=i,this._textDocuments=s,this.logService=o,this._extensionStoragePaths=c,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new S.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:w=>{var b;if(w&&w.$mid===12){const A=(b=w.notebookEditor)===null||b===void 0?void 0:b.notebookUri,C=w.cell.handle,u=this._documents.get(A),F=u==null?void 0:u.getCell(C);if(F)return F.apiCell}return w}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,i]of this._editors)if(i.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const i=this._documents.get(f);if(!i&&!t)throw new Error(`NO notebook document for '${f}'`);return i}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,i,s,o){if((0,y.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:i});let c;return i.onDidChangeNotebookContentOptions&&(c=i.onDidChangeNotebookContentOptions(()=>{const w=g.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(t,w)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),l._convertNotebookRegistrationData(f,o)),new r.Disposable(()=>{c==null||c.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const i=t.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:i,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,i){const s=l._notebookStatusBarItemProviderHandlePool++,o=typeof i.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,o,t);let c;return o!==void 0&&(c=i.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(o))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,o),c&&c.dispose()})}createNotebookEditorDecorationType(f){return new E(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&g.NotebookData.from(f.content)});return n.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(f),s=this._documents.get(n.URI.revive(i));return(0,k.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(f,t){var i;n.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let s;typeof t=="object"?s={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,s),c=o&&((i=this._editors.get(o))===null||i===void 0?void 0:i.apiEditor);if(c)return c;throw o?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,i,s){var o;const c=this._notebookStatusBarItemProviders.get(f),w=n.URI.revive(t),b=this._documents.get(w);if(!b||!c)return;const A=b.getCellFromIndex(i);if(!A)return;const C=await c.provideCellStatusBarItems(A.apiCell,s);if(!C)return;const u=new _.DisposableStore,F=this._statusBarCache.add([u]),O=(o=C&&C.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,u)))!==null&&o!==void 0?o:void 0;return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,i,s,o){if((0,y.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,i),this._notebookProxy.$registerNotebookSerializer(c,{id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),l._convertNotebookRegistrationData(f,o)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(f,t,i){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.deserializeNotebook(t.buffer,i);return g.NotebookData.from(o)}async $notebookToData(f,t,i){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.serializeNotebook(g.NotebookData.to(t),i);return v.VSBuffer.wrap(o)}async $openNotebook(f,t,i,s,o){const{provider:c}=this._getProviderData(f),w=await c.openNotebook(n.URI.revive(t),{backupId:i,untitledDocumentData:s==null?void 0:s.buffer},o);return{metadata:g.NotebookDocumentMetadata.from(w.metadata),cells:w.cells.map(g.NotebookCellData.from)}}async $saveNotebook(f,t,i){const s=this.getNotebookDocument(n.URI.revive(t)),{provider:o}=this._getProviderData(f);return await o.saveNotebook(s.apiNotebook,i),!0}async $saveNotebookAs(f,t,i,s){const o=this.getNotebookDocument(n.URI.revive(t)),{provider:c}=this._getProviderData(f);return await c.saveNotebookAs(n.URI.revive(i),o.apiNotebook,s),!0}async $backupNotebook(f,t,i){var s;const o=this.getNotebookDocument(n.URI.revive(t)),c=this._getProviderData(f),w=(s=this._extensionStoragePaths.workspaceValue(c.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(c.extension),b=String((0,D.hash)([o.uri.toString(),this._backupIdPool++])),A=n.URI.joinPath(w,b),C=await c.provider.backupNotebook(o.apiNotebook,{destination:A},i);return o.updateBackup(C),C.id}$acceptModelChanged(f,t,i){this.getNotebookDocument(n.URI.revive(f)).acceptModelChanged(t,i)}$acceptDirtyStateChanged(f,t){const i=this.getNotebookDocument(n.URI.revive(f));i.acceptModelChanged({rawEvents:[],versionId:i.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(n.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const i=this._editors.get(f);if(!i)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&i._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&i._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:i.apiEditor,visibleRanges:i.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:i.apiEditor,selections:i.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const i=this._editors.get(t);if(!i)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);i._acceptViewColumn(g.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const i=this.getNotebookDocument(n.URI.revive(f));i.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:i.apiNotebook})}_createExtHostEditor(f,t,i){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new m.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,i.visibleRanges.map(g.NotebookRange.to),i.selections.map(g.NotebookRange.to),typeof i.viewColumn=="number"?g.ViewColumn.to(i.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(f){var t,i,s;if(f.removedDocuments)for(const c of f.removedDocuments){const w=n.URI.revive(c),b=this._documents.get(w);b&&(b.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(A=>A.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const A of this._editors.values())A.notebookData.uri.toString()===w.toString()&&this._editors.delete(A.id)}if(f.addedDocuments){const c=[];for(const w of f.addedDocuments){const b=n.URI.revive(w.uri),A=w.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const C=this,u=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){C._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){C._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){C._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){C._onDidChangeCellExecutionState.fire(F)}},A,w.metadata?g.NotebookDocumentMetadata.to(w.metadata):new r.NotebookDocumentMetadata,b);u.acceptModelChanged({versionId:w.versionId,rawEvents:[{kind:a.NotebookCellsChangeType.Initialize,changes:[[0,0,w.cells]]}]},!1),c.push(...w.cells.map(F=>p.ExtHostCell.asModelAddData(u.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this._onDidOpenNotebookDocument.fire(u.apiNotebook)}}if(f.addedEditors)for(const c of f.addedEditors){if(this._editors.has(c.id))return;const w=n.URI.revive(c.documentUri),b=this._documents.get(w);b&&this._createExtHostEditor(b,c.id,c)}const o=[];if(f.removedEditors)for(const c of f.removedEditors){const w=this._editors.get(c);w&&(this._editors.delete(c),((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.id)===w.id&&(this._activeNotebookEditor=void 0),o.push(w))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const c=new Set;this._visibleNotebookEditors.forEach(w=>c.add(w.id));for(const w of this._editors.values()){const b=c.has(w.id);w._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=l,l._notebookStatusBarItemProviderHandlePool=0}),define(be[202],we([0,1,3,6,5,26,2,9,73,22,11,50,20,13,17]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(h,f,t,i){this._mainContext=h,this._initData=f,this._extHostNotebook=t,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=h.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(h,f,t,i,s,o){for(let I of this._kernelData.values())if(I.controller.id===f&&T.ExtensionIdentifier.equals(h.identifier,I.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const c=this._handlePool++,w=this;this._logService.trace(`NotebookController[${c}], CREATED by ${h.identifier.value}, ${f}`);const b=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let A=!1;const C=new R.DisposableStore,u=new v.Emitter,F=new v.Emitter,O={id:`${h.identifier.value}/${f}`,viewType:t,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:i||h.identifier.value,preloads:o?o.map(S.NotebookKernelPreload.from):[]};let z=s!=null?s:b,de;this._proxy.$addKernel(c,O).catch(I=>{console.log(I),A=!0});let he=0;const $=()=>{if(A)return;const I=++he;Promise.resolve().then(()=>{I===he&&this._proxy.$updateKernel(c,O)})},j=new k.ResourceMap,W={get id(){return f},get viewType(){return O.viewType},onDidChangeNotebookAssociation:u.event,get label(){return O.label},set label(I){var H;O.label=(H=I!=null?I:h.displayName)!==null&&H!==void 0?H:h.name,$()},get detail(){var I;return(I=O.detail)!==null&&I!==void 0?I:""},set detail(I){O.detail=I,$()},get description(){var I;return(I=O.description)!==null&&I!==void 0?I:""},set description(I){O.description=I,$()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(I){O.supportedLanguages=I,$()},get hasExecutionOrder(){var I;return(I=O.hasExecutionOrder)!==null&&I!==void 0?I:!1},set hasExecutionOrder(I){O.hasExecutionOrder=I,$()},get preloads(){return O.preloads?O.preloads.map(S.NotebookKernelPreload.to):[]},get executeHandler(){return z},set executeHandler(I){z=I!=null?I:b},get interruptHandler(){return de},set interruptHandler(I){de=I,O.supportsInterrupt=Boolean(I),$()},createNotebookCellExecutionTask(I){if(A)throw new Error("notebook controller is DISPOSED");if(!j.has(I.notebook.uri))throw w._logService.trace(`NotebookController[${c}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${I.notebook.uri.toString()}`);return w._createNotebookCellExecution(I)},dispose:()=>{A||(this._logService.trace(`NotebookController[${c}], DISPOSED`),A=!0,this._kernelData.delete(c),C.dispose(),u.dispose(),F.dispose(),this._proxy.$removeKernel(c))},onDidReceiveMessage:F.event,postMessage(I,H){return w._proxy.$postMessage(c,H&&w._extHostNotebook.getIdByEditor(H),I)},asWebviewUri(I){return(0,y.asWebviewUri)(I,w._initData.remote)},updateNotebookAffinity(I,H){w._proxy.$updateNotebookPriority(c,I.uri,H)}};return this._kernelData.set(c,{extensionId:h.identifier,controller:W,onDidReceiveMessage:F,onDidChangeSelection:u,associatedNotebooks:j}),W}$acceptNotebookAssociation(h,f,t){const i=this._kernelData.get(h);if(i){const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(f));t?i.associatedNotebooks.set(s.uri,!0):i.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,s.uri.toString(),t),i.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(h,f,t){const i=this._kernelData.get(h);if(!i)return;const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(f)),o=[];for(let c of t){const w=s.getCell(c);w&&o.push(w.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,s.uri.toString(),o.length),await i.controller.executeHandler.call(i.controller,o,s.apiNotebook,i.controller)}catch(c){this._logService.error(`NotebookController[${h}] execute cells FAILED`,c),console.error(c)}}async $cancelCells(h,f,t){var i;const s=this._kernelData.get(h);if(!s)return;const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(f));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,o.apiNotebook);for(let c of t){const w=o.getCell(c);w&&((i=this._activeExecutions.get(w.uri))===null||i===void 0||i.cancel())}}$acceptKernelMessageFromRenderer(h,f,t){const i=this._kernelData.get(h);if(!i)return;const s=this._extHostNotebook.getEditorById(f);if(!s)throw new Error(`send message for UNKNOWN editor: ${f}`);i.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}_createNotebookCellExecution(h){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const i=new m(t.notebook,t,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,i);const s=i.onDidChangeState(()=>{i.state===p.Resolved&&(i.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return i.asApiObject()}};a=je([Ke(3,r.ILogService)],a),e.ExtHostNotebookKernels=a;var p;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(p||(p={}));class m extends R.Disposable{constructor(h,f,t){super();this._document=h,this._cell=f,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new E(10,i=>this.applyEdits(i)),this._executionOrder=f.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(h){await this._collector.addItem(h)}async applyEdits(h){return this._proxy.$applyEdits(this._document.uri,h,!1)}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(h){const f={editType:9,handle:this._cell.handle,internalMetadata:h};this.applyEdits([f])}cellIndexToHandle(h){if(typeof h!="number")return this._cell.handle;const f=this._document.getCellFromIndex(h);if(!f)throw new Error("INVALID cell index");return f.handle}asApiObject(){const h=this;return Object.freeze({get document(){return h._document.apiNotebook},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(f){h._executionOrder=f,h.mixinMetadata({executionOrder:f})},start(f){var t;if(h._state===p.Resolved||h._state===p.Started)throw new Error("Cannot call start again");h._state=p.Started,h._onDidChangeState.fire(),h.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(t=f==null?void 0:f.startTime)!==null&&t!==void 0?t:null})},end(f){var t,i;if(h._state===p.Resolved)throw new Error("Cannot call resolve twice");h._state=p.Resolved,h._onDidChangeState.fire(),h.mixinMetadata({runState:null,lastRunSuccess:(t=f==null?void 0:f.success)!==null&&t!==void 0?t:null,runEndTime:(i=f==null?void 0:f.endTime)!==null&&i!==void 0?i:null})},clearOutput(f){return h.verifyStateForOutput(),this.replaceOutput([],f)},async appendOutput(f,t){h.verifyStateForOutput();const i=h.cellIndexToHandle(t);return f=(0,g.asArray)(f),h.applyEditSoon({editType:2,handle:i,append:!0,outputs:f.map(S.NotebookCellOutput.from)})},async replaceOutput(f,t){h.verifyStateForOutput();const i=h.cellIndexToHandle(t);return f=(0,g.asArray)(f),h.applyEditSoon({editType:2,handle:i,outputs:f.map(S.NotebookCellOutput.from)})},async appendOutputItems(f,t){return h.verifyStateForOutput(),f=(0,g.asArray)(f),h.applyEditSoon({editType:7,append:!0,items:f.map(S.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(f,t){return h.verifyStateForOutput(),f=(0,g.asArray)(f),h.applyEditSoon({editType:7,items:f.map(S.NotebookCellOutputItem.from),outputId:t})},token:h._tokenSource.token})}}class E{constructor(h,f){this.delay=h,this.callback=f,this.batch=[]}addItem(h){return this.batch.push(h),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const f=this.batch;return this.batch=[],this.callback(f)})),this.waitPromise}}}),define(be[203],we([0,1,3,5,98]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,k){var n;const P=this._extHostNotebook.getEditorById(S);!P||(n=this._rendererMessageEmitters.get(y))===null||n===void 0||n.fire({editor:P.apiEditor,message:k})}createRendererMessaging(S){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(S).event(...k),postMessage:(k,n)=>{const P=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,S,n)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new v.Emitter({onLastListenerRemove:()=>{y==null||y.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=T}),define(be[102],we([0,1,5,3,6,24,4,15]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends D.Disposable{constructor(r,a,p,m){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,a,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class k extends y{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends y{constructor(r,a,p){super(r,!0,a,p)}append(r){throw new Error("Not supported")}}class P{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(p=>p.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new n(r,a,this._proxy)}};d=je([Ke(0,S.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(be[204],we([0,1,11,20,3,6,5,2,7,12,13,47]),function(J,e,v,R,D,T,_,S,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(g,r,a){const p=g.getProxy(_.MainContext.MainThreadQuickOpen);class m{constructor(o,c){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=c}showQuickPick(o,c,w,b=R.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(o),C=++this._instances,u=p.$show(C,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},b),F={},O=u.then(()=>F);return Promise.race([O,A]).then(z=>{if(z!==F)return A.then(de=>{const he=[];for(let $=0;$<de.length;$++){const j=de[$];let W,I,H,M,B;typeof j=="string"?W=j:(W=j.label,I=j.description,H=j.detail,M=j.picked,B=j.alwaysShow),he.push({label:W,description:I,handle:$,detail:H,picked:M,alwaysShow:B})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{w.onDidSelectItem(de[$])}),p.$setItems(C,he),u.then($=>{if(typeof $=="number")return de[$];if(Array.isArray($))return $.map(j=>de[j])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return p.$setError(C,z),Promise.reject(z)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,c=R.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,p.$input(o,typeof this._validateInput=="function",c).then(void 0,w=>{if(!(0,k.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(o){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,c=R.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!w)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(A=>A.uri.toString()===w.uri.toString())}createQuickPick(o,c){const w=new t(o,c,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(o){const c=new i(o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(o,c){const w=this._sessions.get(o);w&&w._fireDidChangeValue(c)}$onDidAccept(o){const c=this._sessions.get(o);c&&c._fireDidAccept()}$onDidChangeActive(o,c){const w=this._sessions.get(o);w instanceof t&&w._fireDidChangeActive(c)}$onDidChangeSelection(o,c){const w=this._sessions.get(o);w instanceof t&&w._fireDidChangeSelection(c)}$onDidTriggerButton(o,c){const w=this._sessions.get(o);w&&w._fireDidTriggerButton(c)}$onDidHide(o){const c=this._sessions.get(o);c&&c._fireDidHide()}}class E{constructor(o,c){this._extensionId=o,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((c,w)=>{const b=c===y.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(b,c)}),this.update({buttons:o.map((c,w)=>({iconPath:l(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const c=this._handlesToButtons.get(o);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(o){if(!this._disposed){for(const c of Object.keys(o)){const w=o[c];this._pendingUpdate[c]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function l(s){if(s instanceof y.ThemeIcon)return{id:s.id};const o=f(s),c=h(s);return{dark:typeof o=="string"?S.URI.file(o):o,light:typeof c=="string"?S.URI.file(c):c}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends E{constructor(o,c,w){super(o,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((c,w)=>{this._handlesToItems.set(w,c),this._itemsToHandles.set(c,w)}),this.update({items:o.map((c,w)=>({label:c.label,description:c.description,handle:w,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(o){const c=(0,n.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(o){const c=(0,n.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class i extends E{constructor(o,c){super(o,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?P.default.Error:P.default.Ignore})}}return new m(r,a)}e.createExtHostQuickOpen=d}),define(be[205],we([0,1,2,3,53,6,11,5,13,114,17,26,32]),function(J,e,v,R,D,T,_,S,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(o){if(o)return typeof o.iconPath=="string"?v.URI.file(o.iconPath):o.iconPath}function r(o,c){if(!o.iconPath&&!c.iconPath)return 0;if(o.iconPath){if(!c.iconPath)return 1}else return-1;const w=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,b=typeof c.iconPath=="string"?c.iconPath:c.iconPath.fsPath;return(0,k.comparePaths)(w,b)}function a(o,c){let w=0;if(o.strikeThrough!==c.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==c.faded)return o.faded?1:-1;if(o.tooltip!==c.tooltip)return(o.tooltip||"").localeCompare(c.tooltip||"");if(w=r(o,c),w!==0)return w;if(o.light&&c.light)w=r(o.light,c.light);else{if(o.light)return 1;if(c.light)return-1}if(w!==0)return w;if(o.dark&&c.dark)w=r(o.dark,c.dark);else{if(o.dark)return 1;if(c.dark)return-1}return w}function p(o,c){if(o.command!==c.command)return o.command<c.command?-1:1;if(o.title!==c.title)return o.title<c.title?-1:1;if(o.tooltip!==c.tooltip){if(o.tooltip!==void 0&&c.tooltip!==void 0)return o.tooltip<c.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(o.arguments===c.arguments)return 0;if(o.arguments)if(c.arguments){if(o.arguments.length!==c.arguments.length)return o.arguments.length-c.arguments.length}else return 1;else return-1;for(let w=0;w<o.arguments.length;w++){const b=o.arguments[w],A=c.arguments[w];if(b!==A)return b<A?-1:1}return 0}function m(o,c){let w=(0,k.comparePaths)(o.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(w!==0)return w;if(o.command&&c.command)w=p(o.command,c.command);else{if(o.command)return 1;if(c.command)return-1}if(w!==0)return w;if(o.decorations&&c.decorations)w=a(o.decorations,c.decorations);else{if(o.decorations)return 1;if(c.decorations)return-1}return w}function E(o,c){for(let w=0;w<o.length;w++)if(o[w]!==c[w])return!1;return!0}function l(o,c){return o.command===c.command&&o.title===c.title&&o.tooltip===c.tooltip&&(o.arguments&&c.arguments?E(o.arguments,c.arguments):o.arguments===c.arguments)}function h(o,c){return(0,y.equals)(o,c,l)}class f{constructor(c,w,b){this._extension=c,this._proxy=w,this._sourceControlHandle=b,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,d.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,w){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,w)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=f;class t{constructor(c,w,b,A,C){this._proxy=c,this._commands=w,this._sourceControlHandle=b,this._id=A,this._label=C,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,w){const b=this._resourceStatesCommandsMap.get(c);return b?(0,_.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var c;const w=[...this._resourceStates].sort(m),A=(0,y.sortedDiff)(this._resourceSnapshot,w,m).map(F=>{const O=F.toInsert.map(z=>{const de=this._resourceHandlePool++;this._resourceStatesMap.set(de,z);const he=z.resourceUri,$=g(z.decorations),j=z.decorations&&g(z.decorations.light)||$,W=z.decorations&&g(z.decorations.dark)||$,I=[];let H;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ve=new T.DisposableStore;H=this._commands.converter.toInternal(z.command,ve),this._resourceStatesDisposablesMap.set(de,ve)}else this._resourceStatesCommandsMap.set(de,z.command);j&&I.push(j),W&&W.toString()!==(j==null?void 0:j.toString())&&I.push(W);const M=z.decorations&&z.decorations.tooltip||"",B=z.decorations&&!!z.decorations.strikeThrough,G=z.decorations&&!!z.decorations.faded,q=z.contextValue||"";return{rawResource:[de,he,I,M,B,G,q,H],handle:de}});return{start:F.start,deleteCount:F.deleteCount,toInsert:O}}),C=A.map(({start:F,deleteCount:O,toInsert:z})=>[F,O,z.map(de=>de.rawResource)]),u=A.reverse();for(const{start:F,deleteCount:O,toInsert:z}of u){const de=z.map($=>$.handle),he=this._handlesSnapshot.splice(F,O,...de);for(const $ of he)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),(c=this._resourceStatesDisposablesMap.get($))===null||c===void 0||c.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=w,C}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(c,w,b,A,C,u){this._proxy=w,this._commands=b,this._id=A,this._label=C,this._rootUri=u,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,C,u)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=c;const w=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&h(this._statusBarCommands,c))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=c;const w=(c||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(c,w){const b=new t(this._proxy,this._commands,this.handle,c,w),A=R.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,A),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const c=[],w=[];for(const[b,A]of this.createdResourceGroups){A.dispose();const C=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});R.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),C.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),c.push([b.handle,b.id,b.label,b.features]);const u=b._takeResourceStateSnapshot();u.length>0&&w.push([b.handle,u]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,c,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(w=>{const b=w._takeResourceStateSnapshot();b.length!==0&&c.push([w.handle,b])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,D.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Mn{constructor(c,w,b){this._commands=w,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=c.getProxy(S.MainContext.MainThreadSCM),this._telemetry=c.getProxy(S.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const C=this._sourceControls.get(A.sourceControlHandle);if(!C)return A;const u=C.getResourceGroup(A.groupHandle);return u?u.getResourceState(A.handle):A}else if(A&&A.$mid===4){const C=this._sourceControls.get(A.sourceControlHandle);return C?C.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const C=this._sourceControls.get(A.handle);return C||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,w,b,A){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,w,b,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const C=Mn._handlePool++,u=new i(c,this._proxy,this._commands,w,b,A);this._sourceControls.set(C,u);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier))||[];return F.push(u),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(c.identifier),F),u}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const w=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier)),b=w&&w[w.length-1];return b&&b.inputBox}$provideOriginalResource(c,w,b){const A=v.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,A.toString());const C=this._sourceControls.get(c);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>C.quickDiffProvider.provideOriginalResource(A,b)).then(u=>u||null)}$onInputBoxValueChange(c,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const b=this._sourceControls.get(c);return b&&b.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(c,w,b,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,w,b);const C=this._sourceControls.get(c);if(!C)return Promise.resolve(void 0);const u=C.getResourceGroup(w);return u?u.$executeResourceCommand(b,A):Promise.resolve(void 0)}$validateInput(c,w,b){this.logService.trace("ExtHostSCM#$validateInput",c);const A=this._sourceControls.get(c);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>A.inputBox.validateInput(w,b)).then(C=>C?Promise.resolve([C.message,C.type]):Promise.resolve(void 0))}$setSelectedSourceControl(c){var w,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&((w=this._sourceControls.get(c))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};s._handlePool=0,s=je([Ke(2,n.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[206],we([0,1,7,5,135,6]),function(J,e,v,R,D,T){"use strict";var _,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(d,g,r,a,p=v.StatusBarAlignment.Left,m){_.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,_,d,"f"),nt(this,S,g,"f"),this._entryId=y.ID_GEN++,this._extension=r,this._id=a,this._alignment=p,this._priority=m}get id(){var d;return(d=this._id)!==null&&d!==void 0?d:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!y.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Be(this,S,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Be(this,S,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let r;this._name?r=this._name:r=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,_,"f").$setEntry(this._entryId,g,r,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,a,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,_=new WeakMap,S=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const g={message:d};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const r=this._messages.indexOf(g);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(d,g){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(d,g,r,a){return new y(this._proxy,this._commands,d,g,r,a)}setStatusBarMessage(d,g){const r=this._statusMessage.setMessage(d);let a;return typeof g=="number"?a=setTimeout(()=>r.dispose(),g):typeof g!="undefined"&&g.then(()=>r.dispose(),()=>r.dispose()),new v.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=n}),define(be[78],we([0,1,5,3,4]),function(J,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(S){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,y){this._proxy.$registerExtensionStorageKeysToSync(S,y)}getValue(S,y,k){return this._proxy.$getValue(S,y).then(n=>n||k)}setValue(S,y,k){return this._proxy.$setValue(S,y,k)}$acceptValue(S,y,k){this._onDidChangeStorage.fire({shared:S,key:y,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(be[79],we([0,1,4,27,17,77,2]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let S=class{constructor(k,n,P){var d;this._logService=n,this._extHostFileSystem=P,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,P=_.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=_.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};S=je([Ke(0,R.IExtHostInitDataService),Ke(1,D.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(be[40],we([0,1,3,5,4,2,15,6,7,136,12,173,20,37,157]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class a{constructor(t,i,s,o){this._proxy=t,this._id=i,this._creationOptions=s,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const c=this;this.value={get name(){return c._name||""},get processId(){return c._pidPromise},get creationOptions(){return c._creationOptions},get exitStatus(){return c._exitStatus},sendText(w,b=!0){c._checkDisposed(),c._proxy.$sendText(c._id,w,b)},show(w){c._checkDisposed(),c._proxy.$show(c._id,w)},hide(){c._checkDisposed(),c._proxy.$hide(c._id)},dispose(){c._disposed||(c._disposed=!0,c._proxy.$dispose(c._id))},get dimensions(){if(!(c._cols===void 0||c._rows===void 0))return{columns:c._cols,rows:c._rows}}}}async create(t,i,s,o,c,w,b,A,C,u,F,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:s,env:o,icon:c,initialText:w,waitOnExit:b,strictEnv:A,hideFromUser:C,isFeatureTerminal:u,isExtensionOwnedTerminal:F,useShellEnvironment:O})}async createExtensionTerminal(t){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:t}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,E=class extends S.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const i=t?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(t){const i=t?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[]}createExtensionTerminal(t){const i=new a(this._proxy,(0,g.generateUuid)(),t,t.name),s=new p(t.pty);return i.createExtensionTerminal(t.iconPath).then(o=>{const c=this._setupExtHostProcessListeners(o,s);this._terminalProcessDisposables[o]=c}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new p(i),c=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=c}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:i})}async $acceptTerminalDimensions(t,i,s){const o=this._getTerminalById(t);o&&o.setDimensions(i,s)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,s){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,s)}async $acceptTerminalTitleChange(t,i){const s=this._getTerminalById(t);s&&(s.name=i)}async $acceptTerminalClosed(t,i){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const o=this._terminals.splice(s,1)[0];o.setExitCode(i),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,i,s,o){if(i){const b=this._getTerminalObjectIndexById(this._terminals,i);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const c={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},w=new a(this._proxy,t,c,s);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(t,i){const s=this._getTerminalById(t);s&&s._setProcessId(i)}async $startExtensionTerminal(t,i){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(c=>{const w=this.onDidOpenTerminal(async b=>{b===s.value&&(w.dispose(),c())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const s=new S.DisposableStore;s.add(i.onProcessReady(c=>this._proxy.$sendProcessReady(t,c.pid,c.cwd))),s.add(i.onProcessTitleChanged(c=>this._proxy.$sendProcessTitle(t,c))),this._bufferer.startBuffering(t,i.onProcessData),s.add(i.onProcessExit(c=>this._onProcessExit(t,c))),i.onProcessOverrideDimensions&&s.add(i.onProcessOverrideDimensions(c=>this._proxy.$sendOverrideDimensions(t,c))),this._terminalProcesses.set(t,i);const o=this._extensionTerminalAwaitingStart[t];return o&&i instanceof p&&(i.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(i)}$acceptProcessResize(t,i,s){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,s)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(t,i){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const c=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,c);const w=[],b={terminal:s.value,line:i},A=[];for(const F of this._linkProviders)A.push(new Promise(async O=>{c.token.onCancellationRequested(()=>O({provider:F,links:[]}));const z=await F.provideTerminalLinks(b,c.token)||[];c.token.isCancellationRequested||O({provider:F,links:z})}));const C=await Promise.all(A);if(c.token.isCancellationRequested)return[];const u=new Map;for(const F of C)F&&F.links.length>0&&w.push(...F.links.map(O=>{const z={id:m++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return u.set(z.id,{provider:F.provider,link:O}),z}));return this._terminalLinkCache.set(t,u),w}$activateLink(t,i){var s;const o=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(i);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const s=this._getTerminalObjectIndexById(t,i);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,i){let s=null;return t.some((o,c)=>o._id===i?(s=c,!0):!1),s}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new l,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const s=(0,P.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const s=i[0],o=new l(i[1]);this._setEnvironmentVariableCollection(s,o)})}$acceptDefaultProfile(t,i){this._defaultProfile=t,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};E=je([Ke(1,_.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class l{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const s=this.map.get(t);(!s||s.value!==i.value||s.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((s,o)=>t.call(i,o,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let h=class extends E{constructor(t){super(!1,t)}createTerminal(t,i,s){throw new n.NotSupportedError}createTerminalFromOptions(t,i){throw new n.NotSupportedError}};h=je([Ke(0,_.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h}),define(be[207],we([0,1,3,13,5,99,9,7]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(d=>d.value)}async showTextDocument(n,P,d){let g;typeof P=="number"?g={position:_.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?g={position:_.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?_.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(n.uri,g),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n){return new T.TextEditorDecorationType(this._proxy,n).value}$acceptEditorPropertiesChanged(n,P){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const g=P.selections.selections.map(_.Selection.to);d._acceptSelections(g)}if(P.visibleRanges){const g=R.coalesce(P.visibleRanges.map(_.Range.to));d._acceptVisibleRanges(g)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:_.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const g=S.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:g})}if(P.visibleRanges){const g=R.coalesce(P.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:g})}}$acceptEditorPositionData(n){for(const P in n){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const g=_.ViewColumn.to(n[P]);d.value.viewColumn!==g&&(d._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:g}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y});var Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(J);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(J,R[D])&&(v[R[D]]=J[R[D]]);return v};define(be[208],we([0,1,2,4,5,6,7]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class S{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var g,r;if(d&&d.$mid===11){const a=d.uri===void 0?void 0:v.URI.revive(d.uri);return(r=(g=this._itemsBySourceAndUriMap.get(d.source))===null||g===void 0?void 0:g.get(y(a)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(n,P,d,g,r){const a=this._providers.get(n);return a==null?void 0:a.provideTimeline(v.URI.revive(P),d,g,r)}registerTimelineProvider(n,P,d,g){const r=new T.DisposableStore,a=this.convertTimelineItem(P.id,g,r).bind(this);let p;P.onDidChange&&(p=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:n,onDidChange:void 0,async provideTimeline(E,l,h,f){var t;(f==null?void 0:f.resetCache)&&(r.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const i=await P.provideTimeline(E,l,h);if(i==null)return;const s=a(E,f);return Object.assign(Object.assign({},i),{source:P.id,items:i.items.map(s)})},dispose(){var E;for(const l of m.values())(E=l.get(P.id))===null||E===void 0||E.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(n,P,d){return(g,r)=>{let a;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(n);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(n,p));const m=y(g);a=p.get(m),a===void 0&&(a=new Map,p.set(m,a))}return p=>{var m,E;const{iconPath:l}=p,h=Kt(p,["iconPath"]),f=`${n}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;a==null||a.set(f,p);let t,i,s;return p.iconPath&&(l instanceof _.ThemeIcon?s={id:l.id}:v.URI.isUri(l)?(t=l,i=l):{light:t,dark:i}=l),Object.assign(Object.assign({},h),{id:(E=h.id)!==null&&E!==void 0?E:void 0,handle:f,source:n,command:p.command?P.toInternal(p.command,d):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,T.toDisposable)(()=>{var d;for(const g of this._itemsBySourceAndUriMap.values())(d=g.get(n.id))===null||d===void 0||d.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function y(k){return k==null?void 0:k.toString()}}),define(be[209],we([0,1,6,16,2,5]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,n,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=P.schemes.find(g=>!_.supportedSchemes.has(g));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,P.schemes,y,P.label),(0,v.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,n){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const d=D.URI.revive(k);return P.canOpenExternalUri(d,n)}async $openUri(y,k,n){const P=this._openers.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[210],we([0,1,5,2,6,12,26]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=S.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,k),(0,D.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,n){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(n))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=S,S.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[51],we([0,1,3,2,145,166,73,5]),function(J,e,v,R,D,T,_,S){"use strict";var y,k,n,P,d,g,r,a,p,m,E,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(b,A,C,u,F,O,z){y.set(this,void 0),k.set(this,void 0),n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,""),a.set(this,void 0),p.set(this,!1),m.set(this,!1),E.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new v.Emitter),this._onDidDispose=Be(this,l,"f").event,nt(this,y,b,"f"),nt(this,k,A,"f"),nt(this,a,C,"f"),nt(this,P,u,"f"),nt(this,d,F,"f"),nt(this,g,O,"f"),nt(this,E,f(O),"f"),nt(this,n,z,"f")}dispose(){nt(this,p,!0,"f"),Be(this,l,"f").fire(),Be(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return nt(this,m,!0,"f"),(0,_.asWebviewUri)(b,Be(this,P,"f").remote)}get cspSource(){return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,r,"f")}set html(b){this.assertNotDisposed(),Be(this,r,"f")!==b&&(nt(this,r,b,"f"),!Be(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(nt(this,m,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,y,"f"),b))}get options(){return this.assertNotDisposed(),Be(this,a,"f")}set options(b){this.assertNotDisposed(),Be(this,k,"f").$setOptions(Be(this,y,"f"),s(Be(this,g,"f"),Be(this,d,"f"),b)),nt(this,a,b,"f")}async postMessage(b){if(Be(this,p,"f"))return!1;const A=(0,T.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Be(this,E,"f")});return Be(this,k,"f").$postMessage(Be(this,y,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Be(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,y=new WeakMap,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,l=new WeakMap;function f(w){try{const b=(0,D.normalizeVersion)((0,D.parseVersion)(w.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(b,A,C,u,F){this.initData=A,this.workspace=C,this._logService=u,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(b,A,...C){const u=this.getWebview(b);if(u){const{message:F}=(0,T.deserializeWebviewMessage)(A,C);u._onMessageEmitter.fire(F)}}$onMissingCsp(b,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,A,C){const u=new h(b,this._webviewProxy,o(A),this.initData,this.workspace,C,this._deprecationService);return this._webviews.set(b,u),u._onDidDispose(()=>{this._webviews.delete(b)}),u}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function i(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=i;function s(w,b,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||c(w,b)}}e.serializeWebviewOptions=s;function o(w){var b;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(b=w.localResourceRoots)===null||b===void 0?void 0:b.map(A=>R.URI.from(A))}}e.reviveOptions=o;function c(w,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(A=>A.uri),w.extensionLocation]}}),define(be[211],we([0,1,20,57,6,16,25,2,9,51,68,5,7]),function(J,e,v,R,D,T,_,S,y,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const o=this.key(t,i.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const c=new g(i,s);return this._documents.set(o,c),c}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var a;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(a||(a={}));class p{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,o){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:o}),new d.Disposable(()=>this._providers.delete(i))}}class m{constructor(t,i,s,o,c){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=o,this._extHostWebviewPanels=c,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,o){const c=new D.DisposableStore;return E(s)?(c.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),i,o.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(w=>{const b=this.getCustomDocumentEntry(i,w.document.uri);if(l(w)){const A=b.addEdit(w);this._proxy.$onDidEdit(w.document.uri,i,A,w.label)}else this._proxy.$onContentChange(w.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),i,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(c,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,o,c){var w;const b=this._editorProviders.get(i);if(!b)throw new Error(`No provider found for '${i}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${i}'`);const A=S.URI.revive(t),C=await b.provider.openCustomDocument(A,{backupId:s,untitledDocumentData:o==null?void 0:o.buffer},c);let u;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(u=(w=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(i,C,u),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const o=S.URI.revive(t),{document:c}=this.getCustomDocumentEntry(i,o);this._documents.delete(i,c),c.dispose()}async $resolveWebviewEditor(t,i,s,o,c,w){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);const A=y.ViewColumn.to(c),C=this._extHostWebview.createNewWebview(i,o.webviewOptions,b.extension),u=this._extHostWebviewPanels.createNewWebviewPanel(i,s,o.title,A,o.panelOptions,C),F=S.URI.revive(t);switch(b.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,F);return b.provider.resolveCustomEditor(O,u,w)}case 0:{const O=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(O,u,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const w=S.URI.revive(i),b=this._extHostDocuments.getDocument(w);await o.provider.moveCustomTextEditor(b,c,v.CancellationToken.None)}async $undo(t,i,s,o){return this.getCustomDocumentEntry(i,t).undo(s,o)}async $redo(t,i,s,o){return this.getCustomDocumentEntry(i,t).redo(s,o)}async $revert(t,i,s){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(o.document,s),o.disposeBackup()}async $onSave(t,i,s){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(o.document,s),o.disposeBackup()}async $onSaveAs(t,i,s,o){const c=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(c.document,S.URI.revive(s),o)}async $backup(t,i,s){const o=this.getCustomDocumentEntry(i,t),w=await this.getCustomEditorProvider(i).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},s);return o.updateBackup(w),w.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,S.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function E(f){return typeof f.resolveCustomTextEditor=="function"}function l(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function h(f){const t=f.scheme===T.Schemas.file||f.scheme===T.Schemas.untitled?f.fsPath:f.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[212],we([0,1,3,6,2,37,9,51,5,7]),function(J,e,v,R,D,T,_,S,y,k){"use strict";var n,P,d,g,r,a,p,m,E,l,h,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(w,b,A,C,u,F,O){super();n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),p.set(this,void 0),m.set(this,void 0),E.set(this,!0),l.set(this,!0),h.set(this,!1),f.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,f,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,n,w,"f"),nt(this,P,b,"f"),nt(this,d,A,"f"),nt(this,r,F,"f"),nt(this,m,u,"f"),nt(this,a,C,"f"),nt(this,g,O,"f")}dispose(){Be(this,h,"f")||(nt(this,h,!0,"f"),Be(this,f,"f").fire(),Be(this,P,"f").$disposeWebview(Be(this,n,"f")),Be(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,g,"f")}get viewType(){return this.assertNotDisposed(),Be(this,d,"f")}get title(){return this.assertNotDisposed(),Be(this,a,"f")}set title(w){this.assertNotDisposed(),Be(this,a,"f")!==w&&(nt(this,a,w,"f"),Be(this,P,"f").$setTitle(Be(this,n,"f"),w))}get iconPath(){return this.assertNotDisposed(),Be(this,p,"f")}set iconPath(w){this.assertNotDisposed(),Be(this,p,"f")!==w&&(nt(this,p,w,"f"),Be(this,P,"f").$setIconPath(Be(this,n,"f"),D.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Be(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,m,"f")=="number"&&Be(this,m,"f")<0))return Be(this,m,"f")}get active(){return this.assertNotDisposed(),Be(this,l,"f")}get visible(){return this.assertNotDisposed(),Be(this,E,"f")}_updateViewState(w){Be(this,h,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(nt(this,l,w.active,"f"),nt(this,E,w.visible,"f"),nt(this,m,w.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(w,b){this.assertNotDisposed(),Be(this,P,"f").$reveal(Be(this,n,"f"),{viewColumn:w?_.ViewColumn.from(w):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Be(this,h,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,l=new WeakMap,h=new WeakMap,f=new WeakMap,t=new WeakMap;class s{constructor(w,b,A){this.webviews=b,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(w,b,A,C,u={}){const F=typeof C=="object"?C.viewColumn:C,O={viewColumn:_.ViewColumn.from(F),preserveFocus:typeof C=="object"&&!!C.preserveFocus},z=(0,S.shouldSerializeBuffersForPostMessage)(w),de=s.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(w),de,b,{title:A,panelOptions:o(u),webviewOptions:(0,S.serializeWebviewOptions)(w,this.workspace,u),serializeBuffersForPostMessage:z},O);const he=this.webviews.createNewWebview(de,u,w);return this.createNewWebviewPanel(de,b,A,F,u,he)}$onDidChangeWebviewPanelViewStates(w){const b=Object.keys(w);b.sort((A,C)=>{const u=w[A],F=w[C];return u.active?1:F.active?-1:+u.visible-+F.visible});for(const A of b){const C=this.getWebviewPanel(A);if(!C)continue;const u=w[A];C._updateViewState({active:u.active,visible:u.visible,viewColumn:_.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(w){const b=this.getWebviewPanel(w);b==null||b.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,b,A){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:A,extension:w}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(w)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(w,b,A,C){const u=this._serializers.get(b);if(!u)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:O}=u,z=this.webviews.createNewWebview(w,A.webviewOptions,O),de=this.createNewWebviewPanel(w,b,A.title,C,A.panelOptions,z);await F.deserializeWebviewPanel(de,A.state)}createNewWebviewPanel(w,b,A,C,u,F){const O=new i(w,this._proxy,b,A,C,u,F);return this._webviewPanels.set(w,O),O}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=s;function o(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[213],we([0,1,3,6,51,5,7]),function(J,e,v,R,D,T,_){"use strict";var S,y,k,n,P,d,g,r,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends R.Disposable{constructor(h,f,t,i,s,o){super();S.set(this,void 0),y.set(this,void 0),k.set(this,void 0),n.set(this,void 0),P.set(this,!1),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Be(this,a,"f").event,p.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,p,"f").event,nt(this,k,t,"f"),nt(this,g,i,"f"),nt(this,S,h,"f"),nt(this,y,f,"f"),nt(this,n,s,"f"),nt(this,d,o,"f")}dispose(){Be(this,P,"f")||(nt(this,P,!0,"f"),Be(this,p,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(h){this.assertNotDisposed(),Be(this,g,"f")!==h&&(nt(this,g,h,"f"),Be(this,y,"f").$setWebviewViewTitle(Be(this,S,"f"),h))}get description(){return this.assertNotDisposed(),Be(this,r,"f")}set description(h){this.assertNotDisposed(),Be(this,r,"f")!==h&&(nt(this,r,h,"f"),Be(this,y,"f").$setWebviewViewDescription(Be(this,S,"f"),h))}get visible(){return Be(this,d,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,k,"f")}_setVisible(h){h===Be(this,d,"f")||Be(this,P,"f")||(nt(this,d,h,"f"),Be(this,a,"f").fire())}show(h){this.assertNotDisposed(),Be(this,y,"f").$show(Be(this,S,"f"),!!h)}assertNotDisposed(){if(Be(this,P,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap;class E{constructor(h,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,f,t,i){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(h),f,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new _.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(h,f,t,i,s){const o=this._viewProviders.get(f);if(!o)throw new Error(`No view provider found for '${f}'`);const{provider:c,extension:w}=o,b=this._extHostWebview.createNewWebview(h,{},w),A=new m(h,this._proxy,f,t,b,!0);this._webviewViews.set(h,A),await c.resolveWebviewView(A,{state:i},s)}async $onDidChangeWebviewViewVisibility(h,f){this.getWebviewView(h)._setVisible(f)}async $disposeWebviewView(h){const f=this.getWebviewView(h);this._webviewViews.delete(h),f.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const f=this._webviewViews.get(h);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=E}),define(be[103],we([0,1,3,5,2,16,8,4,15]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class On{constructor(P){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let g;if(typeof P=="string"){g=P;try{P=D.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,_.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,g,d)}async asExternalUri(P,d){if((0,_.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(P,d);return D.URI.from(g)}};k.InitialState={focused:!0},k=je([Ke(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(be[214],we([0,1,17,5,27,15]),function(J,e,v,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends v.AbstractLogger{constructor(y,k){super();this._proxy=y.getProxy(R.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...k){this.getLevel()<=v.LogLevel.Trace&&this._proxy.$log(this._logFile,v.LogLevel.Trace,Array.from(arguments))}debug(y,...k){this.getLevel()<=v.LogLevel.Debug&&this._proxy.$log(this._logFile,v.LogLevel.Debug,Array.from(arguments))}info(y,...k){this.getLevel()<=v.LogLevel.Info&&this._proxy.$log(this._logFile,v.LogLevel.Info,Array.from(arguments))}warn(y,...k){this.getLevel()<=v.LogLevel.Warning&&this._proxy.$log(this._logFile,v.LogLevel.Warning,Array.from(arguments))}error(y,...k){this.getLevel()<=v.LogLevel.Error&&this._proxy.$log(this._logFile,v.LogLevel.Error,Array.from(arguments))}critical(y,...k){this.getLevel()<=v.LogLevel.Critical&&this._proxy.$log(this._logFile,v.LogLevel.Critical,Array.from(arguments))}flush(){}};_=je([Ke(0,T.IExtHostRpcService),Ke(1,D.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(be[215],we([0,1,11,20,12,3,6,115,186,100,24]),function(J,e,v,R,D,T,_,S,y,k,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(o,c){try{return JSON.stringify(o,c)}catch(w){return"null"}}function g(o,c){return JSON.stringify(o,c)}function r(o){return o?(c,w)=>w&&w.$mid===1?o.transformOutgoing(w):w:null}var a;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},E=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class h extends _.Disposable{constructor(c,w=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=w,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,C=k.ProxyIdentifier.count;A<C;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,S.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:w,sid:b}=c;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,b)),this._proxies[w]}_createProxy(c,w){let b={get:(A,C)=>(typeof C=="string"&&!A[C]&&C.charCodeAt(0)===36&&(A[C]=(...u)=>this._remoteCall(c,C,u)),C===l?w:A[C])};return new Proxy(Object.create(null),b)}set(c,w){return this._locals[c.nid]=w,w}assertRegistered(c){for(let w=0,b=c.length;w<b;w++){const A=c[w];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const w=c.byteLength,b=f.read(c,0),A=b.readUInt8(),C=b.readUInt32();switch(A){case 1:case 2:{let{rpcId:u,method:F,args:O}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(O=(0,S.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(w,C,u,F,O,A===2);break}case 3:case 4:{let{rpcId:u,method:F,args:O}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(O=(0,S.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(w,C,u,F,O,A===4);break}case 5:{this._logger&&this._logger.logIncoming(w,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(w,C);break}case 7:{this._receiveReply(w,C,void 0);break}case 9:{let u=t.deserializeReplyOKJSON(b);this._uriTransformer&&(u=(0,S.transformIncomingURIs)(u,this._uriTransformer)),this._receiveReply(w,C,u);break}case 8:{let u=t.deserializeReplyOKVSBuffer(b);this._receiveReply(w,C,u);break}case 10:{let u=t.deserializeReplyErrError(b);this._uriTransformer&&(u=(0,S.transformIncomingURIs)(u,this._uriTransformer)),this._receiveReplyErr(w,C,u);break}case 11:{this._receiveReplyErr(w,C,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,w,b,A,C,u){this._logger&&this._logger.logIncoming(c,w,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${A}(`,C);const F=String(w);let O,z;if(u){const he=new R.CancellationTokenSource;C.push(he.token),O=this._invokeHandler(b,A,C),z=()=>he.cancel()}else O=this._invokeHandler(b,A,C),z=m;this._cancelInvokedHandlers[F]=z;const de=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(de.byteLength,w,1,"ack"),this._protocol.send(de),O.then(he=>{delete this._cancelInvokedHandlers[F];const $=t.serializeReplyOK(w,he,this._uriReplacer);this._logger&&this._logger.logOutgoing($.byteLength,w,1,"reply:",he),this._protocol.send($)},he=>{delete this._cancelInvokedHandlers[F];const $=t.serializeReplyErr(w,he);this._logger&&this._logger.logOutgoing($.byteLength,w,1,"replyErr:",he),this._protocol.send($)})}_receiveCancel(c,w){this._logger&&this._logger.logIncoming(c,w,1,"receiveCancel");const b=String(w);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(c,w,b){this._logger&&this._logger.logIncoming(c,w,0,"receiveReply:",b);const A=String(w);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],C.resolveOk(b)}_receiveReplyErr(c,w,b){this._logger&&this._logger.logIncoming(c,w,0,"receiveReplyErr:",b);const A=String(w);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let u;b&&(b.$isError?(u=new Error,u.name=b.name,u.message=b.message,u.stack=b.stack):u=b),C.resolveErr(u)}_invokeHandler(c,w,b){try{return Promise.resolve(this._doInvokeHandler(c,w,b))}catch(A){return Promise.reject(A)}}_doInvokeHandler(c,w,b){const A=this._locals[c];if(!A)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(c));let C=A[w];if(typeof C!="function")throw new Error("Unknown method "+w+" on actor "+(0,k.getStringIdentifierForProxy)(c));return C.apply(A,b)}_remoteCall(c,w,b){if(this._isDisposed)return Promise.reject(D.canceled());let A=null;if(b.length>0&&R.CancellationToken.isCancellationToken(b[b.length-1])&&(A=b.pop()),A&&A.isCancellationRequested)return Promise.reject(D.canceled());const C=t.serializeRequestArguments(b,this._uriReplacer),u=++this._lastMessageId,F=String(u),O=new y.LazyPromise;A&&A.onCancellationRequested(()=>{const de=t.serializeCancel(u);this._logger&&this._logger.logOutgoing(de.byteLength,u,0,"cancel"),this._protocol.send(t.serializeCancel(u))}),this._pendingRPCReplies[F]=O,this._onWillSendRequest(u);const z=t.serializeRequest(u,c,w,C,!!A);return this._logger&&this._logger.logOutgoing(z.byteLength,u,0,`request: ${(0,k.getStringIdentifierForProxy)(c)}.${w}(`,b),this._protocol.send(z),O}}e.RPCProtocol=h,P=E,h.UNRESPONSIVE_TIME=3*1e3;class f{constructor(c,w){this._buff=c,this._offset=w}static alloc(c,w,b){let A=new f(n.VSBuffer.alloc(b+1+4),0);return A.writeUInt8(c),A.writeUInt32(w),A}static read(c,w){return new f(c,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,b}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,b}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,w}static sizeMixedArray(c,w){let b=0;b+=1;for(let A=0,C=c.length;A<C;A++){const u=c[A],F=w[A];switch(b+=1,F){case 1:b+=this.sizeLongString(u);break;case 2:b+=this.sizeVSBuffer(u);break;case 3:break}}return b}writeMixedArray(c,w){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let b=0,A=c.length;b<A;b++){const C=c[b];switch(w[b]){case 1:this.writeUInt8(1),this.writeLongString(C);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(c);for(let b=0;b<c;b++)switch(this.readUInt8()){case 1:w[b]=this.readLongString();break;case 2:w[b]=this.readVSBuffer();break;case 3:w[b]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(c){for(let w=0,b=c.length;w<b;w++)if(c[w]instanceof n.VSBuffer||typeof c[w]=="undefined")return!0;return!1}static serializeRequestArguments(c,w){if(this._arrayContainsBufferOrUndefined(c)){let b=[],A=[];for(let C=0,u=c.length;C<u;C++){const F=c[C];F instanceof n.VSBuffer?(b[C]=F,A[C]=2):typeof F=="undefined"?(b[C]=n.VSBuffer.alloc(0),A[C]=3):(b[C]=n.VSBuffer.fromString(g(F,w)),A[C]=1)}return{type:"mixed",args:b,argsType:A}}return{type:"simple",args:g(c,w)}}static serializeRequest(c,w,b,A,C){return A.type==="mixed"?this._requestMixedArgs(c,w,b,A.args,A.argsType,C):this._requestJSONArgs(c,w,b,A.args,C)}static _requestJSONArgs(c,w,b,A,C){const u=n.VSBuffer.fromString(b),F=n.VSBuffer.fromString(A);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(u),O+=f.sizeLongString(F);let z=f.alloc(C?2:1,c,O);return z.writeUInt8(w),z.writeShortString(u),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(c){const w=c.readUInt8(),b=c.readShortString(),A=c.readLongString();return{rpcId:w,method:b,args:JSON.parse(A)}}static _requestMixedArgs(c,w,b,A,C,u){const F=n.VSBuffer.fromString(b);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(F),O+=f.sizeMixedArray(A,C);let z=f.alloc(u?4:3,c,O);return z.writeUInt8(w),z.writeShortString(F),z.writeMixedArray(A,C),z.buffer}static deserializeRequestMixedArgs(c){const w=c.readUInt8(),b=c.readShortString(),A=c.readMixedArray(),C=new Array(A.length);for(let u=0,F=A.length;u<F;u++){const O=A[u];typeof O=="string"?C[u]=JSON.parse(O):C[u]=O}return{rpcId:w,method:b,args:C}}static serializeAcknowledged(c){return f.alloc(5,c,0).buffer}static serializeCancel(c){return f.alloc(6,c,0).buffer}static serializeReplyOK(c,w,b){return typeof w=="undefined"?this._serializeReplyOKEmpty(c):w instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,w):this._serializeReplyOKJSON(c,d(w,b))}static _serializeReplyOKEmpty(c){return f.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,w){let b=0;b+=f.sizeVSBuffer(w);let A=f.alloc(8,c,b);return A.writeVSBuffer(w),A.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,w){const b=n.VSBuffer.fromString(w);let A=0;A+=f.sizeLongString(b);let C=f.alloc(9,c,A);return C.writeLongString(b),C.buffer}static deserializeReplyOKJSON(c){const w=c.readLongString();return JSON.parse(w)}static serializeReplyErr(c,w){return w?this._serializeReplyErrEror(c,w):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,w){const b=n.VSBuffer.fromString(d(D.transformErrorForSerialization(w),null));let A=0;A+=f.sizeLongString(b);let C=f.alloc(10,c,A);return C.writeLongString(b),C.buffer}static deserializeReplyErrError(c){const w=c.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(c){return f.alloc(11,c,0).buffer}}var i;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(s||(s={}))}),define(be[216],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const v=function(T){const _=S=>{self.removeEventListener("message",_);const y=S.data;Object.defineProperties(self,{postMessage:{value(k,n){y.postMessage(k,n)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",_)}.toString();class R extends EventTarget{constructor(T,_,S){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${v})('${_}'))`,k=new Blob([y],{type:"application/javascript"}),n=URL.createObjectURL(k),P=new MessageChannel,d=n,g={type:"_newWorker",id:d,port:P.port2,url:n,options:S};T(g,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(n),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),P.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),P.port1.start()}}e.NestedWorker=R}),define(be[217],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(be[218],we([0,1,16,14,21,2,4,217]),function(J,e,v,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let y=class{constructor(n,P){this.localUserHome=n,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||D.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||n})()}async userHome(n){return(n==null?void 0:n.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?R.win32:R.posix)}async fileURI(n){let P="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const g=n.indexOf("/",2);g===-1?(P=n.substring(2),n="/"):(P=n.substring(2,g),n=n.substring(g)||"/")}return T.URI.from({scheme:v.Schemas.file,authority:P,path:n,query:"",fragment:""})}};y=je([Ke(1,S.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[104],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(_,S){this.line=_,this.character=S}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,S){return new v(0,0)}with(_){return new v(0,0)}}e.Position=v;class R{constructor(_,S,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(_,S),this.end=new v(y,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new R(0,0,0,0)}with(_){return new R(0,0,0,0)}}e.Range=R;var D;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],we([0,1,13,28,23,36,8,4,14,12,104]),function(J,e,v,R,D,T,_,S,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",g=(P.length+d.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var r;(function(I){I[I.file=0]="file",I[I.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(I){I[I.File=1]="File",I[I.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function p(I){return!!I.preview}e.resultIsMatch=p;function m(I){return!!I.resource}e.isFileMatch=m;function E(I){return!!I.message}e.isProgressMessage=E;var l;(function(I){I[I.Normal=0]="Normal",I[I.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=h;class f{constructor(H,M,B){this.ranges=M;const G=Array.isArray(M)?M:[M];if(B&&B.matchLines===1&&t(G)){H=(0,_.getNLines)(H,B.matchLines);let q="",se=0,ve=0;const Le=Math.floor(B.charsPerLine/5),xe=[];for(const Me of G){const ze=Math.max(Me.startColumn-Le,0),Ve=Me.startColumn+B.charsPerLine;if(ze>ve+Le+g){const x=P+(ze-ve)+d;q+=x+H.slice(ze,Ve),se+=ze-(ve+x.length)}else q+=H.slice(ve,Ve);xe.push(new s(0,Me.startColumn-se,Me.endColumn-se)),ve=Ve}this.preview={text:q,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const q=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:H,matches:(0,v.mapArrayOrNot)(M,se=>new i(se.startLineNumber-q,se.startColumn,se.endLineNumber-q,se.endColumn))}}}}e.TextSearchMatch=f;function t(I){const H=I[0].startLineNumber;for(const M of I)if(M.startLineNumber!==H||M.endLineNumber!==H)return!1;return!0}class i{constructor(H,M,B,G){this.startLineNumber=H,this.startColumn=M,this.endLineNumber=B,this.endColumn=G}}e.SearchRange=i;class s extends i{constructor(H,M,B){super(H,M,H,B)}}e.OneLineRange=s;var o;(function(I){I.Default="default",I.FileNames="fileNames",I.Type="type",I.Modified="modified",I.CountDescending="countDescending",I.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function c(I,H=!0){const M=I&&I.files&&I.files.exclude,B=H&&I&&I.search&&I.search.exclude;if(!M&&!B)return;if(!M||!B)return M||B;let G=Object.create(null);return G=D.mixin(G,D.deepClone(M)),G=D.mixin(G,D.deepClone(B),!0),G}e.getExcludes=c;function w(I,H){return I.excludePattern&&R.match(I.excludePattern,H)?!1:I.includePattern||I.usingSearchPaths?I.includePattern&&R.match(I.includePattern,H)?!0:I.usingSearchPaths?!!I.folderQueries&&I.folderQueries.some(M=>{const B=M.folder.fsPath;if(T.isEqualOrParent(H,B)){const G=y.relative(B,H);return!M.includePattern||!!R.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var b;(function(I){I[I.unknownEncoding=1]="unknownEncoding",I[I.regexParseError=2]="regexParseError",I[I.globParseError=3]="globParseError",I[I.invalidLiteral=4]="invalidLiteral",I[I.rgProcessError=5]="rgProcessError",I[I.other=6]="other",I[I.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(H,M){super(H);this.code=M}}e.SearchError=A;function C(I){const H=I.message;if((0,k.isPromiseCanceledError)(I))return new A(H,b.canceled);try{const M=JSON.parse(H);return new A(M.message,M.code)}catch(M){return new A(H,b.other)}}e.deserializeSearchError=C;function u(I){const H={message:I.message,code:I.code};return new Error(JSON.stringify(H))}e.serializeSearchError=u;function F(I){return I.type==="error"?!0:I.type==="success"}e.isSerializedSearchComplete=F;function O(I){return I.type==="success"}e.isSerializedSearchSuccess=O;function z(I){return!!I.path}e.isSerializedFileMatch=z;function de(I,H){const M=I.searchPath?I.searchPath:I.relativePath;return(0,_.fuzzyContains)(M,H)}e.isFilePatternMatch=de;class he{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function $(I,H){const M=Object.assign(Object.assign({},I||{}),H||{});return Object.keys(M).filter(B=>{const G=M[B];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=$;class j{constructor(H,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},H.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let B=H.includePattern;M.includePattern&&(B?B=Object.assign(Object.assign({},B),M.includePattern):B=M.includePattern),B&&(this._parsedIncludeExpression=R.parse(B))}includedInQuerySync(H,M,B){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,M,B)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,M,B))}includedInQuery(H,M,B){return Promise.resolve(this._parsedExcludeExpression(H,M,B)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(H,M,B)).then(se=>!!se):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=j;function W(I){for(const H in I)if(typeof I[H]!="boolean")return!0;return!1}}),define(be[30],we([0,1,13,11,20,3,22,16,81,25,8,10,2,138,4,17,153,48,49,27,15,7,41,5]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h,f,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,O,z){return new k.ExtUri(de=>b(de,z)).isEqual(F,O)}function o(F,O,z){return s(F.uri,O.uri,z)?0:(0,n.compare)(F.uri.toString(),O.uri.toString())}function c(F,O,z){return F.index!==O.index?F.index<O.index?-1:1:s(F.uri,O.uri,z)?(0,n.compare)(F.name,O.name):(0,n.compare)(F.uri.toString(),O.uri.toString())}function w(F,O,z,de){const he=F.slice(0).sort((j,W)=>z(j,W,de)),$=O.slice(0).sort((j,W)=>z(j,W,de));return(0,v.delta)(he,$,(j,W)=>z(j,W,de))}function b(F,O){const z=O.getCapabilities(F.scheme);return!(z&&z&1024)}class A extends m.Workspace{constructor(O,z,de,he,$,j){super(O,de.map(W=>new m.WorkspaceFolder(W)),he,j);this._name=z,this._isUntitled=$,this._workspaceFolders=[],this._structure=_.TernarySearchTree.forUris(j),de.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(O,z,de,he){if(!O)return{workspace:null,added:[],removed:[]};const{id:$,name:j,folders:W,configuration:I,isUntitled:H}=O,M=[],B=z;z?W.forEach((ve,Le)=>{const xe=d.URI.revive(ve.uri),Me=A._findFolder(de||z,xe,he);Me?(Me.name=ve.name,Me.index=ve.index,M.push(Me)):M.push({uri:xe,name:ve.name,index:Le})}):M.push(...W.map(({uri:ve,name:Le,index:xe})=>({uri:d.URI.revive(ve),name:Le,index:xe}))),M.sort((ve,Le)=>ve.index<Le.index?-1:1);const G=new A($,j,M,I?d.URI.revive(I):null,!!H,ve=>b(ve,he)),{added:q,removed:se}=w(B?B.workspaceFolders:[],G.workspaceFolders,o,he);return{workspace:G,added:q,removed:se}}static _findFolder(O,z,de){for(let he=0;he<O.folders.length;he++){const $=O.workspaceFolders[he];if(s($.uri,z,de))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,z){return z&&this._structure.get(O)&&(O=(0,k.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let C=class{constructor(O,z,de,he){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=he,this._extHostFileSystemInfo=de,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(i.MainContext.MainThreadMessageService);const $=z.workspace;this._confirmedWorkspace=$?new A($.id,$.name,[],$.configuration?d.URI.revive($.configuration):null,!!$.isUntitled,j=>b(j,de)):void 0}$initializeWorkspace(O,z){this._trusted=z,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:S.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,z,de,...he){const $=[];if(Array.isArray(he)&&he.forEach(M=>{d.URI.isUri(M.uri)&&!$.some(B=>s(B.uri,M.uri,this._extHostFileSystemInfo))&&$.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[z,de].some(M=>typeof M!="number"||M<0)||de===0&&$.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+de>j.length)return!1;const W=j.slice(0);W.splice(z,de,...$.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<W.length;M++){const B=W[M];if(W.some((G,q)=>q!==M&&s(B.uri,G.uri,this._extHostFileSystemInfo)))return!1}W.forEach((M,B)=>M.index=B);const{added:I,removed:H}=w(j,W,c,this._extHostFileSystemInfo);if(I.length===0&&H.length===0)return!1;if(this._proxy){const M=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(M,z,de,$).then(void 0,B=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,g.localize)(0,null,M,B.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(O,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,z)}async getWorkspaceFolder2(O,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,z)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,z){let de,he="";if(typeof O=="string"?(de=d.URI.file(O),he=O):typeof O!="undefined"&&(de=O,he=O.fsPath),!de)return he;const $=this.getWorkspaceFolder(de,!0);if(!$)return he;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let j=(0,k.relativePath)($.uri,de);return z&&$.name&&(j=`${$.name}/${j}`),j}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:z,added:de,removed:he}=A.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:de,removed:he}))}findFiles(O,z,de,he,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${he.value}, entryPoint: findFiles`);let j;if(z===null?j=!1:z&&(typeof z=="string"?j=z:j=z.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:I}=u(O);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(W),(0,P.withUndefinedAsNull)(I),(0,P.withUndefinedAsNull)(j),(0,P.withUndefinedAsNull)(de),$).then(H=>Array.isArray(H)?H.map(M=>d.URI.revive(M)):[])}async findTextInFiles(O,z,de,he,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${he.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),W=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:I,folder:H}=u(z.include),M=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,B={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:W,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:I,excludePattern:M},G=!1;if(this._activeSearchCallbacks[j]=q=>{if(G)return;const se=d.URI.revive(q.resource);q.results.forEach(ve=>{(0,t.resultIsMatch)(ve)?de({uri:se,preview:{text:ve.preview.text,matches:(0,v.mapArrayOrNot)(ve.preview.matches,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,v.mapArrayOrNot)(ve.ranges,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):de({uri:se,text:ve.text,lineNumber:ve.lineNumber})})},$.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(O,(0,P.withUndefinedAsNull)(H),B,j,$);return delete this._activeSearchCallbacks[j],q||{}}catch(q){throw delete this._activeSearchCallbacks[j],q}}$handleTextSearchResult(O,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=je([Ke(0,h.IExtHostRpcService),Ke(1,l.IExtHostInitDataService),Ke(2,E.IExtHostFileSystemInfo),Ke(3,a.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function u(F){let O,z;return F&&(typeof F=="string"?O=F:(O=F.pattern,z=F.baseFolder||d.URI.file(F.base))),{includePattern:O,folder:z}}}),define(be[33],we([0,1,23,3,30,5,7,156,67,10,11,4,15,17,2]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(i,s){if(s){const o=s.split(".");let c=i;for(let w=0;c&&w<o.length;w++)c=c[o[w]];return c}}function p(i){return i instanceof r.URI}function m(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function E(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function l(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(p(i))return{resource:i};if(m(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(E(i))return{overrideIdentifier:i.languageId};if(l(i))return{resource:i.uri};if(i===null)return{resource:null}}let f=class{constructor(s,o,c){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,o))}};f=je([Ke(0,d.IExtHostRpcService),Ke(1,D.IExtHostWorkspace),Ke(2,g.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(s,o,c,w){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=w,this._extHostWorkspace=o,this._configuration=S.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,c))}getConfiguration(s,o,c){const w=h(o)||{},b=this._toReadonlyValue(s?a(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,w,c==null?void 0:c.identifier);function A(u){if(u==null)return null;if(typeof u=="boolean")return u?1:4;switch(u){case _.ConfigurationTarget.Global:return 1;case _.ConfigurationTarget.Workspace:return 4;case _.ConfigurationTarget.WorkspaceFolder:return 5}}const C={has(u){return typeof a(b,u)!="undefined"},get:(u,F)=>{this._validateConfigurationAccess(s?`${s}.${u}`:u,w,c==null?void 0:c.identifier);let O=a(b,u);if(typeof O=="undefined")O=F;else{let z;const de=(he,$)=>{let j;const W=()=>{z=z||(0,v.deepClone)(b),j=j||a(z,$)};return(0,k.isObject)(he)?new Proxy(he,{get:(I,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return W(),()=>j;if(z)return j=j||a(z,$),j[H];const M=I[H];return typeof H=="string"?de(M,`${$}.${H}`):M},set:(I,H,M)=>(W(),j&&(j[H]=M),!0),deleteProperty:(I,H)=>(W(),j&&delete j[H],!0),defineProperty:(I,H,M)=>(W(),j&&Object.defineProperty(j,H,M),!0)}):he};O=de(O,u)}return O},update:(u,F,O,z)=>{u=s?`${s}.${u}`:u;const de=A(O);return F!==void 0?this._proxy.$updateConfigurationOption(de,u,F,w,z):this._proxy.$removeConfigurationOption(de,u,w,z)},inspect:u=>{var F,O,z,de,he,$,j,W;u=s?`${s}.${u}`:u;const I=(0,v.deepClone)(this._configuration.inspect(u,w,this._extHostWorkspace.workspace));if(I)return{key:u,defaultValue:(F=I.default)===null||F===void 0?void 0:F.value,globalValue:(O=I.user)===null||O===void 0?void 0:O.value,workspaceValue:(z=I.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(de=I.workspaceFolder)===null||de===void 0?void 0:de.value,defaultLanguageValue:(he=I.default)===null||he===void 0?void 0:he.override,globalLanguageValue:($=I.user)===null||$===void 0?void 0:$.override,workspaceLanguageValue:(j=I.workspace)===null||j===void 0?void 0:j.override,workspaceFolderLanguageValue:(W=I.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:I.overrideIdentifiers}}};return typeof b=="object"&&(0,v.mixin)(C,b,!1),Object.freeze(C)}_toReadonlyValue(s){const o=c=>(0,k.isObject)(c)?new Proxy(c,{get:(w,b)=>o(w[b]),set:(w,b,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(w,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(w,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return o(s)}_validateConfigurationAccess(s,o,c){const w=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),b=c?`[${c.value}] `:"";if(w===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(o==null?void 0:o.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const c=new S.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,b)=>c.affectsConfiguration(w,h(b))})}_toMap(s){return s.reduce((o,c)=>(o.set(c[0],c[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[105],we([0,1,2,11,3,5,7,30,39,33,20,40,15,27,4,16,21,17,75,172,12]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(he){function $(W){if(W!=null)return W}he.from=$;function j(W){if(W!=null)return W}he.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(he){function $(W){if(W!=null)return W}he.from=$;function j(W){if(W!=null)return W}he.to=j})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(he){function $(W){if(W!=null)return W}he.from=$;function j(W){if(W!=null)return W}he.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(he){function $(I){if(I){const H=I;return H&&!!H.process}else return!1}he.is=$;function j(I){if(I==null)return;const H={process:I.process,args:I.args};return I.options&&(H.options=s.from(I.options)),H}he.from=j;function W(I){if(I!=null)return new _.ProcessExecution(I.process,I.args,I.options)}he.to=W})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(he){function $(W){if(W!=null)return W}he.from=$;function j(W){if(W!=null)return W}he.to=j})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(he){function $(I){if(I){const H=I;return H&&(!!H.commandLine||!!H.command)}else return!1}he.is=$;function j(I){if(I==null)return;const H={};return I.commandLine!==void 0?H.commandLine=I.commandLine:(H.command=I.command,H.args=I.args),I.options&&(H.options=c.from(I.options)),H}he.from=j;function W(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new _.ShellExecution(I.commandLine,I.options):new _.ShellExecution(I.command,I.args?I.args:[],I.options)}he.to=W})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(he){function $(I){if(I){let H=I;return H&&H.customExecution==="customExecution"}else return!1}he.is=$;function j(I){return{customExecution:"customExecution"}}he.from=j;function W(I,H){return H.get(I)}he.to=W})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(he){function $(j,W){let I;return j.scope!==void 0&&typeof j.scope!="number"?I=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?I=W.workspaceFile:I=l.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:I}}he.from=$})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var C;(function(he){function $(I,H){if(I==null)return[];const M=[];for(let B of I){const G=j(B,H);G&&M.push(G)}return M}he.fromMany=$;function j(I,H){if(I==null)return;let M;I.execution instanceof _.ProcessExecution?M=o.from(I.execution):I.execution instanceof _.ShellExecution?M=w.from(I.execution):I.execution&&I.execution instanceof _.CustomExecution&&(M=b.from(I.execution));const B=t.from(I.definition);let G;if(I.scope?typeof I.scope=="number"?G=I.scope:G=I.scope.uri:G=_.TaskScope.Workspace,!B||!G)return;const q=I.group?I.group.id:void 0;return{_id:I._id,definition:B,name:I.name,source:{extensionId:H.identifier.value,label:I.source,scope:G},execution:M,isBackground:I.isBackground,group:q,presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}he.from=j;async function W(I,H,M){if(I==null)return;let B;o.is(I.execution)?B=o.to(I.execution):w.is(I.execution)?B=w.to(I.execution):b.is(I.execution)&&(B=b.to(I._id,M));const G=t.to(I.definition);let q;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?q=I.source.scope:q=await H.resolveWorkspaceFolder(v.URI.revive(I.source.scope)):q=_.TaskScope.Workspace),!G||!q)return;const se=new _.Task(G,q,I.name,I.source.label,B,I.problemMatchers);return I.isBackground!==void 0&&(se.isBackground=I.isBackground),I.group!==void 0&&(se.group=_.TaskGroup.from(I.group)),I.presentationOptions&&(se.presentationOptions=i.to(I.presentationOptions)),I._id&&(se._id=I._id),I.detail&&(se.detail=I.detail),se}he.to=W})(C=e.TaskDTO||(e.TaskDTO={}));var u;(function(he){function $(W){return W}he.from=$;function j(W){if(!!W)return Object.assign(Object.create(null),W)}he.to=j})(u=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor($,j,W){this._id=j,this._task=W,f.set(this,void 0),nt(this,f,$,"f")}get task(){return this._task}terminate(){Be(this,f,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}f=new WeakMap;var O;(function(he){function $(j){return{id:j._id,task:void 0}}he.from=$})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor($,j,W,I,H,M,B,G){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=$.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=I,this._configurationService=H,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,j,W){if(!W)return new _.Disposable(()=>{});const I=this.nextHandle();return this._handlers.set(I,{type:j,provider:W,extension:$}),this._proxy.$registerTaskProvider(I,j),new _.Disposable(()=>{this._handlers.delete(I),this._proxy.$unregisterTaskProvider(I)})}registerTaskSystem($,j){this._proxy.$registerTaskSystem($,j)}fetchTasks($){return this._proxy.$fetchTasks(u.from($)).then(async j=>{const W=[];for(let I of j){const H=await C.to(I,this._workspaceProvider,this._providedCustomExecutions2);H&&W.push(H)}return W})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(j=>$.push(j)),$}terminateTask($){if(!($ instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,j,W){const I=this._providedCustomExecutions2.get($.id);if(I){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,I),this._terminalService.attachPtyToTerminal(j,await I.callback(W))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const j=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const j=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:j,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const j=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:$.exitCode})}$provideTasks($,j){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));const I=[],H=(0,R.asPromise)(()=>W.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(j,I,W,M));return new Promise(M=>{H.then(B=>{Promise.all(I).then(()=>{M(B)})})})}async $resolveTask($,j){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));if(j.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${W.type}].`);const I=await C.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const H=await W.provider.resolveTask(I,n.CancellationToken.None);if(!H)return;this.checkDeprecation(H,W);const M=C.from(H,W.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,H,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution($,j,W){const I=await this._proxy.$createTaskId($);!W&&!this._providedCustomExecutions2.has(I)&&this._notProvidedCustomExecutions.add(I),this._providedCustomExecutions2.set(I,j.execution)}async getTaskExecution($,j){if(typeof $=="string"){const H=this._taskExecutionPromises.get($);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let W=this._taskExecutionPromises.get($.id);if(W)return W;const I=new Promise(async(H,M)=>{const B=j||await C.to($.task,this._workspaceProvider,this._providedCustomExecutions2);B?H(new F(this,$.id,B)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,I),I.then(H=>(this._taskExecutions.set($.id,H),H),H=>Promise.reject(H))}checkDeprecation($,j){$._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let W=this._notProvidedCustomExecutions.values(),I=W.next();for(;!I.done;)!this._activeCustomExecutions2.has(I.value)&&this._lastStartedTask!==I.value&&(this._providedCustomExecutions2.delete(I.value),this._notProvidedCustomExecutions.delete(I.value)),I=W.next()}};z=je([Ke(0,d.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,S.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,k.IExtHostConfiguration),Ke(5,P.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,E.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let de=class extends z{constructor($,j,W,I,H,M,B,G){super($,j,W,I,H,M,B,G);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask($,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const W=C.from(j,$);if(W===void 0)throw new Error("Task is not valid");if(b.is(W.execution))await this.addCustomExecution(W,j,!1);else throw new h.NotSupportedError;const I=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),j);return this._proxy.$executeTask(W).catch(H=>{throw new Error(H)}),I}provideTasksInternal($,j,W,I){const H=[];if(I)for(let M of I){this.checkDeprecation(M,W),(!M.definition||!$[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const B=C.from(M,W.extension);B&&b.is(B.execution)?(H.push(B),j.push(this.addCustomExecution(B,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:W.extension}}async resolveTaskInternal($){if(b.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,j,W){}};de=je([Ke(0,d.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,S.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,k.IExtHostConfiguration),Ke(5,P.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,E.IExtHostApiDeprecationService)],de),e.WorkerExtHostTask=de,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},Kt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(J);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(J,R[D])&&(v[R[D]]=J[R[D]]);return v};define(be[219],we([0,1,13,11,24,20,3,54,43,6,23,10,2,37,5,39,15,70,9,7,30,182,97]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h,f,t){"use strict";var i,s,o,c;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const w=(W,I)=>`${W}:${I.toString()}`;let b=class{constructor(I,H,M){this.documents=H,this.workspace=M,this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new $(this.proxy),this.textDocumentObservers=new j(this.proxy,H)}registerTestController(I,H){const M=(0,g.generateUuid)();this.controllers.set(M,{instance:H,extensionId:I}),this.proxy.$registerTestController(M);const B=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const q of B)(G=this.testControllers.get(q))===null||G===void 0||G.subscribeFn(M,H)},0),new l.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(I){return this.textDocumentObservers.checkout(I.uri)}createWorkspaceTestObserver(I){return this.workspaceObservers.checkout(I.uri)}async runTests(I,H=T.CancellationToken.None){const M=B=>B.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:I.exclude?M(I.exclude).map(B=>B.testId):void 0,tests:M(I.tests),debug:I.debug},H)}createTestRun(I,H,M,B=!0){return this.runQueue.createTestRun(I,H,M,B)}$publishTestResults(I){this.results=Object.freeze(I.map(H=>(0,n.deepFreeze)(E.TestResults.to(H))).concat(this.results).sort((H,M)=>M.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(I,H){const M=d.URI.revive(H),B=w(I,M);if(this.testControllers.has(B))return;const G=new T.CancellationTokenSource;let q;if(I===1){let Me=this.documents.getDocument(M);if(!Me){const ze=new k.DisposableStore;Me=await new Promise(Ve=>{ze.add((0,R.disposableTimeout)(()=>Ve(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(x=>{const Q=x.find(te=>te.document.uri.toString()===M.toString());Q&&Ve(Q)}))}).finally(()=>ze.dispose())}if(Me){const ze=await this.workspace.getWorkspaceFolder2(M,!1);q=Ve=>Ve.createDocumentTestRoot?Ve.createDocumentTestRoot(Me.document,G.token):(0,e.createDefaultDocumentTestRoot)(Ve,Me.document,ze,G.token)}}else{const Me=await this.workspace.getWorkspaceFolder2(M,!1);Me&&(q=ze=>ze.createWorkspaceTestRoot(Me,G.token))}if(!q)return;const se=async(Me,ze)=>{try{const Ve=await q(ze);Ve&&Le.addRoot(Ve,Me)}catch(Ve){console.error(Ve)}},ve=new k.DisposableStore,Le=ve.add(this.ownedTests.createForHierarchy(Me=>this.proxy.$publishDiff(I,H,Me)));ve.add((0,k.toDisposable)(()=>G.dispose(!0)));const xe=[];for(const[Me,ze]of this.controllers)xe.push(se(Me,ze.instance));Promise.all(xe).then(()=>Le.pushDiff([3,-1])),this.testControllers.set(B,{store:ve,collection:Le,subscribeFn:se})}async $expandTest(I,H){const M=(0,v.mapFind)(this.testControllers.values(),B=>B.collection.treeId===I.src.tree?B:void 0);await(M==null?void 0:M.collection.expand(I.testId,H<0?Infinity:H)),this.flushCollectionDiffs()}$unsubscribeFromTests(I,H){var M;const B=d.URI.revive(H),G=w(I,B);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(I,H,M){I===1?this.textDocumentObservers.acceptDiff(d.URI.revive(H),M):this.workspaceObservers.acceptDiff(d.URI.revive(H),M)}async $runTestsForProvider(I,H){const M=this.controllers.get(I.tests[0].src.controller);if(!M)return;const B=I.tests.map(({testId:se,src:ve})=>this.ownedTests.getTestById(se,ve==null?void 0:ve.tree)).filter(P.isDefined).map(([se,ve])=>ve),G=I.excludeExtIds.map(se=>this.ownedTests.getTestById(se)).filter(P.isDefined).filter(([se,ve])=>B.some(Le=>se.comparePositions(Le,ve)===1));if(!B.length)return;const q={tests:B.map(se=>O.unwrap(se.actual)),exclude:G.map(([,se])=>O.unwrap(se.actual)),debug:I.debug};await this.runQueue.enqueueRun({dto:C.fromInternal(I),token:H,extensionId:M.extensionId,req:q,doRun:()=>M.instance.runTests(q,H)})}$lookupTest(I){const H=this.ownedTests.getTestById(I.testId);if(!H)return Promise.resolve(void 0);const M=H[1],{actual:B,discoverCts:G,expandLevels:q}=M,se=Kt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(se)}flushCollectionDiffs(){for(const{collection:I}of this.testControllers.values())I.flushDiff()}getInternalTestForReference(I){var H,M;return(M=(H=this.workspaceObservers.getMirroredTestDataByReference(I))!==null&&H!==void 0?H:(0,v.mapFind)(this.testControllers.values(),B=>B.collection.getTestByReference(I)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(I)}};b=je([Ke(0,p.IExtHostRpcService),Ke(1,a.IExtHostDocumentsAndEditors),Ke(2,h.IExtHostWorkspace)],b),e.ExtHostTesting=b;class A{constructor(I){this.proxy=I,this.state=new Map}enqueueRun(I){let H=this.state.get(I.extensionId);H||(H={queue:[],current:void 0},this.state.set(I.extensionId,H));const M=new R.DeferredPromise,B=()=>{const G=[],q=new Set;H.current={publicReq:I.req,factory:se=>{const ve=new u(se,I.dto,q,this.proxy);return G.push(ve),I.token.onCancellationRequested(()=>ve.end()),ve}},this.invokeRunner(I.extensionId,I.dto.id,I.doRun,G).finally(()=>M.complete())};return H.queue.push(B),H.queue.length===1&&B(),M.p}createTestRun(I,H,M,B){var G,q;const se=this.state.get(I);if((se==null?void 0:se.current.publicReq)===H)return se.current.factory(M);const ve=C.fromPublic(H),Le=new u(M,ve,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:H.debug,exclude:(q=(G=H.exclude)===null||G===void 0?void 0:G.map(xe=>xe.id))!==null&&q!==void 0?q:[],id:ve.id,tests:H.tests.map(xe=>xe.id),persist:B}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ve.id)),Le}invokeRunner(I,H,M,B){try{const G=M();return(0,R.isThenable)(G)?G.then(()=>this.handleInvokeResult(I,H,B,void 0)).catch(q=>this.handleInvokeResult(I,H,B,q)):this.handleInvokeResult(I,H,B,void 0)}catch(G){return this.handleInvokeResult(I,H,B,G)}}async handleInvokeResult(I,H,M,B){const G=this.state.get(I);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(I),await Promise.all(M.map(q=>q.onEnd.wait())))}}class C{constructor(I,H,M){this.id=I,this.include=H,this.exclude=M}static fromPublic(I){var H,M;return new C((0,g.generateUuid)(),new Set(I.tests.map(B=>B.id)),new Set((M=(H=I.exclude)===null||H===void 0?void 0:H.map(B=>B.id))!==null&&M!==void 0?M:y.Iterable.empty()))}static fromInternal(I){return new C(I.runId,new Set(I.tests.map(H=>H.testId)),new Set(I.excludeExtIds))}isIncluded(I){for(let H=I;H;H=H.parent){if(this.include.has(H.id))return!0;if(this.exclude.has(H.id))return!1}return!0}}class u{constructor(I,H,M,B){this.name=I,i.set(this,void 0),s.set(this,void 0),o.set(this,(0,g.generateUuid)()),c.set(this,void 0),this.onEnd=new R.Barrier,nt(this,i,B,"f"),nt(this,s,H,"f"),nt(this,c,M,"f"),B.$startedTestRunTask(H.id,{id:Be(this,o,"f"),name:I,running:!0})}setState(I,H,M){Be(this,s,"f").isIncluded(I)&&(this.ensureTestIsKnown(I),Be(this,i,"f").$updateTestStateInRun(Be(this,s,"f").id,Be(this,o,"f"),I.id,H,M))}appendMessage(I,H){Be(this,s,"f").isIncluded(I)&&(this.ensureTestIsKnown(I),Be(this,i,"f").$appendTestMessageInRun(Be(this,s,"f").id,Be(this,o,"f"),I.id,E.TestMessage.from(H)))}appendOutput(I){Be(this,i,"f").$appendOutputToRun(Be(this,s,"f").id,Be(this,o,"f"),D.VSBuffer.fromString(I))}end(){Be(this,i,"f").$finishedTestRunTask(Be(this,s,"f").id,Be(this,o,"f")),this.onEnd.open()}ensureTestIsKnown(I){const H=Be(this,c,"f");if(H.has(I.id))return;const M=[];for(;M.unshift(E.TestItem.from(I)),!(H.has(I.id)||(H.add(I.id),!I.parent));)I=I.parent;Be(this,i,"f").$addTestsToRun(Be(this,s,"f").id,M)}}i=new WeakMap,s=new WeakMap,o=new WeakMap,c=new WeakMap;const F=async(W,I,H,M)=>{if(!H)return;const B=await W.createWorkspaceTestRoot(H,M);if(!B)return;M.onCancellationRequested(()=>{O.removeFilter(I)});const G=O.getWrapperForTestItem(B,I);return G.refreshMatch(),G};e.createDefaultDocumentTestRoot=F;class O extends l.TestItemImpl{constructor(I,H,M){super(I.id,I.label,I.uri,void 0);if(this.actual=I,this.filterDocument=H,this.actualParent=M,!(I instanceof l.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${I.id} did not`);this.debuggable=I.debuggable,this.runnable=I.runnable,this.description=I.description,this.error=I.error,this.status=I.status,this.range=I.range,this.resolveHandler=I.resolveHandler;const B=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(I).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const se=O.getWrapperForTestItem(q[1],this.filterDocument,this);(0,m.getPrivateApiFor)(se).parent=I,se.refreshMatch();break;default:B.bus.fire(q)}})}static removeFilter(I){this.wrapperMap.delete(I)}static getWrapperForTestItem(I,H,M){let B=this.wrapperMap.get(H);if(B==null?void 0:B.has(I))return B.get(I);B||(B=new WeakMap,this.wrapperMap.set(H,B));const G=new O(I,H,M);return B.set(I,G),G}static unwrap(I){return I instanceof O?I.actual:I}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var I,H;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const q=O.getWrapperForTestItem(G,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const B=this.children.size>0||((I=this.actual.uri)===null||I===void 0?void 0:I.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=B,B!==M&&((H=this.actualParent)===null||H===void 0||H.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,E.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:H,removed:M}=this;return{get added(){return[...I].map(B=>B.revived)},get updated(){return[...H].map(B=>B.revived)},get removed(){return[...M].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class de extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(I){let H=[];for(const M of I){const B=this.items.get(M);B&&H.push(B.revived)}return H}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,H){return Object.assign(Object.assign({},I),{revived:E.TestItem.toPlain(I.item),depth:H?H.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=de;class he{constructor(){this.resources=new Map}checkout(I){var H,M;const B=I.toString(),G=(H=this.resources.get(B))!==null&&H!==void 0?H:this.createObserverData(I);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new _.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,S.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(I))})}}getMirroredTestDataByReference(I){for(const{tests:H}of this.resources.values()){const M=H.getMirroredTestDataByReference(I);if(M)return M}}eventuallyDispose(I){return(0,R.disposableTimeout)(()=>this.unlisten(I),10*1e3)}createObserverData(I){const H=new de,M=this.listen(I,G=>H.apply(G)),B={observers:0,tests:H,listener:M};return this.resources.set(I.toString(),B),B}unlisten(I){var H;const M=I.toString(),B=this.resources.get(M);B&&(B.observers=-1,(H=B.pendingDeletion)===null||H===void 0||H.dispose(),B.listener.dispose(),this.resources.delete(M))}}class $ extends he{constructor(I){super();this.proxy=I,this.diffListeners=new Map}acceptDiff(I,H){var M;(M=this.diffListeners.get(I.toString()))===null||M===void 0||M(H)}listen(I,H){this.proxy.$subscribeToDiffs(0,I);const M=I.toString();return this.diffListeners.set(M,H),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,I),this.diffListeners.delete(M)})}}class j extends he{constructor(I,H){super();this.proxy=I,this.documents=H,this.diffListeners=new Map}acceptDiff(I,H){var M;(M=this.diffListeners.get(I.toString()))===null||M===void 0||M(H)}listen(I,H){if(!this.documents.getDocument(I))return new l.Disposable(()=>{});const B=I.toString();return this.diffListeners.set(B,H),this.proxy.$subscribeToDiffs(1,I),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,I),this.diffListeners.delete(B)})}}}),define(be[220],we([0,1,13,52,28,59,22,16,14,25,8,10,2,118,141,92,48,175,218,41]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(A,C,u,F){this.configurationService=A,this.workspaceContextService=C,this.editorGroupsService=u,this.pathService=F}text(A,C,u={}){A=this.getContentPattern(A,u);const F=this.configurationService.getValue(),O=C&&C.some(de=>!this.configurationService.getValue({resource:de}).search.useRipgrep),z=this.commonQuery(C==null?void 0:C.map(p.toWorkspaceFolder),u);return Object.assign(Object.assign({},z),{type:2,contentPattern:A,previewOptions:u.previewOptions,maxFileSize:u.maxFileSize,usePCRE2:F.search.usePCRE2||O||!1,beforeContext:u.beforeContext,afterContext:u.afterContext,userDisabledExcludesAndIgnoreFiles:u.disregardExcludeSettings&&u.disregardIgnoreFiles})}getContentPattern(A,C){const u=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},A),{wordSeparators:u.editor.wordSeparators});return this.isCaseSensitive(A,C)&&(F.isCaseSensitive=!0),this.isMultiline(A)&&(F.isMultiline=!0),F}file(A,C={}){const u=this.commonQuery(A,C);return Object.assign(Object.assign({},u),{type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey})}handleIncludeExclude(A,C){return A?(A=Array.isArray(A)?A.map(o):o(A),C?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],C={}){const u=this.handleIncludeExclude(C.includePattern,C.expandPatterns),F=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),O=A.length>1,z=(u.searchPaths&&u.searchPaths.length?u.searchPaths.map($=>this.getFolderQueryForSearchPath($,C,F)):A.map($=>this.getFolderQueryForRoot($,C,F,O))).filter($=>!!$),de={_reason:C._reason,folderQueries:z,usingSearchPaths:!!(u.searchPaths&&u.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:F.pattern,includePattern:u.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const j=v.coalesce(v.flatten(this.editorGroupsService.groups.map(I=>I.editors.map(H=>H.resource)))).filter(I=>(0,l.pathIncludedInQuery)(de,I.fsPath)),W=this.commonQueryFromFileList(j);return Object.assign(Object.assign({},de),W)}const he=C.extraFileResources&&C.extraFileResources.filter($=>(0,l.pathIncludedInQuery)(de,$.fsPath));return de.extraFileResources=he&&he.length?he:void 0,de}commonQueryFromFileList(A){const C=[],u=new _.ResourceMap,F={};let O=!1;return A.forEach(z=>{var de,he;if(z.scheme===S.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(z)){const j=(he=(de=this.workspaceContextService.getWorkspaceFolder(z))===null||de===void 0?void 0:de.uri)!==null&&he!==void 0?he:z.with({path:y.dirname(z.fsPath)});let W=u.get(j);W||(O=!0,W={folder:j,includePattern:{}},C.push(W),u.set(j,W));const I=y.relative(j.fsPath,z.fsPath);(0,P.assertIsDefined)(W.includePattern)[I.replace(/\\/g,"/")]=!0}else z.fsPath&&(O=!0,F[z.fsPath]=!0)}),{folderQueries:C,includePattern:F,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(A,C){if(C.isSmartCase){if(A.isRegExp){if(n.containsUppercaseCharacter(A.pattern,!0))return!0}else if(n.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,g.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const C=W=>y.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),F=(Array.isArray(A)?A:i(A)).map(W=>{const I=this.pathService.resolvedUserHome;return I?(0,T.untildify)(W,I.scheme===S.Schemas.file?I.fsPath:I.path):W}),O=R.groupBy(F,W=>C(W)?"searchPaths":"exprSegments"),z=(O.exprSegments||[]).map(W=>n.rtrim(W,"/")).map(W=>n.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),de={},he=this.expandSearchPathPatterns(O.searchPaths||[]);he&&he.length&&(de.searchPaths=he);const $=v.flatten(z),j=t(...$);return j&&(de.pattern=j),de}getExcludesForFolder(A,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(A,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const C=v.flatten(A.map(F=>{let{pathPortion:O,globPortion:z}=f(F);z&&(z=c(z));const de=this.expandOneSearchPath(O);return v.flatten(de.map(he=>this.resolveOneSearchPathPattern(he,z)))})),u=new Map;return C.forEach(F=>{const O=F.searchPath.toString(),z=u.get(O);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):u.set(O,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(u.values())}expandOneSearchPath(A){if(y.isAbsolute(A)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==S.Schemas.file?[{searchPath:C[0].uri.with({path:A})}]:[{searchPath:d.URI.file(y.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=o(A),A.startsWith("../")||A===".."){const F=y.posix.resolve(C.path,A);return[{searchPath:C.with({path:F})}]}const u=c(A);return[{searchPath:C,pattern:u}]}else{if(A==="./"||A===".\\")return[];{const C=A.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(O=>{const z=C.match(new RegExp(`^${O.name}(?:/(.*))?`));return z?{match:z,folder:O}:null}).filter(P.isDefined);if(F.length)return F.map(O=>{const z=O.match[1];return{searchPath:O.folder.uri,pattern:z&&c(z)}});{const O=A.match(/\.[\/\\](.+)[\/\\]?/),z=O?O[1]:A,de=r.localize(0,null,z);throw new Error(de)}}}}resolveOneSearchPathPattern(A,C){const u=A.pattern&&C?`${A.pattern}/${C}`:A.pattern||C,F=[{searchPath:A.searchPath,pattern:u}];return u&&!u.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:u+"/**"}),F}getFolderQueryForSearchPath(A,C,u){const F=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(A.searchPath),C,u,!1);return F?Object.assign(Object.assign({},F),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,C,u,F){let O;const z=d.URI.isUri(A)?A:A.uri;if(u.searchPaths){const W=u.searchPaths.filter(I=>(0,k.isEqual)(I.searchPath,z))[0];if(W&&!W.pattern)return null;W&&(O=W.pattern)}const de=this.configurationService.getValue({resource:z}),he=this.getExcludesForFolder(de,C),$=Object.assign(Object.assign({},he||{}),O||{}),j=d.URI.isUri(A)?(0,k.basename)(A):A.name;return{folder:z,folderName:F?j:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:de.files&&de.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!de.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!de.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!de.search.followSymlinks}}};h=je([Ke(0,a.IConfigurationService),Ke(1,p.IWorkspaceContextService),Ke(2,m.IEditorGroupsService),Ke(3,E.IPathService)],h),e.QueryBuilder=h;function f(b){const A=b.match(/[\*\{\}\(\)\[\]\?]/);if(A){const C=A.index,u=b.substr(0,C).match(/[/|\\][^/\\]*$/);if(u){let F=b.substr(0,u.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((u.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((A,C)=>(A[C]=!0,A),Object.create(null)):void 0}function i(b){return D.splitGlobAware(b,",").map(A=>A.trim()).filter(A=>!!A.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function c(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b,A){b=v.distinct(b,F=>F.toString());const C=[],u=A.getWorkspace();return b&&b.forEach(F=>{let O;if(A.getWorkbenchState()===2)O=(0,k.relativePath)(u.folders[0].uri,F),O&&O!=="."&&(O="./"+O);else{const z=A.getWorkspaceFolder(F);if(z){const de=z.name;if(u.folders.filter($=>$.name===de).length===1){const $=(0,k.relativePath)(z.uri,F);$===""?O=`./${z.name}`:O=`./${z.name}/${$}`}else O=F.fsPath}}O&&C.push(O)}),C}e.resolveResourcesForSearchIncludes=w}),define(be[221],we([0,1,25,2,20,12,4,220,41,48]),function(J,e,v,R,D,T,_,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(a,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const E=[],l=[];for(const o of m)if(/^workspaceContains:/.test(o)){const c=o.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||a.forceUsingSearch?l.push(c):E.push(c)}if(E.length===0&&l.length===0)return Promise.resolve(void 0);let h;const f=new Promise((o,c)=>{h=o}),t=o=>h({activationEvent:o}),i=Promise.all(E.map(o=>d(a,o,t))).then(()=>{}),s=g(a,p.identifier,l,t);return Promise.all([i,s]).then(()=>{h(void 0)}),f}e.checkActivateWorkspaceContainsExtension=P;async function d(a,p,m){for(const E of a.folders)if(await a.exists(v.joinPath(R.URI.revive(E),p))){m(`workspaceContains:${p}`);return}}async function g(a,p,m,E){if(m.length===0)return Promise.resolve(void 0);const l=new D.CancellationTokenSource,h=a.checkExists(a.folders,m,l.token),f=setTimeout(async()=>{l.cancel(),E(`workspaceContainsTimeout:${m.join(",")}`)},n);let t=!1;try{t=await h}catch(i){T.isPromiseCanceledError(i)||T.onUnexpectedError(i)}l.dispose(),clearTimeout(f),t&&E(`workspaceContains:${m.join(",")}`)}function r(a,p,m,E){const l=a.get(_.IInstantiationService),h=a.get(y.ISearchService),t=l.createInstance(S.QueryBuilder).file(p.map(i=>(0,k.toWorkspaceFolder)(R.URI.revive(i))),{_reason:"checkExists",includePattern:m,exists:!0});return h.fileSearch(t,E).then(i=>!!i.limitHit,i=>T.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var nt=this&&this.__classPrivateFieldSet||function(J,e,v,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(J,v):D?D.value=v:e.set(J,v),v},Be=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[34],we([0,1,133,14,80,25,11,6,22,2,17,5,33,185,78,30,32,183,12,26,24,162,7,93,4,27,79,15,66,71,40,3,221,74,163]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h,f,t,i,s,o,c,w,b,A,C,u,F,O,z){"use strict";var de,he,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Nn extends S.Disposable{constructor(M,B,G,q,se,ve,Le,xe,Me,ze){super();this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=G,this._initData=Le,this._extHostWorkspace=q,this._extHostConfiguration=se,this._logService=ve,this._extHostTunnelService=Me,this._extHostTerminalService=ze,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=M.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(x=>Ve.add(l.ExtensionIdentifier.toKey(x))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(x,Q,te)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(x,E.transformErrorForSerialization(Q),te)},actualActivateExtension:async(x,Q)=>{if(Ve.has(l.ExtensionIdentifier.toKey(x)))return await this._mainThreadExtensionsProxy.$activateExtension(x,Q),new g.HostExtension;const te=this._registry.getExtensionDescription(x);return this._activateExtension(te,Q)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(B){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,B){return this._activator.activateByEvent(M,B)}_activateById(M,B){return this._activator.activateById(M,B)}activateByIdWithErrors(M,B){return this._activateById(M,B).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=y.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(q=>M.set(k.URI.file(q).fsPath,G))});this._extensionPathIndex=Promise.all(B).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return B;const G=this._activator.getActivatedExtension(M);if(!G)return B;try{typeof G.module.deactivate=="function"&&(B=Promise.resolve(G.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,S.dispose)(G.subscriptions)}catch(q){this._logService.error(q)}return B}async _activateExtension(M,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,B).then(G=>{const q=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,B),this._logExtensionActivationTimes(M,B,"success",q),G},G=>{throw this._logExtensionActivationTimes(M,B,"failure"),G})}_logExtensionActivationTimes(M,B,G,q){const se=W(M,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},se),q||{}),{outcome:G}))}_doActivateExtension(M,B){const G=W(M,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const q=this._getEntryPoint(M);if(!q)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const se=new g.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,q),se),this._loadExtensionContext(M)]).then(ve=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Nn._callActivate(this._logService,M.identifier,ve[0],ve[1],se))).then(ve=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ve))}_loadExtensionContext(M){const B=new f.ExtensionGlobalMemento(M,this._storage),G=new f.ExtensionMemento(M.identifier.value,!1,this._storage),q=new z.ExtensionSecrets(M,this._secretState),se=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ve=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([B.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let xe;return Object.freeze({globalState:B,workspaceState:G,secrets:q,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Me){return R.join(M.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Le._storagePath.workspaceValue(M))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(M).fsPath},get logPath(){return R.join(Le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Le._initData.logsLocation,M.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(M)},get globalStorageUri(){return Le._storagePath.globalValue(M)},get extensionMode(){return se},get extension(){return xe===void 0&&(xe=new I(Le,M.identifier,M,ve)),xe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(M),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,B,G,q,se){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,B,G,q,se).then(ve=>new g.ActivatedExtension(!1,null,se.build(),G,ve,q.subscriptions))}static _callActivateOptional(M,B,G,q,se){if(typeof G.activate=="function")try{se.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ve=typeof global=="object"?global:self,Le=G.activate.apply(ve,[q]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(Le).then(xe=>(se.activateResolveStop(),xe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(G)}_activateOneStartupFinished(M,B){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:B}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const B of M.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(M,B)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(B),q=Promise.all([M,G]).then(()=>{});return Promise.race([q,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(M,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,B){if(this.isActivated(B.identifier))return;const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:M.map(ve=>ve.uri),forceUsingSearch:G,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Le,xe)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Le,xe)},se=await(0,F.checkActivateWorkspaceContainsExtension)(q,B);if(!!se)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:se.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:B}=this._initData.environment;if(!M||!B)throw new Error(v.localize(0,null));const G=await this._loadCommonJSModule(null,B,new g.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(v.localize(1,null,B.toString()));return new Promise((q,se)=>{const ve=(Me,ze)=>{Me?se(Me):q(typeof ze=="number"&&ze>0?1:0)},Le=(0,T.originalFSPath)(B),xe=G.run(Le,ve);xe&&xe.then&&xe.then(()=>{q(0)}).catch(Me=>{se(Me.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,B){return this._resolvers[M]=B,(0,S.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const B=M.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const G=M.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this._resolvers[G]}}async $resolveAuthority(M,B){const{authorityPrefix:G,resolver:q}=await this._activateAndGetResolver(M);if(!q)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${G}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(q)),D.mark(`code/extHost/willResolveAuthority/${G}`);const se=await q.resolve(M,{resolveAttempt:B});D.mark(`code/extHost/didResolveAuthorityOK/${G}`);const ve={authority:M,host:se.host,port:se.port,connectionToken:se.connectionToken},Le={extensionHostEnv:se.extensionHostEnv,isTrusted:se.isTrusted};return{type:"ok",value:{authority:ve,options:Le,tunnelInformation:{environmentTunnels:se.environmentTunnels}}}}catch(se){if(D.mark(`code/extHost/didResolveAuthorityError/${G}`),se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se}}async $getCanonicalURI(M,B){const{authorityPrefix:G,resolver:q}=await this._activateAndGetResolver(M);if(!q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${G}`);const se=k.URI.revive(B);if(typeof q.getCanonicalURI=="undefined")return se;const ve=await(0,_.asPromise)(()=>q.getCanonicalURI(se));return ve||se}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,B){return B===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,B),!0):!1}async $deltaExtensions(M,B){M.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(B.map(async q=>{const se=this._registry.getExtensionDescription(q);if(!se)return;const ve=await this._hostUtils.realpath(se.extensionLocation.fsPath);G.delete(k.URI.file(ve).fsPath)})),await Promise.all(M.map(async q=>{const se=await this._hostUtils.realpath(q.extensionLocation.fsPath);G.set(k.URI.file(se).fsPath,q)})),this._registry.deltaExtensions(M,B),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let B=h.VSBuffer.alloc(M),G=Math.random()%256;for(let q=0;q<M;q++)B.writeUInt8(G,q);return B}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};j=je([Ke(0,s.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,w.IExtHostRpcService),Ke(3,a.IExtHostWorkspace),Ke(4,d.IExtHostConfiguration),Ke(5,n.ILogService),Ke(6,o.IExtHostInitDataService),Ke(7,c.IExtensionStoragePaths),Ke(8,A.IExtHostTunnelService),Ke(9,C.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function W(H,M){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class I{constructor(M,B,G,q){de.set(this,void 0),he.set(this,void 0),$.set(this,void 0),nt(this,de,M,"f"),nt(this,he,B,"f"),nt(this,$,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=q}get isActive(){return Be(this,de,"f").isActivated(Be(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,de,"f").getExtensionExports(Be(this,$,"f"))}activate(){return Be(this,de,"f").activateByIdWithErrors(Be(this,$,"f"),{startup:!1,extensionId:Be(this,he,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=I,de=new WeakMap,he=new WeakMap,$=new WeakMap}),define(be[106],we([0,1,14,2,3,11,5,7,170,30,34,39,174,33,171,15,4,10,46,69]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let h=class{constructor(b,A,C,u,F,O){this._workspaceService=A,this._extensionService=C,this._editorsService=u,this._configurationService=F,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=b.getProxy(_.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(de=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,A){const C=b;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let u=`debug:${encodeURIComponent(C.path||"")}`,F="?";return A&&(u+=`${F}session=${encodeURIComponent(A.id)}`,F="&"),u+=`${F}ref=${C.sourceReference}`,R.URI.parse(u)}else{if(C.path)return R.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const A=[];for(const C of b.getAllExtensionDescriptions())if(C.contributes){const u=C.contributes.debuggers;if(u&&u.length>0)for(const F of u)(0,r.isDebuggerMainContribution)(F)&&A.push(F.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(A=>b.push(A)),b}addBreakpoints(b){this.startBreakpoints();const A=b.filter(F=>{const O=F.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,F),!0)});this.fireBreakpointChanges(A,[],[]);const C=[],u=new Map;for(const F of A)if(F instanceof S.SourceBreakpoint){let O=u.get(F.location.uri.toString());O||(O={type:"sourceMulti",uri:F.location.uri,lines:[]},u.set(F.location.uri.toString(),O),C.push(O)),O.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof S.FunctionBreakpoint&&C.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(b){this.startBreakpoints();const A=b.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],A,[]);const C=A.filter(O=>O instanceof S.SourceBreakpoint).map(O=>O.id),u=A.filter(O=>O instanceof S.FunctionBreakpoint).map(O=>O.id),F=A.filter(O=>O instanceof S.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(C,u,F)}startDebugging(b,A,C){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,A,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,A,C){if(!A)return new S.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:u,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,C,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,u),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(b,A,C){if(!C)return new S.Disposable(()=>{});if(!this.definesDebugType(b,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:u,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,u),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(b,A){if(!A)return new S.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:C,factory:A}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==A)})}async $runInTerminal(b,A){return Promise.resolve(void 0)}async $substituteVariables(b,A){if(!this._variableResolver){const[F,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,O)}let C;const u=await this.getFolder(b);return u&&(C={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(C,A)}createDebugAdapter(b,A){if(b.type==="implementation")return new o(b.implementation)}createSignService(){}async $startDASession(b,A){const C=this,u=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const O=this.convertToDto(F),z=this.createDebugAdapter(O,u);if(!z)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const de=z;return this._debugAdapters.set(b,de),this.getDebugAdapterTrackers(u).then(he=>(he&&this._debugAdaptersTrackers.set(b,he),de.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const j=$,W={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const I=await this._signService.sign(j.arguments.value);W.body={signature:I},de.sendResponse(W)}else throw new Error("no signer")}catch(I){W.success=!1,W.message=I.message,de.sendResponse(W)}}else he&&he.onDidSendMessage&&he.onDidSendMessage($),$=(0,r.convertToVSCPaths)($,!0),C._debugServiceProxy.$acceptDAMessage(b,$)}),de.onError($=>{he&&he.onError&&he.onError($),this._debugServiceProxy.$acceptDAError(b,$.name,$.message,$.stack)}),de.onExit($=>{he&&he.onExit&&he.onExit((0,m.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,m.withNullAsUndefined)($),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),de.startSession()))})}$sendDAMessage(b,A){A=(0,r.convertToDAPaths)(A,!1);const C=this._debugAdaptersTrackers.get(b);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(A);const u=this._debugAdapters.get(b);u&&u.sendMessage(A)}$stopDASession(b){const A=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),A&&A.onWillStopSession&&A.onWillStopSession();const C=this._debugAdapters.get(b);return this._debugAdapters.delete(b),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const A=[],C=[],u=[];if(b.added)for(const F of b.added){const O=F.id;if(O&&!this._breakpoints.has(O)){let z;if(F.type==="function")z=new S.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")z=new S.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const de=R.URI.revive(F.uri);z=new S.SourceBreakpoint(new S.Location(de,new S.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}z._id=O,this._breakpoints.set(O,z),A.push(z)}}if(b.removed)for(const F of b.removed){const O=this._breakpoints.get(F);O&&(this._breakpoints.delete(F),C.push(O))}if(b.changed){for(const F of b.changed)if(F.id){const O=this._breakpoints.get(F.id);if(O){if(O instanceof S.FunctionBreakpoint&&F.type==="function"){const z=O;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(O instanceof S.SourceBreakpoint&&F.type==="source"){const z=O;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new S.Location(R.URI.revive(F.uri),new S.Position(F.line,F.character))}u.push(O)}}}this.fireBreakpointChanges(A,C,u)}$provideDebugConfigurations(b,A,C){return(0,T.asPromise)(async()=>{const u=this.getConfigProviderByHandle(b);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(A);return u.provideDebugConfigurations(F,C)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(b,A,C,u){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(A);return F.resolveDebugConfiguration(O,C,u)})}$resolveDebugConfigurationWithSubstitutedVariables(b,A,C,u){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(A);return F.resolveDebugConfigurationWithSubstitutedVariables(O,C,u)})}async $provideDebugAdapter(b,A){const C=this.getAdapterDescriptorFactoryByHandle(b);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(A);return this.getAdapterDescriptor(C,u).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const A=await this.getSession(b);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(b){const A=await this.getSession(b);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,A){const C=await this.getSession(b);C&&C._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(b,A){const u={session:await this.getSession(b),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(b){if(b instanceof S.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof S.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const A=this._adapterFactories.filter(C=>C.type===b);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(b){const A=this._adapterFactories.filter(C=>C.handle===b);if(A.length>0)return A[0].factory}getConfigProviderByHandle(b){const A=this._configProviders.filter(C=>C.handle===b);if(A.length>0)return A[0].provider}definesDebugType(b,A){if(b.contributes){const C=b.contributes.debuggers;if(C&&C.length>0){for(const u of C)if(u.label&&u.type&&u.type===A)return!0}}return!1}getDebugAdapterTrackers(b){const C=b.configuration.type,u=this._trackerFactories.filter(F=>F.type===C||F.type==="*").map(F=>(0,T.asPromise)(()=>F.factory.createDebugAdapterTracker(b)).then(O=>O,O=>null));return Promise.race([Promise.all(u).then(F=>{const O=F.filter(z=>!!z);if(O.length>0)return new s(O)}),new Promise((F,O)=>{const z=setTimeout(()=>{clearTimeout(z),O(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,A){const C=A.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new S.DebugAdapterServer(C));if(b){const F=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>b.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,F))).then(O=>{if(O)return O})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,u))}daExecutableFromPackage(b,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,A,C){(b.length>0||A.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:A,changed:C}))}async getSession(b){if(b)if(typeof b=="string"){const A=this._debugSessions.get(b);if(A)return A}else{let A=this._debugSessions.get(b.id);if(!A){const C=await this.getFolder(b.folderUri),u=b.parent?this._debugSessions.get(b.parent):void 0;A=new f(this._debugServiceProxy,b.id,b.type,b.name,C,b.configuration,u),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(b){if(b){const A=R.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};h=je([Ke(0,a.IExtHostRpcService),Ke(1,k.IExtHostWorkspace),Ke(2,n.IExtHostExtensionService),Ke(3,P.IExtHostDocumentsAndEditors),Ke(4,g.IExtHostConfiguration),Ke(5,l.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class f{constructor(b,A,C,u,F,O,z){this._debugServiceProxy=b,this._id=A,this._type=C,this._name=u,this._workspaceFolder=F,this._configuration=O,this._parentSession=z}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}get parentSession(){return this._parentSession}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,A)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=f;class t{constructor(b){this.value=Object.freeze({append(A){b.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class i extends d.AbstractVariableResolverService{constructor(b,A,C,u,F){function O(){if(A){const z=A.activeEditor();if(z)return z.document.uri;const de=u.tabs.filter(he=>he.isActive);if(de.length>0)return de[0].resource}}super({getFolderUri:z=>{const de=b.filter(he=>he.name===z);if(de&&de.length>0)return de[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,de)=>C.getConfiguration(void 0,z).get(de),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=O();if(z)return v.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const z=O();if(z){const de=F.getWorkspaceFolder(z);if(de)return v.normalize(de.uri.fsPath)}}},getSelectedText:()=>{if(A){const z=A.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(A){const z=A.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=i;class s{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(A=>A.onError?A.onError(b):void 0)}onExit(b,A){this.trackers.forEach(C=>C.onExit?C.onExit(b,A):void 0)}}class o extends y.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends h{constructor(b,A,C,u,F,O){super(b,A,C,u,F,O)}createVariableResolver(b,A,C){return new i(b,A,C,this._editorTabs)}};c=je([Ke(0,a.IExtHostRpcService),Ke(1,k.IExtHostWorkspace),Ke(2,n.IExtHostExtensionService),Ke(3,P.IExtHostDocumentsAndEditors),Ke(4,g.IExtHostConfiguration),Ke(5,l.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[222],we([0,1,80,2,5,33,32,26,15,27,4,34,46,17]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(l,h,f,t,i,s,o){this._apiFactory=l,this._extensionRegistry=h,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,h,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,h,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let h of l.nodeModuleName)this._factories.set(h,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(h=>l.alternativeModuleName(h))}};r=je([Ke(2,n.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,P.IExtHostExtensionService),Ke(5,k.IExtHostInitDataService),Ke(6,g.ILogService)],r),e.RequireInterceptor=r;class a{constructor(l,h,f,t,i){this._apiFactory=l,this._extensionPaths=h,this._extensionRegistry=f,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,h){const f=this._extensionPaths.findSubstr(h.fsPath);if(f){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,h){this.nodeModuleName="keytar";const{environment:f}=h,t=l.getProxy(D.MainContext.MainThreadKeytar);if(f.appRoot){let i=f.appRoot.fsPath;d.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,o)=>t.$setPassword(i,s,o),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(l,h){return this._impl}alternativeModuleName(l){const h=l.length;if(h<=7||!this.alternativeNames)return;const f=h-7;if((l.charAt(f)==="/"||l.charAt(f)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};p=je([Ke(0,y.IExtHostRpcService),Ke(1,k.IExtHostInitDataService)],p);let m=class{constructor(l,h,f){this._extensionPaths=l,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(D.MainContext.MainThreadTelemetry);const t=f.getProxy(D.MainContext.MainThreadWindow);this._impl=(i,s)=>{const o=R.URI.parse(i);return s?this.callOriginal(i,s):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,i,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,i,{}):this.callOriginal(i,s)}}load(l,h,f){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(l),this._impl}callOriginal(l,h){return this.sendNoForwardTelemetry(),this._original(l,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([Ke(2,y.IExtHostRpcService)],m)}),define(be[223],we([0,1,11,12,80,6,2,5,215,17,62,66,27,152,15,72,34,40]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(h,f,t,i){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(h,null,i),f=E._transform(f,this._rpcProtocol);const s=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),s.set(a.IURITransformerService,new a.URITransformerService(i)),s.set(p.IHostUtils,t);const o=new g.InstantiationService(s,!0),c=o.invokeFunction(C=>C.get(m.IExtHostTerminalService));this._disposables.add(c),this._logService=o.invokeFunction(C=>C.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=o.invokeFunction(C=>C.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(C=>{Error.prepareStackTrace=(u,F)=>{let O="",z,de;for(const he of F)O+=`
	at ${he.toString()}`,de=he.getFileName(),!z&&de&&(z=C.findSubstr(de));return w.set(u,z),`${u.name||"Error"}: ${u.message||""}${O}`}});const b=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(C=>{const u=R.transformErrorForSerialization(C),F=w.get(C);F?b.$onExtensionRuntimeError(F.identifier,u):A.$onUnexpectedError(u)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,f){h.extensions.forEach(i=>i.extensionLocation=_.URI.revive(f.transformIncomingURIs(i.extensionLocation))),h.environment.appRoot=_.URI.revive(f.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(i=>_.URI.revive(f.transformIncomingURIs(i)))),h.environment.extensionTestsLocationURI=_.URI.revive(f.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=_.URI.revive(f.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=_.URI.revive(f.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=_.URI.revive(f.transformIncomingURIs(h.logsLocation)),h.logFile=_.URI.revive(f.transformIncomingURIs(h.logFile)),h.workspace=f.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=E}),define(be[224],we([0,1,14,20,61,28,25,56,41]),function(J,e,v,R,D,T,_,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,g,r){this.config=d,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const g=this.config.folderQueries||[];return new Promise((r,a)=>{const p=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const E=m.toString(),l=v.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,l)||this.matchFile(p,{base:m,basename:l})}),Promise.all(g.map(m=>this.searchInFolder(m,p))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{a(new Error((0,D.toErrorMessage)(m)))})})}async searchInFolder(d,g){const r=new R.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),p=this.initDirectoryTree(),m=new y.QueryGlobTester(this.config,d),E=!m.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(r),l=S.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),f=l.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(i=>{const s=v.posix.relative(d.folder.path,i.path);if(E){const o=v.basename(i.path);this.matchFile(g,{base:d.folder,relativePath:s,basename:o});return}this.addDirectoryEntries(p,d.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,m,g),{providerTime:f,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const g=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:g,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},g,r,a){if(r===this.filePattern){const m=v.basename(this.filePattern);this.matchFile(a,{base:g,relativePath:this.filePattern,basename:m})}function p(m){const E=v.basename(m),l=v.dirname(m);let h=d[l];h||(h=d[l]=[],p(l)),h.push({base:g,relativePath:m,basename:E})}p(r)}matchDirectoryTree({rootEntries:d,pathToEntries:g},r,a){const p=this,m=this.filePattern;function E(l){const h=T.hasSiblingFn(()=>l.map(f=>f.basename));for(let f=0,t=l.length;f<t;f++){const i=l[f],{relativePath:s,basename:o}=i;if(!r.includedInQuerySync(s,o,m!==o?h:void 0))continue;const c=g[s];if(c)E(c);else{if(s===m)continue;p.matchFile(a,i)}if(p.isLimitHit)break}}E(d)}matchFile(d,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(g))}}class n{constructor(){this.sessions=new Map}fileSearch(d,g,r,a){const p=this.getSessionTokenSource(d.cacheKey),m=new k(d,g,p&&p.token);let E=0;const l=h=>{E+=h.length,r(h.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(m,n.BATCH_SIZE,l,a).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:h.stats}}))}clearCache(d){const g=this.getSessionTokenSource(d);g&&g.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:_.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,g,r,a){a.onCancellationRequested(()=>{d.cancel()});const p=E=>{E&&(m.push(E),g>0&&m.length>=g&&(r(m),m=[]))};let m=[];return d.search(p).then(E=>(m.length&&r(m),E),E=>(m.length&&r(m),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[225],we([0,1,14,13,20,61,25,28,2,41,16,10]),function(J,e,v,R,D,T,_,S,y,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(l,h,f){this.query=l,this.provider=h,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,h){const f=this.query.folderQueries||[],t=new D.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new r(l);let o=!1;const c=(w,b)=>{if(!o&&!this.isLimitHit){const A=this.resultSize(w);p(w)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const C=this.resultSize(w);this.resultCount+=C,(C>0||!p(w))&&this.collector.add(w,b)}};Promise.all(f.map((w,b)=>this.searchInFolder(w,A=>c(A,b),t.token))).then(w=>{t.dispose(),this.collector.flush();const b=w.some(A=>!!A&&!!A.limitHit);i({limitHit:this.isLimitHit||b,messages:(0,R.flatten)(w.map(A=>(A==null?void 0:A.message)?(0,P.isArray)(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const b=(0,T.toErrorMessage)(w);s(new Error(b))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,h){const f=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:f.slice(0,h),preview:{matches:t.slice(0,h),text:l.preview.text},uri:l.uri}}async searchInFolder(l,h,f){const t=new k.QueryGlobTester(this.query,l),i=[],s={report:w=>{if(!this.validateProviderResult(w))return;const b=l.folder.scheme===n.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(w.uri))):void 0,A=_.relativePath(l.folder,w.uri);A&&i.push(t.includedInQuery(A,v.basename(A),b).then(C=>{C&&h(w)}))}},o=this.getSearchOptionsForFolder(l),c=await this.provider.provideTextSearchResults(g(this.query.contentPattern),o,s,f);return await Promise.all(i),c}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const h=(0,k.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),f=(0,k.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:y.URI.from(l.folder),excludes:f,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,h=>this.sendItems(h))}add(l,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!_.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(a(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=r;function a(E){return p(E)?{preview:{matches:(0,R.mapArrayOrNot)(E.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:E.preview.text},ranges:(0,R.mapArrayOrNot)(E.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class m{constructor(l,h){this.maxBatchSize=l,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,h){!l||this.addItemToBatch(l,h)}addItems(l,h){!l||this.addItemsToBatch(l,h)}addItemToBatch(l,h){this.batch.push(l),this.batchSize+=h,this.onUpdate()}addItemsToBatch(l,h){this.batch=this.batch.concat(l),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(be[107],we([0,1,6,5,4,224,15,72,17,2,225]),function(J,e,v,R,D,T,_,S,y,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let P=class{constructor(a,p,m){this.extHostRpc=a,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,p){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(a,p){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(a,p,m,E){const l=d(m),h=this._fileSearchProvider.get(a);if(h)return this._fileSearchManager.fileSearch(l,h,f=>{this._proxy.$handleFileMatch(a,p,f.map(t=>t.resource))},E);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,p,m,E){const l=this._textSearchProvider.get(a);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const h=d(m);return this.createTextSearchManager(h,l).search(t=>this._proxy.$handleTextMatch(a,p,t),E)}createTextSearchManager(a,p){return new n.TextSearchManager(a,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=je([Ke(0,_.IExtHostRpcService),Ke(1,S.IURITransformerService),Ke(2,y.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>k.URI.revive(a))})}e.reviveQuery=d;function g(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(be[226],we([0,1,20,12,3,47,2,125,85,119,60,65,5,190,189,76,191,33,192,193,194,177,195,39,34,196,178,198,199,200,102,180,204,205,206,78,40,207,181,9,7,210,51,103,30,32,52,167,197,94,101,105,106,107,17,72,15,27,201,165,71,75,187,208,164,79,77,213,211,212,188,49,219,209,74,69,95,202,104,203,16,154]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h,f,t,i,s,o,c,w,b,A,C,u,F,O,z,de,he,$,j,W,I,H,M,B,G,q,se,ve,Le,xe,Me,ze,Ve,x,Q,te,ie,fe,Ee,le,_e,Ae,We,ge,Ge,V,ee,me,Ne,He,$e,Ye,De,Se,Ce,ne,ae,N,Y,re,ke,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Oe(Ue){const Qe=Ue.get(fe.IExtHostInitDataService),rt=Ue.get(Ye.IExtHostFileSystemInfo),et=Ue.get(ee.IExtHostConsumerFileSystem),Je=Ue.get(s.IExtHostExtensionService),ot=Ue.get(G.IExtHostWorkspace),_t=Ue.get(ae.IExtHostTelemetry),wt=Ue.get(m.IExtHostConfiguration),pe=Ue.get(te.IURITransformerService),ue=Ue.get(ie.IExtHostRpcService),oe=Ue.get(de.IExtHostStorage),K=Ue.get(V.IExtensionStoragePaths),Re=Ue.get(Q.ILogService),Te=Ue.get(_e.IExtHostTunnelService),Xe=Ue.get(Ae.IExtHostApiDeprecationService),Ze=Ue.get(B.IExtHostWindow),ht=Ue.get(Ce.IExtHostSecretState),ut=Ue.get(ne.IExtHostEditorTabs);ue.set(d.ExtHostContext.ExtHostFileSystemInfo,rt),ue.set(d.ExtHostContext.ExtHostLogService,Re),ue.set(d.ExtHostContext.ExtHostWorkspace,ot),ue.set(d.ExtHostContext.ExtHostConfiguration,wt),ue.set(d.ExtHostContext.ExtHostExtensionService,Je),ue.set(d.ExtHostContext.ExtHostStorage,oe),ue.set(d.ExtHostContext.ExtHostTunnelService,Te),ue.set(d.ExtHostContext.ExtHostWindow,Ze),ue.set(d.ExtHostContext.ExtHostSecretState,ht),ue.set(d.ExtHostContext.ExtHostTelemetry,_t),ue.set(d.ExtHostContext.ExtHostEditorTabs,ut);const it=ue.set(d.ExtHostContext.ExtHostDecorations,Ue.get(Me.IExtHostDecorations)),pt=ue.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Ue.get(i.IExtHostDocumentsAndEditors)),dt=ue.set(d.ExtHostContext.ExtHostCommands,Ue.get(a.IExtHostCommands)),at=ue.set(d.ExtHostContext.ExtHostTerminalService,Ue.get(he.IExtHostTerminalService)),ft=ue.set(d.ExtHostContext.ExtHostDebugService,Ue.get(Ve.IExtHostDebugService)),Pt=ue.set(d.ExtHostContext.ExtHostSearch,Ue.get(x.IExtHostSearch)),Ct=ue.set(d.ExtHostContext.ExtHostTask,Ue.get(ze.IExtHostTask)),At=ue.set(d.ExtHostContext.ExtHostOutputService,Ue.get(C.IExtHostOutputService)),Rt=ue.set(d.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(ue)),yt=ue.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ue,pt)),Gt=ue.set(d.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(ue,pt,Re)),Qt=ue.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Re,yt,ue.getProxy(d.MainContext.MainThreadBulkEdits))),gt=ue.set(d.ExtHostContext.ExtHostNotebook,new Ee.ExtHostNotebookController(ue,dt,pt,yt,Re,K)),Yt=ue.set(d.ExtHostContext.ExtHostNotebookKernels,new N.ExtHostNotebookKernels(ue,Qe,gt,Re)),Jt=ue.set(d.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(ue,gt)),Dt=ue.set(d.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ue,pt)),un=ue.set(d.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(ue.getProxy(d.MainContext.MainThreadTreeViews),dt,Re)),Xt=ue.set(d.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(ue.getProxy(d.MainContext.MainThreadEditorInsets),Dt,Qe)),Bt=ue.set(d.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ue,Re)),ct=ue.set(d.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(ue,pe,yt,dt,Bt,Re,Xe)),Zt=ue.set(d.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ue,ct)),Lt=ue.set(d.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ue,Re,pt)),Mt=ue.set(d.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ue,ot,dt)),Vt=ue.set(d.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(ue,dt,Re)),pn=ue.set(d.ExtHostContext.ExtHostComments,new p.ExtHostComments(ue,dt,yt)),cn=ue.set(d.ExtHostContext.ExtHostProgress,new u.ExtHostProgress(ue.getProxy(d.MainContext.MainThreadProgress))),vn=ue.set(d.ExtHostContext.ExtHosLabelService,new Le.ExtHostLabelService(ue)),dn=ue.set(d.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(ue)),$t=ue.set(d.ExtHostContext.ExtHostAuthentication,new We.ExtHostAuthentication(ue)),en=ue.set(d.ExtHostContext.ExtHostTimeline,new ge.ExtHostTimeline(ue,dt)),Ht=ue.set(d.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(ue,{remote:Qe.remote},ot,Re,Xe)),tn=ue.set(d.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(ue,Ht,ot)),bn=ue.set(d.ExtHostContext.ExtHostCustomEditors,new Ne.ExtHostCustomEditors(ue,yt,K,Ht,tn)),wn=ue.set(d.ExtHostContext.ExtHostWebviewViews,new me.ExtHostWebviewViews(ue,Ht)),Ot=ue.set(d.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(ue,pt,ot)),jt=ue.set(d.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(ue)),_n=(0,se.values)(d.ExtHostContext);ue.assertRegistered(_n);const En=new $e.ExtHostBulkEdits(ue,pt),nn=new r.ExtHostClipboard(ue),rn=new A.ExtHostMessageService(ue,Re),xt=new l.ExtHostDialogs(ue),qt=new z.ExtHostStatusBar(ue,dt.converter),Wt=new b.ExtHostLanguages(ue,yt);return g.ExtHostApiCommands.register(dt),function(Fe,sn,It){const vt=function(){let X=!Fe.isUnderDevelopment;function ce(Pe){X||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")ce(st);else{const bt=st;typeof bt.scheme=="undefined"&&ce(st),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Fe)}return st}}(),yn={getSession(X,ce,Pe){return $t.getSession(Fe,X,ce,Pe)},get onDidChangeSessions(){return $t.onDidChangeSessions},registerAuthenticationProvider(X,ce,Pe,st){return $t.registerAuthenticationProvider(X,ce,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,q.checkProposedApiEnabled)(Fe),$t.onDidChangeAuthenticationProviders},get providers(){return(0,q.checkProposedApiEnabled)(Fe),$t.providers},logout(X,ce){return(0,q.checkProposedApiEnabled)(Fe),$t.removeSession(X,ce)}},Sn={registerCommand(X,ce,Pe){return dt.registerCommand(!0,X,ce,Pe)},registerTextEditorCommand(X,ce,Pe){return dt.registerCommand(!0,X,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Re.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Et=>{ce.apply(Pe,[bt,Et,...st])}).then(Et=>{Et||Re.warn("Edits from command "+X+" were not applied.")},Et=>{Re.warn("An error occurred while running command "+X,Et)})})},registerDiffInformationCommand:(X,ce,Pe)=>((0,q.checkProposedApiEnabled)(Fe),dt.registerCommand(!0,X,async(...st)=>{const bt=pt.activeEditor(!0);if(!bt){Re.warn("Cannot execute "+X+" because there is no active text editor.");return}const Et=await Dt.getDiffInformation(bt.id);ce.apply(Pe,[Et,...st])})),executeCommand(X,...ce){return dt.executeCommand(X,...ce)},getCommands(X=!1){return dt.getCommands(X)}},hn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var X,ce;return(ce=(X=Qe.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return _t.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ze.openUri(X,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===Qe.environment.appUriScheme?Rt.createAppUri(X):(!(0,Ie.matchesScheme)(X.scheme,ke.Schemas.http)&&!(0,Ie.matchesScheme)(X.scheme,ke.Schemas.https)&&(0,q.checkProposedApiEnabled)(Fe),Ze.asExternalUri(X,{allowTunneling:!!Qe.remote.authority}))},get remoteName(){return(0,xe.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(hn);const fn=Qe.remote.isRemote?I.ExtensionKind.Workspace:I.ExtensionKind.UI,Dn={registerTestController(X){return Ot.registerTestController(Fe.identifier.value,X)},createDocumentTestObserver(X){return(0,q.checkProposedApiEnabled)(Fe),Ot.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,q.checkProposedApiEnabled)(Fe),Ot.createWorkspaceTestObserver(X)},runTests(X){return Ot.runTests(X)},createTestItem(X,ce){return new I.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRun(X,ce,Pe){return Ot.createTestRun(Fe.identifier.value,X,ce,Pe)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Fe),Ot.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Fe),Ot.results}},Cn={getExtension(X){const ce=sn.getExtensionDescription(X);if(ce)return new s.Extension(Je,Fe.identifier,ce,fn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new s.Extension(Je,Fe.identifier,X,fn))},get onDidChange(){return sn.onDidChange}},kn={createDiagnosticCollection(X){return Bt.createDiagnosticCollection(Fe.identifier,X)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:X=>Bt.getDiagnostics(X),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(X,ce){return Wt.changeLanguage(X.uri,ce)},match(X,ce){return(0,n.score)(W.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,Pe){return ct.registerCodeActionProvider(Fe,vt(X),ce,Pe)},registerCodeLensProvider(X,ce){return ct.registerCodeLensProvider(Fe,vt(X),ce)},registerDefinitionProvider(X,ce){return ct.registerDefinitionProvider(Fe,vt(X),ce)},registerDeclarationProvider(X,ce){return ct.registerDeclarationProvider(Fe,vt(X),ce)},registerImplementationProvider(X,ce){return ct.registerImplementationProvider(Fe,vt(X),ce)},registerTypeDefinitionProvider(X,ce){return ct.registerTypeDefinitionProvider(Fe,vt(X),ce)},registerHoverProvider(X,ce){return ct.registerHoverProvider(Fe,vt(X),ce,Fe.identifier)},registerEvaluatableExpressionProvider(X,ce){return ct.registerEvaluatableExpressionProvider(Fe,vt(X),ce,Fe.identifier)},registerInlineValuesProvider(X,ce){return ct.registerInlineValuesProvider(Fe,vt(X),ce,Fe.identifier)},registerDocumentHighlightProvider(X,ce){return ct.registerDocumentHighlightProvider(Fe,vt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ct.registerLinkedEditingRangeProvider(Fe,vt(X),ce)},registerReferenceProvider(X,ce){return ct.registerReferenceProvider(Fe,vt(X),ce)},registerRenameProvider(X,ce){return ct.registerRenameProvider(Fe,vt(X),ce)},registerDocumentSymbolProvider(X,ce,Pe){return ct.registerDocumentSymbolProvider(Fe,vt(X),ce,Pe)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Fe,X)},registerDocumentFormattingEditProvider(X,ce){return ct.registerDocumentFormattingEditProvider(Fe,vt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ct.registerDocumentRangeFormattingEditProvider(Fe,vt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,Pe,...st){return ct.registerOnTypeFormattingEditProvider(Fe,vt(X),ce,[Pe].concat(st))},registerDocumentSemanticTokensProvider(X,ce,Pe){return ct.registerDocumentSemanticTokensProvider(Fe,vt(X),ce,Pe)},registerDocumentRangeSemanticTokensProvider(X,ce,Pe){return ct.registerDocumentRangeSemanticTokensProvider(Fe,vt(X),ce,Pe)},registerSignatureHelpProvider(X,ce,Pe,...st){return typeof Pe=="object"?ct.registerSignatureHelpProvider(Fe,vt(X),ce,Pe):ct.registerSignatureHelpProvider(Fe,vt(X),ce,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(X,ce,...Pe){return ct.registerCompletionItemProvider(Fe,vt(X),ce,Pe)},registerInlineCompletionItemProvider(X,ce){return(0,q.checkProposedApiEnabled)(Fe),ct.registerInlineCompletionsProvider(Fe,vt(X),ce)},registerDocumentLinkProvider(X,ce){return ct.registerDocumentLinkProvider(Fe,vt(X),ce)},registerColorProvider(X,ce){return ct.registerColorProvider(Fe,vt(X),ce)},registerFoldingRangeProvider(X,ce){return ct.registerFoldingRangeProvider(Fe,vt(X),ce)},registerSelectionRangeProvider(X,ce){return ct.registerSelectionRangeProvider(Fe,X,ce)},registerCallHierarchyProvider(X,ce){return ct.registerCallHierarchyProvider(Fe,X,ce)},setLanguageConfiguration:(X,ce)=>ct.setLanguageConfiguration(Fe,X,ce),getTokenInformationAtPosition(X,ce){return(0,q.checkProposedApiEnabled)(Fe),Wt.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return(0,q.checkProposedApiEnabled)(Fe),ct.registerInlayHintsProvider(Fe,X,ce)}},on={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(X,ce,Pe){const st=await(_.URI.isUri(X)?Promise.resolve(mn.openTextDocument(X)):Promise.resolve(X));return Dt.showTextDocument(st,ce,Pe)},createTextEditorDecorationType(X){return Dt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,Pe){return Dt.onDidChangeActiveTextEditor(X,ce,Pe)},onDidChangeVisibleTextEditors(X,ce,Pe){return Dt.onDidChangeVisibleTextEditors(X,ce,Pe)},onDidChangeTextEditorSelection(X,ce,Pe){return Dt.onDidChangeTextEditorSelection(X,ce,Pe)},onDidChangeTextEditorOptions(X,ce,Pe){return Dt.onDidChangeTextEditorOptions(X,ce,Pe)},onDidChangeTextEditorVisibleRanges(X,ce,Pe){return Dt.onDidChangeTextEditorVisibleRanges(X,ce,Pe)},onDidChangeTextEditorViewColumn(X,ce,Pe){return Dt.onDidChangeTextEditorViewColumn(X,ce,Pe)},onDidCloseTerminal(X,ce,Pe){return at.onDidCloseTerminal(X,ce,Pe)},onDidOpenTerminal(X,ce,Pe){return at.onDidOpenTerminal(X,ce,Pe)},onDidChangeActiveTerminal(X,ce,Pe){return at.onDidChangeActiveTerminal(X,ce,Pe)},onDidChangeTerminalDimensions(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),at.onDidChangeTerminalDimensions(X,ce,Pe)},onDidWriteTerminalData(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),at.onDidWriteTerminalData(X,ce,Pe)},get state(){return Ze.state},onDidChangeWindowState(X,ce,Pe){return Ze.onDidChangeWindowState(X,ce,Pe)},showInformationMessage(X,...ce){return rn.showMessage(Fe,T.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return rn.showMessage(Fe,T.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return rn.showMessage(Fe,T.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,Pe){return Mt.showQuickPick(X,!!Fe.enableProposedApi,ce,Pe)},showWorkspaceFolderPick(X){return Mt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Mt.showInput(X,ce)},showOpenDialog(X){return xt.showOpenDialog(X)},showSaveDialog(X){return xt.showSaveDialog(X)},createStatusBarItem(X,ce,Pe){let st,bt,Et;return typeof X=="string"?(st=X,bt=ce,Et=Pe):(bt=X,Et=ce),qt.createStatusBarEntry(Fe,st,bt,Et)},setStatusBarMessage(X,ce){return qt.setStatusBarMessage(X,ce)},withScmProgress(X){return Xe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),cn.withProgress(Fe,{location:I.ProgressLocation.SourceControl},(ce,Pe)=>X({report(st){}}))},withProgress(X,ce){return cn.withProgress(Fe,X,ce)},createOutputChannel(X){return At.createOutputChannel(X)},createWebviewPanel(X,ce,Pe,st){return tn.createWebviewPanel(Fe,X,ce,Pe,st)},createWebviewTextEditorInset(X,ce,Pe,st){return(0,q.checkProposedApiEnabled)(Fe),Xt.createWebviewEditorInset(X,ce,Pe,st,Fe)},createTerminal(X,ce,Pe){return typeof X=="object"?"pty"in X?at.createExtensionTerminal(X):(X.iconPath&&(0,q.checkProposedApiEnabled)(Fe),at.createTerminalFromOptions(X)):at.createTerminal(X,ce,Pe)},registerTerminalLinkProvider(X){return at.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return un.registerTreeDataProvider(X,ce,Fe)},createTreeView(X,ce){return un.createTreeView(X,ce,Fe)},registerWebviewPanelSerializer:(X,ce)=>tn.registerWebviewPanelSerializer(Fe,X,ce),registerCustomEditorProvider:(X,ce,Pe={})=>bn.registerCustomEditorProvider(Fe,X,ce,Pe),registerFileDecorationProvider(X){return it.registerFileDecorationProvider(X,Fe.identifier)},registerUriHandler(X){return Rt.registerUriHandler(Fe.identifier,X)},createQuickPick(){return Mt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Mt.createInputBox(Fe.identifier)},get activeColorTheme(){return dn.activeColorTheme},onDidChangeActiveColorTheme(X,ce,Pe){return dn.onDidChangeActiveColorTheme(X,ce,Pe)},registerWebviewViewProvider(X,ce,Pe){return wn.registerWebviewViewProvider(Fe,X,ce,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(X,ce,Pe)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(X,ce,Pe)},onDidChangeNotebookEditorVisibleRanges(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(X,ce,Pe)},showNotebookDocument(X,ce){return(0,q.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),jt.registerExternalUriOpener(Fe.identifier,X,ce,Pe)},get openEditors(){return(0,q.checkProposedApiEnabled)(Fe),ut.tabs},get onDidChangeOpenEditors(){return(0,q.checkProposedApiEnabled)(Fe),ut.onDidChangeTabs}},mn={get rootPath(){return Xe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(X){throw R.readonly()},getWorkspaceFolder(X){return ot.getWorkspaceFolder(X)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(X){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(X){throw R.readonly()},updateWorkspaceFolders:(X,ce,...Pe)=>ot.updateWorkspaceFolders(Fe,X,ce||0,...Pe),onDidChangeWorkspaceFolders:function(X,ce,Pe){return ot.onDidChangeWorkspace(X,ce,Pe)},asRelativePath:(X,ce)=>ot.getRelativePath(X,ce),findFiles:(X,ce,Pe,st)=>ot.findFiles(W.GlobPattern.from(X),W.GlobPattern.from(ce),Pe,Fe.identifier,st),findTextInFiles:(X,ce,Pe,st)=>{let bt,Et;return typeof ce=="object"?(bt=ce,Et=Pe):(bt={},Et=ce,st=Pe),ot.findTextInFiles(X,bt||{},Et,Fe.identifier,st)},saveAll:X=>ot.saveAll(X),applyEdit(X){return En.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,Pe,st)=>Lt.createFileSystemWatcher(W.GlobPattern.from(X),ce,Pe,st),get textDocuments(){return yt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw R.readonly()},openTextDocument(X){let ce;const Pe=X;if(typeof X=="string")ce=Promise.resolve(_.URI.file(X));else if(_.URI.isUri(X))ce=Promise.resolve(X);else if(!Pe||typeof Pe=="object")ce=yt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>yt.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,Pe)=>yt.onDidAddDocument(X,ce,Pe),onDidCloseTextDocument:(X,ce,Pe)=>yt.onDidRemoveDocument(X,ce,Pe),onDidChangeTextDocument:(X,ce,Pe)=>yt.onDidChangeDocument(X,ce,Pe),onDidSaveTextDocument:(X,ce,Pe)=>yt.onDidSaveDocument(X,ce,Pe),onWillSaveTextDocument:(X,ce,Pe)=>Qt.getOnWillSaveTextDocumentEvent(Fe)(X,ce,Pe),onDidChangeConfiguration:(X,ce,Pe)=>It.onDidChangeConfiguration(X,ce,Pe),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,It.getConfiguration(X,ce,Fe)},registerTextDocumentContentProvider(X,ce){return Gt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Xe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Fe,X,ce)),registerFileSystemProvider(X,ce,Pe){return Zt.registerFileSystemProvider(Fe.identifier,X,ce,Pe,Fe.enableProposedApi)},get fs(){return et.value},registerFileSearchProvider:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),Pt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),Pt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),Je.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Fe),vn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,Pe)=>Lt.onDidCreateFile(X,ce,Pe),onDidDeleteFiles:(X,ce,Pe)=>Lt.onDidDeleteFile(X,ce,Pe),onDidRenameFiles:(X,ce,Pe)=>Lt.onDidRenameFile(X,ce,Pe),onWillCreateFiles:(X,ce,Pe)=>Lt.getOnWillCreateFileEvent(Fe)(X,ce,Pe),onWillDeleteFiles:(X,ce,Pe)=>Lt.getOnWillDeleteFileEvent(Fe)(X,ce,Pe),onWillRenameFiles:(X,ce,Pe)=>Lt.getOnWillRenameFileEvent(Fe)(X,ce,Pe),openTunnel:X=>((0,q.checkProposedApiEnabled)(Fe),Te.openTunnel(Fe,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,q.checkProposedApiEnabled)(Fe),Te.getTunnels()},onDidChangeTunnels:(X,ce,Pe)=>((0,q.checkProposedApiEnabled)(Fe),Te.onDidChangeTunnels(X,ce,Pe)),registerPortAttributesProvider:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),Te.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),en.registerTimelineProvider(X,ce,Fe.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Fe),ot.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,Pe)=>ot.onDidGrantWorkspaceTrust(X,ce,Pe)},In={get inputBox(){return Xe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Fe)},createSourceControl(X,ce,Pe){return Vt.createSourceControl(Fe,X,ce,Pe)}},Pn={createCommentController(X,ce){return pn.createCommentController(Fe,X,ce)}},An={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(X,ce,Pe){return ft.onDidStartDebugSession(X,ce,Pe)},onDidTerminateDebugSession(X,ce,Pe){return ft.onDidTerminateDebugSession(X,ce,Pe)},onDidChangeActiveDebugSession(X,ce,Pe){return ft.onDidChangeActiveDebugSession(X,ce,Pe)},onDidReceiveDebugSessionCustomEvent(X,ce,Pe){return ft.onDidReceiveDebugSessionCustomEvent(X,ce,Pe)},onDidChangeBreakpoints(X,ce,Pe){return ft.onDidChangeBreakpoints(X,ce,Pe)},registerDebugConfigurationProvider(X,ce,Pe){return ft.registerDebugConfigurationProvider(X,ce,Pe||I.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return ft.registerDebugAdapterDescriptorFactory(Fe,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return ft.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?ft.startDebugging(X,ce,{parentSession:Pe}):ft.startDebugging(X,ce,Pe||{})},stopDebugging(X){return ft.stopDebugging(X)},addBreakpoints(X){return ft.addBreakpoints(X)},removeBreakpoints(X){return ft.removeBreakpoints(X)},asDebugSourceUri(X,ce){return ft.asDebugSourceUri(X,ce)}},Tn={registerTaskProvider:(X,ce)=>Ct.registerTaskProvider(Fe,X,ce),fetchTasks:X=>Ct.fetchTasks(X),executeTask:X=>Ct.executeTask(Fe,X),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(X,ce,Pe)=>Ct.onDidStartTask(X,ce,Pe),onDidEndTask:(X,ce,Pe)=>Ct.onDidEndTask(X,ce,Pe),onDidStartTaskProcess:(X,ce,Pe)=>Ct.onDidStartTaskProcess(X,ce,Pe),onDidEndTaskProcess:(X,ce,Pe)=>Ct.onDidEndTaskProcess(X,ce,Pe)},Rn={async openNotebookDocument(X,ce){(0,q.checkProposedApiEnabled)(Fe);let Pe;if(_.URI.isUri(X))Pe=X,await gt.openNotebookDocument(X);else if(typeof X=="string")Pe=_.URI.revive(await gt.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,q.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,ce,Pe,st){return(0,q.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,X,ce,Pe,Fe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,ce,Pe,st)=>((0,q.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,X,ce,Pe,Fe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(X,ce)=>((0,q.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,X,ce)),createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return(0,q.checkProposedApiEnabled)(Fe),Jt.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(X,ce,Pe)},onDidChangeNotebookCells(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(X,ce,Pe)},onDidChangeNotebookCellExecutionState(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(X,ce,Pe)},onDidChangeCellOutputs(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(X,ce,Pe)},onDidChangeCellMetadata(X,ce,Pe){return(0,q.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(X,ce,Pe)},createConcatTextDocument(X,ce){return(0,q.checkProposedApiEnabled)(Fe),new Ge.ExtHostNotebookConcatDocument(gt,yt,X,ce)},createNotebookController(X,ce,Pe,st,bt){return(0,q.checkProposedApiEnabled)(Fe),Yt.createNotebookController(Fe,X,ce,Pe,st,bt)}};return{version:Qe.version,authentication:yn,commands:Sn,comments:Pn,debug:An,env:hn,extensions:Cn,languages:kn,notebook:Rn,scm:In,tasks:Tn,test:Dn,window:on,workspace:mn,Breakpoint:I.Breakpoint,CallHierarchyIncomingCall:I.CallHierarchyIncomingCall,CallHierarchyItem:I.CallHierarchyItem,CallHierarchyOutgoingCall:I.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:I.CodeAction,CodeActionKind:I.CodeActionKind,CodeActionTriggerKind:I.CodeActionTriggerKind,CodeLens:I.CodeLens,Color:I.Color,ColorInformation:I.ColorInformation,ColorPresentation:I.ColorPresentation,ColorThemeKind:I.ColorThemeKind,CommentMode:I.CommentMode,CommentThreadCollapsibleState:I.CommentThreadCollapsibleState,CompletionItem:I.CompletionItem,CompletionItemKind:I.CompletionItemKind,CompletionItemTag:I.CompletionItemTag,CompletionList:I.CompletionList,CompletionTriggerKind:I.CompletionTriggerKind,ConfigurationTarget:I.ConfigurationTarget,CustomExecution:I.CustomExecution,DebugAdapterExecutable:I.DebugAdapterExecutable,DebugAdapterInlineImplementation:I.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:I.DebugAdapterNamedPipeServer,DebugAdapterServer:I.DebugAdapterServer,DebugConfigurationProviderTriggerKind:I.DebugConfigurationProviderTriggerKind,DebugConsoleMode:I.DebugConsoleMode,DecorationRangeBehavior:I.DecorationRangeBehavior,Diagnostic:I.Diagnostic,DiagnosticRelatedInformation:I.DiagnosticRelatedInformation,DiagnosticSeverity:I.DiagnosticSeverity,DiagnosticTag:I.DiagnosticTag,Disposable:I.Disposable,DocumentHighlight:I.DocumentHighlight,DocumentHighlightKind:I.DocumentHighlightKind,DocumentLink:I.DocumentLink,DocumentSymbol:I.DocumentSymbol,EndOfLine:I.EndOfLine,EnvironmentVariableMutatorType:I.EnvironmentVariableMutatorType,EvaluatableExpression:I.EvaluatableExpression,InlineValueText:I.InlineValueText,InlineValueVariableLookup:I.InlineValueVariableLookup,InlineValueEvaluatableExpression:I.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:I.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:I.ExtensionKind,ExtensionMode:I.ExtensionMode,ExternalUriOpenerPriority:I.ExternalUriOpenerPriority,FileChangeType:I.FileChangeType,FileDecoration:I.FileDecoration,FileSystemError:I.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:I.FoldingRange,FoldingRangeKind:I.FoldingRangeKind,FunctionBreakpoint:I.FunctionBreakpoint,InlineCompletionItem:I.InlineSuggestion,InlineCompletionList:I.InlineSuggestions,Hover:I.Hover,IndentAction:k.IndentAction,Location:I.Location,MarkdownString:I.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:I.ParameterInformation,PortAutoForwardAction:I.PortAutoForwardAction,Position:I.Position,ProcessExecution:I.ProcessExecution,ProgressLocation:I.ProgressLocation,QuickInputButtons:I.QuickInputButtons,Range:I.Range,RelativePattern:I.RelativePattern,Selection:I.Selection,SelectionRange:I.SelectionRange,SemanticTokens:I.SemanticTokens,SemanticTokensBuilder:I.SemanticTokensBuilder,SemanticTokensEdit:I.SemanticTokensEdit,SemanticTokensEdits:I.SemanticTokensEdits,SemanticTokensLegend:I.SemanticTokensLegend,ShellExecution:I.ShellExecution,ShellQuoting:I.ShellQuoting,SignatureHelp:I.SignatureHelp,SignatureHelpTriggerKind:I.SignatureHelpTriggerKind,SignatureInformation:I.SignatureInformation,SnippetString:I.SnippetString,SourceBreakpoint:I.SourceBreakpoint,StandardTokenType:I.StandardTokenType,StatusBarAlignment:I.StatusBarAlignment,SymbolInformation:I.SymbolInformation,SymbolKind:I.SymbolKind,SymbolTag:I.SymbolTag,Task:I.Task,TaskGroup:I.TaskGroup,TaskPanelKind:I.TaskPanelKind,TaskRevealKind:I.TaskRevealKind,TaskScope:I.TaskScope,TextDocumentSaveReason:I.TextDocumentSaveReason,TextEdit:I.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:I.TextEditorLineNumbersStyle,TextEditorRevealType:I.TextEditorRevealType,TextEditorSelectionChangeKind:I.TextEditorSelectionChangeKind,ThemeColor:I.ThemeColor,ThemeIcon:I.ThemeIcon,TreeItem:I.TreeItem,TreeItemCollapsibleState:I.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:_.URI,ViewColumn:I.ViewColumn,WorkspaceEdit:I.WorkspaceEdit,InlayHint:I.InlayHint,InlayHintKind:I.InlayHintKind,RemoteAuthorityResolverError:I.RemoteAuthorityResolverError,ResolvedAuthority:I.ResolvedAuthority,SourceControlInputBoxValidationType:I.SourceControlInputBoxValidationType,ExtensionRuntime:I.ExtensionRuntime,TimelineItem:I.TimelineItem,NotebookRange:I.NotebookRange,NotebookCellKind:I.NotebookCellKind,NotebookCellExecutionState:I.NotebookCellExecutionState,NotebookDocumentMetadata:I.NotebookDocumentMetadata,NotebookCellMetadata:I.NotebookCellMetadata,NotebookCellData:I.NotebookCellData,NotebookData:I.NotebookData,NotebookKernelPreload:I.NotebookKernelPreload,NotebookCellStatusBarAlignment:I.NotebookCellStatusBarAlignment,NotebookEditorRevealType:I.NotebookEditorRevealType,NotebookCellOutput:I.NotebookCellOutput,NotebookCellOutputItem:I.NotebookCellOutputItem,NotebookCellStatusBarItem:I.NotebookCellStatusBarItem,NotebookControllerAffinity:I.NotebookControllerAffinity,PortAttributes:I.PortAttributes,LinkedEditingRanges:I.LinkedEditingRanges,TestItemStatus:I.TestItemStatus,TestResultState:I.TestResultState,TestMessage:I.TestMessage,TextSearchCompleteMessageType:Y.TextSearchCompleteMessageType,TestMessageSeverity:I.TestMessageSeverity,WorkspaceTrustState:I.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Oe}),define(be[227],we([0,1,62,102,30,101,33,76,39,40,105,106,107,79,78,71,75,103,77,49,74,95,69]),function(J,e,v,R,D,T,_,S,y,k,n,P,d,g,r,a,p,m,E,l,h,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,v.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,v.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,v.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration),(0,v.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,v.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,v.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,v.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),(0,v.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,v.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,v.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,v.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,v.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,v.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,v.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,v.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,v.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,v.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(be[228],we([0,1,226,34,222,7,11,5]),function(J,e,v,R,D,T,_,S){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var a;const p=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...l)=>{l.forEach(i=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(i)))throw new Error("TrustedScripts only, please")});const h=l.slice(0,-1).join(","),f=l.pop().toString();return`(function anonymous(${h}) {
${f}
})`}});function m(...E){return p?self.eval(p.createScript("",...E)):new Function(...E)}r.create=m})(k||(k={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(a,p){for(let m of this._alternatives){let E=m(a);if(E){a=E;break}}if(this._factories.has(a))return this._factories.get(a).load(a,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);g(a,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(v.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,p,m){var E,l,h,f,t,i,s,o;p=p.with({path:d(p.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const c=await fetch(p.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),c.status!==200)throw new Error(c.statusText);const w=await c.text(),b=`${p.toString(!0)}#vscode-extension`,A=`${w}
//# sourceURL=${b}`;let C;try{C=k.create((l=(E=P._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&l!==void 0?l:"module",(f=(h=P._ttpExtensionScripts)===null||h===void 0?void 0:h.createScript("exports"))!==null&&f!==void 0?f:"exports",(i=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(o=(s=P._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(A))!==null&&o!==void 0?o:A)}catch(z){throw console.error(a?`Loading code for extension ${a.value} failed: ${z.message}`:`Loading code failed: ${z.message}`),console.error(`${p.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const u={},F={exports:u},O=z=>{const de=this._fakeModules.getModule(z,p);if(de===void 0)throw new Error(`Cannot load module '${z}'`);return de};try{return m.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),C(F,u,O),F.exports!==u?F.exports:u}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+a;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,_.timeout)(10)}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,a){return r.endsWith(a)?r:r+a}function g(r,a){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,h){const f=console[l];console[l]=function(){r.$logExtensionHostMessage({type:"__$console",severity:h,arguments:E(arguments)}),a&&f.apply(console,arguments)}}const m=1e5;function E(l){const h=[],f=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const i=l[t];i.stack?l[t]=i.stack:l[t]=i.toString()}f.push(l[t])}try{const t=JSON.stringify(f,function(i,s){if(s&&typeof s=="object"){if(h.indexOf(s)!==-1)return"[Circular]";h.push(s)}return s});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[229],we([0,1,62,17,34,228,214]),function(J,e,v,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(D.IExtHostExtensionService,T.ExtHostExtensionService),(0,v.registerSingleton)(R.ILogService,_.ExtHostLogService)}),define(be[231],we([0,1,24,3,184,223,216,14,80,227,229]),function(J,e,v,R,D,T,_,S,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),m=self.Worker;Worker=function(E,l){const h=`importScripts('${E}');`;l=l||{},l.name=l.name||S.basename(E.toString());const f=new Blob([h],{type:"application/javascript"}),t=URL.createObjectURL(f);return new m(p?p.createScriptURL(t):t,l)}}else self.Worker=class extends _.NestedWorker{constructor(p,m){super(P,p,Object.assign({name:S.basename(p.toString())},m))}};const d=new class{exit(p){n()}async exists(p){return!0}async realpath(p){return p}};class g{constructor(){const m=new MessageChannel,E=new R.Emitter;let l=!1;P(m.port2,[m.port2]),m.port1.onmessage=h=>{const{data:f}=h;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=v.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,D.isMessageOfType)(t,2)){l=!0,a("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:h=>{if(!l){const f=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);m.port1.postMessage(f,[f])}}}}}function r(p){return new Promise(m=>{const E=p.onMessage(l=>{E.dispose();const h=JSON.parse(l.toString());p.send((0,D.createMessageOfType)(0)),m({protocol:p,initData:h})});p.send((0,D.createMessageOfType)(1))})}let a=p=>n();(function(){const m=new g;y.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(E=>{y.mark("code/extHost/didWaitForInitData");const l=new T.ExtensionHostMain(E.protocol,E.initData,d,null);a=h=>l.terminate(h)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a18ea9c9ec25c59e599ba3c2eb668315546dd269/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
